var searchIndex = {};
searchIndex['collections'] = {"items":[[0,"","collections","Collection types.",null,null],[0,"boxed","","A pointer type for heap allocation.",null,null],[17,"HEAP","collections::boxed","A value that represents the heap. This is the default place that the `box`\nkeyword allocates into when no place is supplied.",null,null],[11,"clone","alloc::boxed","",0,{"inputs":[{"name":"exchangeheapsingleton"}],"output":{"name":"exchangeheapsingleton"}}],[11,"pointer","","",1,null],[11,"make_place","","",1,{"inputs":[{"name":"intermediatebox"}],"output":{"name":"intermediatebox"}}],[11,"finalize","","",1,{"inputs":[{"name":"intermediatebox"}],"output":{"name":"box"}}],[11,"finalize","","",2,{"inputs":[{"name":"box"},{"name":"intermediatebox"}],"output":{"name":"box"}}],[11,"make_place","","",0,{"inputs":[{"name":"exchangeheapsingleton"}],"output":{"name":"intermediatebox"}}],[11,"drop","","",1,null],[11,"new","","Allocates memory on the heap and then moves `x` into it.",2,{"inputs":[{"name":"box"},{"name":"t"}],"output":{"name":"box"}}],[11,"from_raw","","Constructs a box from the raw pointer.",2,null],[11,"into_raw","","Consumes the `Box`, returning the wrapped raw pointer.",2,null],[11,"default","","",2,{"inputs":[{"name":"box"}],"output":{"name":"box"}}],[11,"default","","",2,{"inputs":[{"name":"box"}],"output":{"name":"box"}}],[11,"clone","","Returns a new box with a `clone()` of this box's contents.",2,{"inputs":[{"name":"box"}],"output":{"name":"box"}}],[11,"clone_from","","Copies `source`'s contents into `self` without creating a new allocation.",2,null],[11,"clone","","",2,{"inputs":[{"name":"box"}],"output":{"name":"box"}}],[11,"eq","","",2,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"bool"}}],[11,"ne","","",2,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",2,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"option"}}],[11,"lt","","",2,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"bool"}}],[11,"le","","",2,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"bool"}}],[11,"ge","","",2,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"bool"}}],[11,"gt","","",2,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"bool"}}],[11,"cmp","","",2,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"ordering"}}],[11,"hash","","",2,null],[11,"downcast","","Attempt to downcast the box to a concrete type.",2,{"inputs":[{"name":"box"}],"output":{"name":"result"}}],[11,"downcast","","Attempt to downcast the box to a concrete type.",2,{"inputs":[{"name":"box"}],"output":{"name":"result"}}],[11,"fmt","","",2,{"inputs":[{"name":"box"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",2,{"inputs":[{"name":"box"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",2,{"inputs":[{"name":"box"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"deref","","",2,{"inputs":[{"name":"box"}],"output":{"name":"t"}}],[11,"deref_mut","","",2,{"inputs":[{"name":"box"}],"output":{"name":"t"}}],[11,"next","","",2,{"inputs":[{"name":"box"}],"output":{"name":"option"}}],[11,"size_hint","","",2,null],[11,"next_back","","",2,{"inputs":[{"name":"box"}],"output":{"name":"option"}}],[11,"call_once","","",2,{"inputs":[{"name":"box"},{"name":"a"}],"output":{"name":"r"}}],[11,"call_once","","",2,{"inputs":[{"name":"box"},{"name":"a"}],"output":{"name":"r"}}],[11,"clone","","",2,{"inputs":[{"name":"box"}],"output":{"name":"box"}}],[11,"fmt","alloc::arc","",3,{"inputs":[{"name":"weak"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","Constructs a new `Arc<T>`.",4,{"inputs":[{"name":"arc"},{"name":"t"}],"output":{"name":"arc"}}],[11,"downgrade","","Downgrades the `Arc<T>` to a `Weak<T>` reference.",4,{"inputs":[{"name":"arc"}],"output":{"name":"weak"}}],[11,"weak_count","","Get the number of weak references to this value.",4,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"usize"}}],[11,"strong_count","","Get the number of strong references to this value.",4,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"usize"}}],[11,"clone","","Makes a clone of the `Arc<T>`.",4,{"inputs":[{"name":"arc"}],"output":{"name":"arc"}}],[11,"deref","","",4,{"inputs":[{"name":"arc"}],"output":{"name":"t"}}],[11,"make_unique","","Make a mutable reference from the given `Arc<T>`.",4,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"t"}}],[11,"get_mut","","Returns a mutable reference to the contained value if the `Arc<T>` is unique.",4,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"option"}}],[11,"drop","","Drops the `Arc<T>`.",4,null],[11,"upgrade","","Upgrades a weak reference to a strong reference.",3,{"inputs":[{"name":"weak"}],"output":{"name":"option"}}],[11,"clone","","Makes a clone of the `Weak<T>`.",3,{"inputs":[{"name":"weak"}],"output":{"name":"weak"}}],[11,"drop","","Drops the `Weak<T>`.",3,null],[11,"eq","","Equality for two `Arc<T>`s.",4,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"bool"}}],[11,"ne","","Inequality for two `Arc<T>`s.",4,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"bool"}}],[11,"partial_cmp","","Partial comparison for two `Arc<T>`s.",4,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"option"}}],[11,"lt","","Less-than comparison for two `Arc<T>`s.",4,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"bool"}}],[11,"le","","'Less-than or equal to' comparison for two `Arc<T>`s.",4,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"bool"}}],[11,"gt","","Greater-than comparison for two `Arc<T>`s.",4,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"bool"}}],[11,"ge","","'Greater-than or equal to' comparison for two `Arc<T>`s.",4,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"bool"}}],[11,"cmp","","",4,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"ordering"}}],[11,"fmt","","",4,{"inputs":[{"name":"arc"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",4,{"inputs":[{"name":"arc"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",4,{"inputs":[{"name":"arc"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"default","","",4,{"inputs":[{"name":"arc"}],"output":{"name":"arc"}}],[11,"hash","","",4,null],[11,"new","alloc::rc","Constructs a new `Rc<T>`.",5,{"inputs":[{"name":"rc"},{"name":"t"}],"output":{"name":"rc"}}],[11,"try_unwrap","","Unwraps the contained value if the `Rc<T>` is unique.",5,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"result"}}],[11,"downgrade","","Downgrades the `Rc<T>` to a `Weak<T>` reference.",5,{"inputs":[{"name":"rc"}],"output":{"name":"weak"}}],[11,"weak_count","","Get the number of weak references to this value.",5,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"usize"}}],[11,"strong_count","","Get the number of strong references to this value.",5,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"usize"}}],[11,"is_unique","","Returns true if there are no other `Rc` or `Weak<T>` values that share\nthe same inner value.",5,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"get_mut","","Returns a mutable reference to the contained value if the `Rc<T>` is\nunique.",5,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"option"}}],[11,"make_unique","","Make a mutable reference from the given `Rc<T>`.",5,{"inputs":[{"name":"rc"}],"output":{"name":"t"}}],[11,"deref","","",5,{"inputs":[{"name":"rc"}],"output":{"name":"t"}}],[11,"drop","","Drops the `Rc<T>`.",5,null],[11,"clone","","Makes a clone of the `Rc<T>`.",5,{"inputs":[{"name":"rc"}],"output":{"name":"rc"}}],[11,"default","","Creates a new `Rc<T>`, with the `Default` value for `T`.",5,{"inputs":[{"name":"rc"}],"output":{"name":"rc"}}],[11,"eq","","Equality for two `Rc<T>`s.",5,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"ne","","Inequality for two `Rc<T>`s.",5,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"partial_cmp","","Partial comparison for two `Rc<T>`s.",5,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"option"}}],[11,"lt","","Less-than comparison for two `Rc<T>`s.",5,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"le","","'Less-than or equal to' comparison for two `Rc<T>`s.",5,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"gt","","Greater-than comparison for two `Rc<T>`s.",5,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"ge","","'Greater-than or equal to' comparison for two `Rc<T>`s.",5,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"cmp","","Comparison for two `Rc<T>`s.",5,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"ordering"}}],[11,"hash","","",5,null],[11,"fmt","","",5,{"inputs":[{"name":"rc"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",5,{"inputs":[{"name":"rc"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",5,{"inputs":[{"name":"rc"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"upgrade","","Upgrades a weak reference to a strong reference.",6,{"inputs":[{"name":"weak"}],"output":{"name":"option"}}],[11,"drop","","Drops the `Weak<T>`.",6,null],[11,"clone","","Makes a clone of the `Weak<T>`.",6,{"inputs":[{"name":"weak"}],"output":{"name":"weak"}}],[11,"fmt","","",6,{"inputs":[{"name":"weak"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","alloc::raw_vec","Creates the biggest possible RawVec without allocating. If T has positive\nsize, then this makes a RawVec with capacity 0. If T has 0 size, then it\nit makes a RawVec with capacity `usize::MAX`. Useful for implementing\ndelayed allocation.",7,{"inputs":[{"name":"rawvec"}],"output":{"name":"rawvec"}}],[11,"with_capacity","","Creates a RawVec with exactly the capacity and alignment requirements\nfor a `[T; cap]`. This is equivalent to calling RawVec::new when `cap` is 0\nor T is zero-sized. Note that if `T` is zero-sized this means you will *not*\nget a RawVec with the requested capacity!",7,{"inputs":[{"name":"rawvec"},{"name":"usize"}],"output":{"name":"rawvec"}}],[11,"from_raw_parts","","Reconstitutes a RawVec from a pointer and capacity.",7,null],[11,"from_box","","Converts a `Box<[T]>` into a `RawVec<T>`.",7,{"inputs":[{"name":"rawvec"},{"name":"box"}],"output":{"name":"rawvec"}}],[11,"ptr","","Gets a raw pointer to the start of the allocation. Note that this is\nheap::EMPTY if `cap = 0` or T is zero-sized. In the former case, you must\nbe careful.",7,null],[11,"cap","","Gets the capacity of the allocation.",7,{"inputs":[{"name":"rawvec"}],"output":{"name":"usize"}}],[11,"double","","Doubles the size of the type's backing allocation. This is common enough\nto want to do that it's easiest to just have a dedicated method. Slightly\nmore efficient logic can be provided for this than the general case.",7,null],[11,"reserve_exact","","Ensures that the buffer contains at least enough space to hold\n`used_cap + needed_extra_cap` elements. If it doesn't already,\nwill reallocate the minimum possible amount of memory necessary.\nGenerally this will be exactly the amount of memory necessary,\nbut in principle the allocator is free to give back more than\nwe asked for.",7,null],[11,"reserve","","Ensures that the buffer contains at least enough space to hold\n`used_cap + needed_extra_cap` elements. If it doesn't already have\nenough capacity, will reallocate enough space plus comfortable slack\nspace to get amortized `O(1)` behaviour. Will limit this behaviour\nif it would needlessly cause itself to panic.",7,null],[11,"shrink_to_fit","","Shrinks the allocation down to the specified amount. If the given amount\nis 0, actually completely deallocates.",7,null],[11,"into_box","","Converts the entire buffer into `Box<[T]>`.",7,{"inputs":[{"name":"rawvec"}],"output":{"name":"box"}}],[11,"unsafe_no_drop_flag_needs_drop","","This is a stupid name in the hopes that someone will find this in the\nnot too distant future and remove it with the rest of\n#[unsafe_no_drop_flag]",7,{"inputs":[{"name":"rawvec"}],"output":{"name":"bool"}}],[11,"drop","","Frees the memory owned by the RawVec *without* trying to Drop its contents.",7,null],[3,"ExchangeHeapSingleton","collections::boxed","This the singleton type used solely for `boxed::HEAP`.",null,null],[3,"Box","","A pointer type for heap allocation.",null,null],[3,"IntermediateBox","","`IntermediateBox` represents uninitialized backing storage for `Box`.",null,null],[5,"into_raw","","Consumes the `Box`, returning the wrapped raw pointer.",null,null],[8,"FnBox","","`FnBox` is a version of the `FnOnce` intended for use with boxed\nclosure objects. The idea is that where one would normally store a\n`Box<FnOnce()>` in a data structure, you should use\n`Box<FnBox()>`. The two traits behave essentially the same, except\nthat a `FnBox` closure can only be called if it is boxed. (Note\nthat `FnBox` may be deprecated in the future if `Box<FnOnce()>`\nclosures become directly usable.)",null,null],[16,"Output","","",8,null],[10,"call_box","","",8,null],[3,"BitVec","collections","The bitvector type.",null,null],[3,"BitSet","","An implementation of a set using a bit vector as an underlying\nrepresentation for holding unsigned numerical elements.",null,null],[3,"BTreeMap","","A map based on a B-Tree.",null,null],[3,"BTreeSet","","A set based on a B-Tree.",null,null],[4,"Bound","","An endpoint of a range of keys.",null,null],[13,"Included","","An inclusive bound.",9,null],[13,"Excluded","","An exclusive bound.",9,null],[13,"Unbounded","","An infinite endpoint. Indicates that there is no bound in this direction.",9,null],[0,"binary_heap","","A priority queue implemented with a binary heap.",null,null],[3,"BinaryHeap","collections::binary_heap","A priority queue implemented with a binary heap.",null,null],[3,"Iter","","`BinaryHeap` iterator.",null,null],[3,"IntoIter","","An iterator that moves out of a `BinaryHeap`.",null,null],[3,"Drain","","An iterator that drains a `BinaryHeap`.",null,null],[11,"clone","","",10,{"inputs":[{"name":"binaryheap"}],"output":{"name":"binaryheap"}}],[11,"default","","",10,{"inputs":[{"name":"binaryheap"}],"output":{"name":"binaryheap"}}],[11,"new","","Creates an empty `BinaryHeap` as a max-heap.",10,{"inputs":[{"name":"binaryheap"}],"output":{"name":"binaryheap"}}],[11,"with_capacity","","Creates an empty `BinaryHeap` with a specific capacity.\nThis preallocates enough memory for `capacity` elements,\nso that the `BinaryHeap` does not have to be reallocated\nuntil it contains at least that many values.",10,{"inputs":[{"name":"binaryheap"},{"name":"usize"}],"output":{"name":"binaryheap"}}],[11,"from_vec","","Creates a `BinaryHeap` from a vector. This is sometimes called\n`heapifying` the vector.",10,{"inputs":[{"name":"binaryheap"},{"name":"vec"}],"output":{"name":"binaryheap"}}],[11,"iter","","Returns an iterator visiting all values in the underlying vector, in\narbitrary order.",10,{"inputs":[{"name":"binaryheap"}],"output":{"name":"iter"}}],[11,"peek","","Returns the greatest item in the binary heap, or `None` if it is empty.",10,{"inputs":[{"name":"binaryheap"}],"output":{"name":"option"}}],[11,"capacity","","Returns the number of elements the binary heap can hold without reallocating.",10,{"inputs":[{"name":"binaryheap"}],"output":{"name":"usize"}}],[11,"reserve_exact","","Reserves the minimum capacity for exactly `additional` more elements to be inserted in the\ngiven `BinaryHeap`. Does nothing if the capacity is already sufficient.",10,{"inputs":[{"name":"binaryheap"},{"name":"usize"}],"output":null}],[11,"reserve","","Reserves capacity for at least `additional` more elements to be inserted in the\n`BinaryHeap`. The collection may reserve more space to avoid frequent reallocations.",10,{"inputs":[{"name":"binaryheap"},{"name":"usize"}],"output":null}],[11,"shrink_to_fit","","Discards as much additional capacity as possible.",10,{"inputs":[{"name":"binaryheap"}],"output":null}],[11,"pop","","Removes the greatest item from the binary heap and returns it, or `None` if it\nis empty.",10,{"inputs":[{"name":"binaryheap"}],"output":{"name":"option"}}],[11,"push","","Pushes an item onto the binary heap.",10,{"inputs":[{"name":"binaryheap"},{"name":"t"}],"output":null}],[11,"push_pop","","Pushes an item onto the binary heap, then pops the greatest item off the queue in\nan optimized fashion.",10,{"inputs":[{"name":"binaryheap"},{"name":"t"}],"output":{"name":"t"}}],[11,"replace","","Pops the greatest item off the binary heap, then pushes an item onto the queue in\nan optimized fashion. The push is done regardless of whether the binary heap\nwas empty.",10,{"inputs":[{"name":"binaryheap"},{"name":"t"}],"output":{"name":"option"}}],[11,"into_vec","","Consumes the `BinaryHeap` and returns the underlying vector\nin arbitrary order.",10,{"inputs":[{"name":"binaryheap"}],"output":{"name":"vec"}}],[11,"into_sorted_vec","","Consumes the `BinaryHeap` and returns a vector in sorted\n(ascending) order.",10,{"inputs":[{"name":"binaryheap"}],"output":{"name":"vec"}}],[11,"len","","Returns the length of the binary heap.",10,{"inputs":[{"name":"binaryheap"}],"output":{"name":"usize"}}],[11,"is_empty","","Checks if the binary heap is empty.",10,{"inputs":[{"name":"binaryheap"}],"output":{"name":"bool"}}],[11,"drain","","Clears the binary heap, returning an iterator over the removed elements.",10,{"inputs":[{"name":"binaryheap"}],"output":{"name":"drain"}}],[11,"clear","","Drops all items from the binary heap.",10,{"inputs":[{"name":"binaryheap"}],"output":null}],[11,"clone","","",11,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[11,"next","","",11,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",11,null],[11,"next_back","","",11,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"next","","",12,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",12,null],[11,"next_back","","",12,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"next","","",13,{"inputs":[{"name":"drain"}],"output":{"name":"option"}}],[11,"size_hint","","",13,null],[11,"next_back","","",13,{"inputs":[{"name":"drain"}],"output":{"name":"option"}}],[11,"from_iter","","",10,{"inputs":[{"name":"binaryheap"},{"name":"i"}],"output":{"name":"binaryheap"}}],[11,"into_iter","","Creates a consuming iterator, that is, one that moves each value out of\nthe binary heap in arbitrary order. The binary heap cannot be used\nafter calling this.",10,{"inputs":[{"name":"binaryheap"}],"output":{"name":"intoiter"}}],[11,"extend","","",10,{"inputs":[{"name":"binaryheap"},{"name":"i"}],"output":null}],[11,"extend","","",10,{"inputs":[{"name":"binaryheap"},{"name":"i"}],"output":null}],[11,"index","collections","",14,{"inputs":[{"name":"bitvec"},{"name":"usize"}],"output":{"name":"bool"}}],[11,"new","","Creates an empty `BitVec`.",14,{"inputs":[{"name":"bitvec"}],"output":{"name":"bitvec"}}],[11,"from_elem","","Creates a `BitVec` that holds `nbits` elements, setting each element\nto `bit`.",14,{"inputs":[{"name":"bitvec"},{"name":"usize"},{"name":"bool"}],"output":{"name":"bitvec"}}],[11,"with_capacity","","Constructs a new, empty `BitVec` with the specified capacity.",14,{"inputs":[{"name":"bitvec"},{"name":"usize"}],"output":{"name":"bitvec"}}],[11,"from_bytes","","Transforms a byte-vector into a `BitVec`. Each byte becomes eight bits,\nwith the most significant bits of each byte coming first. Each\nbit becomes `true` if equal to 1 or `false` if equal to 0.",14,null],[11,"from_fn","","Creates a `BitVec` of the specified length where the value at each index\nis `f(index)`.",14,{"inputs":[{"name":"bitvec"},{"name":"usize"},{"name":"f"}],"output":{"name":"bitvec"}}],[11,"get","","Retrieves the value at index `i`, or `None` if the index is out of bounds.",14,{"inputs":[{"name":"bitvec"},{"name":"usize"}],"output":{"name":"option"}}],[11,"set","","Sets the value of a bit at an index `i`.",14,{"inputs":[{"name":"bitvec"},{"name":"usize"},{"name":"bool"}],"output":null}],[11,"set_all","","Sets all bits to 1.",14,{"inputs":[{"name":"bitvec"}],"output":null}],[11,"negate","","Flips all bits.",14,{"inputs":[{"name":"bitvec"}],"output":null}],[11,"union","","Calculates the union of two bitvectors. This acts like the bitwise `or`\nfunction.",14,{"inputs":[{"name":"bitvec"},{"name":"bitvec"}],"output":{"name":"bool"}}],[11,"intersect","","Calculates the intersection of two bitvectors. This acts like the\nbitwise `and` function.",14,{"inputs":[{"name":"bitvec"},{"name":"bitvec"}],"output":{"name":"bool"}}],[11,"difference","","Calculates the difference between two bitvectors.",14,{"inputs":[{"name":"bitvec"},{"name":"bitvec"}],"output":{"name":"bool"}}],[11,"all","","Returns `true` if all bits are 1.",14,{"inputs":[{"name":"bitvec"}],"output":{"name":"bool"}}],[11,"iter","","Returns an iterator over the elements of the vector in order.",14,{"inputs":[{"name":"bitvec"}],"output":{"name":"iter"}}],[11,"append","","Moves all bits from `other` into `Self`, leaving `other` empty.",14,{"inputs":[{"name":"bitvec"},{"name":"self"}],"output":null}],[11,"split_off","","Splits the `BitVec` into two at the given bit,\nretaining the first half in-place and returning the second one.",14,{"inputs":[{"name":"bitvec"},{"name":"usize"}],"output":{"name":"self"}}],[11,"none","","Returns `true` if all bits are 0.",14,{"inputs":[{"name":"bitvec"}],"output":{"name":"bool"}}],[11,"any","","Returns `true` if any bit is 1.",14,{"inputs":[{"name":"bitvec"}],"output":{"name":"bool"}}],[11,"to_bytes","","Organises the bits into bytes, such that the first bit in the\n`BitVec` becomes the high-order bit of the first byte. If the\nsize of the `BitVec` is not a multiple of eight then trailing bits\nwill be filled-in with `false`.",14,{"inputs":[{"name":"bitvec"}],"output":{"name":"vec"}}],[11,"eq_vec","","Compares a `BitVec` to a slice of `bool`s.\nBoth the `BitVec` and slice must have the same length.",14,null],[11,"truncate","","Shortens a `BitVec`, dropping excess elements.",14,{"inputs":[{"name":"bitvec"},{"name":"usize"}],"output":null}],[11,"reserve","","Reserves capacity for at least `additional` more bits to be inserted in the given\n`BitVec`. The collection may reserve more space to avoid frequent reallocations.",14,{"inputs":[{"name":"bitvec"},{"name":"usize"}],"output":null}],[11,"reserve_exact","","Reserves the minimum capacity for exactly `additional` more bits to be inserted in the\ngiven `BitVec`. Does nothing if the capacity is already sufficient.",14,{"inputs":[{"name":"bitvec"},{"name":"usize"}],"output":null}],[11,"capacity","","Returns the capacity in bits for this bit vector. Inserting any\nelement less than this amount will not trigger a resizing.",14,{"inputs":[{"name":"bitvec"}],"output":{"name":"usize"}}],[11,"grow","","Grows the `BitVec` in-place, adding `n` copies of `value` to the `BitVec`.",14,{"inputs":[{"name":"bitvec"},{"name":"usize"},{"name":"bool"}],"output":null}],[11,"pop","","Removes the last bit from the BitVec, and returns it. Returns None if the BitVec is empty.",14,{"inputs":[{"name":"bitvec"}],"output":{"name":"option"}}],[11,"push","","Pushes a `bool` onto the end.",14,{"inputs":[{"name":"bitvec"},{"name":"bool"}],"output":null}],[11,"len","","Returns the total number of bits in this vector",14,{"inputs":[{"name":"bitvec"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns true if there are no bits in this vector",14,{"inputs":[{"name":"bitvec"}],"output":{"name":"bool"}}],[11,"clear","","Clears all bits in this vector.",14,{"inputs":[{"name":"bitvec"}],"output":null}],[11,"default","","",14,{"inputs":[{"name":"bitvec"}],"output":{"name":"bitvec"}}],[11,"from_iter","","",14,{"inputs":[{"name":"bitvec"},{"name":"i"}],"output":{"name":"bitvec"}}],[11,"extend","","",14,{"inputs":[{"name":"bitvec"},{"name":"i"}],"output":null}],[11,"extend","","",14,{"inputs":[{"name":"bitvec"},{"name":"i"}],"output":null}],[11,"clone","","",14,{"inputs":[{"name":"bitvec"}],"output":{"name":"bitvec"}}],[11,"clone_from","","",14,{"inputs":[{"name":"bitvec"},{"name":"bitvec"}],"output":null}],[11,"partial_cmp","","",14,{"inputs":[{"name":"bitvec"},{"name":"bitvec"}],"output":{"name":"option"}}],[11,"cmp","","",14,{"inputs":[{"name":"bitvec"},{"name":"bitvec"}],"output":{"name":"ordering"}}],[11,"fmt","","",14,{"inputs":[{"name":"bitvec"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",14,{"inputs":[{"name":"bitvec"},{"name":"h"}],"output":null}],[11,"eq","","",14,{"inputs":[{"name":"bitvec"},{"name":"bitvec"}],"output":{"name":"bool"}}],[11,"clone","","",15,{"inputs":[{"name":"bitset"}],"output":{"name":"bitset"}}],[11,"default","","",15,{"inputs":[{"name":"bitset"}],"output":{"name":"bitset"}}],[11,"from_iter","","",15,{"inputs":[{"name":"bitset"},{"name":"i"}],"output":{"name":"bitset"}}],[11,"extend","","",15,{"inputs":[{"name":"bitset"},{"name":"i"}],"output":null}],[11,"extend","","",15,{"inputs":[{"name":"bitset"},{"name":"i"}],"output":null}],[11,"partial_cmp","","",15,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":{"name":"option"}}],[11,"cmp","","",15,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":{"name":"ordering"}}],[11,"eq","","",15,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":{"name":"bool"}}],[11,"new","","Creates a new empty `BitSet`.",15,{"inputs":[{"name":"bitset"}],"output":{"name":"bitset"}}],[11,"with_capacity","","Creates a new `BitSet` with initially no contents, able to\nhold `nbits` elements without resizing.",15,{"inputs":[{"name":"bitset"},{"name":"usize"}],"output":{"name":"bitset"}}],[11,"from_bit_vec","","Creates a new `BitSet` from the given bit vector.",15,{"inputs":[{"name":"bitset"},{"name":"bitvec"}],"output":{"name":"bitset"}}],[11,"capacity","","Returns the capacity in bits for this bit vector. Inserting any\nelement less than this amount will not trigger a resizing.",15,{"inputs":[{"name":"bitset"}],"output":{"name":"usize"}}],[11,"reserve_len","","Reserves capacity for the given `BitSet` to contain `len` distinct\nelements. In the case of `BitSet` this means reallocations will not\noccur as long as all inserted elements are less than `len`.",15,{"inputs":[{"name":"bitset"},{"name":"usize"}],"output":null}],[11,"reserve_len_exact","","Reserves the minimum capacity for the given `BitSet` to contain `len`\ndistinct elements.  In the case of `BitSet` this means reallocations\nwill not occur as long as all inserted elements are less than `len`.",15,{"inputs":[{"name":"bitset"},{"name":"usize"}],"output":null}],[11,"into_bit_vec","","Consumes this set to return the underlying bit vector.",15,{"inputs":[{"name":"bitset"}],"output":{"name":"bitvec"}}],[11,"get_ref","","Returns a reference to the underlying bit vector.",15,{"inputs":[{"name":"bitset"}],"output":{"name":"bitvec"}}],[11,"shrink_to_fit","","Truncates the underlying vector to the least length required.",15,{"inputs":[{"name":"bitset"}],"output":null}],[11,"iter","","Iterator over each usize stored in the `BitSet`.",15,{"inputs":[{"name":"bitset"}],"output":{"name":"iter"}}],[11,"union","","Iterator over each usize stored in `self` union `other`.\nSee [union_with](#method.union_with) for an efficient in-place version.",15,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":{"name":"union"}}],[11,"intersection","","Iterator over each usize stored in `self` intersect `other`.\nSee [intersect_with](#method.intersect_with) for an efficient in-place\nversion.",15,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":{"name":"intersection"}}],[11,"difference","","Iterator over each usize stored in the `self` setminus `other`.\nSee [difference_with](#method.difference_with) for an efficient in-place\nversion.",15,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":{"name":"difference"}}],[11,"symmetric_difference","","Iterator over each usize stored in the symmetric difference of `self`\nand `other`.  See\n[symmetric_difference_with](#method.symmetric_difference_with) for an\nefficient in-place version.",15,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":{"name":"symmetricdifference"}}],[11,"union_with","","Unions in-place with the specified other bit vector.",15,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":null}],[11,"intersect_with","","Intersects in-place with the specified other bit vector.",15,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":null}],[11,"difference_with","","Makes this bit vector the difference with the specified other bit vector\nin-place.",15,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":null}],[11,"symmetric_difference_with","","Makes this bit vector the symmetric difference with the specified other\nbit vector in-place.",15,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":null}],[11,"append","","Moves all elements from `other` into `Self`, leaving `other` empty.",15,{"inputs":[{"name":"bitset"},{"name":"self"}],"output":null}],[11,"split_off","","Splits the `BitSet` into two at the given key including the key.\nRetains the first part in-place while returning the second part.",15,{"inputs":[{"name":"bitset"},{"name":"usize"}],"output":{"name":"self"}}],[11,"len","","Returns the number of set bits in this set.",15,{"inputs":[{"name":"bitset"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns whether there are no bits set in this set",15,{"inputs":[{"name":"bitset"}],"output":{"name":"bool"}}],[11,"clear","","Clears all bits in this set",15,{"inputs":[{"name":"bitset"}],"output":null}],[11,"contains","","Returns `true` if this set contains the specified integer.",15,{"inputs":[{"name":"bitset"},{"name":"usize"}],"output":{"name":"bool"}}],[11,"is_disjoint","","Returns `true` if the set has no elements in common with `other`.\nThis is equivalent to checking for an empty intersection.",15,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":{"name":"bool"}}],[11,"is_subset","","Returns `true` if the set is a subset of another.",15,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":{"name":"bool"}}],[11,"is_superset","","Returns `true` if the set is a superset of another.",15,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":{"name":"bool"}}],[11,"insert","","Adds a value to the set. Returns `true` if the value was not already\npresent in the set.",15,{"inputs":[{"name":"bitset"},{"name":"usize"}],"output":{"name":"bool"}}],[11,"remove","","Removes a value from the set. Returns `true` if the value was\npresent in the set.",15,{"inputs":[{"name":"bitset"},{"name":"usize"}],"output":{"name":"bool"}}],[11,"fmt","","",15,{"inputs":[{"name":"bitset"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",15,{"inputs":[{"name":"bitset"},{"name":"h"}],"output":null}],[11,"clone","","",16,{"inputs":[{"name":"btreemap"}],"output":{"name":"btreemap"}}],[11,"new","","Makes a new empty BTreeMap with a reasonable choice for B.",16,{"inputs":[{"name":"btreemap"}],"output":{"name":"btreemap"}}],[11,"with_b","","Makes a new empty BTreeMap with the given B.",16,{"inputs":[{"name":"btreemap"},{"name":"usize"}],"output":{"name":"btreemap"}}],[11,"clear","","Clears the map, removing all values.",16,{"inputs":[{"name":"btreemap"}],"output":null}],[11,"get","","Returns a reference to the value corresponding to the key.",16,{"inputs":[{"name":"btreemap"},{"name":"q"}],"output":{"name":"option"}}],[11,"contains_key","","Returns true if the map contains a value for the specified key.",16,{"inputs":[{"name":"btreemap"},{"name":"q"}],"output":{"name":"bool"}}],[11,"get_mut","","Returns a mutable reference to the value corresponding to the key.",16,{"inputs":[{"name":"btreemap"},{"name":"q"}],"output":{"name":"option"}}],[11,"insert","","Inserts a key-value pair into the map. If the key already had a value\npresent in the map, that value is returned. Otherwise, `None` is returned.",16,{"inputs":[{"name":"btreemap"},{"name":"k"},{"name":"v"}],"output":{"name":"option"}}],[11,"remove","","Removes a key from the map, returning the value at the key if the key\nwas previously in the map.",16,{"inputs":[{"name":"btreemap"},{"name":"q"}],"output":{"name":"option"}}],[11,"into_iter","","Gets an owning iterator over the entries of the map.",16,{"inputs":[{"name":"btreemap"}],"output":{"name":"intoiter"}}],[11,"from_iter","","",16,{"inputs":[{"name":"btreemap"},{"name":"t"}],"output":{"name":"btreemap"}}],[11,"extend","","",16,{"inputs":[{"name":"btreemap"},{"name":"t"}],"output":null}],[11,"extend","","",16,{"inputs":[{"name":"btreemap"},{"name":"i"}],"output":null}],[11,"hash","","",16,{"inputs":[{"name":"btreemap"},{"name":"h"}],"output":null}],[11,"default","","",16,{"inputs":[{"name":"btreemap"}],"output":{"name":"btreemap"}}],[11,"eq","","",16,{"inputs":[{"name":"btreemap"},{"name":"btreemap"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",16,{"inputs":[{"name":"btreemap"},{"name":"btreemap"}],"output":{"name":"option"}}],[11,"cmp","","",16,{"inputs":[{"name":"btreemap"},{"name":"btreemap"}],"output":{"name":"ordering"}}],[11,"fmt","","",16,{"inputs":[{"name":"btreemap"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"index","","",16,{"inputs":[{"name":"btreemap"},{"name":"q"}],"output":{"name":"v"}}],[11,"iter","","Gets an iterator over the entries of the map.",16,{"inputs":[{"name":"btreemap"}],"output":{"name":"iter"}}],[11,"iter_mut","","Gets a mutable iterator over the entries of the map.",16,{"inputs":[{"name":"btreemap"}],"output":{"name":"itermut"}}],[11,"keys","","Gets an iterator over the keys of the map.",16,{"inputs":[{"name":"btreemap"}],"output":{"name":"keys"}}],[11,"values","","Gets an iterator over the values of the map.",16,{"inputs":[{"name":"btreemap"}],"output":{"name":"values"}}],[11,"len","","Returns the number of elements in the map.",16,{"inputs":[{"name":"btreemap"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns true if the map contains no elements.",16,{"inputs":[{"name":"btreemap"}],"output":{"name":"bool"}}],[11,"range","","Constructs a double-ended iterator over a sub-range of elements in the map, starting\nat min, and ending at max. If min is `Unbounded`, then it will be treated as \"negative\ninfinity\", and if max is `Unbounded`, then it will be treated as \"positive infinity\".\nThus range(Unbounded, Unbounded) will yield the whole collection.",16,{"inputs":[{"name":"btreemap"},{"name":"bound"},{"name":"bound"}],"output":{"name":"range"}}],[11,"range_mut","","Constructs a mutable double-ended iterator over a sub-range of elements in the map, starting\nat min, and ending at max. If min is `Unbounded`, then it will be treated as \"negative\ninfinity\", and if max is `Unbounded`, then it will be treated as \"positive infinity\".\nThus range(Unbounded, Unbounded) will yield the whole collection.",16,{"inputs":[{"name":"btreemap"},{"name":"bound"},{"name":"bound"}],"output":{"name":"rangemut"}}],[11,"entry","","Gets the given key's corresponding entry in the map for in-place manipulation.",16,{"inputs":[{"name":"btreemap"},{"name":"k"}],"output":{"name":"entry"}}],[11,"partial_cmp","","",17,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"option"}}],[11,"lt","","",17,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"bool"}}],[11,"le","","",17,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"bool"}}],[11,"gt","","",17,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"bool"}}],[11,"ge","","",17,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"bool"}}],[11,"cmp","","",17,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"ordering"}}],[11,"eq","","",17,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"bool"}}],[11,"ne","","",17,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"bool"}}],[11,"hash","","",17,null],[11,"clone","","",17,{"inputs":[{"name":"btreeset"}],"output":{"name":"btreeset"}}],[11,"new","","Makes a new BTreeSet with a reasonable choice of B.",17,{"inputs":[{"name":"btreeset"}],"output":{"name":"btreeset"}}],[11,"with_b","","Makes a new BTreeSet with the given B.",17,{"inputs":[{"name":"btreeset"},{"name":"usize"}],"output":{"name":"btreeset"}}],[11,"iter","","Gets an iterator over the BTreeSet's contents.",17,{"inputs":[{"name":"btreeset"}],"output":{"name":"iter"}}],[11,"range","","Constructs a double-ended iterator over a sub-range of elements in the set, starting\nat min, and ending at max. If min is `Unbounded`, then it will be treated as \"negative\ninfinity\", and if max is `Unbounded`, then it will be treated as \"positive infinity\".\nThus range(Unbounded, Unbounded) will yield the whole collection.",17,{"inputs":[{"name":"btreeset"},{"name":"bound"},{"name":"bound"}],"output":{"name":"range"}}],[11,"difference","","Visits the values representing the difference, in ascending order.",17,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"difference"}}],[11,"symmetric_difference","","Visits the values representing the symmetric difference, in ascending order.",17,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"symmetricdifference"}}],[11,"intersection","","Visits the values representing the intersection, in ascending order.",17,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"intersection"}}],[11,"union","","Visits the values representing the union, in ascending order.",17,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"union"}}],[11,"len","","Returns the number of elements in the set.",17,{"inputs":[{"name":"btreeset"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns true if the set contains no elements.",17,{"inputs":[{"name":"btreeset"}],"output":{"name":"bool"}}],[11,"clear","","Clears the set, removing all values.",17,{"inputs":[{"name":"btreeset"}],"output":null}],[11,"contains","","Returns `true` if the set contains a value.",17,{"inputs":[{"name":"btreeset"},{"name":"q"}],"output":{"name":"bool"}}],[11,"is_disjoint","","Returns `true` if the set has no elements in common with `other`.\nThis is equivalent to checking for an empty intersection.",17,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"bool"}}],[11,"is_subset","","Returns `true` if the set is a subset of another.",17,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"bool"}}],[11,"is_superset","","Returns `true` if the set is a superset of another.",17,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"bool"}}],[11,"insert","","Adds a value to the set. Returns `true` if the value was not already\npresent in the set.",17,{"inputs":[{"name":"btreeset"},{"name":"t"}],"output":{"name":"bool"}}],[11,"remove","","Removes a value from the set. Returns `true` if the value was\npresent in the set.",17,{"inputs":[{"name":"btreeset"},{"name":"q"}],"output":{"name":"bool"}}],[11,"from_iter","","",17,{"inputs":[{"name":"btreeset"},{"name":"i"}],"output":{"name":"btreeset"}}],[11,"into_iter","","Gets an iterator for moving out the BtreeSet's contents.",17,{"inputs":[{"name":"btreeset"}],"output":{"name":"intoiter"}}],[11,"extend","","",17,{"inputs":[{"name":"btreeset"},{"name":"iter"}],"output":null}],[11,"extend","","",17,{"inputs":[{"name":"btreeset"},{"name":"i"}],"output":null}],[11,"default","","",17,{"inputs":[{"name":"btreeset"}],"output":{"name":"btreeset"}}],[11,"fmt","","",17,{"inputs":[{"name":"btreeset"},{"name":"formatter"}],"output":{"name":"result"}}],[0,"borrow","","A module for working with borrowed data.",null,null],[4,"Cow","collections::borrow","A clone-on-write smart pointer.",null,null],[13,"Borrowed","","Borrowed data.",18,null],[13,"Owned","","Owned data.",18,null],[8,"Borrow","","A trait for borrowing data.",null,null],[10,"borrow","","Immutably borrows from an owned value.",19,{"inputs":[{"name":"borrow"}],"output":{"name":"borrowed"}}],[8,"BorrowMut","","A trait for mutably borrowing data.",null,null],[10,"borrow_mut","","Mutably borrows from an owned value.",20,{"inputs":[{"name":"borrowmut"}],"output":{"name":"borrowed"}}],[8,"ToOwned","","A generalization of `Clone` to borrowed data.",null,null],[16,"Owned","","",21,null],[10,"to_owned","","Creates owned data from borrowed data, usually by cloning.",21,{"inputs":[{"name":"toowned"}],"output":{"name":"owned"}}],[8,"IntoCow","","Trait for moving into a `Cow`.",null,null],[10,"into_cow","","Moves `self` into `Cow`",22,{"inputs":[{"name":"intocow"}],"output":{"name":"cow"}}],[11,"borrow","collections::boxed","",2,{"inputs":[{"name":"box"}],"output":{"name":"t"}}],[11,"borrow_mut","","",2,{"inputs":[{"name":"box"}],"output":{"name":"t"}}],[11,"borrow","alloc::rc","",5,{"inputs":[{"name":"rc"}],"output":{"name":"t"}}],[11,"borrow","alloc::arc","",4,{"inputs":[{"name":"arc"}],"output":{"name":"t"}}],[11,"borrow","collections::borrow","",18,{"inputs":[{"name":"cow"}],"output":{"name":"b"}}],[11,"clone","","",18,{"inputs":[{"name":"cow"}],"output":{"name":"cow"}}],[11,"to_mut","","Acquires a mutable reference to the owned form of the data.",18,null],[11,"into_owned","","Extracts the owned data.",18,null],[11,"deref","","",18,{"inputs":[{"name":"cow"}],"output":{"name":"b"}}],[11,"cmp","","",18,{"inputs":[{"name":"cow"},{"name":"cow"}],"output":{"name":"ordering"}}],[11,"eq","","",18,{"inputs":[{"name":"cow"},{"name":"cow"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",18,{"inputs":[{"name":"cow"},{"name":"cow"}],"output":{"name":"option"}}],[11,"fmt","","",18,{"inputs":[{"name":"cow"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",18,{"inputs":[{"name":"cow"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",18,{"inputs":[{"name":"cow"},{"name":"h"}],"output":null}],[11,"into_cow","","",18,{"inputs":[{"name":"cow"}],"output":{"name":"cow"}}],[11,"as_ref","","",18,{"inputs":[{"name":"cow"}],"output":{"name":"t"}}],[0,"enum_set","collections","A structure for holding a set of enum variants.",null,null],[3,"EnumSet","collections::enum_set","A specialized set implementation to use enum types.",null,null],[3,"Iter","","An iterator over an EnumSet",null,null],[8,"CLike","","An interface for casting C-like enum to usize and back.\nA typically implementation is as below.",null,null],[10,"to_usize","","Converts a C-like enum to a `usize`.",23,{"inputs":[{"name":"clike"}],"output":{"name":"usize"}}],[10,"from_usize","","Converts a `usize` to a C-like enum.",23,{"inputs":[{"name":"clike"},{"name":"usize"}],"output":{"name":"self"}}],[11,"hash","","",24,null],[11,"cmp","","",24,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",24,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"option"}}],[11,"lt","","",24,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"bool"}}],[11,"le","","",24,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"bool"}}],[11,"gt","","",24,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"bool"}}],[11,"ge","","",24,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"bool"}}],[11,"eq","","",24,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"bool"}}],[11,"ne","","",24,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"bool"}}],[11,"clone","","",24,{"inputs":[{"name":"enumset"}],"output":{"name":"enumset"}}],[11,"fmt","","",24,{"inputs":[{"name":"enumset"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","Returns an empty `EnumSet`.",24,{"inputs":[{"name":"enumset"}],"output":{"name":"enumset"}}],[11,"len","","Returns the number of elements in the given `EnumSet`.",24,{"inputs":[{"name":"enumset"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns true if the `EnumSet` is empty.",24,{"inputs":[{"name":"enumset"}],"output":{"name":"bool"}}],[11,"clear","","",24,{"inputs":[{"name":"enumset"}],"output":null}],[11,"is_disjoint","","Returns `false` if the `EnumSet` contains any enum of the given `EnumSet`.",24,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"bool"}}],[11,"is_superset","","Returns `true` if a given `EnumSet` is included in this `EnumSet`.",24,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"bool"}}],[11,"is_subset","","Returns `true` if this `EnumSet` is included in the given `EnumSet`.",24,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"bool"}}],[11,"union","","Returns the union of both `EnumSets`.",24,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"enumset"}}],[11,"intersection","","Returns the intersection of both `EnumSets`.",24,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"enumset"}}],[11,"insert","","Adds an enum to the `EnumSet`, and returns `true` if it wasn't there before",24,{"inputs":[{"name":"enumset"},{"name":"e"}],"output":{"name":"bool"}}],[11,"remove","","Removes an enum from the EnumSet",24,{"inputs":[{"name":"enumset"},{"name":"e"}],"output":{"name":"bool"}}],[11,"contains","","Returns `true` if an `EnumSet` contains a given enum.",24,{"inputs":[{"name":"enumset"},{"name":"e"}],"output":{"name":"bool"}}],[11,"iter","","Returns an iterator over an `EnumSet`.",24,{"inputs":[{"name":"enumset"}],"output":{"name":"iter"}}],[11,"sub","","",24,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"enumset"}}],[11,"bitor","","",24,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"enumset"}}],[11,"bitand","","",24,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"enumset"}}],[11,"bitxor","","",24,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"enumset"}}],[11,"clone","","",25,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[11,"next","","",25,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",25,null],[11,"from_iter","","",24,{"inputs":[{"name":"enumset"},{"name":"i"}],"output":{"name":"enumset"}}],[11,"extend","","",24,{"inputs":[{"name":"enumset"},{"name":"i"}],"output":null}],[11,"extend","","",24,{"inputs":[{"name":"enumset"},{"name":"i"}],"output":null}],[0,"fmt","collections","Utilities for formatting and printing strings",null,null],[11,"pad_integral","core::fmt","Performs the correct padding for an integer which has already been\nemitted into a str. The str should *not* contain the sign for the\ninteger, that will be added by this method.",26,{"inputs":[{"name":"formatter"},{"name":"bool"},{"name":"str"},{"name":"str"}],"output":{"name":"result"}}],[11,"pad","","This function takes a string slice and emits it to the internal buffer\nafter applying the relevant formatting flags specified. The flags\nrecognized for generic strings are:",26,{"inputs":[{"name":"formatter"},{"name":"str"}],"output":{"name":"result"}}],[11,"write_str","","Writes some data to the underlying buffer contained within this\nformatter.",26,{"inputs":[{"name":"formatter"},{"name":"str"}],"output":{"name":"result"}}],[11,"write_fmt","","Writes some formatted information into this instance",26,{"inputs":[{"name":"formatter"},{"name":"arguments"}],"output":{"name":"result"}}],[11,"flags","","Flags for formatting (packed version of rt::Flag)",26,{"inputs":[{"name":"formatter"}],"output":{"name":"u32"}}],[11,"fill","","Character used as 'fill' whenever there is alignment",26,{"inputs":[{"name":"formatter"}],"output":{"name":"char"}}],[11,"align","","Flag indicating what form of alignment was requested",26,{"inputs":[{"name":"formatter"}],"output":{"name":"alignment"}}],[11,"width","","Optionally specified integer width that the output should be",26,{"inputs":[{"name":"formatter"}],"output":{"name":"option"}}],[11,"precision","","Optionally specified precision for numeric types",26,{"inputs":[{"name":"formatter"}],"output":{"name":"option"}}],[11,"debug_struct","","Creates a `DebugStruct` builder designed to assist with creation of\n`fmt::Debug` implementations for structs.",26,{"inputs":[{"name":"formatter"},{"name":"str"}],"output":{"name":"debugstruct"}}],[11,"debug_tuple","","Creates a `DebugTuple` builder designed to assist with creation of\n`fmt::Debug` implementations for tuple structs.",26,{"inputs":[{"name":"formatter"},{"name":"str"}],"output":{"name":"debugtuple"}}],[11,"debug_list","","Creates a `DebugList` builder designed to assist with creation of\n`fmt::Debug` implementations for list-like structures.",26,{"inputs":[{"name":"formatter"}],"output":{"name":"debuglist"}}],[11,"debug_set","","Creates a `DebugSet` builder designed to assist with creation of\n`fmt::Debug` implementations for set-like structures.",26,{"inputs":[{"name":"formatter"}],"output":{"name":"debugset"}}],[11,"debug_map","","Creates a `DebugMap` builder designed to assist with creation of\n`fmt::Debug` implementations for map-like structures.",26,{"inputs":[{"name":"formatter"}],"output":{"name":"debugmap"}}],[11,"fmt","core::num","",27,{"inputs":[{"name":"wrapping"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",27,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"cmp","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"option"}}],[11,"lt","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"le","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"gt","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"ge","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"eq","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"ne","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"shl","","",27,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shr","","",27,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shl","","",27,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shr","","",27,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shl","","",27,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shr","","",27,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shl","","",27,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shr","","",27,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shl","","",27,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shr","","",27,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shl","","",27,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shr","","",27,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shl","","",27,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shr","","",27,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shl","","",27,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shr","","",27,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shl","","",27,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shr","","",27,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shl","","",27,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shr","","",27,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"add","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"sub","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"mul","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"div","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"not","","",27,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitxor","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitor","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitand","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"add","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"sub","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"mul","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"div","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"not","","",27,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitxor","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitor","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitand","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"add","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"sub","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"mul","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"div","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"not","","",27,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitxor","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitor","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitand","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"add","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"sub","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"mul","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"div","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"not","","",27,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitxor","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitor","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitand","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"add","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"sub","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"mul","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"div","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"not","","",27,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitxor","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitor","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitand","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"add","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"sub","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"mul","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"div","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"not","","",27,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitxor","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitor","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitand","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"add","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"sub","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"mul","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"div","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"not","","",27,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitxor","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitor","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitand","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"add","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"sub","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"mul","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"div","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"not","","",27,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitxor","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitor","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitand","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"add","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"sub","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"mul","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"div","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"not","","",27,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitxor","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitor","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitand","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"add","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"sub","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"mul","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"div","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"not","","",27,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitxor","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitor","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitand","","",27,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"from_small","core::num::flt2dec::bignum","Makes a bignum from one digit.",28,{"inputs":[{"name":"big32x36"},{"name":"u32"}],"output":{"name":"big32x36"}}],[11,"from_u64","","Makes a bignum from `u64` value.",28,{"inputs":[{"name":"big32x36"},{"name":"u64"}],"output":{"name":"big32x36"}}],[11,"is_zero","","Returns true if the bignum is zero.",28,{"inputs":[{"name":"big32x36"}],"output":{"name":"bool"}}],[11,"add","","Adds `other` to itself and returns its own mutable reference.",28,{"inputs":[{"name":"big32x36"},{"name":"big32x36"}],"output":{"name":"big32x36"}}],[11,"sub","","Subtracts `other` from itself and returns its own mutable reference.",28,{"inputs":[{"name":"big32x36"},{"name":"big32x36"}],"output":{"name":"big32x36"}}],[11,"mul_small","","Multiplies itself by a digit-sized `other` and returns its own\nmutable reference.",28,{"inputs":[{"name":"big32x36"},{"name":"u32"}],"output":{"name":"big32x36"}}],[11,"mul_pow2","","Multiplies itself by `2^bits` and returns its own mutable reference.",28,{"inputs":[{"name":"big32x36"},{"name":"usize"}],"output":{"name":"big32x36"}}],[11,"mul_digits","","Multiplies itself by a number described by `other[0] + other[1] * 2^W +\nother[2] * 2^(2W) + ...` (where `W` is the number of bits in the digit type)\nand returns its own mutable reference.",28,null],[11,"div_rem_small","","Divides itself by a digit-sized `other` and returns its own\nmutable reference *and* the remainder.",28,null],[11,"eq","","",28,{"inputs":[{"name":"big32x36"},{"name":"big32x36"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",28,{"inputs":[{"name":"big32x36"},{"name":"big32x36"}],"output":{"name":"option"}}],[11,"cmp","","",28,{"inputs":[{"name":"big32x36"},{"name":"big32x36"}],"output":{"name":"ordering"}}],[11,"clone","","",28,{"inputs":[{"name":"big32x36"}],"output":{"name":"big32x36"}}],[11,"fmt","","",28,{"inputs":[{"name":"big32x36"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from_small","core::num::flt2dec::bignum::tests","Makes a bignum from one digit.",29,{"inputs":[{"name":"big8x3"},{"name":"u8"}],"output":{"name":"big8x3"}}],[11,"from_u64","","Makes a bignum from `u64` value.",29,{"inputs":[{"name":"big8x3"},{"name":"u64"}],"output":{"name":"big8x3"}}],[11,"is_zero","","Returns true if the bignum is zero.",29,{"inputs":[{"name":"big8x3"}],"output":{"name":"bool"}}],[11,"add","","Adds `other` to itself and returns its own mutable reference.",29,{"inputs":[{"name":"big8x3"},{"name":"big8x3"}],"output":{"name":"big8x3"}}],[11,"sub","","Subtracts `other` from itself and returns its own mutable reference.",29,{"inputs":[{"name":"big8x3"},{"name":"big8x3"}],"output":{"name":"big8x3"}}],[11,"mul_small","","Multiplies itself by a digit-sized `other` and returns its own\nmutable reference.",29,{"inputs":[{"name":"big8x3"},{"name":"u8"}],"output":{"name":"big8x3"}}],[11,"mul_pow2","","Multiplies itself by `2^bits` and returns its own mutable reference.",29,{"inputs":[{"name":"big8x3"},{"name":"usize"}],"output":{"name":"big8x3"}}],[11,"mul_digits","","Multiplies itself by a number described by `other[0] + other[1] * 2^W +\nother[2] * 2^(2W) + ...` (where `W` is the number of bits in the digit type)\nand returns its own mutable reference.",29,null],[11,"div_rem_small","","Divides itself by a digit-sized `other` and returns its own\nmutable reference *and* the remainder.",29,null],[11,"eq","","",29,{"inputs":[{"name":"big8x3"},{"name":"big8x3"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",29,{"inputs":[{"name":"big8x3"},{"name":"big8x3"}],"output":{"name":"option"}}],[11,"cmp","","",29,{"inputs":[{"name":"big8x3"},{"name":"big8x3"}],"output":{"name":"ordering"}}],[11,"clone","","",29,{"inputs":[{"name":"big8x3"}],"output":{"name":"big8x3"}}],[11,"fmt","","",29,{"inputs":[{"name":"big8x3"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","core::num::flt2dec::decoder","",30,{"inputs":[{"name":"decoded"},{"name":"decoded"}],"output":{"name":"bool"}}],[11,"ne","","",30,{"inputs":[{"name":"decoded"},{"name":"decoded"}],"output":{"name":"bool"}}],[11,"fmt","","",30,{"inputs":[{"name":"decoded"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",30,{"inputs":[{"name":"decoded"}],"output":{"name":"decoded"}}],[11,"eq","","",31,{"inputs":[{"name":"fulldecoded"},{"name":"fulldecoded"}],"output":{"name":"bool"}}],[11,"ne","","",31,{"inputs":[{"name":"fulldecoded"},{"name":"fulldecoded"}],"output":{"name":"bool"}}],[11,"fmt","","",31,{"inputs":[{"name":"fulldecoded"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",31,{"inputs":[{"name":"fulldecoded"}],"output":{"name":"fulldecoded"}}],[11,"fmt","core::num::flt2dec::strategy::grisu","",32,{"inputs":[{"name":"fp"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",32,{"inputs":[{"name":"fp"}],"output":{"name":"fp"}}],[11,"fmt","core::num::flt2dec","",33,{"inputs":[{"name":"part"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",33,{"inputs":[{"name":"part"},{"name":"part"}],"output":{"name":"bool"}}],[11,"ne","","",33,{"inputs":[{"name":"part"},{"name":"part"}],"output":{"name":"bool"}}],[11,"clone","","",33,{"inputs":[{"name":"part"}],"output":{"name":"part"}}],[11,"len","","Returns the exact byte length of given part.",33,{"inputs":[{"name":"part"}],"output":{"name":"usize"}}],[11,"write","","Writes a part into the supplied buffer.\nReturns the number of written bytes, or `None` if the buffer is not enough.\n(It may still leave partially written bytes in the buffer; do not rely on that.)",33,null],[11,"clone","","",34,{"inputs":[{"name":"formatted"}],"output":{"name":"formatted"}}],[11,"len","","Returns the exact byte length of combined formatted result.",34,{"inputs":[{"name":"formatted"}],"output":{"name":"usize"}}],[11,"write","","Writes all formatted parts into the supplied buffer.\nReturns the number of written bytes, or `None` if the buffer is not enough.\n(It may still leave partially written bytes in the buffer; do not rely on that.)",34,null],[11,"fmt","","",35,{"inputs":[{"name":"sign"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",35,{"inputs":[{"name":"sign"},{"name":"sign"}],"output":{"name":"bool"}}],[11,"ne","","",35,{"inputs":[{"name":"sign"},{"name":"sign"}],"output":{"name":"bool"}}],[11,"clone","","",35,{"inputs":[{"name":"sign"}],"output":{"name":"sign"}}],[11,"fmt","core::num","",36,{"inputs":[{"name":"fpcategory"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",36,{"inputs":[{"name":"fpcategory"},{"name":"fpcategory"}],"output":{"name":"bool"}}],[11,"ne","","",36,{"inputs":[{"name":"fpcategory"},{"name":"fpcategory"}],"output":{"name":"bool"}}],[11,"clone","","",36,{"inputs":[{"name":"fpcategory"}],"output":{"name":"fpcategory"}}],[11,"eq","","",37,{"inputs":[{"name":"parseinterror"},{"name":"parseinterror"}],"output":{"name":"bool"}}],[11,"ne","","",37,{"inputs":[{"name":"parseinterror"},{"name":"parseinterror"}],"output":{"name":"bool"}}],[11,"clone","","",37,{"inputs":[{"name":"parseinterror"}],"output":{"name":"parseinterror"}}],[11,"fmt","","",37,{"inputs":[{"name":"parseinterror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",38,{"inputs":[{"name":"interrorkind"},{"name":"interrorkind"}],"output":{"name":"bool"}}],[11,"ne","","",38,{"inputs":[{"name":"interrorkind"},{"name":"interrorkind"}],"output":{"name":"bool"}}],[11,"clone","","",38,{"inputs":[{"name":"interrorkind"}],"output":{"name":"interrorkind"}}],[11,"fmt","","",38,{"inputs":[{"name":"interrorkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",37,{"inputs":[{"name":"parseinterror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",39,{"inputs":[{"name":"parsefloaterror"},{"name":"parsefloaterror"}],"output":{"name":"bool"}}],[11,"ne","","",39,{"inputs":[{"name":"parsefloaterror"},{"name":"parsefloaterror"}],"output":{"name":"bool"}}],[11,"clone","","",39,{"inputs":[{"name":"parsefloaterror"}],"output":{"name":"parsefloaterror"}}],[11,"fmt","","",39,{"inputs":[{"name":"parsefloaterror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",40,{"inputs":[{"name":"floaterrorkind"},{"name":"floaterrorkind"}],"output":{"name":"bool"}}],[11,"ne","","",40,{"inputs":[{"name":"floaterrorkind"},{"name":"floaterrorkind"}],"output":{"name":"bool"}}],[11,"clone","","",40,{"inputs":[{"name":"floaterrorkind"}],"output":{"name":"floaterrorkind"}}],[11,"fmt","","",40,{"inputs":[{"name":"floaterrorkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",39,{"inputs":[{"name":"parsefloaterror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","core::nonzero","",41,null],[11,"fmt","","",41,{"inputs":[{"name":"nonzero"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"partial_cmp","","",41,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"option"}}],[11,"lt","","",41,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"le","","",41,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"gt","","",41,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"ge","","",41,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"cmp","","",41,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"ordering"}}],[11,"eq","","",41,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"ne","","",41,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"clone","","",41,{"inputs":[{"name":"nonzero"}],"output":{"name":"nonzero"}}],[11,"new","","Creates an instance of NonZero with the provided value.\nYou must indeed ensure that the value is actually \"non-zero\".",41,{"inputs":[{"name":"nonzero"},{"name":"t"}],"output":{"name":"nonzero"}}],[11,"deref","","",41,{"inputs":[{"name":"nonzero"}],"output":{"name":"t"}}],[11,"new","core::ptr","Creates a new `Unique`.",42,null],[11,"get","","Dereferences the content.",42,{"inputs":[{"name":"unique"}],"output":{"name":"t"}}],[11,"get_mut","","Mutably dereferences the content.",42,{"inputs":[{"name":"unique"}],"output":{"name":"t"}}],[11,"deref","","",42,null],[11,"fmt","","",42,{"inputs":[{"name":"unique"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"cmp","core::marker","",43,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",43,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"option"}}],[11,"lt","","",43,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"le","","",43,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"gt","","",43,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"ge","","",43,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"eq","","",43,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"ne","","",43,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"clone","","",43,{"inputs":[{"name":"nocopy"}],"output":{"name":"nocopy"}}],[11,"hash","","",44,null],[11,"eq","","",44,{"inputs":[{"name":"phantomdata"},{"name":"phantomdata"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",44,{"inputs":[{"name":"phantomdata"},{"name":"phantomdata"}],"output":{"name":"option"}}],[11,"cmp","","",44,{"inputs":[{"name":"phantomdata"},{"name":"phantomdata"}],"output":{"name":"ordering"}}],[11,"clone","","",44,{"inputs":[{"name":"phantomdata"}],"output":{"name":"phantomdata"}}],[11,"eq","core::ops","",45,{"inputs":[{"name":"rangefull"},{"name":"rangefull"}],"output":{"name":"bool"}}],[11,"ne","","",45,{"inputs":[{"name":"rangefull"},{"name":"rangefull"}],"output":{"name":"bool"}}],[11,"clone","","",45,{"inputs":[{"name":"rangefull"}],"output":{"name":"rangefull"}}],[11,"fmt","","",45,{"inputs":[{"name":"rangefull"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",46,{"inputs":[{"name":"range"},{"name":"range"}],"output":{"name":"bool"}}],[11,"ne","","",46,{"inputs":[{"name":"range"},{"name":"range"}],"output":{"name":"bool"}}],[11,"clone","","",46,{"inputs":[{"name":"range"}],"output":{"name":"range"}}],[11,"fmt","","",46,{"inputs":[{"name":"range"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",47,{"inputs":[{"name":"rangefrom"},{"name":"rangefrom"}],"output":{"name":"bool"}}],[11,"ne","","",47,{"inputs":[{"name":"rangefrom"},{"name":"rangefrom"}],"output":{"name":"bool"}}],[11,"clone","","",47,{"inputs":[{"name":"rangefrom"}],"output":{"name":"rangefrom"}}],[11,"fmt","","",47,{"inputs":[{"name":"rangefrom"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",48,{"inputs":[{"name":"rangeto"},{"name":"rangeto"}],"output":{"name":"bool"}}],[11,"ne","","",48,{"inputs":[{"name":"rangeto"},{"name":"rangeto"}],"output":{"name":"bool"}}],[11,"clone","","",48,{"inputs":[{"name":"rangeto"}],"output":{"name":"rangeto"}}],[11,"fmt","","",48,{"inputs":[{"name":"rangeto"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","core::cmp","",49,{"inputs":[{"name":"ordering"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",49,{"inputs":[{"name":"ordering"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"ne","","",49,{"inputs":[{"name":"ordering"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"clone","","",49,{"inputs":[{"name":"ordering"}],"output":{"name":"ordering"}}],[11,"reverse","","Reverse the `Ordering`.",49,{"inputs":[{"name":"ordering"}],"output":{"name":"ordering"}}],[11,"cmp","","",49,{"inputs":[{"name":"ordering"},{"name":"ordering"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",49,{"inputs":[{"name":"ordering"},{"name":"ordering"}],"output":{"name":"option"}}],[11,"fmt","collections","",50,{"inputs":[{"name":"any"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",50,{"inputs":[{"name":"any"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"is","","Returns true if the boxed type is the same as `T`",50,{"inputs":[{"name":"any"}],"output":{"name":"bool"}}],[11,"downcast_ref","","Returns some reference to the boxed value if it is of type `T`, or\n`None` if it isn't.",50,{"inputs":[{"name":"any"}],"output":{"name":"option"}}],[11,"downcast_mut","","Returns some mutable reference to the boxed value if it is of type `T`, or\n`None` if it isn't.",50,{"inputs":[{"name":"any"}],"output":{"name":"option"}}],[11,"is","","Forwards to the method defined on the type `Any`.",50,{"inputs":[{"name":"any"}],"output":{"name":"bool"}}],[11,"downcast_ref","","Forwards to the method defined on the type `Any`.",50,{"inputs":[{"name":"any"}],"output":{"name":"option"}}],[11,"downcast_mut","","Forwards to the method defined on the type `Any`.",50,{"inputs":[{"name":"any"}],"output":{"name":"option"}}],[11,"hash","core::any","",51,null],[11,"fmt","","",51,{"inputs":[{"name":"typeid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",51,{"inputs":[{"name":"typeid"},{"name":"typeid"}],"output":{"name":"bool"}}],[11,"ne","","",51,{"inputs":[{"name":"typeid"},{"name":"typeid"}],"output":{"name":"bool"}}],[11,"clone","","",51,{"inputs":[{"name":"typeid"}],"output":{"name":"typeid"}}],[11,"of","","Returns the `TypeId` of the type this generic function has been\ninstantiated with",51,{"inputs":[{"name":"typeid"}],"output":{"name":"typeid"}}],[11,"default","core::atomic","",52,{"inputs":[{"name":"atomicbool"}],"output":{"name":"atomicbool"}}],[11,"default","","",53,{"inputs":[{"name":"atomicisize"}],"output":{"name":"atomicisize"}}],[11,"default","","",54,{"inputs":[{"name":"atomicusize"}],"output":{"name":"atomicusize"}}],[11,"default","","",55,{"inputs":[{"name":"atomicptr"}],"output":{"name":"atomicptr"}}],[11,"clone","","",56,{"inputs":[{"name":"ordering"}],"output":{"name":"ordering"}}],[11,"new","","Creates a new `AtomicBool`.",52,{"inputs":[{"name":"atomicbool"},{"name":"bool"}],"output":{"name":"atomicbool"}}],[11,"load","","Loads a value from the bool.",52,{"inputs":[{"name":"atomicbool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"store","","Stores a value into the bool.",52,null],[11,"swap","","Stores a value into the bool, returning the old value.",52,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"compare_and_swap","","Stores a value into the `bool` if the current value is the same as the `current` value.",52,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"fetch_and","","Logical \"and\" with a boolean value.",52,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"fetch_nand","","Logical \"nand\" with a boolean value.",52,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"fetch_or","","Logical \"or\" with a boolean value.",52,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"fetch_xor","","Logical \"xor\" with a boolean value.",52,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"new","","Creates a new `AtomicIsize`.",53,{"inputs":[{"name":"atomicisize"},{"name":"isize"}],"output":{"name":"atomicisize"}}],[11,"load","","Loads a value from the isize.",53,{"inputs":[{"name":"atomicisize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"store","","Stores a value into the isize.",53,null],[11,"swap","","Stores a value into the isize, returning the old value.",53,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"compare_and_swap","","Stores a value into the `isize` if the current value is the same as the `current` value.",53,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"fetch_add","","Add an isize to the current value, returning the previous value.",53,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"fetch_sub","","Subtract an isize from the current value, returning the previous value.",53,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"fetch_and","","Bitwise and with the current isize, returning the previous value.",53,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"fetch_or","","Bitwise or with the current isize, returning the previous value.",53,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"fetch_xor","","Bitwise xor with the current isize, returning the previous value.",53,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"new","","Creates a new `AtomicUsize`.",54,{"inputs":[{"name":"atomicusize"},{"name":"usize"}],"output":{"name":"atomicusize"}}],[11,"load","","Loads a value from the usize.",54,{"inputs":[{"name":"atomicusize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"store","","Stores a value into the usize.",54,null],[11,"swap","","Stores a value into the usize, returning the old value.",54,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"compare_and_swap","","Stores a value into the `usize` if the current value is the same as the `current` value.",54,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"fetch_add","","Add to the current usize, returning the previous value.",54,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"fetch_sub","","Subtract from the current usize, returning the previous value.",54,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"fetch_and","","Bitwise and with the current usize, returning the previous value.",54,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"fetch_or","","Bitwise or with the current usize, returning the previous value.",54,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"fetch_xor","","Bitwise xor with the current usize, returning the previous value.",54,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"new","","Creates a new `AtomicPtr`.",55,null],[11,"load","","Loads a value from the pointer.",55,null],[11,"store","","Stores a value into the pointer.",55,null],[11,"swap","","Stores a value into the pointer, returning the old value.",55,null],[11,"compare_and_swap","","Stores a value into the pointer if the current value is the same as the `current` value.",55,null],[11,"fmt","","",54,{"inputs":[{"name":"atomicusize"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",53,{"inputs":[{"name":"atomicisize"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",52,{"inputs":[{"name":"atomicbool"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",55,{"inputs":[{"name":"atomicptr"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","core::cell","Creates a new `Cell` containing the given value.",57,{"inputs":[{"name":"cell"},{"name":"t"}],"output":{"name":"cell"}}],[11,"get","","Returns a copy of the contained value.",57,{"inputs":[{"name":"cell"}],"output":{"name":"t"}}],[11,"set","","Sets the contained value.",57,null],[11,"as_unsafe_cell","","Returns a reference to the underlying `UnsafeCell`.",57,{"inputs":[{"name":"cell"}],"output":{"name":"unsafecell"}}],[11,"clone","","",57,{"inputs":[{"name":"cell"}],"output":{"name":"cell"}}],[11,"default","","",57,{"inputs":[{"name":"cell"}],"output":{"name":"cell"}}],[11,"eq","","",57,{"inputs":[{"name":"cell"},{"name":"cell"}],"output":{"name":"bool"}}],[11,"fmt","","",58,{"inputs":[{"name":"borrowstate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",58,{"inputs":[{"name":"borrowstate"},{"name":"borrowstate"}],"output":{"name":"bool"}}],[11,"ne","","",58,{"inputs":[{"name":"borrowstate"},{"name":"borrowstate"}],"output":{"name":"bool"}}],[11,"clone","","",58,{"inputs":[{"name":"borrowstate"}],"output":{"name":"borrowstate"}}],[11,"new","","Creates a new `RefCell` containing `value`.",59,{"inputs":[{"name":"refcell"},{"name":"t"}],"output":{"name":"refcell"}}],[11,"into_inner","","Consumes the `RefCell`, returning the wrapped value.",59,{"inputs":[{"name":"refcell"}],"output":{"name":"t"}}],[11,"borrow_state","","Query the current state of this `RefCell`",59,{"inputs":[{"name":"refcell"}],"output":{"name":"borrowstate"}}],[11,"borrow","","Immutably borrows the wrapped value.",59,{"inputs":[{"name":"refcell"}],"output":{"name":"ref"}}],[11,"borrow_mut","","Mutably borrows the wrapped value.",59,{"inputs":[{"name":"refcell"}],"output":{"name":"refmut"}}],[11,"as_unsafe_cell","","Returns a reference to the underlying `UnsafeCell`.",59,{"inputs":[{"name":"refcell"}],"output":{"name":"unsafecell"}}],[11,"clone","","",59,{"inputs":[{"name":"refcell"}],"output":{"name":"refcell"}}],[11,"default","","",59,{"inputs":[{"name":"refcell"}],"output":{"name":"refcell"}}],[11,"eq","","",59,{"inputs":[{"name":"refcell"},{"name":"refcell"}],"output":{"name":"bool"}}],[11,"drop","","",60,null],[11,"clone","","",60,{"inputs":[{"name":"borrowref"}],"output":{"name":"borrowref"}}],[11,"deref","","",61,{"inputs":[{"name":"ref"}],"output":{"name":"t"}}],[11,"clone","","Copies a `Ref`.",61,{"inputs":[{"name":"ref"},{"name":"ref"}],"output":{"name":"ref"}}],[11,"map","","Make a new `Ref` for a component of the borrowed data.",61,{"inputs":[{"name":"ref"},{"name":"ref"},{"name":"f"}],"output":{"name":"ref"}}],[11,"filter_map","","Make a new `Ref` for a optional component of the borrowed data, e.g. an\nenum variant.",61,{"inputs":[{"name":"ref"},{"name":"ref"},{"name":"f"}],"output":{"name":"option"}}],[11,"map","","Make a new `RefMut` for a component of the borrowed data, e.g. an enum\nvariant.",62,{"inputs":[{"name":"refmut"},{"name":"refmut"},{"name":"f"}],"output":{"name":"refmut"}}],[11,"filter_map","","Make a new `RefMut` for a optional component of the borrowed data, e.g.\nan enum variant.",62,{"inputs":[{"name":"refmut"},{"name":"refmut"},{"name":"f"}],"output":{"name":"option"}}],[11,"drop","","",63,null],[11,"deref","","",62,{"inputs":[{"name":"refmut"}],"output":{"name":"t"}}],[11,"deref_mut","","",62,{"inputs":[{"name":"refmut"}],"output":{"name":"t"}}],[11,"new","","Constructs a new instance of `UnsafeCell` which will wrap the specified\nvalue.",64,{"inputs":[{"name":"unsafecell"},{"name":"t"}],"output":{"name":"unsafecell"}}],[11,"into_inner","","Unwraps the value.",64,{"inputs":[{"name":"unsafecell"}],"output":{"name":"t"}}],[11,"get","","Gets a mutable pointer to the wrapped value.",64,null],[11,"clone","core::char","",65,{"inputs":[{"name":"escapeunicode"}],"output":{"name":"escapeunicode"}}],[11,"clone","","",66,{"inputs":[{"name":"escapeunicodestate"}],"output":{"name":"escapeunicodestate"}}],[11,"next","","",65,{"inputs":[{"name":"escapeunicode"}],"output":{"name":"option"}}],[11,"clone","","",67,{"inputs":[{"name":"escapedefault"}],"output":{"name":"escapedefault"}}],[11,"clone","","",68,{"inputs":[{"name":"escapedefaultstate"}],"output":{"name":"escapedefaultstate"}}],[11,"next","","",67,{"inputs":[{"name":"escapedefault"}],"output":{"name":"option"}}],[11,"clone","core::iter","",69,{"inputs":[{"name":"rev"}],"output":{"name":"rev"}}],[11,"next","","",69,{"inputs":[{"name":"rev"}],"output":{"name":"option"}}],[11,"size_hint","","",69,null],[11,"next_back","","",69,{"inputs":[{"name":"rev"}],"output":{"name":"option"}}],[11,"indexable","","",69,{"inputs":[{"name":"rev"}],"output":{"name":"usize"}}],[11,"idx","","",69,{"inputs":[{"name":"rev"},{"name":"usize"}],"output":{"name":"option"}}],[11,"fmt","","",70,{"inputs":[{"name":"minmaxresult"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",70,{"inputs":[{"name":"minmaxresult"},{"name":"minmaxresult"}],"output":{"name":"bool"}}],[11,"ne","","",70,{"inputs":[{"name":"minmaxresult"},{"name":"minmaxresult"}],"output":{"name":"bool"}}],[11,"clone","","",70,{"inputs":[{"name":"minmaxresult"}],"output":{"name":"minmaxresult"}}],[11,"into_option","","`into_option` creates an `Option` of type `(T,T)`. The returned `Option`\nhas variant `None` if and only if the `MinMaxResult` has variant\n`NoElements`. Otherwise variant `Some(x,y)` is returned where `x <= y`.\nIf `MinMaxResult` has variant `OneElement(x)`, performing this operation\nwill make one clone of `x`.",70,{"inputs":[{"name":"minmaxresult"}],"output":{"name":"option"}}],[11,"clone","","",71,{"inputs":[{"name":"cloned"}],"output":{"name":"cloned"}}],[11,"next","","",71,{"inputs":[{"name":"cloned"}],"output":{"name":"option"}}],[11,"size_hint","","",71,null],[11,"next_back","","",71,{"inputs":[{"name":"cloned"}],"output":{"name":"option"}}],[11,"indexable","","",71,{"inputs":[{"name":"cloned"}],"output":{"name":"usize"}}],[11,"idx","","",71,{"inputs":[{"name":"cloned"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",72,{"inputs":[{"name":"cycle"}],"output":{"name":"cycle"}}],[11,"next","","",72,{"inputs":[{"name":"cycle"}],"output":{"name":"option"}}],[11,"size_hint","","",72,null],[11,"indexable","","",72,{"inputs":[{"name":"cycle"}],"output":{"name":"usize"}}],[11,"idx","","",72,{"inputs":[{"name":"cycle"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",73,{"inputs":[{"name":"chain"}],"output":{"name":"chain"}}],[11,"next","","",73,{"inputs":[{"name":"chain"}],"output":{"name":"option"}}],[11,"count","","",73,{"inputs":[{"name":"chain"}],"output":{"name":"usize"}}],[11,"nth","","",73,{"inputs":[{"name":"chain"},{"name":"usize"}],"output":{"name":"option"}}],[11,"last","","",73,{"inputs":[{"name":"chain"}],"output":{"name":"option"}}],[11,"size_hint","","",73,null],[11,"next_back","","",73,{"inputs":[{"name":"chain"}],"output":{"name":"option"}}],[11,"indexable","","",73,{"inputs":[{"name":"chain"}],"output":{"name":"usize"}}],[11,"idx","","",73,{"inputs":[{"name":"chain"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",74,{"inputs":[{"name":"zip"}],"output":{"name":"zip"}}],[11,"next","","",74,{"inputs":[{"name":"zip"}],"output":{"name":"option"}}],[11,"size_hint","","",74,null],[11,"next_back","","",74,{"inputs":[{"name":"zip"}],"output":{"name":"option"}}],[11,"indexable","","",74,{"inputs":[{"name":"zip"}],"output":{"name":"usize"}}],[11,"idx","","",74,{"inputs":[{"name":"zip"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",75,{"inputs":[{"name":"map"}],"output":{"name":"map"}}],[11,"next","","",75,{"inputs":[{"name":"map"}],"output":{"name":"option"}}],[11,"size_hint","","",75,null],[11,"next_back","","",75,{"inputs":[{"name":"map"}],"output":{"name":"option"}}],[11,"indexable","","",75,{"inputs":[{"name":"map"}],"output":{"name":"usize"}}],[11,"idx","","",75,{"inputs":[{"name":"map"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",76,{"inputs":[{"name":"filter"}],"output":{"name":"filter"}}],[11,"next","","",76,{"inputs":[{"name":"filter"}],"output":{"name":"option"}}],[11,"size_hint","","",76,null],[11,"next_back","","",76,{"inputs":[{"name":"filter"}],"output":{"name":"option"}}],[11,"clone","","",77,{"inputs":[{"name":"filtermap"}],"output":{"name":"filtermap"}}],[11,"next","","",77,{"inputs":[{"name":"filtermap"}],"output":{"name":"option"}}],[11,"size_hint","","",77,null],[11,"next_back","","",77,{"inputs":[{"name":"filtermap"}],"output":{"name":"option"}}],[11,"clone","","",78,{"inputs":[{"name":"enumerate"}],"output":{"name":"enumerate"}}],[11,"next","","# Overflow Behavior",78,{"inputs":[{"name":"enumerate"}],"output":{"name":"option"}}],[11,"size_hint","","",78,null],[11,"nth","","",78,{"inputs":[{"name":"enumerate"},{"name":"usize"}],"output":{"name":"option"}}],[11,"count","","",78,{"inputs":[{"name":"enumerate"}],"output":{"name":"usize"}}],[11,"next_back","","",78,{"inputs":[{"name":"enumerate"}],"output":{"name":"option"}}],[11,"indexable","","",78,{"inputs":[{"name":"enumerate"}],"output":{"name":"usize"}}],[11,"idx","","",78,{"inputs":[{"name":"enumerate"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",79,{"inputs":[{"name":"peekable"}],"output":{"name":"peekable"}}],[11,"next","","",79,{"inputs":[{"name":"peekable"}],"output":{"name":"option"}}],[11,"count","","",79,{"inputs":[{"name":"peekable"}],"output":{"name":"usize"}}],[11,"nth","","",79,{"inputs":[{"name":"peekable"},{"name":"usize"}],"output":{"name":"option"}}],[11,"last","","",79,{"inputs":[{"name":"peekable"}],"output":{"name":"option"}}],[11,"size_hint","","",79,null],[11,"peek","","Returns a reference to the next element of the iterator with out\nadvancing it, or None if the iterator is exhausted.",79,{"inputs":[{"name":"peekable"}],"output":{"name":"option"}}],[11,"is_empty","","Checks whether peekable iterator is empty or not.",79,{"inputs":[{"name":"peekable"}],"output":{"name":"bool"}}],[11,"clone","","",80,{"inputs":[{"name":"skipwhile"}],"output":{"name":"skipwhile"}}],[11,"next","","",80,{"inputs":[{"name":"skipwhile"}],"output":{"name":"option"}}],[11,"size_hint","","",80,null],[11,"clone","","",81,{"inputs":[{"name":"takewhile"}],"output":{"name":"takewhile"}}],[11,"next","","",81,{"inputs":[{"name":"takewhile"}],"output":{"name":"option"}}],[11,"size_hint","","",81,null],[11,"clone","","",82,{"inputs":[{"name":"skip"}],"output":{"name":"skip"}}],[11,"next","","",82,{"inputs":[{"name":"skip"}],"output":{"name":"option"}}],[11,"nth","","",82,{"inputs":[{"name":"skip"},{"name":"usize"}],"output":{"name":"option"}}],[11,"count","","",82,{"inputs":[{"name":"skip"}],"output":{"name":"usize"}}],[11,"last","","",82,{"inputs":[{"name":"skip"}],"output":{"name":"option"}}],[11,"size_hint","","",82,null],[11,"indexable","","",82,{"inputs":[{"name":"skip"}],"output":{"name":"usize"}}],[11,"idx","","",82,{"inputs":[{"name":"skip"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",83,{"inputs":[{"name":"take"}],"output":{"name":"take"}}],[11,"next","","",83,{"inputs":[{"name":"take"}],"output":{"name":"option"}}],[11,"nth","","",83,{"inputs":[{"name":"take"},{"name":"usize"}],"output":{"name":"option"}}],[11,"size_hint","","",83,null],[11,"indexable","","",83,{"inputs":[{"name":"take"}],"output":{"name":"usize"}}],[11,"idx","","",83,{"inputs":[{"name":"take"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",84,{"inputs":[{"name":"scan"}],"output":{"name":"scan"}}],[11,"next","","",84,{"inputs":[{"name":"scan"}],"output":{"name":"option"}}],[11,"size_hint","","",84,null],[11,"clone","","",85,{"inputs":[{"name":"flatmap"}],"output":{"name":"flatmap"}}],[11,"next","","",85,{"inputs":[{"name":"flatmap"}],"output":{"name":"option"}}],[11,"size_hint","","",85,null],[11,"next_back","","",85,{"inputs":[{"name":"flatmap"}],"output":{"name":"option"}}],[11,"clone","","",86,{"inputs":[{"name":"fuse"}],"output":{"name":"fuse"}}],[11,"next","","",86,{"inputs":[{"name":"fuse"}],"output":{"name":"option"}}],[11,"nth","","",86,{"inputs":[{"name":"fuse"},{"name":"usize"}],"output":{"name":"option"}}],[11,"last","","",86,{"inputs":[{"name":"fuse"}],"output":{"name":"option"}}],[11,"count","","",86,{"inputs":[{"name":"fuse"}],"output":{"name":"usize"}}],[11,"size_hint","","",86,null],[11,"next_back","","",86,{"inputs":[{"name":"fuse"}],"output":{"name":"option"}}],[11,"indexable","","",86,{"inputs":[{"name":"fuse"}],"output":{"name":"usize"}}],[11,"idx","","",86,{"inputs":[{"name":"fuse"},{"name":"usize"}],"output":{"name":"option"}}],[11,"reset_fuse","","Resets the `Fuse` such that the next call to `.next()` or\n`.next_back()` will call the underlying iterator again even if it\npreviously returned `None`.",86,null],[11,"clone","","",87,{"inputs":[{"name":"inspect"}],"output":{"name":"inspect"}}],[11,"next","","",87,{"inputs":[{"name":"inspect"}],"output":{"name":"option"}}],[11,"size_hint","","",87,null],[11,"next_back","","",87,{"inputs":[{"name":"inspect"}],"output":{"name":"option"}}],[11,"indexable","","",87,{"inputs":[{"name":"inspect"}],"output":{"name":"usize"}}],[11,"idx","","",87,{"inputs":[{"name":"inspect"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",88,{"inputs":[{"name":"unfold"}],"output":{"name":"unfold"}}],[11,"new","","Creates a new iterator with the specified closure as the \"iterator\nfunction\" and an initial state to eventually pass to the closure",88,{"inputs":[{"name":"unfold"},{"name":"st"},{"name":"f"}],"output":{"name":"unfold"}}],[11,"next","","",88,{"inputs":[{"name":"unfold"}],"output":{"name":"option"}}],[11,"size_hint","","",88,null],[11,"clone","","",89,{"inputs":[{"name":"stepby"}],"output":{"name":"stepby"}}],[11,"step_by","core::ops","Creates an iterator starting at the same point, but stepping by\nthe given amount at each iteration.",47,{"inputs":[{"name":"rangefrom"},{"name":"a"}],"output":{"name":"stepby"}}],[11,"step_by","","Creates an iterator with the same range, but stepping by the\ngiven amount at each iteration.",46,{"inputs":[{"name":"range"},{"name":"a"}],"output":{"name":"stepby"}}],[11,"next","core::iter","",89,{"inputs":[{"name":"stepby"}],"output":{"name":"option"}}],[11,"size_hint","","",89,null],[11,"clone","","",90,{"inputs":[{"name":"rangeinclusive"}],"output":{"name":"rangeinclusive"}}],[11,"next","","",90,{"inputs":[{"name":"rangeinclusive"}],"output":{"name":"option"}}],[11,"size_hint","","",90,null],[11,"next_back","","",90,{"inputs":[{"name":"rangeinclusive"}],"output":{"name":"option"}}],[11,"next","","",89,{"inputs":[{"name":"stepby"}],"output":{"name":"option"}}],[11,"size_hint","","",89,null],[11,"next","core::ops","",46,{"inputs":[{"name":"range"}],"output":{"name":"option"}}],[11,"size_hint","","",46,null],[11,"next_back","","",46,{"inputs":[{"name":"range"}],"output":{"name":"option"}}],[11,"next","","",47,{"inputs":[{"name":"rangefrom"}],"output":{"name":"option"}}],[11,"clone","core::iter","",91,{"inputs":[{"name":"repeat"}],"output":{"name":"repeat"}}],[11,"next","","",91,{"inputs":[{"name":"repeat"}],"output":{"name":"option"}}],[11,"size_hint","","",91,null],[11,"next_back","","",91,{"inputs":[{"name":"repeat"}],"output":{"name":"option"}}],[11,"indexable","","",91,{"inputs":[{"name":"repeat"}],"output":{"name":"usize"}}],[11,"idx","","",91,{"inputs":[{"name":"repeat"},{"name":"usize"}],"output":{"name":"option"}}],[11,"next","","",92,{"inputs":[{"name":"empty"}],"output":{"name":"option"}}],[11,"size_hint","","",92,null],[11,"next_back","","",92,{"inputs":[{"name":"empty"}],"output":{"name":"option"}}],[11,"len","","",92,{"inputs":[{"name":"empty"}],"output":{"name":"usize"}}],[11,"clone","","",92,{"inputs":[{"name":"empty"}],"output":{"name":"empty"}}],[11,"default","","",92,{"inputs":[{"name":"empty"}],"output":{"name":"empty"}}],[11,"clone","","",93,{"inputs":[{"name":"once"}],"output":{"name":"once"}}],[11,"next","","",93,{"inputs":[{"name":"once"}],"output":{"name":"option"}}],[11,"size_hint","","",93,null],[11,"next_back","","",93,{"inputs":[{"name":"once"}],"output":{"name":"option"}}],[11,"len","","",93,{"inputs":[{"name":"once"}],"output":{"name":"usize"}}],[11,"hash","core::option","",94,null],[11,"fmt","","",94,{"inputs":[{"name":"option"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"cmp","","",94,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",94,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"option"}}],[11,"lt","","",94,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"le","","",94,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"gt","","",94,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"ge","","",94,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"eq","","",94,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"ne","","",94,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"clone","","",94,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[11,"is_some","","Returns `true` if the option is a `Some` value",94,{"inputs":[{"name":"option"}],"output":{"name":"bool"}}],[11,"is_none","","Returns `true` if the option is a `None` value",94,{"inputs":[{"name":"option"}],"output":{"name":"bool"}}],[11,"as_ref","","Converts from `Option<T>` to `Option<&T>`",94,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[11,"as_mut","","Converts from `Option<T>` to `Option<&mut T>`",94,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[11,"as_mut_slice","","Converts from `Option<T>` to `&mut [T]` (without copying)",94,null],[11,"expect","","Unwraps an option, yielding the content of a `Some`",94,{"inputs":[{"name":"option"},{"name":"str"}],"output":{"name":"t"}}],[11,"unwrap","","Moves the value `v` out of the `Option<T>` if it is `Some(v)`.",94,{"inputs":[{"name":"option"}],"output":{"name":"t"}}],[11,"unwrap_or","","Returns the contained value or a default.",94,{"inputs":[{"name":"option"},{"name":"t"}],"output":{"name":"t"}}],[11,"unwrap_or_else","","Returns the contained value or computes it from a closure.",94,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"t"}}],[11,"map","","Maps an `Option<T>` to `Option<U>` by applying a function to a contained value",94,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"option"}}],[11,"map_or","","Applies a function to the contained value (if any),\nor returns a `default` (if not).",94,{"inputs":[{"name":"option"},{"name":"u"},{"name":"f"}],"output":{"name":"u"}}],[11,"map_or_else","","Applies a function to the contained value (if any),\nor computes a `default` (if not).",94,{"inputs":[{"name":"option"},{"name":"d"},{"name":"f"}],"output":{"name":"u"}}],[11,"ok_or","","Transforms the `Option<T>` into a `Result<T, E>`, mapping `Some(v)` to\n`Ok(v)` and `None` to `Err(err)`.",94,{"inputs":[{"name":"option"},{"name":"e"}],"output":{"name":"result"}}],[11,"ok_or_else","","Transforms the `Option<T>` into a `Result<T, E>`, mapping `Some(v)` to\n`Ok(v)` and `None` to `Err(err())`.",94,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"result"}}],[11,"iter","","Returns an iterator over the possibly contained value.",94,{"inputs":[{"name":"option"}],"output":{"name":"iter"}}],[11,"iter_mut","","Returns a mutable iterator over the possibly contained value.",94,{"inputs":[{"name":"option"}],"output":{"name":"itermut"}}],[11,"and","","Returns `None` if the option is `None`, otherwise returns `optb`.",94,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"option"}}],[11,"and_then","","Returns `None` if the option is `None`, otherwise calls `f` with the\nwrapped value and returns the result.",94,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"option"}}],[11,"or","","Returns the option if it contains a value, otherwise returns `optb`.",94,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"option"}}],[11,"or_else","","Returns the option if it contains a value, otherwise calls `f` and\nreturns the result.",94,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"option"}}],[11,"take","","Takes the value out of the option, leaving a `None` in its place.",94,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[11,"as_slice","","Converts from `Option<T>` to `&[T]` (without copying)",94,null],[11,"cloned","","Maps an Option<&T> to an Option<T> by cloning the contents of the Option.",94,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[11,"unwrap_or_default","","Returns the contained value or a default",94,{"inputs":[{"name":"option"}],"output":{"name":"t"}}],[11,"default","","",94,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[11,"into_iter","","Returns a consuming iterator over the possibly contained value.",94,{"inputs":[{"name":"option"}],"output":{"name":"intoiter"}}],[11,"clone","","",95,{"inputs":[{"name":"item"}],"output":{"name":"item"}}],[11,"next","","",95,{"inputs":[{"name":"item"}],"output":{"name":"option"}}],[11,"size_hint","","",95,null],[11,"next_back","","",95,{"inputs":[{"name":"item"}],"output":{"name":"option"}}],[11,"next","","",96,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",96,null],[11,"next_back","","",96,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"clone","","",96,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[11,"next","","",97,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"size_hint","","",97,null],[11,"next_back","","",97,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"clone","","",98,{"inputs":[{"name":"intoiter"}],"output":{"name":"intoiter"}}],[11,"next","","",98,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",98,null],[11,"next_back","","",98,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"from_iter","","Takes each element in the `Iterator`: if it is `None`, no further\nelements are taken, and the `None` is returned. Should no `None` occur, a\ncontainer with the values of each `Option` is returned.",94,{"inputs":[{"name":"option"},{"name":"i"}],"output":{"name":"option"}}],[11,"clone","core::raw","",99,{"inputs":[{"name":"slice"}],"output":{"name":"slice"}}],[11,"clone","","",100,{"inputs":[{"name":"traitobject"}],"output":{"name":"traitobject"}}],[11,"hash","core::result","",101,null],[11,"fmt","","",101,{"inputs":[{"name":"result"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"cmp","","",101,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",101,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"option"}}],[11,"lt","","",101,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"le","","",101,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"gt","","",101,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"ge","","",101,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"eq","","",101,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"ne","","",101,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"clone","","",101,{"inputs":[{"name":"result"}],"output":{"name":"result"}}],[11,"is_ok","","Returns true if the result is `Ok`",101,{"inputs":[{"name":"result"}],"output":{"name":"bool"}}],[11,"is_err","","Returns true if the result is `Err`",101,{"inputs":[{"name":"result"}],"output":{"name":"bool"}}],[11,"ok","","Converts from `Result<T, E>` to `Option<T>`",101,{"inputs":[{"name":"result"}],"output":{"name":"option"}}],[11,"err","","Converts from `Result<T, E>` to `Option<E>`",101,{"inputs":[{"name":"result"}],"output":{"name":"option"}}],[11,"as_ref","","Converts from `Result<T, E>` to `Result<&T, &E>`",101,{"inputs":[{"name":"result"}],"output":{"name":"result"}}],[11,"as_mut","","Converts from `Result<T, E>` to `Result<&mut T, &mut E>`",101,{"inputs":[{"name":"result"}],"output":{"name":"result"}}],[11,"as_slice","","Converts from `Result<T, E>` to `&[T]` (without copying)",101,null],[11,"as_mut_slice","","Converts from `Result<T, E>` to `&mut [T]` (without copying)",101,null],[11,"map","","Maps a `Result<T, E>` to `Result<U, E>` by applying a function to an\ncontained `Ok` value, leaving an `Err` value untouched.",101,{"inputs":[{"name":"result"},{"name":"f"}],"output":{"name":"result"}}],[11,"map_err","","Maps a `Result<T, E>` to `Result<T, F>` by applying a function to an\ncontained `Err` value, leaving an `Ok` value untouched.",101,{"inputs":[{"name":"result"},{"name":"o"}],"output":{"name":"result"}}],[11,"iter","","Returns an iterator over the possibly contained value.",101,{"inputs":[{"name":"result"}],"output":{"name":"iter"}}],[11,"iter_mut","","Returns a mutable iterator over the possibly contained value.",101,{"inputs":[{"name":"result"}],"output":{"name":"itermut"}}],[11,"and","","Returns `res` if the result is `Ok`, otherwise returns the `Err` value of `self`.",101,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"result"}}],[11,"and_then","","Calls `op` if the result is `Ok`, otherwise returns the `Err` value of `self`.",101,{"inputs":[{"name":"result"},{"name":"f"}],"output":{"name":"result"}}],[11,"or","","Returns `res` if the result is `Err`, otherwise returns the `Ok` value of `self`.",101,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"result"}}],[11,"or_else","","Calls `op` if the result is `Err`, otherwise returns the `Ok` value of `self`.",101,{"inputs":[{"name":"result"},{"name":"o"}],"output":{"name":"result"}}],[11,"unwrap_or","","Unwraps a result, yielding the content of an `Ok`.\nElse it returns `optb`.",101,{"inputs":[{"name":"result"},{"name":"t"}],"output":{"name":"t"}}],[11,"unwrap_or_else","","Unwraps a result, yielding the content of an `Ok`.\nIf the value is an `Err` then it calls `op` with its value.",101,{"inputs":[{"name":"result"},{"name":"f"}],"output":{"name":"t"}}],[11,"unwrap","","Unwraps a result, yielding the content of an `Ok`.",101,{"inputs":[{"name":"result"}],"output":{"name":"t"}}],[11,"expect","","Unwraps a result, yielding the content of an `Ok`.",101,{"inputs":[{"name":"result"},{"name":"str"}],"output":{"name":"t"}}],[11,"unwrap_err","","Unwraps a result, yielding the content of an `Err`.",101,{"inputs":[{"name":"result"}],"output":{"name":"e"}}],[11,"into_iter","","Returns a consuming iterator over the possibly contained value.",101,{"inputs":[{"name":"result"}],"output":{"name":"intoiter"}}],[11,"next","","",102,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",102,null],[11,"next_back","","",102,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"clone","","",102,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[11,"next","","",103,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"size_hint","","",103,null],[11,"next_back","","",103,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"next","","",104,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",104,null],[11,"next_back","","",104,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"from_iter","","Takes each element in the `Iterator`: if it is an `Err`, no further\nelements are taken, and the `Err` is returned. Should no `Err` occur, a\ncontainer with the values of each `Result` is returned.",101,{"inputs":[{"name":"result"},{"name":"i"}],"output":{"name":"result"}}],[11,"fmt","core::simd","",105,{"inputs":[{"name":"i8x16"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",105,{"inputs":[{"name":"i8x16"}],"output":{"name":"i8x16"}}],[11,"fmt","","",106,{"inputs":[{"name":"i16x8"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",106,{"inputs":[{"name":"i16x8"}],"output":{"name":"i16x8"}}],[11,"fmt","","",107,{"inputs":[{"name":"i32x4"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",107,{"inputs":[{"name":"i32x4"}],"output":{"name":"i32x4"}}],[11,"fmt","","",108,{"inputs":[{"name":"i64x2"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",108,{"inputs":[{"name":"i64x2"}],"output":{"name":"i64x2"}}],[11,"fmt","","",109,{"inputs":[{"name":"u8x16"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",109,{"inputs":[{"name":"u8x16"}],"output":{"name":"u8x16"}}],[11,"fmt","","",110,{"inputs":[{"name":"u16x8"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",110,{"inputs":[{"name":"u16x8"}],"output":{"name":"u16x8"}}],[11,"fmt","","",111,{"inputs":[{"name":"u32x4"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",111,{"inputs":[{"name":"u32x4"}],"output":{"name":"u32x4"}}],[11,"fmt","","",112,{"inputs":[{"name":"u64x2"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",112,{"inputs":[{"name":"u64x2"}],"output":{"name":"u64x2"}}],[11,"fmt","","",113,{"inputs":[{"name":"f32x4"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",113,{"inputs":[{"name":"f32x4"}],"output":{"name":"f32x4"}}],[11,"fmt","","",114,{"inputs":[{"name":"f64x2"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",114,{"inputs":[{"name":"f64x2"}],"output":{"name":"f64x2"}}],[11,"as_slice","core::slice","View the underlying data as a subslice of the original data.",115,null],[11,"next","","",115,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",115,null],[11,"count","","",115,{"inputs":[{"name":"iter"}],"output":{"name":"usize"}}],[11,"nth","","",115,{"inputs":[{"name":"iter"},{"name":"usize"}],"output":{"name":"option"}}],[11,"last","","",115,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"next_back","","",115,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"clone","","",115,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[11,"indexable","","",115,{"inputs":[{"name":"iter"}],"output":{"name":"usize"}}],[11,"idx","","",115,{"inputs":[{"name":"iter"},{"name":"usize"}],"output":{"name":"option"}}],[11,"into_slice","","View the underlying data as a subslice of the original data.",116,null],[11,"next","","",116,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"size_hint","","",116,null],[11,"count","","",116,{"inputs":[{"name":"itermut"}],"output":{"name":"usize"}}],[11,"nth","","",116,{"inputs":[{"name":"itermut"},{"name":"usize"}],"output":{"name":"option"}}],[11,"last","","",116,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"next_back","","",116,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"clone","","",117,{"inputs":[{"name":"split"}],"output":{"name":"split"}}],[11,"next","","",117,{"inputs":[{"name":"split"}],"output":{"name":"option"}}],[11,"size_hint","","",117,null],[11,"next_back","","",117,{"inputs":[{"name":"split"}],"output":{"name":"option"}}],[11,"finish","","",117,{"inputs":[{"name":"split"}],"output":{"name":"option"}}],[11,"finish","","",118,{"inputs":[{"name":"splitmut"}],"output":{"name":"option"}}],[11,"next","","",118,{"inputs":[{"name":"splitmut"}],"output":{"name":"option"}}],[11,"size_hint","","",118,null],[11,"next_back","","",118,{"inputs":[{"name":"splitmut"}],"output":{"name":"option"}}],[11,"next","","",119,{"inputs":[{"name":"genericsplitn"}],"output":{"name":"option"}}],[11,"size_hint","","",119,null],[11,"next","","",120,{"inputs":[{"name":"splitn"}],"output":{"name":"option"}}],[11,"size_hint","","",120,null],[11,"next","","",121,{"inputs":[{"name":"rsplitn"}],"output":{"name":"option"}}],[11,"size_hint","","",121,null],[11,"next","","",122,{"inputs":[{"name":"splitnmut"}],"output":{"name":"option"}}],[11,"size_hint","","",122,null],[11,"next","","",123,{"inputs":[{"name":"rsplitnmut"}],"output":{"name":"option"}}],[11,"size_hint","","",123,null],[11,"clone","","",124,{"inputs":[{"name":"windows"}],"output":{"name":"windows"}}],[11,"next","","",124,{"inputs":[{"name":"windows"}],"output":{"name":"option"}}],[11,"size_hint","","",124,null],[11,"next_back","","",124,{"inputs":[{"name":"windows"}],"output":{"name":"option"}}],[11,"indexable","","",124,{"inputs":[{"name":"windows"}],"output":{"name":"usize"}}],[11,"idx","","",124,{"inputs":[{"name":"windows"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",125,{"inputs":[{"name":"chunks"}],"output":{"name":"chunks"}}],[11,"next","","",125,{"inputs":[{"name":"chunks"}],"output":{"name":"option"}}],[11,"size_hint","","",125,null],[11,"next_back","","",125,{"inputs":[{"name":"chunks"}],"output":{"name":"option"}}],[11,"indexable","","",125,{"inputs":[{"name":"chunks"}],"output":{"name":"usize"}}],[11,"idx","","",125,{"inputs":[{"name":"chunks"},{"name":"usize"}],"output":{"name":"option"}}],[11,"next","","",126,{"inputs":[{"name":"chunksmut"}],"output":{"name":"option"}}],[11,"size_hint","","",126,null],[11,"next_back","","",126,{"inputs":[{"name":"chunksmut"}],"output":{"name":"option"}}],[11,"fmt","core::str::pattern","",127,{"inputs":[{"name":"searchstep"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",127,{"inputs":[{"name":"searchstep"},{"name":"searchstep"}],"output":{"name":"bool"}}],[11,"ne","","",127,{"inputs":[{"name":"searchstep"},{"name":"searchstep"}],"output":{"name":"bool"}}],[11,"clone","","",127,{"inputs":[{"name":"searchstep"}],"output":{"name":"searchstep"}}],[11,"clone","","",128,{"inputs":[{"name":"chareqsearcher"}],"output":{"name":"chareqsearcher"}}],[11,"into_searcher","","",129,{"inputs":[{"name":"chareqpattern"},{"name":"str"}],"output":{"name":"chareqsearcher"}}],[11,"haystack","","",128,{"inputs":[{"name":"chareqsearcher"}],"output":{"name":"str"}}],[11,"next","","",128,{"inputs":[{"name":"chareqsearcher"}],"output":{"name":"searchstep"}}],[11,"next_back","","",128,{"inputs":[{"name":"chareqsearcher"}],"output":{"name":"searchstep"}}],[11,"clone","","",130,{"inputs":[{"name":"charsearcher"}],"output":{"name":"charsearcher"}}],[11,"haystack","","",130,{"inputs":[{"name":"charsearcher"}],"output":{"name":"str"}}],[11,"next","","",130,{"inputs":[{"name":"charsearcher"}],"output":{"name":"searchstep"}}],[11,"next_match","","",130,{"inputs":[{"name":"charsearcher"}],"output":{"name":"option"}}],[11,"next_reject","","",130,{"inputs":[{"name":"charsearcher"}],"output":{"name":"option"}}],[11,"next_back","","",130,{"inputs":[{"name":"charsearcher"}],"output":{"name":"searchstep"}}],[11,"next_match_back","","",130,{"inputs":[{"name":"charsearcher"}],"output":{"name":"option"}}],[11,"next_reject_back","","",130,{"inputs":[{"name":"charsearcher"}],"output":{"name":"option"}}],[11,"clone","","",131,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"charslicesearcher"}}],[11,"haystack","","",131,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"str"}}],[11,"next","","",131,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"searchstep"}}],[11,"next_match","","",131,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"option"}}],[11,"next_reject","","",131,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"option"}}],[11,"next_back","","",131,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"searchstep"}}],[11,"next_match_back","","",131,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"option"}}],[11,"next_reject_back","","",131,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"option"}}],[11,"clone","","",132,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"charpredicatesearcher"}}],[11,"haystack","","",132,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"str"}}],[11,"next","","",132,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"searchstep"}}],[11,"next_match","","",132,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"option"}}],[11,"next_reject","","",132,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"option"}}],[11,"next_back","","",132,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"searchstep"}}],[11,"next_match_back","","",132,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"option"}}],[11,"next_reject_back","","",132,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"option"}}],[11,"fmt","","",133,{"inputs":[{"name":"strsearcher"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",133,{"inputs":[{"name":"strsearcher"}],"output":{"name":"strsearcher"}}],[11,"fmt","","",134,{"inputs":[{"name":"strsearcherimpl"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",134,{"inputs":[{"name":"strsearcherimpl"}],"output":{"name":"strsearcherimpl"}}],[11,"fmt","","",135,{"inputs":[{"name":"emptyneedle"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",135,{"inputs":[{"name":"emptyneedle"}],"output":{"name":"emptyneedle"}}],[11,"haystack","","",133,{"inputs":[{"name":"strsearcher"}],"output":{"name":"str"}}],[11,"next","","",133,{"inputs":[{"name":"strsearcher"}],"output":{"name":"searchstep"}}],[11,"next_match","","",133,{"inputs":[{"name":"strsearcher"}],"output":{"name":"option"}}],[11,"next_back","","",133,{"inputs":[{"name":"strsearcher"}],"output":{"name":"searchstep"}}],[11,"next_match_back","","",133,{"inputs":[{"name":"strsearcher"}],"output":{"name":"option"}}],[11,"fmt","","",136,{"inputs":[{"name":"twowaysearcher"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",136,{"inputs":[{"name":"twowaysearcher"}],"output":{"name":"twowaysearcher"}}],[11,"use_early_reject","","",137,{"inputs":[{"name":"matchonly"}],"output":{"name":"bool"}}],[11,"rejecting","","",137,null],[11,"matching","","",137,null],[11,"use_early_reject","","",138,{"inputs":[{"name":"rejectandmatch"}],"output":{"name":"bool"}}],[11,"rejecting","","",138,null],[11,"matching","","",138,null],[11,"eq","core::str","",139,{"inputs":[{"name":"parseboolerror"},{"name":"parseboolerror"}],"output":{"name":"bool"}}],[11,"ne","","",139,{"inputs":[{"name":"parseboolerror"},{"name":"parseboolerror"}],"output":{"name":"bool"}}],[11,"clone","","",139,{"inputs":[{"name":"parseboolerror"}],"output":{"name":"parseboolerror"}}],[11,"fmt","","",139,{"inputs":[{"name":"parseboolerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",139,{"inputs":[{"name":"parseboolerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",140,{"inputs":[{"name":"utf8error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",140,{"inputs":[{"name":"utf8error"}],"output":{"name":"utf8error"}}],[11,"eq","","",140,{"inputs":[{"name":"utf8error"},{"name":"utf8error"}],"output":{"name":"bool"}}],[11,"ne","","",140,{"inputs":[{"name":"utf8error"},{"name":"utf8error"}],"output":{"name":"bool"}}],[11,"valid_up_to","","Returns the index in the given string up to which valid UTF-8 was\nverified.",140,{"inputs":[{"name":"utf8error"}],"output":{"name":"usize"}}],[11,"fmt","","",140,{"inputs":[{"name":"utf8error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",141,{"inputs":[{"name":"chars"}],"output":{"name":"chars"}}],[11,"next","","",141,{"inputs":[{"name":"chars"}],"output":{"name":"option"}}],[11,"size_hint","","",141,null],[11,"next_back","","",141,{"inputs":[{"name":"chars"}],"output":{"name":"option"}}],[11,"clone","","",142,{"inputs":[{"name":"charindices"}],"output":{"name":"charindices"}}],[11,"next","","",142,{"inputs":[{"name":"charindices"}],"output":{"name":"option"}}],[11,"size_hint","","",142,null],[11,"next_back","","",142,{"inputs":[{"name":"charindices"}],"output":{"name":"option"}}],[11,"clone","","",143,{"inputs":[{"name":"bytes"}],"output":{"name":"bytes"}}],[11,"clone","","",144,{"inputs":[{"name":"bytesderef"}],"output":{"name":"bytesderef"}}],[11,"call","","",144,null],[11,"call_mut","","",144,null],[11,"call_once","","",144,null],[11,"next","","",143,{"inputs":[{"name":"bytes"}],"output":{"name":"option"}}],[11,"size_hint","","",143,null],[11,"next_back","","",143,{"inputs":[{"name":"bytes"}],"output":{"name":"option"}}],[11,"len","","",143,{"inputs":[{"name":"bytes"}],"output":{"name":"usize"}}],[11,"clone","","",145,{"inputs":[{"name":"splitinternal"}],"output":{"name":"splitinternal"}}],[11,"next","","",146,{"inputs":[{"name":"split"}],"output":{"name":"option"}}],[11,"clone","","",146,{"inputs":[{"name":"split"}],"output":{"name":"split"}}],[11,"next","","",147,{"inputs":[{"name":"rsplit"}],"output":{"name":"option"}}],[11,"clone","","",147,{"inputs":[{"name":"rsplit"}],"output":{"name":"rsplit"}}],[11,"next_back","","",146,{"inputs":[{"name":"split"}],"output":{"name":"option"}}],[11,"next_back","","",147,{"inputs":[{"name":"rsplit"}],"output":{"name":"option"}}],[11,"next","","",148,{"inputs":[{"name":"splitterminator"}],"output":{"name":"option"}}],[11,"clone","","",148,{"inputs":[{"name":"splitterminator"}],"output":{"name":"splitterminator"}}],[11,"next","","",149,{"inputs":[{"name":"rsplitterminator"}],"output":{"name":"option"}}],[11,"clone","","",149,{"inputs":[{"name":"rsplitterminator"}],"output":{"name":"rsplitterminator"}}],[11,"next_back","","",148,{"inputs":[{"name":"splitterminator"}],"output":{"name":"option"}}],[11,"next_back","","",149,{"inputs":[{"name":"rsplitterminator"}],"output":{"name":"option"}}],[11,"clone","","",150,{"inputs":[{"name":"splitninternal"}],"output":{"name":"splitninternal"}}],[11,"next","","",151,{"inputs":[{"name":"splitn"}],"output":{"name":"option"}}],[11,"clone","","",151,{"inputs":[{"name":"splitn"}],"output":{"name":"splitn"}}],[11,"next","","",152,{"inputs":[{"name":"rsplitn"}],"output":{"name":"option"}}],[11,"clone","","",152,{"inputs":[{"name":"rsplitn"}],"output":{"name":"rsplitn"}}],[11,"clone","","",153,{"inputs":[{"name":"matchindicesinternal"}],"output":{"name":"matchindicesinternal"}}],[11,"next","","",154,{"inputs":[{"name":"matchindices"}],"output":{"name":"option"}}],[11,"clone","","",154,{"inputs":[{"name":"matchindices"}],"output":{"name":"matchindices"}}],[11,"next","","",155,{"inputs":[{"name":"rmatchindices"}],"output":{"name":"option"}}],[11,"clone","","",155,{"inputs":[{"name":"rmatchindices"}],"output":{"name":"rmatchindices"}}],[11,"next_back","","",154,{"inputs":[{"name":"matchindices"}],"output":{"name":"option"}}],[11,"next_back","","",155,{"inputs":[{"name":"rmatchindices"}],"output":{"name":"option"}}],[11,"clone","","",156,{"inputs":[{"name":"matchesinternal"}],"output":{"name":"matchesinternal"}}],[11,"next","","",157,{"inputs":[{"name":"matches"}],"output":{"name":"option"}}],[11,"clone","","",157,{"inputs":[{"name":"matches"}],"output":{"name":"matches"}}],[11,"next","","",158,{"inputs":[{"name":"rmatches"}],"output":{"name":"option"}}],[11,"clone","","",158,{"inputs":[{"name":"rmatches"}],"output":{"name":"rmatches"}}],[11,"next_back","","",157,{"inputs":[{"name":"matches"}],"output":{"name":"option"}}],[11,"next_back","","",158,{"inputs":[{"name":"rmatches"}],"output":{"name":"option"}}],[11,"clone","","",159,{"inputs":[{"name":"lines"}],"output":{"name":"lines"}}],[11,"next","","",159,{"inputs":[{"name":"lines"}],"output":{"name":"option"}}],[11,"size_hint","","",159,null],[11,"next_back","","",159,{"inputs":[{"name":"lines"}],"output":{"name":"option"}}],[11,"clone","","",160,{"inputs":[{"name":"linesany"}],"output":{"name":"linesany"}}],[11,"clone","","",161,{"inputs":[{"name":"linesanymap"}],"output":{"name":"linesanymap"}}],[11,"call","","",161,null],[11,"call_mut","","",161,null],[11,"call_once","","",161,null],[11,"next","","",160,{"inputs":[{"name":"linesany"}],"output":{"name":"option"}}],[11,"size_hint","","",160,null],[11,"next_back","","",160,{"inputs":[{"name":"linesany"}],"output":{"name":"option"}}],[11,"clone","","",162,{"inputs":[{"name":"charrange"}],"output":{"name":"charrange"}}],[11,"new","core::hash::sip","Creates a new `SipHasher` with the two initial keys set to 0.",163,{"inputs":[{"name":"siphasher"}],"output":{"name":"siphasher"}}],[11,"new_with_keys","","Creates a `SipHasher` that is keyed off the provided keys.",163,{"inputs":[{"name":"siphasher"},{"name":"u64"},{"name":"u64"}],"output":{"name":"siphasher"}}],[11,"write","","",163,null],[11,"finish","","",163,{"inputs":[{"name":"siphasher"}],"output":{"name":"u64"}}],[11,"clone","","",163,{"inputs":[{"name":"siphasher"}],"output":{"name":"siphasher"}}],[11,"default","","",163,{"inputs":[{"name":"siphasher"}],"output":{"name":"siphasher"}}],[11,"eq","core::fmt::num","",164,{"inputs":[{"name":"binary"},{"name":"binary"}],"output":{"name":"bool"}}],[11,"ne","","",164,{"inputs":[{"name":"binary"},{"name":"binary"}],"output":{"name":"bool"}}],[11,"clone","","",164,{"inputs":[{"name":"binary"}],"output":{"name":"binary"}}],[11,"eq","","",165,{"inputs":[{"name":"octal"},{"name":"octal"}],"output":{"name":"bool"}}],[11,"ne","","",165,{"inputs":[{"name":"octal"},{"name":"octal"}],"output":{"name":"bool"}}],[11,"clone","","",165,{"inputs":[{"name":"octal"}],"output":{"name":"octal"}}],[11,"eq","","",166,{"inputs":[{"name":"decimal"},{"name":"decimal"}],"output":{"name":"bool"}}],[11,"ne","","",166,{"inputs":[{"name":"decimal"},{"name":"decimal"}],"output":{"name":"bool"}}],[11,"clone","","",166,{"inputs":[{"name":"decimal"}],"output":{"name":"decimal"}}],[11,"eq","","",167,{"inputs":[{"name":"lowerhex"},{"name":"lowerhex"}],"output":{"name":"bool"}}],[11,"ne","","",167,{"inputs":[{"name":"lowerhex"},{"name":"lowerhex"}],"output":{"name":"bool"}}],[11,"clone","","",167,{"inputs":[{"name":"lowerhex"}],"output":{"name":"lowerhex"}}],[11,"eq","","",168,{"inputs":[{"name":"upperhex"},{"name":"upperhex"}],"output":{"name":"bool"}}],[11,"ne","","",168,{"inputs":[{"name":"upperhex"},{"name":"upperhex"}],"output":{"name":"bool"}}],[11,"clone","","",168,{"inputs":[{"name":"upperhex"}],"output":{"name":"upperhex"}}],[11,"eq","","",169,{"inputs":[{"name":"radix"},{"name":"radix"}],"output":{"name":"bool"}}],[11,"ne","","",169,{"inputs":[{"name":"radix"},{"name":"radix"}],"output":{"name":"bool"}}],[11,"clone","","",169,{"inputs":[{"name":"radix"}],"output":{"name":"radix"}}],[11,"clone","","",170,{"inputs":[{"name":"radixfmt"}],"output":{"name":"radixfmt"}}],[11,"fmt","","",170,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",170,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",170,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",170,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",170,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",170,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",170,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",170,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",170,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",170,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",170,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",170,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",170,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",170,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",170,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",170,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",170,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",170,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",170,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",170,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"write_str","core::fmt::builders","",171,{"inputs":[{"name":"padadapter"},{"name":"str"}],"output":{"name":"result"}}],[11,"field","","Adds a new field to the generated struct output.",172,{"inputs":[{"name":"debugstruct"},{"name":"str"},{"name":"debug"}],"output":{"name":"debugstruct"}}],[11,"finish","","Finishes output and returns any error encountered.",172,{"inputs":[{"name":"debugstruct"}],"output":{"name":"result"}}],[11,"field","","Adds a new field to the generated tuple struct output.",173,{"inputs":[{"name":"debugtuple"},{"name":"debug"}],"output":{"name":"debugtuple"}}],[11,"finish","","Finishes output and returns any error encountered.",173,{"inputs":[{"name":"debugtuple"}],"output":{"name":"result"}}],[11,"formatter","","Returns the wrapped `Formatter`.",173,{"inputs":[{"name":"debugtuple"}],"output":{"name":"formatter"}}],[11,"finish","","",174,null],[11,"entry","","Adds a new entry to the set output.",175,{"inputs":[{"name":"debugset"},{"name":"debug"}],"output":{"name":"debugset"}}],[11,"entries","","Adds the contents of an iterator of entries to the set output.",175,{"inputs":[{"name":"debugset"},{"name":"i"}],"output":{"name":"debugset"}}],[11,"finish","","Finishes output and returns any error encountered.",175,{"inputs":[{"name":"debugset"}],"output":{"name":"result"}}],[11,"entry","","Adds a new entry to the list output.",176,{"inputs":[{"name":"debuglist"},{"name":"debug"}],"output":{"name":"debuglist"}}],[11,"entries","","Adds the contents of an iterator of entries to the list output.",176,{"inputs":[{"name":"debuglist"},{"name":"i"}],"output":{"name":"debuglist"}}],[11,"finish","","Finishes output and returns any error encountered.",176,{"inputs":[{"name":"debuglist"}],"output":{"name":"result"}}],[11,"entry","","Adds a new entry to the map output.",177,{"inputs":[{"name":"debugmap"},{"name":"debug"},{"name":"debug"}],"output":{"name":"debugmap"}}],[11,"entries","","Adds the contents of an iterator of entries to the map output.",177,{"inputs":[{"name":"debugmap"},{"name":"i"}],"output":{"name":"debugmap"}}],[11,"finish","","Finishes output and returns any error encountered.",177,{"inputs":[{"name":"debugmap"}],"output":{"name":"result"}}],[11,"clone","core::fmt::rt::v1","",178,{"inputs":[{"name":"argument"}],"output":{"name":"argument"}}],[11,"clone","","",179,{"inputs":[{"name":"formatspec"}],"output":{"name":"formatspec"}}],[11,"eq","","",180,{"inputs":[{"name":"alignment"},{"name":"alignment"}],"output":{"name":"bool"}}],[11,"ne","","",180,{"inputs":[{"name":"alignment"},{"name":"alignment"}],"output":{"name":"bool"}}],[11,"clone","","",180,{"inputs":[{"name":"alignment"}],"output":{"name":"alignment"}}],[11,"clone","","",181,{"inputs":[{"name":"count"}],"output":{"name":"count"}}],[11,"clone","","",182,{"inputs":[{"name":"position"}],"output":{"name":"position"}}],[11,"fmt","core::fmt","",183,{"inputs":[{"name":"error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",183,{"inputs":[{"name":"error"}],"output":{"name":"error"}}],[11,"clone","","",184,{"inputs":[{"name":"flagv1"}],"output":{"name":"flagv1"}}],[11,"clone","","",185,{"inputs":[{"name":"arguments"}],"output":{"name":"arguments"}}],[11,"fmt","","",185,{"inputs":[{"name":"arguments"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",185,{"inputs":[{"name":"arguments"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"write_str","","",26,{"inputs":[{"name":"formatter"},{"name":"str"}],"output":{"name":"result"}}],[11,"write_char","","",26,{"inputs":[{"name":"formatter"},{"name":"char"}],"output":{"name":"result"}}],[11,"write_fmt","","",26,{"inputs":[{"name":"formatter"},{"name":"arguments"}],"output":{"name":"result"}}],[11,"fmt","","",183,{"inputs":[{"name":"error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","core::marker","",44,{"inputs":[{"name":"phantomdata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","core::cell","",57,{"inputs":[{"name":"cell"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",59,{"inputs":[{"name":"refcell"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",61,{"inputs":[{"name":"ref"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",62,{"inputs":[{"name":"refmut"},{"name":"formatter"}],"output":{"name":"result"}}],[3,"Formatter","collections::fmt","A struct to represent both where to emit formatting strings to and how they\nshould be formatted. A mutable version of this is passed to all formatting\ntraits.",null,null],[6,"Result","","",null,null],[8,"Write","","A collection of methods that are required to format a message into a stream.",null,null],[10,"write_str","","Writes a slice of bytes into this writer, returning whether the write\nsucceeded.",186,{"inputs":[{"name":"write"},{"name":"str"}],"output":{"name":"result"}}],[11,"write_char","","Writes a `char` into this writer, returning whether the write succeeded.",186,{"inputs":[{"name":"write"},{"name":"char"}],"output":{"name":"result"}}],[11,"write_fmt","","Glue for usage of the `write!` macro with implementers of this trait.",186,{"inputs":[{"name":"write"},{"name":"arguments"}],"output":{"name":"result"}}],[8,"Octal","","Format trait for the `o` character.",null,null],[10,"fmt","","Formats the value using the given formatter.",187,{"inputs":[{"name":"octal"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"Binary","","Format trait for the `b` character.",null,null],[10,"fmt","","Formats the value using the given formatter.",188,{"inputs":[{"name":"binary"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"Display","","Format trait for an empty format, `{}`.",null,null],[10,"fmt","","Formats the value using the given formatter.",189,{"inputs":[{"name":"display"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"Debug","","Format trait for the `?` character.",null,null],[10,"fmt","","Formats the value using the given formatter.",190,{"inputs":[{"name":"debug"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"LowerHex","","Format trait for the `x` character.",null,null],[10,"fmt","","Formats the value using the given formatter.",191,{"inputs":[{"name":"lowerhex"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"UpperHex","","Format trait for the `X` character.",null,null],[10,"fmt","","Formats the value using the given formatter.",192,{"inputs":[{"name":"upperhex"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"Pointer","","Format trait for the `p` character.",null,null],[10,"fmt","","Formats the value using the given formatter.",193,{"inputs":[{"name":"pointer"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"LowerExp","","Format trait for the `e` character.",null,null],[10,"fmt","","Formats the value using the given formatter.",194,{"inputs":[{"name":"lowerexp"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"UpperExp","","Format trait for the `E` character.",null,null],[10,"fmt","","Formats the value using the given formatter.",195,{"inputs":[{"name":"upperexp"},{"name":"formatter"}],"output":{"name":"result"}}],[3,"Error","","The error type which is returned from formatting a message into a stream.",null,null],[3,"Arguments","","This structure represents a safely precompiled version of a format string\nand its arguments. This cannot be generated at runtime because it cannot\nsafely be done so, so no constructors are given and the fields are private\nto prevent modification.",null,null],[5,"write","","The `write` function takes an output stream, a precompiled format string,\nand a list of arguments. The arguments will be formatted according to the\nspecified format string into the output stream provided.",null,{"inputs":[{"name":"write"},{"name":"arguments"}],"output":{"name":"result"}}],[5,"radix","","Constructs a radix formatter in the range of `2..36`.",null,{"inputs":[{"name":"t"},{"name":"u8"}],"output":{"name":"radixfmt"}}],[3,"Radix","","A radix with in the range of `2..36`.",null,null],[3,"RadixFmt","","A helper type for formatting radixes.",null,null],[5,"format","","The format function takes a precompiled format string and a list of\narguments, to return the resulting formatted string.",null,{"inputs":[{"name":"arguments"}],"output":{"name":"string"}}],[0,"linked_list","collections","A doubly-linked list with owned nodes.",null,null],[3,"LinkedList","collections::linked_list","A doubly-linked list.",null,null],[3,"Iter","","An iterator over references to the items of a `LinkedList`.",null,null],[3,"IterMut","","An iterator over mutable references to the items of a `LinkedList`.",null,null],[3,"IntoIter","","An iterator over mutable references to the items of a `LinkedList`.",null,null],[11,"clone","","",196,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[11,"clone","","",197,{"inputs":[{"name":"intoiter"}],"output":{"name":"intoiter"}}],[11,"default","","",198,{"inputs":[{"name":"linkedlist"}],"output":{"name":"linkedlist"}}],[11,"new","","Creates an empty `LinkedList`.",198,{"inputs":[{"name":"linkedlist"}],"output":{"name":"linkedlist"}}],[11,"append","","Moves all elements from `other` to the end of the list.",198,{"inputs":[{"name":"linkedlist"},{"name":"linkedlist"}],"output":null}],[11,"iter","","Provides a forward iterator.",198,{"inputs":[{"name":"linkedlist"}],"output":{"name":"iter"}}],[11,"iter_mut","","Provides a forward iterator with mutable references.",198,{"inputs":[{"name":"linkedlist"}],"output":{"name":"itermut"}}],[11,"is_empty","","Returns `true` if the `LinkedList` is empty.",198,{"inputs":[{"name":"linkedlist"}],"output":{"name":"bool"}}],[11,"len","","Returns the length of the `LinkedList`.",198,{"inputs":[{"name":"linkedlist"}],"output":{"name":"usize"}}],[11,"clear","","Removes all elements from the `LinkedList`.",198,{"inputs":[{"name":"linkedlist"}],"output":null}],[11,"front","","Provides a reference to the front element, or `None` if the list is\nempty.",198,{"inputs":[{"name":"linkedlist"}],"output":{"name":"option"}}],[11,"front_mut","","Provides a mutable reference to the front element, or `None` if the list\nis empty.",198,{"inputs":[{"name":"linkedlist"}],"output":{"name":"option"}}],[11,"back","","Provides a reference to the back element, or `None` if the list is\nempty.",198,{"inputs":[{"name":"linkedlist"}],"output":{"name":"option"}}],[11,"back_mut","","Provides a mutable reference to the back element, or `None` if the list\nis empty.",198,{"inputs":[{"name":"linkedlist"}],"output":{"name":"option"}}],[11,"push_front","","Adds an element first in the list.",198,{"inputs":[{"name":"linkedlist"},{"name":"t"}],"output":null}],[11,"pop_front","","Removes the first element and returns it, or `None` if the list is\nempty.",198,{"inputs":[{"name":"linkedlist"}],"output":{"name":"option"}}],[11,"push_back","","Appends an element to the back of a list",198,{"inputs":[{"name":"linkedlist"},{"name":"t"}],"output":null}],[11,"pop_back","","Removes the last element from a list and returns it, or `None` if\nit is empty.",198,{"inputs":[{"name":"linkedlist"}],"output":{"name":"option"}}],[11,"split_off","","Splits the list into two at the given index. Returns everything after the given index,\nincluding the index.",198,{"inputs":[{"name":"linkedlist"},{"name":"usize"}],"output":{"name":"linkedlist"}}],[11,"drop","","",198,{"inputs":[{"name":"linkedlist"}],"output":null}],[11,"next","","",196,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",196,null],[11,"next_back","","",196,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"next","","",199,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"size_hint","","",199,null],[11,"next_back","","",199,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"insert_next","","Inserts `elt` just after the element most recently returned by `.next()`.\nThe inserted element does not appear in the iteration.",199,{"inputs":[{"name":"itermut"},{"name":"a"}],"output":null}],[11,"peek_next","","Provides a reference to the next element, without changing the iterator.",199,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"next","","",197,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",197,null],[11,"next_back","","",197,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"from_iter","","",198,{"inputs":[{"name":"linkedlist"},{"name":"t"}],"output":{"name":"linkedlist"}}],[11,"into_iter","","Consumes the list into an iterator yielding elements by value.",198,{"inputs":[{"name":"linkedlist"}],"output":{"name":"intoiter"}}],[11,"extend","","",198,{"inputs":[{"name":"linkedlist"},{"name":"t"}],"output":null}],[11,"extend","","",198,{"inputs":[{"name":"linkedlist"},{"name":"i"}],"output":null}],[11,"eq","","",198,{"inputs":[{"name":"linkedlist"},{"name":"linkedlist"}],"output":{"name":"bool"}}],[11,"ne","","",198,{"inputs":[{"name":"linkedlist"},{"name":"linkedlist"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",198,{"inputs":[{"name":"linkedlist"},{"name":"linkedlist"}],"output":{"name":"option"}}],[11,"cmp","","",198,{"inputs":[{"name":"linkedlist"},{"name":"linkedlist"}],"output":{"name":"ordering"}}],[11,"clone","","",198,{"inputs":[{"name":"linkedlist"}],"output":{"name":"linkedlist"}}],[11,"fmt","","",198,{"inputs":[{"name":"linkedlist"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",198,{"inputs":[{"name":"linkedlist"},{"name":"h"}],"output":null}],[0,"range","collections","Range syntax.",null,null],[8,"RangeArgument","collections::range","**RangeArgument** is implemented by Rust's built-in range types, produced\nby range syntax like `..`, `a..`, `..b` or `c..d`.",null,null],[11,"start","","Start index (inclusive)",200,{"inputs":[{"name":"rangeargument"}],"output":{"name":"option"}}],[11,"end","","End index (exclusive)",200,{"inputs":[{"name":"rangeargument"}],"output":{"name":"option"}}],[11,"start","core::ops","",47,{"inputs":[{"name":"rangefrom"}],"output":{"name":"option"}}],[11,"end","","",48,{"inputs":[{"name":"rangeto"}],"output":{"name":"option"}}],[11,"start","","",46,{"inputs":[{"name":"range"}],"output":{"name":"option"}}],[11,"end","","",46,{"inputs":[{"name":"range"}],"output":{"name":"option"}}],[0,"slice","collections","A dynamically-sized view into a contiguous sequence, `[T]`.",null,null],[3,"Chunks","collections::slice","An iterator over a slice in (non-overlapping) chunks (`size` elements at a\ntime).",null,null],[3,"Windows","","An iterator over overlapping subslices of length `size`.",null,null],[3,"Iter","","Immutable slice iterator",null,null],[3,"IterMut","","Mutable slice iterator.",null,null],[8,"IntSliceExt","","Extension methods for slices containing integers.",null,null],[10,"as_unsigned","","Converts the slice to an immutable slice of unsigned integers with the same width.",201,null],[10,"as_signed","","Converts the slice to an immutable slice of signed integers with the same width.",201,null],[10,"as_unsigned_mut","","Converts the slice to a mutable slice of unsigned integers with the same width.",201,null],[10,"as_signed_mut","","Converts the slice to a mutable slice of signed integers with the same width.",201,null],[3,"SplitMut","","An iterator over the subslices of the vector which are separated\nby elements that match `pred`.",null,null],[3,"ChunksMut","","An iterator over a slice in (non-overlapping) mutable chunks (`size`\nelements at a time). When the slice len is not evenly divided by the chunk\nsize, the last slice of the iteration will be the remainder.",null,null],[3,"Split","","An iterator over subslices separated by elements that match a predicate\nfunction.",null,null],[3,"SplitN","","An iterator over subslices separated by elements that match a predicate\nfunction, limited to a given number of splits.",null,null],[3,"RSplitN","","An iterator over subslices separated by elements that match a\npredicate function, limited to a given number of splits, starting\nfrom the end of the slice.",null,null],[3,"SplitNMut","","An iterator over subslices separated by elements that match a predicate\nfunction, limited to a given number of splits.",null,null],[3,"RSplitNMut","","An iterator over subslices separated by elements that match a\npredicate function, limited to a given number of splits, starting\nfrom the end of the slice.",null,null],[0,"bytes","","Operations on `[u8]`.",null,null],[8,"MutableByteVector","collections::slice::bytes","A trait for operations on mutable `[u8]`s.",null,null],[10,"set_memory","","Sets all bytes of the receiver to the given value.",202,null],[5,"copy_memory","","Copies data from `src` to `dst`",null,null],[5,"mut_ref_slice","collections::slice","Converts a pointer to A into a slice of length 1 (without copying).",null,null],[5,"ref_slice","","Converts a pointer to A into a slice of length 1 (without copying).",null,null],[5,"from_raw_parts","","Forms a slice from a pointer and a length.",null,null],[5,"from_raw_parts_mut","","Performs the same functionality as `from_raw_parts`, except that a mutable\nslice is returned.",null,null],[3,"ElementSwaps","","An iterator that yields the element swaps needed to produce\na sequence of all possible permutations for an indexed sequence of\nelements. Each permutation is only a single swap apart.",null,null],[3,"Permutations","","An iterator that uses `ElementSwaps` to iterate through\nall possible permutations of a vector.",null,null],[8,"SliceConcatExt","","An extension trait for concatenating slices",null,null],[16,"Output","","The resulting type after concatenation",203,null],[10,"concat","","Flattens a slice of `T` into a single value `Self::Output`.",203,{"inputs":[{"name":"sliceconcatext"}],"output":{"name":"output"}}],[10,"join","","Flattens a slice of `T` into a single value `Self::Output`, placing a\ngiven separator between each.",203,{"inputs":[{"name":"sliceconcatext"},{"name":"t"}],"output":{"name":"output"}}],[10,"connect","","Flattens a slice of `T` into a single value `Self::Output`, placing a\ngiven separator between each.",203,{"inputs":[{"name":"sliceconcatext"},{"name":"t"}],"output":{"name":"output"}}],[11,"clone","","",204,{"inputs":[{"name":"elementswaps"}],"output":{"name":"elementswaps"}}],[11,"new","","Creates an `ElementSwaps` iterator for a sequence of `length` elements.",204,{"inputs":[{"name":"elementswaps"},{"name":"usize"}],"output":{"name":"elementswaps"}}],[11,"next","","",204,{"inputs":[{"name":"elementswaps"}],"output":{"name":"option"}}],[11,"size_hint","","",204,null],[11,"next","","",205,{"inputs":[{"name":"permutations"}],"output":{"name":"option"}}],[11,"size_hint","","",205,null],[0,"str","collections","Unicode string slices",null,null],[8,"FromStr","collections::str","A trait to abstract the idea of creating a new instance of a type from a\nstring.",null,null],[16,"Err","","The associated error which can be returned from parsing.",206,null],[10,"from_str","","Parses a string `s` to return a value of this type.",206,{"inputs":[{"name":"fromstr"},{"name":"str"}],"output":{"name":"result"}}],[3,"Utf8Error","","Errors which can occur when attempting to interpret a byte slice as a `str`.",null,null],[3,"Lines","","Created with the method `.lines()`.",null,null],[3,"LinesAny","","Created with the method `.lines_any()`.",null,null],[3,"CharRange","","Struct that contains a `char` and the index of the first byte of\nthe next `char` in a string.  This can be used as a data structure\nfor iterating over the UTF-8 bytes of a string.",null,null],[12,"ch","","Current `char`",162,null],[12,"next","","Index of the first byte of the next `char`",162,null],[3,"Split","","Created with the method `.split()`.",null,null],[3,"RSplit","","Created with the method `.rsplit()`.",null,null],[3,"SplitN","","Created with the method `.splitn()`.",null,null],[3,"RSplitN","","Created with the method `.rsplitn()`.",null,null],[3,"SplitTerminator","","Created with the method `.split_terminator()`.",null,null],[3,"RSplitTerminator","","Created with the method `.rsplit_terminator()`.",null,null],[3,"Matches","","Created with the method `.matches()`.",null,null],[3,"RMatches","","Created with the method `.rmatches()`.",null,null],[3,"MatchIndices","","Created with the method `.match_indices()`.",null,null],[3,"RMatchIndices","","Created with the method `.rmatch_indices()`.",null,null],[5,"from_utf8","","Converts a slice of bytes to a string slice without performing any\nallocations.",null,null],[3,"Chars","","Iterator for the char (representing *Unicode Scalar Values*) of a string",null,null],[3,"CharIndices","","Iterator for a string's characters and their byte offsets.",null,null],[3,"Bytes","","External iterator for a string's bytes.\nUse with the `std::iter` module.",null,null],[5,"from_utf8_unchecked","","Converts a slice of bytes to a string slice without checking\nthat the string contains valid UTF-8.",null,null],[3,"ParseBoolError","","An error returned when parsing a `bool` from a string fails.",null,null],[11,"clone","rustc_unicode::tables::grapheme","",207,{"inputs":[{"name":"graphemecat"}],"output":{"name":"graphemecat"}}],[11,"clone","rustc_unicode::u_str","",208,{"inputs":[{"name":"graphemeindices"}],"output":{"name":"graphemeindices"}}],[11,"next","","",208,{"inputs":[{"name":"graphemeindices"}],"output":{"name":"option"}}],[11,"size_hint","","",208,null],[11,"next_back","","",208,{"inputs":[{"name":"graphemeindices"}],"output":{"name":"option"}}],[11,"clone","","",209,{"inputs":[{"name":"graphemes"}],"output":{"name":"graphemes"}}],[11,"eq","","",210,{"inputs":[{"name":"graphemestate"},{"name":"graphemestate"}],"output":{"name":"bool"}}],[11,"ne","","",210,{"inputs":[{"name":"graphemestate"},{"name":"graphemestate"}],"output":{"name":"bool"}}],[11,"size_hint","","",209,null],[11,"next","","",209,{"inputs":[{"name":"graphemes"}],"output":{"name":"option"}}],[11,"next_back","","",209,{"inputs":[{"name":"graphemes"}],"output":{"name":"option"}}],[11,"clone","","",211,{"inputs":[{"name":"utf16items"}],"output":{"name":"utf16items"}}],[11,"fmt","","",212,{"inputs":[{"name":"utf16item"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",212,{"inputs":[{"name":"utf16item"}],"output":{"name":"utf16item"}}],[11,"eq","","",212,{"inputs":[{"name":"utf16item"},{"name":"utf16item"}],"output":{"name":"bool"}}],[11,"ne","","",212,{"inputs":[{"name":"utf16item"},{"name":"utf16item"}],"output":{"name":"bool"}}],[11,"to_char_lossy","","Convert `self` to a `char`, taking `LoneSurrogate`s to the\nreplacement character (U+FFFD).",212,{"inputs":[{"name":"utf16item"}],"output":{"name":"char"}}],[11,"next","","",211,{"inputs":[{"name":"utf16items"}],"output":{"name":"option"}}],[11,"size_hint","","",211,null],[11,"clone","","",213,{"inputs":[{"name":"utf16encoder"}],"output":{"name":"utf16encoder"}}],[11,"new","","Create a UTF-16 encoder from any `char` iterator.",213,{"inputs":[{"name":"utf16encoder"},{"name":"i"}],"output":{"name":"utf16encoder"}}],[11,"next","","",213,{"inputs":[{"name":"utf16encoder"}],"output":{"name":"option"}}],[11,"size_hint","","",213,null],[11,"next","","",214,{"inputs":[{"name":"splitwhitespace"}],"output":{"name":"option"}}],[11,"next_back","","",214,{"inputs":[{"name":"splitwhitespace"}],"output":{"name":"option"}}],[11,"next","rustc_unicode::char","",215,{"inputs":[{"name":"tolowercase"}],"output":{"name":"option"}}],[11,"next","","",216,{"inputs":[{"name":"touppercase"}],"output":{"name":"option"}}],[11,"next","","",217,{"inputs":[{"name":"casemappingiter"}],"output":{"name":"option"}}],[3,"SplitWhitespace","collections::str","An iterator over the non-whitespace substrings of a string,\nseparated by any amount of whitespace.",null,null],[6,"Words","","",null,null],[3,"Graphemes","","External iterator for a string's\n[grapheme clusters](http://www.unicode.org/reports/tr29/#Grapheme_Cluster_Boundaries).",null,null],[3,"GraphemeIndices","","External iterator for grapheme clusters and byte offsets.",null,null],[0,"pattern","","The string Pattern API.",null,null],[8,"Pattern","collections::str::pattern","A string pattern.",null,null],[16,"Searcher","","Associated searcher for this pattern",218,null],[10,"into_searcher","","Constructs the associated searcher from\n`self` and the `haystack` to search in.",218,null],[11,"is_contained_in","","Checks whether the pattern matches anywhere in the haystack",218,{"inputs":[{"name":"pattern"},{"name":"str"}],"output":{"name":"bool"}}],[11,"is_prefix_of","","Checks whether the pattern matches at the front of the haystack",218,{"inputs":[{"name":"pattern"},{"name":"str"}],"output":{"name":"bool"}}],[11,"is_suffix_of","","Checks whether the pattern matches at the back of the haystack",218,{"inputs":[{"name":"pattern"},{"name":"str"}],"output":{"name":"bool"}}],[4,"SearchStep","","Result of calling `Searcher::next()` or `ReverseSearcher::next_back()`.",null,null],[13,"Match","","Expresses that a match of the pattern has been found at\n`haystack[a..b]`.",127,null],[13,"Reject","","Expresses that `haystack[a..b]` has been rejected as a possible match\nof the pattern.",127,null],[13,"Done","","Expresses that every byte of the haystack has been visted, ending\nthe iteration.",127,null],[8,"Searcher","","A searcher for a string pattern.",null,null],[10,"haystack","","Getter for the underlaying string to be searched in",219,{"inputs":[{"name":"searcher"}],"output":{"name":"str"}}],[10,"next","","Performs the next search step starting from the front.",219,{"inputs":[{"name":"searcher"}],"output":{"name":"searchstep"}}],[11,"next_match","","Find the next `Match` result. See `next()`",219,{"inputs":[{"name":"searcher"}],"output":{"name":"option"}}],[11,"next_reject","","Find the next `Reject` result. See `next()`",219,{"inputs":[{"name":"searcher"}],"output":{"name":"option"}}],[8,"ReverseSearcher","","A reverse searcher for a string pattern.",null,null],[10,"next_back","","Performs the next search step starting from the back.",220,{"inputs":[{"name":"reversesearcher"}],"output":{"name":"searchstep"}}],[11,"next_match_back","","Find the next `Match` result. See `next_back()`",220,{"inputs":[{"name":"reversesearcher"}],"output":{"name":"option"}}],[11,"next_reject_back","","Find the next `Reject` result. See `next_back()`",220,{"inputs":[{"name":"reversesearcher"}],"output":{"name":"option"}}],[8,"DoubleEndedSearcher","","A marker trait to express that a `ReverseSearcher`\ncan be used for a `DoubleEndedIterator` implementation.",null,null],[3,"CharSearcher","","Associated type for `<char as Pattern<'a>>::Searcher`.",null,null],[3,"CharSliceSearcher","","Associated type for `<&[char] as Pattern<'a>>::Searcher`.",null,null],[3,"CharPredicateSearcher","","Associated type for `<F as Pattern<'a>>::Searcher`.",null,null],[3,"StrSearcher","","Associated type for `<&str as Pattern<'a>>::Searcher`.",null,null],[3,"Decompositions","collections::str","External iterator for a string decomposition's characters.",null,null],[3,"Recompositions","","External iterator for a string recomposition's characters.",null,null],[3,"Utf16Units","","External iterator for a string's UTF16 codeunits.",null,null],[11,"clone","","",221,{"inputs":[{"name":"decompositions"}],"output":{"name":"decompositions"}}],[11,"next","","",221,{"inputs":[{"name":"decompositions"}],"output":{"name":"option"}}],[11,"size_hint","","",221,null],[11,"clone","","",222,{"inputs":[{"name":"recompositions"}],"output":{"name":"recompositions"}}],[11,"next","","",222,{"inputs":[{"name":"recompositions"}],"output":{"name":"option"}}],[11,"clone","","",223,{"inputs":[{"name":"utf16units"}],"output":{"name":"utf16units"}}],[11,"next","","",223,{"inputs":[{"name":"utf16units"}],"output":{"name":"option"}}],[11,"size_hint","","",223,null],[0,"string","collections","An owned, growable string that enforces that its contents are valid UTF-8.",null,null],[3,"String","collections::string","A growable string stored as a UTF-8 encoded buffer.",null,null],[3,"FromUtf8Error","","A possible error value from the `String::from_utf8` function.",null,null],[3,"FromUtf16Error","","A possible error value from the `String::from_utf16` function.",null,null],[3,"ParseError","","Error returned from `String::from`",null,null],[3,"Drain","","A draining iterator for `String`.",null,null],[8,"ToString","","A generic trait for converting a value to a string",null,null],[10,"to_string","","Converts the value of `self` to an owned string",224,{"inputs":[{"name":"tostring"}],"output":{"name":"string"}}],[11,"cmp","","",225,{"inputs":[{"name":"string"},{"name":"string"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",225,{"inputs":[{"name":"string"},{"name":"string"}],"output":{"name":"option"}}],[11,"lt","","",225,{"inputs":[{"name":"string"},{"name":"string"}],"output":{"name":"bool"}}],[11,"le","","",225,{"inputs":[{"name":"string"},{"name":"string"}],"output":{"name":"bool"}}],[11,"gt","","",225,{"inputs":[{"name":"string"},{"name":"string"}],"output":{"name":"bool"}}],[11,"ge","","",225,{"inputs":[{"name":"string"},{"name":"string"}],"output":{"name":"bool"}}],[11,"clone","","",225,{"inputs":[{"name":"string"}],"output":{"name":"string"}}],[11,"fmt","","",226,{"inputs":[{"name":"fromutf8error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",227,{"inputs":[{"name":"fromutf16error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","Creates a new string buffer initialized with the empty string.",225,{"inputs":[{"name":"string"}],"output":{"name":"string"}}],[11,"with_capacity","","Creates a new string buffer with the given capacity.\nThe string will be able to hold exactly `capacity` bytes without\nreallocating. If `capacity` is 0, the string will not allocate.",225,{"inputs":[{"name":"string"},{"name":"usize"}],"output":{"name":"string"}}],[11,"from_str","","Creates a new string buffer from the given string.",225,{"inputs":[{"name":"string"},{"name":"str"}],"output":{"name":"string"}}],[11,"from_utf8","","Returns the vector as a string buffer, if possible, taking care not to\ncopy it.",225,{"inputs":[{"name":"string"},{"name":"vec"}],"output":{"name":"result"}}],[11,"from_utf8_lossy","","Converts a vector of bytes to a new UTF-8 string.\nAny invalid UTF-8 sequences are replaced with U+FFFD REPLACEMENT CHARACTER.",225,null],[11,"from_utf16","","Decode a UTF-16 encoded vector `v` into a `String`, returning `None`\nif `v` contains any invalid data.",225,null],[11,"from_utf16_lossy","","Decode a UTF-16 encoded vector `v` into a string, replacing\ninvalid data with the replacement character (U+FFFD).",225,null],[11,"from_raw_parts","","Creates a new `String` from a length, capacity, and pointer.",225,null],[11,"from_utf8_unchecked","","Converts a vector of bytes to a new `String` without checking if\nit contains valid UTF-8. This is unsafe because it assumes that\nthe UTF-8-ness of the vector has already been validated.",225,{"inputs":[{"name":"string"},{"name":"vec"}],"output":{"name":"string"}}],[11,"into_bytes","","Returns the underlying byte buffer, encoded as UTF-8.",225,{"inputs":[{"name":"string"}],"output":{"name":"vec"}}],[11,"as_str","","Extracts a string slice containing the entire string.",225,{"inputs":[{"name":"string"}],"output":{"name":"str"}}],[11,"push_str","","Pushes the given string onto this string buffer.",225,{"inputs":[{"name":"string"},{"name":"str"}],"output":null}],[11,"capacity","","Returns the number of bytes that this string buffer can hold without\nreallocating.",225,{"inputs":[{"name":"string"}],"output":{"name":"usize"}}],[11,"reserve","","Reserves capacity for at least `additional` more bytes to be inserted\nin the given `String`. The collection may reserve more space to avoid\nfrequent reallocations.",225,{"inputs":[{"name":"string"},{"name":"usize"}],"output":null}],[11,"reserve_exact","","Reserves the minimum capacity for exactly `additional` more bytes to be\ninserted in the given `String`. Does nothing if the capacity is already\nsufficient.",225,{"inputs":[{"name":"string"},{"name":"usize"}],"output":null}],[11,"shrink_to_fit","","Shrinks the capacity of this string buffer to match its length.",225,{"inputs":[{"name":"string"}],"output":null}],[11,"push","","Adds the given character to the end of the string.",225,{"inputs":[{"name":"string"},{"name":"char"}],"output":null}],[11,"as_bytes","","Works with the underlying buffer as a byte slice.",225,null],[11,"truncate","","Shortens a string to the specified length.",225,{"inputs":[{"name":"string"},{"name":"usize"}],"output":null}],[11,"pop","","Removes the last character from the string buffer and returns it.\nReturns `None` if this string buffer is empty.",225,{"inputs":[{"name":"string"}],"output":{"name":"option"}}],[11,"remove","","Removes the character from the string buffer at byte position `idx` and\nreturns it.",225,{"inputs":[{"name":"string"},{"name":"usize"}],"output":{"name":"char"}}],[11,"insert","","Inserts a character into the string buffer at byte position `idx`.",225,{"inputs":[{"name":"string"},{"name":"usize"},{"name":"char"}],"output":null}],[11,"as_mut_vec","","Views the string buffer as a mutable sequence of bytes.",225,{"inputs":[{"name":"string"}],"output":{"name":"vec"}}],[11,"len","","Returns the number of bytes in this string.",225,{"inputs":[{"name":"string"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns true if the string contains no bytes",225,{"inputs":[{"name":"string"}],"output":{"name":"bool"}}],[11,"clear","","Truncates the string, returning it to 0 length.",225,{"inputs":[{"name":"string"}],"output":null}],[11,"drain","","Create a draining iterator that removes the specified range in the string\nand yields the removed chars from start to end. The element range is\nremoved even if the iterator is not consumed until the end.",225,{"inputs":[{"name":"string"},{"name":"r"}],"output":{"name":"drain"}}],[11,"into_boxed_slice","","Converts the string into `Box<str>`.",225,{"inputs":[{"name":"string"}],"output":{"name":"box"}}],[11,"into_bytes","","Consumes this error, returning the bytes that were attempted to make a\n`String` with.",226,{"inputs":[{"name":"fromutf8error"}],"output":{"name":"vec"}}],[11,"utf8_error","","Access the underlying UTF8-error that was the cause of this error.",226,{"inputs":[{"name":"fromutf8error"}],"output":{"name":"utf8error"}}],[11,"fmt","","",226,{"inputs":[{"name":"fromutf8error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",227,{"inputs":[{"name":"fromutf16error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from_iter","","",225,{"inputs":[{"name":"string"},{"name":"i"}],"output":{"name":"string"}}],[11,"from_iter","","",225,{"inputs":[{"name":"string"},{"name":"i"}],"output":{"name":"string"}}],[11,"extend","","",225,{"inputs":[{"name":"string"},{"name":"i"}],"output":null}],[11,"extend","","",225,{"inputs":[{"name":"string"},{"name":"i"}],"output":null}],[11,"extend","","",225,{"inputs":[{"name":"string"},{"name":"i"}],"output":null}],[11,"eq","","",225,{"inputs":[{"name":"string"},{"name":"string"}],"output":{"name":"bool"}}],[11,"ne","","",225,{"inputs":[{"name":"string"},{"name":"string"}],"output":{"name":"bool"}}],[11,"eq","","",225,{"inputs":[{"name":"string"},{"name":"str"}],"output":{"name":"bool"}}],[11,"ne","","",225,{"inputs":[{"name":"string"},{"name":"str"}],"output":{"name":"bool"}}],[11,"eq","","",225,{"inputs":[{"name":"string"},{"name":"str"}],"output":{"name":"bool"}}],[11,"ne","","",225,{"inputs":[{"name":"string"},{"name":"str"}],"output":{"name":"bool"}}],[11,"eq","collections::borrow","",18,{"inputs":[{"name":"cow"},{"name":"str"}],"output":{"name":"bool"}}],[11,"ne","","",18,{"inputs":[{"name":"cow"},{"name":"str"}],"output":{"name":"bool"}}],[11,"eq","","",18,{"inputs":[{"name":"cow"},{"name":"string"}],"output":{"name":"bool"}}],[11,"ne","","",18,{"inputs":[{"name":"cow"},{"name":"string"}],"output":{"name":"bool"}}],[11,"eq","collections::string","",225,{"inputs":[{"name":"string"},{"name":"cow"}],"output":{"name":"bool"}}],[11,"ne","","",225,{"inputs":[{"name":"string"},{"name":"cow"}],"output":{"name":"bool"}}],[11,"eq","collections::borrow","",18,{"inputs":[{"name":"cow"},{"name":"str"}],"output":{"name":"bool"}}],[11,"ne","","",18,{"inputs":[{"name":"cow"},{"name":"str"}],"output":{"name":"bool"}}],[11,"default","collections::string","",225,{"inputs":[{"name":"string"}],"output":{"name":"string"}}],[11,"fmt","","",225,{"inputs":[{"name":"string"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",225,{"inputs":[{"name":"string"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",225,{"inputs":[{"name":"string"},{"name":"h"}],"output":null}],[11,"add","","",225,{"inputs":[{"name":"string"},{"name":"str"}],"output":{"name":"string"}}],[11,"index","","",225,{"inputs":[{"name":"string"},{"name":"range"}],"output":{"name":"str"}}],[11,"index","","",225,{"inputs":[{"name":"string"},{"name":"rangeto"}],"output":{"name":"str"}}],[11,"index","","",225,{"inputs":[{"name":"string"},{"name":"rangefrom"}],"output":{"name":"str"}}],[11,"index","","",225,{"inputs":[{"name":"string"},{"name":"rangefull"}],"output":{"name":"str"}}],[11,"index_mut","","",225,{"inputs":[{"name":"string"},{"name":"range"}],"output":{"name":"str"}}],[11,"index_mut","","",225,{"inputs":[{"name":"string"},{"name":"rangeto"}],"output":{"name":"str"}}],[11,"index_mut","","",225,{"inputs":[{"name":"string"},{"name":"rangefrom"}],"output":{"name":"str"}}],[11,"index_mut","","",225,{"inputs":[{"name":"string"},{"name":"rangefull"}],"output":{"name":"str"}}],[11,"deref","","",225,{"inputs":[{"name":"string"}],"output":{"name":"str"}}],[11,"deref_mut","","",225,{"inputs":[{"name":"string"}],"output":{"name":"str"}}],[11,"eq","","",228,{"inputs":[{"name":"parseerror"},{"name":"parseerror"}],"output":{"name":"bool"}}],[11,"ne","","",228,{"inputs":[{"name":"parseerror"},{"name":"parseerror"}],"output":{"name":"bool"}}],[11,"fmt","","",228,{"inputs":[{"name":"parseerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",228,{"inputs":[{"name":"parseerror"}],"output":{"name":"parseerror"}}],[11,"from_str","","",225,{"inputs":[{"name":"string"},{"name":"str"}],"output":{"name":"result"}}],[11,"as_ref","","",225,{"inputs":[{"name":"string"}],"output":{"name":"str"}}],[11,"as_ref","","",225,null],[11,"from","","",225,{"inputs":[{"name":"string"},{"name":"str"}],"output":{"name":"string"}}],[11,"from","collections::borrow","",18,{"inputs":[{"name":"cow"},{"name":"str"}],"output":{"name":"cow"}}],[11,"from","","",18,{"inputs":[{"name":"cow"},{"name":"string"}],"output":{"name":"cow"}}],[11,"into","collections::string","",225,{"inputs":[{"name":"string"}],"output":{"name":"vec"}}],[11,"into_cow","","",225,{"inputs":[{"name":"string"}],"output":{"name":"cow"}}],[11,"write_str","","",225,{"inputs":[{"name":"string"},{"name":"str"}],"output":{"name":"result"}}],[11,"write_char","","",225,{"inputs":[{"name":"string"},{"name":"char"}],"output":{"name":"result"}}],[11,"drop","","",229,{"inputs":[{"name":"drain"}],"output":null}],[11,"next","","",229,{"inputs":[{"name":"drain"}],"output":{"name":"option"}}],[11,"size_hint","","",229,null],[11,"next_back","","",229,{"inputs":[{"name":"drain"}],"output":{"name":"option"}}],[0,"vec","collections","A growable list type with heap-allocated contents, written `Vec<T>` but\npronounced 'vector.'",null,null],[3,"Vec","collections::vec","A growable list type, written `Vec<T>` but pronounced 'vector.'",null,null],[3,"IntoIter","","An iterator that moves out of a vector.",null,null],[3,"Drain","","A draining iterator for `Vec<T>`.",null,null],[11,"new","","Constructs a new, empty `Vec<T>`.",230,{"inputs":[{"name":"vec"}],"output":{"name":"vec"}}],[11,"with_capacity","","Constructs a new, empty `Vec<T>` with the specified capacity.",230,{"inputs":[{"name":"vec"},{"name":"usize"}],"output":{"name":"vec"}}],[11,"from_raw_parts","","Creates a `Vec<T>` directly from the raw components of another vector.",230,null],[11,"from_raw_buf","","Creates a vector by copying the elements from a raw pointer.",230,null],[11,"capacity","","Returns the number of elements the vector can hold without\nreallocating.",230,{"inputs":[{"name":"vec"}],"output":{"name":"usize"}}],[11,"reserve","","Reserves capacity for at least `additional` more elements to be inserted\nin the given `Vec<T>`. The collection may reserve more space to avoid\nfrequent reallocations.",230,{"inputs":[{"name":"vec"},{"name":"usize"}],"output":null}],[11,"reserve_exact","","Reserves the minimum capacity for exactly `additional` more elements to\nbe inserted in the given `Vec<T>`. Does nothing if the capacity is already\nsufficient.",230,{"inputs":[{"name":"vec"},{"name":"usize"}],"output":null}],[11,"shrink_to_fit","","Shrinks the capacity of the vector as much as possible.",230,{"inputs":[{"name":"vec"}],"output":null}],[11,"into_boxed_slice","","Converts the vector into Box<[T]>.",230,{"inputs":[{"name":"vec"}],"output":{"name":"box"}}],[11,"truncate","","Shorten a vector, dropping excess elements.",230,{"inputs":[{"name":"vec"},{"name":"usize"}],"output":null}],[11,"as_slice","","Extracts a slice containing the entire vector.",230,null],[11,"as_mut_slice","","Extracts a mutable slice of the entire vector.",230,null],[11,"set_len","","Sets the length of a vector.",230,{"inputs":[{"name":"vec"},{"name":"usize"}],"output":null}],[11,"swap_remove","","Removes an element from anywhere in the vector and return it, replacing\nit with the last element.",230,{"inputs":[{"name":"vec"},{"name":"usize"}],"output":{"name":"t"}}],[11,"insert","","Inserts an element at position `index` within the vector, shifting all\nelements after position `i` one position to the right.",230,{"inputs":[{"name":"vec"},{"name":"usize"},{"name":"t"}],"output":null}],[11,"remove","","Removes and returns the element at position `index` within the vector,\nshifting all elements after position `index` one position to the left.",230,{"inputs":[{"name":"vec"},{"name":"usize"}],"output":{"name":"t"}}],[11,"retain","","Retains only the elements specified by the predicate.",230,{"inputs":[{"name":"vec"},{"name":"f"}],"output":null}],[11,"push","","Appends an element to the back of a collection.",230,{"inputs":[{"name":"vec"},{"name":"t"}],"output":null}],[11,"pop","","Removes the last element from a vector and returns it, or `None` if it is empty.",230,{"inputs":[{"name":"vec"}],"output":{"name":"option"}}],[11,"append","","Moves all the elements of `other` into `Self`, leaving `other` empty.",230,{"inputs":[{"name":"vec"},{"name":"self"}],"output":null}],[11,"drain","","Create a draining iterator that removes the specified range in the vector\nand yields the removed items from start to end. The element range is\nremoved even if the iterator is not consumed until the end.",230,{"inputs":[{"name":"vec"},{"name":"r"}],"output":{"name":"drain"}}],[11,"clear","","Clears the vector, removing all values.",230,{"inputs":[{"name":"vec"}],"output":null}],[11,"len","","Returns the number of elements in the vector.",230,{"inputs":[{"name":"vec"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns `true` if the vector contains no elements.",230,{"inputs":[{"name":"vec"}],"output":{"name":"bool"}}],[11,"map_in_place","","Converts a `Vec<T>` to a `Vec<U>` where `T` and `U` have the same\nsize and in case they are not zero-sized the same minimal alignment.",230,{"inputs":[{"name":"vec"},{"name":"f"}],"output":{"name":"vec"}}],[11,"split_off","","Splits the collection into two at the given index.",230,{"inputs":[{"name":"vec"},{"name":"usize"}],"output":{"name":"self"}}],[11,"resize","","Resizes the `Vec` in-place so that `len()` is equal to `new_len`.",230,{"inputs":[{"name":"vec"},{"name":"usize"},{"name":"t"}],"output":null}],[11,"push_all","","Appends all elements in a slice to the `Vec`.",230,null],[11,"dedup","","Removes consecutive repeated elements in the vector.",230,{"inputs":[{"name":"vec"}],"output":null}],[11,"clone","","",230,{"inputs":[{"name":"vec"}],"output":{"name":"vec"}}],[11,"clone_from","","",230,{"inputs":[{"name":"vec"},{"name":"vec"}],"output":null}],[11,"hash","","",230,{"inputs":[{"name":"vec"},{"name":"h"}],"output":null}],[11,"index","","",230,{"inputs":[{"name":"vec"},{"name":"usize"}],"output":{"name":"t"}}],[11,"index_mut","","",230,{"inputs":[{"name":"vec"},{"name":"usize"}],"output":{"name":"t"}}],[11,"index","","",230,null],[11,"index","","",230,null],[11,"index","","",230,null],[11,"index","","",230,null],[11,"index_mut","","",230,null],[11,"index_mut","","",230,null],[11,"index_mut","","",230,null],[11,"index_mut","","",230,null],[11,"deref","","",230,null],[11,"deref_mut","","",230,null],[11,"from_iter","","",230,{"inputs":[{"name":"vec"},{"name":"i"}],"output":{"name":"vec"}}],[11,"into_iter","","Creates a consuming iterator, that is, one that moves each value out of\nthe vector (from start to end). The vector cannot be used after calling\nthis.",230,{"inputs":[{"name":"vec"}],"output":{"name":"intoiter"}}],[11,"extend","","",230,{"inputs":[{"name":"vec"},{"name":"i"}],"output":null}],[11,"extend","","",230,{"inputs":[{"name":"vec"},{"name":"i"}],"output":null}],[11,"eq","","",230,{"inputs":[{"name":"vec"},{"name":"vec"}],"output":{"name":"bool"}}],[11,"ne","","",230,{"inputs":[{"name":"vec"},{"name":"vec"}],"output":{"name":"bool"}}],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","collections::borrow","",18,null],[11,"ne","","",18,null],[11,"eq","","",18,null],[11,"ne","","",18,null],[11,"eq","","",18,{"inputs":[{"name":"cow"},{"name":"vec"}],"output":{"name":"bool"}}],[11,"ne","","",18,{"inputs":[{"name":"cow"},{"name":"vec"}],"output":{"name":"bool"}}],[11,"eq","collections::vec","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"eq","","",230,null],[11,"ne","","",230,null],[11,"partial_cmp","","",230,{"inputs":[{"name":"vec"},{"name":"vec"}],"output":{"name":"option"}}],[11,"cmp","","",230,{"inputs":[{"name":"vec"},{"name":"vec"}],"output":{"name":"ordering"}}],[11,"drop","","",230,{"inputs":[{"name":"vec"}],"output":null}],[11,"default","","",230,{"inputs":[{"name":"vec"}],"output":{"name":"vec"}}],[11,"fmt","","",230,{"inputs":[{"name":"vec"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"as_ref","","",230,{"inputs":[{"name":"vec"}],"output":{"name":"vec"}}],[11,"as_ref","","",230,null],[11,"from","","",230,null],[11,"from","","",230,{"inputs":[{"name":"vec"},{"name":"str"}],"output":{"name":"vec"}}],[11,"from_iter","collections::borrow","",18,{"inputs":[{"name":"cow"},{"name":"i"}],"output":{"name":"cow"}}],[11,"into_cow","collections::vec","",230,{"inputs":[{"name":"vec"}],"output":{"name":"cow"}}],[11,"into_inner","","Drops all items that have not yet been moved and returns the empty vector.",231,{"inputs":[{"name":"intoiter"}],"output":{"name":"vec"}}],[11,"next","","",231,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",231,null],[11,"count","","",231,{"inputs":[{"name":"intoiter"}],"output":{"name":"usize"}}],[11,"next_back","","",231,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"drop","","",231,{"inputs":[{"name":"intoiter"}],"output":null}],[11,"next","","",232,{"inputs":[{"name":"drain"}],"output":{"name":"option"}}],[11,"size_hint","","",232,null],[11,"next_back","","",232,{"inputs":[{"name":"drain"}],"output":{"name":"option"}}],[11,"drop","","",232,{"inputs":[{"name":"drain"}],"output":null}],[0,"vec_deque","collections","VecDeque is a double-ended queue, which is implemented with the help of a\ngrowing ring buffer.",null,null],[3,"VecDeque","collections::vec_deque","`VecDeque` is a growable ring buffer, which can be used as a\ndouble-ended queue efficiently.",null,null],[3,"Iter","","`VecDeque` iterator.",null,null],[3,"IterMut","","`VecDeque` mutable iterator.",null,null],[3,"IntoIter","","A by-value VecDeque iterator",null,null],[3,"Drain","","A draining VecDeque iterator",null,null],[11,"clone","","",233,{"inputs":[{"name":"vecdeque"}],"output":{"name":"vecdeque"}}],[11,"drop","","",233,{"inputs":[{"name":"vecdeque"}],"output":null}],[11,"default","","",233,{"inputs":[{"name":"vecdeque"}],"output":{"name":"vecdeque"}}],[11,"new","","Creates an empty `VecDeque`.",233,{"inputs":[{"name":"vecdeque"}],"output":{"name":"vecdeque"}}],[11,"with_capacity","","Creates an empty `VecDeque` with space for at least `n` elements.",233,{"inputs":[{"name":"vecdeque"},{"name":"usize"}],"output":{"name":"vecdeque"}}],[11,"get","","Retrieves an element in the `VecDeque` by index.",233,{"inputs":[{"name":"vecdeque"},{"name":"usize"}],"output":{"name":"option"}}],[11,"get_mut","","Retrieves an element in the `VecDeque` mutably by index.",233,{"inputs":[{"name":"vecdeque"},{"name":"usize"}],"output":{"name":"option"}}],[11,"swap","","Swaps elements at indices `i` and `j`.",233,{"inputs":[{"name":"vecdeque"},{"name":"usize"},{"name":"usize"}],"output":null}],[11,"capacity","","Returns the number of elements the `VecDeque` can hold without\nreallocating.",233,{"inputs":[{"name":"vecdeque"}],"output":{"name":"usize"}}],[11,"reserve_exact","","Reserves the minimum capacity for exactly `additional` more elements to be inserted in the\ngiven `VecDeque`. Does nothing if the capacity is already sufficient.",233,{"inputs":[{"name":"vecdeque"},{"name":"usize"}],"output":null}],[11,"reserve","","Reserves capacity for at least `additional` more elements to be inserted in the given\n`VecDeque`. The collection may reserve more space to avoid frequent reallocations.",233,{"inputs":[{"name":"vecdeque"},{"name":"usize"}],"output":null}],[11,"shrink_to_fit","","Shrinks the capacity of the `VecDeque` as much as possible.",233,{"inputs":[{"name":"vecdeque"}],"output":null}],[11,"truncate","","Shortens a `VecDeque`, dropping excess elements from the back.",233,{"inputs":[{"name":"vecdeque"},{"name":"usize"}],"output":null}],[11,"iter","","Returns a front-to-back iterator.",233,{"inputs":[{"name":"vecdeque"}],"output":{"name":"iter"}}],[11,"iter_mut","","Returns a front-to-back iterator that returns mutable references.",233,{"inputs":[{"name":"vecdeque"}],"output":{"name":"itermut"}}],[11,"as_slices","","Returns a pair of slices which contain, in order, the contents of the\n`VecDeque`.",233,null],[11,"as_mut_slices","","Returns a pair of slices which contain, in order, the contents of the\n`VecDeque`.",233,null],[11,"len","","Returns the number of elements in the `VecDeque`.",233,{"inputs":[{"name":"vecdeque"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns true if the buffer contains no elements",233,{"inputs":[{"name":"vecdeque"}],"output":{"name":"bool"}}],[11,"drain","","Creates a draining iterator that clears the `VecDeque` and iterates over\nthe removed items from start to end.",233,{"inputs":[{"name":"vecdeque"}],"output":{"name":"drain"}}],[11,"clear","","Clears the buffer, removing all values.",233,{"inputs":[{"name":"vecdeque"}],"output":null}],[11,"front","","Provides a reference to the front element, or `None` if the sequence is\nempty.",233,{"inputs":[{"name":"vecdeque"}],"output":{"name":"option"}}],[11,"front_mut","","Provides a mutable reference to the front element, or `None` if the\nsequence is empty.",233,{"inputs":[{"name":"vecdeque"}],"output":{"name":"option"}}],[11,"back","","Provides a reference to the back element, or `None` if the sequence is\nempty.",233,{"inputs":[{"name":"vecdeque"}],"output":{"name":"option"}}],[11,"back_mut","","Provides a mutable reference to the back element, or `None` if the\nsequence is empty.",233,{"inputs":[{"name":"vecdeque"}],"output":{"name":"option"}}],[11,"pop_front","","Removes the first element and returns it, or `None` if the sequence is\nempty.",233,{"inputs":[{"name":"vecdeque"}],"output":{"name":"option"}}],[11,"push_front","","Inserts an element first in the sequence.",233,{"inputs":[{"name":"vecdeque"},{"name":"t"}],"output":null}],[11,"push_back","","Appends an element to the back of a buffer",233,{"inputs":[{"name":"vecdeque"},{"name":"t"}],"output":null}],[11,"pop_back","","Removes the last element from a buffer and returns it, or `None` if\nit is empty.",233,{"inputs":[{"name":"vecdeque"}],"output":{"name":"option"}}],[11,"swap_back_remove","","Removes an element from anywhere in the `VecDeque` and returns it, replacing it with the\nlast element.",233,{"inputs":[{"name":"vecdeque"},{"name":"usize"}],"output":{"name":"option"}}],[11,"swap_front_remove","","Removes an element from anywhere in the `VecDeque` and returns it,\nreplacing it with the first element.",233,{"inputs":[{"name":"vecdeque"},{"name":"usize"}],"output":{"name":"option"}}],[11,"insert","","Inserts an element at `index` within the `VecDeque`. Whichever\nend is closer to the insertion point will be moved to make room,\nand all the affected elements will be moved to new positions.",233,{"inputs":[{"name":"vecdeque"},{"name":"usize"},{"name":"t"}],"output":null}],[11,"remove","","Removes and returns the element at `index` from the `VecDeque`.\nWhichever end is closer to the removal point will be moved to make\nroom, and all the affected elements will be moved to new positions.\nReturns `None` if `index` is out of bounds.",233,{"inputs":[{"name":"vecdeque"},{"name":"usize"}],"output":{"name":"option"}}],[11,"split_off","","Splits the collection into two at the given index.",233,{"inputs":[{"name":"vecdeque"},{"name":"usize"}],"output":{"name":"self"}}],[11,"append","","Moves all the elements of `other` into `Self`, leaving `other` empty.",233,{"inputs":[{"name":"vecdeque"},{"name":"self"}],"output":null}],[11,"retain","","Retains only the elements specified by the predicate.",233,{"inputs":[{"name":"vecdeque"},{"name":"f"}],"output":null}],[11,"resize","","Modifies the `VecDeque` in-place so that `len()` is equal to new_len,\neither by removing excess elements or by appending copies of a value to the back.",233,{"inputs":[{"name":"vecdeque"},{"name":"usize"},{"name":"t"}],"output":null}],[11,"clone","","",234,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[11,"next","","",234,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",234,null],[11,"next_back","","",234,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"indexable","","",234,{"inputs":[{"name":"iter"}],"output":{"name":"usize"}}],[11,"idx","","",234,{"inputs":[{"name":"iter"},{"name":"usize"}],"output":{"name":"option"}}],[11,"next","","",235,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"size_hint","","",235,null],[11,"next_back","","",235,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"clone","","",236,{"inputs":[{"name":"intoiter"}],"output":{"name":"intoiter"}}],[11,"next","","",236,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",236,null],[11,"next_back","","",236,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"drop","","",237,{"inputs":[{"name":"drain"}],"output":null}],[11,"next","","",237,{"inputs":[{"name":"drain"}],"output":{"name":"option"}}],[11,"size_hint","","",237,null],[11,"next_back","","",237,{"inputs":[{"name":"drain"}],"output":{"name":"option"}}],[11,"eq","","",233,{"inputs":[{"name":"vecdeque"},{"name":"vecdeque"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",233,{"inputs":[{"name":"vecdeque"},{"name":"vecdeque"}],"output":{"name":"option"}}],[11,"cmp","","",233,{"inputs":[{"name":"vecdeque"},{"name":"vecdeque"}],"output":{"name":"ordering"}}],[11,"hash","","",233,{"inputs":[{"name":"vecdeque"},{"name":"h"}],"output":null}],[11,"index","","",233,{"inputs":[{"name":"vecdeque"},{"name":"usize"}],"output":{"name":"a"}}],[11,"index_mut","","",233,{"inputs":[{"name":"vecdeque"},{"name":"usize"}],"output":{"name":"a"}}],[11,"from_iter","","",233,{"inputs":[{"name":"vecdeque"},{"name":"t"}],"output":{"name":"vecdeque"}}],[11,"into_iter","","Consumes the list into a front-to-back iterator yielding elements by\nvalue.",233,{"inputs":[{"name":"vecdeque"}],"output":{"name":"intoiter"}}],[11,"extend","","",233,{"inputs":[{"name":"vecdeque"},{"name":"t"}],"output":null}],[11,"extend","","",233,{"inputs":[{"name":"vecdeque"},{"name":"i"}],"output":null}],[11,"fmt","","",233,{"inputs":[{"name":"vecdeque"},{"name":"formatter"}],"output":{"name":"result"}}],[0,"vec_map","collections","A simple map based on a vector for small integer keys. Space requirements\nare O(highest integer key).",null,null],[3,"VecMap","collections::vec_map","A map optimized for small integer keys.",null,null],[3,"VacantEntry","","A vacant Entry.",null,null],[3,"OccupiedEntry","","An occupied Entry.",null,null],[3,"Iter","","An iterator over the key-value pairs of a map.",null,null],[3,"IterMut","","An iterator over the key-value pairs of a map, with the\nvalues being mutable.",null,null],[3,"Keys","","An iterator over the keys of a map.",null,null],[3,"Values","","An iterator over the values of a map.",null,null],[3,"IntoIter","","A consuming iterator over the key-value pairs of a map.",null,null],[3,"Drain","","",null,null],[4,"Entry","","A view into a single entry in a map, which may either be vacant or occupied.",null,null],[13,"Vacant","","A vacant Entry",238,null],[13,"Occupied","","An occupied Entry",238,null],[11,"default","","",239,{"inputs":[{"name":"vecmap"}],"output":{"name":"vecmap"}}],[11,"clone","","",239,{"inputs":[{"name":"vecmap"}],"output":{"name":"vecmap"}}],[11,"clone_from","","",239,{"inputs":[{"name":"vecmap"},{"name":"vecmap"}],"output":null}],[11,"hash","","",239,{"inputs":[{"name":"vecmap"},{"name":"h"}],"output":null}],[11,"new","","Creates an empty `VecMap`.",239,{"inputs":[{"name":"vecmap"}],"output":{"name":"vecmap"}}],[11,"with_capacity","","Creates an empty `VecMap` with space for at least `capacity`\nelements before resizing.",239,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":{"name":"vecmap"}}],[11,"capacity","","Returns the number of elements the `VecMap` can hold without\nreallocating.",239,{"inputs":[{"name":"vecmap"}],"output":{"name":"usize"}}],[11,"reserve_len","","Reserves capacity for the given `VecMap` to contain `len` distinct keys.\nIn the case of `VecMap` this means reallocations will not occur as long\nas all inserted keys are less than `len`.",239,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":null}],[11,"reserve_len_exact","","Reserves the minimum capacity for the given `VecMap` to contain `len` distinct keys.\nIn the case of `VecMap` this means reallocations will not occur as long as all inserted\nkeys are less than `len`.",239,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":null}],[11,"keys","","Returns an iterator visiting all keys in ascending order of the keys.\nThe iterator's element type is `usize`.",239,{"inputs":[{"name":"vecmap"}],"output":{"name":"keys"}}],[11,"values","","Returns an iterator visiting all values in ascending order of the keys.\nThe iterator's element type is `&'r V`.",239,{"inputs":[{"name":"vecmap"}],"output":{"name":"values"}}],[11,"iter","","Returns an iterator visiting all key-value pairs in ascending order of the keys.\nThe iterator's element type is `(usize, &'r V)`.",239,{"inputs":[{"name":"vecmap"}],"output":{"name":"iter"}}],[11,"iter_mut","","Returns an iterator visiting all key-value pairs in ascending order of the keys,\nwith mutable references to the values.\nThe iterator's element type is `(usize, &'r mut V)`.",239,{"inputs":[{"name":"vecmap"}],"output":{"name":"itermut"}}],[11,"append","","Moves all elements from `other` into the map while overwriting existing keys.",239,{"inputs":[{"name":"vecmap"},{"name":"self"}],"output":null}],[11,"split_off","","Splits the collection into two at the given key.",239,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":{"name":"self"}}],[11,"drain","","Returns an iterator visiting all key-value pairs in ascending order of\nthe keys, emptying (but not consuming) the original `VecMap`.\nThe iterator's element type is `(usize, &'r V)`. Keeps the allocated memory for reuse.",239,{"inputs":[{"name":"vecmap"}],"output":{"name":"drain"}}],[11,"len","","Returns the number of elements in the map.",239,{"inputs":[{"name":"vecmap"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns true if the map contains no elements.",239,{"inputs":[{"name":"vecmap"}],"output":{"name":"bool"}}],[11,"clear","","Clears the map, removing all key-value pairs.",239,{"inputs":[{"name":"vecmap"}],"output":null}],[11,"get","","Returns a reference to the value corresponding to the key.",239,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":{"name":"option"}}],[11,"contains_key","","Returns true if the map contains a value for the specified key.",239,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":{"name":"bool"}}],[11,"get_mut","","Returns a mutable reference to the value corresponding to the key.",239,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":{"name":"option"}}],[11,"insert","","Inserts a key-value pair into the map. If the key already had a value\npresent in the map, that value is returned. Otherwise, `None` is returned.",239,{"inputs":[{"name":"vecmap"},{"name":"usize"},{"name":"v"}],"output":{"name":"option"}}],[11,"remove","","Removes a key from the map, returning the value at the key if the key\nwas previously in the map.",239,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":{"name":"option"}}],[11,"entry","","Gets the given key's corresponding entry in the map for in-place manipulation.",239,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":{"name":"entry"}}],[11,"get","","Returns a mutable reference to the entry if occupied, or the VacantEntry if vacant",238,{"inputs":[{"name":"entry"}],"output":{"name":"result"}}],[11,"or_insert","","Ensures a value is in the entry by inserting the default if empty, and\nreturns a mutable reference to the value in the entry.",238,{"inputs":[{"name":"entry"},{"name":"v"}],"output":{"name":"v"}}],[11,"or_insert_with","","Ensures a value is in the entry by inserting the result of the default\nfunction if empty, and returns a mutable reference to the value in the\nentry.",238,{"inputs":[{"name":"entry"},{"name":"f"}],"output":{"name":"v"}}],[11,"insert","","Sets the value of the entry with the VacantEntry's key,\nand returns a mutable reference to it.",240,{"inputs":[{"name":"vacantentry"},{"name":"v"}],"output":{"name":"v"}}],[11,"get","","Gets a reference to the value in the entry.",241,{"inputs":[{"name":"occupiedentry"}],"output":{"name":"v"}}],[11,"get_mut","","Gets a mutable reference to the value in the entry.",241,{"inputs":[{"name":"occupiedentry"}],"output":{"name":"v"}}],[11,"into_mut","","Converts the entry into a mutable reference to its value.",241,{"inputs":[{"name":"occupiedentry"}],"output":{"name":"v"}}],[11,"insert","","Sets the value of the entry with the OccupiedEntry's key,\nand returns the entry's old value.",241,{"inputs":[{"name":"occupiedentry"},{"name":"v"}],"output":{"name":"v"}}],[11,"remove","","Takes the value of the entry out of the map, and returns it.",241,{"inputs":[{"name":"occupiedentry"}],"output":{"name":"v"}}],[11,"eq","","",239,{"inputs":[{"name":"vecmap"},{"name":"vecmap"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",239,{"inputs":[{"name":"vecmap"},{"name":"vecmap"}],"output":{"name":"option"}}],[11,"cmp","","",239,{"inputs":[{"name":"vecmap"},{"name":"vecmap"}],"output":{"name":"ordering"}}],[11,"fmt","","",239,{"inputs":[{"name":"vecmap"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from_iter","","",239,{"inputs":[{"name":"vecmap"},{"name":"i"}],"output":{"name":"vecmap"}}],[11,"into_iter","","Returns an iterator visiting all key-value pairs in ascending order of\nthe keys, consuming the original `VecMap`.\nThe iterator's element type is `(usize, &'r V)`.",239,{"inputs":[{"name":"vecmap"}],"output":{"name":"intoiter"}}],[11,"extend","","",239,{"inputs":[{"name":"vecmap"},{"name":"i"}],"output":null}],[11,"extend","","",239,{"inputs":[{"name":"vecmap"},{"name":"i"}],"output":null}],[11,"index","","",239,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":{"name":"v"}}],[11,"index","","",239,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":{"name":"v"}}],[11,"index_mut","","",239,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":{"name":"v"}}],[11,"index_mut","","",239,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":{"name":"v"}}],[11,"clone","","",242,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[11,"next","","",242,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",242,null],[11,"next_back","","",242,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"next","","",243,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"size_hint","","",243,null],[11,"next_back","","",243,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"clone","","",244,{"inputs":[{"name":"keys"}],"output":{"name":"keys"}}],[11,"clone","","",245,{"inputs":[{"name":"values"}],"output":{"name":"values"}}],[11,"next","","",246,{"inputs":[{"name":"drain"}],"output":{"name":"option"}}],[11,"size_hint","","",246,null],[11,"next_back","","",246,{"inputs":[{"name":"drain"}],"output":{"name":"option"}}],[11,"next","","",244,{"inputs":[{"name":"keys"}],"output":{"name":"option"}}],[11,"size_hint","","",244,null],[11,"next_back","","",244,{"inputs":[{"name":"keys"}],"output":{"name":"option"}}],[11,"next","","",245,{"inputs":[{"name":"values"}],"output":{"name":"option"}}],[11,"size_hint","","",245,null],[11,"next_back","","",245,{"inputs":[{"name":"values"}],"output":{"name":"option"}}],[11,"next","","",247,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",247,null],[11,"next_back","","",247,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[0,"bit_vec","collections","",null,null],[3,"Iter","collections::bit_vec","An iterator for `BitVec`.",null,null],[0,"bit_set","collections","",null,null],[3,"Union","collections::bit_set","",null,null],[3,"Intersection","","",null,null],[3,"Difference","","",null,null],[3,"SymmetricDifference","","",null,null],[3,"Iter","","An iterator for `BitSet`.",null,null],[0,"btree_map","collections","",null,null],[3,"BTreeMap","collections::btree_map","A map based on a B-Tree.",null,null],[3,"Iter","","An iterator over a BTreeMap's entries.",null,null],[3,"IterMut","","A mutable iterator over a BTreeMap's entries.",null,null],[3,"IntoIter","","An owning iterator over a BTreeMap's entries.",null,null],[3,"Keys","","An iterator over a BTreeMap's keys.",null,null],[3,"Values","","An iterator over a BTreeMap's values.",null,null],[3,"Range","","An iterator over a sub-range of BTreeMap's entries.",null,null],[3,"RangeMut","","A mutable iterator over a sub-range of BTreeMap's entries.",null,null],[3,"VacantEntry","","A vacant Entry.",null,null],[3,"OccupiedEntry","","An occupied Entry.",null,null],[4,"Entry","","A view into a single entry in a map, which may either be vacant or occupied.",null,null],[13,"Vacant","","A vacant Entry",248,null],[13,"Occupied","","An occupied Entry",248,null],[0,"btree_set","collections","",null,null],[3,"BTreeSet","collections::btree_set","A set based on a B-Tree.",null,null],[3,"Iter","","An iterator over a BTreeSet's items.",null,null],[3,"IntoIter","","An owning iterator over a BTreeSet's items.",null,null],[3,"Range","","An iterator over a sub-range of BTreeSet's items.",null,null],[3,"Difference","","A lazy iterator producing elements in the set difference (in-order).",null,null],[3,"SymmetricDifference","","A lazy iterator producing elements in the set symmetric difference (in-order).",null,null],[3,"Intersection","","A lazy iterator producing elements in the set intersection (in-order).",null,null],[3,"Union","","A lazy iterator producing elements in the set union (in-order).",null,null],[11,"eq","collections","",9,{"inputs":[{"name":"bound"},{"name":"bound"}],"output":{"name":"bool"}}],[11,"ne","","",9,{"inputs":[{"name":"bound"},{"name":"bound"}],"output":{"name":"bool"}}],[11,"hash","","",9,null],[11,"fmt","","",9,{"inputs":[{"name":"bound"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",9,{"inputs":[{"name":"bound"}],"output":{"name":"bound"}}],[14,"vec!","","Creates a `Vec` containing the arguments.",null,null],[14,"format!","","Use the syntax described in `std::fmt` to create a value of type `String`.\nSee `std::fmt` for more information.",null,null],[11,"clone","collections::bit_vec","",249,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[11,"next","","",249,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",249,null],[11,"next_back","","",249,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"indexable","","",249,{"inputs":[{"name":"iter"}],"output":{"name":"usize"}}],[11,"idx","","",249,{"inputs":[{"name":"iter"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","collections::bit_set","",250,{"inputs":[{"name":"iter"}],"output":{"name":"setiter"}}],[11,"clone","","",251,{"inputs":[{"name":"union"}],"output":{"name":"union"}}],[11,"clone","","",252,{"inputs":[{"name":"intersection"}],"output":{"name":"intersection"}}],[11,"clone","","",253,{"inputs":[{"name":"difference"}],"output":{"name":"difference"}}],[11,"clone","","",254,{"inputs":[{"name":"symmetricdifference"}],"output":{"name":"symmetricdifference"}}],[11,"next","","",250,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",250,null],[11,"next","","",251,{"inputs":[{"name":"union"}],"output":{"name":"option"}}],[11,"size_hint","","",251,null],[11,"next","","",252,{"inputs":[{"name":"intersection"}],"output":{"name":"option"}}],[11,"size_hint","","",252,null],[11,"next","","",253,{"inputs":[{"name":"difference"}],"output":{"name":"option"}}],[11,"size_hint","","",253,null],[11,"next","","",254,{"inputs":[{"name":"symmetricdifference"}],"output":{"name":"option"}}],[11,"size_hint","","",254,null],[11,"clone","collections::btree_map","",255,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[11,"next","","",255,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",255,null],[11,"next_back","","",255,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"next","","",256,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"size_hint","","",256,null],[11,"next_back","","",256,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"next","","",257,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",257,null],[11,"next_back","","",257,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"clone","","",258,{"inputs":[{"name":"keys"}],"output":{"name":"keys"}}],[11,"next","","",258,{"inputs":[{"name":"keys"}],"output":{"name":"option"}}],[11,"size_hint","","",258,null],[11,"next_back","","",258,{"inputs":[{"name":"keys"}],"output":{"name":"option"}}],[11,"clone","","",259,{"inputs":[{"name":"values"}],"output":{"name":"values"}}],[11,"next","","",259,{"inputs":[{"name":"values"}],"output":{"name":"option"}}],[11,"size_hint","","",259,null],[11,"next_back","","",259,{"inputs":[{"name":"values"}],"output":{"name":"option"}}],[11,"clone","","",260,{"inputs":[{"name":"range"}],"output":{"name":"range"}}],[11,"next","","",260,{"inputs":[{"name":"range"}],"output":{"name":"option"}}],[11,"next_back","","",260,{"inputs":[{"name":"range"}],"output":{"name":"option"}}],[11,"next","","",261,{"inputs":[{"name":"rangemut"}],"output":{"name":"option"}}],[11,"next_back","","",261,{"inputs":[{"name":"rangemut"}],"output":{"name":"option"}}],[11,"get","","Returns a mutable reference to the entry if occupied, or the VacantEntry if vacant",248,{"inputs":[{"name":"entry"}],"output":{"name":"result"}}],[11,"or_insert","","Ensures a value is in the entry by inserting the default if empty, and returns\na mutable reference to the value in the entry.",248,{"inputs":[{"name":"entry"},{"name":"v"}],"output":{"name":"v"}}],[11,"or_insert_with","","Ensures a value is in the entry by inserting the result of the default function if empty,\nand returns a mutable reference to the value in the entry.",248,{"inputs":[{"name":"entry"},{"name":"f"}],"output":{"name":"v"}}],[11,"insert","","Sets the value of the entry with the VacantEntry's key,\nand returns a mutable reference to it.",262,{"inputs":[{"name":"vacantentry"},{"name":"v"}],"output":{"name":"v"}}],[11,"get","","Gets a reference to the value in the entry.",263,{"inputs":[{"name":"occupiedentry"}],"output":{"name":"v"}}],[11,"get_mut","","Gets a mutable reference to the value in the entry.",263,{"inputs":[{"name":"occupiedentry"}],"output":{"name":"v"}}],[11,"into_mut","","Converts the entry into a mutable reference to its value.",263,{"inputs":[{"name":"occupiedentry"}],"output":{"name":"v"}}],[11,"insert","","Sets the value of the entry with the OccupiedEntry's key,\nand returns the entry's old value.",263,{"inputs":[{"name":"occupiedentry"},{"name":"v"}],"output":{"name":"v"}}],[11,"remove","","Takes the value of the entry out of the map, and returns it.",263,{"inputs":[{"name":"occupiedentry"}],"output":{"name":"v"}}],[11,"clone","collections::btree_set","",264,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[11,"next","","",264,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",264,null],[11,"next_back","","",264,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"next","","",265,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",265,null],[11,"next_back","","",265,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"clone","","",266,{"inputs":[{"name":"range"}],"output":{"name":"range"}}],[11,"next","","",266,{"inputs":[{"name":"range"}],"output":{"name":"option"}}],[11,"next_back","","",266,{"inputs":[{"name":"range"}],"output":{"name":"option"}}],[11,"clone","","",267,{"inputs":[{"name":"difference"}],"output":{"name":"difference"}}],[11,"next","","",267,{"inputs":[{"name":"difference"}],"output":{"name":"option"}}],[11,"clone","","",268,{"inputs":[{"name":"symmetricdifference"}],"output":{"name":"symmetricdifference"}}],[11,"next","","",268,{"inputs":[{"name":"symmetricdifference"}],"output":{"name":"option"}}],[11,"clone","","",269,{"inputs":[{"name":"intersection"}],"output":{"name":"intersection"}}],[11,"next","","",269,{"inputs":[{"name":"intersection"}],"output":{"name":"option"}}],[11,"clone","","",270,{"inputs":[{"name":"union"}],"output":{"name":"union"}}],[11,"next","","",270,{"inputs":[{"name":"union"}],"output":{"name":"option"}}],[11,"borrow","collections::vec","",230,null],[11,"borrow_mut","","",230,null],[11,"borrow","collections::string","",225,{"inputs":[{"name":"string"}],"output":{"name":"str"}}]],"paths":[[3,"ExchangeHeapSingleton"],[3,"IntermediateBox"],[3,"Box"],[3,"Weak"],[3,"Arc"],[3,"Rc"],[3,"Weak"],[3,"RawVec"],[8,"FnBox"],[4,"Bound"],[3,"BinaryHeap"],[3,"Iter"],[3,"IntoIter"],[3,"Drain"],[3,"BitVec"],[3,"BitSet"],[3,"BTreeMap"],[3,"BTreeSet"],[4,"Cow"],[8,"Borrow"],[8,"BorrowMut"],[8,"ToOwned"],[8,"IntoCow"],[8,"CLike"],[3,"EnumSet"],[3,"Iter"],[3,"Formatter"],[3,"Wrapping"],[3,"Big32x36"],[3,"Big8x3"],[3,"Decoded"],[4,"FullDecoded"],[3,"Fp"],[4,"Part"],[3,"Formatted"],[4,"Sign"],[4,"FpCategory"],[3,"ParseIntError"],[4,"IntErrorKind"],[3,"ParseFloatError"],[4,"FloatErrorKind"],[3,"NonZero"],[3,"Unique"],[3,"NoCopy"],[3,"PhantomData"],[3,"RangeFull"],[3,"Range"],[3,"RangeFrom"],[3,"RangeTo"],[4,"Ordering"],[8,"Any"],[3,"TypeId"],[3,"AtomicBool"],[3,"AtomicIsize"],[3,"AtomicUsize"],[3,"AtomicPtr"],[4,"Ordering"],[3,"Cell"],[4,"BorrowState"],[3,"RefCell"],[3,"BorrowRef"],[3,"Ref"],[3,"RefMut"],[3,"BorrowRefMut"],[3,"UnsafeCell"],[3,"EscapeUnicode"],[4,"EscapeUnicodeState"],[3,"EscapeDefault"],[4,"EscapeDefaultState"],[3,"Rev"],[4,"MinMaxResult"],[3,"Cloned"],[3,"Cycle"],[3,"Chain"],[3,"Zip"],[3,"Map"],[3,"Filter"],[3,"FilterMap"],[3,"Enumerate"],[3,"Peekable"],[3,"SkipWhile"],[3,"TakeWhile"],[3,"Skip"],[3,"Take"],[3,"Scan"],[3,"FlatMap"],[3,"Fuse"],[3,"Inspect"],[3,"Unfold"],[3,"StepBy"],[3,"RangeInclusive"],[3,"Repeat"],[3,"Empty"],[3,"Once"],[4,"Option"],[3,"Item"],[3,"Iter"],[3,"IterMut"],[3,"IntoIter"],[3,"Slice"],[3,"TraitObject"],[4,"Result"],[3,"Iter"],[3,"IterMut"],[3,"IntoIter"],[3,"i8x16"],[3,"i16x8"],[3,"i32x4"],[3,"i64x2"],[3,"u8x16"],[3,"u16x8"],[3,"u32x4"],[3,"u64x2"],[3,"f32x4"],[3,"f64x2"],[3,"Iter"],[3,"IterMut"],[3,"Split"],[3,"SplitMut"],[3,"GenericSplitN"],[3,"SplitN"],[3,"RSplitN"],[3,"SplitNMut"],[3,"RSplitNMut"],[3,"Windows"],[3,"Chunks"],[3,"ChunksMut"],[4,"SearchStep"],[3,"CharEqSearcher"],[3,"CharEqPattern"],[3,"CharSearcher"],[3,"CharSliceSearcher"],[3,"CharPredicateSearcher"],[3,"StrSearcher"],[4,"StrSearcherImpl"],[3,"EmptyNeedle"],[3,"TwoWaySearcher"],[4,"MatchOnly"],[4,"RejectAndMatch"],[3,"ParseBoolError"],[3,"Utf8Error"],[3,"Chars"],[3,"CharIndices"],[3,"Bytes"],[3,"BytesDeref"],[3,"SplitInternal"],[3,"Split"],[3,"RSplit"],[3,"SplitTerminator"],[3,"RSplitTerminator"],[3,"SplitNInternal"],[3,"SplitN"],[3,"RSplitN"],[3,"MatchIndicesInternal"],[3,"MatchIndices"],[3,"RMatchIndices"],[3,"MatchesInternal"],[3,"Matches"],[3,"RMatches"],[3,"Lines"],[3,"LinesAny"],[3,"LinesAnyMap"],[3,"CharRange"],[3,"SipHasher"],[3,"Binary"],[3,"Octal"],[3,"Decimal"],[3,"LowerHex"],[3,"UpperHex"],[3,"Radix"],[3,"RadixFmt"],[3,"PadAdapter"],[3,"DebugStruct"],[3,"DebugTuple"],[3,"DebugInner"],[3,"DebugSet"],[3,"DebugList"],[3,"DebugMap"],[3,"Argument"],[3,"FormatSpec"],[4,"Alignment"],[4,"Count"],[4,"Position"],[3,"Error"],[4,"FlagV1"],[3,"Arguments"],[8,"Write"],[8,"Octal"],[8,"Binary"],[8,"Display"],[8,"Debug"],[8,"LowerHex"],[8,"UpperHex"],[8,"Pointer"],[8,"LowerExp"],[8,"UpperExp"],[3,"Iter"],[3,"IntoIter"],[3,"LinkedList"],[3,"IterMut"],[8,"RangeArgument"],[8,"IntSliceExt"],[8,"MutableByteVector"],[8,"SliceConcatExt"],[3,"ElementSwaps"],[3,"Permutations"],[8,"FromStr"],[4,"GraphemeCat"],[3,"GraphemeIndices"],[3,"Graphemes"],[4,"GraphemeState"],[3,"Utf16Items"],[4,"Utf16Item"],[3,"Utf16Encoder"],[3,"SplitWhitespace"],[3,"ToLowercase"],[3,"ToUppercase"],[4,"CaseMappingIter"],[8,"Pattern"],[8,"Searcher"],[8,"ReverseSearcher"],[3,"Decompositions"],[3,"Recompositions"],[3,"Utf16Units"],[8,"ToString"],[3,"String"],[3,"FromUtf8Error"],[3,"FromUtf16Error"],[3,"ParseError"],[3,"Drain"],[3,"Vec"],[3,"IntoIter"],[3,"Drain"],[3,"VecDeque"],[3,"Iter"],[3,"IterMut"],[3,"IntoIter"],[3,"Drain"],[4,"Entry"],[3,"VecMap"],[3,"VacantEntry"],[3,"OccupiedEntry"],[3,"Iter"],[3,"IterMut"],[3,"Keys"],[3,"Values"],[3,"Drain"],[3,"IntoIter"],[4,"Entry"],[3,"Iter"],[3,"Iter"],[3,"Union"],[3,"Intersection"],[3,"Difference"],[3,"SymmetricDifference"],[3,"Iter"],[3,"IterMut"],[3,"IntoIter"],[3,"Keys"],[3,"Values"],[3,"Range"],[3,"RangeMut"],[3,"VacantEntry"],[3,"OccupiedEntry"],[3,"Iter"],[3,"IntoIter"],[3,"Range"],[3,"Difference"],[3,"SymmetricDifference"],[3,"Intersection"],[3,"Union"]]};
searchIndex['alloc'] = {"items":[[0,"","alloc","# The Rust core allocation library",null,null],[5,"oom","","Common out-of-memory routine",null,{"inputs":[],"output":null}],[0,"heap","","",null,null],[5,"allocate","alloc::heap","Return a pointer to `size` bytes of memory aligned to `align`.",null,null],[5,"reallocate","","Resize the allocation referenced by `ptr` to `size` bytes.",null,null],[5,"reallocate_inplace","","Resize the allocation referenced by `ptr` to `size` bytes.",null,null],[5,"deallocate","","Deallocates the memory referenced by `ptr`.",null,null],[5,"usable_size","","Returns the usable size of an allocation created with the specified the\n`size` and `align`.",null,{"inputs":[{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[5,"stats_print","","Prints implementation-defined allocator statistics.",null,{"inputs":[],"output":null}],[17,"EMPTY","","An arbitrary non-null address to represent zero-size allocations.",null,null],[0,"boxed","alloc","A pointer type for heap allocation.",null,null],[3,"ExchangeHeapSingleton","alloc::boxed","This the singleton type used solely for `boxed::HEAP`.",null,null],[3,"Box","","A pointer type for heap allocation.",null,null],[3,"IntermediateBox","","`IntermediateBox` represents uninitialized backing storage for `Box`.",null,null],[5,"into_raw","","Consumes the `Box`, returning the wrapped raw pointer.",null,null],[17,"HEAP","","A value that represents the heap. This is the default place that the `box`\nkeyword allocates into when no place is supplied.",null,null],[8,"FnBox","","`FnBox` is a version of the `FnOnce` intended for use with boxed\nclosure objects. The idea is that where one would normally store a\n`Box<FnOnce()>` in a data structure, you should use\n`Box<FnBox()>`. The two traits behave essentially the same, except\nthat a `FnBox` closure can only be called if it is boxed. (Note\nthat `FnBox` may be deprecated in the future if `Box<FnOnce()>`\nclosures become directly usable.)",null,null],[16,"Output","","",0,null],[10,"call_box","","",0,{"inputs":[{"name":"fnbox"},{"name":"a"}],"output":{"name":"output"}}],[11,"clone","","",1,{"inputs":[{"name":"exchangeheapsingleton"}],"output":{"name":"exchangeheapsingleton"}}],[11,"pointer","","",2,null],[11,"make_place","","",2,{"inputs":[{"name":"intermediatebox"}],"output":{"name":"intermediatebox"}}],[11,"finalize","","",2,{"inputs":[{"name":"intermediatebox"}],"output":{"name":"box"}}],[11,"finalize","","",3,{"inputs":[{"name":"box"},{"name":"intermediatebox"}],"output":{"name":"box"}}],[11,"make_place","","",1,{"inputs":[{"name":"exchangeheapsingleton"}],"output":{"name":"intermediatebox"}}],[11,"drop","","",2,{"inputs":[{"name":"intermediatebox"}],"output":null}],[11,"new","","Allocates memory on the heap and then moves `x` into it.",3,{"inputs":[{"name":"box"},{"name":"t"}],"output":{"name":"box"}}],[11,"from_raw","","Constructs a box from the raw pointer.",3,null],[11,"into_raw","","Consumes the `Box`, returning the wrapped raw pointer.",3,null],[11,"default","","",3,{"inputs":[{"name":"box"}],"output":{"name":"box"}}],[11,"default","","",3,{"inputs":[{"name":"box"}],"output":{"name":"box"}}],[11,"clone","","Returns a new box with a `clone()` of this box's contents.",3,{"inputs":[{"name":"box"}],"output":{"name":"box"}}],[11,"clone_from","","Copies `source`'s contents into `self` without creating a new allocation.",3,{"inputs":[{"name":"box"},{"name":"box"}],"output":null}],[11,"clone","","",3,{"inputs":[{"name":"box"}],"output":{"name":"self"}}],[11,"eq","","",3,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"bool"}}],[11,"ne","","",3,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",3,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"option"}}],[11,"lt","","",3,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"bool"}}],[11,"le","","",3,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"bool"}}],[11,"ge","","",3,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"bool"}}],[11,"gt","","",3,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"bool"}}],[11,"cmp","","",3,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"ordering"}}],[11,"hash","","",3,{"inputs":[{"name":"box"},{"name":"h"}],"output":null}],[11,"downcast","","Attempt to downcast the box to a concrete type.",3,{"inputs":[{"name":"box"}],"output":{"name":"result"}}],[11,"downcast","","Attempt to downcast the box to a concrete type.",3,{"inputs":[{"name":"box"}],"output":{"name":"result"}}],[11,"fmt","","",3,{"inputs":[{"name":"box"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",3,{"inputs":[{"name":"box"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",3,{"inputs":[{"name":"box"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"deref","","",3,{"inputs":[{"name":"box"}],"output":{"name":"t"}}],[11,"deref_mut","","",3,{"inputs":[{"name":"box"}],"output":{"name":"t"}}],[11,"next","","",3,{"inputs":[{"name":"box"}],"output":{"name":"option"}}],[11,"size_hint","","",3,null],[11,"next_back","","",3,{"inputs":[{"name":"box"}],"output":{"name":"option"}}],[11,"call_once","","",3,{"inputs":[{"name":"box"},{"name":"a"}],"output":{"name":"r"}}],[11,"call_once","","",3,{"inputs":[{"name":"box"},{"name":"a"}],"output":{"name":"r"}}],[11,"clone","","",3,{"inputs":[{"name":"box"}],"output":{"name":"self"}}],[0,"arc","alloc","Threadsafe reference-counted boxes (the `Arc<T>` type).",null,null],[3,"Arc","alloc::arc","An atomically reference counted wrapper for shared state.",null,null],[3,"Weak","","A weak pointer to an `Arc`.",null,null],[5,"weak_count","","Get the number of weak references to this value.",null,{"inputs":[{"name":"arc"}],"output":{"name":"usize"}}],[5,"strong_count","","Get the number of strong references to this value.",null,{"inputs":[{"name":"arc"}],"output":{"name":"usize"}}],[5,"get_mut","","",null,{"inputs":[{"name":"arc"}],"output":{"name":"option"}}],[11,"fmt","","",4,{"inputs":[{"name":"weak"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","Constructs a new `Arc<T>`.",5,{"inputs":[{"name":"arc"},{"name":"t"}],"output":{"name":"arc"}}],[11,"downgrade","","Downgrades the `Arc<T>` to a `Weak<T>` reference.",5,{"inputs":[{"name":"arc"}],"output":{"name":"weak"}}],[11,"weak_count","","Get the number of weak references to this value.",5,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"usize"}}],[11,"strong_count","","Get the number of strong references to this value.",5,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"usize"}}],[11,"clone","","Makes a clone of the `Arc<T>`.",5,{"inputs":[{"name":"arc"}],"output":{"name":"arc"}}],[11,"deref","","",5,{"inputs":[{"name":"arc"}],"output":{"name":"t"}}],[11,"make_unique","","Make a mutable reference from the given `Arc<T>`.",5,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"t"}}],[11,"get_mut","","Returns a mutable reference to the contained value if the `Arc<T>` is unique.",5,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"option"}}],[11,"drop","","Drops the `Arc<T>`.",5,{"inputs":[{"name":"arc"}],"output":null}],[11,"upgrade","","Upgrades a weak reference to a strong reference.",4,{"inputs":[{"name":"weak"}],"output":{"name":"option"}}],[11,"clone","","Makes a clone of the `Weak<T>`.",4,{"inputs":[{"name":"weak"}],"output":{"name":"weak"}}],[11,"drop","","Drops the `Weak<T>`.",4,{"inputs":[{"name":"weak"}],"output":null}],[11,"eq","","Equality for two `Arc<T>`s.",5,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"bool"}}],[11,"ne","","Inequality for two `Arc<T>`s.",5,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"bool"}}],[11,"partial_cmp","","Partial comparison for two `Arc<T>`s.",5,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"option"}}],[11,"lt","","Less-than comparison for two `Arc<T>`s.",5,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"bool"}}],[11,"le","","'Less-than or equal to' comparison for two `Arc<T>`s.",5,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"bool"}}],[11,"gt","","Greater-than comparison for two `Arc<T>`s.",5,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"bool"}}],[11,"ge","","'Greater-than or equal to' comparison for two `Arc<T>`s.",5,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"bool"}}],[11,"cmp","","",5,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"ordering"}}],[11,"fmt","","",5,{"inputs":[{"name":"arc"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",5,{"inputs":[{"name":"arc"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",5,{"inputs":[{"name":"arc"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"default","","",5,{"inputs":[{"name":"arc"}],"output":{"name":"arc"}}],[11,"hash","","",5,{"inputs":[{"name":"arc"},{"name":"h"}],"output":null}],[0,"rc","alloc","Thread-local reference-counted boxes (the `Rc<T>` type).",null,null],[3,"Rc","alloc::rc","A reference-counted pointer type over an immutable value.",null,null],[3,"Weak","","A weak version of `Rc<T>`.",null,null],[5,"weak_count","","Get the number of weak references to this value.",null,{"inputs":[{"name":"rc"}],"output":{"name":"usize"}}],[5,"strong_count","","Get the number of strong references to this value.",null,{"inputs":[{"name":"rc"}],"output":{"name":"usize"}}],[5,"is_unique","","Returns true if there are no other `Rc` or `Weak<T>` values that share the\nsame inner value.",null,{"inputs":[{"name":"rc"}],"output":{"name":"bool"}}],[5,"try_unwrap","","Unwraps the contained value if the `Rc<T>` is unique.",null,{"inputs":[{"name":"rc"}],"output":{"name":"result"}}],[5,"get_mut","","Returns a mutable reference to the contained value if the `Rc<T>` is unique.",null,{"inputs":[{"name":"rc"}],"output":{"name":"option"}}],[11,"new","","Constructs a new `Rc<T>`.",6,{"inputs":[{"name":"rc"},{"name":"t"}],"output":{"name":"rc"}}],[11,"try_unwrap","","Unwraps the contained value if the `Rc<T>` is unique.",6,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"result"}}],[11,"downgrade","","Downgrades the `Rc<T>` to a `Weak<T>` reference.",6,{"inputs":[{"name":"rc"}],"output":{"name":"weak"}}],[11,"weak_count","","Get the number of weak references to this value.",6,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"usize"}}],[11,"strong_count","","Get the number of strong references to this value.",6,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"usize"}}],[11,"is_unique","","Returns true if there are no other `Rc` or `Weak<T>` values that share\nthe same inner value.",6,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"get_mut","","Returns a mutable reference to the contained value if the `Rc<T>` is\nunique.",6,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"option"}}],[11,"make_unique","","Make a mutable reference from the given `Rc<T>`.",6,{"inputs":[{"name":"rc"}],"output":{"name":"t"}}],[11,"deref","","",6,{"inputs":[{"name":"rc"}],"output":{"name":"t"}}],[11,"drop","","Drops the `Rc<T>`.",6,{"inputs":[{"name":"rc"}],"output":null}],[11,"clone","","Makes a clone of the `Rc<T>`.",6,{"inputs":[{"name":"rc"}],"output":{"name":"rc"}}],[11,"default","","Creates a new `Rc<T>`, with the `Default` value for `T`.",6,{"inputs":[{"name":"rc"}],"output":{"name":"rc"}}],[11,"eq","","Equality for two `Rc<T>`s.",6,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"ne","","Inequality for two `Rc<T>`s.",6,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"partial_cmp","","Partial comparison for two `Rc<T>`s.",6,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"option"}}],[11,"lt","","Less-than comparison for two `Rc<T>`s.",6,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"le","","'Less-than or equal to' comparison for two `Rc<T>`s.",6,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"gt","","Greater-than comparison for two `Rc<T>`s.",6,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"ge","","'Greater-than or equal to' comparison for two `Rc<T>`s.",6,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"cmp","","Comparison for two `Rc<T>`s.",6,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"ordering"}}],[11,"hash","","",6,{"inputs":[{"name":"rc"},{"name":"h"}],"output":null}],[11,"fmt","","",6,{"inputs":[{"name":"rc"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",6,{"inputs":[{"name":"rc"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",6,{"inputs":[{"name":"rc"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"upgrade","","Upgrades a weak reference to a strong reference.",7,{"inputs":[{"name":"weak"}],"output":{"name":"option"}}],[11,"drop","","Drops the `Weak<T>`.",7,{"inputs":[{"name":"weak"}],"output":null}],[11,"clone","","Makes a clone of the `Weak<T>`.",7,{"inputs":[{"name":"weak"}],"output":{"name":"weak"}}],[11,"fmt","","",7,{"inputs":[{"name":"weak"},{"name":"formatter"}],"output":{"name":"result"}}],[0,"raw_vec","alloc","",null,null],[3,"RawVec","alloc::raw_vec","A low-level utility for more ergonomically allocating, reallocating, and deallocating a\na buffer of memory on the heap without having to worry about all the corner cases\ninvolved. This type is excellent for building your own data structures like Vec and VecDeque.\nIn particular:",null,null],[11,"new","","Creates the biggest possible RawVec without allocating. If T has positive\nsize, then this makes a RawVec with capacity 0. If T has 0 size, then it\nit makes a RawVec with capacity `usize::MAX`. Useful for implementing\ndelayed allocation.",8,{"inputs":[{"name":"rawvec"}],"output":{"name":"self"}}],[11,"with_capacity","","Creates a RawVec with exactly the capacity and alignment requirements\nfor a `[T; cap]`. This is equivalent to calling RawVec::new when `cap` is 0\nor T is zero-sized. Note that if `T` is zero-sized this means you will *not*\nget a RawVec with the requested capacity!",8,{"inputs":[{"name":"rawvec"},{"name":"usize"}],"output":{"name":"self"}}],[11,"from_raw_parts","","Reconstitutes a RawVec from a pointer and capacity.",8,null],[11,"from_box","","Converts a `Box<[T]>` into a `RawVec<T>`.",8,{"inputs":[{"name":"rawvec"},{"name":"box"}],"output":{"name":"self"}}],[11,"ptr","","Gets a raw pointer to the start of the allocation. Note that this is\nheap::EMPTY if `cap = 0` or T is zero-sized. In the former case, you must\nbe careful.",8,null],[11,"cap","","Gets the capacity of the allocation.",8,{"inputs":[{"name":"rawvec"}],"output":{"name":"usize"}}],[11,"double","","Doubles the size of the type's backing allocation. This is common enough\nto want to do that it's easiest to just have a dedicated method. Slightly\nmore efficient logic can be provided for this than the general case.",8,{"inputs":[{"name":"rawvec"}],"output":null}],[11,"reserve_exact","","Ensures that the buffer contains at least enough space to hold\n`used_cap + needed_extra_cap` elements. If it doesn't already,\nwill reallocate the minimum possible amount of memory necessary.\nGenerally this will be exactly the amount of memory necessary,\nbut in principle the allocator is free to give back more than\nwe asked for.",8,{"inputs":[{"name":"rawvec"},{"name":"usize"},{"name":"usize"}],"output":null}],[11,"reserve","","Ensures that the buffer contains at least enough space to hold\n`used_cap + needed_extra_cap` elements. If it doesn't already have\nenough capacity, will reallocate enough space plus comfortable slack\nspace to get amortized `O(1)` behaviour. Will limit this behaviour\nif it would needlessly cause itself to panic.",8,{"inputs":[{"name":"rawvec"},{"name":"usize"},{"name":"usize"}],"output":null}],[11,"shrink_to_fit","","Shrinks the allocation down to the specified amount. If the given amount\nis 0, actually completely deallocates.",8,{"inputs":[{"name":"rawvec"},{"name":"usize"}],"output":null}],[11,"into_box","","Converts the entire buffer into `Box<[T]>`.",8,{"inputs":[{"name":"rawvec"}],"output":{"name":"box"}}],[11,"unsafe_no_drop_flag_needs_drop","","This is a stupid name in the hopes that someone will find this in the\nnot too distant future and remove it with the rest of\n#[unsafe_no_drop_flag]",8,{"inputs":[{"name":"rawvec"}],"output":{"name":"bool"}}],[11,"drop","","Frees the memory owned by the RawVec *without* trying to Drop its contents.",8,{"inputs":[{"name":"rawvec"}],"output":null}]],"paths":[[8,"FnBox"],[3,"ExchangeHeapSingleton"],[3,"IntermediateBox"],[3,"Box"],[3,"Weak"],[3,"Arc"],[3,"Rc"],[3,"Weak"],[3,"RawVec"]]};
searchIndex['std'] = {"items":[[0,"","std","# The Rust Standard Library",null,null],[0,"any","","This module implements the `Any` trait, which enables dynamic typing\nof any `'static` type through runtime reflection.",null,null],[8,"Any","std::any","A type to emulate dynamic typing.",null,null],[10,"get_type_id","","Gets the `TypeId` of `self`.",0,{"inputs":[{"name":"any"}],"output":{"name":"typeid"}}],[11,"of","core::any","Returns the `TypeId` of the type this generic function has been\ninstantiated with",1,{"inputs":[{"name":"typeid"}],"output":{"name":"typeid"}}],[11,"fmt","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",2,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"cmp","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"option"}}],[11,"lt","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"le","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"gt","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"ge","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"eq","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"ne","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"shl","","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shr","","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shl","","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shr","","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shl","","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shr","","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shl","","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shr","","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shl","","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shr","","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shl","","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shr","","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shl","","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shr","","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shl","","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shr","","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shl","","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shr","","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shl","","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shr","","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"add","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"sub","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"mul","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"div","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"not","","",2,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitxor","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitor","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitand","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"add","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"sub","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"mul","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"div","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"not","","",2,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitxor","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitor","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitand","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"add","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"sub","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"mul","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"div","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"not","","",2,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitxor","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitor","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitand","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"add","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"sub","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"mul","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"div","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"not","","",2,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitxor","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitor","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitand","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"add","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"sub","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"mul","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"div","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"not","","",2,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitxor","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitor","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitand","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"add","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"sub","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"mul","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"div","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"not","","",2,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitxor","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitor","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitand","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"add","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"sub","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"mul","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"div","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"not","","",2,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitxor","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitor","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitand","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"add","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"sub","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"mul","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"div","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"not","","",2,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitxor","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitor","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitand","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"add","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"sub","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"mul","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"div","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"not","","",2,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitxor","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitor","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitand","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"add","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"sub","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"mul","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"div","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"not","","",2,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitxor","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitor","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitand","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"from_small","core::num::flt2dec::bignum","Makes a bignum from one digit.",3,{"inputs":[{"name":"big32x36"},{"name":"u32"}],"output":{"name":"big32x36"}}],[11,"from_u64","","Makes a bignum from `u64` value.",3,{"inputs":[{"name":"big32x36"},{"name":"u64"}],"output":{"name":"big32x36"}}],[11,"is_zero","","Returns true if the bignum is zero.",3,{"inputs":[{"name":"big32x36"}],"output":{"name":"bool"}}],[11,"add","","Adds `other` to itself and returns its own mutable reference.",3,{"inputs":[{"name":"big32x36"},{"name":"big32x36"}],"output":{"name":"big32x36"}}],[11,"sub","","Subtracts `other` from itself and returns its own mutable reference.",3,{"inputs":[{"name":"big32x36"},{"name":"big32x36"}],"output":{"name":"big32x36"}}],[11,"mul_small","","Multiplies itself by a digit-sized `other` and returns its own\nmutable reference.",3,{"inputs":[{"name":"big32x36"},{"name":"u32"}],"output":{"name":"big32x36"}}],[11,"mul_pow2","","Multiplies itself by `2^bits` and returns its own mutable reference.",3,{"inputs":[{"name":"big32x36"},{"name":"usize"}],"output":{"name":"big32x36"}}],[11,"mul_digits","","Multiplies itself by a number described by `other[0] + other[1] * 2^W +\nother[2] * 2^(2W) + ...` (where `W` is the number of bits in the digit type)\nand returns its own mutable reference.",3,null],[11,"div_rem_small","","Divides itself by a digit-sized `other` and returns its own\nmutable reference *and* the remainder.",3,null],[11,"eq","","",3,{"inputs":[{"name":"big32x36"},{"name":"big32x36"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",3,{"inputs":[{"name":"big32x36"},{"name":"big32x36"}],"output":{"name":"option"}}],[11,"cmp","","",3,{"inputs":[{"name":"big32x36"},{"name":"big32x36"}],"output":{"name":"ordering"}}],[11,"clone","","",3,{"inputs":[{"name":"big32x36"}],"output":{"name":"big32x36"}}],[11,"fmt","","",3,{"inputs":[{"name":"big32x36"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from_small","core::num::flt2dec::bignum::tests","Makes a bignum from one digit.",4,{"inputs":[{"name":"big8x3"},{"name":"u8"}],"output":{"name":"big8x3"}}],[11,"from_u64","","Makes a bignum from `u64` value.",4,{"inputs":[{"name":"big8x3"},{"name":"u64"}],"output":{"name":"big8x3"}}],[11,"is_zero","","Returns true if the bignum is zero.",4,{"inputs":[{"name":"big8x3"}],"output":{"name":"bool"}}],[11,"add","","Adds `other` to itself and returns its own mutable reference.",4,{"inputs":[{"name":"big8x3"},{"name":"big8x3"}],"output":{"name":"big8x3"}}],[11,"sub","","Subtracts `other` from itself and returns its own mutable reference.",4,{"inputs":[{"name":"big8x3"},{"name":"big8x3"}],"output":{"name":"big8x3"}}],[11,"mul_small","","Multiplies itself by a digit-sized `other` and returns its own\nmutable reference.",4,{"inputs":[{"name":"big8x3"},{"name":"u8"}],"output":{"name":"big8x3"}}],[11,"mul_pow2","","Multiplies itself by `2^bits` and returns its own mutable reference.",4,{"inputs":[{"name":"big8x3"},{"name":"usize"}],"output":{"name":"big8x3"}}],[11,"mul_digits","","Multiplies itself by a number described by `other[0] + other[1] * 2^W +\nother[2] * 2^(2W) + ...` (where `W` is the number of bits in the digit type)\nand returns its own mutable reference.",4,null],[11,"div_rem_small","","Divides itself by a digit-sized `other` and returns its own\nmutable reference *and* the remainder.",4,null],[11,"eq","","",4,{"inputs":[{"name":"big8x3"},{"name":"big8x3"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",4,{"inputs":[{"name":"big8x3"},{"name":"big8x3"}],"output":{"name":"option"}}],[11,"cmp","","",4,{"inputs":[{"name":"big8x3"},{"name":"big8x3"}],"output":{"name":"ordering"}}],[11,"clone","","",4,{"inputs":[{"name":"big8x3"}],"output":{"name":"big8x3"}}],[11,"fmt","","",4,{"inputs":[{"name":"big8x3"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","core::num::flt2dec::decoder","",5,{"inputs":[{"name":"decoded"},{"name":"decoded"}],"output":{"name":"bool"}}],[11,"ne","","",5,{"inputs":[{"name":"decoded"},{"name":"decoded"}],"output":{"name":"bool"}}],[11,"fmt","","",5,{"inputs":[{"name":"decoded"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",5,{"inputs":[{"name":"decoded"}],"output":{"name":"decoded"}}],[11,"eq","","",6,{"inputs":[{"name":"fulldecoded"},{"name":"fulldecoded"}],"output":{"name":"bool"}}],[11,"ne","","",6,{"inputs":[{"name":"fulldecoded"},{"name":"fulldecoded"}],"output":{"name":"bool"}}],[11,"fmt","","",6,{"inputs":[{"name":"fulldecoded"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",6,{"inputs":[{"name":"fulldecoded"}],"output":{"name":"fulldecoded"}}],[11,"fmt","core::num::flt2dec::strategy::grisu","",7,{"inputs":[{"name":"fp"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",7,{"inputs":[{"name":"fp"}],"output":{"name":"fp"}}],[11,"fmt","core::num::flt2dec","",8,{"inputs":[{"name":"part"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",8,{"inputs":[{"name":"part"},{"name":"part"}],"output":{"name":"bool"}}],[11,"ne","","",8,{"inputs":[{"name":"part"},{"name":"part"}],"output":{"name":"bool"}}],[11,"clone","","",8,{"inputs":[{"name":"part"}],"output":{"name":"part"}}],[11,"len","","Returns the exact byte length of given part.",8,{"inputs":[{"name":"part"}],"output":{"name":"usize"}}],[11,"write","","Writes a part into the supplied buffer.\nReturns the number of written bytes, or `None` if the buffer is not enough.\n(It may still leave partially written bytes in the buffer; do not rely on that.)",8,null],[11,"clone","","",9,{"inputs":[{"name":"formatted"}],"output":{"name":"formatted"}}],[11,"len","","Returns the exact byte length of combined formatted result.",9,{"inputs":[{"name":"formatted"}],"output":{"name":"usize"}}],[11,"write","","Writes all formatted parts into the supplied buffer.\nReturns the number of written bytes, or `None` if the buffer is not enough.\n(It may still leave partially written bytes in the buffer; do not rely on that.)",9,null],[11,"fmt","","",10,{"inputs":[{"name":"sign"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",10,{"inputs":[{"name":"sign"},{"name":"sign"}],"output":{"name":"bool"}}],[11,"ne","","",10,{"inputs":[{"name":"sign"},{"name":"sign"}],"output":{"name":"bool"}}],[11,"clone","","",10,{"inputs":[{"name":"sign"}],"output":{"name":"sign"}}],[11,"fmt","core::num","",11,{"inputs":[{"name":"fpcategory"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",11,{"inputs":[{"name":"fpcategory"},{"name":"fpcategory"}],"output":{"name":"bool"}}],[11,"ne","","",11,{"inputs":[{"name":"fpcategory"},{"name":"fpcategory"}],"output":{"name":"bool"}}],[11,"clone","","",11,{"inputs":[{"name":"fpcategory"}],"output":{"name":"fpcategory"}}],[11,"eq","","",12,{"inputs":[{"name":"parseinterror"},{"name":"parseinterror"}],"output":{"name":"bool"}}],[11,"ne","","",12,{"inputs":[{"name":"parseinterror"},{"name":"parseinterror"}],"output":{"name":"bool"}}],[11,"clone","","",12,{"inputs":[{"name":"parseinterror"}],"output":{"name":"parseinterror"}}],[11,"fmt","","",12,{"inputs":[{"name":"parseinterror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",13,{"inputs":[{"name":"interrorkind"},{"name":"interrorkind"}],"output":{"name":"bool"}}],[11,"ne","","",13,{"inputs":[{"name":"interrorkind"},{"name":"interrorkind"}],"output":{"name":"bool"}}],[11,"clone","","",13,{"inputs":[{"name":"interrorkind"}],"output":{"name":"interrorkind"}}],[11,"fmt","","",13,{"inputs":[{"name":"interrorkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",12,{"inputs":[{"name":"parseinterror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",14,{"inputs":[{"name":"parsefloaterror"},{"name":"parsefloaterror"}],"output":{"name":"bool"}}],[11,"ne","","",14,{"inputs":[{"name":"parsefloaterror"},{"name":"parsefloaterror"}],"output":{"name":"bool"}}],[11,"clone","","",14,{"inputs":[{"name":"parsefloaterror"}],"output":{"name":"parsefloaterror"}}],[11,"fmt","","",14,{"inputs":[{"name":"parsefloaterror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",15,{"inputs":[{"name":"floaterrorkind"},{"name":"floaterrorkind"}],"output":{"name":"bool"}}],[11,"ne","","",15,{"inputs":[{"name":"floaterrorkind"},{"name":"floaterrorkind"}],"output":{"name":"bool"}}],[11,"clone","","",15,{"inputs":[{"name":"floaterrorkind"}],"output":{"name":"floaterrorkind"}}],[11,"fmt","","",15,{"inputs":[{"name":"floaterrorkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",14,{"inputs":[{"name":"parsefloaterror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","core::nonzero","",16,null],[11,"fmt","","",16,{"inputs":[{"name":"nonzero"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"partial_cmp","","",16,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"option"}}],[11,"lt","","",16,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"le","","",16,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"gt","","",16,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"ge","","",16,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"cmp","","",16,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"ordering"}}],[11,"eq","","",16,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"ne","","",16,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"clone","","",16,{"inputs":[{"name":"nonzero"}],"output":{"name":"nonzero"}}],[11,"new","","Creates an instance of NonZero with the provided value.\nYou must indeed ensure that the value is actually \"non-zero\".",16,{"inputs":[{"name":"nonzero"},{"name":"t"}],"output":{"name":"nonzero"}}],[11,"deref","","",16,{"inputs":[{"name":"nonzero"}],"output":{"name":"t"}}],[11,"new","core::ptr","Creates a new `Unique`.",17,null],[11,"get","","Dereferences the content.",17,{"inputs":[{"name":"unique"}],"output":{"name":"t"}}],[11,"get_mut","","Mutably dereferences the content.",17,{"inputs":[{"name":"unique"}],"output":{"name":"t"}}],[11,"deref","","",17,null],[11,"fmt","","",17,{"inputs":[{"name":"unique"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"cmp","core::marker","",18,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",18,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"option"}}],[11,"lt","","",18,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"le","","",18,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"gt","","",18,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"ge","","",18,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"eq","","",18,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"ne","","",18,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"clone","","",18,{"inputs":[{"name":"nocopy"}],"output":{"name":"nocopy"}}],[11,"hash","","",19,null],[11,"eq","","",19,{"inputs":[{"name":"phantomdata"},{"name":"phantomdata"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",19,{"inputs":[{"name":"phantomdata"},{"name":"phantomdata"}],"output":{"name":"option"}}],[11,"cmp","","",19,{"inputs":[{"name":"phantomdata"},{"name":"phantomdata"}],"output":{"name":"ordering"}}],[11,"clone","","",19,{"inputs":[{"name":"phantomdata"}],"output":{"name":"phantomdata"}}],[11,"eq","core::ops","",20,{"inputs":[{"name":"rangefull"},{"name":"rangefull"}],"output":{"name":"bool"}}],[11,"ne","","",20,{"inputs":[{"name":"rangefull"},{"name":"rangefull"}],"output":{"name":"bool"}}],[11,"clone","","",20,{"inputs":[{"name":"rangefull"}],"output":{"name":"rangefull"}}],[11,"fmt","","",20,{"inputs":[{"name":"rangefull"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",21,{"inputs":[{"name":"range"},{"name":"range"}],"output":{"name":"bool"}}],[11,"ne","","",21,{"inputs":[{"name":"range"},{"name":"range"}],"output":{"name":"bool"}}],[11,"clone","","",21,{"inputs":[{"name":"range"}],"output":{"name":"range"}}],[11,"fmt","","",21,{"inputs":[{"name":"range"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",22,{"inputs":[{"name":"rangefrom"},{"name":"rangefrom"}],"output":{"name":"bool"}}],[11,"ne","","",22,{"inputs":[{"name":"rangefrom"},{"name":"rangefrom"}],"output":{"name":"bool"}}],[11,"clone","","",22,{"inputs":[{"name":"rangefrom"}],"output":{"name":"rangefrom"}}],[11,"fmt","","",22,{"inputs":[{"name":"rangefrom"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",23,{"inputs":[{"name":"rangeto"},{"name":"rangeto"}],"output":{"name":"bool"}}],[11,"ne","","",23,{"inputs":[{"name":"rangeto"},{"name":"rangeto"}],"output":{"name":"bool"}}],[11,"clone","","",23,{"inputs":[{"name":"rangeto"}],"output":{"name":"rangeto"}}],[11,"fmt","","",23,{"inputs":[{"name":"rangeto"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","core::cmp","",24,{"inputs":[{"name":"ordering"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",24,{"inputs":[{"name":"ordering"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"ne","","",24,{"inputs":[{"name":"ordering"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"clone","","",24,{"inputs":[{"name":"ordering"}],"output":{"name":"ordering"}}],[11,"reverse","","Reverse the `Ordering`.",24,{"inputs":[{"name":"ordering"}],"output":{"name":"ordering"}}],[11,"cmp","","",24,{"inputs":[{"name":"ordering"},{"name":"ordering"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",24,{"inputs":[{"name":"ordering"},{"name":"ordering"}],"output":{"name":"option"}}],[11,"fmt","std","",0,{"inputs":[{"name":"any"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",0,{"inputs":[{"name":"any"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"is","","Returns true if the boxed type is the same as `T`",0,{"inputs":[{"name":"any"}],"output":{"name":"bool"}}],[11,"downcast_ref","","Returns some reference to the boxed value if it is of type `T`, or\n`None` if it isn't.",0,{"inputs":[{"name":"any"}],"output":{"name":"option"}}],[11,"downcast_mut","","Returns some mutable reference to the boxed value if it is of type `T`, or\n`None` if it isn't.",0,{"inputs":[{"name":"any"}],"output":{"name":"option"}}],[11,"is","","Forwards to the method defined on the type `Any`.",0,{"inputs":[{"name":"any"}],"output":{"name":"bool"}}],[11,"downcast_ref","","Forwards to the method defined on the type `Any`.",0,{"inputs":[{"name":"any"}],"output":{"name":"option"}}],[11,"downcast_mut","","Forwards to the method defined on the type `Any`.",0,{"inputs":[{"name":"any"}],"output":{"name":"option"}}],[11,"hash","core::any","",1,null],[11,"fmt","","",1,{"inputs":[{"name":"typeid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",1,{"inputs":[{"name":"typeid"},{"name":"typeid"}],"output":{"name":"bool"}}],[11,"ne","","",1,{"inputs":[{"name":"typeid"},{"name":"typeid"}],"output":{"name":"bool"}}],[11,"clone","","",1,{"inputs":[{"name":"typeid"}],"output":{"name":"typeid"}}],[11,"default","core::atomic","",25,{"inputs":[{"name":"atomicbool"}],"output":{"name":"atomicbool"}}],[11,"default","","",26,{"inputs":[{"name":"atomicisize"}],"output":{"name":"atomicisize"}}],[11,"default","","",27,{"inputs":[{"name":"atomicusize"}],"output":{"name":"atomicusize"}}],[11,"default","","",28,{"inputs":[{"name":"atomicptr"}],"output":{"name":"atomicptr"}}],[11,"clone","","",29,{"inputs":[{"name":"ordering"}],"output":{"name":"ordering"}}],[11,"new","","Creates a new `AtomicBool`.",25,{"inputs":[{"name":"atomicbool"},{"name":"bool"}],"output":{"name":"atomicbool"}}],[11,"load","","Loads a value from the bool.",25,{"inputs":[{"name":"atomicbool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"store","","Stores a value into the bool.",25,null],[11,"swap","","Stores a value into the bool, returning the old value.",25,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"compare_and_swap","","Stores a value into the `bool` if the current value is the same as the `current` value.",25,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"fetch_and","","Logical \"and\" with a boolean value.",25,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"fetch_nand","","Logical \"nand\" with a boolean value.",25,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"fetch_or","","Logical \"or\" with a boolean value.",25,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"fetch_xor","","Logical \"xor\" with a boolean value.",25,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"new","","Creates a new `AtomicIsize`.",26,{"inputs":[{"name":"atomicisize"},{"name":"isize"}],"output":{"name":"atomicisize"}}],[11,"load","","Loads a value from the isize.",26,{"inputs":[{"name":"atomicisize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"store","","Stores a value into the isize.",26,null],[11,"swap","","Stores a value into the isize, returning the old value.",26,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"compare_and_swap","","Stores a value into the `isize` if the current value is the same as the `current` value.",26,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"fetch_add","","Add an isize to the current value, returning the previous value.",26,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"fetch_sub","","Subtract an isize from the current value, returning the previous value.",26,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"fetch_and","","Bitwise and with the current isize, returning the previous value.",26,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"fetch_or","","Bitwise or with the current isize, returning the previous value.",26,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"fetch_xor","","Bitwise xor with the current isize, returning the previous value.",26,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"new","","Creates a new `AtomicUsize`.",27,{"inputs":[{"name":"atomicusize"},{"name":"usize"}],"output":{"name":"atomicusize"}}],[11,"load","","Loads a value from the usize.",27,{"inputs":[{"name":"atomicusize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"store","","Stores a value into the usize.",27,null],[11,"swap","","Stores a value into the usize, returning the old value.",27,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"compare_and_swap","","Stores a value into the `usize` if the current value is the same as the `current` value.",27,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"fetch_add","","Add to the current usize, returning the previous value.",27,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"fetch_sub","","Subtract from the current usize, returning the previous value.",27,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"fetch_and","","Bitwise and with the current usize, returning the previous value.",27,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"fetch_or","","Bitwise or with the current usize, returning the previous value.",27,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"fetch_xor","","Bitwise xor with the current usize, returning the previous value.",27,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"new","","Creates a new `AtomicPtr`.",28,null],[11,"load","","Loads a value from the pointer.",28,null],[11,"store","","Stores a value into the pointer.",28,null],[11,"swap","","Stores a value into the pointer, returning the old value.",28,null],[11,"compare_and_swap","","Stores a value into the pointer if the current value is the same as the `current` value.",28,null],[11,"fmt","","",27,{"inputs":[{"name":"atomicusize"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",26,{"inputs":[{"name":"atomicisize"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",25,{"inputs":[{"name":"atomicbool"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",28,{"inputs":[{"name":"atomicptr"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","core::cell","Creates a new `Cell` containing the given value.",30,{"inputs":[{"name":"cell"},{"name":"t"}],"output":{"name":"cell"}}],[11,"get","","Returns a copy of the contained value.",30,{"inputs":[{"name":"cell"}],"output":{"name":"t"}}],[11,"set","","Sets the contained value.",30,null],[11,"as_unsafe_cell","","Returns a reference to the underlying `UnsafeCell`.",30,{"inputs":[{"name":"cell"}],"output":{"name":"unsafecell"}}],[11,"clone","","",30,{"inputs":[{"name":"cell"}],"output":{"name":"cell"}}],[11,"default","","",30,{"inputs":[{"name":"cell"}],"output":{"name":"cell"}}],[11,"eq","","",30,{"inputs":[{"name":"cell"},{"name":"cell"}],"output":{"name":"bool"}}],[11,"fmt","","",31,{"inputs":[{"name":"borrowstate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",31,{"inputs":[{"name":"borrowstate"},{"name":"borrowstate"}],"output":{"name":"bool"}}],[11,"ne","","",31,{"inputs":[{"name":"borrowstate"},{"name":"borrowstate"}],"output":{"name":"bool"}}],[11,"clone","","",31,{"inputs":[{"name":"borrowstate"}],"output":{"name":"borrowstate"}}],[11,"new","","Creates a new `RefCell` containing `value`.",32,{"inputs":[{"name":"refcell"},{"name":"t"}],"output":{"name":"refcell"}}],[11,"into_inner","","Consumes the `RefCell`, returning the wrapped value.",32,{"inputs":[{"name":"refcell"}],"output":{"name":"t"}}],[11,"borrow_state","","Query the current state of this `RefCell`",32,{"inputs":[{"name":"refcell"}],"output":{"name":"borrowstate"}}],[11,"borrow","","Immutably borrows the wrapped value.",32,{"inputs":[{"name":"refcell"}],"output":{"name":"ref"}}],[11,"borrow_mut","","Mutably borrows the wrapped value.",32,{"inputs":[{"name":"refcell"}],"output":{"name":"refmut"}}],[11,"as_unsafe_cell","","Returns a reference to the underlying `UnsafeCell`.",32,{"inputs":[{"name":"refcell"}],"output":{"name":"unsafecell"}}],[11,"clone","","",32,{"inputs":[{"name":"refcell"}],"output":{"name":"refcell"}}],[11,"default","","",32,{"inputs":[{"name":"refcell"}],"output":{"name":"refcell"}}],[11,"eq","","",32,{"inputs":[{"name":"refcell"},{"name":"refcell"}],"output":{"name":"bool"}}],[11,"drop","","",33,null],[11,"clone","","",33,{"inputs":[{"name":"borrowref"}],"output":{"name":"borrowref"}}],[11,"deref","","",34,{"inputs":[{"name":"ref"}],"output":{"name":"t"}}],[11,"clone","","Copies a `Ref`.",34,{"inputs":[{"name":"ref"},{"name":"ref"}],"output":{"name":"ref"}}],[11,"map","","Make a new `Ref` for a component of the borrowed data.",34,{"inputs":[{"name":"ref"},{"name":"ref"},{"name":"f"}],"output":{"name":"ref"}}],[11,"filter_map","","Make a new `Ref` for a optional component of the borrowed data, e.g. an\nenum variant.",34,{"inputs":[{"name":"ref"},{"name":"ref"},{"name":"f"}],"output":{"name":"option"}}],[11,"map","","Make a new `RefMut` for a component of the borrowed data, e.g. an enum\nvariant.",35,{"inputs":[{"name":"refmut"},{"name":"refmut"},{"name":"f"}],"output":{"name":"refmut"}}],[11,"filter_map","","Make a new `RefMut` for a optional component of the borrowed data, e.g.\nan enum variant.",35,{"inputs":[{"name":"refmut"},{"name":"refmut"},{"name":"f"}],"output":{"name":"option"}}],[11,"drop","","",36,null],[11,"deref","","",35,{"inputs":[{"name":"refmut"}],"output":{"name":"t"}}],[11,"deref_mut","","",35,{"inputs":[{"name":"refmut"}],"output":{"name":"t"}}],[11,"new","","Constructs a new instance of `UnsafeCell` which will wrap the specified\nvalue.",37,{"inputs":[{"name":"unsafecell"},{"name":"t"}],"output":{"name":"unsafecell"}}],[11,"into_inner","","Unwraps the value.",37,{"inputs":[{"name":"unsafecell"}],"output":{"name":"t"}}],[11,"get","","Gets a mutable pointer to the wrapped value.",37,null],[11,"clone","core::char","",38,{"inputs":[{"name":"escapeunicode"}],"output":{"name":"escapeunicode"}}],[11,"clone","","",39,{"inputs":[{"name":"escapeunicodestate"}],"output":{"name":"escapeunicodestate"}}],[11,"next","","",38,{"inputs":[{"name":"escapeunicode"}],"output":{"name":"option"}}],[11,"clone","","",40,{"inputs":[{"name":"escapedefault"}],"output":{"name":"escapedefault"}}],[11,"clone","","",41,{"inputs":[{"name":"escapedefaultstate"}],"output":{"name":"escapedefaultstate"}}],[11,"next","","",40,{"inputs":[{"name":"escapedefault"}],"output":{"name":"option"}}],[11,"clone","core::iter","",42,{"inputs":[{"name":"rev"}],"output":{"name":"rev"}}],[11,"next","","",42,{"inputs":[{"name":"rev"}],"output":{"name":"option"}}],[11,"size_hint","","",42,null],[11,"next_back","","",42,{"inputs":[{"name":"rev"}],"output":{"name":"option"}}],[11,"indexable","","",42,{"inputs":[{"name":"rev"}],"output":{"name":"usize"}}],[11,"idx","","",42,{"inputs":[{"name":"rev"},{"name":"usize"}],"output":{"name":"option"}}],[11,"fmt","","",43,{"inputs":[{"name":"minmaxresult"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",43,{"inputs":[{"name":"minmaxresult"},{"name":"minmaxresult"}],"output":{"name":"bool"}}],[11,"ne","","",43,{"inputs":[{"name":"minmaxresult"},{"name":"minmaxresult"}],"output":{"name":"bool"}}],[11,"clone","","",43,{"inputs":[{"name":"minmaxresult"}],"output":{"name":"minmaxresult"}}],[11,"into_option","","`into_option` creates an `Option` of type `(T,T)`. The returned `Option`\nhas variant `None` if and only if the `MinMaxResult` has variant\n`NoElements`. Otherwise variant `Some(x,y)` is returned where `x <= y`.\nIf `MinMaxResult` has variant `OneElement(x)`, performing this operation\nwill make one clone of `x`.",43,{"inputs":[{"name":"minmaxresult"}],"output":{"name":"option"}}],[11,"clone","","",44,{"inputs":[{"name":"cloned"}],"output":{"name":"cloned"}}],[11,"next","","",44,{"inputs":[{"name":"cloned"}],"output":{"name":"option"}}],[11,"size_hint","","",44,null],[11,"next_back","","",44,{"inputs":[{"name":"cloned"}],"output":{"name":"option"}}],[11,"indexable","","",44,{"inputs":[{"name":"cloned"}],"output":{"name":"usize"}}],[11,"idx","","",44,{"inputs":[{"name":"cloned"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",45,{"inputs":[{"name":"cycle"}],"output":{"name":"cycle"}}],[11,"next","","",45,{"inputs":[{"name":"cycle"}],"output":{"name":"option"}}],[11,"size_hint","","",45,null],[11,"indexable","","",45,{"inputs":[{"name":"cycle"}],"output":{"name":"usize"}}],[11,"idx","","",45,{"inputs":[{"name":"cycle"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",46,{"inputs":[{"name":"chain"}],"output":{"name":"chain"}}],[11,"next","","",46,{"inputs":[{"name":"chain"}],"output":{"name":"option"}}],[11,"count","","",46,{"inputs":[{"name":"chain"}],"output":{"name":"usize"}}],[11,"nth","","",46,{"inputs":[{"name":"chain"},{"name":"usize"}],"output":{"name":"option"}}],[11,"last","","",46,{"inputs":[{"name":"chain"}],"output":{"name":"option"}}],[11,"size_hint","","",46,null],[11,"next_back","","",46,{"inputs":[{"name":"chain"}],"output":{"name":"option"}}],[11,"indexable","","",46,{"inputs":[{"name":"chain"}],"output":{"name":"usize"}}],[11,"idx","","",46,{"inputs":[{"name":"chain"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",47,{"inputs":[{"name":"zip"}],"output":{"name":"zip"}}],[11,"next","","",47,{"inputs":[{"name":"zip"}],"output":{"name":"option"}}],[11,"size_hint","","",47,null],[11,"next_back","","",47,{"inputs":[{"name":"zip"}],"output":{"name":"option"}}],[11,"indexable","","",47,{"inputs":[{"name":"zip"}],"output":{"name":"usize"}}],[11,"idx","","",47,{"inputs":[{"name":"zip"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",48,{"inputs":[{"name":"map"}],"output":{"name":"map"}}],[11,"next","","",48,{"inputs":[{"name":"map"}],"output":{"name":"option"}}],[11,"size_hint","","",48,null],[11,"next_back","","",48,{"inputs":[{"name":"map"}],"output":{"name":"option"}}],[11,"indexable","","",48,{"inputs":[{"name":"map"}],"output":{"name":"usize"}}],[11,"idx","","",48,{"inputs":[{"name":"map"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",49,{"inputs":[{"name":"filter"}],"output":{"name":"filter"}}],[11,"next","","",49,{"inputs":[{"name":"filter"}],"output":{"name":"option"}}],[11,"size_hint","","",49,null],[11,"next_back","","",49,{"inputs":[{"name":"filter"}],"output":{"name":"option"}}],[11,"clone","","",50,{"inputs":[{"name":"filtermap"}],"output":{"name":"filtermap"}}],[11,"next","","",50,{"inputs":[{"name":"filtermap"}],"output":{"name":"option"}}],[11,"size_hint","","",50,null],[11,"next_back","","",50,{"inputs":[{"name":"filtermap"}],"output":{"name":"option"}}],[11,"clone","","",51,{"inputs":[{"name":"enumerate"}],"output":{"name":"enumerate"}}],[11,"next","","# Overflow Behavior",51,{"inputs":[{"name":"enumerate"}],"output":{"name":"option"}}],[11,"size_hint","","",51,null],[11,"nth","","",51,{"inputs":[{"name":"enumerate"},{"name":"usize"}],"output":{"name":"option"}}],[11,"count","","",51,{"inputs":[{"name":"enumerate"}],"output":{"name":"usize"}}],[11,"next_back","","",51,{"inputs":[{"name":"enumerate"}],"output":{"name":"option"}}],[11,"indexable","","",51,{"inputs":[{"name":"enumerate"}],"output":{"name":"usize"}}],[11,"idx","","",51,{"inputs":[{"name":"enumerate"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",52,{"inputs":[{"name":"peekable"}],"output":{"name":"peekable"}}],[11,"next","","",52,{"inputs":[{"name":"peekable"}],"output":{"name":"option"}}],[11,"count","","",52,{"inputs":[{"name":"peekable"}],"output":{"name":"usize"}}],[11,"nth","","",52,{"inputs":[{"name":"peekable"},{"name":"usize"}],"output":{"name":"option"}}],[11,"last","","",52,{"inputs":[{"name":"peekable"}],"output":{"name":"option"}}],[11,"size_hint","","",52,null],[11,"peek","","Returns a reference to the next element of the iterator with out\nadvancing it, or None if the iterator is exhausted.",52,{"inputs":[{"name":"peekable"}],"output":{"name":"option"}}],[11,"is_empty","","Checks whether peekable iterator is empty or not.",52,{"inputs":[{"name":"peekable"}],"output":{"name":"bool"}}],[11,"clone","","",53,{"inputs":[{"name":"skipwhile"}],"output":{"name":"skipwhile"}}],[11,"next","","",53,{"inputs":[{"name":"skipwhile"}],"output":{"name":"option"}}],[11,"size_hint","","",53,null],[11,"clone","","",54,{"inputs":[{"name":"takewhile"}],"output":{"name":"takewhile"}}],[11,"next","","",54,{"inputs":[{"name":"takewhile"}],"output":{"name":"option"}}],[11,"size_hint","","",54,null],[11,"clone","","",55,{"inputs":[{"name":"skip"}],"output":{"name":"skip"}}],[11,"next","","",55,{"inputs":[{"name":"skip"}],"output":{"name":"option"}}],[11,"nth","","",55,{"inputs":[{"name":"skip"},{"name":"usize"}],"output":{"name":"option"}}],[11,"count","","",55,{"inputs":[{"name":"skip"}],"output":{"name":"usize"}}],[11,"last","","",55,{"inputs":[{"name":"skip"}],"output":{"name":"option"}}],[11,"size_hint","","",55,null],[11,"indexable","","",55,{"inputs":[{"name":"skip"}],"output":{"name":"usize"}}],[11,"idx","","",55,{"inputs":[{"name":"skip"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",56,{"inputs":[{"name":"take"}],"output":{"name":"take"}}],[11,"next","","",56,{"inputs":[{"name":"take"}],"output":{"name":"option"}}],[11,"nth","","",56,{"inputs":[{"name":"take"},{"name":"usize"}],"output":{"name":"option"}}],[11,"size_hint","","",56,null],[11,"indexable","","",56,{"inputs":[{"name":"take"}],"output":{"name":"usize"}}],[11,"idx","","",56,{"inputs":[{"name":"take"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",57,{"inputs":[{"name":"scan"}],"output":{"name":"scan"}}],[11,"next","","",57,{"inputs":[{"name":"scan"}],"output":{"name":"option"}}],[11,"size_hint","","",57,null],[11,"clone","","",58,{"inputs":[{"name":"flatmap"}],"output":{"name":"flatmap"}}],[11,"next","","",58,{"inputs":[{"name":"flatmap"}],"output":{"name":"option"}}],[11,"size_hint","","",58,null],[11,"next_back","","",58,{"inputs":[{"name":"flatmap"}],"output":{"name":"option"}}],[11,"clone","","",59,{"inputs":[{"name":"fuse"}],"output":{"name":"fuse"}}],[11,"next","","",59,{"inputs":[{"name":"fuse"}],"output":{"name":"option"}}],[11,"nth","","",59,{"inputs":[{"name":"fuse"},{"name":"usize"}],"output":{"name":"option"}}],[11,"last","","",59,{"inputs":[{"name":"fuse"}],"output":{"name":"option"}}],[11,"count","","",59,{"inputs":[{"name":"fuse"}],"output":{"name":"usize"}}],[11,"size_hint","","",59,null],[11,"next_back","","",59,{"inputs":[{"name":"fuse"}],"output":{"name":"option"}}],[11,"indexable","","",59,{"inputs":[{"name":"fuse"}],"output":{"name":"usize"}}],[11,"idx","","",59,{"inputs":[{"name":"fuse"},{"name":"usize"}],"output":{"name":"option"}}],[11,"reset_fuse","","Resets the `Fuse` such that the next call to `.next()` or\n`.next_back()` will call the underlying iterator again even if it\npreviously returned `None`.",59,null],[11,"clone","","",60,{"inputs":[{"name":"inspect"}],"output":{"name":"inspect"}}],[11,"next","","",60,{"inputs":[{"name":"inspect"}],"output":{"name":"option"}}],[11,"size_hint","","",60,null],[11,"next_back","","",60,{"inputs":[{"name":"inspect"}],"output":{"name":"option"}}],[11,"indexable","","",60,{"inputs":[{"name":"inspect"}],"output":{"name":"usize"}}],[11,"idx","","",60,{"inputs":[{"name":"inspect"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",61,{"inputs":[{"name":"unfold"}],"output":{"name":"unfold"}}],[11,"new","","Creates a new iterator with the specified closure as the \"iterator\nfunction\" and an initial state to eventually pass to the closure",61,{"inputs":[{"name":"unfold"},{"name":"st"},{"name":"f"}],"output":{"name":"unfold"}}],[11,"next","","",61,{"inputs":[{"name":"unfold"}],"output":{"name":"option"}}],[11,"size_hint","","",61,null],[11,"clone","","",62,{"inputs":[{"name":"stepby"}],"output":{"name":"stepby"}}],[11,"step_by","core::ops","Creates an iterator starting at the same point, but stepping by\nthe given amount at each iteration.",22,{"inputs":[{"name":"rangefrom"},{"name":"a"}],"output":{"name":"stepby"}}],[11,"step_by","","Creates an iterator with the same range, but stepping by the\ngiven amount at each iteration.",21,{"inputs":[{"name":"range"},{"name":"a"}],"output":{"name":"stepby"}}],[11,"next","core::iter","",62,{"inputs":[{"name":"stepby"}],"output":{"name":"option"}}],[11,"size_hint","","",62,null],[11,"clone","","",63,{"inputs":[{"name":"rangeinclusive"}],"output":{"name":"rangeinclusive"}}],[11,"next","","",63,{"inputs":[{"name":"rangeinclusive"}],"output":{"name":"option"}}],[11,"size_hint","","",63,null],[11,"next_back","","",63,{"inputs":[{"name":"rangeinclusive"}],"output":{"name":"option"}}],[11,"next","","",62,{"inputs":[{"name":"stepby"}],"output":{"name":"option"}}],[11,"size_hint","","",62,null],[11,"next","core::ops","",21,{"inputs":[{"name":"range"}],"output":{"name":"option"}}],[11,"size_hint","","",21,null],[11,"next_back","","",21,{"inputs":[{"name":"range"}],"output":{"name":"option"}}],[11,"next","","",22,{"inputs":[{"name":"rangefrom"}],"output":{"name":"option"}}],[11,"clone","core::iter","",64,{"inputs":[{"name":"repeat"}],"output":{"name":"repeat"}}],[11,"next","","",64,{"inputs":[{"name":"repeat"}],"output":{"name":"option"}}],[11,"size_hint","","",64,null],[11,"next_back","","",64,{"inputs":[{"name":"repeat"}],"output":{"name":"option"}}],[11,"indexable","","",64,{"inputs":[{"name":"repeat"}],"output":{"name":"usize"}}],[11,"idx","","",64,{"inputs":[{"name":"repeat"},{"name":"usize"}],"output":{"name":"option"}}],[11,"next","","",65,{"inputs":[{"name":"empty"}],"output":{"name":"option"}}],[11,"size_hint","","",65,null],[11,"next_back","","",65,{"inputs":[{"name":"empty"}],"output":{"name":"option"}}],[11,"len","","",65,{"inputs":[{"name":"empty"}],"output":{"name":"usize"}}],[11,"clone","","",65,{"inputs":[{"name":"empty"}],"output":{"name":"empty"}}],[11,"default","","",65,{"inputs":[{"name":"empty"}],"output":{"name":"empty"}}],[11,"clone","","",66,{"inputs":[{"name":"once"}],"output":{"name":"once"}}],[11,"next","","",66,{"inputs":[{"name":"once"}],"output":{"name":"option"}}],[11,"size_hint","","",66,null],[11,"next_back","","",66,{"inputs":[{"name":"once"}],"output":{"name":"option"}}],[11,"len","","",66,{"inputs":[{"name":"once"}],"output":{"name":"usize"}}],[11,"hash","core::option","",67,null],[11,"fmt","","",67,{"inputs":[{"name":"option"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"cmp","","",67,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",67,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"option"}}],[11,"lt","","",67,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"le","","",67,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"gt","","",67,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"ge","","",67,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"eq","","",67,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"ne","","",67,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"clone","","",67,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[11,"is_some","","Returns `true` if the option is a `Some` value",67,{"inputs":[{"name":"option"}],"output":{"name":"bool"}}],[11,"is_none","","Returns `true` if the option is a `None` value",67,{"inputs":[{"name":"option"}],"output":{"name":"bool"}}],[11,"as_ref","","Converts from `Option<T>` to `Option<&T>`",67,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[11,"as_mut","","Converts from `Option<T>` to `Option<&mut T>`",67,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[11,"as_mut_slice","","Converts from `Option<T>` to `&mut [T]` (without copying)",67,null],[11,"expect","","Unwraps an option, yielding the content of a `Some`",67,{"inputs":[{"name":"option"},{"name":"str"}],"output":{"name":"t"}}],[11,"unwrap","","Moves the value `v` out of the `Option<T>` if it is `Some(v)`.",67,{"inputs":[{"name":"option"}],"output":{"name":"t"}}],[11,"unwrap_or","","Returns the contained value or a default.",67,{"inputs":[{"name":"option"},{"name":"t"}],"output":{"name":"t"}}],[11,"unwrap_or_else","","Returns the contained value or computes it from a closure.",67,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"t"}}],[11,"map","","Maps an `Option<T>` to `Option<U>` by applying a function to a contained value",67,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"option"}}],[11,"map_or","","Applies a function to the contained value (if any),\nor returns a `default` (if not).",67,{"inputs":[{"name":"option"},{"name":"u"},{"name":"f"}],"output":{"name":"u"}}],[11,"map_or_else","","Applies a function to the contained value (if any),\nor computes a `default` (if not).",67,{"inputs":[{"name":"option"},{"name":"d"},{"name":"f"}],"output":{"name":"u"}}],[11,"ok_or","","Transforms the `Option<T>` into a `Result<T, E>`, mapping `Some(v)` to\n`Ok(v)` and `None` to `Err(err)`.",67,{"inputs":[{"name":"option"},{"name":"e"}],"output":{"name":"result"}}],[11,"ok_or_else","","Transforms the `Option<T>` into a `Result<T, E>`, mapping `Some(v)` to\n`Ok(v)` and `None` to `Err(err())`.",67,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"result"}}],[11,"iter","","Returns an iterator over the possibly contained value.",67,{"inputs":[{"name":"option"}],"output":{"name":"iter"}}],[11,"iter_mut","","Returns a mutable iterator over the possibly contained value.",67,{"inputs":[{"name":"option"}],"output":{"name":"itermut"}}],[11,"and","","Returns `None` if the option is `None`, otherwise returns `optb`.",67,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"option"}}],[11,"and_then","","Returns `None` if the option is `None`, otherwise calls `f` with the\nwrapped value and returns the result.",67,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"option"}}],[11,"or","","Returns the option if it contains a value, otherwise returns `optb`.",67,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"option"}}],[11,"or_else","","Returns the option if it contains a value, otherwise calls `f` and\nreturns the result.",67,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"option"}}],[11,"take","","Takes the value out of the option, leaving a `None` in its place.",67,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[11,"as_slice","","Converts from `Option<T>` to `&[T]` (without copying)",67,null],[11,"cloned","","Maps an Option<&T> to an Option<T> by cloning the contents of the Option.",67,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[11,"unwrap_or_default","","Returns the contained value or a default",67,{"inputs":[{"name":"option"}],"output":{"name":"t"}}],[11,"default","","",67,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[11,"into_iter","","Returns a consuming iterator over the possibly contained value.",67,{"inputs":[{"name":"option"}],"output":{"name":"intoiter"}}],[11,"clone","","",68,{"inputs":[{"name":"item"}],"output":{"name":"item"}}],[11,"next","","",68,{"inputs":[{"name":"item"}],"output":{"name":"option"}}],[11,"size_hint","","",68,null],[11,"next_back","","",68,{"inputs":[{"name":"item"}],"output":{"name":"option"}}],[11,"next","","",69,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",69,null],[11,"next_back","","",69,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"clone","","",69,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[11,"next","","",70,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"size_hint","","",70,null],[11,"next_back","","",70,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"clone","","",71,{"inputs":[{"name":"intoiter"}],"output":{"name":"intoiter"}}],[11,"next","","",71,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",71,null],[11,"next_back","","",71,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"from_iter","","Takes each element in the `Iterator`: if it is `None`, no further\nelements are taken, and the `None` is returned. Should no `None` occur, a\ncontainer with the values of each `Option` is returned.",67,{"inputs":[{"name":"option"},{"name":"i"}],"output":{"name":"option"}}],[11,"clone","core::raw","",72,{"inputs":[{"name":"slice"}],"output":{"name":"slice"}}],[11,"clone","","",73,{"inputs":[{"name":"traitobject"}],"output":{"name":"traitobject"}}],[11,"hash","core::result","",74,null],[11,"fmt","","",74,{"inputs":[{"name":"result"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"cmp","","",74,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",74,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"option"}}],[11,"lt","","",74,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"le","","",74,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"gt","","",74,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"ge","","",74,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"eq","","",74,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"ne","","",74,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"clone","","",74,{"inputs":[{"name":"result"}],"output":{"name":"result"}}],[11,"is_ok","","Returns true if the result is `Ok`",74,{"inputs":[{"name":"result"}],"output":{"name":"bool"}}],[11,"is_err","","Returns true if the result is `Err`",74,{"inputs":[{"name":"result"}],"output":{"name":"bool"}}],[11,"ok","","Converts from `Result<T, E>` to `Option<T>`",74,{"inputs":[{"name":"result"}],"output":{"name":"option"}}],[11,"err","","Converts from `Result<T, E>` to `Option<E>`",74,{"inputs":[{"name":"result"}],"output":{"name":"option"}}],[11,"as_ref","","Converts from `Result<T, E>` to `Result<&T, &E>`",74,{"inputs":[{"name":"result"}],"output":{"name":"result"}}],[11,"as_mut","","Converts from `Result<T, E>` to `Result<&mut T, &mut E>`",74,{"inputs":[{"name":"result"}],"output":{"name":"result"}}],[11,"as_slice","","Converts from `Result<T, E>` to `&[T]` (without copying)",74,null],[11,"as_mut_slice","","Converts from `Result<T, E>` to `&mut [T]` (without copying)",74,null],[11,"map","","Maps a `Result<T, E>` to `Result<U, E>` by applying a function to an\ncontained `Ok` value, leaving an `Err` value untouched.",74,{"inputs":[{"name":"result"},{"name":"f"}],"output":{"name":"result"}}],[11,"map_err","","Maps a `Result<T, E>` to `Result<T, F>` by applying a function to an\ncontained `Err` value, leaving an `Ok` value untouched.",74,{"inputs":[{"name":"result"},{"name":"o"}],"output":{"name":"result"}}],[11,"iter","","Returns an iterator over the possibly contained value.",74,{"inputs":[{"name":"result"}],"output":{"name":"iter"}}],[11,"iter_mut","","Returns a mutable iterator over the possibly contained value.",74,{"inputs":[{"name":"result"}],"output":{"name":"itermut"}}],[11,"and","","Returns `res` if the result is `Ok`, otherwise returns the `Err` value of `self`.",74,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"result"}}],[11,"and_then","","Calls `op` if the result is `Ok`, otherwise returns the `Err` value of `self`.",74,{"inputs":[{"name":"result"},{"name":"f"}],"output":{"name":"result"}}],[11,"or","","Returns `res` if the result is `Err`, otherwise returns the `Ok` value of `self`.",74,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"result"}}],[11,"or_else","","Calls `op` if the result is `Err`, otherwise returns the `Ok` value of `self`.",74,{"inputs":[{"name":"result"},{"name":"o"}],"output":{"name":"result"}}],[11,"unwrap_or","","Unwraps a result, yielding the content of an `Ok`.\nElse it returns `optb`.",74,{"inputs":[{"name":"result"},{"name":"t"}],"output":{"name":"t"}}],[11,"unwrap_or_else","","Unwraps a result, yielding the content of an `Ok`.\nIf the value is an `Err` then it calls `op` with its value.",74,{"inputs":[{"name":"result"},{"name":"f"}],"output":{"name":"t"}}],[11,"unwrap","","Unwraps a result, yielding the content of an `Ok`.",74,{"inputs":[{"name":"result"}],"output":{"name":"t"}}],[11,"expect","","Unwraps a result, yielding the content of an `Ok`.",74,{"inputs":[{"name":"result"},{"name":"str"}],"output":{"name":"t"}}],[11,"unwrap_err","","Unwraps a result, yielding the content of an `Err`.",74,{"inputs":[{"name":"result"}],"output":{"name":"e"}}],[11,"into_iter","","Returns a consuming iterator over the possibly contained value.",74,{"inputs":[{"name":"result"}],"output":{"name":"intoiter"}}],[11,"next","","",75,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",75,null],[11,"next_back","","",75,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"clone","","",75,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[11,"next","","",76,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"size_hint","","",76,null],[11,"next_back","","",76,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"next","","",77,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",77,null],[11,"next_back","","",77,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"from_iter","","Takes each element in the `Iterator`: if it is an `Err`, no further\nelements are taken, and the `Err` is returned. Should no `Err` occur, a\ncontainer with the values of each `Result` is returned.",74,{"inputs":[{"name":"result"},{"name":"i"}],"output":{"name":"result"}}],[11,"fmt","core::simd","",78,{"inputs":[{"name":"i8x16"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",78,{"inputs":[{"name":"i8x16"}],"output":{"name":"i8x16"}}],[11,"fmt","","",79,{"inputs":[{"name":"i16x8"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",79,{"inputs":[{"name":"i16x8"}],"output":{"name":"i16x8"}}],[11,"fmt","","",80,{"inputs":[{"name":"i32x4"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",80,{"inputs":[{"name":"i32x4"}],"output":{"name":"i32x4"}}],[11,"fmt","","",81,{"inputs":[{"name":"i64x2"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",81,{"inputs":[{"name":"i64x2"}],"output":{"name":"i64x2"}}],[11,"fmt","","",82,{"inputs":[{"name":"u8x16"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",82,{"inputs":[{"name":"u8x16"}],"output":{"name":"u8x16"}}],[11,"fmt","","",83,{"inputs":[{"name":"u16x8"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",83,{"inputs":[{"name":"u16x8"}],"output":{"name":"u16x8"}}],[11,"fmt","","",84,{"inputs":[{"name":"u32x4"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",84,{"inputs":[{"name":"u32x4"}],"output":{"name":"u32x4"}}],[11,"fmt","","",85,{"inputs":[{"name":"u64x2"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",85,{"inputs":[{"name":"u64x2"}],"output":{"name":"u64x2"}}],[11,"fmt","","",86,{"inputs":[{"name":"f32x4"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",86,{"inputs":[{"name":"f32x4"}],"output":{"name":"f32x4"}}],[11,"fmt","","",87,{"inputs":[{"name":"f64x2"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",87,{"inputs":[{"name":"f64x2"}],"output":{"name":"f64x2"}}],[11,"as_slice","core::slice","View the underlying data as a subslice of the original data.",88,null],[11,"next","","",88,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",88,null],[11,"count","","",88,{"inputs":[{"name":"iter"}],"output":{"name":"usize"}}],[11,"nth","","",88,{"inputs":[{"name":"iter"},{"name":"usize"}],"output":{"name":"option"}}],[11,"last","","",88,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"next_back","","",88,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"clone","","",88,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[11,"indexable","","",88,{"inputs":[{"name":"iter"}],"output":{"name":"usize"}}],[11,"idx","","",88,{"inputs":[{"name":"iter"},{"name":"usize"}],"output":{"name":"option"}}],[11,"into_slice","","View the underlying data as a subslice of the original data.",89,null],[11,"next","","",89,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"size_hint","","",89,null],[11,"count","","",89,{"inputs":[{"name":"itermut"}],"output":{"name":"usize"}}],[11,"nth","","",89,{"inputs":[{"name":"itermut"},{"name":"usize"}],"output":{"name":"option"}}],[11,"last","","",89,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"next_back","","",89,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"clone","","",90,{"inputs":[{"name":"split"}],"output":{"name":"split"}}],[11,"next","","",90,{"inputs":[{"name":"split"}],"output":{"name":"option"}}],[11,"size_hint","","",90,null],[11,"next_back","","",90,{"inputs":[{"name":"split"}],"output":{"name":"option"}}],[11,"finish","","",90,{"inputs":[{"name":"split"}],"output":{"name":"option"}}],[11,"finish","","",91,{"inputs":[{"name":"splitmut"}],"output":{"name":"option"}}],[11,"next","","",91,{"inputs":[{"name":"splitmut"}],"output":{"name":"option"}}],[11,"size_hint","","",91,null],[11,"next_back","","",91,{"inputs":[{"name":"splitmut"}],"output":{"name":"option"}}],[11,"next","","",92,{"inputs":[{"name":"genericsplitn"}],"output":{"name":"option"}}],[11,"size_hint","","",92,null],[11,"next","","",93,{"inputs":[{"name":"splitn"}],"output":{"name":"option"}}],[11,"size_hint","","",93,null],[11,"next","","",94,{"inputs":[{"name":"rsplitn"}],"output":{"name":"option"}}],[11,"size_hint","","",94,null],[11,"next","","",95,{"inputs":[{"name":"splitnmut"}],"output":{"name":"option"}}],[11,"size_hint","","",95,null],[11,"next","","",96,{"inputs":[{"name":"rsplitnmut"}],"output":{"name":"option"}}],[11,"size_hint","","",96,null],[11,"clone","","",97,{"inputs":[{"name":"windows"}],"output":{"name":"windows"}}],[11,"next","","",97,{"inputs":[{"name":"windows"}],"output":{"name":"option"}}],[11,"size_hint","","",97,null],[11,"next_back","","",97,{"inputs":[{"name":"windows"}],"output":{"name":"option"}}],[11,"indexable","","",97,{"inputs":[{"name":"windows"}],"output":{"name":"usize"}}],[11,"idx","","",97,{"inputs":[{"name":"windows"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",98,{"inputs":[{"name":"chunks"}],"output":{"name":"chunks"}}],[11,"next","","",98,{"inputs":[{"name":"chunks"}],"output":{"name":"option"}}],[11,"size_hint","","",98,null],[11,"next_back","","",98,{"inputs":[{"name":"chunks"}],"output":{"name":"option"}}],[11,"indexable","","",98,{"inputs":[{"name":"chunks"}],"output":{"name":"usize"}}],[11,"idx","","",98,{"inputs":[{"name":"chunks"},{"name":"usize"}],"output":{"name":"option"}}],[11,"next","","",99,{"inputs":[{"name":"chunksmut"}],"output":{"name":"option"}}],[11,"size_hint","","",99,null],[11,"next_back","","",99,{"inputs":[{"name":"chunksmut"}],"output":{"name":"option"}}],[11,"fmt","core::str::pattern","",100,{"inputs":[{"name":"searchstep"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",100,{"inputs":[{"name":"searchstep"},{"name":"searchstep"}],"output":{"name":"bool"}}],[11,"ne","","",100,{"inputs":[{"name":"searchstep"},{"name":"searchstep"}],"output":{"name":"bool"}}],[11,"clone","","",100,{"inputs":[{"name":"searchstep"}],"output":{"name":"searchstep"}}],[11,"clone","","",101,{"inputs":[{"name":"chareqsearcher"}],"output":{"name":"chareqsearcher"}}],[11,"into_searcher","","",102,{"inputs":[{"name":"chareqpattern"},{"name":"str"}],"output":{"name":"chareqsearcher"}}],[11,"haystack","","",101,{"inputs":[{"name":"chareqsearcher"}],"output":{"name":"str"}}],[11,"next","","",101,{"inputs":[{"name":"chareqsearcher"}],"output":{"name":"searchstep"}}],[11,"next_back","","",101,{"inputs":[{"name":"chareqsearcher"}],"output":{"name":"searchstep"}}],[11,"clone","","",103,{"inputs":[{"name":"charsearcher"}],"output":{"name":"charsearcher"}}],[11,"haystack","","",103,{"inputs":[{"name":"charsearcher"}],"output":{"name":"str"}}],[11,"next","","",103,{"inputs":[{"name":"charsearcher"}],"output":{"name":"searchstep"}}],[11,"next_match","","",103,{"inputs":[{"name":"charsearcher"}],"output":{"name":"option"}}],[11,"next_reject","","",103,{"inputs":[{"name":"charsearcher"}],"output":{"name":"option"}}],[11,"next_back","","",103,{"inputs":[{"name":"charsearcher"}],"output":{"name":"searchstep"}}],[11,"next_match_back","","",103,{"inputs":[{"name":"charsearcher"}],"output":{"name":"option"}}],[11,"next_reject_back","","",103,{"inputs":[{"name":"charsearcher"}],"output":{"name":"option"}}],[11,"clone","","",104,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"charslicesearcher"}}],[11,"haystack","","",104,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"str"}}],[11,"next","","",104,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"searchstep"}}],[11,"next_match","","",104,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"option"}}],[11,"next_reject","","",104,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"option"}}],[11,"next_back","","",104,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"searchstep"}}],[11,"next_match_back","","",104,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"option"}}],[11,"next_reject_back","","",104,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"option"}}],[11,"clone","","",105,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"charpredicatesearcher"}}],[11,"haystack","","",105,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"str"}}],[11,"next","","",105,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"searchstep"}}],[11,"next_match","","",105,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"option"}}],[11,"next_reject","","",105,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"option"}}],[11,"next_back","","",105,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"searchstep"}}],[11,"next_match_back","","",105,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"option"}}],[11,"next_reject_back","","",105,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"option"}}],[11,"fmt","","",106,{"inputs":[{"name":"strsearcher"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",106,{"inputs":[{"name":"strsearcher"}],"output":{"name":"strsearcher"}}],[11,"fmt","","",107,{"inputs":[{"name":"strsearcherimpl"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",107,{"inputs":[{"name":"strsearcherimpl"}],"output":{"name":"strsearcherimpl"}}],[11,"fmt","","",108,{"inputs":[{"name":"emptyneedle"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",108,{"inputs":[{"name":"emptyneedle"}],"output":{"name":"emptyneedle"}}],[11,"haystack","","",106,{"inputs":[{"name":"strsearcher"}],"output":{"name":"str"}}],[11,"next","","",106,{"inputs":[{"name":"strsearcher"}],"output":{"name":"searchstep"}}],[11,"next_match","","",106,{"inputs":[{"name":"strsearcher"}],"output":{"name":"option"}}],[11,"next_back","","",106,{"inputs":[{"name":"strsearcher"}],"output":{"name":"searchstep"}}],[11,"next_match_back","","",106,{"inputs":[{"name":"strsearcher"}],"output":{"name":"option"}}],[11,"fmt","","",109,{"inputs":[{"name":"twowaysearcher"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",109,{"inputs":[{"name":"twowaysearcher"}],"output":{"name":"twowaysearcher"}}],[11,"use_early_reject","","",110,{"inputs":[{"name":"matchonly"}],"output":{"name":"bool"}}],[11,"rejecting","","",110,null],[11,"matching","","",110,null],[11,"use_early_reject","","",111,{"inputs":[{"name":"rejectandmatch"}],"output":{"name":"bool"}}],[11,"rejecting","","",111,null],[11,"matching","","",111,null],[11,"eq","core::str","",112,{"inputs":[{"name":"parseboolerror"},{"name":"parseboolerror"}],"output":{"name":"bool"}}],[11,"ne","","",112,{"inputs":[{"name":"parseboolerror"},{"name":"parseboolerror"}],"output":{"name":"bool"}}],[11,"clone","","",112,{"inputs":[{"name":"parseboolerror"}],"output":{"name":"parseboolerror"}}],[11,"fmt","","",112,{"inputs":[{"name":"parseboolerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",112,{"inputs":[{"name":"parseboolerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",113,{"inputs":[{"name":"utf8error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",113,{"inputs":[{"name":"utf8error"}],"output":{"name":"utf8error"}}],[11,"eq","","",113,{"inputs":[{"name":"utf8error"},{"name":"utf8error"}],"output":{"name":"bool"}}],[11,"ne","","",113,{"inputs":[{"name":"utf8error"},{"name":"utf8error"}],"output":{"name":"bool"}}],[11,"valid_up_to","","Returns the index in the given string up to which valid UTF-8 was\nverified.",113,{"inputs":[{"name":"utf8error"}],"output":{"name":"usize"}}],[11,"fmt","","",113,{"inputs":[{"name":"utf8error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",114,{"inputs":[{"name":"chars"}],"output":{"name":"chars"}}],[11,"next","","",114,{"inputs":[{"name":"chars"}],"output":{"name":"option"}}],[11,"size_hint","","",114,null],[11,"next_back","","",114,{"inputs":[{"name":"chars"}],"output":{"name":"option"}}],[11,"clone","","",115,{"inputs":[{"name":"charindices"}],"output":{"name":"charindices"}}],[11,"next","","",115,{"inputs":[{"name":"charindices"}],"output":{"name":"option"}}],[11,"size_hint","","",115,null],[11,"next_back","","",115,{"inputs":[{"name":"charindices"}],"output":{"name":"option"}}],[11,"clone","","",116,{"inputs":[{"name":"bytes"}],"output":{"name":"bytes"}}],[11,"clone","","",117,{"inputs":[{"name":"bytesderef"}],"output":{"name":"bytesderef"}}],[11,"call","","",117,null],[11,"call_mut","","",117,null],[11,"call_once","","",117,null],[11,"next","","",116,{"inputs":[{"name":"bytes"}],"output":{"name":"option"}}],[11,"size_hint","","",116,null],[11,"next_back","","",116,{"inputs":[{"name":"bytes"}],"output":{"name":"option"}}],[11,"len","","",116,{"inputs":[{"name":"bytes"}],"output":{"name":"usize"}}],[11,"clone","","",118,{"inputs":[{"name":"splitinternal"}],"output":{"name":"splitinternal"}}],[11,"next","","",119,{"inputs":[{"name":"split"}],"output":{"name":"option"}}],[11,"clone","","",119,{"inputs":[{"name":"split"}],"output":{"name":"split"}}],[11,"next","","",120,{"inputs":[{"name":"rsplit"}],"output":{"name":"option"}}],[11,"clone","","",120,{"inputs":[{"name":"rsplit"}],"output":{"name":"rsplit"}}],[11,"next_back","","",119,{"inputs":[{"name":"split"}],"output":{"name":"option"}}],[11,"next_back","","",120,{"inputs":[{"name":"rsplit"}],"output":{"name":"option"}}],[11,"next","","",121,{"inputs":[{"name":"splitterminator"}],"output":{"name":"option"}}],[11,"clone","","",121,{"inputs":[{"name":"splitterminator"}],"output":{"name":"splitterminator"}}],[11,"next","","",122,{"inputs":[{"name":"rsplitterminator"}],"output":{"name":"option"}}],[11,"clone","","",122,{"inputs":[{"name":"rsplitterminator"}],"output":{"name":"rsplitterminator"}}],[11,"next_back","","",121,{"inputs":[{"name":"splitterminator"}],"output":{"name":"option"}}],[11,"next_back","","",122,{"inputs":[{"name":"rsplitterminator"}],"output":{"name":"option"}}],[11,"clone","","",123,{"inputs":[{"name":"splitninternal"}],"output":{"name":"splitninternal"}}],[11,"next","","",124,{"inputs":[{"name":"splitn"}],"output":{"name":"option"}}],[11,"clone","","",124,{"inputs":[{"name":"splitn"}],"output":{"name":"splitn"}}],[11,"next","","",125,{"inputs":[{"name":"rsplitn"}],"output":{"name":"option"}}],[11,"clone","","",125,{"inputs":[{"name":"rsplitn"}],"output":{"name":"rsplitn"}}],[11,"clone","","",126,{"inputs":[{"name":"matchindicesinternal"}],"output":{"name":"matchindicesinternal"}}],[11,"next","","",127,{"inputs":[{"name":"matchindices"}],"output":{"name":"option"}}],[11,"clone","","",127,{"inputs":[{"name":"matchindices"}],"output":{"name":"matchindices"}}],[11,"next","","",128,{"inputs":[{"name":"rmatchindices"}],"output":{"name":"option"}}],[11,"clone","","",128,{"inputs":[{"name":"rmatchindices"}],"output":{"name":"rmatchindices"}}],[11,"next_back","","",127,{"inputs":[{"name":"matchindices"}],"output":{"name":"option"}}],[11,"next_back","","",128,{"inputs":[{"name":"rmatchindices"}],"output":{"name":"option"}}],[11,"clone","","",129,{"inputs":[{"name":"matchesinternal"}],"output":{"name":"matchesinternal"}}],[11,"next","","",130,{"inputs":[{"name":"matches"}],"output":{"name":"option"}}],[11,"clone","","",130,{"inputs":[{"name":"matches"}],"output":{"name":"matches"}}],[11,"next","","",131,{"inputs":[{"name":"rmatches"}],"output":{"name":"option"}}],[11,"clone","","",131,{"inputs":[{"name":"rmatches"}],"output":{"name":"rmatches"}}],[11,"next_back","","",130,{"inputs":[{"name":"matches"}],"output":{"name":"option"}}],[11,"next_back","","",131,{"inputs":[{"name":"rmatches"}],"output":{"name":"option"}}],[11,"clone","","",132,{"inputs":[{"name":"lines"}],"output":{"name":"lines"}}],[11,"next","","",132,{"inputs":[{"name":"lines"}],"output":{"name":"option"}}],[11,"size_hint","","",132,null],[11,"next_back","","",132,{"inputs":[{"name":"lines"}],"output":{"name":"option"}}],[11,"clone","","",133,{"inputs":[{"name":"linesany"}],"output":{"name":"linesany"}}],[11,"clone","","",134,{"inputs":[{"name":"linesanymap"}],"output":{"name":"linesanymap"}}],[11,"call","","",134,null],[11,"call_mut","","",134,null],[11,"call_once","","",134,null],[11,"next","","",133,{"inputs":[{"name":"linesany"}],"output":{"name":"option"}}],[11,"size_hint","","",133,null],[11,"next_back","","",133,{"inputs":[{"name":"linesany"}],"output":{"name":"option"}}],[11,"clone","","",135,{"inputs":[{"name":"charrange"}],"output":{"name":"charrange"}}],[11,"new","core::hash::sip","Creates a new `SipHasher` with the two initial keys set to 0.",136,{"inputs":[{"name":"siphasher"}],"output":{"name":"siphasher"}}],[11,"new_with_keys","","Creates a `SipHasher` that is keyed off the provided keys.",136,{"inputs":[{"name":"siphasher"},{"name":"u64"},{"name":"u64"}],"output":{"name":"siphasher"}}],[11,"write","","",136,null],[11,"finish","","",136,{"inputs":[{"name":"siphasher"}],"output":{"name":"u64"}}],[11,"clone","","",136,{"inputs":[{"name":"siphasher"}],"output":{"name":"siphasher"}}],[11,"default","","",136,{"inputs":[{"name":"siphasher"}],"output":{"name":"siphasher"}}],[11,"eq","core::fmt::num","",137,{"inputs":[{"name":"binary"},{"name":"binary"}],"output":{"name":"bool"}}],[11,"ne","","",137,{"inputs":[{"name":"binary"},{"name":"binary"}],"output":{"name":"bool"}}],[11,"clone","","",137,{"inputs":[{"name":"binary"}],"output":{"name":"binary"}}],[11,"eq","","",138,{"inputs":[{"name":"octal"},{"name":"octal"}],"output":{"name":"bool"}}],[11,"ne","","",138,{"inputs":[{"name":"octal"},{"name":"octal"}],"output":{"name":"bool"}}],[11,"clone","","",138,{"inputs":[{"name":"octal"}],"output":{"name":"octal"}}],[11,"eq","","",139,{"inputs":[{"name":"decimal"},{"name":"decimal"}],"output":{"name":"bool"}}],[11,"ne","","",139,{"inputs":[{"name":"decimal"},{"name":"decimal"}],"output":{"name":"bool"}}],[11,"clone","","",139,{"inputs":[{"name":"decimal"}],"output":{"name":"decimal"}}],[11,"eq","","",140,{"inputs":[{"name":"lowerhex"},{"name":"lowerhex"}],"output":{"name":"bool"}}],[11,"ne","","",140,{"inputs":[{"name":"lowerhex"},{"name":"lowerhex"}],"output":{"name":"bool"}}],[11,"clone","","",140,{"inputs":[{"name":"lowerhex"}],"output":{"name":"lowerhex"}}],[11,"eq","","",141,{"inputs":[{"name":"upperhex"},{"name":"upperhex"}],"output":{"name":"bool"}}],[11,"ne","","",141,{"inputs":[{"name":"upperhex"},{"name":"upperhex"}],"output":{"name":"bool"}}],[11,"clone","","",141,{"inputs":[{"name":"upperhex"}],"output":{"name":"upperhex"}}],[11,"eq","","",142,{"inputs":[{"name":"radix"},{"name":"radix"}],"output":{"name":"bool"}}],[11,"ne","","",142,{"inputs":[{"name":"radix"},{"name":"radix"}],"output":{"name":"bool"}}],[11,"clone","","",142,{"inputs":[{"name":"radix"}],"output":{"name":"radix"}}],[11,"clone","","",143,{"inputs":[{"name":"radixfmt"}],"output":{"name":"radixfmt"}}],[11,"fmt","","",143,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",143,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",143,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",143,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",143,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",143,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",143,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",143,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",143,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",143,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",143,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",143,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",143,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",143,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",143,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",143,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",143,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",143,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",143,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",143,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"write_str","core::fmt::builders","",144,{"inputs":[{"name":"padadapter"},{"name":"str"}],"output":{"name":"result"}}],[11,"field","","Adds a new field to the generated struct output.",145,{"inputs":[{"name":"debugstruct"},{"name":"str"},{"name":"debug"}],"output":{"name":"debugstruct"}}],[11,"finish","","Finishes output and returns any error encountered.",145,{"inputs":[{"name":"debugstruct"}],"output":{"name":"result"}}],[11,"field","","Adds a new field to the generated tuple struct output.",146,{"inputs":[{"name":"debugtuple"},{"name":"debug"}],"output":{"name":"debugtuple"}}],[11,"finish","","Finishes output and returns any error encountered.",146,{"inputs":[{"name":"debugtuple"}],"output":{"name":"result"}}],[11,"formatter","","Returns the wrapped `Formatter`.",146,{"inputs":[{"name":"debugtuple"}],"output":{"name":"formatter"}}],[11,"finish","","",147,null],[11,"entry","","Adds a new entry to the set output.",148,{"inputs":[{"name":"debugset"},{"name":"debug"}],"output":{"name":"debugset"}}],[11,"entries","","Adds the contents of an iterator of entries to the set output.",148,{"inputs":[{"name":"debugset"},{"name":"i"}],"output":{"name":"debugset"}}],[11,"finish","","Finishes output and returns any error encountered.",148,{"inputs":[{"name":"debugset"}],"output":{"name":"result"}}],[11,"entry","","Adds a new entry to the list output.",149,{"inputs":[{"name":"debuglist"},{"name":"debug"}],"output":{"name":"debuglist"}}],[11,"entries","","Adds the contents of an iterator of entries to the list output.",149,{"inputs":[{"name":"debuglist"},{"name":"i"}],"output":{"name":"debuglist"}}],[11,"finish","","Finishes output and returns any error encountered.",149,{"inputs":[{"name":"debuglist"}],"output":{"name":"result"}}],[11,"entry","","Adds a new entry to the map output.",150,{"inputs":[{"name":"debugmap"},{"name":"debug"},{"name":"debug"}],"output":{"name":"debugmap"}}],[11,"entries","","Adds the contents of an iterator of entries to the map output.",150,{"inputs":[{"name":"debugmap"},{"name":"i"}],"output":{"name":"debugmap"}}],[11,"finish","","Finishes output and returns any error encountered.",150,{"inputs":[{"name":"debugmap"}],"output":{"name":"result"}}],[11,"clone","core::fmt::rt::v1","",151,{"inputs":[{"name":"argument"}],"output":{"name":"argument"}}],[11,"clone","","",152,{"inputs":[{"name":"formatspec"}],"output":{"name":"formatspec"}}],[11,"eq","","",153,{"inputs":[{"name":"alignment"},{"name":"alignment"}],"output":{"name":"bool"}}],[11,"ne","","",153,{"inputs":[{"name":"alignment"},{"name":"alignment"}],"output":{"name":"bool"}}],[11,"clone","","",153,{"inputs":[{"name":"alignment"}],"output":{"name":"alignment"}}],[11,"clone","","",154,{"inputs":[{"name":"count"}],"output":{"name":"count"}}],[11,"clone","","",155,{"inputs":[{"name":"position"}],"output":{"name":"position"}}],[11,"fmt","core::fmt","",156,{"inputs":[{"name":"error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",156,{"inputs":[{"name":"error"}],"output":{"name":"error"}}],[11,"clone","","",157,{"inputs":[{"name":"flagv1"}],"output":{"name":"flagv1"}}],[11,"clone","","",158,{"inputs":[{"name":"arguments"}],"output":{"name":"arguments"}}],[11,"fmt","","",158,{"inputs":[{"name":"arguments"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",158,{"inputs":[{"name":"arguments"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"pad_integral","","Performs the correct padding for an integer which has already been\nemitted into a str. The str should *not* contain the sign for the\ninteger, that will be added by this method.",159,{"inputs":[{"name":"formatter"},{"name":"bool"},{"name":"str"},{"name":"str"}],"output":{"name":"result"}}],[11,"pad","","This function takes a string slice and emits it to the internal buffer\nafter applying the relevant formatting flags specified. The flags\nrecognized for generic strings are:",159,{"inputs":[{"name":"formatter"},{"name":"str"}],"output":{"name":"result"}}],[11,"write_str","","Writes some data to the underlying buffer contained within this\nformatter.",159,{"inputs":[{"name":"formatter"},{"name":"str"}],"output":{"name":"result"}}],[11,"write_fmt","","Writes some formatted information into this instance",159,{"inputs":[{"name":"formatter"},{"name":"arguments"}],"output":{"name":"result"}}],[11,"flags","","Flags for formatting (packed version of rt::Flag)",159,{"inputs":[{"name":"formatter"}],"output":{"name":"u32"}}],[11,"fill","","Character used as 'fill' whenever there is alignment",159,{"inputs":[{"name":"formatter"}],"output":{"name":"char"}}],[11,"align","","Flag indicating what form of alignment was requested",159,{"inputs":[{"name":"formatter"}],"output":{"name":"alignment"}}],[11,"width","","Optionally specified integer width that the output should be",159,{"inputs":[{"name":"formatter"}],"output":{"name":"option"}}],[11,"precision","","Optionally specified precision for numeric types",159,{"inputs":[{"name":"formatter"}],"output":{"name":"option"}}],[11,"debug_struct","","Creates a `DebugStruct` builder designed to assist with creation of\n`fmt::Debug` implementations for structs.",159,{"inputs":[{"name":"formatter"},{"name":"str"}],"output":{"name":"debugstruct"}}],[11,"debug_tuple","","Creates a `DebugTuple` builder designed to assist with creation of\n`fmt::Debug` implementations for tuple structs.",159,{"inputs":[{"name":"formatter"},{"name":"str"}],"output":{"name":"debugtuple"}}],[11,"debug_list","","Creates a `DebugList` builder designed to assist with creation of\n`fmt::Debug` implementations for list-like structures.",159,{"inputs":[{"name":"formatter"}],"output":{"name":"debuglist"}}],[11,"debug_set","","Creates a `DebugSet` builder designed to assist with creation of\n`fmt::Debug` implementations for set-like structures.",159,{"inputs":[{"name":"formatter"}],"output":{"name":"debugset"}}],[11,"debug_map","","Creates a `DebugMap` builder designed to assist with creation of\n`fmt::Debug` implementations for map-like structures.",159,{"inputs":[{"name":"formatter"}],"output":{"name":"debugmap"}}],[11,"write_str","","",159,{"inputs":[{"name":"formatter"},{"name":"str"}],"output":{"name":"result"}}],[11,"write_char","","",159,{"inputs":[{"name":"formatter"},{"name":"char"}],"output":{"name":"result"}}],[11,"write_fmt","","",159,{"inputs":[{"name":"formatter"},{"name":"arguments"}],"output":{"name":"result"}}],[11,"fmt","","",156,{"inputs":[{"name":"error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","core::marker","",19,{"inputs":[{"name":"phantomdata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","core::cell","",30,{"inputs":[{"name":"cell"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",32,{"inputs":[{"name":"refcell"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",34,{"inputs":[{"name":"ref"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",35,{"inputs":[{"name":"refmut"},{"name":"formatter"}],"output":{"name":"result"}}],[3,"TypeId","std::any","A `TypeId` represents a globally unique identifier for a type.",null,null],[0,"cell","std","Shareable mutable containers.",null,null],[3,"Cell","std::cell","A mutable memory location that admits only `Copy` data.",null,null],[3,"RefCell","","A mutable memory location with dynamically checked borrow rules",null,null],[4,"BorrowState","","An enumeration of values returned from the `state` method on a `RefCell<T>`.",null,null],[13,"Reading","","The cell is currently being read, there is at least one active `borrow`.",31,null],[13,"Writing","","The cell is currently being written to, there is an active `borrow_mut`.",31,null],[13,"Unused","","There are no outstanding borrows on this cell.",31,null],[3,"Ref","","Wraps a borrowed reference to a value in a `RefCell` box.\nA wrapper type for an immutably borrowed value from a `RefCell<T>`.",null,null],[5,"clone_ref","","Copies a `Ref`.",null,{"inputs":[{"name":"ref"}],"output":{"name":"ref"}}],[3,"RefMut","","A wrapper type for a mutably borrowed value from a `RefCell<T>`.",null,null],[3,"UnsafeCell","","The core primitive for interior mutability in Rust.",null,null],[12,"value","","Wrapped value",37,null],[0,"clone","std","The `Clone` trait for types that cannot be 'implicitly copied'",null,null],[8,"Clone","std::clone","A common trait for cloning an object.",null,null],[10,"clone","","Returns a copy of the value.",160,{"inputs":[{"name":"clone"}],"output":{"name":"self"}}],[11,"clone_from","","Performs copy-assignment from `source`.",160,null],[0,"cmp","std","Functionality for ordering and comparison.",null,null],[8,"PartialEq","std::cmp","Trait for equality comparisons which are [partial equivalence\nrelations](http://en.wikipedia.org/wiki/Partial_equivalence_relation).",null,null],[10,"eq","","This method tests for `self` and `other` values to be equal, and is used\nby `==`.",161,{"inputs":[{"name":"partialeq"},{"name":"rhs"}],"output":{"name":"bool"}}],[11,"ne","","This method tests for `!=`.",161,{"inputs":[{"name":"partialeq"},{"name":"rhs"}],"output":{"name":"bool"}}],[8,"Eq","","Trait for equality comparisons which are [equivalence relations](\nhttps://en.wikipedia.org/wiki/Equivalence_relation).",null,null],[4,"Ordering","","An `Ordering` is the result of a comparison between two values.",null,null],[13,"Less","","An ordering where a compared value is less [than another].",24,null],[13,"Equal","","An ordering where a compared value is equal [to another].",24,null],[13,"Greater","","An ordering where a compared value is greater [than another].",24,null],[8,"Ord","","Trait for types that form a [total order](https://en.wikipedia.org/wiki/Total_order).",null,null],[10,"cmp","","This method returns an `Ordering` between `self` and `other`.",162,{"inputs":[{"name":"ord"},{"name":"self"}],"output":{"name":"ordering"}}],[8,"PartialOrd","","Trait for values that can be compared for a sort-order.",null,null],[10,"partial_cmp","","This method returns an ordering between `self` and `other` values if one exists.",163,{"inputs":[{"name":"partialord"},{"name":"rhs"}],"output":{"name":"option"}}],[11,"lt","","This method tests less than (for `self` and `other`) and is used by the `<` operator.",163,{"inputs":[{"name":"partialord"},{"name":"rhs"}],"output":{"name":"bool"}}],[11,"le","","This method tests less than or equal to (for `self` and `other`) and is used by the `<=`\noperator.",163,{"inputs":[{"name":"partialord"},{"name":"rhs"}],"output":{"name":"bool"}}],[11,"gt","","This method tests greater than (for `self` and `other`) and is used by the `>` operator.",163,{"inputs":[{"name":"partialord"},{"name":"rhs"}],"output":{"name":"bool"}}],[11,"ge","","This method tests greater than or equal to (for `self` and `other`) and is used by the `>=`\noperator.",163,{"inputs":[{"name":"partialord"},{"name":"rhs"}],"output":{"name":"bool"}}],[5,"min","","Compare and return the minimum of two values.",null,{"inputs":[{"name":"t"},{"name":"t"}],"output":{"name":"t"}}],[5,"max","","Compare and return the maximum of two values.",null,{"inputs":[{"name":"t"},{"name":"t"}],"output":{"name":"t"}}],[5,"partial_min","","Compare and return the minimum of two values if there is one.",null,{"inputs":[{"name":"t"},{"name":"t"}],"output":{"name":"option"}}],[5,"partial_max","","Compare and return the maximum of two values if there is one.",null,{"inputs":[{"name":"t"},{"name":"t"}],"output":{"name":"option"}}],[0,"convert","std","Traits for conversions between types.",null,null],[8,"AsRef","std::convert","A cheap, reference-to-reference conversion.",null,null],[10,"as_ref","","Performs the conversion.",164,{"inputs":[{"name":"asref"}],"output":{"name":"t"}}],[8,"AsMut","","A cheap, mutable reference-to-mutable reference conversion.",null,null],[10,"as_mut","","Performs the conversion.",165,{"inputs":[{"name":"asmut"}],"output":{"name":"t"}}],[8,"Into","","A conversion that consumes `self`, which may or may not be expensive.",null,null],[10,"into","","Performs the conversion.",166,{"inputs":[{"name":"into"}],"output":{"name":"t"}}],[8,"From","","Construct `Self` via a conversion.",null,null],[10,"from","","Performs the conversion.",167,{"inputs":[{"name":"from"},{"name":"t"}],"output":{"name":"self"}}],[0,"default","std","The `Default` trait for types which may have meaningful default values.",null,null],[8,"Default","std::default","A trait that types which have a useful default value should implement.",null,null],[10,"default","","Returns the \"default value\" for a type.",168,{"inputs":[{"name":"default"}],"output":{"name":"self"}}],[0,"hash","std","Generic hashing support.",null,null],[8,"Hash","std::hash","A hashable type.",null,null],[10,"hash","","Feeds this value into the state given, updating the hasher as necessary.",169,null],[11,"hash_slice","","Feeds a slice of this type into the state provided.",169,null],[8,"Hasher","","A trait which represents the ability to hash an arbitrary stream of bytes.",null,null],[10,"finish","","Completes a round of hashing, producing the output hash generated.",170,{"inputs":[{"name":"hasher"}],"output":{"name":"u64"}}],[10,"write","","Writes some data into this `Hasher`",170,null],[11,"write_u8","","Write a single `u8` into this hasher",170,null],[11,"write_u16","","Write a single `u16` into this hasher.",170,null],[11,"write_u32","","Write a single `u32` into this hasher.",170,null],[11,"write_u64","","Write a single `u64` into this hasher.",170,null],[11,"write_usize","","Write a single `usize` into this hasher.",170,null],[11,"write_i8","","Write a single `i8` into this hasher.",170,null],[11,"write_i16","","Write a single `i16` into this hasher.",170,null],[11,"write_i32","","Write a single `i32` into this hasher.",170,null],[11,"write_i64","","Write a single `i64` into this hasher.",170,null],[11,"write_isize","","Write a single `isize` into this hasher.",170,null],[5,"hash","","Hash a value with the default SipHasher algorithm (two initial keys of 0).",null,{"inputs":[{"name":"t"}],"output":{"name":"u64"}}],[3,"SipHasher","","An implementation of SipHash 2-4.",null,null],[0,"intrinsics","std","rustc compiler intrinsics.",null,null],[5,"atomic_cxchg","std::intrinsics","",null,null],[5,"atomic_cxchg_acq","","",null,null],[5,"atomic_cxchg_rel","","",null,null],[5,"atomic_cxchg_acqrel","","",null,null],[5,"atomic_cxchg_relaxed","","",null,null],[5,"atomic_load","","",null,null],[5,"atomic_load_acq","","",null,null],[5,"atomic_load_relaxed","","",null,null],[5,"atomic_load_unordered","","",null,null],[5,"atomic_store","","",null,null],[5,"atomic_store_rel","","",null,null],[5,"atomic_store_relaxed","","",null,null],[5,"atomic_store_unordered","","",null,null],[5,"atomic_xchg","","",null,null],[5,"atomic_xchg_acq","","",null,null],[5,"atomic_xchg_rel","","",null,null],[5,"atomic_xchg_acqrel","","",null,null],[5,"atomic_xchg_relaxed","","",null,null],[5,"atomic_xadd","","",null,null],[5,"atomic_xadd_acq","","",null,null],[5,"atomic_xadd_rel","","",null,null],[5,"atomic_xadd_acqrel","","",null,null],[5,"atomic_xadd_relaxed","","",null,null],[5,"atomic_xsub","","",null,null],[5,"atomic_xsub_acq","","",null,null],[5,"atomic_xsub_rel","","",null,null],[5,"atomic_xsub_acqrel","","",null,null],[5,"atomic_xsub_relaxed","","",null,null],[5,"atomic_and","","",null,null],[5,"atomic_and_acq","","",null,null],[5,"atomic_and_rel","","",null,null],[5,"atomic_and_acqrel","","",null,null],[5,"atomic_and_relaxed","","",null,null],[5,"atomic_nand","","",null,null],[5,"atomic_nand_acq","","",null,null],[5,"atomic_nand_rel","","",null,null],[5,"atomic_nand_acqrel","","",null,null],[5,"atomic_nand_relaxed","","",null,null],[5,"atomic_or","","",null,null],[5,"atomic_or_acq","","",null,null],[5,"atomic_or_rel","","",null,null],[5,"atomic_or_acqrel","","",null,null],[5,"atomic_or_relaxed","","",null,null],[5,"atomic_xor","","",null,null],[5,"atomic_xor_acq","","",null,null],[5,"atomic_xor_rel","","",null,null],[5,"atomic_xor_acqrel","","",null,null],[5,"atomic_xor_relaxed","","",null,null],[5,"atomic_max","","",null,null],[5,"atomic_max_acq","","",null,null],[5,"atomic_max_rel","","",null,null],[5,"atomic_max_acqrel","","",null,null],[5,"atomic_max_relaxed","","",null,null],[5,"atomic_min","","",null,null],[5,"atomic_min_acq","","",null,null],[5,"atomic_min_rel","","",null,null],[5,"atomic_min_acqrel","","",null,null],[5,"atomic_min_relaxed","","",null,null],[5,"atomic_umin","","",null,null],[5,"atomic_umin_acq","","",null,null],[5,"atomic_umin_rel","","",null,null],[5,"atomic_umin_acqrel","","",null,null],[5,"atomic_umin_relaxed","","",null,null],[5,"atomic_umax","","",null,null],[5,"atomic_umax_acq","","",null,null],[5,"atomic_umax_rel","","",null,null],[5,"atomic_umax_acqrel","","",null,null],[5,"atomic_umax_relaxed","","",null,null],[5,"atomic_fence","","",null,null],[5,"atomic_fence_acq","","",null,null],[5,"atomic_fence_rel","","",null,null],[5,"atomic_fence_acqrel","","",null,null],[5,"atomic_singlethreadfence","","A compiler-only memory barrier.",null,null],[5,"atomic_singlethreadfence_acq","","",null,null],[5,"atomic_singlethreadfence_rel","","",null,null],[5,"atomic_singlethreadfence_acqrel","","",null,null],[5,"abort","","Aborts the execution of the process.",null,null],[5,"unreachable","","Tells LLVM that this point in the code is not reachable,\nenabling further optimizations.",null,null],[5,"assume","","Informs the optimizer that a condition is always true.\nIf the condition is false, the behavior is undefined.",null,null],[5,"breakpoint","","Executes a breakpoint trap, for inspection by a debugger.",null,null],[5,"size_of","","The size of a type in bytes.",null,{"inputs":[],"output":{"name":"usize"}}],[5,"move_val_init","","Moves a value to an uninitialized memory location.",null,null],[5,"min_align_of","","",null,{"inputs":[],"output":{"name":"usize"}}],[5,"pref_align_of","","",null,{"inputs":[],"output":{"name":"usize"}}],[5,"size_of_val","","",null,{"inputs":[{"name":"t"}],"output":{"name":"usize"}}],[5,"min_align_of_val","","",null,{"inputs":[{"name":"t"}],"output":{"name":"usize"}}],[5,"drop_in_place","","",null,null],[5,"type_name","","Gets a static string slice containing the name of a type.",null,{"inputs":[],"output":{"name":"str"}}],[5,"type_id","","Gets an identifier which is globally unique to the specified type. This\nfunction will return the same value for a type regardless of whichever\ncrate it is invoked in.",null,{"inputs":[],"output":{"name":"u64"}}],[5,"init_dropped","","Creates a value initialized to so that its drop flag,\nif any, says that it has been dropped.",null,{"inputs":[],"output":{"name":"t"}}],[5,"init","","Creates a value initialized to zero.",null,{"inputs":[],"output":{"name":"t"}}],[5,"uninit","","Creates an uninitialized value.",null,{"inputs":[],"output":{"name":"t"}}],[5,"forget","","Moves a value out of scope without running drop glue.",null,null],[5,"transmute","","Unsafely transforms a value of one type into a value of another type.",null,{"inputs":[{"name":"t"}],"output":{"name":"u"}}],[5,"return_address","","Gives the address for the return value of the enclosing function.",null,null],[5,"needs_drop","","Returns `true` if the actual type given as `T` requires drop\nglue; returns `false` if the actual type provided for `T`\nimplements `Copy`.",null,{"inputs":[],"output":{"name":"bool"}}],[5,"offset","","Calculates the offset from a pointer.",null,null],[5,"arith_offset","","Calculates the offset from a pointer, potentially wrapping.",null,null],[5,"copy_nonoverlapping","","Copies `count * size_of<T>` bytes from `src` to `dst`. The source\nand destination may *not* overlap.",null,null],[5,"copy","","Copies `count * size_of<T>` bytes from `src` to `dst`. The source\nand destination may overlap.",null,null],[5,"write_bytes","","Invokes memset on the specified pointer, setting `count * size_of::<T>()`\nbytes of memory starting at `dst` to `c`.",null,null],[5,"volatile_copy_nonoverlapping_memory","","Equivalent to the appropriate `llvm.memcpy.p0i8.0i8.*` intrinsic, with\na size of `count` * `size_of::<T>()` and an alignment of\n`min_align_of::<T>()`",null,null],[5,"volatile_copy_memory","","Equivalent to the appropriate `llvm.memmove.p0i8.0i8.*` intrinsic, with\na size of `count` * `size_of::<T>()` and an alignment of\n`min_align_of::<T>()`",null,null],[5,"volatile_set_memory","","Equivalent to the appropriate `llvm.memset.p0i8.*` intrinsic, with a\nsize of `count` * `size_of::<T>()` and an alignment of\n`min_align_of::<T>()`.",null,null],[5,"volatile_load","","Perform a volatile load from the `src` pointer.",null,null],[5,"volatile_store","","Perform a volatile store to the `dst` pointer.",null,null],[5,"sqrtf32","","Returns the square root of an `f32`",null,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[5,"sqrtf64","","Returns the square root of an `f64`",null,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[5,"powif32","","Raises an `f32` to an integer power.",null,{"inputs":[{"name":"f32"},{"name":"i32"}],"output":{"name":"f32"}}],[5,"powif64","","Raises an `f64` to an integer power.",null,{"inputs":[{"name":"f64"},{"name":"i32"}],"output":{"name":"f64"}}],[5,"sinf32","","Returns the sine of an `f32`.",null,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[5,"sinf64","","Returns the sine of an `f64`.",null,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[5,"cosf32","","Returns the cosine of an `f32`.",null,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[5,"cosf64","","Returns the cosine of an `f64`.",null,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[5,"powf32","","Raises an `f32` to an `f32` power.",null,{"inputs":[{"name":"f32"},{"name":"f32"}],"output":{"name":"f32"}}],[5,"powf64","","Raises an `f64` to an `f64` power.",null,{"inputs":[{"name":"f64"},{"name":"f64"}],"output":{"name":"f64"}}],[5,"expf32","","Returns the exponential of an `f32`.",null,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[5,"expf64","","Returns the exponential of an `f64`.",null,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[5,"exp2f32","","Returns 2 raised to the power of an `f32`.",null,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[5,"exp2f64","","Returns 2 raised to the power of an `f64`.",null,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[5,"logf32","","Returns the natural logarithm of an `f32`.",null,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[5,"logf64","","Returns the natural logarithm of an `f64`.",null,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[5,"log10f32","","Returns the base 10 logarithm of an `f32`.",null,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[5,"log10f64","","Returns the base 10 logarithm of an `f64`.",null,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[5,"log2f32","","Returns the base 2 logarithm of an `f32`.",null,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[5,"log2f64","","Returns the base 2 logarithm of an `f64`.",null,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[5,"fmaf32","","Returns `a * b + c` for `f32` values.",null,{"inputs":[{"name":"f32"},{"name":"f32"},{"name":"f32"}],"output":{"name":"f32"}}],[5,"fmaf64","","Returns `a * b + c` for `f64` values.",null,{"inputs":[{"name":"f64"},{"name":"f64"},{"name":"f64"}],"output":{"name":"f64"}}],[5,"fabsf32","","Returns the absolute value of an `f32`.",null,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[5,"fabsf64","","Returns the absolute value of an `f64`.",null,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[5,"copysignf32","","Copies the sign from `y` to `x` for `f32` values.",null,{"inputs":[{"name":"f32"},{"name":"f32"}],"output":{"name":"f32"}}],[5,"copysignf64","","Copies the sign from `y` to `x` for `f64` values.",null,{"inputs":[{"name":"f64"},{"name":"f64"}],"output":{"name":"f64"}}],[5,"floorf32","","Returns the largest integer less than or equal to an `f32`.",null,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[5,"floorf64","","Returns the largest integer less than or equal to an `f64`.",null,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[5,"ceilf32","","Returns the smallest integer greater than or equal to an `f32`.",null,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[5,"ceilf64","","Returns the smallest integer greater than or equal to an `f64`.",null,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[5,"truncf32","","Returns the integer part of an `f32`.",null,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[5,"truncf64","","Returns the integer part of an `f64`.",null,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[5,"rintf32","","Returns the nearest integer to an `f32`. May raise an inexact floating-point exception\nif the argument is not an integer.",null,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[5,"rintf64","","Returns the nearest integer to an `f64`. May raise an inexact floating-point exception\nif the argument is not an integer.",null,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[5,"nearbyintf32","","Returns the nearest integer to an `f32`.",null,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[5,"nearbyintf64","","Returns the nearest integer to an `f64`.",null,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[5,"roundf32","","Returns the nearest integer to an `f32`. Rounds half-way cases away from zero.",null,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[5,"roundf64","","Returns the nearest integer to an `f64`. Rounds half-way cases away from zero.",null,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[5,"ctpop8","","Returns the number of bits set in a `u8`.",null,{"inputs":[{"name":"u8"}],"output":{"name":"u8"}}],[5,"ctpop16","","Returns the number of bits set in a `u16`.",null,{"inputs":[{"name":"u16"}],"output":{"name":"u16"}}],[5,"ctpop32","","Returns the number of bits set in a `u32`.",null,{"inputs":[{"name":"u32"}],"output":{"name":"u32"}}],[5,"ctpop64","","Returns the number of bits set in a `u64`.",null,{"inputs":[{"name":"u64"}],"output":{"name":"u64"}}],[5,"ctlz8","","Returns the number of leading bits unset in a `u8`.",null,{"inputs":[{"name":"u8"}],"output":{"name":"u8"}}],[5,"ctlz16","","Returns the number of leading bits unset in a `u16`.",null,{"inputs":[{"name":"u16"}],"output":{"name":"u16"}}],[5,"ctlz32","","Returns the number of leading bits unset in a `u32`.",null,{"inputs":[{"name":"u32"}],"output":{"name":"u32"}}],[5,"ctlz64","","Returns the number of leading bits unset in a `u64`.",null,{"inputs":[{"name":"u64"}],"output":{"name":"u64"}}],[5,"cttz8","","Returns the number of trailing bits unset in a `u8`.",null,{"inputs":[{"name":"u8"}],"output":{"name":"u8"}}],[5,"cttz16","","Returns the number of trailing bits unset in a `u16`.",null,{"inputs":[{"name":"u16"}],"output":{"name":"u16"}}],[5,"cttz32","","Returns the number of trailing bits unset in a `u32`.",null,{"inputs":[{"name":"u32"}],"output":{"name":"u32"}}],[5,"cttz64","","Returns the number of trailing bits unset in a `u64`.",null,{"inputs":[{"name":"u64"}],"output":{"name":"u64"}}],[5,"bswap16","","Reverses the bytes in a `u16`.",null,{"inputs":[{"name":"u16"}],"output":{"name":"u16"}}],[5,"bswap32","","Reverses the bytes in a `u32`.",null,{"inputs":[{"name":"u32"}],"output":{"name":"u32"}}],[5,"bswap64","","Reverses the bytes in a `u64`.",null,{"inputs":[{"name":"u64"}],"output":{"name":"u64"}}],[5,"i8_add_with_overflow","","Performs checked `i8` addition.",null,null],[5,"i16_add_with_overflow","","Performs checked `i16` addition.",null,null],[5,"i32_add_with_overflow","","Performs checked `i32` addition.",null,null],[5,"i64_add_with_overflow","","Performs checked `i64` addition.",null,null],[5,"u8_add_with_overflow","","Performs checked `u8` addition.",null,null],[5,"u16_add_with_overflow","","Performs checked `u16` addition.",null,null],[5,"u32_add_with_overflow","","Performs checked `u32` addition.",null,null],[5,"u64_add_with_overflow","","Performs checked `u64` addition.",null,null],[5,"i8_sub_with_overflow","","Performs checked `i8` subtraction.",null,null],[5,"i16_sub_with_overflow","","Performs checked `i16` subtraction.",null,null],[5,"i32_sub_with_overflow","","Performs checked `i32` subtraction.",null,null],[5,"i64_sub_with_overflow","","Performs checked `i64` subtraction.",null,null],[5,"u8_sub_with_overflow","","Performs checked `u8` subtraction.",null,null],[5,"u16_sub_with_overflow","","Performs checked `u16` subtraction.",null,null],[5,"u32_sub_with_overflow","","Performs checked `u32` subtraction.",null,null],[5,"u64_sub_with_overflow","","Performs checked `u64` subtraction.",null,null],[5,"i8_mul_with_overflow","","Performs checked `i8` multiplication.",null,null],[5,"i16_mul_with_overflow","","Performs checked `i16` multiplication.",null,null],[5,"i32_mul_with_overflow","","Performs checked `i32` multiplication.",null,null],[5,"i64_mul_with_overflow","","Performs checked `i64` multiplication.",null,null],[5,"u8_mul_with_overflow","","Performs checked `u8` multiplication.",null,null],[5,"u16_mul_with_overflow","","Performs checked `u16` multiplication.",null,null],[5,"u32_mul_with_overflow","","Performs checked `u32` multiplication.",null,null],[5,"u64_mul_with_overflow","","Performs checked `u64` multiplication.",null,null],[5,"overflowing_add","","Returns (a + b) mod 2^N, where N is the width of N in bits.",null,{"inputs":[{"name":"t"},{"name":"t"}],"output":{"name":"t"}}],[5,"overflowing_sub","","Returns (a - b) mod 2^N, where N is the width of N in bits.",null,{"inputs":[{"name":"t"},{"name":"t"}],"output":{"name":"t"}}],[5,"overflowing_mul","","Returns (a * b) mod 2^N, where N is the width of N in bits.",null,{"inputs":[{"name":"t"},{"name":"t"}],"output":{"name":"t"}}],[5,"unchecked_sdiv","","Performs an unchecked signed division, which results in undefined behavior,\nin cases where y == 0, or x == isize::MIN and y == -1",null,{"inputs":[{"name":"t"},{"name":"t"}],"output":{"name":"t"}}],[5,"unchecked_udiv","","Performs an unchecked unsigned division, which results in undefined behavior,\nin cases where y == 0",null,{"inputs":[{"name":"t"},{"name":"t"}],"output":{"name":"t"}}],[5,"unchecked_srem","","Returns the remainder of an unchecked signed division, which results in\nundefined behavior, in cases where y == 0, or x == isize::MIN and y == -1",null,{"inputs":[{"name":"t"},{"name":"t"}],"output":{"name":"t"}}],[5,"unchecked_urem","","Returns the remainder of an unchecked unsigned division, which results in\nundefined behavior, in cases where y == 0",null,{"inputs":[{"name":"t"},{"name":"t"}],"output":{"name":"t"}}],[5,"discriminant_value","","Returns the value of the discriminant for the variant in 'v',\ncast to a `u64`; if `T` has no discriminant, returns 0.",null,{"inputs":[{"name":"t"}],"output":{"name":"u64"}}],[5,"try","","Rust's \"try catch\" construct which invokes the function pointer `f` with\nthe data pointer `data`, returning the exception payload if an exception\nis thrown (aka the thread panics).",null,null],[0,"iter","std","Composable external iterators",null,null],[8,"Iterator","std::iter","An interface for dealing with \"external iterators\". These types of iterators\ncan be resumed at any time as all state is stored internally as opposed to\nbeing located on the call stack.",null,null],[16,"Item","","The type of the elements being iterated",171,null],[10,"next","","Advances the iterator and returns the next value. Returns `None` when the\nend is reached.",171,{"inputs":[{"name":"iterator"}],"output":{"name":"option"}}],[11,"size_hint","","Returns a lower and upper bound on the remaining length of the iterator.",171,null],[11,"count","","Counts the number of elements in this iterator.",171,{"inputs":[{"name":"iterator"}],"output":{"name":"usize"}}],[11,"last","","Loops through the entire iterator, returning the last element.",171,{"inputs":[{"name":"iterator"}],"output":{"name":"option"}}],[11,"nth","","Loops through `n` iterations, returning the `n`th element of the\niterator.",171,{"inputs":[{"name":"iterator"},{"name":"usize"}],"output":{"name":"option"}}],[11,"chain","","Chain this iterator with another, returning a new iterator that will\nfinish iterating over the current iterator, and then iterate\nover the other specified iterator.",171,{"inputs":[{"name":"iterator"},{"name":"u"}],"output":{"name":"chain"}}],[11,"zip","","Creates an iterator that iterates over both this and the specified\niterators simultaneously, yielding the two elements as pairs. When\neither iterator returns `None`, all further invocations of `next()`\nwill return `None`.",171,{"inputs":[{"name":"iterator"},{"name":"u"}],"output":{"name":"zip"}}],[11,"map","","Creates a new iterator that will apply the specified function to each\nelement returned by the first, yielding the mapped element instead.",171,{"inputs":[{"name":"iterator"},{"name":"f"}],"output":{"name":"map"}}],[11,"filter","","Creates an iterator that applies the predicate to each element returned\nby this iterator. The only elements that will be yielded are those that\nmake the predicate evaluate to `true`.",171,{"inputs":[{"name":"iterator"},{"name":"p"}],"output":{"name":"filter"}}],[11,"filter_map","","Creates an iterator that both filters and maps elements.\nIf the specified function returns `None`, the element is skipped.\nOtherwise the option is unwrapped and the new value is yielded.",171,{"inputs":[{"name":"iterator"},{"name":"f"}],"output":{"name":"filtermap"}}],[11,"enumerate","","Creates an iterator that yields pairs `(i, val)` where `i` is the\ncurrent index of iteration and `val` is the value returned by the\niterator.",171,{"inputs":[{"name":"iterator"}],"output":{"name":"enumerate"}}],[11,"peekable","","Creates an iterator that has a `.peek()` method\nthat returns an optional reference to the next element.",171,{"inputs":[{"name":"iterator"}],"output":{"name":"peekable"}}],[11,"skip_while","","Creates an iterator that invokes the predicate on elements\nuntil it returns false. Once the predicate returns false, that\nelement and all further elements are yielded.",171,{"inputs":[{"name":"iterator"},{"name":"p"}],"output":{"name":"skipwhile"}}],[11,"take_while","","Creates an iterator that yields elements so long as the predicate\nreturns true. After the predicate returns false for the first time, no\nfurther elements will be yielded.",171,{"inputs":[{"name":"iterator"},{"name":"p"}],"output":{"name":"takewhile"}}],[11,"skip","","Creates an iterator that skips the first `n` elements of this iterator,\nand then yields all further items.",171,{"inputs":[{"name":"iterator"},{"name":"usize"}],"output":{"name":"skip"}}],[11,"take","","Creates an iterator that yields the first `n` elements of this\niterator.",171,{"inputs":[{"name":"iterator"},{"name":"usize"}],"output":{"name":"take"}}],[11,"scan","","Creates a new iterator that behaves in a similar fashion to fold.\nThere is a state which is passed between each iteration and can be\nmutated as necessary. The yielded values from the closure are yielded\nfrom the Scan instance when not `None`.",171,{"inputs":[{"name":"iterator"},{"name":"st"},{"name":"f"}],"output":{"name":"scan"}}],[11,"flat_map","","Takes a function that maps each element to a new iterator and yields\nall the elements of the produced iterators.",171,{"inputs":[{"name":"iterator"},{"name":"f"}],"output":{"name":"flatmap"}}],[11,"fuse","","Creates an iterator that yields `None` forever after the underlying\niterator yields `None`. Random-access iterator behavior is not\naffected, only single and double-ended iterator behavior.",171,{"inputs":[{"name":"iterator"}],"output":{"name":"fuse"}}],[11,"inspect","","Creates an iterator that calls a function with a reference to each\nelement before yielding it. This is often useful for debugging an\niterator pipeline.",171,{"inputs":[{"name":"iterator"},{"name":"f"}],"output":{"name":"inspect"}}],[11,"by_ref","","Creates a wrapper around a mutable reference to the iterator.",171,{"inputs":[{"name":"iterator"}],"output":{"name":"self"}}],[11,"collect","","Loops through the entire iterator, collecting all of the elements into\na container implementing `FromIterator`.",171,{"inputs":[{"name":"iterator"}],"output":{"name":"b"}}],[11,"partition","","Loops through the entire iterator, collecting all of the elements into\none of two containers, depending on a predicate. The elements of the\nfirst container satisfy the predicate, while the elements of the second\ndo not.",171,null],[11,"fold","","Performs a fold operation over the entire iterator, returning the\neventual state at the end of the iteration.",171,{"inputs":[{"name":"iterator"},{"name":"b"},{"name":"f"}],"output":{"name":"b"}}],[11,"all","","Tests whether the predicate holds true for all elements in the iterator.",171,{"inputs":[{"name":"iterator"},{"name":"f"}],"output":{"name":"bool"}}],[11,"any","","Tests whether any element of an iterator satisfies the specified\npredicate.",171,{"inputs":[{"name":"iterator"},{"name":"f"}],"output":{"name":"bool"}}],[11,"find","","Returns the first element satisfying the specified predicate.",171,{"inputs":[{"name":"iterator"},{"name":"p"}],"output":{"name":"option"}}],[11,"position","","Returns the index of the first element satisfying the specified predicate",171,{"inputs":[{"name":"iterator"},{"name":"p"}],"output":{"name":"option"}}],[11,"rposition","","Returns the index of the last element satisfying the specified predicate",171,{"inputs":[{"name":"iterator"},{"name":"p"}],"output":{"name":"option"}}],[11,"max","","Consumes the entire iterator to return the maximum element.",171,{"inputs":[{"name":"iterator"}],"output":{"name":"option"}}],[11,"min","","Consumes the entire iterator to return the minimum element.",171,{"inputs":[{"name":"iterator"}],"output":{"name":"option"}}],[11,"min_max","","`min_max` finds the minimum and maximum elements in the iterator.",171,{"inputs":[{"name":"iterator"}],"output":{"name":"minmaxresult"}}],[11,"max_by","","Returns the element that gives the maximum value from the\nspecified function.",171,{"inputs":[{"name":"iterator"},{"name":"f"}],"output":{"name":"option"}}],[11,"min_by","","Returns the element that gives the minimum value from the\nspecified function.",171,{"inputs":[{"name":"iterator"},{"name":"f"}],"output":{"name":"option"}}],[11,"rev","","Change the direction of the iterator",171,{"inputs":[{"name":"iterator"}],"output":{"name":"rev"}}],[11,"unzip","","Converts an iterator of pairs into a pair of containers.",171,null],[11,"cloned","","Creates an iterator that clones the elements it yields.",171,{"inputs":[{"name":"iterator"}],"output":{"name":"cloned"}}],[11,"cycle","","Repeats an iterator endlessly",171,{"inputs":[{"name":"iterator"}],"output":{"name":"cycle"}}],[11,"reverse_in_place","","Use an iterator to reverse a container in place.",171,null],[11,"sum","","Iterates over the entire iterator, summing up all the elements",171,{"inputs":[{"name":"iterator"}],"output":{"name":"s"}}],[11,"product","","Iterates over the entire iterator, multiplying all the elements",171,{"inputs":[{"name":"iterator"}],"output":{"name":"p"}}],[8,"FromIterator","","Conversion from an `Iterator`",null,null],[10,"from_iter","","Builds a container with elements from something iterable.",172,{"inputs":[{"name":"fromiterator"},{"name":"t"}],"output":{"name":"self"}}],[8,"IntoIterator","","Conversion into an `Iterator`",null,null],[16,"Item","","The type of the elements being iterated",173,null],[16,"IntoIter","","A container for iterating over elements of type `Item`",173,null],[10,"into_iter","","Consumes `Self` and returns an iterator over it",173,null],[8,"Extend","","A type growable from an `Iterator` implementation",null,null],[10,"extend","","Extends a container with the elements yielded by an arbitrary iterator",174,null],[8,"DoubleEndedIterator","","A range iterator able to yield elements from both ends",null,null],[10,"next_back","","Yields an element from the end of the range, returning `None` if the\nrange is empty.",175,{"inputs":[{"name":"doubleendediterator"}],"output":{"name":"option"}}],[8,"RandomAccessIterator","","An object implementing random access indexing by `usize`",null,null],[10,"indexable","","Returns the number of indexable elements. At most `std::usize::MAX`\nelements are indexable, even if the iterator represents a longer range.",176,{"inputs":[{"name":"randomaccessiterator"}],"output":{"name":"usize"}}],[10,"idx","","Returns an element at an index, or `None` if the index is out of bounds",176,{"inputs":[{"name":"randomaccessiterator"},{"name":"usize"}],"output":{"name":"option"}}],[8,"ExactSizeIterator","","An iterator that knows its exact length",null,null],[11,"len","","Returns the exact length of the iterator.",177,{"inputs":[{"name":"exactsizeiterator"}],"output":{"name":"usize"}}],[3,"Rev","","An double-ended iterator with the direction inverted",null,null],[4,"MinMaxResult","","`MinMaxResult` is an enum returned by `min_max`. See `Iterator::min_max` for\nmore detail.",null,null],[13,"NoElements","","Empty iterator",43,null],[13,"OneElement","","Iterator with one element, so the minimum and maximum are the same",43,null],[13,"MinMax","","More than one element in the iterator, the first element is not larger\nthan the second",43,null],[3,"Cloned","","An iterator that clones the elements of an underlying iterator",null,null],[3,"Cycle","","An iterator that repeats endlessly",null,null],[3,"Chain","","An iterator that strings two iterators together",null,null],[3,"Zip","","An iterator that iterates two other iterators simultaneously",null,null],[3,"Map","","An iterator that maps the values of `iter` with `f`",null,null],[3,"Filter","","An iterator that filters the elements of `iter` with `predicate`",null,null],[3,"FilterMap","","An iterator that uses `f` to both filter and map elements from `iter`",null,null],[3,"Enumerate","","An iterator that yields the current count and the element during iteration",null,null],[3,"Peekable","","An iterator with a `peek()` that returns an optional reference to the next element.",null,null],[3,"SkipWhile","","An iterator that rejects elements while `predicate` is true",null,null],[3,"TakeWhile","","An iterator that only accepts elements while `predicate` is true",null,null],[3,"Skip","","An iterator that skips over `n` elements of `iter`.",null,null],[3,"Take","","An iterator that only iterates over the first `n` iterations of `iter`.",null,null],[3,"Scan","","An iterator to maintain state while iterating another iterator",null,null],[12,"state","","The current internal state to be passed to the closure next.",57,null],[3,"FlatMap","","An iterator that maps each element to an iterator,\nand yields the elements of the produced iterators",null,null],[3,"Fuse","","An iterator that yields `None` forever after the underlying iterator\nyields `None` once.",null,null],[3,"Inspect","","An iterator that calls a function with a reference to each\nelement before yielding it.",null,null],[3,"Unfold","","An iterator that passes mutable state to a closure and yields the result.",null,null],[12,"state","","Internal state that will be passed to the closure on the next iteration",61,null],[8,"Step","","Objects that can be stepped over in both directions.",null,null],[10,"step","","Steps `self` if possible.",178,{"inputs":[{"name":"step"},{"name":"self"}],"output":{"name":"option"}}],[10,"steps_between","","Returns the number of steps between two step objects. The count is\ninclusive of `start` and exclusive of `end`.",178,{"inputs":[{"name":"step"},{"name":"self"},{"name":"self"},{"name":"self"}],"output":{"name":"option"}}],[3,"StepBy","","An adapter for stepping range iterators by a custom amount.",null,null],[3,"RangeInclusive","","An iterator over the range [start, stop]",null,null],[5,"range_inclusive","","Returns an iterator over the range [start, stop].",null,{"inputs":[{"name":"a"},{"name":"a"}],"output":{"name":"rangeinclusive"}}],[3,"Repeat","","An iterator that repeats an element endlessly",null,null],[6,"Iterate","","",null,null],[5,"iterate","","Creates a new iterator that produces an infinite sequence of\nrepeated applications of the given function `f`.",null,{"inputs":[{"name":"t"},{"name":"f"}],"output":{"name":"unfold"}}],[5,"repeat","","Creates a new iterator that endlessly repeats the element `elt`.",null,{"inputs":[{"name":"t"}],"output":{"name":"repeat"}}],[3,"Empty","","An iterator that yields nothing.",null,null],[5,"empty","","Creates an iterator that yields nothing.",null,{"inputs":[],"output":{"name":"empty"}}],[3,"Once","","An iterator that yields an element exactly once.",null,null],[5,"once","","Creates an iterator that yields an element exactly once.",null,{"inputs":[{"name":"t"}],"output":{"name":"once"}}],[0,"order","","Functions for lexicographical ordering of sequences.",null,null],[5,"equals","std::iter::order","Compare `a` and `b` for equality using `Eq`",null,{"inputs":[{"name":"l"},{"name":"r"}],"output":{"name":"bool"}}],[5,"cmp","","Order `a` and `b` lexicographically using `Ord`",null,{"inputs":[{"name":"l"},{"name":"r"}],"output":{"name":"ordering"}}],[5,"partial_cmp","","Order `a` and `b` lexicographically using `PartialOrd`",null,{"inputs":[{"name":"l"},{"name":"r"}],"output":{"name":"option"}}],[5,"eq","","Compare `a` and `b` for equality (Using partial equality, `PartialEq`)",null,{"inputs":[{"name":"l"},{"name":"r"}],"output":{"name":"bool"}}],[5,"ne","","Compares `a` and `b` for nonequality (Using partial equality, `PartialEq`)",null,{"inputs":[{"name":"l"},{"name":"r"}],"output":{"name":"bool"}}],[5,"lt","","Returns `a` < `b` lexicographically (Using partial order, `PartialOrd`)",null,{"inputs":[{"name":"l"},{"name":"r"}],"output":{"name":"bool"}}],[5,"le","","Returns `a` <= `b` lexicographically (Using partial order, `PartialOrd`)",null,{"inputs":[{"name":"l"},{"name":"r"}],"output":{"name":"bool"}}],[5,"gt","","Returns `a` > `b` lexicographically (Using partial order, `PartialOrd`)",null,{"inputs":[{"name":"l"},{"name":"r"}],"output":{"name":"bool"}}],[5,"ge","","Returns `a` >= `b` lexicographically (Using partial order, `PartialOrd`)",null,{"inputs":[{"name":"l"},{"name":"r"}],"output":{"name":"bool"}}],[0,"marker","std","Primitive traits and marker types representing basic 'kinds' of types.",null,null],[8,"Send","std::marker","Types able to be transferred across thread boundaries.",null,null],[8,"Sized","","Types with a constant size known at compile-time.",null,null],[8,"Unsize","","Types that can be \"unsized\" to a dynamically sized type.",null,null],[8,"Copy","","Types that can be copied by simply copying bits (i.e. `memcpy`).",null,null],[8,"Sync","","Types that can be safely shared between threads when aliased.",null,null],[3,"NoCopy","","A type which is considered \"not POD\", meaning that it is not\nimplicitly copyable. This is typically embedded in other types to\nensure that they are never copied, even if they lack a destructor.",null,null],[3,"PhantomData","","`PhantomData<T>` allows you to describe that a type acts as if it stores a value of type `T`,\neven though it does not. This allows you to inform the compiler about certain safety properties\nof your code.",null,null],[8,"Reflect","","A marker trait indicates a type that can be reflected over. This\ntrait is implemented for all types. Its purpose is to ensure that\nwhen you write a generic function that will employ reflection,\nthat must be reflected (no pun intended) in the generic bounds of\nthat function. Here is an example:",null,null],[0,"mem","std","Basic functions for dealing with memory",null,null],[5,"forget","std::mem","Leaks a value into the void, consuming ownership and never running its\ndestructor.",null,null],[5,"size_of","","Returns the size of a type in bytes.",null,{"inputs":[],"output":{"name":"usize"}}],[5,"size_of_val","","Returns the size of the type that `val` points to in bytes.",null,{"inputs":[{"name":"t"}],"output":{"name":"usize"}}],[5,"min_align_of","","Returns the ABI-required minimum alignment of a type",null,{"inputs":[],"output":{"name":"usize"}}],[5,"min_align_of_val","","Returns the ABI-required minimum alignment of the type of the value that `val` points to",null,{"inputs":[{"name":"t"}],"output":{"name":"usize"}}],[5,"align_of","","Returns the alignment in memory for a type.",null,{"inputs":[],"output":{"name":"usize"}}],[5,"align_of_val","","Returns the ABI-required minimum alignment of the type of the value that `val` points to",null,{"inputs":[{"name":"t"}],"output":{"name":"usize"}}],[5,"zeroed","","Creates a value initialized to zero.",null,{"inputs":[],"output":{"name":"t"}}],[5,"dropped","","Creates a value initialized to an unspecified series of bytes.",null,{"inputs":[],"output":{"name":"t"}}],[5,"uninitialized","","Bypasses Rust's normal memory-initialization checks by pretending to\nproduce a value of type T, while doing nothing at all.",null,{"inputs":[],"output":{"name":"t"}}],[5,"swap","","Swap the values at two mutable locations of the same type, without deinitialising or copying\neither one.",null,null],[5,"replace","","Replaces the value at a mutable location with a new one, returning the old value, without\ndeinitialising or copying either one.",null,{"inputs":[{"name":"t"},{"name":"t"}],"output":{"name":"t"}}],[5,"drop","","Disposes of a value.",null,null],[17,"POST_DROP_U8","","",null,null],[17,"POST_DROP_U32","","",null,null],[17,"POST_DROP_U64","","",null,null],[17,"POST_DROP_USIZE","","",null,null],[5,"transmute_copy","","Interprets `src` as `&U`, and then reads `src` without moving the contained\nvalue.",null,{"inputs":[{"name":"t"}],"output":{"name":"u"}}],[5,"copy_lifetime","","Transforms lifetime of the second pointer to match the first.",null,{"inputs":[{"name":"s"},{"name":"t"}],"output":{"name":"t"}}],[5,"copy_mut_lifetime","","Transforms lifetime of the second mutable pointer to match the first.",null,{"inputs":[{"name":"s"},{"name":"t"}],"output":{"name":"t"}}],[5,"transmute","","Unsafely transforms a value of one type into a value of another type.",null,{"inputs":[{"name":"t"}],"output":{"name":"u"}}],[0,"ops","std","Overloadable operators",null,null],[8,"Drop","std::ops","The `Drop` trait is used to run some code when a value goes out of scope.\nThis is sometimes called a 'destructor'.",null,null],[10,"drop","","The `drop` method, called when the value goes out of scope.",179,null],[8,"Add","","The `Add` trait is used to specify the functionality of `+`.",null,null],[16,"Output","","The resulting type after applying the `+` operator",180,null],[10,"add","","The method for the `+` operator",180,null],[8,"Sub","","The `Sub` trait is used to specify the functionality of `-`.",null,null],[16,"Output","","The resulting type after applying the `-` operator",181,null],[10,"sub","","The method for the `-` operator",181,null],[8,"Mul","","The `Mul` trait is used to specify the functionality of `*`.",null,null],[16,"Output","","The resulting type after applying the `*` operator",182,null],[10,"mul","","The method for the `*` operator",182,null],[8,"Div","","The `Div` trait is used to specify the functionality of `/`.",null,null],[16,"Output","","The resulting type after applying the `/` operator",183,null],[10,"div","","The method for the `/` operator",183,null],[8,"Rem","","The `Rem` trait is used to specify the functionality of `%`.",null,null],[16,"Output","","The resulting type after applying the `%` operator",184,null],[10,"rem","","The method for the `%` operator",184,null],[8,"Neg","","The `Neg` trait is used to specify the functionality of unary `-`.",null,null],[16,"Output","","The resulting type after applying the `-` operator",185,null],[10,"neg","","The method for the unary `-` operator",185,null],[8,"Not","","The `Not` trait is used to specify the functionality of unary `!`.",null,null],[16,"Output","","The resulting type after applying the `!` operator",186,null],[10,"not","","The method for the unary `!` operator",186,null],[8,"BitAnd","","The `BitAnd` trait is used to specify the functionality of `&`.",null,null],[16,"Output","","The resulting type after applying the `&` operator",187,null],[10,"bitand","","The method for the `&` operator",187,null],[8,"BitOr","","The `BitOr` trait is used to specify the functionality of `|`.",null,null],[16,"Output","","The resulting type after applying the `|` operator",188,null],[10,"bitor","","The method for the `|` operator",188,null],[8,"BitXor","","The `BitXor` trait is used to specify the functionality of `^`.",null,null],[16,"Output","","The resulting type after applying the `^` operator",189,null],[10,"bitxor","","The method for the `^` operator",189,null],[8,"Shl","","The `Shl` trait is used to specify the functionality of `<<`.",null,null],[16,"Output","","The resulting type after applying the `<<` operator",190,null],[10,"shl","","The method for the `<<` operator",190,null],[8,"Shr","","The `Shr` trait is used to specify the functionality of `>>`.",null,null],[16,"Output","","The resulting type after applying the `>>` operator",191,null],[10,"shr","","The method for the `>>` operator",191,null],[8,"Index","","The `Index` trait is used to specify the functionality of indexing operations\nlike `arr[idx]` when used in an immutable context.",null,null],[16,"Output","","The returned type after indexing",192,null],[10,"index","","The method for the indexing (`Foo[Bar]`) operation",192,null],[8,"IndexMut","","The `IndexMut` trait is used to specify the functionality of indexing\noperations like `arr[idx]`, when used in a mutable context.",null,null],[10,"index_mut","","The method for the indexing (`Foo[Bar]`) operation",193,null],[3,"RangeFull","","An unbounded range.",null,null],[3,"Range","","A (half-open) range which is bounded at both ends.",null,null],[12,"start","","The lower bound of the range (inclusive).",21,null],[12,"end","","The upper bound of the range (exclusive).",21,null],[3,"RangeFrom","","A range which is only bounded below.",null,null],[12,"start","","The lower bound of the range (inclusive).",22,null],[3,"RangeTo","","A range which is only bounded above.",null,null],[12,"end","","The upper bound of the range (exclusive).",23,null],[8,"Deref","","The `Deref` trait is used to specify the functionality of dereferencing\noperations like `*v`.",null,null],[16,"Target","","The resulting type after dereferencing",194,null],[10,"deref","","The method called to dereference a value",194,null],[8,"DerefMut","","The `DerefMut` trait is used to specify the functionality of dereferencing\nmutably like `*v = 1;`",null,null],[10,"deref_mut","","The method called to mutably dereference a value",195,null],[8,"Fn","","A version of the call operator that takes an immutable receiver.",null,null],[10,"call","","This is called when the call operator is used.",196,null],[8,"FnMut","","A version of the call operator that takes a mutable receiver.",null,null],[10,"call_mut","","This is called when the call operator is used.",197,null],[8,"FnOnce","","A version of the call operator that takes a by-value receiver.",null,null],[16,"Output","","The returned type after the call operator is used.",198,null],[10,"call_once","","This is called when the call operator is used.",198,null],[8,"CoerceUnsized","","Trait that indicates that this is a pointer or a wrapper for one,\nwhere unsizing can be performed on the pointee.",null,null],[8,"Place","","Both `in (PLACE) EXPR` and `box EXPR` desugar into expressions\nthat allocate an intermediate \"place\" that holds uninitialized\nstate.  The desugaring evaluates EXPR, and writes the result at\nthe address returned by the `pointer` method of this trait.",null,null],[10,"pointer","","Returns the address where the input value will be written.\nNote that the data at this address is generally uninitialized,\nand thus one should use `ptr::write` for initializing it.",199,null],[8,"Placer","","Interface to implementations of  `in (PLACE) EXPR`.",null,null],[16,"Place","","`Place` is the intermedate agent guarding the\nuninitialized state for `Data`.",200,null],[10,"make_place","","Creates a fresh place from `self`.",200,null],[8,"InPlace","","Specialization of `Place` trait supporting `in (PLACE) EXPR`.",null,null],[16,"Owner","","`Owner` is the type of the end value of `in (PLACE) EXPR`",201,null],[10,"finalize","","Converts self into the final value, shifting\ndeallocation/cleanup responsibilities (if any remain), over to\nthe returned instance of `Owner` and forgetting self.",201,null],[8,"Boxed","","Core trait for the `box EXPR` form.",null,null],[16,"Data","","The kind of data that is stored in this kind of box.",202,null],[16,"Place","","The place that will negotiate the storage of the data.",202,null],[10,"finalize","","Converts filled place into final owning value, shifting\ndeallocation/cleanup responsibilities (if any remain), over to\nreturned instance of `Self` and forgetting `filled`.",202,null],[8,"BoxPlace","","Specialization of `Place` trait supporting `box EXPR`.",null,null],[10,"make_place","","Creates a globally fresh place.",203,{"inputs":[{"name":"boxplace"}],"output":{"name":"self"}}],[0,"ptr","std","Raw, unsafe pointers, `*const T`, and `*mut T`",null,null],[5,"null","std::ptr","Creates a null raw pointer.",null,null],[5,"null_mut","","Creates a null mutable raw pointer.",null,null],[5,"swap","","Swaps the values at two mutable locations of the same type, without\ndeinitialising either. They may overlap, unlike `mem::swap` which is\notherwise equivalent.",null,null],[5,"replace","","Replaces the value at `dest` with `src`, returning the old\nvalue, without dropping either.",null,null],[5,"read","","Reads the value from `src` without moving it. This leaves the\nmemory in `src` unchanged.",null,null],[5,"read_and_zero","","Reads the value from `src` and nulls it out without dropping it.",null,null],[5,"read_and_drop","","Variant of read_and_zero that writes the specific drop-flag byte\n(which may be more appropriate than zero).",null,null],[5,"write","","Overwrites a memory location with the given value without reading or\ndropping the old value.",null,null],[3,"Unique","","A wrapper around a raw `*mut T` that indicates that the possessor\nof this wrapper owns the referent. This in turn implies that the\n`Unique<T>` is `Send`/`Sync` if `T` is `Send`/`Sync`, unlike a raw\n`*mut T` (which conveys no particular ownership semantics).  It\nalso implies that the referent of the pointer should not be\nmodified without a unique path to the `Unique` reference. Useful\nfor building abstractions like `Vec<T>` or `Box<T>`, which\ninternally use raw pointers to manage the memory that they own.",null,null],[5,"write_bytes","","Invokes memset on the specified pointer, setting `count * size_of::<T>()`\nbytes of memory starting at `dst` to `c`.",null,null],[5,"copy_nonoverlapping","","Copies `count * size_of<T>` bytes from `src` to `dst`. The source\nand destination may *not* overlap.",null,null],[5,"copy","","Copies `count * size_of<T>` bytes from `src` to `dst`. The source\nand destination may overlap.",null,null],[0,"raw","std","Contains struct definitions for the layout of compiler built-in types.",null,null],[3,"Slice","std::raw","The representation of a slice like `&[T]`.",null,null],[12,"data","","",72,null],[12,"len","","",72,null],[3,"TraitObject","","The representation of a trait object like `&SomeTrait`.",null,null],[12,"data","","",73,null],[12,"vtable","","",73,null],[8,"Repr","","This trait is meant to map equivalences between raw structs and their\ncorresponding rust values.",null,null],[11,"repr","","This function \"unwraps\" a rust value (without consuming it) into its raw\nstruct representation. This can be used to read/write different values\nfor the struct. This is a safe method because by default it does not\nenable write-access to the fields of the return value in safe code.",204,{"inputs":[{"name":"repr"}],"output":{"name":"t"}}],[0,"simd","std","SIMD vectors.",null,null],[3,"i8x16","std::simd","",null,null],[3,"i16x8","","",null,null],[3,"i32x4","","",null,null],[3,"i64x2","","",null,null],[3,"u8x16","","",null,null],[3,"u16x8","","",null,null],[3,"u32x4","","",null,null],[3,"u64x2","","",null,null],[3,"f32x4","","",null,null],[3,"f64x2","","",null,null],[0,"result","std","Error handling with the `Result` type",null,null],[4,"Result","std::result","`Result` is a type that represents either success (`Ok`) or failure (`Err`).",null,null],[13,"Ok","","Contains the success value",74,null],[13,"Err","","Contains the error value",74,null],[3,"Iter","","An iterator over a reference to the `Ok` variant of a `Result`.",null,null],[3,"IterMut","","An iterator over a mutable reference to the `Ok` variant of a `Result`.",null,null],[3,"IntoIter","","An iterator over the value in a `Ok` variant of a `Result`.",null,null],[5,"fold","","Performs a fold operation over the result values from an iterator.",null,{"inputs":[{"name":"iter"},{"name":"v"},{"name":"f"}],"output":{"name":"result"}}],[0,"option","std","Optional values",null,null],[4,"Option","std::option","The `Option` type. See [the module level documentation](index.html) for more.",null,null],[13,"None","","No value",67,null],[13,"Some","","Some value `T`",67,null],[3,"Iter","","An iterator over a reference of the contained item in an Option.",null,null],[3,"IterMut","","An iterator over a mutable reference of the contained item in an Option.",null,null],[3,"IntoIter","","An iterator over the item contained inside an Option.",null,null],[0,"boxed","std","A pointer type for heap allocation.",null,null],[17,"HEAP","std::boxed","A value that represents the heap. This is the default place that the `box`\nkeyword allocates into when no place is supplied.",null,null],[11,"clone","alloc::boxed","",205,{"inputs":[{"name":"exchangeheapsingleton"}],"output":{"name":"exchangeheapsingleton"}}],[11,"pointer","","",206,null],[11,"make_place","","",206,{"inputs":[{"name":"intermediatebox"}],"output":{"name":"intermediatebox"}}],[11,"finalize","","",206,{"inputs":[{"name":"intermediatebox"}],"output":{"name":"box"}}],[11,"finalize","","",207,{"inputs":[{"name":"box"},{"name":"intermediatebox"}],"output":{"name":"box"}}],[11,"make_place","","",205,{"inputs":[{"name":"exchangeheapsingleton"}],"output":{"name":"intermediatebox"}}],[11,"drop","","",206,null],[11,"new","","Allocates memory on the heap and then moves `x` into it.",207,{"inputs":[{"name":"box"},{"name":"t"}],"output":{"name":"box"}}],[11,"from_raw","","Constructs a box from the raw pointer.",207,null],[11,"into_raw","","Consumes the `Box`, returning the wrapped raw pointer.",207,null],[11,"default","","",207,{"inputs":[{"name":"box"}],"output":{"name":"box"}}],[11,"default","","",207,{"inputs":[{"name":"box"}],"output":{"name":"box"}}],[11,"clone","","Returns a new box with a `clone()` of this box's contents.",207,{"inputs":[{"name":"box"}],"output":{"name":"box"}}],[11,"clone_from","","Copies `source`'s contents into `self` without creating a new allocation.",207,null],[11,"clone","","",207,{"inputs":[{"name":"box"}],"output":{"name":"box"}}],[11,"eq","","",207,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"bool"}}],[11,"ne","","",207,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",207,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"option"}}],[11,"lt","","",207,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"bool"}}],[11,"le","","",207,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"bool"}}],[11,"ge","","",207,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"bool"}}],[11,"gt","","",207,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"bool"}}],[11,"cmp","","",207,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"ordering"}}],[11,"hash","","",207,null],[11,"downcast","","Attempt to downcast the box to a concrete type.",207,{"inputs":[{"name":"box"}],"output":{"name":"result"}}],[11,"downcast","","Attempt to downcast the box to a concrete type.",207,{"inputs":[{"name":"box"}],"output":{"name":"result"}}],[11,"fmt","","",207,{"inputs":[{"name":"box"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",207,{"inputs":[{"name":"box"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",207,{"inputs":[{"name":"box"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"deref","","",207,{"inputs":[{"name":"box"}],"output":{"name":"t"}}],[11,"deref_mut","","",207,{"inputs":[{"name":"box"}],"output":{"name":"t"}}],[11,"next","","",207,{"inputs":[{"name":"box"}],"output":{"name":"option"}}],[11,"size_hint","","",207,null],[11,"next_back","","",207,{"inputs":[{"name":"box"}],"output":{"name":"option"}}],[11,"call_once","","",207,{"inputs":[{"name":"box"},{"name":"a"}],"output":{"name":"r"}}],[11,"call_once","","",207,{"inputs":[{"name":"box"},{"name":"a"}],"output":{"name":"r"}}],[11,"clone","","",207,{"inputs":[{"name":"box"}],"output":{"name":"box"}}],[11,"fmt","alloc::arc","",208,{"inputs":[{"name":"weak"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","Constructs a new `Arc<T>`.",209,{"inputs":[{"name":"arc"},{"name":"t"}],"output":{"name":"arc"}}],[11,"downgrade","","Downgrades the `Arc<T>` to a `Weak<T>` reference.",209,{"inputs":[{"name":"arc"}],"output":{"name":"weak"}}],[11,"weak_count","","Get the number of weak references to this value.",209,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"usize"}}],[11,"strong_count","","Get the number of strong references to this value.",209,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"usize"}}],[11,"clone","","Makes a clone of the `Arc<T>`.",209,{"inputs":[{"name":"arc"}],"output":{"name":"arc"}}],[11,"deref","","",209,{"inputs":[{"name":"arc"}],"output":{"name":"t"}}],[11,"make_unique","","Make a mutable reference from the given `Arc<T>`.",209,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"t"}}],[11,"get_mut","","Returns a mutable reference to the contained value if the `Arc<T>` is unique.",209,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"option"}}],[11,"drop","","Drops the `Arc<T>`.",209,null],[11,"upgrade","","Upgrades a weak reference to a strong reference.",208,{"inputs":[{"name":"weak"}],"output":{"name":"option"}}],[11,"clone","","Makes a clone of the `Weak<T>`.",208,{"inputs":[{"name":"weak"}],"output":{"name":"weak"}}],[11,"drop","","Drops the `Weak<T>`.",208,null],[11,"eq","","Equality for two `Arc<T>`s.",209,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"bool"}}],[11,"ne","","Inequality for two `Arc<T>`s.",209,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"bool"}}],[11,"partial_cmp","","Partial comparison for two `Arc<T>`s.",209,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"option"}}],[11,"lt","","Less-than comparison for two `Arc<T>`s.",209,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"bool"}}],[11,"le","","'Less-than or equal to' comparison for two `Arc<T>`s.",209,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"bool"}}],[11,"gt","","Greater-than comparison for two `Arc<T>`s.",209,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"bool"}}],[11,"ge","","'Greater-than or equal to' comparison for two `Arc<T>`s.",209,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"bool"}}],[11,"cmp","","",209,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"ordering"}}],[11,"fmt","","",209,{"inputs":[{"name":"arc"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",209,{"inputs":[{"name":"arc"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",209,{"inputs":[{"name":"arc"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"default","","",209,{"inputs":[{"name":"arc"}],"output":{"name":"arc"}}],[11,"hash","","",209,null],[11,"new","alloc::rc","Constructs a new `Rc<T>`.",210,{"inputs":[{"name":"rc"},{"name":"t"}],"output":{"name":"rc"}}],[11,"try_unwrap","","Unwraps the contained value if the `Rc<T>` is unique.",210,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"result"}}],[11,"downgrade","","Downgrades the `Rc<T>` to a `Weak<T>` reference.",210,{"inputs":[{"name":"rc"}],"output":{"name":"weak"}}],[11,"weak_count","","Get the number of weak references to this value.",210,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"usize"}}],[11,"strong_count","","Get the number of strong references to this value.",210,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"usize"}}],[11,"is_unique","","Returns true if there are no other `Rc` or `Weak<T>` values that share\nthe same inner value.",210,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"get_mut","","Returns a mutable reference to the contained value if the `Rc<T>` is\nunique.",210,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"option"}}],[11,"make_unique","","Make a mutable reference from the given `Rc<T>`.",210,{"inputs":[{"name":"rc"}],"output":{"name":"t"}}],[11,"deref","","",210,{"inputs":[{"name":"rc"}],"output":{"name":"t"}}],[11,"drop","","Drops the `Rc<T>`.",210,null],[11,"clone","","Makes a clone of the `Rc<T>`.",210,{"inputs":[{"name":"rc"}],"output":{"name":"rc"}}],[11,"default","","Creates a new `Rc<T>`, with the `Default` value for `T`.",210,{"inputs":[{"name":"rc"}],"output":{"name":"rc"}}],[11,"eq","","Equality for two `Rc<T>`s.",210,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"ne","","Inequality for two `Rc<T>`s.",210,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"partial_cmp","","Partial comparison for two `Rc<T>`s.",210,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"option"}}],[11,"lt","","Less-than comparison for two `Rc<T>`s.",210,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"le","","'Less-than or equal to' comparison for two `Rc<T>`s.",210,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"gt","","Greater-than comparison for two `Rc<T>`s.",210,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"ge","","'Greater-than or equal to' comparison for two `Rc<T>`s.",210,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"cmp","","Comparison for two `Rc<T>`s.",210,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"ordering"}}],[11,"hash","","",210,null],[11,"fmt","","",210,{"inputs":[{"name":"rc"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",210,{"inputs":[{"name":"rc"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",210,{"inputs":[{"name":"rc"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"upgrade","","Upgrades a weak reference to a strong reference.",211,{"inputs":[{"name":"weak"}],"output":{"name":"option"}}],[11,"drop","","Drops the `Weak<T>`.",211,null],[11,"clone","","Makes a clone of the `Weak<T>`.",211,{"inputs":[{"name":"weak"}],"output":{"name":"weak"}}],[11,"fmt","","",211,{"inputs":[{"name":"weak"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","alloc::raw_vec","Creates the biggest possible RawVec without allocating. If T has positive\nsize, then this makes a RawVec with capacity 0. If T has 0 size, then it\nit makes a RawVec with capacity `usize::MAX`. Useful for implementing\ndelayed allocation.",212,{"inputs":[{"name":"rawvec"}],"output":{"name":"rawvec"}}],[11,"with_capacity","","Creates a RawVec with exactly the capacity and alignment requirements\nfor a `[T; cap]`. This is equivalent to calling RawVec::new when `cap` is 0\nor T is zero-sized. Note that if `T` is zero-sized this means you will *not*\nget a RawVec with the requested capacity!",212,{"inputs":[{"name":"rawvec"},{"name":"usize"}],"output":{"name":"rawvec"}}],[11,"from_raw_parts","","Reconstitutes a RawVec from a pointer and capacity.",212,null],[11,"from_box","","Converts a `Box<[T]>` into a `RawVec<T>`.",212,{"inputs":[{"name":"rawvec"},{"name":"box"}],"output":{"name":"rawvec"}}],[11,"ptr","","Gets a raw pointer to the start of the allocation. Note that this is\nheap::EMPTY if `cap = 0` or T is zero-sized. In the former case, you must\nbe careful.",212,null],[11,"cap","","Gets the capacity of the allocation.",212,{"inputs":[{"name":"rawvec"}],"output":{"name":"usize"}}],[11,"double","","Doubles the size of the type's backing allocation. This is common enough\nto want to do that it's easiest to just have a dedicated method. Slightly\nmore efficient logic can be provided for this than the general case.",212,null],[11,"reserve_exact","","Ensures that the buffer contains at least enough space to hold\n`used_cap + needed_extra_cap` elements. If it doesn't already,\nwill reallocate the minimum possible amount of memory necessary.\nGenerally this will be exactly the amount of memory necessary,\nbut in principle the allocator is free to give back more than\nwe asked for.",212,null],[11,"reserve","","Ensures that the buffer contains at least enough space to hold\n`used_cap + needed_extra_cap` elements. If it doesn't already have\nenough capacity, will reallocate enough space plus comfortable slack\nspace to get amortized `O(1)` behaviour. Will limit this behaviour\nif it would needlessly cause itself to panic.",212,null],[11,"shrink_to_fit","","Shrinks the allocation down to the specified amount. If the given amount\nis 0, actually completely deallocates.",212,null],[11,"into_box","","Converts the entire buffer into `Box<[T]>`.",212,{"inputs":[{"name":"rawvec"}],"output":{"name":"box"}}],[11,"unsafe_no_drop_flag_needs_drop","","This is a stupid name in the hopes that someone will find this in the\nnot too distant future and remove it with the rest of\n#[unsafe_no_drop_flag]",212,{"inputs":[{"name":"rawvec"}],"output":{"name":"bool"}}],[11,"drop","","Frees the memory owned by the RawVec *without* trying to Drop its contents.",212,null],[3,"ExchangeHeapSingleton","std::boxed","This the singleton type used solely for `boxed::HEAP`.",null,null],[3,"Box","","A pointer type for heap allocation.",null,null],[3,"IntermediateBox","","`IntermediateBox` represents uninitialized backing storage for `Box`.",null,null],[5,"into_raw","","Consumes the `Box`, returning the wrapped raw pointer.",null,null],[8,"FnBox","","`FnBox` is a version of the `FnOnce` intended for use with boxed\nclosure objects. The idea is that where one would normally store a\n`Box<FnOnce()>` in a data structure, you should use\n`Box<FnBox()>`. The two traits behave essentially the same, except\nthat a `FnBox` closure can only be called if it is boxed. (Note\nthat `FnBox` may be deprecated in the future if `Box<FnOnce()>`\nclosures become directly usable.)",null,null],[16,"Output","","",213,null],[10,"call_box","","",213,null],[0,"rc","std","Thread-local reference-counted boxes (the `Rc<T>` type).",null,null],[3,"Rc","std::rc","A reference-counted pointer type over an immutable value.",null,null],[5,"weak_count","","Get the number of weak references to this value.",null,{"inputs":[{"name":"rc"}],"output":{"name":"usize"}}],[5,"strong_count","","Get the number of strong references to this value.",null,{"inputs":[{"name":"rc"}],"output":{"name":"usize"}}],[5,"is_unique","","Returns true if there are no other `Rc` or `Weak<T>` values that share the\nsame inner value.",null,{"inputs":[{"name":"rc"}],"output":{"name":"bool"}}],[5,"try_unwrap","","Unwraps the contained value if the `Rc<T>` is unique.",null,{"inputs":[{"name":"rc"}],"output":{"name":"result"}}],[5,"get_mut","","Returns a mutable reference to the contained value if the `Rc<T>` is unique.",null,{"inputs":[{"name":"rc"}],"output":{"name":"option"}}],[3,"Weak","","A weak version of `Rc<T>`.",null,null],[0,"borrow","std","A module for working with borrowed data.",null,null],[8,"Borrow","std::borrow","A trait for borrowing data.",null,null],[10,"borrow","","Immutably borrows from an owned value.",214,{"inputs":[{"name":"borrow"}],"output":{"name":"borrowed"}}],[8,"BorrowMut","","A trait for mutably borrowing data.",null,null],[10,"borrow_mut","","Mutably borrows from an owned value.",215,{"inputs":[{"name":"borrowmut"}],"output":{"name":"borrowed"}}],[8,"ToOwned","","A generalization of `Clone` to borrowed data.",null,null],[16,"Owned","","",216,null],[10,"to_owned","","Creates owned data from borrowed data, usually by cloning.",216,null],[11,"to_mut","collections::borrow","Acquires a mutable reference to the owned form of the data.",217,null],[11,"into_owned","","Extracts the owned data.",217,null],[11,"clone","collections::binary_heap","",218,{"inputs":[{"name":"binaryheap"}],"output":{"name":"binaryheap"}}],[11,"default","","",218,{"inputs":[{"name":"binaryheap"}],"output":{"name":"binaryheap"}}],[11,"new","","Creates an empty `BinaryHeap` as a max-heap.",218,{"inputs":[{"name":"binaryheap"}],"output":{"name":"binaryheap"}}],[11,"with_capacity","","Creates an empty `BinaryHeap` with a specific capacity.\nThis preallocates enough memory for `capacity` elements,\nso that the `BinaryHeap` does not have to be reallocated\nuntil it contains at least that many values.",218,{"inputs":[{"name":"binaryheap"},{"name":"usize"}],"output":{"name":"binaryheap"}}],[11,"from_vec","","Creates a `BinaryHeap` from a vector. This is sometimes called\n`heapifying` the vector.",218,{"inputs":[{"name":"binaryheap"},{"name":"vec"}],"output":{"name":"binaryheap"}}],[11,"iter","","Returns an iterator visiting all values in the underlying vector, in\narbitrary order.",218,{"inputs":[{"name":"binaryheap"}],"output":{"name":"iter"}}],[11,"peek","","Returns the greatest item in the binary heap, or `None` if it is empty.",218,{"inputs":[{"name":"binaryheap"}],"output":{"name":"option"}}],[11,"capacity","","Returns the number of elements the binary heap can hold without reallocating.",218,{"inputs":[{"name":"binaryheap"}],"output":{"name":"usize"}}],[11,"reserve_exact","","Reserves the minimum capacity for exactly `additional` more elements to be inserted in the\ngiven `BinaryHeap`. Does nothing if the capacity is already sufficient.",218,null],[11,"reserve","","Reserves capacity for at least `additional` more elements to be inserted in the\n`BinaryHeap`. The collection may reserve more space to avoid frequent reallocations.",218,null],[11,"shrink_to_fit","","Discards as much additional capacity as possible.",218,null],[11,"pop","","Removes the greatest item from the binary heap and returns it, or `None` if it\nis empty.",218,{"inputs":[{"name":"binaryheap"}],"output":{"name":"option"}}],[11,"push","","Pushes an item onto the binary heap.",218,null],[11,"push_pop","","Pushes an item onto the binary heap, then pops the greatest item off the queue in\nan optimized fashion.",218,{"inputs":[{"name":"binaryheap"},{"name":"t"}],"output":{"name":"t"}}],[11,"replace","","Pops the greatest item off the binary heap, then pushes an item onto the queue in\nan optimized fashion. The push is done regardless of whether the binary heap\nwas empty.",218,{"inputs":[{"name":"binaryheap"},{"name":"t"}],"output":{"name":"option"}}],[11,"into_vec","","Consumes the `BinaryHeap` and returns the underlying vector\nin arbitrary order.",218,{"inputs":[{"name":"binaryheap"}],"output":{"name":"vec"}}],[11,"into_sorted_vec","","Consumes the `BinaryHeap` and returns a vector in sorted\n(ascending) order.",218,{"inputs":[{"name":"binaryheap"}],"output":{"name":"vec"}}],[11,"len","","Returns the length of the binary heap.",218,{"inputs":[{"name":"binaryheap"}],"output":{"name":"usize"}}],[11,"is_empty","","Checks if the binary heap is empty.",218,{"inputs":[{"name":"binaryheap"}],"output":{"name":"bool"}}],[11,"drain","","Clears the binary heap, returning an iterator over the removed elements.",218,{"inputs":[{"name":"binaryheap"}],"output":{"name":"drain"}}],[11,"clear","","Drops all items from the binary heap.",218,null],[11,"drop","","",219,null],[11,"clone","","",220,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[11,"next","","",220,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",220,null],[11,"next_back","","",220,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"next","","",221,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",221,null],[11,"next_back","","",221,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"next","","",222,{"inputs":[{"name":"drain"}],"output":{"name":"option"}}],[11,"size_hint","","",222,null],[11,"next_back","","",222,{"inputs":[{"name":"drain"}],"output":{"name":"option"}}],[11,"from_iter","","",218,{"inputs":[{"name":"binaryheap"},{"name":"i"}],"output":{"name":"binaryheap"}}],[11,"into_iter","","Creates a consuming iterator, that is, one that moves each value out of\nthe binary heap in arbitrary order. The binary heap cannot be used\nafter calling this.",218,{"inputs":[{"name":"binaryheap"}],"output":{"name":"intoiter"}}],[11,"extend","","",218,null],[11,"extend","","",218,null],[11,"index","collections::bit","",223,{"inputs":[{"name":"bitvec"},{"name":"usize"}],"output":{"name":"bool"}}],[11,"new","","Creates an empty `BitVec`.",223,{"inputs":[{"name":"bitvec"}],"output":{"name":"bitvec"}}],[11,"from_elem","","Creates a `BitVec` that holds `nbits` elements, setting each element\nto `bit`.",223,{"inputs":[{"name":"bitvec"},{"name":"usize"},{"name":"bool"}],"output":{"name":"bitvec"}}],[11,"with_capacity","","Constructs a new, empty `BitVec` with the specified capacity.",223,{"inputs":[{"name":"bitvec"},{"name":"usize"}],"output":{"name":"bitvec"}}],[11,"from_bytes","","Transforms a byte-vector into a `BitVec`. Each byte becomes eight bits,\nwith the most significant bits of each byte coming first. Each\nbit becomes `true` if equal to 1 or `false` if equal to 0.",223,null],[11,"from_fn","","Creates a `BitVec` of the specified length where the value at each index\nis `f(index)`.",223,{"inputs":[{"name":"bitvec"},{"name":"usize"},{"name":"f"}],"output":{"name":"bitvec"}}],[11,"get","","Retrieves the value at index `i`, or `None` if the index is out of bounds.",223,{"inputs":[{"name":"bitvec"},{"name":"usize"}],"output":{"name":"option"}}],[11,"set","","Sets the value of a bit at an index `i`.",223,null],[11,"set_all","","Sets all bits to 1.",223,null],[11,"negate","","Flips all bits.",223,null],[11,"union","","Calculates the union of two bitvectors. This acts like the bitwise `or`\nfunction.",223,{"inputs":[{"name":"bitvec"},{"name":"bitvec"}],"output":{"name":"bool"}}],[11,"intersect","","Calculates the intersection of two bitvectors. This acts like the\nbitwise `and` function.",223,{"inputs":[{"name":"bitvec"},{"name":"bitvec"}],"output":{"name":"bool"}}],[11,"difference","","Calculates the difference between two bitvectors.",223,{"inputs":[{"name":"bitvec"},{"name":"bitvec"}],"output":{"name":"bool"}}],[11,"all","","Returns `true` if all bits are 1.",223,{"inputs":[{"name":"bitvec"}],"output":{"name":"bool"}}],[11,"iter","","Returns an iterator over the elements of the vector in order.",223,{"inputs":[{"name":"bitvec"}],"output":{"name":"iter"}}],[11,"append","","Moves all bits from `other` into `Self`, leaving `other` empty.",223,null],[11,"split_off","","Splits the `BitVec` into two at the given bit,\nretaining the first half in-place and returning the second one.",223,{"inputs":[{"name":"bitvec"},{"name":"usize"}],"output":{"name":"bitvec"}}],[11,"none","","Returns `true` if all bits are 0.",223,{"inputs":[{"name":"bitvec"}],"output":{"name":"bool"}}],[11,"any","","Returns `true` if any bit is 1.",223,{"inputs":[{"name":"bitvec"}],"output":{"name":"bool"}}],[11,"to_bytes","","Organises the bits into bytes, such that the first bit in the\n`BitVec` becomes the high-order bit of the first byte. If the\nsize of the `BitVec` is not a multiple of eight then trailing bits\nwill be filled-in with `false`.",223,{"inputs":[{"name":"bitvec"}],"output":{"name":"vec"}}],[11,"eq_vec","","Compares a `BitVec` to a slice of `bool`s.\nBoth the `BitVec` and slice must have the same length.",223,null],[11,"truncate","","Shortens a `BitVec`, dropping excess elements.",223,null],[11,"reserve","","Reserves capacity for at least `additional` more bits to be inserted in the given\n`BitVec`. The collection may reserve more space to avoid frequent reallocations.",223,null],[11,"reserve_exact","","Reserves the minimum capacity for exactly `additional` more bits to be inserted in the\ngiven `BitVec`. Does nothing if the capacity is already sufficient.",223,null],[11,"capacity","","Returns the capacity in bits for this bit vector. Inserting any\nelement less than this amount will not trigger a resizing.",223,{"inputs":[{"name":"bitvec"}],"output":{"name":"usize"}}],[11,"grow","","Grows the `BitVec` in-place, adding `n` copies of `value` to the `BitVec`.",223,null],[11,"pop","","Removes the last bit from the BitVec, and returns it. Returns None if the BitVec is empty.",223,{"inputs":[{"name":"bitvec"}],"output":{"name":"option"}}],[11,"push","","Pushes a `bool` onto the end.",223,null],[11,"len","","Returns the total number of bits in this vector",223,{"inputs":[{"name":"bitvec"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns true if there are no bits in this vector",223,{"inputs":[{"name":"bitvec"}],"output":{"name":"bool"}}],[11,"clear","","Clears all bits in this vector.",223,null],[11,"default","","",223,{"inputs":[{"name":"bitvec"}],"output":{"name":"bitvec"}}],[11,"from_iter","","",223,{"inputs":[{"name":"bitvec"},{"name":"i"}],"output":{"name":"bitvec"}}],[11,"extend","","",223,null],[11,"extend","","",223,null],[11,"clone","","",223,{"inputs":[{"name":"bitvec"}],"output":{"name":"bitvec"}}],[11,"clone_from","","",223,null],[11,"partial_cmp","","",223,{"inputs":[{"name":"bitvec"},{"name":"bitvec"}],"output":{"name":"option"}}],[11,"cmp","","",223,{"inputs":[{"name":"bitvec"},{"name":"bitvec"}],"output":{"name":"ordering"}}],[11,"fmt","","",223,{"inputs":[{"name":"bitvec"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",223,null],[11,"eq","","",223,{"inputs":[{"name":"bitvec"},{"name":"bitvec"}],"output":{"name":"bool"}}],[11,"clone","","",224,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[11,"next","","",224,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",224,null],[11,"next_back","","",224,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"indexable","","",224,{"inputs":[{"name":"iter"}],"output":{"name":"usize"}}],[11,"idx","","",224,{"inputs":[{"name":"iter"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",225,{"inputs":[{"name":"bitset"}],"output":{"name":"bitset"}}],[11,"default","","",225,{"inputs":[{"name":"bitset"}],"output":{"name":"bitset"}}],[11,"from_iter","","",225,{"inputs":[{"name":"bitset"},{"name":"i"}],"output":{"name":"bitset"}}],[11,"extend","","",225,null],[11,"extend","","",225,null],[11,"partial_cmp","","",225,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":{"name":"option"}}],[11,"cmp","","",225,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":{"name":"ordering"}}],[11,"eq","","",225,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":{"name":"bool"}}],[11,"new","","Creates a new empty `BitSet`.",225,{"inputs":[{"name":"bitset"}],"output":{"name":"bitset"}}],[11,"with_capacity","","Creates a new `BitSet` with initially no contents, able to\nhold `nbits` elements without resizing.",225,{"inputs":[{"name":"bitset"},{"name":"usize"}],"output":{"name":"bitset"}}],[11,"from_bit_vec","","Creates a new `BitSet` from the given bit vector.",225,{"inputs":[{"name":"bitset"},{"name":"bitvec"}],"output":{"name":"bitset"}}],[11,"capacity","","Returns the capacity in bits for this bit vector. Inserting any\nelement less than this amount will not trigger a resizing.",225,{"inputs":[{"name":"bitset"}],"output":{"name":"usize"}}],[11,"reserve_len","","Reserves capacity for the given `BitSet` to contain `len` distinct\nelements. In the case of `BitSet` this means reallocations will not\noccur as long as all inserted elements are less than `len`.",225,null],[11,"reserve_len_exact","","Reserves the minimum capacity for the given `BitSet` to contain `len`\ndistinct elements.  In the case of `BitSet` this means reallocations\nwill not occur as long as all inserted elements are less than `len`.",225,null],[11,"into_bit_vec","","Consumes this set to return the underlying bit vector.",225,{"inputs":[{"name":"bitset"}],"output":{"name":"bitvec"}}],[11,"get_ref","","Returns a reference to the underlying bit vector.",225,{"inputs":[{"name":"bitset"}],"output":{"name":"bitvec"}}],[11,"shrink_to_fit","","Truncates the underlying vector to the least length required.",225,null],[11,"iter","","Iterator over each usize stored in the `BitSet`.",225,{"inputs":[{"name":"bitset"}],"output":{"name":"setiter"}}],[11,"union","","Iterator over each usize stored in `self` union `other`.\nSee [union_with](#method.union_with) for an efficient in-place version.",225,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":{"name":"union"}}],[11,"intersection","","Iterator over each usize stored in `self` intersect `other`.\nSee [intersect_with](#method.intersect_with) for an efficient in-place\nversion.",225,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":{"name":"intersection"}}],[11,"difference","","Iterator over each usize stored in the `self` setminus `other`.\nSee [difference_with](#method.difference_with) for an efficient in-place\nversion.",225,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":{"name":"difference"}}],[11,"symmetric_difference","","Iterator over each usize stored in the symmetric difference of `self`\nand `other`.  See\n[symmetric_difference_with](#method.symmetric_difference_with) for an\nefficient in-place version.",225,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":{"name":"symmetricdifference"}}],[11,"union_with","","Unions in-place with the specified other bit vector.",225,null],[11,"intersect_with","","Intersects in-place with the specified other bit vector.",225,null],[11,"difference_with","","Makes this bit vector the difference with the specified other bit vector\nin-place.",225,null],[11,"symmetric_difference_with","","Makes this bit vector the symmetric difference with the specified other\nbit vector in-place.",225,null],[11,"append","","Moves all elements from `other` into `Self`, leaving `other` empty.",225,null],[11,"split_off","","Splits the `BitSet` into two at the given key including the key.\nRetains the first part in-place while returning the second part.",225,{"inputs":[{"name":"bitset"},{"name":"usize"}],"output":{"name":"bitset"}}],[11,"len","","Returns the number of set bits in this set.",225,{"inputs":[{"name":"bitset"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns whether there are no bits set in this set",225,{"inputs":[{"name":"bitset"}],"output":{"name":"bool"}}],[11,"clear","","Clears all bits in this set",225,null],[11,"contains","","Returns `true` if this set contains the specified integer.",225,{"inputs":[{"name":"bitset"},{"name":"usize"}],"output":{"name":"bool"}}],[11,"is_disjoint","","Returns `true` if the set has no elements in common with `other`.\nThis is equivalent to checking for an empty intersection.",225,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":{"name":"bool"}}],[11,"is_subset","","Returns `true` if the set is a subset of another.",225,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":{"name":"bool"}}],[11,"is_superset","","Returns `true` if the set is a superset of another.",225,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":{"name":"bool"}}],[11,"insert","","Adds a value to the set. Returns `true` if the value was not already\npresent in the set.",225,{"inputs":[{"name":"bitset"},{"name":"usize"}],"output":{"name":"bool"}}],[11,"remove","","Removes a value from the set. Returns `true` if the value was\npresent in the set.",225,{"inputs":[{"name":"bitset"},{"name":"usize"}],"output":{"name":"bool"}}],[11,"fmt","","",225,{"inputs":[{"name":"bitset"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",225,null],[11,"clone","","",226,{"inputs":[{"name":"blockiter"}],"output":{"name":"blockiter"}}],[11,"clone","","",227,{"inputs":[{"name":"twobitpositions"}],"output":{"name":"twobitpositions"}}],[11,"clone","","",228,{"inputs":[{"name":"setiter"}],"output":{"name":"setiter"}}],[11,"clone","","",229,{"inputs":[{"name":"union"}],"output":{"name":"union"}}],[11,"clone","","",230,{"inputs":[{"name":"intersection"}],"output":{"name":"intersection"}}],[11,"clone","","",231,{"inputs":[{"name":"difference"}],"output":{"name":"difference"}}],[11,"clone","","",232,{"inputs":[{"name":"symmetricdifference"}],"output":{"name":"symmetricdifference"}}],[11,"next","","",226,{"inputs":[{"name":"blockiter"}],"output":{"name":"option"}}],[11,"size_hint","","",226,null],[11,"next","","",227,{"inputs":[{"name":"twobitpositions"}],"output":{"name":"option"}}],[11,"size_hint","","",227,null],[11,"next","","",228,{"inputs":[{"name":"setiter"}],"output":{"name":"option"}}],[11,"size_hint","","",228,null],[11,"next","","",229,{"inputs":[{"name":"union"}],"output":{"name":"option"}}],[11,"size_hint","","",229,null],[11,"next","","",230,{"inputs":[{"name":"intersection"}],"output":{"name":"option"}}],[11,"size_hint","","",230,null],[11,"next","","",231,{"inputs":[{"name":"difference"}],"output":{"name":"option"}}],[11,"size_hint","","",231,null],[11,"next","","",232,{"inputs":[{"name":"symmetricdifference"}],"output":{"name":"option"}}],[11,"size_hint","","",232,null],[11,"next","collections::btree::node","",233,{"inputs":[{"name":"rawitems"}],"output":{"name":"option"}}],[11,"next_back","","",233,{"inputs":[{"name":"rawitems"}],"output":{"name":"option"}}],[11,"drop","","",233,null],[11,"drop","","",234,null],[11,"as_slices","","",234,null],[11,"as_slices_mut","","",234,null],[11,"as_slices_internal","","",234,{"inputs":[{"name":"node"}],"output":{"name":"nodeslice"}}],[11,"as_slices_internal_mut","","",234,{"inputs":[{"name":"node"}],"output":{"name":"mutnodeslice"}}],[11,"keys","","",234,null],[11,"keys_mut","","",234,null],[11,"vals","","",234,null],[11,"vals_mut","","",234,null],[11,"edges","","",234,null],[11,"edges_mut","","",234,null],[11,"clone","","",234,{"inputs":[{"name":"node"}],"output":{"name":"node"}}],[11,"clone","","",235,{"inputs":[{"name":"handle"}],"output":{"name":"handle"}}],[11,"search","","Searches for the given key in the node. If it finds an exact match,\n`Found` will be yielded with the matching index. If it doesn't find an exact match,\n`GoDown` will be yielded with the index of the subtree the key must lie in.",234,{"inputs":[{"name":"node"},{"name":"noderef"},{"name":"q"}],"output":{"name":"searchresult"}}],[11,"make_leaf_root","","Make a leaf root from scratch",234,{"inputs":[{"name":"node"},{"name":"usize"}],"output":{"name":"node"}}],[11,"make_internal_root","","Make an internal root and swap it with an old root",234,null],[11,"len","","How many key-value pairs the node contains",234,{"inputs":[{"name":"node"}],"output":{"name":"usize"}}],[11,"is_empty","","Does the node not contain any key-value pairs",234,{"inputs":[{"name":"node"}],"output":{"name":"bool"}}],[11,"capacity","","How many key-value pairs the node can fit",234,{"inputs":[{"name":"node"}],"output":{"name":"usize"}}],[11,"is_leaf","","If the node has any children",234,{"inputs":[{"name":"node"}],"output":{"name":"bool"}}],[11,"is_underfull","","if the node has too few elements",234,{"inputs":[{"name":"node"}],"output":{"name":"bool"}}],[11,"is_full","","if the node cannot fit any more elements",234,{"inputs":[{"name":"node"}],"output":{"name":"bool"}}],[11,"node","","Returns a reference to the node that contains the pointed-to edge or key/value pair. This\nis very different from `edge` and `edge_mut` because those return children of the node\nreturned by `node`.",235,{"inputs":[{"name":"handle"}],"output":{"name":"node"}}],[11,"as_raw","","Converts a handle into one that stores the same information using a raw pointer. This can\nbe useful in conjunction with `from_raw` when the type system is insufficient for\ndetermining the lifetimes of the nodes.",235,{"inputs":[{"name":"handle"}],"output":{"name":"handle"}}],[11,"from_raw","","Converts from a handle stored with a raw pointer, which isn't directly usable, to a handle\nstored with a reference. This is an unsafe inverse of `as_raw`, and together they allow\nunsafely extending the lifetime of the reference to the `Node`.",235,{"inputs":[{"name":"handle"}],"output":{"name":"handle"}}],[11,"from_raw_mut","","Converts from a handle stored with a raw pointer, which isn't directly usable, to a handle\nstored with a mutable reference. This is an unsafe inverse of `as_raw`, and together they\nallow unsafely extending the lifetime of the reference to the `Node`.",235,{"inputs":[{"name":"handle"}],"output":{"name":"handle"}}],[11,"into_edge","","Turns the handle into a reference to the edge it points at. This is necessary because the\nreturned pointer has a larger lifetime than what would be returned by `edge` or `edge_mut`,\nmaking it more suitable for moving down a chain of nodes.",235,{"inputs":[{"name":"handle"}],"output":{"name":"node"}}],[11,"into_edge_mut","","Turns the handle into a mutable reference to the edge it points at. This is necessary\nbecause the returned pointer has a larger lifetime than what would be returned by\n`edge_mut`, making it more suitable for moving down a chain of nodes.",235,{"inputs":[{"name":"handle"}],"output":{"name":"node"}}],[11,"force","","Figure out whether this handle is pointing to something in a leaf node or to something in\nan internal node, clarifying the type according to the result.",235,{"inputs":[{"name":"handle"}],"output":{"name":"forceresult"}}],[11,"insert_as_leaf","","Tries to insert this key-value pair at the given index in this leaf node\nIf the node is full, we have to split it.",235,null],[11,"edge_mut","","Returns a mutable reference to the edge pointed-to by this handle. This should not be\nconfused with `node`, which references the parent node of what is returned here.",235,{"inputs":[{"name":"handle"}],"output":{"name":"node"}}],[11,"insert_as_internal","","Tries to insert this key-value pair at the given index in this internal node\nIf the node is full, we have to split it.",235,{"inputs":[{"name":"handle"},{"name":"k"},{"name":"v"},{"name":"node"}],"output":{"name":"insertionresult"}}],[11,"handle_underflow","","Handle an underflow in this node's child. We favour handling \"to the left\" because we know\nwe're empty, but our neighbour can be full. Handling to the left means when we choose to\nsteal, we pop off the end of our neighbour (always fast) and \"unshift\" ourselves\n(always slow, but at least faster since we know we're half-empty).\nHandling \"to the right\" reverses these roles. Of course, we merge whenever possible\nbecause we want dense nodes, and merging is about equal work regardless of direction.",235,null],[11,"into_kv","","Turns the handle into references to the key and value it points at. This is necessary\nbecause the returned pointers have larger lifetimes than what would be returned by `key`\nor `val`.",235,null],[11,"into_kv_mut","","Turns the handle into mutable references to the key and value it points at. This is\nnecessary because the returned pointers have larger lifetimes than what would be returned\nby `key_mut` or `val_mut`.",235,null],[11,"into_left_edge","","Convert this handle into one pointing at the edge immediately to the left of the key/value\npair pointed-to by this handle. This is useful because it returns a reference with larger\nlifetime than `left_edge`.",235,{"inputs":[{"name":"handle"}],"output":{"name":"handle"}}],[11,"key_mut","","Returns a mutable reference to the key pointed-to by this handle. This doesn't return a\nreference with a lifetime as large as `into_kv_mut`, but it also does not consume the\nhandle.",235,{"inputs":[{"name":"handle"}],"output":{"name":"k"}}],[11,"val_mut","","Returns a mutable reference to the value pointed-to by this handle. This doesn't return a\nreference with a lifetime as large as `into_kv_mut`, but it also does not consume the\nhandle.",235,{"inputs":[{"name":"handle"}],"output":{"name":"v"}}],[11,"left_edge","","Gets the handle pointing to the edge immediately to the left of the key/value pair pointed\nto by this handle.",235,{"inputs":[{"name":"handle"}],"output":{"name":"handle"}}],[11,"right_edge","","Gets the handle pointing to the edge immediately to the right of the key/value pair pointed\nto by this handle.",235,{"inputs":[{"name":"handle"}],"output":{"name":"handle"}}],[11,"remove_as_leaf","","Removes the key/value pair at the handle's location.",235,null],[11,"kv_handle","","Returns the mutable handle pointing to the key/value pair at a given index.",234,{"inputs":[{"name":"node"},{"name":"usize"}],"output":{"name":"handle"}}],[11,"iter","","",234,{"inputs":[{"name":"node"}],"output":{"name":"abstraversal"}}],[11,"iter_mut","","",234,{"inputs":[{"name":"node"}],"output":{"name":"abstraversal"}}],[11,"into_iter","","",234,{"inputs":[{"name":"node"}],"output":{"name":"abstraversal"}}],[11,"hoist_lone_child","","When a node has no keys or values and only a single edge, extract that edge.",234,null],[11,"clone","","",236,{"inputs":[{"name":"elemsandedges"}],"output":{"name":"elemsandedges"}}],[11,"next_kv","","",236,{"inputs":[{"name":"elemsandedges"}],"output":{"name":"option"}}],[11,"next_kv_back","","",236,{"inputs":[{"name":"elemsandedges"}],"output":{"name":"option"}}],[11,"next_edge","","",236,{"inputs":[{"name":"elemsandedges"}],"output":{"name":"option"}}],[11,"next_edge_back","","",236,{"inputs":[{"name":"elemsandedges"}],"output":{"name":"option"}}],[11,"next_kv","","",237,{"inputs":[{"name":"movetraversalimpl"}],"output":{"name":"option"}}],[11,"next_kv_back","","",237,{"inputs":[{"name":"movetraversalimpl"}],"output":{"name":"option"}}],[11,"next_edge","","",237,{"inputs":[{"name":"movetraversalimpl"}],"output":{"name":"option"}}],[11,"next_edge_back","","",237,{"inputs":[{"name":"movetraversalimpl"}],"output":{"name":"option"}}],[11,"drop","","",237,null],[11,"clone","","",238,{"inputs":[{"name":"abstraversal"}],"output":{"name":"abstraversal"}}],[11,"next","","",238,{"inputs":[{"name":"abstraversal"}],"output":{"name":"option"}}],[11,"next_back","","",238,{"inputs":[{"name":"abstraversal"}],"output":{"name":"option"}}],[11,"next_edge_item","","Advances the iterator and returns the item if it's an edge. Returns None\nand does nothing if the first item is not an edge.",238,{"inputs":[{"name":"abstraversal"}],"output":{"name":"option"}}],[11,"next_edge_item_back","","Advances the iterator and returns the item if it's an edge. Returns None\nand does nothing if the last item is not an edge.",238,{"inputs":[{"name":"abstraversal"}],"output":{"name":"option"}}],[11,"next_kv_item","","Advances the iterator and returns the item if it's a key-value pair. Returns None\nand does nothing if the first item is not a key-value pair.",238,{"inputs":[{"name":"abstraversal"}],"output":{"name":"option"}}],[11,"next_kv_item_back","","Advances the iterator and returns the item if it's a key-value pair. Returns None\nand does nothing if the last item is not a key-value pair.",238,{"inputs":[{"name":"abstraversal"}],"output":{"name":"option"}}],[11,"slice_from","","Returns a sub-slice with elements starting with `min_key`.",239,{"inputs":[{"name":"nodeslice"},{"name":"k"}],"output":{"name":"nodeslice"}}],[11,"slice_to","","Returns a sub-slice with elements up to and including `max_key`.",239,{"inputs":[{"name":"nodeslice"},{"name":"k"}],"output":{"name":"nodeslice"}}],[11,"iter","","Returns an iterator over key/value pairs and edges in a slice.",239,{"inputs":[{"name":"nodeslice"}],"output":{"name":"abstraversal"}}],[11,"slice_from","","Returns a sub-slice with elements starting with `min_key`.",240,{"inputs":[{"name":"mutnodeslice"},{"name":"k"}],"output":{"name":"mutnodeslice"}}],[11,"slice_to","","Returns a sub-slice with elements up to and including `max_key`.",240,{"inputs":[{"name":"mutnodeslice"},{"name":"k"}],"output":{"name":"mutnodeslice"}}],[11,"iter_mut","","Returns an iterator over key/value pairs and edges in a slice.",240,{"inputs":[{"name":"mutnodeslice"}],"output":{"name":"abstraversal"}}],[11,"clone","collections::btree::map","",241,{"inputs":[{"name":"btreemap"}],"output":{"name":"btreemap"}}],[11,"clone","","",242,{"inputs":[{"name":"absiter"}],"output":{"name":"absiter"}}],[11,"new","","Makes a new empty BTreeMap with a reasonable choice for B.",241,{"inputs":[{"name":"btreemap"}],"output":{"name":"btreemap"}}],[11,"with_b","","Makes a new empty BTreeMap with the given B.",241,{"inputs":[{"name":"btreemap"},{"name":"usize"}],"output":{"name":"btreemap"}}],[11,"clear","","Clears the map, removing all values.",241,null],[11,"get","","Returns a reference to the value corresponding to the key.",241,{"inputs":[{"name":"btreemap"},{"name":"q"}],"output":{"name":"option"}}],[11,"contains_key","","Returns true if the map contains a value for the specified key.",241,{"inputs":[{"name":"btreemap"},{"name":"q"}],"output":{"name":"bool"}}],[11,"get_mut","","Returns a mutable reference to the value corresponding to the key.",241,{"inputs":[{"name":"btreemap"},{"name":"q"}],"output":{"name":"option"}}],[11,"insert","","Inserts a key-value pair into the map. If the key already had a value\npresent in the map, that value is returned. Otherwise, `None` is returned.",241,{"inputs":[{"name":"btreemap"},{"name":"k"},{"name":"v"}],"output":{"name":"option"}}],[11,"remove","","Removes a key from the map, returning the value at the key if the key\nwas previously in the map.",241,{"inputs":[{"name":"btreemap"},{"name":"q"}],"output":{"name":"option"}}],[11,"into_iter","","Gets an owning iterator over the entries of the map.",241,{"inputs":[{"name":"btreemap"}],"output":{"name":"intoiter"}}],[11,"deref","collections::btree::map::stack","",243,{"inputs":[{"name":"idref"}],"output":{"name":"t"}}],[11,"deref_mut","","",243,{"inputs":[{"name":"idref"}],"output":{"name":"t"}}],[11,"new","","Creates a new PartialSearchStack from a BTreeMap by initializing the stack with the\nroot of the tree.",244,{"inputs":[{"name":"partialsearchstack"},{"name":"btreemap"}],"output":{"name":"partialsearchstack"}}],[11,"with","","Breaks up the stack into a `Pusher` and the next `Node`, allowing the given closure\nto interact with, search, and finally push the `Node` onto the stack. The passed in\nclosure must be polymorphic on the `'id` lifetime parameter, as this statically\nensures that only `Handle`s from the correct `Node` can be pushed.",244,{"inputs":[{"name":"partialsearchstack"},{"name":"f"}],"output":{"name":"t"}}],[11,"push","","Pushes the requested child of the stack's current top on top of the stack. If the child\nexists, then a new PartialSearchStack is yielded. Otherwise, a VacantSearchStack is\nyielded.",245,{"inputs":[{"name":"pusher"},{"name":"handle"}],"output":{"name":"partialsearchstack"}}],[11,"seal","","Converts the PartialSearchStack into a SearchStack.",245,{"inputs":[{"name":"pusher"},{"name":"handle"}],"output":{"name":"searchstack"}}],[11,"peek","","Gets a reference to the value the stack points to.",246,{"inputs":[{"name":"searchstack"}],"output":{"name":"v"}}],[11,"peek_mut","","Gets a mutable reference to the value the stack points to.",246,{"inputs":[{"name":"searchstack"}],"output":{"name":"v"}}],[11,"into_top","","Converts the stack into a mutable reference to the value it points to, with a lifetime\ntied to the original tree.",246,{"inputs":[{"name":"searchstack"}],"output":{"name":"v"}}],[11,"remove","","Removes the key and value in the top element of the stack, then handles underflows as\ndescribed in BTree's pop function.",246,{"inputs":[{"name":"searchstack"}],"output":{"name":"v"}}],[11,"insert","","Inserts the key and value into the top element in the stack, and if that node has to\nsplit recursively inserts the split contents into the next element stack until\nsplits stop.",246,{"inputs":[{"name":"searchstack"},{"name":"k"},{"name":"v"}],"output":{"name":"v"}}],[11,"from_iter","collections::btree::map","",241,{"inputs":[{"name":"btreemap"},{"name":"t"}],"output":{"name":"btreemap"}}],[11,"extend","","",241,null],[11,"extend","","",241,null],[11,"hash","","",241,null],[11,"default","","",241,{"inputs":[{"name":"btreemap"}],"output":{"name":"btreemap"}}],[11,"eq","","",241,{"inputs":[{"name":"btreemap"},{"name":"btreemap"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",241,{"inputs":[{"name":"btreemap"},{"name":"btreemap"}],"output":{"name":"option"}}],[11,"cmp","","",241,{"inputs":[{"name":"btreemap"},{"name":"btreemap"}],"output":{"name":"ordering"}}],[11,"fmt","","",241,{"inputs":[{"name":"btreemap"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"index","","",241,{"inputs":[{"name":"btreemap"},{"name":"q"}],"output":{"name":"v"}}],[11,"traverse","collections::btree::node","",238,{"inputs":[{"name":"abstraversal"},{"name":"node"}],"output":{"name":"abstraversal"}}],[11,"traverse","","",238,{"inputs":[{"name":"abstraversal"},{"name":"node"}],"output":{"name":"abstraversal"}}],[11,"traverse","","",238,{"inputs":[{"name":"abstraversal"},{"name":"node"}],"output":{"name":"abstraversal"}}],[11,"next","collections::btree::map","",242,{"inputs":[{"name":"absiter"}],"output":{"name":"option"}}],[11,"size_hint","","",242,null],[11,"next_back","","",242,{"inputs":[{"name":"absiter"}],"output":{"name":"option"}}],[11,"clone","","",247,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[11,"next","","",247,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",247,null],[11,"next_back","","",247,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"next","","",248,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"size_hint","","",248,null],[11,"next_back","","",248,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"next","","",249,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",249,null],[11,"next_back","","",249,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"clone","","",250,{"inputs":[{"name":"keys"}],"output":{"name":"keys"}}],[11,"next","","",250,{"inputs":[{"name":"keys"}],"output":{"name":"option"}}],[11,"size_hint","","",250,null],[11,"next_back","","",250,{"inputs":[{"name":"keys"}],"output":{"name":"option"}}],[11,"clone","","",251,{"inputs":[{"name":"values"}],"output":{"name":"values"}}],[11,"next","","",251,{"inputs":[{"name":"values"}],"output":{"name":"option"}}],[11,"size_hint","","",251,null],[11,"next_back","","",251,{"inputs":[{"name":"values"}],"output":{"name":"option"}}],[11,"clone","","",252,{"inputs":[{"name":"range"}],"output":{"name":"range"}}],[11,"next","","",252,{"inputs":[{"name":"range"}],"output":{"name":"option"}}],[11,"next_back","","",252,{"inputs":[{"name":"range"}],"output":{"name":"option"}}],[11,"next","","",253,{"inputs":[{"name":"rangemut"}],"output":{"name":"option"}}],[11,"next_back","","",253,{"inputs":[{"name":"rangemut"}],"output":{"name":"option"}}],[11,"get","","Returns a mutable reference to the entry if occupied, or the VacantEntry if vacant",254,{"inputs":[{"name":"entry"}],"output":{"name":"result"}}],[11,"or_insert","","Ensures a value is in the entry by inserting the default if empty, and returns\na mutable reference to the value in the entry.",254,{"inputs":[{"name":"entry"},{"name":"v"}],"output":{"name":"v"}}],[11,"or_insert_with","","Ensures a value is in the entry by inserting the result of the default function if empty,\nand returns a mutable reference to the value in the entry.",254,{"inputs":[{"name":"entry"},{"name":"f"}],"output":{"name":"v"}}],[11,"insert","","Sets the value of the entry with the VacantEntry's key,\nand returns a mutable reference to it.",255,{"inputs":[{"name":"vacantentry"},{"name":"v"}],"output":{"name":"v"}}],[11,"get","","Gets a reference to the value in the entry.",256,{"inputs":[{"name":"occupiedentry"}],"output":{"name":"v"}}],[11,"get_mut","","Gets a mutable reference to the value in the entry.",256,{"inputs":[{"name":"occupiedentry"}],"output":{"name":"v"}}],[11,"into_mut","","Converts the entry into a mutable reference to its value.",256,{"inputs":[{"name":"occupiedentry"}],"output":{"name":"v"}}],[11,"insert","","Sets the value of the entry with the OccupiedEntry's key,\nand returns the entry's old value.",256,{"inputs":[{"name":"occupiedentry"},{"name":"v"}],"output":{"name":"v"}}],[11,"remove","","Takes the value of the entry out of the map, and returns it.",256,{"inputs":[{"name":"occupiedentry"}],"output":{"name":"v"}}],[11,"iter","","Gets an iterator over the entries of the map.",241,{"inputs":[{"name":"btreemap"}],"output":{"name":"iter"}}],[11,"iter_mut","","Gets a mutable iterator over the entries of the map.",241,{"inputs":[{"name":"btreemap"}],"output":{"name":"itermut"}}],[11,"keys","","Gets an iterator over the keys of the map.",241,{"inputs":[{"name":"btreemap"}],"output":{"name":"keys"}}],[11,"values","","Gets an iterator over the values of the map.",241,{"inputs":[{"name":"btreemap"}],"output":{"name":"values"}}],[11,"len","","Returns the number of elements in the map.",241,{"inputs":[{"name":"btreemap"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns true if the map contains no elements.",241,{"inputs":[{"name":"btreemap"}],"output":{"name":"bool"}}],[11,"range","","Constructs a double-ended iterator over a sub-range of elements in the map, starting\nat min, and ending at max. If min is `Unbounded`, then it will be treated as \"negative\ninfinity\", and if max is `Unbounded`, then it will be treated as \"positive infinity\".\nThus range(Unbounded, Unbounded) will yield the whole collection.",241,{"inputs":[{"name":"btreemap"},{"name":"bound"},{"name":"bound"}],"output":{"name":"range"}}],[11,"range_mut","","Constructs a mutable double-ended iterator over a sub-range of elements in the map, starting\nat min, and ending at max. If min is `Unbounded`, then it will be treated as \"negative\ninfinity\", and if max is `Unbounded`, then it will be treated as \"positive infinity\".\nThus range(Unbounded, Unbounded) will yield the whole collection.",241,{"inputs":[{"name":"btreemap"},{"name":"bound"},{"name":"bound"}],"output":{"name":"rangemut"}}],[11,"entry","","Gets the given key's corresponding entry in the map for in-place manipulation.",241,{"inputs":[{"name":"btreemap"},{"name":"k"}],"output":{"name":"entry"}}],[11,"partial_cmp","collections::btree::set","",257,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"option"}}],[11,"lt","","",257,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"bool"}}],[11,"le","","",257,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"bool"}}],[11,"gt","","",257,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"bool"}}],[11,"ge","","",257,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"bool"}}],[11,"cmp","","",257,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"ordering"}}],[11,"eq","","",257,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"bool"}}],[11,"ne","","",257,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"bool"}}],[11,"hash","","",257,null],[11,"clone","","",257,{"inputs":[{"name":"btreeset"}],"output":{"name":"btreeset"}}],[11,"new","","Makes a new BTreeSet with a reasonable choice of B.",257,{"inputs":[{"name":"btreeset"}],"output":{"name":"btreeset"}}],[11,"with_b","","Makes a new BTreeSet with the given B.",257,{"inputs":[{"name":"btreeset"},{"name":"usize"}],"output":{"name":"btreeset"}}],[11,"iter","","Gets an iterator over the BTreeSet's contents.",257,{"inputs":[{"name":"btreeset"}],"output":{"name":"iter"}}],[11,"range","","Constructs a double-ended iterator over a sub-range of elements in the set, starting\nat min, and ending at max. If min is `Unbounded`, then it will be treated as \"negative\ninfinity\", and if max is `Unbounded`, then it will be treated as \"positive infinity\".\nThus range(Unbounded, Unbounded) will yield the whole collection.",257,{"inputs":[{"name":"btreeset"},{"name":"bound"},{"name":"bound"}],"output":{"name":"range"}}],[11,"difference","","Visits the values representing the difference, in ascending order.",257,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"difference"}}],[11,"symmetric_difference","","Visits the values representing the symmetric difference, in ascending order.",257,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"symmetricdifference"}}],[11,"intersection","","Visits the values representing the intersection, in ascending order.",257,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"intersection"}}],[11,"union","","Visits the values representing the union, in ascending order.",257,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"union"}}],[11,"len","","Returns the number of elements in the set.",257,{"inputs":[{"name":"btreeset"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns true if the set contains no elements.",257,{"inputs":[{"name":"btreeset"}],"output":{"name":"bool"}}],[11,"clear","","Clears the set, removing all values.",257,null],[11,"contains","","Returns `true` if the set contains a value.",257,{"inputs":[{"name":"btreeset"},{"name":"q"}],"output":{"name":"bool"}}],[11,"is_disjoint","","Returns `true` if the set has no elements in common with `other`.\nThis is equivalent to checking for an empty intersection.",257,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"bool"}}],[11,"is_subset","","Returns `true` if the set is a subset of another.",257,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"bool"}}],[11,"is_superset","","Returns `true` if the set is a superset of another.",257,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"bool"}}],[11,"insert","","Adds a value to the set. Returns `true` if the value was not already\npresent in the set.",257,{"inputs":[{"name":"btreeset"},{"name":"t"}],"output":{"name":"bool"}}],[11,"remove","","Removes a value from the set. Returns `true` if the value was\npresent in the set.",257,{"inputs":[{"name":"btreeset"},{"name":"q"}],"output":{"name":"bool"}}],[11,"from_iter","","",257,{"inputs":[{"name":"btreeset"},{"name":"i"}],"output":{"name":"btreeset"}}],[11,"into_iter","","Gets an iterator for moving out the BtreeSet's contents.",257,{"inputs":[{"name":"btreeset"}],"output":{"name":"intoiter"}}],[11,"extend","","",257,null],[11,"extend","","",257,null],[11,"default","","",257,{"inputs":[{"name":"btreeset"}],"output":{"name":"btreeset"}}],[11,"fmt","","",257,{"inputs":[{"name":"btreeset"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",258,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[11,"next","","",258,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",258,null],[11,"next_back","","",258,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"next","","",259,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",259,null],[11,"next_back","","",259,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"clone","","",260,{"inputs":[{"name":"range"}],"output":{"name":"range"}}],[11,"next","","",260,{"inputs":[{"name":"range"}],"output":{"name":"option"}}],[11,"next_back","","",260,{"inputs":[{"name":"range"}],"output":{"name":"option"}}],[11,"clone","","",261,{"inputs":[{"name":"difference"}],"output":{"name":"difference"}}],[11,"next","","",261,{"inputs":[{"name":"difference"}],"output":{"name":"option"}}],[11,"clone","","",262,{"inputs":[{"name":"symmetricdifference"}],"output":{"name":"symmetricdifference"}}],[11,"next","","",262,{"inputs":[{"name":"symmetricdifference"}],"output":{"name":"option"}}],[11,"clone","","",263,{"inputs":[{"name":"intersection"}],"output":{"name":"intersection"}}],[11,"next","","",263,{"inputs":[{"name":"intersection"}],"output":{"name":"option"}}],[11,"clone","","",264,{"inputs":[{"name":"union"}],"output":{"name":"union"}}],[11,"next","","",264,{"inputs":[{"name":"union"}],"output":{"name":"option"}}],[11,"borrow","std::boxed","",207,{"inputs":[{"name":"box"}],"output":{"name":"t"}}],[11,"borrow_mut","","",207,{"inputs":[{"name":"box"}],"output":{"name":"t"}}],[11,"borrow","std::rc","",210,{"inputs":[{"name":"rc"}],"output":{"name":"t"}}],[11,"borrow","alloc::arc","",209,{"inputs":[{"name":"arc"}],"output":{"name":"t"}}],[11,"borrow","collections::borrow","",217,{"inputs":[{"name":"cow"}],"output":{"name":"b"}}],[11,"clone","","",217,{"inputs":[{"name":"cow"}],"output":{"name":"cow"}}],[11,"deref","","",217,{"inputs":[{"name":"cow"}],"output":{"name":"b"}}],[11,"cmp","","",217,{"inputs":[{"name":"cow"},{"name":"cow"}],"output":{"name":"ordering"}}],[11,"eq","","",217,{"inputs":[{"name":"cow"},{"name":"cow"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",217,{"inputs":[{"name":"cow"},{"name":"cow"}],"output":{"name":"option"}}],[11,"fmt","","",217,{"inputs":[{"name":"cow"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",217,{"inputs":[{"name":"cow"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",217,null],[11,"into_cow","","",217,{"inputs":[{"name":"cow"}],"output":{"name":"cow"}}],[11,"as_ref","","",217,{"inputs":[{"name":"cow"}],"output":{"name":"t"}}],[11,"hash","collections::enum_set","",265,null],[11,"cmp","","",265,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",265,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"option"}}],[11,"lt","","",265,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"bool"}}],[11,"le","","",265,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"bool"}}],[11,"gt","","",265,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"bool"}}],[11,"ge","","",265,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"bool"}}],[11,"eq","","",265,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"bool"}}],[11,"ne","","",265,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"bool"}}],[11,"clone","","",265,{"inputs":[{"name":"enumset"}],"output":{"name":"enumset"}}],[11,"fmt","","",265,{"inputs":[{"name":"enumset"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","Returns an empty `EnumSet`.",265,{"inputs":[{"name":"enumset"}],"output":{"name":"enumset"}}],[11,"len","","Returns the number of elements in the given `EnumSet`.",265,{"inputs":[{"name":"enumset"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns true if the `EnumSet` is empty.",265,{"inputs":[{"name":"enumset"}],"output":{"name":"bool"}}],[11,"clear","","",265,null],[11,"is_disjoint","","Returns `false` if the `EnumSet` contains any enum of the given `EnumSet`.",265,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"bool"}}],[11,"is_superset","","Returns `true` if a given `EnumSet` is included in this `EnumSet`.",265,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"bool"}}],[11,"is_subset","","Returns `true` if this `EnumSet` is included in the given `EnumSet`.",265,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"bool"}}],[11,"union","","Returns the union of both `EnumSets`.",265,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"enumset"}}],[11,"intersection","","Returns the intersection of both `EnumSets`.",265,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"enumset"}}],[11,"insert","","Adds an enum to the `EnumSet`, and returns `true` if it wasn't there before",265,{"inputs":[{"name":"enumset"},{"name":"e"}],"output":{"name":"bool"}}],[11,"remove","","Removes an enum from the EnumSet",265,{"inputs":[{"name":"enumset"},{"name":"e"}],"output":{"name":"bool"}}],[11,"contains","","Returns `true` if an `EnumSet` contains a given enum.",265,{"inputs":[{"name":"enumset"},{"name":"e"}],"output":{"name":"bool"}}],[11,"iter","","Returns an iterator over an `EnumSet`.",265,{"inputs":[{"name":"enumset"}],"output":{"name":"iter"}}],[11,"sub","","",265,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"enumset"}}],[11,"bitor","","",265,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"enumset"}}],[11,"bitand","","",265,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"enumset"}}],[11,"bitxor","","",265,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"enumset"}}],[11,"clone","","",266,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[11,"next","","",266,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",266,null],[11,"from_iter","","",265,{"inputs":[{"name":"enumset"},{"name":"i"}],"output":{"name":"enumset"}}],[11,"extend","","",265,null],[11,"extend","","",265,null],[11,"clone","collections::linked_list","",267,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[11,"clone","","",268,{"inputs":[{"name":"intoiter"}],"output":{"name":"intoiter"}}],[11,"from","","",269,{"inputs":[{"name":"rawlink"},{"name":"option"}],"output":{"name":"rawlink"}}],[11,"clone","","",269,{"inputs":[{"name":"rawlink"}],"output":{"name":"rawlink"}}],[11,"default","","",270,{"inputs":[{"name":"linkedlist"}],"output":{"name":"linkedlist"}}],[11,"new","","Creates an empty `LinkedList`.",270,{"inputs":[{"name":"linkedlist"}],"output":{"name":"linkedlist"}}],[11,"append","","Moves all elements from `other` to the end of the list.",270,null],[11,"iter","","Provides a forward iterator.",270,{"inputs":[{"name":"linkedlist"}],"output":{"name":"iter"}}],[11,"iter_mut","","Provides a forward iterator with mutable references.",270,{"inputs":[{"name":"linkedlist"}],"output":{"name":"itermut"}}],[11,"is_empty","","Returns `true` if the `LinkedList` is empty.",270,{"inputs":[{"name":"linkedlist"}],"output":{"name":"bool"}}],[11,"len","","Returns the length of the `LinkedList`.",270,{"inputs":[{"name":"linkedlist"}],"output":{"name":"usize"}}],[11,"clear","","Removes all elements from the `LinkedList`.",270,null],[11,"front","","Provides a reference to the front element, or `None` if the list is\nempty.",270,{"inputs":[{"name":"linkedlist"}],"output":{"name":"option"}}],[11,"front_mut","","Provides a mutable reference to the front element, or `None` if the list\nis empty.",270,{"inputs":[{"name":"linkedlist"}],"output":{"name":"option"}}],[11,"back","","Provides a reference to the back element, or `None` if the list is\nempty.",270,{"inputs":[{"name":"linkedlist"}],"output":{"name":"option"}}],[11,"back_mut","","Provides a mutable reference to the back element, or `None` if the list\nis empty.",270,{"inputs":[{"name":"linkedlist"}],"output":{"name":"option"}}],[11,"push_front","","Adds an element first in the list.",270,null],[11,"pop_front","","Removes the first element and returns it, or `None` if the list is\nempty.",270,{"inputs":[{"name":"linkedlist"}],"output":{"name":"option"}}],[11,"push_back","","Appends an element to the back of a list",270,null],[11,"pop_back","","Removes the last element from a list and returns it, or `None` if\nit is empty.",270,{"inputs":[{"name":"linkedlist"}],"output":{"name":"option"}}],[11,"split_off","","Splits the list into two at the given index. Returns everything after the given index,\nincluding the index.",270,{"inputs":[{"name":"linkedlist"},{"name":"usize"}],"output":{"name":"linkedlist"}}],[11,"drop","","",270,null],[11,"next","","",267,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",267,null],[11,"next_back","","",267,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"next","","",271,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"size_hint","","",271,null],[11,"next_back","","",271,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"insert_next","","Inserts `elt` just after the element most recently returned by `.next()`.\nThe inserted element does not appear in the iteration.",271,null],[11,"peek_next","","Provides a reference to the next element, without changing the iterator.",271,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"next","","",268,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",268,null],[11,"next_back","","",268,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"from_iter","","",270,{"inputs":[{"name":"linkedlist"},{"name":"t"}],"output":{"name":"linkedlist"}}],[11,"into_iter","","Consumes the list into an iterator yielding elements by value.",270,{"inputs":[{"name":"linkedlist"}],"output":{"name":"intoiter"}}],[11,"extend","","",270,null],[11,"extend","","",270,null],[11,"eq","","",270,{"inputs":[{"name":"linkedlist"},{"name":"linkedlist"}],"output":{"name":"bool"}}],[11,"ne","","",270,{"inputs":[{"name":"linkedlist"},{"name":"linkedlist"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",270,{"inputs":[{"name":"linkedlist"},{"name":"linkedlist"}],"output":{"name":"option"}}],[11,"cmp","","",270,{"inputs":[{"name":"linkedlist"},{"name":"linkedlist"}],"output":{"name":"ordering"}}],[11,"clone","","",270,{"inputs":[{"name":"linkedlist"}],"output":{"name":"linkedlist"}}],[11,"fmt","","",270,{"inputs":[{"name":"linkedlist"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",270,null],[11,"start","std::ops","",22,{"inputs":[{"name":"rangefrom"}],"output":{"name":"option"}}],[11,"end","","",23,{"inputs":[{"name":"rangeto"}],"output":{"name":"option"}}],[11,"start","","",21,{"inputs":[{"name":"range"}],"output":{"name":"option"}}],[11,"end","","",21,{"inputs":[{"name":"range"}],"output":{"name":"option"}}],[11,"clone","collections::slice","",272,{"inputs":[{"name":"elementswaps"}],"output":{"name":"elementswaps"}}],[11,"new","","Creates an `ElementSwaps` iterator for a sequence of `length` elements.",272,{"inputs":[{"name":"elementswaps"},{"name":"usize"}],"output":{"name":"elementswaps"}}],[11,"borrow","collections::vec","",273,null],[11,"borrow_mut","","",273,null],[11,"clone","collections::slice","",274,{"inputs":[{"name":"direction"}],"output":{"name":"direction"}}],[11,"clone","","",275,{"inputs":[{"name":"sizedirection"}],"output":{"name":"sizedirection"}}],[11,"next","","",272,{"inputs":[{"name":"elementswaps"}],"output":{"name":"option"}}],[11,"size_hint","","",272,null],[11,"next","","",276,{"inputs":[{"name":"permutations"}],"output":{"name":"option"}}],[11,"size_hint","","",276,null],[11,"clone","collections::str","",277,{"inputs":[{"name":"decompositiontype"}],"output":{"name":"decompositiontype"}}],[11,"clone","","",278,{"inputs":[{"name":"decompositions"}],"output":{"name":"decompositions"}}],[11,"next","","",278,{"inputs":[{"name":"decompositions"}],"output":{"name":"option"}}],[11,"size_hint","","",278,null],[11,"clone","","",279,{"inputs":[{"name":"recompositionstate"}],"output":{"name":"recompositionstate"}}],[11,"clone","","",280,{"inputs":[{"name":"recompositions"}],"output":{"name":"recompositions"}}],[11,"next","","",280,{"inputs":[{"name":"recompositions"}],"output":{"name":"option"}}],[11,"clone","","",281,{"inputs":[{"name":"utf16units"}],"output":{"name":"utf16units"}}],[11,"next","","",281,{"inputs":[{"name":"utf16units"}],"output":{"name":"option"}}],[11,"size_hint","","",281,null],[11,"borrow","collections::string","",282,{"inputs":[{"name":"string"}],"output":{"name":"str"}}],[11,"cmp","","",282,{"inputs":[{"name":"string"},{"name":"string"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",282,{"inputs":[{"name":"string"},{"name":"string"}],"output":{"name":"option"}}],[11,"lt","","",282,{"inputs":[{"name":"string"},{"name":"string"}],"output":{"name":"bool"}}],[11,"le","","",282,{"inputs":[{"name":"string"},{"name":"string"}],"output":{"name":"bool"}}],[11,"gt","","",282,{"inputs":[{"name":"string"},{"name":"string"}],"output":{"name":"bool"}}],[11,"ge","","",282,{"inputs":[{"name":"string"},{"name":"string"}],"output":{"name":"bool"}}],[11,"clone","","",282,{"inputs":[{"name":"string"}],"output":{"name":"string"}}],[11,"fmt","","",283,{"inputs":[{"name":"fromutf8error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",284,{"inputs":[{"name":"fromutf16error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","Creates a new string buffer initialized with the empty string.",282,{"inputs":[{"name":"string"}],"output":{"name":"string"}}],[11,"with_capacity","","Creates a new string buffer with the given capacity.\nThe string will be able to hold exactly `capacity` bytes without\nreallocating. If `capacity` is 0, the string will not allocate.",282,{"inputs":[{"name":"string"},{"name":"usize"}],"output":{"name":"string"}}],[11,"from_str","","Creates a new string buffer from the given string.",282,{"inputs":[{"name":"string"},{"name":"str"}],"output":{"name":"string"}}],[11,"from_utf8","","Returns the vector as a string buffer, if possible, taking care not to\ncopy it.",282,{"inputs":[{"name":"string"},{"name":"vec"}],"output":{"name":"result"}}],[11,"from_utf8_lossy","","Converts a vector of bytes to a new UTF-8 string.\nAny invalid UTF-8 sequences are replaced with U+FFFD REPLACEMENT CHARACTER.",282,null],[11,"from_utf16","","Decode a UTF-16 encoded vector `v` into a `String`, returning `None`\nif `v` contains any invalid data.",282,null],[11,"from_utf16_lossy","","Decode a UTF-16 encoded vector `v` into a string, replacing\ninvalid data with the replacement character (U+FFFD).",282,null],[11,"from_raw_parts","","Creates a new `String` from a length, capacity, and pointer.",282,null],[11,"from_utf8_unchecked","","Converts a vector of bytes to a new `String` without checking if\nit contains valid UTF-8. This is unsafe because it assumes that\nthe UTF-8-ness of the vector has already been validated.",282,{"inputs":[{"name":"string"},{"name":"vec"}],"output":{"name":"string"}}],[11,"into_bytes","","Returns the underlying byte buffer, encoded as UTF-8.",282,{"inputs":[{"name":"string"}],"output":{"name":"vec"}}],[11,"as_str","","Extracts a string slice containing the entire string.",282,{"inputs":[{"name":"string"}],"output":{"name":"str"}}],[11,"push_str","","Pushes the given string onto this string buffer.",282,null],[11,"capacity","","Returns the number of bytes that this string buffer can hold without\nreallocating.",282,{"inputs":[{"name":"string"}],"output":{"name":"usize"}}],[11,"reserve","","Reserves capacity for at least `additional` more bytes to be inserted\nin the given `String`. The collection may reserve more space to avoid\nfrequent reallocations.",282,null],[11,"reserve_exact","","Reserves the minimum capacity for exactly `additional` more bytes to be\ninserted in the given `String`. Does nothing if the capacity is already\nsufficient.",282,null],[11,"shrink_to_fit","","Shrinks the capacity of this string buffer to match its length.",282,null],[11,"push","","Adds the given character to the end of the string.",282,null],[11,"as_bytes","","Works with the underlying buffer as a byte slice.",282,null],[11,"truncate","","Shortens a string to the specified length.",282,null],[11,"pop","","Removes the last character from the string buffer and returns it.\nReturns `None` if this string buffer is empty.",282,{"inputs":[{"name":"string"}],"output":{"name":"option"}}],[11,"remove","","Removes the character from the string buffer at byte position `idx` and\nreturns it.",282,{"inputs":[{"name":"string"},{"name":"usize"}],"output":{"name":"char"}}],[11,"insert","","Inserts a character into the string buffer at byte position `idx`.",282,null],[11,"as_mut_vec","","Views the string buffer as a mutable sequence of bytes.",282,{"inputs":[{"name":"string"}],"output":{"name":"vec"}}],[11,"len","","Returns the number of bytes in this string.",282,{"inputs":[{"name":"string"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns true if the string contains no bytes",282,{"inputs":[{"name":"string"}],"output":{"name":"bool"}}],[11,"clear","","Truncates the string, returning it to 0 length.",282,null],[11,"drain","","Create a draining iterator that removes the specified range in the string\nand yields the removed chars from start to end. The element range is\nremoved even if the iterator is not consumed until the end.",282,{"inputs":[{"name":"string"},{"name":"r"}],"output":{"name":"drain"}}],[11,"into_boxed_slice","","Converts the string into `Box<str>`.",282,{"inputs":[{"name":"string"}],"output":{"name":"box"}}],[11,"into_bytes","","Consumes this error, returning the bytes that were attempted to make a\n`String` with.",283,{"inputs":[{"name":"fromutf8error"}],"output":{"name":"vec"}}],[11,"utf8_error","","Access the underlying UTF8-error that was the cause of this error.",283,{"inputs":[{"name":"fromutf8error"}],"output":{"name":"utf8error"}}],[11,"fmt","","",283,{"inputs":[{"name":"fromutf8error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",284,{"inputs":[{"name":"fromutf16error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from_iter","","",282,{"inputs":[{"name":"string"},{"name":"i"}],"output":{"name":"string"}}],[11,"from_iter","","",282,{"inputs":[{"name":"string"},{"name":"i"}],"output":{"name":"string"}}],[11,"extend","","",282,null],[11,"extend","","",282,null],[11,"extend","","",282,null],[11,"eq","","",282,{"inputs":[{"name":"string"},{"name":"string"}],"output":{"name":"bool"}}],[11,"ne","","",282,{"inputs":[{"name":"string"},{"name":"string"}],"output":{"name":"bool"}}],[11,"eq","","",282,{"inputs":[{"name":"string"},{"name":"str"}],"output":{"name":"bool"}}],[11,"ne","","",282,{"inputs":[{"name":"string"},{"name":"str"}],"output":{"name":"bool"}}],[11,"eq","","",282,{"inputs":[{"name":"string"},{"name":"str"}],"output":{"name":"bool"}}],[11,"ne","","",282,{"inputs":[{"name":"string"},{"name":"str"}],"output":{"name":"bool"}}],[11,"eq","collections::borrow","",217,{"inputs":[{"name":"cow"},{"name":"str"}],"output":{"name":"bool"}}],[11,"ne","","",217,{"inputs":[{"name":"cow"},{"name":"str"}],"output":{"name":"bool"}}],[11,"eq","","",217,{"inputs":[{"name":"cow"},{"name":"string"}],"output":{"name":"bool"}}],[11,"ne","","",217,{"inputs":[{"name":"cow"},{"name":"string"}],"output":{"name":"bool"}}],[11,"eq","collections::string","",282,{"inputs":[{"name":"string"},{"name":"cow"}],"output":{"name":"bool"}}],[11,"ne","","",282,{"inputs":[{"name":"string"},{"name":"cow"}],"output":{"name":"bool"}}],[11,"eq","collections::borrow","",217,{"inputs":[{"name":"cow"},{"name":"str"}],"output":{"name":"bool"}}],[11,"ne","","",217,{"inputs":[{"name":"cow"},{"name":"str"}],"output":{"name":"bool"}}],[11,"default","collections::string","",282,{"inputs":[{"name":"string"}],"output":{"name":"string"}}],[11,"fmt","","",282,{"inputs":[{"name":"string"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",282,{"inputs":[{"name":"string"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",282,null],[11,"add","","",282,{"inputs":[{"name":"string"},{"name":"str"}],"output":{"name":"string"}}],[11,"index","","",282,{"inputs":[{"name":"string"},{"name":"range"}],"output":{"name":"str"}}],[11,"index","","",282,{"inputs":[{"name":"string"},{"name":"rangeto"}],"output":{"name":"str"}}],[11,"index","","",282,{"inputs":[{"name":"string"},{"name":"rangefrom"}],"output":{"name":"str"}}],[11,"index","","",282,{"inputs":[{"name":"string"},{"name":"rangefull"}],"output":{"name":"str"}}],[11,"index_mut","","",282,{"inputs":[{"name":"string"},{"name":"range"}],"output":{"name":"str"}}],[11,"index_mut","","",282,{"inputs":[{"name":"string"},{"name":"rangeto"}],"output":{"name":"str"}}],[11,"index_mut","","",282,{"inputs":[{"name":"string"},{"name":"rangefrom"}],"output":{"name":"str"}}],[11,"index_mut","","",282,{"inputs":[{"name":"string"},{"name":"rangefull"}],"output":{"name":"str"}}],[11,"deref","","",282,{"inputs":[{"name":"string"}],"output":{"name":"str"}}],[11,"deref_mut","","",282,{"inputs":[{"name":"string"}],"output":{"name":"str"}}],[11,"eq","","",285,{"inputs":[{"name":"parseerror"},{"name":"parseerror"}],"output":{"name":"bool"}}],[11,"ne","","",285,{"inputs":[{"name":"parseerror"},{"name":"parseerror"}],"output":{"name":"bool"}}],[11,"fmt","","",285,{"inputs":[{"name":"parseerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",285,{"inputs":[{"name":"parseerror"}],"output":{"name":"parseerror"}}],[11,"from_str","","",282,{"inputs":[{"name":"string"},{"name":"str"}],"output":{"name":"result"}}],[11,"as_ref","","",282,{"inputs":[{"name":"string"}],"output":{"name":"str"}}],[11,"as_ref","","",282,null],[11,"from","","",282,{"inputs":[{"name":"string"},{"name":"str"}],"output":{"name":"string"}}],[11,"from","collections::borrow","",217,{"inputs":[{"name":"cow"},{"name":"str"}],"output":{"name":"cow"}}],[11,"from","","",217,{"inputs":[{"name":"cow"},{"name":"string"}],"output":{"name":"cow"}}],[11,"into","collections::string","",282,{"inputs":[{"name":"string"}],"output":{"name":"vec"}}],[11,"into_cow","","",282,{"inputs":[{"name":"string"}],"output":{"name":"cow"}}],[11,"write_str","","",282,{"inputs":[{"name":"string"},{"name":"str"}],"output":{"name":"result"}}],[11,"write_char","","",282,{"inputs":[{"name":"string"},{"name":"char"}],"output":{"name":"result"}}],[11,"drop","","",286,null],[11,"next","","",286,{"inputs":[{"name":"drain"}],"output":{"name":"option"}}],[11,"size_hint","","",286,null],[11,"next_back","","",286,{"inputs":[{"name":"drain"}],"output":{"name":"option"}}],[11,"new","collections::vec","Constructs a new, empty `Vec<T>`.",273,{"inputs":[{"name":"vec"}],"output":{"name":"vec"}}],[11,"with_capacity","","Constructs a new, empty `Vec<T>` with the specified capacity.",273,{"inputs":[{"name":"vec"},{"name":"usize"}],"output":{"name":"vec"}}],[11,"from_raw_parts","","Creates a `Vec<T>` directly from the raw components of another vector.",273,null],[11,"from_raw_buf","","Creates a vector by copying the elements from a raw pointer.",273,null],[11,"capacity","","Returns the number of elements the vector can hold without\nreallocating.",273,{"inputs":[{"name":"vec"}],"output":{"name":"usize"}}],[11,"reserve","","Reserves capacity for at least `additional` more elements to be inserted\nin the given `Vec<T>`. The collection may reserve more space to avoid\nfrequent reallocations.",273,null],[11,"reserve_exact","","Reserves the minimum capacity for exactly `additional` more elements to\nbe inserted in the given `Vec<T>`. Does nothing if the capacity is already\nsufficient.",273,null],[11,"shrink_to_fit","","Shrinks the capacity of the vector as much as possible.",273,null],[11,"into_boxed_slice","","Converts the vector into Box<[T]>.",273,{"inputs":[{"name":"vec"}],"output":{"name":"box"}}],[11,"truncate","","Shorten a vector, dropping excess elements.",273,null],[11,"as_slice","","Extracts a slice containing the entire vector.",273,null],[11,"as_mut_slice","","Extracts a mutable slice of the entire vector.",273,null],[11,"set_len","","Sets the length of a vector.",273,null],[11,"swap_remove","","Removes an element from anywhere in the vector and return it, replacing\nit with the last element.",273,{"inputs":[{"name":"vec"},{"name":"usize"}],"output":{"name":"t"}}],[11,"insert","","Inserts an element at position `index` within the vector, shifting all\nelements after position `i` one position to the right.",273,null],[11,"remove","","Removes and returns the element at position `index` within the vector,\nshifting all elements after position `index` one position to the left.",273,{"inputs":[{"name":"vec"},{"name":"usize"}],"output":{"name":"t"}}],[11,"retain","","Retains only the elements specified by the predicate.",273,null],[11,"push","","Appends an element to the back of a collection.",273,null],[11,"pop","","Removes the last element from a vector and returns it, or `None` if it is empty.",273,{"inputs":[{"name":"vec"}],"output":{"name":"option"}}],[11,"append","","Moves all the elements of `other` into `Self`, leaving `other` empty.",273,null],[11,"drain","","Create a draining iterator that removes the specified range in the vector\nand yields the removed items from start to end. The element range is\nremoved even if the iterator is not consumed until the end.",273,{"inputs":[{"name":"vec"},{"name":"r"}],"output":{"name":"drain"}}],[11,"clear","","Clears the vector, removing all values.",273,null],[11,"len","","Returns the number of elements in the vector.",273,{"inputs":[{"name":"vec"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns `true` if the vector contains no elements.",273,{"inputs":[{"name":"vec"}],"output":{"name":"bool"}}],[11,"map_in_place","","Converts a `Vec<T>` to a `Vec<U>` where `T` and `U` have the same\nsize and in case they are not zero-sized the same minimal alignment.",273,{"inputs":[{"name":"vec"},{"name":"f"}],"output":{"name":"vec"}}],[11,"split_off","","Splits the collection into two at the given index.",273,{"inputs":[{"name":"vec"},{"name":"usize"}],"output":{"name":"vec"}}],[11,"resize","","Resizes the `Vec` in-place so that `len()` is equal to `new_len`.",273,null],[11,"push_all","","Appends all elements in a slice to the `Vec`.",273,null],[11,"dedup","","Removes consecutive repeated elements in the vector.",273,null],[11,"clone","","",273,{"inputs":[{"name":"vec"}],"output":{"name":"vec"}}],[11,"clone_from","","",273,null],[11,"hash","","",273,null],[11,"index","","",273,{"inputs":[{"name":"vec"},{"name":"usize"}],"output":{"name":"t"}}],[11,"index_mut","","",273,{"inputs":[{"name":"vec"},{"name":"usize"}],"output":{"name":"t"}}],[11,"index","","",273,null],[11,"index","","",273,null],[11,"index","","",273,null],[11,"index","","",273,null],[11,"index_mut","","",273,null],[11,"index_mut","","",273,null],[11,"index_mut","","",273,null],[11,"index_mut","","",273,null],[11,"deref","","",273,null],[11,"deref_mut","","",273,null],[11,"from_iter","","",273,{"inputs":[{"name":"vec"},{"name":"i"}],"output":{"name":"vec"}}],[11,"into_iter","","Creates a consuming iterator, that is, one that moves each value out of\nthe vector (from start to end). The vector cannot be used after calling\nthis.",273,{"inputs":[{"name":"vec"}],"output":{"name":"intoiter"}}],[11,"extend","","",273,null],[11,"extend","","",273,null],[11,"eq","","",273,{"inputs":[{"name":"vec"},{"name":"vec"}],"output":{"name":"bool"}}],[11,"ne","","",273,{"inputs":[{"name":"vec"},{"name":"vec"}],"output":{"name":"bool"}}],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","collections::borrow","",217,null],[11,"ne","","",217,null],[11,"eq","","",217,null],[11,"ne","","",217,null],[11,"eq","","",217,{"inputs":[{"name":"cow"},{"name":"vec"}],"output":{"name":"bool"}}],[11,"ne","","",217,{"inputs":[{"name":"cow"},{"name":"vec"}],"output":{"name":"bool"}}],[11,"eq","collections::vec","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"eq","","",273,null],[11,"ne","","",273,null],[11,"partial_cmp","","",273,{"inputs":[{"name":"vec"},{"name":"vec"}],"output":{"name":"option"}}],[11,"cmp","","",273,{"inputs":[{"name":"vec"},{"name":"vec"}],"output":{"name":"ordering"}}],[11,"drop","","",273,null],[11,"default","","",273,{"inputs":[{"name":"vec"}],"output":{"name":"vec"}}],[11,"fmt","","",273,{"inputs":[{"name":"vec"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"as_ref","","",273,{"inputs":[{"name":"vec"}],"output":{"name":"vec"}}],[11,"as_ref","","",273,null],[11,"from","","",273,null],[11,"from","","",273,{"inputs":[{"name":"vec"},{"name":"str"}],"output":{"name":"vec"}}],[11,"from_iter","collections::borrow","",217,{"inputs":[{"name":"cow"},{"name":"i"}],"output":{"name":"cow"}}],[11,"into_cow","collections::vec","",273,{"inputs":[{"name":"vec"}],"output":{"name":"cow"}}],[11,"into_inner","","Drops all items that have not yet been moved and returns the empty vector.",287,{"inputs":[{"name":"intoiter"}],"output":{"name":"vec"}}],[11,"next","","",287,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",287,null],[11,"count","","",287,{"inputs":[{"name":"intoiter"}],"output":{"name":"usize"}}],[11,"next_back","","",287,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"drop","","",287,null],[11,"next","","",288,{"inputs":[{"name":"drain"}],"output":{"name":"option"}}],[11,"size_hint","","",288,null],[11,"next_back","","",288,{"inputs":[{"name":"drain"}],"output":{"name":"option"}}],[11,"drop","","",288,null],[11,"drop","","",289,null],[11,"drop","","",290,null],[11,"clone","collections::vec_deque","",291,{"inputs":[{"name":"vecdeque"}],"output":{"name":"vecdeque"}}],[11,"drop","","",291,null],[11,"default","","",291,{"inputs":[{"name":"vecdeque"}],"output":{"name":"vecdeque"}}],[11,"new","","Creates an empty `VecDeque`.",291,{"inputs":[{"name":"vecdeque"}],"output":{"name":"vecdeque"}}],[11,"with_capacity","","Creates an empty `VecDeque` with space for at least `n` elements.",291,{"inputs":[{"name":"vecdeque"},{"name":"usize"}],"output":{"name":"vecdeque"}}],[11,"get","","Retrieves an element in the `VecDeque` by index.",291,{"inputs":[{"name":"vecdeque"},{"name":"usize"}],"output":{"name":"option"}}],[11,"get_mut","","Retrieves an element in the `VecDeque` mutably by index.",291,{"inputs":[{"name":"vecdeque"},{"name":"usize"}],"output":{"name":"option"}}],[11,"swap","","Swaps elements at indices `i` and `j`.",291,null],[11,"capacity","","Returns the number of elements the `VecDeque` can hold without\nreallocating.",291,{"inputs":[{"name":"vecdeque"}],"output":{"name":"usize"}}],[11,"reserve_exact","","Reserves the minimum capacity for exactly `additional` more elements to be inserted in the\ngiven `VecDeque`. Does nothing if the capacity is already sufficient.",291,null],[11,"reserve","","Reserves capacity for at least `additional` more elements to be inserted in the given\n`VecDeque`. The collection may reserve more space to avoid frequent reallocations.",291,null],[11,"shrink_to_fit","","Shrinks the capacity of the `VecDeque` as much as possible.",291,null],[11,"truncate","","Shortens a `VecDeque`, dropping excess elements from the back.",291,null],[11,"iter","","Returns a front-to-back iterator.",291,{"inputs":[{"name":"vecdeque"}],"output":{"name":"iter"}}],[11,"iter_mut","","Returns a front-to-back iterator that returns mutable references.",291,{"inputs":[{"name":"vecdeque"}],"output":{"name":"itermut"}}],[11,"as_slices","","Returns a pair of slices which contain, in order, the contents of the\n`VecDeque`.",291,null],[11,"as_mut_slices","","Returns a pair of slices which contain, in order, the contents of the\n`VecDeque`.",291,null],[11,"len","","Returns the number of elements in the `VecDeque`.",291,{"inputs":[{"name":"vecdeque"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns true if the buffer contains no elements",291,{"inputs":[{"name":"vecdeque"}],"output":{"name":"bool"}}],[11,"drain","","Creates a draining iterator that clears the `VecDeque` and iterates over\nthe removed items from start to end.",291,{"inputs":[{"name":"vecdeque"}],"output":{"name":"drain"}}],[11,"clear","","Clears the buffer, removing all values.",291,null],[11,"front","","Provides a reference to the front element, or `None` if the sequence is\nempty.",291,{"inputs":[{"name":"vecdeque"}],"output":{"name":"option"}}],[11,"front_mut","","Provides a mutable reference to the front element, or `None` if the\nsequence is empty.",291,{"inputs":[{"name":"vecdeque"}],"output":{"name":"option"}}],[11,"back","","Provides a reference to the back element, or `None` if the sequence is\nempty.",291,{"inputs":[{"name":"vecdeque"}],"output":{"name":"option"}}],[11,"back_mut","","Provides a mutable reference to the back element, or `None` if the\nsequence is empty.",291,{"inputs":[{"name":"vecdeque"}],"output":{"name":"option"}}],[11,"pop_front","","Removes the first element and returns it, or `None` if the sequence is\nempty.",291,{"inputs":[{"name":"vecdeque"}],"output":{"name":"option"}}],[11,"push_front","","Inserts an element first in the sequence.",291,null],[11,"push_back","","Appends an element to the back of a buffer",291,null],[11,"pop_back","","Removes the last element from a buffer and returns it, or `None` if\nit is empty.",291,{"inputs":[{"name":"vecdeque"}],"output":{"name":"option"}}],[11,"swap_back_remove","","Removes an element from anywhere in the `VecDeque` and returns it, replacing it with the\nlast element.",291,{"inputs":[{"name":"vecdeque"},{"name":"usize"}],"output":{"name":"option"}}],[11,"swap_front_remove","","Removes an element from anywhere in the `VecDeque` and returns it,\nreplacing it with the first element.",291,{"inputs":[{"name":"vecdeque"},{"name":"usize"}],"output":{"name":"option"}}],[11,"insert","","Inserts an element at `index` within the `VecDeque`. Whichever\nend is closer to the insertion point will be moved to make room,\nand all the affected elements will be moved to new positions.",291,null],[11,"remove","","Removes and returns the element at `index` from the `VecDeque`.\nWhichever end is closer to the removal point will be moved to make\nroom, and all the affected elements will be moved to new positions.\nReturns `None` if `index` is out of bounds.",291,{"inputs":[{"name":"vecdeque"},{"name":"usize"}],"output":{"name":"option"}}],[11,"split_off","","Splits the collection into two at the given index.",291,{"inputs":[{"name":"vecdeque"},{"name":"usize"}],"output":{"name":"vecdeque"}}],[11,"append","","Moves all the elements of `other` into `Self`, leaving `other` empty.",291,null],[11,"retain","","Retains only the elements specified by the predicate.",291,null],[11,"resize","","Modifies the `VecDeque` in-place so that `len()` is equal to new_len,\neither by removing excess elements or by appending copies of a value to the back.",291,null],[11,"clone","","",292,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[11,"next","","",292,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",292,null],[11,"next_back","","",292,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"indexable","","",292,{"inputs":[{"name":"iter"}],"output":{"name":"usize"}}],[11,"idx","","",292,{"inputs":[{"name":"iter"},{"name":"usize"}],"output":{"name":"option"}}],[11,"next","","",293,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"size_hint","","",293,null],[11,"next_back","","",293,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"clone","","",294,{"inputs":[{"name":"intoiter"}],"output":{"name":"intoiter"}}],[11,"next","","",294,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",294,null],[11,"next_back","","",294,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"drop","","",295,null],[11,"next","","",295,{"inputs":[{"name":"drain"}],"output":{"name":"option"}}],[11,"size_hint","","",295,null],[11,"next_back","","",295,{"inputs":[{"name":"drain"}],"output":{"name":"option"}}],[11,"eq","","",291,{"inputs":[{"name":"vecdeque"},{"name":"vecdeque"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",291,{"inputs":[{"name":"vecdeque"},{"name":"vecdeque"}],"output":{"name":"option"}}],[11,"cmp","","",291,{"inputs":[{"name":"vecdeque"},{"name":"vecdeque"}],"output":{"name":"ordering"}}],[11,"hash","","",291,null],[11,"index","","",291,{"inputs":[{"name":"vecdeque"},{"name":"usize"}],"output":{"name":"a"}}],[11,"index_mut","","",291,{"inputs":[{"name":"vecdeque"},{"name":"usize"}],"output":{"name":"a"}}],[11,"from_iter","","",291,{"inputs":[{"name":"vecdeque"},{"name":"t"}],"output":{"name":"vecdeque"}}],[11,"into_iter","","Consumes the list into a front-to-back iterator yielding elements by\nvalue.",291,{"inputs":[{"name":"vecdeque"}],"output":{"name":"intoiter"}}],[11,"extend","","",291,null],[11,"extend","","",291,null],[11,"fmt","","",291,{"inputs":[{"name":"vecdeque"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"default","collections::vec_map","",296,{"inputs":[{"name":"vecmap"}],"output":{"name":"vecmap"}}],[11,"clone","","",296,{"inputs":[{"name":"vecmap"}],"output":{"name":"vecmap"}}],[11,"clone_from","","",296,null],[11,"hash","","",296,null],[11,"new","","Creates an empty `VecMap`.",296,{"inputs":[{"name":"vecmap"}],"output":{"name":"vecmap"}}],[11,"with_capacity","","Creates an empty `VecMap` with space for at least `capacity`\nelements before resizing.",296,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":{"name":"vecmap"}}],[11,"capacity","","Returns the number of elements the `VecMap` can hold without\nreallocating.",296,{"inputs":[{"name":"vecmap"}],"output":{"name":"usize"}}],[11,"reserve_len","","Reserves capacity for the given `VecMap` to contain `len` distinct keys.\nIn the case of `VecMap` this means reallocations will not occur as long\nas all inserted keys are less than `len`.",296,null],[11,"reserve_len_exact","","Reserves the minimum capacity for the given `VecMap` to contain `len` distinct keys.\nIn the case of `VecMap` this means reallocations will not occur as long as all inserted\nkeys are less than `len`.",296,null],[11,"keys","","Returns an iterator visiting all keys in ascending order of the keys.\nThe iterator's element type is `usize`.",296,{"inputs":[{"name":"vecmap"}],"output":{"name":"keys"}}],[11,"values","","Returns an iterator visiting all values in ascending order of the keys.\nThe iterator's element type is `&'r V`.",296,{"inputs":[{"name":"vecmap"}],"output":{"name":"values"}}],[11,"iter","","Returns an iterator visiting all key-value pairs in ascending order of the keys.\nThe iterator's element type is `(usize, &'r V)`.",296,{"inputs":[{"name":"vecmap"}],"output":{"name":"iter"}}],[11,"iter_mut","","Returns an iterator visiting all key-value pairs in ascending order of the keys,\nwith mutable references to the values.\nThe iterator's element type is `(usize, &'r mut V)`.",296,{"inputs":[{"name":"vecmap"}],"output":{"name":"itermut"}}],[11,"append","","Moves all elements from `other` into the map while overwriting existing keys.",296,null],[11,"split_off","","Splits the collection into two at the given key.",296,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":{"name":"vecmap"}}],[11,"drain","","Returns an iterator visiting all key-value pairs in ascending order of\nthe keys, emptying (but not consuming) the original `VecMap`.\nThe iterator's element type is `(usize, &'r V)`. Keeps the allocated memory for reuse.",296,{"inputs":[{"name":"vecmap"}],"output":{"name":"drain"}}],[11,"len","","Returns the number of elements in the map.",296,{"inputs":[{"name":"vecmap"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns true if the map contains no elements.",296,{"inputs":[{"name":"vecmap"}],"output":{"name":"bool"}}],[11,"clear","","Clears the map, removing all key-value pairs.",296,null],[11,"get","","Returns a reference to the value corresponding to the key.",296,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":{"name":"option"}}],[11,"contains_key","","Returns true if the map contains a value for the specified key.",296,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":{"name":"bool"}}],[11,"get_mut","","Returns a mutable reference to the value corresponding to the key.",296,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":{"name":"option"}}],[11,"insert","","Inserts a key-value pair into the map. If the key already had a value\npresent in the map, that value is returned. Otherwise, `None` is returned.",296,{"inputs":[{"name":"vecmap"},{"name":"usize"},{"name":"v"}],"output":{"name":"option"}}],[11,"remove","","Removes a key from the map, returning the value at the key if the key\nwas previously in the map.",296,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":{"name":"option"}}],[11,"entry","","Gets the given key's corresponding entry in the map for in-place manipulation.",296,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":{"name":"entry"}}],[11,"get","","Returns a mutable reference to the entry if occupied, or the VacantEntry if vacant",297,{"inputs":[{"name":"entry"}],"output":{"name":"result"}}],[11,"or_insert","","Ensures a value is in the entry by inserting the default if empty, and\nreturns a mutable reference to the value in the entry.",297,{"inputs":[{"name":"entry"},{"name":"v"}],"output":{"name":"v"}}],[11,"or_insert_with","","Ensures a value is in the entry by inserting the result of the default\nfunction if empty, and returns a mutable reference to the value in the\nentry.",297,{"inputs":[{"name":"entry"},{"name":"f"}],"output":{"name":"v"}}],[11,"insert","","Sets the value of the entry with the VacantEntry's key,\nand returns a mutable reference to it.",298,{"inputs":[{"name":"vacantentry"},{"name":"v"}],"output":{"name":"v"}}],[11,"get","","Gets a reference to the value in the entry.",299,{"inputs":[{"name":"occupiedentry"}],"output":{"name":"v"}}],[11,"get_mut","","Gets a mutable reference to the value in the entry.",299,{"inputs":[{"name":"occupiedentry"}],"output":{"name":"v"}}],[11,"into_mut","","Converts the entry into a mutable reference to its value.",299,{"inputs":[{"name":"occupiedentry"}],"output":{"name":"v"}}],[11,"insert","","Sets the value of the entry with the OccupiedEntry's key,\nand returns the entry's old value.",299,{"inputs":[{"name":"occupiedentry"},{"name":"v"}],"output":{"name":"v"}}],[11,"remove","","Takes the value of the entry out of the map, and returns it.",299,{"inputs":[{"name":"occupiedentry"}],"output":{"name":"v"}}],[11,"eq","","",296,{"inputs":[{"name":"vecmap"},{"name":"vecmap"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",296,{"inputs":[{"name":"vecmap"},{"name":"vecmap"}],"output":{"name":"option"}}],[11,"cmp","","",296,{"inputs":[{"name":"vecmap"},{"name":"vecmap"}],"output":{"name":"ordering"}}],[11,"fmt","","",296,{"inputs":[{"name":"vecmap"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from_iter","","",296,{"inputs":[{"name":"vecmap"},{"name":"i"}],"output":{"name":"vecmap"}}],[11,"into_iter","","Returns an iterator visiting all key-value pairs in ascending order of\nthe keys, consuming the original `VecMap`.\nThe iterator's element type is `(usize, &'r V)`.",296,{"inputs":[{"name":"vecmap"}],"output":{"name":"intoiter"}}],[11,"extend","","",296,null],[11,"extend","","",296,null],[11,"index","","",296,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":{"name":"v"}}],[11,"index","","",296,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":{"name":"v"}}],[11,"index_mut","","",296,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":{"name":"v"}}],[11,"index_mut","","",296,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":{"name":"v"}}],[11,"clone","","",300,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[11,"next","","",300,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",300,null],[11,"next_back","","",300,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"next","","",301,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"size_hint","","",301,null],[11,"next_back","","",301,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"clone","","",302,{"inputs":[{"name":"keys"}],"output":{"name":"keys"}}],[11,"clone","","",303,{"inputs":[{"name":"values"}],"output":{"name":"values"}}],[11,"next","","",304,{"inputs":[{"name":"drain"}],"output":{"name":"option"}}],[11,"size_hint","","",304,null],[11,"next_back","","",304,{"inputs":[{"name":"drain"}],"output":{"name":"option"}}],[11,"next","","",302,{"inputs":[{"name":"keys"}],"output":{"name":"option"}}],[11,"size_hint","","",302,null],[11,"next_back","","",302,{"inputs":[{"name":"keys"}],"output":{"name":"option"}}],[11,"next","","",303,{"inputs":[{"name":"values"}],"output":{"name":"option"}}],[11,"size_hint","","",303,null],[11,"next_back","","",303,{"inputs":[{"name":"values"}],"output":{"name":"option"}}],[11,"next","","",305,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",305,null],[11,"next_back","","",305,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"eq","collections","",306,{"inputs":[{"name":"bound"},{"name":"bound"}],"output":{"name":"bool"}}],[11,"ne","","",306,{"inputs":[{"name":"bound"},{"name":"bound"}],"output":{"name":"bool"}}],[11,"hash","","",306,null],[11,"fmt","","",306,{"inputs":[{"name":"bound"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",306,{"inputs":[{"name":"bound"}],"output":{"name":"bound"}}],[4,"Cow","std::borrow","A clone-on-write smart pointer.",null,null],[13,"Borrowed","","Borrowed data.",217,null],[13,"Owned","","Owned data.",217,null],[8,"IntoCow","","Trait for moving into a `Cow`.",null,null],[10,"into_cow","","Moves `self` into `Cow`",307,{"inputs":[{"name":"intocow"}],"output":{"name":"cow"}}],[0,"fmt","std","Utilities for formatting and printing strings",null,null],[5,"format","std::fmt","The format function takes a precompiled format string and a list of\narguments, to return the resulting formatted string.",null,{"inputs":[{"name":"arguments"}],"output":{"name":"string"}}],[8,"Binary","","Format trait for the `b` character.",null,null],[10,"fmt","","Formats the value using the given formatter.",308,{"inputs":[{"name":"binary"},{"name":"formatter"}],"output":{"name":"result"}}],[5,"radix","","Constructs a radix formatter in the range of `2..36`.",null,{"inputs":[{"name":"t"},{"name":"u8"}],"output":{"name":"radixfmt"}}],[3,"Formatter","","A struct to represent both where to emit formatting strings to and how they\nshould be formatted. A mutable version of this is passed to all formatting\ntraits.",null,null],[8,"Pointer","","Format trait for the `p` character.",null,null],[10,"fmt","","Formats the value using the given formatter.",309,{"inputs":[{"name":"pointer"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"Write","","A collection of methods that are required to format a message into a stream.",null,null],[10,"write_str","","Writes a slice of bytes into this writer, returning whether the write\nsucceeded.",310,{"inputs":[{"name":"write"},{"name":"str"}],"output":{"name":"result"}}],[11,"write_char","","Writes a `char` into this writer, returning whether the write succeeded.",310,{"inputs":[{"name":"write"},{"name":"char"}],"output":{"name":"result"}}],[11,"write_fmt","","Glue for usage of the `write!` macro with implementers of this trait.",310,{"inputs":[{"name":"write"},{"name":"arguments"}],"output":{"name":"result"}}],[3,"Radix","","A radix with in the range of `2..36`.",null,null],[8,"Octal","","Format trait for the `o` character.",null,null],[10,"fmt","","Formats the value using the given formatter.",311,{"inputs":[{"name":"octal"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"LowerHex","","Format trait for the `x` character.",null,null],[10,"fmt","","Formats the value using the given formatter.",312,{"inputs":[{"name":"lowerhex"},{"name":"formatter"}],"output":{"name":"result"}}],[3,"Arguments","","This structure represents a safely precompiled version of a format string\nand its arguments. This cannot be generated at runtime because it cannot\nsafely be done so, so no constructors are given and the fields are private\nto prevent modification.",null,null],[6,"Result","","",null,null],[8,"UpperHex","","Format trait for the `X` character.",null,null],[10,"fmt","","Formats the value using the given formatter.",313,{"inputs":[{"name":"upperhex"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"UpperExp","","Format trait for the `E` character.",null,null],[10,"fmt","","Formats the value using the given formatter.",314,{"inputs":[{"name":"upperexp"},{"name":"formatter"}],"output":{"name":"result"}}],[3,"RadixFmt","","A helper type for formatting radixes.",null,null],[5,"write","","The `write` function takes an output stream, a precompiled format string,\nand a list of arguments. The arguments will be formatted according to the\nspecified format string into the output stream provided.",null,{"inputs":[{"name":"write"},{"name":"arguments"}],"output":{"name":"result"}}],[8,"Display","","Format trait for an empty format, `{}`.",null,null],[10,"fmt","","Formats the value using the given formatter.",315,{"inputs":[{"name":"display"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"Debug","","Format trait for the `?` character.",null,null],[10,"fmt","","Formats the value using the given formatter.",316,{"inputs":[{"name":"debug"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"LowerExp","","Format trait for the `e` character.",null,null],[10,"fmt","","Formats the value using the given formatter.",317,{"inputs":[{"name":"lowerexp"},{"name":"formatter"}],"output":{"name":"result"}}],[3,"Error","","The error type which is returned from formatting a message into a stream.",null,null],[0,"slice","std","A dynamically-sized view into a contiguous sequence, `[T]`.",null,null],[8,"SliceConcatExt","std::slice","An extension trait for concatenating slices",null,null],[16,"Output","","The resulting type after concatenation",318,null],[10,"concat","","Flattens a slice of `T` into a single value `Self::Output`.",318,null],[10,"join","","Flattens a slice of `T` into a single value `Self::Output`, placing a\ngiven separator between each.",318,null],[10,"connect","","Flattens a slice of `T` into a single value `Self::Output`, placing a\ngiven separator between each.",318,null],[3,"ElementSwaps","","An iterator that yields the element swaps needed to produce\na sequence of all possible permutations for an indexed sequence of\nelements. Each permutation is only a single swap apart.",null,null],[3,"Permutations","","An iterator that uses `ElementSwaps` to iterate through\nall possible permutations of a vector.",null,null],[0,"bytes","","Operations on `[u8]`.",null,null],[8,"MutableByteVector","std::slice::bytes","A trait for operations on mutable `[u8]`s.",null,null],[10,"set_memory","","Sets all bytes of the receiver to the given value.",319,null],[5,"copy_memory","","Copies data from `src` to `dst`",null,null],[3,"IterMut","std::slice","Mutable slice iterator.",null,null],[3,"SplitN","","An iterator over subslices separated by elements that match a predicate\nfunction, limited to a given number of splits.",null,null],[3,"Windows","","An iterator over overlapping subslices of length `size`.",null,null],[5,"from_raw_parts_mut","","Performs the same functionality as `from_raw_parts`, except that a mutable\nslice is returned.",null,null],[3,"SplitMut","","An iterator over the subslices of the vector which are separated\nby elements that match `pred`.",null,null],[3,"RSplitNMut","","An iterator over subslices separated by elements that match a\npredicate function, limited to a given number of splits, starting\nfrom the end of the slice.",null,null],[8,"IntSliceExt","","Extension methods for slices containing integers.",null,null],[10,"as_unsigned","","Converts the slice to an immutable slice of unsigned integers with the same width.",320,null],[10,"as_signed","","Converts the slice to an immutable slice of signed integers with the same width.",320,null],[10,"as_unsigned_mut","","Converts the slice to a mutable slice of unsigned integers with the same width.",320,null],[10,"as_signed_mut","","Converts the slice to a mutable slice of signed integers with the same width.",320,null],[5,"ref_slice","","Converts a pointer to A into a slice of length 1 (without copying).",null,null],[3,"RSplitN","","An iterator over subslices separated by elements that match a\npredicate function, limited to a given number of splits, starting\nfrom the end of the slice.",null,null],[3,"Chunks","","An iterator over a slice in (non-overlapping) chunks (`size` elements at a\ntime).",null,null],[3,"SplitNMut","","An iterator over subslices separated by elements that match a predicate\nfunction, limited to a given number of splits.",null,null],[3,"Split","","An iterator over subslices separated by elements that match a predicate\nfunction.",null,null],[5,"from_raw_parts","","Forms a slice from a pointer and a length.",null,null],[3,"ChunksMut","","An iterator over a slice in (non-overlapping) mutable chunks (`size`\nelements at a time). When the slice len is not evenly divided by the chunk\nsize, the last slice of the iteration will be the remainder.",null,null],[5,"mut_ref_slice","","Converts a pointer to A into a slice of length 1 (without copying).",null,null],[3,"Iter","","Immutable slice iterator",null,null],[0,"str","std","Unicode string slices",null,null],[3,"Decompositions","std::str","External iterator for a string decomposition's characters.",null,null],[3,"Recompositions","","External iterator for a string recomposition's characters.",null,null],[3,"Utf16Units","","External iterator for a string's UTF16 codeunits.",null,null],[5,"from_utf8_unchecked","","Converts a slice of bytes to a string slice without checking\nthat the string contains valid UTF-8.",null,null],[11,"clone","rustc_unicode::tables::grapheme","",321,{"inputs":[{"name":"graphemecat"}],"output":{"name":"graphemecat"}}],[11,"clone","rustc_unicode::u_str","",322,{"inputs":[{"name":"graphemeindices"}],"output":{"name":"graphemeindices"}}],[11,"next","","",322,{"inputs":[{"name":"graphemeindices"}],"output":{"name":"option"}}],[11,"size_hint","","",322,null],[11,"next_back","","",322,{"inputs":[{"name":"graphemeindices"}],"output":{"name":"option"}}],[11,"clone","","",323,{"inputs":[{"name":"graphemes"}],"output":{"name":"graphemes"}}],[11,"eq","","",324,{"inputs":[{"name":"graphemestate"},{"name":"graphemestate"}],"output":{"name":"bool"}}],[11,"ne","","",324,{"inputs":[{"name":"graphemestate"},{"name":"graphemestate"}],"output":{"name":"bool"}}],[11,"size_hint","","",323,null],[11,"next","","",323,{"inputs":[{"name":"graphemes"}],"output":{"name":"option"}}],[11,"next_back","","",323,{"inputs":[{"name":"graphemes"}],"output":{"name":"option"}}],[11,"clone","","",325,{"inputs":[{"name":"utf16items"}],"output":{"name":"utf16items"}}],[11,"fmt","","",326,{"inputs":[{"name":"utf16item"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",326,{"inputs":[{"name":"utf16item"}],"output":{"name":"utf16item"}}],[11,"eq","","",326,{"inputs":[{"name":"utf16item"},{"name":"utf16item"}],"output":{"name":"bool"}}],[11,"ne","","",326,{"inputs":[{"name":"utf16item"},{"name":"utf16item"}],"output":{"name":"bool"}}],[11,"to_char_lossy","","Convert `self` to a `char`, taking `LoneSurrogate`s to the\nreplacement character (U+FFFD).",326,{"inputs":[{"name":"utf16item"}],"output":{"name":"char"}}],[11,"next","","",325,{"inputs":[{"name":"utf16items"}],"output":{"name":"option"}}],[11,"size_hint","","",325,null],[11,"clone","","",327,{"inputs":[{"name":"utf16encoder"}],"output":{"name":"utf16encoder"}}],[11,"new","","Create a UTF-16 encoder from any `char` iterator.",327,{"inputs":[{"name":"utf16encoder"},{"name":"i"}],"output":{"name":"utf16encoder"}}],[11,"next","","",327,{"inputs":[{"name":"utf16encoder"}],"output":{"name":"option"}}],[11,"size_hint","","",327,null],[11,"next","","",328,{"inputs":[{"name":"splitwhitespace"}],"output":{"name":"option"}}],[11,"next_back","","",328,{"inputs":[{"name":"splitwhitespace"}],"output":{"name":"option"}}],[11,"next","rustc_unicode::char","",329,{"inputs":[{"name":"tolowercase"}],"output":{"name":"option"}}],[11,"next","","",330,{"inputs":[{"name":"touppercase"}],"output":{"name":"option"}}],[11,"next","","",331,{"inputs":[{"name":"casemappingiter"}],"output":{"name":"option"}}],[3,"GraphemeIndices","std::str","External iterator for grapheme clusters and byte offsets.",null,null],[3,"SplitN","","Created with the method `.splitn()`.",null,null],[3,"CharRange","","Struct that contains a `char` and the index of the first byte of\nthe next `char` in a string.  This can be used as a data structure\nfor iterating over the UTF-8 bytes of a string.",null,null],[12,"ch","","Current `char`",135,null],[12,"next","","Index of the first byte of the next `char`",135,null],[3,"RMatchIndices","","Created with the method `.rmatch_indices()`.",null,null],[3,"ParseBoolError","","An error returned when parsing a `bool` from a string fails.",null,null],[5,"from_utf8","","Converts a slice of bytes to a string slice without performing any\nallocations.",null,null],[3,"RSplitTerminator","","Created with the method `.rsplit_terminator()`.",null,null],[3,"SplitWhitespace","","An iterator over the non-whitespace substrings of a string,\nseparated by any amount of whitespace.",null,null],[8,"FromStr","","A trait to abstract the idea of creating a new instance of a type from a\nstring.",null,null],[16,"Err","","The associated error which can be returned from parsing.",332,null],[10,"from_str","","Parses a string `s` to return a value of this type.",332,{"inputs":[{"name":"fromstr"},{"name":"str"}],"output":{"name":"result"}}],[3,"SplitTerminator","","Created with the method `.split_terminator()`.",null,null],[3,"Utf8Error","","Errors which can occur when attempting to interpret a byte slice as a `str`.",null,null],[3,"RMatches","","Created with the method `.rmatches()`.",null,null],[3,"Chars","","Iterator for the char (representing *Unicode Scalar Values*) of a string",null,null],[3,"CharIndices","","Iterator for a string's characters and their byte offsets.",null,null],[3,"Lines","","Created with the method `.lines()`.",null,null],[3,"MatchIndices","","Created with the method `.match_indices()`.",null,null],[3,"RSplit","","Created with the method `.rsplit()`.",null,null],[6,"Words","","",null,null],[0,"pattern","","The string Pattern API.",null,null],[8,"Pattern","std::str::pattern","A string pattern.",null,null],[16,"Searcher","","Associated searcher for this pattern",333,null],[10,"into_searcher","","Constructs the associated searcher from\n`self` and the `haystack` to search in.",333,null],[11,"is_contained_in","","Checks whether the pattern matches anywhere in the haystack",333,{"inputs":[{"name":"pattern"},{"name":"str"}],"output":{"name":"bool"}}],[11,"is_prefix_of","","Checks whether the pattern matches at the front of the haystack",333,{"inputs":[{"name":"pattern"},{"name":"str"}],"output":{"name":"bool"}}],[11,"is_suffix_of","","Checks whether the pattern matches at the back of the haystack",333,{"inputs":[{"name":"pattern"},{"name":"str"}],"output":{"name":"bool"}}],[4,"SearchStep","","Result of calling `Searcher::next()` or `ReverseSearcher::next_back()`.",null,null],[13,"Match","","Expresses that a match of the pattern has been found at\n`haystack[a..b]`.",100,null],[13,"Reject","","Expresses that `haystack[a..b]` has been rejected as a possible match\nof the pattern.",100,null],[13,"Done","","Expresses that every byte of the haystack has been visted, ending\nthe iteration.",100,null],[8,"Searcher","","A searcher for a string pattern.",null,null],[10,"haystack","","Getter for the underlaying string to be searched in",334,{"inputs":[{"name":"searcher"}],"output":{"name":"str"}}],[10,"next","","Performs the next search step starting from the front.",334,{"inputs":[{"name":"searcher"}],"output":{"name":"searchstep"}}],[11,"next_match","","Find the next `Match` result. See `next()`",334,{"inputs":[{"name":"searcher"}],"output":{"name":"option"}}],[11,"next_reject","","Find the next `Reject` result. See `next()`",334,{"inputs":[{"name":"searcher"}],"output":{"name":"option"}}],[8,"ReverseSearcher","","A reverse searcher for a string pattern.",null,null],[10,"next_back","","Performs the next search step starting from the back.",335,{"inputs":[{"name":"reversesearcher"}],"output":{"name":"searchstep"}}],[11,"next_match_back","","Find the next `Match` result. See `next_back()`",335,{"inputs":[{"name":"reversesearcher"}],"output":{"name":"option"}}],[11,"next_reject_back","","Find the next `Reject` result. See `next_back()`",335,{"inputs":[{"name":"reversesearcher"}],"output":{"name":"option"}}],[8,"DoubleEndedSearcher","","A marker trait to express that a `ReverseSearcher`\ncan be used for a `DoubleEndedIterator` implementation.",null,null],[3,"CharSearcher","","Associated type for `<char as Pattern<'a>>::Searcher`.",null,null],[3,"CharSliceSearcher","","Associated type for `<&[char] as Pattern<'a>>::Searcher`.",null,null],[3,"CharPredicateSearcher","","Associated type for `<F as Pattern<'a>>::Searcher`.",null,null],[3,"StrSearcher","","Associated type for `<&str as Pattern<'a>>::Searcher`.",null,null],[3,"LinesAny","std::str","Created with the method `.lines_any()`.",null,null],[3,"RSplitN","","Created with the method `.rsplitn()`.",null,null],[3,"Matches","","Created with the method `.matches()`.",null,null],[3,"Split","","Created with the method `.split()`.",null,null],[3,"Bytes","","External iterator for a string's bytes.\nUse with the `std::iter` module.",null,null],[3,"Graphemes","","External iterator for a string's\n[grapheme clusters](http://www.unicode.org/reports/tr29/#Grapheme_Cluster_Boundaries).",null,null],[0,"string","std","An owned, growable string that enforces that its contents are valid UTF-8.",null,null],[3,"String","std::string","A growable string stored as a UTF-8 encoded buffer.",null,null],[3,"FromUtf8Error","","A possible error value from the `String::from_utf8` function.",null,null],[3,"FromUtf16Error","","A possible error value from the `String::from_utf16` function.",null,null],[3,"ParseError","","Error returned from `String::from`",null,null],[8,"ToString","","A generic trait for converting a value to a string",null,null],[10,"to_string","","Converts the value of `self` to an owned string",336,{"inputs":[{"name":"tostring"}],"output":{"name":"string"}}],[3,"Drain","","A draining iterator for `String`.",null,null],[0,"vec","std","A growable list type with heap-allocated contents, written `Vec<T>` but\npronounced 'vector.'",null,null],[3,"Vec","std::vec","A growable list type, written `Vec<T>` but pronounced 'vector.'",null,null],[3,"IntoIter","","An iterator that moves out of a vector.",null,null],[3,"Drain","","A draining iterator for `Vec<T>`.",null,null],[0,"char","std","A Unicode scalar value",null,null],[3,"ToLowercase","std::char","An iterator over the lowercase mapping of a given character, returned from\nthe [`to_lowercase` method](../primitive.char.html#method.to_lowercase) on\ncharacters.",null,null],[3,"ToUppercase","","An iterator over the uppercase mapping of a given character, returned from\nthe [`to_uppercase` method](../primitive.char.html#method.to_uppercase) on\ncharacters.",null,null],[3,"EscapeUnicode","","An iterator over the characters that represent a `char`, as escaped by\nRust's unicode escaping rules.",null,null],[5,"from_u32_unchecked","","Converts a `u32` to an `char`, not checking whether it is a valid unicode\ncodepoint.",null,{"inputs":[{"name":"u32"}],"output":{"name":"char"}}],[5,"from_u32","","Converts a `u32` to an `Option<char>`.",null,{"inputs":[{"name":"u32"}],"output":{"name":"option"}}],[5,"canonical_combining_class","","",null,{"inputs":[{"name":"char"}],"output":{"name":"u8"}}],[5,"compose","","",null,{"inputs":[{"name":"char"},{"name":"char"}],"output":{"name":"option"}}],[3,"EscapeDefault","","An iterator over the characters that represent a `char`, escaped\nfor maximum portability.",null,null],[5,"from_digit","","Converts a number to the character representing it.",null,{"inputs":[{"name":"u32"},{"name":"u32"}],"output":{"name":"option"}}],[17,"UNICODE_VERSION","","The version of [Unicode](http://www.unicode.org/)\nthat the unicode parts of `CharExt` and `UnicodeStrPrelude` traits are based on.",null,null],[5,"decompose_compatible","","Compute canonical or compatible Unicode decomposition for character",null,null],[17,"MAX","","The highest valid code point",null,null],[5,"decompose_canonical","","Compute canonical Unicode decomposition for character",null,null],[0,"error","std","Traits for working with Errors.",null,null],[8,"Error","std::error","Base functionality for all errors in Rust.",null,null],[10,"description","","A short description of the error.",337,{"inputs":[{"name":"error"}],"output":{"name":"str"}}],[11,"cause","","The lower-level cause of this error, if any.",337,{"inputs":[{"name":"error"}],"output":{"name":"option"}}],[11,"from","std::boxed","",207,{"inputs":[{"name":"box"},{"name":"e"}],"output":{"name":"box"}}],[11,"from","","",207,{"inputs":[{"name":"box"},{"name":"e"}],"output":{"name":"box"}}],[11,"from","","",207,{"inputs":[{"name":"box"},{"name":"string"}],"output":{"name":"box"}}],[11,"from","","",207,{"inputs":[{"name":"box"},{"name":"str"}],"output":{"name":"box"}}],[11,"description","std::str","",112,{"inputs":[{"name":"parseboolerror"}],"output":{"name":"str"}}],[11,"description","","",113,{"inputs":[{"name":"utf8error"}],"output":{"name":"str"}}],[11,"description","core::num","",12,{"inputs":[{"name":"parseinterror"}],"output":{"name":"str"}}],[11,"description","","",14,{"inputs":[{"name":"parsefloaterror"}],"output":{"name":"str"}}],[11,"description","std::string","",283,{"inputs":[{"name":"fromutf8error"}],"output":{"name":"str"}}],[11,"description","","",284,{"inputs":[{"name":"fromutf16error"}],"output":{"name":"str"}}],[11,"is","std","Returns true if the boxed type is the same as `T`",337,{"inputs":[{"name":"error"}],"output":{"name":"bool"}}],[11,"downcast_ref","","Returns some reference to the boxed value if it is of type `T`, or\n`None` if it isn't.",337,{"inputs":[{"name":"error"}],"output":{"name":"option"}}],[11,"downcast_mut","","Returns some mutable reference to the boxed value if it is of type `T`, or\n`None` if it isn't.",337,{"inputs":[{"name":"error"}],"output":{"name":"option"}}],[11,"is","","Forwards to the method defined on the type `Any`.",337,{"inputs":[{"name":"error"}],"output":{"name":"bool"}}],[11,"downcast_ref","","Forwards to the method defined on the type `Any`.",337,{"inputs":[{"name":"error"}],"output":{"name":"option"}}],[11,"downcast_mut","","Forwards to the method defined on the type `Any`.",337,{"inputs":[{"name":"error"}],"output":{"name":"option"}}],[11,"is","","Forwards to the method defined on the type `Any`.",337,{"inputs":[{"name":"error"}],"output":{"name":"bool"}}],[11,"downcast_ref","","Forwards to the method defined on the type `Any`.",337,{"inputs":[{"name":"error"}],"output":{"name":"option"}}],[11,"downcast_mut","","Forwards to the method defined on the type `Any`.",337,{"inputs":[{"name":"error"}],"output":{"name":"option"}}],[11,"downcast","","Attempt to downcast the box to a concrete type.",337,{"inputs":[{"name":"error"}],"output":{"name":"result"}}],[11,"downcast","","Attempt to downcast the box to a concrete type.",337,{"inputs":[{"name":"error"}],"output":{"name":"result"}}],[11,"downcast","","Attempt to downcast the box to a concrete type.",337,{"inputs":[{"name":"error"}],"output":{"name":"result"}}],[0,"prelude","","The Rust Prelude",null,null],[0,"v1","std::prelude","The first version of the prelude of The Rust Standard Library.",null,null],[0,"isize","std","The pointer-sized signed integer type.",null,null],[17,"BITS","std::isize","",null,null],[17,"BYTES","","",null,null],[17,"MIN","","",null,null],[17,"MAX","","",null,null],[0,"i8","std","The 8-bit signed integer type.",null,null],[17,"BITS","std::i8","",null,null],[17,"BYTES","","",null,null],[17,"MIN","","",null,null],[17,"MAX","","",null,null],[0,"i16","std","The 16-bit signed integer type.",null,null],[17,"BITS","std::i16","",null,null],[17,"BYTES","","",null,null],[17,"MIN","","",null,null],[17,"MAX","","",null,null],[0,"i32","std","The 32-bit signed integer type.",null,null],[17,"BITS","std::i32","",null,null],[17,"BYTES","","",null,null],[17,"MIN","","",null,null],[17,"MAX","","",null,null],[0,"i64","std","The 64-bit signed integer type.",null,null],[17,"BITS","std::i64","",null,null],[17,"BYTES","","",null,null],[17,"MIN","","",null,null],[17,"MAX","","",null,null],[0,"usize","std","The pointer-sized unsigned integer type.",null,null],[17,"BITS","std::usize","",null,null],[17,"BYTES","","",null,null],[17,"MIN","","",null,null],[17,"MAX","","",null,null],[0,"u8","std","The 8-bit unsigned integer type.",null,null],[17,"BITS","std::u8","",null,null],[17,"BYTES","","",null,null],[17,"MIN","","",null,null],[17,"MAX","","",null,null],[0,"u16","std","The 16-bit unsigned integer type.",null,null],[17,"BITS","std::u16","",null,null],[17,"BYTES","","",null,null],[17,"MIN","","",null,null],[17,"MAX","","",null,null],[0,"u32","std","The 32-bit unsigned integer type.",null,null],[17,"BITS","std::u32","",null,null],[17,"BYTES","","",null,null],[17,"MIN","","",null,null],[17,"MAX","","",null,null],[0,"u64","std","The 64-bit unsigned integer type.",null,null],[17,"BITS","std::u64","",null,null],[17,"BYTES","","",null,null],[17,"MIN","","",null,null],[17,"MAX","","",null,null],[0,"f32","std","The 32-bit floating point type.",null,null],[17,"RADIX","std::f32","",null,null],[17,"MANTISSA_DIGITS","","",null,null],[17,"DIGITS","","",null,null],[17,"EPSILON","","",null,null],[17,"MIN_EXP","","",null,null],[17,"MAX_EXP","","",null,null],[17,"MIN_10_EXP","","",null,null],[17,"MAX_10_EXP","","",null,null],[17,"NAN","","",null,null],[17,"INFINITY","","",null,null],[17,"NEG_INFINITY","","",null,null],[17,"MIN","","Smallest finite f32 value",null,null],[17,"MIN_POSITIVE","","Smallest positive, normalized f32 value",null,null],[17,"MAX","","Largest finite f32 value",null,null],[0,"consts","","Basic mathematial constants.",null,null],[17,"PI","std::f32::consts","Archimedes' constant",null,null],[17,"PI_2","","pi * 2.0",null,null],[17,"FRAC_PI_2","","pi/2.0",null,null],[17,"FRAC_PI_3","","pi/3.0",null,null],[17,"FRAC_PI_4","","pi/4.0",null,null],[17,"FRAC_PI_6","","pi/6.0",null,null],[17,"FRAC_PI_8","","pi/8.0",null,null],[17,"FRAC_1_PI","","1.0/pi",null,null],[17,"FRAC_2_PI","","2.0/pi",null,null],[17,"FRAC_2_SQRT_PI","","2.0/sqrt(pi)",null,null],[17,"SQRT_2","","sqrt(2.0)",null,null],[17,"FRAC_1_SQRT_2","","1.0/sqrt(2.0)",null,null],[17,"E","","Euler's number",null,null],[17,"LOG2_E","","log2(e)",null,null],[17,"LOG10_E","","log10(e)",null,null],[17,"LN_2","","ln(2.0)",null,null],[17,"LN_10","","ln(10.0)",null,null],[0,"f64","std","The 64-bit floating point type.",null,null],[17,"RADIX","std::f64","",null,null],[17,"MANTISSA_DIGITS","","",null,null],[17,"DIGITS","","",null,null],[17,"EPSILON","","",null,null],[17,"MIN_EXP","","",null,null],[17,"MAX_EXP","","",null,null],[17,"MIN_10_EXP","","",null,null],[17,"MAX_10_EXP","","",null,null],[17,"NAN","","",null,null],[17,"INFINITY","","",null,null],[17,"NEG_INFINITY","","",null,null],[17,"MIN","","Smallest finite f64 value",null,null],[17,"MIN_POSITIVE","","Smallest positive, normalized f64 value",null,null],[17,"MAX","","Largest finite f64 value",null,null],[0,"consts","","Basic mathematial constants.",null,null],[17,"PI","std::f64::consts","Archimedes' constant",null,null],[17,"PI_2","","pi * 2.0",null,null],[17,"FRAC_PI_2","","pi/2.0",null,null],[17,"FRAC_PI_3","","pi/3.0",null,null],[17,"FRAC_PI_4","","pi/4.0",null,null],[17,"FRAC_PI_6","","pi/6.0",null,null],[17,"FRAC_PI_8","","pi/8.0",null,null],[17,"FRAC_1_PI","","1.0/pi",null,null],[17,"FRAC_2_PI","","2.0/pi",null,null],[17,"FRAC_2_SQRT_PI","","2.0/sqrt(pi)",null,null],[17,"SQRT_2","","sqrt(2.0)",null,null],[17,"FRAC_1_SQRT_2","","1.0/sqrt(2.0)",null,null],[17,"E","","Euler's number",null,null],[17,"LOG2_E","","log2(e)",null,null],[17,"LOG10_E","","log10(e)",null,null],[17,"LN_2","","ln(2.0)",null,null],[17,"LN_10","","ln(10.0)",null,null],[0,"ascii","std","Operations on ASCII strings and characters",null,null],[3,"EscapeDefault","std::ascii","An iterator over the escaped version of a byte, constructed via\n`std::ascii::escape_default`.",null,null],[5,"escape_default","","Returns an iterator that produces an escaped version of a `u8`.",null,{"inputs":[{"name":"u8"}],"output":{"name":"escapedefault"}}],[8,"OwnedAsciiExt","","Extension methods for ASCII-subset only operations on owned strings",null,null],[10,"into_ascii_uppercase","","Converts the string to ASCII upper case:\nASCII letters 'a' to 'z' are mapped to 'A' to 'Z',\nbut non-ASCII letters are unchanged.",338,{"inputs":[{"name":"ownedasciiext"}],"output":{"name":"self"}}],[10,"into_ascii_lowercase","","Converts the string to ASCII lower case:\nASCII letters 'A' to 'Z' are mapped to 'a' to 'z',\nbut non-ASCII letters are unchanged.",338,{"inputs":[{"name":"ownedasciiext"}],"output":{"name":"self"}}],[8,"AsciiExt","","Extension methods for ASCII-subset only operations on string slices.",null,null],[16,"Owned","","Container type for copied ASCII characters.",339,null],[10,"is_ascii","","Checks if within the ASCII range.",339,{"inputs":[{"name":"asciiext"}],"output":{"name":"bool"}}],[10,"to_ascii_uppercase","","Makes a copy of the string in ASCII upper case.",339,{"inputs":[{"name":"asciiext"}],"output":{"name":"owned"}}],[10,"to_ascii_lowercase","","Makes a copy of the string in ASCII lower case.",339,{"inputs":[{"name":"asciiext"}],"output":{"name":"owned"}}],[10,"eq_ignore_ascii_case","","Checks that two strings are an ASCII case-insensitive match.",339,{"inputs":[{"name":"asciiext"},{"name":"self"}],"output":{"name":"bool"}}],[10,"make_ascii_uppercase","","Converts this type to its ASCII upper case equivalent in-place.",339,{"inputs":[{"name":"asciiext"}],"output":null}],[10,"make_ascii_lowercase","","Converts this type to its ASCII lower case equivalent in-place.",339,{"inputs":[{"name":"asciiext"}],"output":null}],[11,"into_ascii_uppercase","std::string","",282,{"inputs":[{"name":"string"}],"output":{"name":"string"}}],[11,"into_ascii_lowercase","","",282,{"inputs":[{"name":"string"}],"output":{"name":"string"}}],[11,"into_ascii_uppercase","std::vec","",273,{"inputs":[{"name":"vec"}],"output":{"name":"vec"}}],[11,"into_ascii_lowercase","","",273,{"inputs":[{"name":"vec"}],"output":{"name":"vec"}}],[11,"next","std::ascii","",340,{"inputs":[{"name":"escapedefault"}],"output":{"name":"option"}}],[11,"size_hint","","",340,null],[11,"next_back","","",340,{"inputs":[{"name":"escapedefault"}],"output":{"name":"option"}}],[0,"thunk","std","",null,null],[6,"Thunk","std::thunk","",null,null],[0,"num","std","Numeric traits and functions for generic mathematics",null,null],[8,"Zero","std::num","Types that have a \"zero\" value.",null,null],[10,"zero","","The \"zero\" (usually, additive identity) for this type.",341,{"inputs":[{"name":"zero"}],"output":{"name":"self"}}],[8,"One","","Types that have a \"one\" value.",null,null],[10,"one","","The \"one\" (usually, multiplicative identity) for this type.",342,{"inputs":[{"name":"one"}],"output":{"name":"self"}}],[4,"FpCategory","","Used for representing the classification of floating point numbers",null,null],[13,"Nan","","\"Not a Number\", often obtained by dividing by zero",11,null],[13,"Infinite","","Positive or negative infinity",11,null],[13,"Zero","","Positive or negative zero",11,null],[13,"Subnormal","","De-normalized floating point representation (less precise than `Normal`)",11,null],[13,"Normal","","A regular floating point number",11,null],[3,"ParseIntError","","An error which can be returned when parsing an integer.",null,null],[3,"ParseFloatError","","An error which can be returned when parsing a float.",null,null],[0,"wrapping","","",null,null],[8,"OverflowingOps","std::num::wrapping","",null,null],[10,"overflowing_add","","",343,null],[10,"overflowing_sub","","",343,null],[10,"overflowing_mul","","",343,null],[10,"overflowing_div","","",343,null],[10,"overflowing_rem","","",343,null],[10,"overflowing_neg","","",343,null],[10,"overflowing_shl","","",343,null],[10,"overflowing_shr","","",343,null],[3,"Wrapping","std::num","Provides intentionally-wrapped arithmetic on `T`.",null,null],[0,"thread","std","Native threads",null,null],[3,"LocalKey","std::thread","A thread local storage key which owns its contents.",null,null],[3,"ScopedKey","","Type representing a thread local storage key corresponding to a reference\nto the type parameter `T`.",null,null],[3,"Builder","","Thread configuration. Provides detailed control over the properties\nand behavior of new threads.",null,null],[3,"Thread","","A handle to a thread.",null,null],[3,"JoinHandle","","An owned permission to join on a thread (block on its termination).",null,null],[3,"JoinGuard","","An RAII-style guard that will block until thread termination when dropped.",null,null],[4,"LocalKeyState","","Indicator of the state of a thread local storage key.",null,null],[13,"Uninitialized","","All keys are in this state whenever a thread starts. Keys will\ntransition to the `Valid` state once the first call to `with` happens\nand the initialization expression succeeds.",344,null],[13,"Valid","","Once a key has been accessed successfully, it will enter the `Valid`\nstate. Keys in the `Valid` state will remain so until the thread exits,\nat which point the destructor will be run and the key will enter the\n`Destroyed` state.",344,null],[13,"Destroyed","","When a thread exits, the destructors for keys will be run (if\nnecessary). While a destructor is running, and possibly after a\ndestructor has run, a key is in the `Destroyed` state.",344,null],[5,"spawn","","Spawns a new thread, returning a `JoinHandle` for it.",null,{"inputs":[{"name":"f"}],"output":{"name":"joinhandle"}}],[5,"scoped","","Spawns a new *scoped* thread, returning a `JoinGuard` for it.",null,{"inputs":[{"name":"f"}],"output":{"name":"joinguard"}}],[5,"current","","Gets a handle to the thread that invokes it.",null,{"inputs":[],"output":{"name":"thread"}}],[5,"yield_now","","Cooperatively gives up a timeslice to the OS scheduler.",null,{"inputs":[],"output":null}],[5,"panicking","","Determines whether the current thread is unwinding because of panic.",null,{"inputs":[],"output":{"name":"bool"}}],[5,"catch_panic","","Invokes a closure, capturing the cause of panic if one occurs.",null,{"inputs":[{"name":"f"}],"output":{"name":"result"}}],[5,"sleep_ms","","Puts the current thread to sleep for the specified amount of time.",null,{"inputs":[{"name":"u32"}],"output":null}],[5,"sleep","","Puts the current thread to sleep for the specified amount of time.",null,{"inputs":[{"name":"duration"}],"output":null}],[5,"park","","Blocks unless or until the current thread's token is made available.",null,{"inputs":[],"output":null}],[5,"park_timeout_ms","","Blocks unless or until the current thread's token is made available or\nthe specified duration has been reached (may wake spuriously).",null,{"inputs":[{"name":"u32"}],"output":null}],[5,"park_timeout","","Blocks unless or until the current thread's token is made available or\nthe specified duration has been reached (may wake spuriously).",null,{"inputs":[{"name":"duration"}],"output":null}],[11,"clone","","",344,{"inputs":[{"name":"localkeystate"}],"output":{"name":"localkeystate"}}],[11,"eq","","",344,{"inputs":[{"name":"localkeystate"},{"name":"localkeystate"}],"output":{"name":"bool"}}],[11,"ne","","",344,{"inputs":[{"name":"localkeystate"},{"name":"localkeystate"}],"output":{"name":"bool"}}],[11,"with","","Acquires a reference to the value in this TLS key.",345,{"inputs":[{"name":"localkey"},{"name":"f"}],"output":{"name":"r"}}],[11,"state","","Query the current state of this key.",345,{"inputs":[{"name":"localkey"}],"output":{"name":"localkeystate"}}],[11,"set","","Inserts a value into this scoped thread local storage slot for a\nduration of a closure.",346,{"inputs":[{"name":"scopedkey"},{"name":"t"},{"name":"f"}],"output":{"name":"r"}}],[11,"with","","Gets a value out of this scoped variable.",346,{"inputs":[{"name":"scopedkey"},{"name":"f"}],"output":{"name":"r"}}],[11,"is_set","","Test whether this TLS key has been `set` for the current thread.",346,{"inputs":[{"name":"scopedkey"}],"output":{"name":"bool"}}],[6,"Result","","Indicates the manner in which a thread exited.",null,null],[11,"new","","Generates the base configuration for spawning a thread, from which\nconfiguration methods can be chained.",347,{"inputs":[{"name":"builder"}],"output":{"name":"builder"}}],[11,"name","","Names the thread-to-be. Currently the name is used for identification\nonly in panic messages.",347,{"inputs":[{"name":"builder"},{"name":"string"}],"output":{"name":"builder"}}],[11,"stack_size","","Sets the size of the stack for the new thread.",347,{"inputs":[{"name":"builder"},{"name":"usize"}],"output":{"name":"builder"}}],[11,"spawn","","Spawns a new thread, and returns a join handle for it.",347,{"inputs":[{"name":"builder"},{"name":"f"}],"output":{"name":"result"}}],[11,"scoped","","Spawns a new child thread that must be joined within a given\nscope, and returns a `JoinGuard`.",347,{"inputs":[{"name":"builder"},{"name":"f"}],"output":{"name":"result"}}],[11,"clone","","",348,{"inputs":[{"name":"thread"}],"output":{"name":"thread"}}],[11,"unpark","","Atomically makes the handle's token available if it is not already.",348,{"inputs":[{"name":"thread"}],"output":null}],[11,"name","","Gets the thread's name.",348,{"inputs":[{"name":"thread"}],"output":{"name":"option"}}],[11,"fmt","","",348,{"inputs":[{"name":"thread"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",348,{"inputs":[{"name":"thread"},{"name":"option"}],"output":{"name":"thread"}}],[11,"thread","","Extracts a handle to the underlying thread",349,{"inputs":[{"name":"joinhandle"}],"output":{"name":"thread"}}],[11,"join","","Waits for the associated thread to finish.",349,{"inputs":[{"name":"joinhandle"}],"output":{"name":"result"}}],[11,"thread","","Extracts a handle to the thread this guard will join on.",350,{"inputs":[{"name":"joinguard"}],"output":{"name":"thread"}}],[11,"join","","Waits for the associated thread to finish, returning the result of the\nthread's calculation.",350,{"inputs":[{"name":"joinguard"}],"output":{"name":"t"}}],[11,"drop","","",350,{"inputs":[{"name":"joinguard"}],"output":null}],[0,"collections","std","Collection types.",null,null],[4,"Bound","std::collections","An endpoint of a range of keys.",null,null],[13,"Included","","An inclusive bound.",306,null],[13,"Excluded","","An exclusive bound.",306,null],[13,"Unbounded","","An infinite endpoint. Indicates that there is no bound in this direction.",306,null],[3,"BinaryHeap","","A priority queue implemented with a binary heap.",null,null],[3,"BitVec","","The bitvector type.",null,null],[3,"BitSet","","An implementation of a set using a bit vector as an underlying\nrepresentation for holding unsigned numerical elements.",null,null],[3,"BTreeMap","","A map based on a B-Tree.",null,null],[3,"BTreeSet","","A set based on a B-Tree.",null,null],[3,"LinkedList","","A doubly-linked list.",null,null],[3,"VecDeque","","`VecDeque` is a growable ring buffer, which can be used as a\ndouble-ended queue efficiently.",null,null],[3,"VecMap","","A map optimized for small integer keys.",null,null],[0,"binary_heap","","A priority queue implemented with a binary heap.",null,null],[3,"BinaryHeap","std::collections::binary_heap","A priority queue implemented with a binary heap.",null,null],[3,"Iter","","`BinaryHeap` iterator.",null,null],[3,"IntoIter","","An iterator that moves out of a `BinaryHeap`.",null,null],[3,"Drain","","An iterator that drains a `BinaryHeap`.",null,null],[0,"bit_vec","std::collections","",null,null],[3,"Iter","std::collections::bit_vec","An iterator for `BitVec`.",null,null],[3,"BitVec","","The bitvector type.",null,null],[0,"bit_set","std::collections","",null,null],[3,"SymmetricDifference","std::collections::bit_set","",null,null],[3,"Difference","","",null,null],[3,"BitSet","","An implementation of a set using a bit vector as an underlying\nrepresentation for holding unsigned numerical elements.",null,null],[3,"Intersection","","",null,null],[3,"Union","","",null,null],[3,"SetIter","","An iterator for `BitSet`.",null,null],[0,"btree_map","std::collections","",null,null],[3,"Keys","std::collections::btree_map","An iterator over a BTreeMap's keys.",null,null],[3,"OccupiedEntry","","An occupied Entry.",null,null],[3,"BTreeMap","","A map based on a B-Tree.",null,null],[3,"Values","","An iterator over a BTreeMap's values.",null,null],[3,"VacantEntry","","A vacant Entry.",null,null],[4,"Entry","","A view into a single entry in a map, which may either be vacant or occupied.",null,null],[13,"Vacant","","A vacant Entry",254,null],[13,"Occupied","","An occupied Entry",254,null],[3,"IterMut","","A mutable iterator over a BTreeMap's entries.",null,null],[3,"IntoIter","","An owning iterator over a BTreeMap's entries.",null,null],[3,"Iter","","An iterator over a BTreeMap's entries.",null,null],[3,"Range","","An iterator over a sub-range of BTreeMap's entries.",null,null],[3,"RangeMut","","A mutable iterator over a sub-range of BTreeMap's entries.",null,null],[0,"btree_set","std::collections","",null,null],[3,"Union","std::collections::btree_set","A lazy iterator producing elements in the set union (in-order).",null,null],[3,"Difference","","A lazy iterator producing elements in the set difference (in-order).",null,null],[3,"Range","","An iterator over a sub-range of BTreeSet's items.",null,null],[3,"Iter","","An iterator over a BTreeSet's items.",null,null],[3,"Intersection","","A lazy iterator producing elements in the set intersection (in-order).",null,null],[3,"IntoIter","","An owning iterator over a BTreeSet's items.",null,null],[3,"BTreeSet","","A set based on a B-Tree.",null,null],[3,"SymmetricDifference","","A lazy iterator producing elements in the set symmetric difference (in-order).",null,null],[0,"linked_list","std::collections","A doubly-linked list with owned nodes.",null,null],[3,"LinkedList","std::collections::linked_list","A doubly-linked list.",null,null],[3,"Iter","","An iterator over references to the items of a `LinkedList`.",null,null],[3,"IterMut","","An iterator over mutable references to the items of a `LinkedList`.",null,null],[3,"IntoIter","","An iterator over mutable references to the items of a `LinkedList`.",null,null],[0,"vec_deque","std::collections","VecDeque is a double-ended queue, which is implemented with the help of a\ngrowing ring buffer.",null,null],[3,"VecDeque","std::collections::vec_deque","`VecDeque` is a growable ring buffer, which can be used as a\ndouble-ended queue efficiently.",null,null],[3,"Iter","","`VecDeque` iterator.",null,null],[3,"IterMut","","`VecDeque` mutable iterator.",null,null],[3,"IntoIter","","A by-value VecDeque iterator",null,null],[3,"Drain","","A draining VecDeque iterator",null,null],[0,"vec_map","std::collections","A simple map based on a vector for small integer keys. Space requirements\nare O(highest integer key).",null,null],[3,"VecMap","std::collections::vec_map","A map optimized for small integer keys.",null,null],[4,"Entry","","A view into a single entry in a map, which may either be vacant or occupied.",null,null],[13,"Vacant","","A vacant Entry",297,null],[13,"Occupied","","An occupied Entry",297,null],[3,"VacantEntry","","A vacant Entry.",null,null],[3,"OccupiedEntry","","An occupied Entry.",null,null],[3,"Iter","","An iterator over the key-value pairs of a map.",null,null],[3,"IterMut","","An iterator over the key-value pairs of a map, with the\nvalues being mutable.",null,null],[3,"Keys","","An iterator over the keys of a map.",null,null],[3,"Values","","An iterator over the values of a map.",null,null],[3,"IntoIter","","A consuming iterator over the key-value pairs of a map.",null,null],[3,"Drain","","",null,null],[3,"HashMap","std::collections","A hash map implementation which uses linear probing with Robin\nHood bucket stealing.",null,null],[3,"HashSet","","An implementation of a hash set using the underlying representation of a\nHashMap where the value is ().",null,null],[11,"clone","","",351,{"inputs":[{"name":"hashmap"}],"output":{"name":"hashmap"}}],[11,"new","","Creates an empty HashMap.",351,{"inputs":[{"name":"hashmap"}],"output":{"name":"hashmap"}}],[11,"with_capacity","","Creates an empty hash map with the given initial capacity.",351,{"inputs":[{"name":"hashmap"},{"name":"usize"}],"output":{"name":"hashmap"}}],[11,"with_hash_state","","Creates an empty hashmap which will use the given hasher to hash keys.",351,{"inputs":[{"name":"hashmap"},{"name":"s"}],"output":{"name":"hashmap"}}],[11,"with_capacity_and_hash_state","","Creates an empty HashMap with space for at least `capacity`\nelements, using `hasher` to hash the keys.",351,{"inputs":[{"name":"hashmap"},{"name":"usize"},{"name":"s"}],"output":{"name":"hashmap"}}],[11,"capacity","","Returns the number of elements the map can hold without reallocating.",351,{"inputs":[{"name":"hashmap"}],"output":{"name":"usize"}}],[11,"reserve","","Reserves capacity for at least `additional` more elements to be inserted\nin the `HashMap`. The collection may reserve more space to avoid\nfrequent reallocations.",351,{"inputs":[{"name":"hashmap"},{"name":"usize"}],"output":null}],[11,"shrink_to_fit","","Shrinks the capacity of the map as much as possible. It will drop\ndown as much as possible while maintaining the internal rules\nand possibly leaving some space in accordance with the resize policy.",351,{"inputs":[{"name":"hashmap"}],"output":null}],[11,"keys","","An iterator visiting all keys in arbitrary order.\nIterator element type is `&'a K`.",351,{"inputs":[{"name":"hashmap"}],"output":{"name":"keys"}}],[11,"values","","An iterator visiting all values in arbitrary order.\nIterator element type is `&'a V`.",351,{"inputs":[{"name":"hashmap"}],"output":{"name":"values"}}],[11,"iter","","An iterator visiting all key-value pairs in arbitrary order.\nIterator element type is `(&'a K, &'a V)`.",351,{"inputs":[{"name":"hashmap"}],"output":{"name":"iter"}}],[11,"iter_mut","","An iterator visiting all key-value pairs in arbitrary order,\nwith mutable references to the values.\nIterator element type is `(&'a K, &'a mut V)`.",351,{"inputs":[{"name":"hashmap"}],"output":{"name":"itermut"}}],[11,"entry","","Gets the given key's corresponding entry in the map for in-place manipulation.",351,{"inputs":[{"name":"hashmap"},{"name":"k"}],"output":{"name":"entry"}}],[11,"len","","Returns the number of elements in the map.",351,{"inputs":[{"name":"hashmap"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns true if the map contains no elements.",351,{"inputs":[{"name":"hashmap"}],"output":{"name":"bool"}}],[11,"drain","","Clears the map, returning all key-value pairs as an iterator. Keeps the\nallocated memory for reuse.",351,{"inputs":[{"name":"hashmap"}],"output":{"name":"drain"}}],[11,"clear","","Clears the map, removing all key-value pairs. Keeps the allocated memory\nfor reuse.",351,{"inputs":[{"name":"hashmap"}],"output":null}],[11,"get","","Returns a reference to the value corresponding to the key.",351,{"inputs":[{"name":"hashmap"},{"name":"q"}],"output":{"name":"option"}}],[11,"contains_key","","Returns true if the map contains a value for the specified key.",351,{"inputs":[{"name":"hashmap"},{"name":"q"}],"output":{"name":"bool"}}],[11,"get_mut","","Returns a mutable reference to the value corresponding to the key.",351,{"inputs":[{"name":"hashmap"},{"name":"q"}],"output":{"name":"option"}}],[11,"insert","","Inserts a key-value pair into the map. If the key already had a value\npresent in the map, that value is returned. Otherwise, `None` is returned.",351,{"inputs":[{"name":"hashmap"},{"name":"k"},{"name":"v"}],"output":{"name":"option"}}],[11,"remove","","Removes a key from the map, returning the value at the key if the key\nwas previously in the map.",351,{"inputs":[{"name":"hashmap"},{"name":"q"}],"output":{"name":"option"}}],[11,"eq","","",351,{"inputs":[{"name":"hashmap"},{"name":"hashmap"}],"output":{"name":"bool"}}],[11,"fmt","","",351,{"inputs":[{"name":"hashmap"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"default","","",351,{"inputs":[{"name":"hashmap"}],"output":{"name":"hashmap"}}],[11,"index","","",351,{"inputs":[{"name":"hashmap"},{"name":"q"}],"output":{"name":"v"}}],[11,"into_iter","","Creates a consuming iterator, that is, one that moves each key-value\npair out of the map in arbitrary order. The map cannot be used after\ncalling this.",351,{"inputs":[{"name":"hashmap"}],"output":{"name":"intoiter"}}],[11,"from_iter","","",351,{"inputs":[{"name":"hashmap"},{"name":"t"}],"output":{"name":"hashmap"}}],[11,"extend","","",351,{"inputs":[{"name":"hashmap"},{"name":"t"}],"output":null}],[11,"clone","","",352,{"inputs":[{"name":"hashset"}],"output":{"name":"hashset"}}],[11,"new","","Creates an empty HashSet.",352,{"inputs":[{"name":"hashset"}],"output":{"name":"hashset"}}],[11,"with_capacity","","Creates an empty HashSet with space for at least `n` elements in\nthe hash table.",352,{"inputs":[{"name":"hashset"},{"name":"usize"}],"output":{"name":"hashset"}}],[11,"with_hash_state","","Creates a new empty hash set which will use the given hasher to hash\nkeys.",352,{"inputs":[{"name":"hashset"},{"name":"s"}],"output":{"name":"hashset"}}],[11,"with_capacity_and_hash_state","","Creates an empty HashSet with space for at least `capacity`\nelements in the hash table, using `hasher` to hash the keys.",352,{"inputs":[{"name":"hashset"},{"name":"usize"},{"name":"s"}],"output":{"name":"hashset"}}],[11,"capacity","","Returns the number of elements the set can hold without reallocating.",352,{"inputs":[{"name":"hashset"}],"output":{"name":"usize"}}],[11,"reserve","","Reserves capacity for at least `additional` more elements to be inserted\nin the `HashSet`. The collection may reserve more space to avoid\nfrequent reallocations.",352,{"inputs":[{"name":"hashset"},{"name":"usize"}],"output":null}],[11,"shrink_to_fit","","Shrinks the capacity of the set as much as possible. It will drop\ndown as much as possible while maintaining the internal rules\nand possibly leaving some space in accordance with the resize policy.",352,{"inputs":[{"name":"hashset"}],"output":null}],[11,"iter","","An iterator visiting all elements in arbitrary order.\nIterator element type is &'a T.",352,{"inputs":[{"name":"hashset"}],"output":{"name":"iter"}}],[11,"difference","","Visit the values representing the difference.",352,{"inputs":[{"name":"hashset"},{"name":"hashset"}],"output":{"name":"difference"}}],[11,"symmetric_difference","","Visit the values representing the symmetric difference.",352,{"inputs":[{"name":"hashset"},{"name":"hashset"}],"output":{"name":"symmetricdifference"}}],[11,"intersection","","Visit the values representing the intersection.",352,{"inputs":[{"name":"hashset"},{"name":"hashset"}],"output":{"name":"intersection"}}],[11,"union","","Visit the values representing the union.",352,{"inputs":[{"name":"hashset"},{"name":"hashset"}],"output":{"name":"union"}}],[11,"len","","Returns the number of elements in the set.",352,{"inputs":[{"name":"hashset"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns true if the set contains no elements.",352,{"inputs":[{"name":"hashset"}],"output":{"name":"bool"}}],[11,"drain","","Clears the set, returning all elements in an iterator.",352,{"inputs":[{"name":"hashset"}],"output":{"name":"drain"}}],[11,"clear","","Clears the set, removing all values.",352,{"inputs":[{"name":"hashset"}],"output":null}],[11,"contains","","Returns `true` if the set contains a value.",352,{"inputs":[{"name":"hashset"},{"name":"q"}],"output":{"name":"bool"}}],[11,"is_disjoint","","Returns `true` if the set has no elements in common with `other`.\nThis is equivalent to checking for an empty intersection.",352,{"inputs":[{"name":"hashset"},{"name":"hashset"}],"output":{"name":"bool"}}],[11,"is_subset","","Returns `true` if the set is a subset of another.",352,{"inputs":[{"name":"hashset"},{"name":"hashset"}],"output":{"name":"bool"}}],[11,"is_superset","","Returns `true` if the set is a superset of another.",352,{"inputs":[{"name":"hashset"},{"name":"hashset"}],"output":{"name":"bool"}}],[11,"insert","","Adds a value to the set. Returns `true` if the value was not already\npresent in the set.",352,{"inputs":[{"name":"hashset"},{"name":"t"}],"output":{"name":"bool"}}],[11,"remove","","Removes a value from the set. Returns `true` if the value was\npresent in the set.",352,{"inputs":[{"name":"hashset"},{"name":"q"}],"output":{"name":"bool"}}],[11,"eq","","",352,{"inputs":[{"name":"hashset"},{"name":"hashset"}],"output":{"name":"bool"}}],[11,"fmt","","",352,{"inputs":[{"name":"hashset"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from_iter","","",352,{"inputs":[{"name":"hashset"},{"name":"i"}],"output":{"name":"hashset"}}],[11,"extend","","",352,{"inputs":[{"name":"hashset"},{"name":"i"}],"output":null}],[11,"default","","",352,{"inputs":[{"name":"hashset"}],"output":{"name":"hashset"}}],[11,"into_iter","","Creates a consuming iterator, that is, one that moves each value out\nof the set in arbitrary order. The set cannot be used after calling\nthis.",352,{"inputs":[{"name":"hashset"}],"output":{"name":"intoiter"}}],[0,"hash_map","","A hashmap",null,null],[3,"HashMap","std::collections::hash_map","A hash map implementation which uses linear probing with Robin\nHood bucket stealing.",null,null],[3,"Iter","","HashMap iterator.",null,null],[3,"IterMut","","HashMap mutable values iterator.",null,null],[3,"IntoIter","","HashMap move iterator.",null,null],[3,"Keys","","HashMap keys iterator.",null,null],[3,"Values","","HashMap values iterator.",null,null],[3,"Drain","","HashMap drain iterator.",null,null],[3,"OccupiedEntry","","A view into a single occupied location in a HashMap.",null,null],[3,"VacantEntry","","A view into a single empty location in a HashMap.",null,null],[3,"RandomState","","`RandomState` is the default state for `HashMap` types.",null,null],[4,"Entry","","A view into a single location in a map, which may be vacant or occupied.",null,null],[13,"Occupied","","An occupied Entry.",353,null],[13,"Vacant","","A vacant Entry.",353,null],[0,"hash_set","std::collections","A hashset",null,null],[3,"HashSet","std::collections::hash_set","An implementation of a hash set using the underlying representation of a\nHashMap where the value is ().",null,null],[3,"Iter","","HashSet iterator",null,null],[3,"IntoIter","","HashSet move iterator",null,null],[3,"Drain","","HashSet drain iterator",null,null],[3,"Intersection","","Intersection iterator",null,null],[3,"Difference","","Difference iterator",null,null],[3,"SymmetricDifference","","Symmetric difference iterator.",null,null],[3,"Union","","Set union iterator.",null,null],[0,"hash_state","std::collections","Experimental support for providing custom hash algorithms to a HashMap and\nHashSet.",null,null],[3,"DefaultState","std::collections::hash_state","A structure which is a factory for instances of `Hasher` which implement the\ndefault trait.",null,null],[8,"HashState","","A trait representing stateful hashes which can be used to hash keys in a\n`HashMap`.",null,null],[16,"Hasher","","Type of the hasher that will be created.",354,null],[10,"hasher","","Creates a new hasher based on the given state of this object.",354,{"inputs":[{"name":"hashstate"}],"output":{"name":"hasher"}}],[0,"dynamic_lib","std","Dynamic library facilities.",null,null],[3,"DynamicLibrary","std::dynamic_lib","",null,null],[11,"drop","","",355,{"inputs":[{"name":"dynamiclibrary"}],"output":null}],[11,"open","","Lazily open a dynamic library. When passed None it gives a\nhandle to the calling process",355,{"inputs":[{"name":"dynamiclibrary"},{"name":"option"}],"output":{"name":"result"}}],[11,"prepend_search_path","","Prepends a path to this process's search path for dynamic libraries",355,{"inputs":[{"name":"dynamiclibrary"},{"name":"path"}],"output":null}],[11,"create_path","","From a slice of paths, create a new vector which is suitable to be an\nenvironment variable for this platforms dylib search path.",355,null],[11,"envvar","","Returns the environment variable for this process's dynamic library\nsearch path",355,{"inputs":[{"name":"dynamiclibrary"}],"output":{"name":"str"}}],[11,"search_path","","Returns the current search path for dynamic libraries being used by this\nprocess",355,{"inputs":[{"name":"dynamiclibrary"}],"output":{"name":"vec"}}],[11,"symbol","","Accesses the value at the symbol of the dynamic library.",355,{"inputs":[{"name":"dynamiclibrary"},{"name":"str"}],"output":{"name":"result"}}],[0,"env","std","Inspection and manipulation of the process's environment.",null,null],[3,"Vars","std::env","An iterator over a snapshot of the environment variables of this process.",null,null],[3,"VarsOs","","An iterator over a snapshot of the environment variables of this process.",null,null],[3,"SplitPaths","","An iterator over `Path` instances for parsing an environment variable\naccording to platform-specific conventions.",null,null],[3,"JoinPathsError","","Error type returned from `std::env::join_paths` when paths fail to be\njoined.",null,null],[3,"Args","","An iterator over the arguments of a process, yielding a `String` value\nfor each argument.",null,null],[3,"ArgsOs","","An iterator over the arguments of a process, yielding an `OsString` value\nfor each argument.",null,null],[4,"VarError","","Possible errors from the `env::var` method.",null,null],[13,"NotPresent","","The specified environment variable was not present in the current\nprocess's environment.",356,null],[13,"NotUnicode","","The specified environment variable was found, but it did not contain\nvalid unicode data. The found data is returned as a payload of this\nvariant.",356,null],[5,"current_dir","","Returns the current working directory as a `PathBuf`.",null,{"inputs":[],"output":{"name":"result"}}],[5,"set_current_dir","","Changes the current working directory to the specified path, returning\nwhether the change was completed successfully or not.",null,{"inputs":[{"name":"p"}],"output":{"name":"result"}}],[5,"vars","","Returns an iterator of (variable, value) pairs of strings, for all the\nenvironment variables of the current process.",null,{"inputs":[],"output":{"name":"vars"}}],[5,"vars_os","","Returns an iterator of (variable, value) pairs of OS strings, for all the\nenvironment variables of the current process.",null,{"inputs":[],"output":{"name":"varsos"}}],[5,"var","","Fetches the environment variable `key` from the current process.",null,{"inputs":[{"name":"k"}],"output":{"name":"result"}}],[5,"var_os","","Fetches the environment variable `key` from the current process, returning\nNone if the variable isn't set.",null,{"inputs":[{"name":"k"}],"output":{"name":"option"}}],[5,"set_var","","Sets the environment variable `k` to the value `v` for the currently running\nprocess.",null,{"inputs":[{"name":"k"},{"name":"v"}],"output":null}],[5,"remove_var","","Removes an environment variable from the environment of the currently running process.",null,{"inputs":[{"name":"k"}],"output":null}],[5,"split_paths","","Parses input according to platform conventions for the `PATH`\nenvironment variable.",null,{"inputs":[{"name":"t"}],"output":{"name":"splitpaths"}}],[5,"join_paths","","Joins a collection of `Path`s appropriately for the `PATH`\nenvironment variable.",null,{"inputs":[{"name":"i"}],"output":{"name":"result"}}],[5,"home_dir","","Optionally returns the path to the current user's home directory if known.",null,{"inputs":[],"output":{"name":"option"}}],[5,"temp_dir","","Returns the path to a temporary directory.",null,{"inputs":[],"output":{"name":"pathbuf"}}],[5,"current_exe","","Optionally returns the filesystem path to the current executable which is\nrunning but with the executable name.",null,{"inputs":[],"output":{"name":"result"}}],[5,"set_exit_status","","Sets the process exit code",null,{"inputs":[{"name":"i32"}],"output":null}],[5,"get_exit_status","","Fetches the process's current exit code. This defaults to 0 and can change\nby calling `set_exit_status`.",null,{"inputs":[],"output":{"name":"i32"}}],[5,"args","","Returns the arguments which this program was started with (normally passed\nvia the command line).",null,{"inputs":[],"output":{"name":"args"}}],[5,"args_os","","Returns the arguments which this program was started with (normally passed\nvia the command line).",null,{"inputs":[],"output":{"name":"argsos"}}],[5,"page_size","","Returns the page size of the current architecture in bytes.",null,{"inputs":[],"output":{"name":"usize"}}],[0,"consts","","Constants associated with the current target",null,null],[17,"ARCH","std::env::consts","A string describing the architecture of the CPU that this is currently\nin use.",null,null],[17,"FAMILY","","The family of the operating system. In this case, `unix`.",null,null],[17,"OS","","A string describing the specific operating system in use: in this\ncase, `linux`.",null,null],[17,"DLL_PREFIX","","Specifies the filename prefix used for shared libraries on this\nplatform: in this case, `lib`.",null,null],[17,"DLL_SUFFIX","","Specifies the filename suffix used for shared libraries on this\nplatform: in this case, `.so`.",null,null],[17,"DLL_EXTENSION","","Specifies the file extension used for shared libraries on this\nplatform that goes after the dot: in this case, `so`.",null,null],[17,"EXE_SUFFIX","","Specifies the filename suffix used for executable binaries on this\nplatform: in this case, the empty string.",null,null],[17,"EXE_EXTENSION","","Specifies the file extension, if any, used for executable binaries\non this platform: in this case, the empty string.",null,null],[11,"next","std::env","",357,{"inputs":[{"name":"vars"}],"output":{"name":"option"}}],[11,"size_hint","","",357,null],[11,"next","","",358,{"inputs":[{"name":"varsos"}],"output":{"name":"option"}}],[11,"size_hint","","",358,null],[11,"clone","","",356,{"inputs":[{"name":"varerror"}],"output":{"name":"varerror"}}],[11,"eq","","",356,{"inputs":[{"name":"varerror"},{"name":"varerror"}],"output":{"name":"bool"}}],[11,"ne","","",356,{"inputs":[{"name":"varerror"},{"name":"varerror"}],"output":{"name":"bool"}}],[11,"fmt","","",356,{"inputs":[{"name":"varerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",356,{"inputs":[{"name":"varerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"description","","",356,{"inputs":[{"name":"varerror"}],"output":{"name":"str"}}],[11,"next","","",359,{"inputs":[{"name":"splitpaths"}],"output":{"name":"option"}}],[11,"size_hint","","",359,null],[11,"fmt","","",360,{"inputs":[{"name":"joinpathserror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",360,{"inputs":[{"name":"joinpathserror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"description","","",360,{"inputs":[{"name":"joinpathserror"}],"output":{"name":"str"}}],[11,"next","","",361,{"inputs":[{"name":"args"}],"output":{"name":"option"}}],[11,"size_hint","","",361,null],[11,"len","","",361,{"inputs":[{"name":"args"}],"output":{"name":"usize"}}],[11,"next","","",362,{"inputs":[{"name":"argsos"}],"output":{"name":"option"}}],[11,"size_hint","","",362,null],[11,"len","","",362,{"inputs":[{"name":"argsos"}],"output":{"name":"usize"}}],[0,"ffi","std","Utilities related to FFI bindings.",null,null],[3,"CString","std::ffi","A type representing an owned C-compatible string",null,null],[3,"CStr","","Representation of a borrowed C string.",null,null],[3,"NulError","","An error returned from `CString::new` to indicate that a nul byte was found\nin the vector provided.",null,null],[3,"OsString","","Owned, mutable OS strings.",null,null],[3,"OsStr","","Slices into OS strings.",null,null],[11,"clone","","",363,{"inputs":[{"name":"cstring"}],"output":{"name":"cstring"}}],[11,"hash","","",363,null],[11,"cmp","","",363,{"inputs":[{"name":"cstring"},{"name":"cstring"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",363,{"inputs":[{"name":"cstring"},{"name":"cstring"}],"output":{"name":"option"}}],[11,"lt","","",363,{"inputs":[{"name":"cstring"},{"name":"cstring"}],"output":{"name":"bool"}}],[11,"le","","",363,{"inputs":[{"name":"cstring"},{"name":"cstring"}],"output":{"name":"bool"}}],[11,"gt","","",363,{"inputs":[{"name":"cstring"},{"name":"cstring"}],"output":{"name":"bool"}}],[11,"ge","","",363,{"inputs":[{"name":"cstring"},{"name":"cstring"}],"output":{"name":"bool"}}],[11,"eq","","",363,{"inputs":[{"name":"cstring"},{"name":"cstring"}],"output":{"name":"bool"}}],[11,"ne","","",363,{"inputs":[{"name":"cstring"},{"name":"cstring"}],"output":{"name":"bool"}}],[11,"hash","","",364,null],[11,"fmt","","",365,{"inputs":[{"name":"nulerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",365,{"inputs":[{"name":"nulerror"},{"name":"nulerror"}],"output":{"name":"bool"}}],[11,"ne","","",365,{"inputs":[{"name":"nulerror"},{"name":"nulerror"}],"output":{"name":"bool"}}],[11,"clone","","",365,{"inputs":[{"name":"nulerror"}],"output":{"name":"nulerror"}}],[11,"new","","Creates a new C-compatible string from a container of bytes.",363,{"inputs":[{"name":"cstring"},{"name":"t"}],"output":{"name":"result"}}],[11,"from_vec_unchecked","","Creates a C-compatible string from a byte vector without checking for\ninterior 0 bytes.",363,{"inputs":[{"name":"cstring"},{"name":"vec"}],"output":{"name":"cstring"}}],[11,"from_ptr","","Retakes ownership of a CString that was transferred to C.",363,null],[11,"into_ptr","","Transfers ownership of the string to a C caller.",363,null],[11,"as_bytes","","Returns the contents of this `CString` as a slice of bytes.",363,null],[11,"as_bytes_with_nul","","Equivalent to the `as_bytes` function except that the returned slice\nincludes the trailing nul byte.",363,null],[11,"deref","","",363,{"inputs":[{"name":"cstring"}],"output":{"name":"cstr"}}],[11,"fmt","","",363,{"inputs":[{"name":"cstring"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",364,{"inputs":[{"name":"cstr"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"borrow","","",363,{"inputs":[{"name":"cstring"}],"output":{"name":"cstr"}}],[11,"nul_position","","Returns the position of the nul byte in the slice that was provided to\n`CString::new`.",365,{"inputs":[{"name":"nulerror"}],"output":{"name":"usize"}}],[11,"into_vec","","Consumes this error, returning the underlying vector of bytes which\ngenerated the error in the first place.",365,{"inputs":[{"name":"nulerror"}],"output":{"name":"vec"}}],[11,"description","","",365,{"inputs":[{"name":"nulerror"}],"output":{"name":"str"}}],[11,"fmt","","",365,{"inputs":[{"name":"nulerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from_ptr","","Casts a raw C string to a safe C string wrapper.",364,null],[11,"as_ptr","","Returns the inner pointer to this C string.",364,null],[11,"to_bytes","","Converts this C string to a byte slice.",364,null],[11,"to_bytes_with_nul","","Converts this C string to a byte slice containing the trailing 0 byte.",364,null],[11,"to_str","","Yields a `&str` slice if the `CStr` contains valid UTF-8.",364,{"inputs":[{"name":"cstr"}],"output":{"name":"result"}}],[11,"to_string_lossy","","Converts a `CStr` into a `Cow<str>`.",364,{"inputs":[{"name":"cstr"}],"output":{"name":"cow"}}],[11,"eq","","",364,{"inputs":[{"name":"cstr"},{"name":"cstr"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",364,{"inputs":[{"name":"cstr"},{"name":"cstr"}],"output":{"name":"option"}}],[11,"cmp","","",364,{"inputs":[{"name":"cstr"},{"name":"cstr"}],"output":{"name":"ordering"}}],[11,"to_owned","","",364,{"inputs":[{"name":"cstr"}],"output":{"name":"cstring"}}],[11,"clone","","",366,{"inputs":[{"name":"osstring"}],"output":{"name":"osstring"}}],[11,"new","","Constructs a new empty `OsString`.",366,{"inputs":[{"name":"osstring"}],"output":{"name":"osstring"}}],[11,"from_bytes","","Constructs an `OsString` from a byte sequence.",366,{"inputs":[{"name":"osstring"},{"name":"b"}],"output":{"name":"option"}}],[11,"as_os_str","","Converts to an `OsStr` slice.",366,{"inputs":[{"name":"osstring"}],"output":{"name":"osstr"}}],[11,"into_string","","Converts the `OsString` into a `String` if it contains valid Unicode data.",366,{"inputs":[{"name":"osstring"}],"output":{"name":"result"}}],[11,"push","","Extends the string with the given `&OsStr` slice.",366,{"inputs":[{"name":"osstring"},{"name":"t"}],"output":null}],[11,"from","","",366,{"inputs":[{"name":"osstring"},{"name":"string"}],"output":{"name":"osstring"}}],[11,"from","","",366,{"inputs":[{"name":"osstring"},{"name":"t"}],"output":{"name":"osstring"}}],[11,"index","","",366,{"inputs":[{"name":"osstring"},{"name":"rangefull"}],"output":{"name":"osstr"}}],[11,"deref","","",366,{"inputs":[{"name":"osstring"}],"output":{"name":"osstr"}}],[11,"fmt","","",366,{"inputs":[{"name":"osstring"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",366,{"inputs":[{"name":"osstring"},{"name":"osstring"}],"output":{"name":"bool"}}],[11,"eq","","",366,{"inputs":[{"name":"osstring"},{"name":"str"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",366,{"inputs":[{"name":"osstring"},{"name":"osstring"}],"output":{"name":"option"}}],[11,"lt","","",366,{"inputs":[{"name":"osstring"},{"name":"osstring"}],"output":{"name":"bool"}}],[11,"le","","",366,{"inputs":[{"name":"osstring"},{"name":"osstring"}],"output":{"name":"bool"}}],[11,"gt","","",366,{"inputs":[{"name":"osstring"},{"name":"osstring"}],"output":{"name":"bool"}}],[11,"ge","","",366,{"inputs":[{"name":"osstring"},{"name":"osstring"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",366,{"inputs":[{"name":"osstring"},{"name":"str"}],"output":{"name":"option"}}],[11,"cmp","","",366,{"inputs":[{"name":"osstring"},{"name":"osstring"}],"output":{"name":"ordering"}}],[11,"hash","","",366,{"inputs":[{"name":"osstring"},{"name":"h"}],"output":null}],[11,"new","","Coerces into an `OsStr` slice.",367,{"inputs":[{"name":"osstr"},{"name":"s"}],"output":{"name":"osstr"}}],[11,"to_str","","Yields a `&str` slice if the `OsStr` is valid unicode.",367,{"inputs":[{"name":"osstr"}],"output":{"name":"option"}}],[11,"to_string_lossy","","Converts an `OsStr` to a `Cow<str>`.",367,{"inputs":[{"name":"osstr"}],"output":{"name":"cow"}}],[11,"to_os_string","","Copies the slice into an owned `OsString`.",367,{"inputs":[{"name":"osstr"}],"output":{"name":"osstring"}}],[11,"to_bytes","","Yields this `OsStr` as a byte slice.",367,{"inputs":[{"name":"osstr"}],"output":{"name":"option"}}],[11,"to_cstring","","Creates a `CString` containing this `OsStr` data.",367,{"inputs":[{"name":"osstr"}],"output":{"name":"option"}}],[11,"eq","","",367,{"inputs":[{"name":"osstr"},{"name":"osstr"}],"output":{"name":"bool"}}],[11,"eq","","",367,{"inputs":[{"name":"osstr"},{"name":"str"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",367,{"inputs":[{"name":"osstr"},{"name":"osstr"}],"output":{"name":"option"}}],[11,"lt","","",367,{"inputs":[{"name":"osstr"},{"name":"osstr"}],"output":{"name":"bool"}}],[11,"le","","",367,{"inputs":[{"name":"osstr"},{"name":"osstr"}],"output":{"name":"bool"}}],[11,"gt","","",367,{"inputs":[{"name":"osstr"},{"name":"osstr"}],"output":{"name":"bool"}}],[11,"ge","","",367,{"inputs":[{"name":"osstr"},{"name":"osstr"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",367,{"inputs":[{"name":"osstr"},{"name":"str"}],"output":{"name":"option"}}],[11,"cmp","","",367,{"inputs":[{"name":"osstr"},{"name":"osstr"}],"output":{"name":"ordering"}}],[11,"hash","","",367,{"inputs":[{"name":"osstr"},{"name":"h"}],"output":null}],[11,"fmt","","",367,{"inputs":[{"name":"osstr"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"borrow","","",366,{"inputs":[{"name":"osstring"}],"output":{"name":"osstr"}}],[11,"to_owned","","",367,{"inputs":[{"name":"osstr"}],"output":{"name":"osstring"}}],[11,"as_ref","","",367,{"inputs":[{"name":"osstr"}],"output":{"name":"osstr"}}],[11,"as_ref","","",366,{"inputs":[{"name":"osstring"}],"output":{"name":"osstr"}}],[11,"as_ref","std::string","",282,{"inputs":[{"name":"string"}],"output":{"name":"osstr"}}],[0,"fs","std","Filesystem manipulation operations",null,null],[3,"File","std::fs","A reference to an open file on the filesystem.",null,null],[3,"Metadata","","Metadata information about a file.",null,null],[3,"ReadDir","","Iterator over the entries in a directory.",null,null],[3,"DirEntry","","Entries returned by the `ReadDir` iterator.",null,null],[3,"WalkDir","","An iterator that recursively walks over the contents of a directory.",null,null],[3,"OpenOptions","","Options and flags which can be used to configure how a file is opened.",null,null],[3,"Permissions","","Representation of the various permissions on a file.",null,null],[3,"FileType","","An structure representing a type of file with accessors for each file type.",null,null],[3,"DirBuilder","","A builder used to create directories in various manners.",null,null],[5,"remove_file","","Removes a file from the underlying filesystem.",null,{"inputs":[{"name":"p"}],"output":{"name":"result"}}],[5,"metadata","","Given a path, query the file system to get information about a file,\ndirectory, etc.",null,{"inputs":[{"name":"p"}],"output":{"name":"result"}}],[5,"symlink_metadata","","Query the metadata about a file without following symlinks.",null,{"inputs":[{"name":"p"}],"output":{"name":"result"}}],[5,"rename","","Rename a file or directory to a new name.",null,{"inputs":[{"name":"p"},{"name":"q"}],"output":{"name":"result"}}],[5,"copy","","Copies the contents of one file to another. This function will also\ncopy the permission bits of the original file to the destination file.",null,{"inputs":[{"name":"p"},{"name":"q"}],"output":{"name":"result"}}],[5,"hard_link","","Creates a new hard link on the filesystem.",null,{"inputs":[{"name":"p"},{"name":"q"}],"output":{"name":"result"}}],[5,"soft_link","","Creates a new symbolic link on the filesystem.",null,{"inputs":[{"name":"p"},{"name":"q"}],"output":{"name":"result"}}],[5,"read_link","","Reads a symbolic link, returning the file that the link points to.",null,{"inputs":[{"name":"p"}],"output":{"name":"result"}}],[5,"canonicalize","","Returns the canonical form of a path with all intermediate components\nnormalized and symbolic links resolved.",null,{"inputs":[{"name":"p"}],"output":{"name":"result"}}],[5,"create_dir","","Creates a new, empty directory at the provided path",null,{"inputs":[{"name":"p"}],"output":{"name":"result"}}],[5,"create_dir_all","","Recursively create a directory and all of its parent components if they\nare missing.",null,{"inputs":[{"name":"p"}],"output":{"name":"result"}}],[5,"remove_dir","","Removes an existing, empty directory.",null,{"inputs":[{"name":"p"}],"output":{"name":"result"}}],[5,"remove_dir_all","","Removes a directory at this path, after removing all its contents. Use\ncarefully!",null,{"inputs":[{"name":"p"}],"output":{"name":"result"}}],[5,"read_dir","","Returns an iterator over the entries within a directory.",null,{"inputs":[{"name":"p"}],"output":{"name":"result"}}],[5,"walk_dir","","Returns an iterator that will recursively walk the directory structure\nrooted at `path`.",null,{"inputs":[{"name":"p"}],"output":{"name":"result"}}],[5,"set_file_times","","Changes the timestamps for a file's last modification and access time.",null,{"inputs":[{"name":"p"},{"name":"u64"},{"name":"u64"}],"output":{"name":"result"}}],[5,"set_permissions","","Changes the permissions found on a file or a directory.",null,{"inputs":[{"name":"p"},{"name":"permissions"}],"output":{"name":"result"}}],[8,"PathExt","","Utility methods for paths.",null,null],[10,"metadata","","Gets information on the file, directory, etc at this path.",368,{"inputs":[{"name":"pathext"}],"output":{"name":"result"}}],[10,"symlink_metadata","","Gets information on the file, directory, etc at this path.",368,{"inputs":[{"name":"pathext"}],"output":{"name":"result"}}],[10,"canonicalize","","Returns the canonical form of a path, normalizing all components and\neliminate all symlinks.",368,{"inputs":[{"name":"pathext"}],"output":{"name":"result"}}],[10,"read_link","","Reads the symlink at this path.",368,{"inputs":[{"name":"pathext"}],"output":{"name":"result"}}],[10,"read_dir","","Reads the directory at this path.",368,{"inputs":[{"name":"pathext"}],"output":{"name":"result"}}],[10,"exists","","Boolean value indicator whether the underlying file exists on the local\nfilesystem. Returns false in exactly the cases where `fs::stat` fails.",368,{"inputs":[{"name":"pathext"}],"output":{"name":"bool"}}],[10,"is_file","","Whether the underlying implementation (be it a file path, or something\nelse) points at a \"regular file\" on the FS. Will return false for paths\nto non-existent locations or directories or other non-regular files\n(named pipes, etc). Follows links when making this determination.",368,{"inputs":[{"name":"pathext"}],"output":{"name":"bool"}}],[10,"is_dir","","Whether the underlying implementation (be it a file path, or something\nelse) is pointing at a directory in the underlying FS. Will return\nfalse for paths to non-existent locations or if the item is not a\ndirectory (eg files, named pipes, etc). Follows links when making this\ndetermination.",368,{"inputs":[{"name":"pathext"}],"output":{"name":"bool"}}],[11,"clone","","",369,{"inputs":[{"name":"openoptions"}],"output":{"name":"openoptions"}}],[11,"fmt","","",370,{"inputs":[{"name":"permissions"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",370,{"inputs":[{"name":"permissions"},{"name":"permissions"}],"output":{"name":"bool"}}],[11,"ne","","",370,{"inputs":[{"name":"permissions"},{"name":"permissions"}],"output":{"name":"bool"}}],[11,"clone","","",370,{"inputs":[{"name":"permissions"}],"output":{"name":"permissions"}}],[11,"hash","","",371,null],[11,"eq","","",371,{"inputs":[{"name":"filetype"},{"name":"filetype"}],"output":{"name":"bool"}}],[11,"ne","","",371,{"inputs":[{"name":"filetype"},{"name":"filetype"}],"output":{"name":"bool"}}],[11,"clone","","",371,{"inputs":[{"name":"filetype"}],"output":{"name":"filetype"}}],[11,"open","","Attempts to open a file in read-only mode.",372,{"inputs":[{"name":"file"},{"name":"p"}],"output":{"name":"result"}}],[11,"create","","Opens a file in write-only mode.",372,{"inputs":[{"name":"file"},{"name":"p"}],"output":{"name":"result"}}],[11,"sync_all","","Attempts to sync all OS-internal metadata to disk.",372,{"inputs":[{"name":"file"}],"output":{"name":"result"}}],[11,"sync_data","","This function is similar to `sync_all`, except that it may not\nsynchronize file metadata to the filesystem.",372,{"inputs":[{"name":"file"}],"output":{"name":"result"}}],[11,"set_len","","Truncates or extends the underlying file, updating the size of\nthis file to become `size`.",372,{"inputs":[{"name":"file"},{"name":"u64"}],"output":{"name":"result"}}],[11,"metadata","","Queries metadata about the underlying file.",372,{"inputs":[{"name":"file"}],"output":{"name":"result"}}],[11,"fmt","","",372,{"inputs":[{"name":"file"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"read","","",372,null],[11,"read_to_end","","",372,{"inputs":[{"name":"file"},{"name":"vec"}],"output":{"name":"result"}}],[11,"write","","",372,null],[11,"flush","","",372,{"inputs":[{"name":"file"}],"output":{"name":"result"}}],[11,"seek","","",372,{"inputs":[{"name":"file"},{"name":"seekfrom"}],"output":{"name":"result"}}],[11,"new","","Creates a blank net set of options ready for configuration.",369,{"inputs":[{"name":"openoptions"}],"output":{"name":"openoptions"}}],[11,"read","","Sets the option for read access.",369,{"inputs":[{"name":"openoptions"},{"name":"bool"}],"output":{"name":"openoptions"}}],[11,"write","","Sets the option for write access.",369,{"inputs":[{"name":"openoptions"},{"name":"bool"}],"output":{"name":"openoptions"}}],[11,"append","","Sets the option for the append mode.",369,{"inputs":[{"name":"openoptions"},{"name":"bool"}],"output":{"name":"openoptions"}}],[11,"truncate","","Sets the option for truncating a previous file.",369,{"inputs":[{"name":"openoptions"},{"name":"bool"}],"output":{"name":"openoptions"}}],[11,"create","","Sets the option for creating a new file.",369,{"inputs":[{"name":"openoptions"},{"name":"bool"}],"output":{"name":"openoptions"}}],[11,"open","","Opens a file at `path` with the options specified by `self`.",369,{"inputs":[{"name":"openoptions"},{"name":"p"}],"output":{"name":"result"}}],[11,"file_type","","Returns the file type for this metadata.",373,{"inputs":[{"name":"metadata"}],"output":{"name":"filetype"}}],[11,"is_dir","","Returns whether this metadata is for a directory.",373,{"inputs":[{"name":"metadata"}],"output":{"name":"bool"}}],[11,"is_file","","Returns whether this metadata is for a regular file.",373,{"inputs":[{"name":"metadata"}],"output":{"name":"bool"}}],[11,"len","","Returns the size of the file, in bytes, this metadata is for.",373,{"inputs":[{"name":"metadata"}],"output":{"name":"u64"}}],[11,"permissions","","Returns the permissions of the file this metadata is for.",373,{"inputs":[{"name":"metadata"}],"output":{"name":"permissions"}}],[11,"readonly","","Returns whether these permissions describe a readonly file.",370,{"inputs":[{"name":"permissions"}],"output":{"name":"bool"}}],[11,"set_readonly","","Modifies the readonly flag for this set of permissions.",370,{"inputs":[{"name":"permissions"},{"name":"bool"}],"output":null}],[11,"is_dir","","Test whether this file type represents a directory.",371,{"inputs":[{"name":"filetype"}],"output":{"name":"bool"}}],[11,"is_file","","Test whether this file type represents a regular file.",371,{"inputs":[{"name":"filetype"}],"output":{"name":"bool"}}],[11,"is_symlink","","Test whether this file type represents a symbolic link.",371,{"inputs":[{"name":"filetype"}],"output":{"name":"bool"}}],[11,"next","","",374,{"inputs":[{"name":"readdir"}],"output":{"name":"option"}}],[11,"path","","Returns the full path to the file that this entry represents.",375,{"inputs":[{"name":"direntry"}],"output":{"name":"pathbuf"}}],[11,"metadata","","Return the metadata for the file that this entry points at.",375,{"inputs":[{"name":"direntry"}],"output":{"name":"result"}}],[11,"file_type","","Return the file type for the file that this entry points at.",375,{"inputs":[{"name":"direntry"}],"output":{"name":"result"}}],[11,"file_name","","Returns the bare file name of this directory entry without any other\nleading path component.",375,{"inputs":[{"name":"direntry"}],"output":{"name":"osstring"}}],[11,"next","","",376,{"inputs":[{"name":"walkdir"}],"output":{"name":"option"}}],[11,"new","","Creates a new set of options with default mode/security settings for all\nplatforms and also non-recursive.",377,{"inputs":[{"name":"dirbuilder"}],"output":{"name":"dirbuilder"}}],[11,"recursive","","Indicate that directories create should be created recursively, creating\nall parent directories if they do not exist with the same security and\npermissions settings.",377,{"inputs":[{"name":"dirbuilder"},{"name":"bool"}],"output":{"name":"self"}}],[11,"create","","Create the specified directory with the options configured in this\nbuilder.",377,{"inputs":[{"name":"dirbuilder"},{"name":"p"}],"output":{"name":"result"}}],[0,"io","std","Traits, helpers, and type definitions for core I/O functionality.",null,null],[3,"BufReader","std::io","The `BufReader` struct adds buffering to any reader.",null,null],[3,"BufWriter","","Wraps a writer and buffers its output.",null,null],[3,"BufStream","","Wraps a Stream and buffers input and output to and from it.",null,null],[3,"LineWriter","","Wraps a writer and buffers output to it, flushing whenever a newline\n(`0x0a`, `'\\n'`) is detected.",null,null],[3,"IntoInnerError","","An error returned by `into_inner` which combines an error that\nhappened while writing out the buffer, and the buffered writer object\nwhich may be used to recover from the condition.",null,null],[3,"Cursor","","A `Cursor` wraps another type and provides it with a\n[`Seek`](trait.Seek.html) implementation.",null,null],[3,"Error","","The error type for I/O operations of the `Read`, `Write`, `Seek`, and\nassociated traits.",null,null],[3,"Sink","","A writer which will move data into the void.",null,null],[3,"Empty","","A reader which is always at EOF.",null,null],[3,"Repeat","","A reader which yields one byte over and over and over and over and over and...",null,null],[3,"Stdin","","A handle to the standard input stream of a process.",null,null],[3,"Stdout","","A handle to the global standard output stream of the current process.",null,null],[3,"Stderr","","A handle to the standard error stream of a process.",null,null],[3,"StdoutLock","","A locked reference to the a `Stdout` handle.",null,null],[3,"StderrLock","","A locked reference to the a `Stderr` handle.",null,null],[3,"StdinLock","","A locked reference to the a `Stdin` handle.",null,null],[3,"Broadcast","","A `Write` adaptor which will write data to multiple locations.",null,null],[3,"Chain","","Adaptor to chain together two readers.",null,null],[3,"Take","","Reader adaptor which limits the bytes read from an underlying reader.",null,null],[3,"Tee","","An adaptor which will emit all read data to a specified writer as well.",null,null],[3,"Bytes","","An iterator over `u8` values of a reader.",null,null],[3,"Chars","","An iterator over the `char`s of a reader.",null,null],[3,"Split","","An iterator over the contents of an instance of `BufRead` split on a\nparticular byte.",null,null],[3,"Lines","","An iterator over the lines of an instance of `BufRead`.",null,null],[4,"ErrorKind","","A list specifying general categories of I/O error.",null,null],[13,"NotFound","","An entity was not found, often a file.",378,null],[13,"PermissionDenied","","The operation lacked the necessary privileges to complete.",378,null],[13,"ConnectionRefused","","The connection was refused by the remote server.",378,null],[13,"ConnectionReset","","The connection was reset by the remote server.",378,null],[13,"ConnectionAborted","","The connection was aborted (terminated) by the remote server.",378,null],[13,"NotConnected","","The network operation failed because it was not connected yet.",378,null],[13,"AddrInUse","","A socket address could not be bound because the address is already in\nuse elsewhere.",378,null],[13,"AddrNotAvailable","","A nonexistent interface was requested or the requested address was not\nlocal.",378,null],[13,"BrokenPipe","","The operation failed because a pipe was closed.",378,null],[13,"AlreadyExists","","An entity already exists, often a file.",378,null],[13,"WouldBlock","","The operation needs to block to complete, but the blocking operation was\nrequested to not occur.",378,null],[13,"InvalidInput","","A parameter was incorrect.",378,null],[13,"InvalidData","","Data not valid for the operation were encountered.",378,null],[13,"TimedOut","","The I/O operation's timeout expired, causing it to be canceled.",378,null],[13,"WriteZero","","An error returned when an operation could not be completed because a\ncall to `write` returned `Ok(0)`.",378,null],[13,"Interrupted","","This operation was interrupted.",378,null],[13,"Other","","Any I/O error not part of this list.",378,null],[4,"SeekFrom","","Enumeration of possible methods to seek within an I/O object.",null,null],[13,"Start","","Set the offset to the provided number of bytes.",379,null],[13,"End","","Set the offset to the size of this object plus the specified number of\nbytes.",379,null],[13,"Current","","Set the offset to the current position plus the specified number of\nbytes.",379,null],[4,"CharsError","","An enumeration of possible errors that can be generated from the `Chars`\nadapter.",null,null],[13,"NotUtf8","","Variant representing that the underlying stream was read successfully\nbut it did not contain valid utf8 data.",380,null],[13,"Other","","Variant representing that an I/O error occurred.",380,null],[5,"copy","","Copies the entire contents of a reader into a writer.",null,{"inputs":[{"name":"r"},{"name":"w"}],"output":{"name":"result"}}],[5,"sink","","Creates an instance of a writer which will successfully consume all data.",null,{"inputs":[],"output":{"name":"sink"}}],[5,"empty","","Constructs a new handle to an empty reader.",null,{"inputs":[],"output":{"name":"empty"}}],[5,"repeat","","Creates an instance of a reader that infinitely repeats one byte.",null,{"inputs":[{"name":"u8"}],"output":{"name":"repeat"}}],[5,"stdin","","Constructs a new handle to the standard input of the current process.",null,{"inputs":[],"output":{"name":"stdin"}}],[5,"stdout","","Constructs a new handle to the standard output of the current process.",null,{"inputs":[],"output":{"name":"stdout"}}],[5,"stderr","","Constructs a new handle to the standard error of the current process.",null,{"inputs":[],"output":{"name":"stderr"}}],[0,"prelude","","The I/O Prelude",null,null],[11,"new","","Creates a new `BufReader` with a default buffer capacity.",381,{"inputs":[{"name":"bufreader"},{"name":"r"}],"output":{"name":"bufreader"}}],[11,"with_capacity","","Creates a new `BufReader` with the specified buffer capacity.",381,{"inputs":[{"name":"bufreader"},{"name":"usize"},{"name":"r"}],"output":{"name":"bufreader"}}],[11,"get_ref","","Gets a reference to the underlying reader.",381,{"inputs":[{"name":"bufreader"}],"output":{"name":"r"}}],[11,"get_mut","","Gets a mutable reference to the underlying reader.",381,{"inputs":[{"name":"bufreader"}],"output":{"name":"r"}}],[11,"into_inner","","Unwraps this `BufReader`, returning the underlying reader.",381,{"inputs":[{"name":"bufreader"}],"output":{"name":"r"}}],[11,"read","","",381,null],[11,"fill_buf","","",381,{"inputs":[{"name":"bufreader"}],"output":{"name":"result"}}],[11,"consume","","",381,{"inputs":[{"name":"bufreader"},{"name":"usize"}],"output":null}],[11,"fmt","","",381,{"inputs":[{"name":"bufreader"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"seek","","Seek to an offset, in bytes, in the underlying reader.",381,{"inputs":[{"name":"bufreader"},{"name":"seekfrom"}],"output":{"name":"result"}}],[11,"fmt","","",382,{"inputs":[{"name":"intoinnererror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","Creates a new `BufWriter` with a default buffer capacity.",383,{"inputs":[{"name":"bufwriter"},{"name":"w"}],"output":{"name":"bufwriter"}}],[11,"with_capacity","","Creates a new `BufWriter` with the specified buffer capacity.",383,{"inputs":[{"name":"bufwriter"},{"name":"usize"},{"name":"w"}],"output":{"name":"bufwriter"}}],[11,"get_ref","","Gets a reference to the underlying writer.",383,{"inputs":[{"name":"bufwriter"}],"output":{"name":"w"}}],[11,"get_mut","","Gets a mutable reference to the underlying writer.",383,{"inputs":[{"name":"bufwriter"}],"output":{"name":"w"}}],[11,"into_inner","","Unwraps this `BufWriter`, returning the underlying writer.",383,{"inputs":[{"name":"bufwriter"}],"output":{"name":"result"}}],[11,"write","","",383,null],[11,"flush","","",383,{"inputs":[{"name":"bufwriter"}],"output":{"name":"result"}}],[11,"fmt","","",383,{"inputs":[{"name":"bufwriter"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"seek","","Seek to the offset, in bytes, in the underlying writer.",383,{"inputs":[{"name":"bufwriter"},{"name":"seekfrom"}],"output":{"name":"result"}}],[11,"drop","","",383,{"inputs":[{"name":"bufwriter"}],"output":null}],[11,"error","","Returns the error which caused the call to `into_inner()` to fail.",382,{"inputs":[{"name":"intoinnererror"}],"output":{"name":"error"}}],[11,"into_inner","","Returns the buffered writer instance which generated the error.",382,{"inputs":[{"name":"intoinnererror"}],"output":{"name":"w"}}],[11,"from","","",384,{"inputs":[{"name":"error"},{"name":"intoinnererror"}],"output":{"name":"error"}}],[11,"description","","",382,{"inputs":[{"name":"intoinnererror"}],"output":{"name":"str"}}],[11,"fmt","","",382,{"inputs":[{"name":"intoinnererror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","Creates a new `LineWriter`.",385,{"inputs":[{"name":"linewriter"},{"name":"w"}],"output":{"name":"linewriter"}}],[11,"with_capacity","","Creates a new `LineWriter` with a specified capacity for the internal\nbuffer.",385,{"inputs":[{"name":"linewriter"},{"name":"usize"},{"name":"w"}],"output":{"name":"linewriter"}}],[11,"get_ref","","Gets a reference to the underlying writer.",385,{"inputs":[{"name":"linewriter"}],"output":{"name":"w"}}],[11,"get_mut","","Gets a mutable reference to the underlying writer.",385,{"inputs":[{"name":"linewriter"}],"output":{"name":"w"}}],[11,"into_inner","","Unwraps this `LineWriter`, returning the underlying writer.",385,{"inputs":[{"name":"linewriter"}],"output":{"name":"result"}}],[11,"write","","",385,null],[11,"flush","","",385,{"inputs":[{"name":"linewriter"}],"output":{"name":"result"}}],[11,"fmt","","",385,{"inputs":[{"name":"linewriter"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"with_capacities","","Creates a new buffered stream with explicitly listed capacities for the\nreader/writer buffer.",386,{"inputs":[{"name":"bufstream"},{"name":"usize"},{"name":"usize"},{"name":"s"}],"output":{"name":"bufstream"}}],[11,"new","","Creates a new buffered stream with the default reader/writer buffer\ncapacities.",386,{"inputs":[{"name":"bufstream"},{"name":"s"}],"output":{"name":"bufstream"}}],[11,"get_ref","","Gets a reference to the underlying stream.",386,{"inputs":[{"name":"bufstream"}],"output":{"name":"s"}}],[11,"get_mut","","Gets a mutable reference to the underlying stream.",386,{"inputs":[{"name":"bufstream"}],"output":{"name":"s"}}],[11,"into_inner","","Unwraps this `BufStream`, returning the underlying stream.",386,{"inputs":[{"name":"bufstream"}],"output":{"name":"result"}}],[11,"fill_buf","","",386,{"inputs":[{"name":"bufstream"}],"output":{"name":"result"}}],[11,"consume","","",386,{"inputs":[{"name":"bufstream"},{"name":"usize"}],"output":null}],[11,"read","","",386,null],[11,"write","","",386,null],[11,"flush","","",386,{"inputs":[{"name":"bufstream"}],"output":{"name":"result"}}],[11,"fmt","","",386,{"inputs":[{"name":"bufstream"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",387,{"inputs":[{"name":"cursor"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",387,{"inputs":[{"name":"cursor"}],"output":{"name":"cursor"}}],[11,"new","","Creates a new cursor wrapping the provided underlying I/O object.",387,{"inputs":[{"name":"cursor"},{"name":"t"}],"output":{"name":"cursor"}}],[11,"into_inner","","Consumes this cursor, returning the underlying value.",387,{"inputs":[{"name":"cursor"}],"output":{"name":"t"}}],[11,"get_ref","","Gets a reference to the underlying value in this cursor.",387,{"inputs":[{"name":"cursor"}],"output":{"name":"t"}}],[11,"get_mut","","Gets a mutable reference to the underlying value in this cursor.",387,{"inputs":[{"name":"cursor"}],"output":{"name":"t"}}],[11,"position","","Returns the current position of this cursor.",387,{"inputs":[{"name":"cursor"}],"output":{"name":"u64"}}],[11,"set_position","","Sets the position of this cursor.",387,{"inputs":[{"name":"cursor"},{"name":"u64"}],"output":null}],[11,"seek","","",387,{"inputs":[{"name":"cursor"},{"name":"seekfrom"}],"output":{"name":"result"}}],[11,"seek","","",387,{"inputs":[{"name":"cursor"},{"name":"seekfrom"}],"output":{"name":"result"}}],[11,"seek","","",387,{"inputs":[{"name":"cursor"},{"name":"seekfrom"}],"output":{"name":"result"}}],[11,"read","","",387,null],[11,"read","","",387,null],[11,"read","","",387,null],[11,"fill_buf","","",387,{"inputs":[{"name":"cursor"}],"output":{"name":"result"}}],[11,"consume","","",387,{"inputs":[{"name":"cursor"},{"name":"usize"}],"output":null}],[11,"fill_buf","","",387,{"inputs":[{"name":"cursor"}],"output":{"name":"result"}}],[11,"consume","","",387,{"inputs":[{"name":"cursor"},{"name":"usize"}],"output":null}],[11,"fill_buf","","",387,{"inputs":[{"name":"cursor"}],"output":{"name":"result"}}],[11,"consume","","",387,{"inputs":[{"name":"cursor"},{"name":"usize"}],"output":null}],[11,"write","","",387,null],[11,"flush","","",387,{"inputs":[{"name":"cursor"}],"output":{"name":"result"}}],[11,"write","","",387,null],[11,"flush","","",387,{"inputs":[{"name":"cursor"}],"output":{"name":"result"}}],[11,"fmt","","",384,{"inputs":[{"name":"error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",378,{"inputs":[{"name":"errorkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",378,{"inputs":[{"name":"errorkind"}],"output":{"name":"errorkind"}}],[11,"eq","","",378,{"inputs":[{"name":"errorkind"},{"name":"errorkind"}],"output":{"name":"bool"}}],[11,"ne","","",378,{"inputs":[{"name":"errorkind"},{"name":"errorkind"}],"output":{"name":"bool"}}],[11,"new","","Creates a new I/O error from a known kind of error as well as an\narbitrary error payload.",384,{"inputs":[{"name":"error"},{"name":"errorkind"},{"name":"e"}],"output":{"name":"error"}}],[11,"last_os_error","","Returns an error representing the last OS error which occurred.",384,{"inputs":[{"name":"error"}],"output":{"name":"error"}}],[11,"from_raw_os_error","","Creates a new instance of an `Error` from a particular OS error code.",384,{"inputs":[{"name":"error"},{"name":"i32"}],"output":{"name":"error"}}],[11,"raw_os_error","","Returns the OS error that this error represents (if any).",384,{"inputs":[{"name":"error"}],"output":{"name":"option"}}],[11,"get_ref","","Returns a reference to the inner error wrapped by this error (if any).",384,{"inputs":[{"name":"error"}],"output":{"name":"option"}}],[11,"get_mut","","Returns a mutable reference to the inner error wrapped by this error\n(if any).",384,{"inputs":[{"name":"error"}],"output":{"name":"option"}}],[11,"into_inner","","Consumes the `Error`, returning its inner error (if any).",384,{"inputs":[{"name":"error"}],"output":{"name":"option"}}],[11,"kind","","Returns the corresponding `ErrorKind` for this error.",384,{"inputs":[{"name":"error"}],"output":{"name":"errorkind"}}],[11,"fmt","","",384,{"inputs":[{"name":"error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"description","","",384,{"inputs":[{"name":"error"}],"output":{"name":"str"}}],[11,"cause","","",384,{"inputs":[{"name":"error"}],"output":{"name":"option"}}],[11,"read","std::boxed","",207,null],[11,"read_to_end","","",207,{"inputs":[{"name":"box"},{"name":"vec"}],"output":{"name":"result"}}],[11,"read_to_string","","",207,{"inputs":[{"name":"box"},{"name":"string"}],"output":{"name":"result"}}],[11,"write","","",207,null],[11,"flush","","",207,{"inputs":[{"name":"box"}],"output":{"name":"result"}}],[11,"write_all","","",207,null],[11,"write_fmt","","",207,{"inputs":[{"name":"box"},{"name":"arguments"}],"output":{"name":"result"}}],[11,"seek","","",207,{"inputs":[{"name":"box"},{"name":"seekfrom"}],"output":{"name":"result"}}],[11,"fill_buf","","",207,{"inputs":[{"name":"box"}],"output":{"name":"result"}}],[11,"consume","","",207,{"inputs":[{"name":"box"},{"name":"usize"}],"output":null}],[11,"read_until","","",207,{"inputs":[{"name":"box"},{"name":"u8"},{"name":"vec"}],"output":{"name":"result"}}],[11,"read_line","","",207,{"inputs":[{"name":"box"},{"name":"string"}],"output":{"name":"result"}}],[11,"write","std::vec","",273,null],[11,"write_all","","",273,null],[11,"flush","","",273,{"inputs":[{"name":"vec"}],"output":{"name":"result"}}],[11,"read","std::io","",388,null],[11,"fill_buf","","",388,{"inputs":[{"name":"empty"}],"output":{"name":"result"}}],[11,"consume","","",388,{"inputs":[{"name":"empty"},{"name":"usize"}],"output":null}],[11,"read","","",389,null],[11,"write","","",390,null],[11,"flush","","",390,{"inputs":[{"name":"sink"}],"output":{"name":"result"}}],[11,"lock","","Locks this handle to the standard input stream, returning a readable\nguard.",391,{"inputs":[{"name":"stdin"}],"output":{"name":"stdinlock"}}],[11,"read_line","","Locks this handle and reads a line of input into the specified buffer.",391,{"inputs":[{"name":"stdin"},{"name":"string"}],"output":{"name":"result"}}],[11,"read","","",391,null],[11,"read_to_end","","",391,{"inputs":[{"name":"stdin"},{"name":"vec"}],"output":{"name":"result"}}],[11,"read_to_string","","",391,{"inputs":[{"name":"stdin"},{"name":"string"}],"output":{"name":"result"}}],[11,"read","","",392,null],[11,"read_to_end","","",392,{"inputs":[{"name":"stdinlock"},{"name":"vec"}],"output":{"name":"result"}}],[11,"fill_buf","","",392,{"inputs":[{"name":"stdinlock"}],"output":{"name":"result"}}],[11,"consume","","",392,{"inputs":[{"name":"stdinlock"},{"name":"usize"}],"output":null}],[11,"lock","","Locks this handle to the standard output stream, returning a writable\nguard.",393,{"inputs":[{"name":"stdout"}],"output":{"name":"stdoutlock"}}],[11,"write","","",393,null],[11,"flush","","",393,{"inputs":[{"name":"stdout"}],"output":{"name":"result"}}],[11,"write_all","","",393,null],[11,"write_fmt","","",393,{"inputs":[{"name":"stdout"},{"name":"arguments"}],"output":{"name":"result"}}],[11,"write","","",394,null],[11,"flush","","",394,{"inputs":[{"name":"stdoutlock"}],"output":{"name":"result"}}],[11,"lock","","Locks this handle to the standard error stream, returning a writable\nguard.",395,{"inputs":[{"name":"stderr"}],"output":{"name":"stderrlock"}}],[11,"write","","",395,null],[11,"flush","","",395,{"inputs":[{"name":"stderr"}],"output":{"name":"result"}}],[11,"write_all","","",395,null],[11,"write_fmt","","",395,{"inputs":[{"name":"stderr"},{"name":"arguments"}],"output":{"name":"result"}}],[11,"write","","",396,null],[11,"flush","","",396,{"inputs":[{"name":"stderrlock"}],"output":{"name":"result"}}],[6,"Result","","A specialized [`Result`][result] type for I/O operations.",null,null],[8,"Read","","The `Read` trait allows for reading bytes from a source.",null,null],[10,"read","","Pull some bytes from this source into the specified buffer, returning\nhow many bytes were read.",397,null],[11,"read_to_end","","Read all bytes until EOF in this source, placing them into `buf`.",397,{"inputs":[{"name":"read"},{"name":"vec"}],"output":{"name":"result"}}],[11,"read_to_string","","Read all bytes until EOF in this source, placing them into `buf`.",397,{"inputs":[{"name":"read"},{"name":"string"}],"output":{"name":"result"}}],[11,"by_ref","","Creates a \"by reference\" adaptor for this instance of `Read`.",397,{"inputs":[{"name":"read"}],"output":{"name":"self"}}],[11,"bytes","","Transforms this `Read` instance to an `Iterator` over its bytes.",397,{"inputs":[{"name":"read"}],"output":{"name":"bytes"}}],[11,"chars","","Transforms this `Read` instance to an `Iterator` over `char`s.",397,{"inputs":[{"name":"read"}],"output":{"name":"chars"}}],[11,"chain","","Creates an adaptor which will chain this stream with another.",397,{"inputs":[{"name":"read"},{"name":"r"}],"output":{"name":"chain"}}],[11,"take","","Creates an adaptor which will read at most `limit` bytes from it.",397,{"inputs":[{"name":"read"},{"name":"u64"}],"output":{"name":"take"}}],[11,"tee","","Creates a reader adaptor which will write all read data into the given\noutput stream.",397,{"inputs":[{"name":"read"},{"name":"w"}],"output":{"name":"tee"}}],[8,"Write","","A trait for objects which are byte-oriented sinks.",null,null],[10,"write","","Write a buffer into this object, returning how many bytes were written.",398,null],[10,"flush","","Flush this output stream, ensuring that all intermediately buffered\ncontents reach their destination.",398,{"inputs":[{"name":"write"}],"output":{"name":"result"}}],[11,"write_all","","Attempts to write an entire buffer into this write.",398,null],[11,"write_fmt","","Writes a formatted string into this writer, returning any error\nencountered.",398,{"inputs":[{"name":"write"},{"name":"arguments"}],"output":{"name":"result"}}],[11,"by_ref","","Creates a \"by reference\" adaptor for this instance of `Write`.",398,{"inputs":[{"name":"write"}],"output":{"name":"self"}}],[11,"broadcast","","Creates a new writer which will write all data to both this writer and\nanother writer.",398,{"inputs":[{"name":"write"},{"name":"w"}],"output":{"name":"broadcast"}}],[8,"Seek","","The `Seek` trait provides a cursor which can be moved within a stream of\nbytes.",null,null],[10,"seek","","Seek to an offset, in bytes, in a stream.",399,{"inputs":[{"name":"seek"},{"name":"seekfrom"}],"output":{"name":"result"}}],[8,"BufRead","","A `BufRead` is a type of `Read`er which has an internal buffer, allowing it\nto perform extra ways of reading.",null,null],[10,"fill_buf","","Fills the internal buffer of this object, returning the buffer contents.",400,{"inputs":[{"name":"bufread"}],"output":{"name":"result"}}],[10,"consume","","Tells this buffer that `amt` bytes have been consumed from the buffer,\nso they should no longer be returned in calls to `read`.",400,{"inputs":[{"name":"bufread"},{"name":"usize"}],"output":null}],[11,"read_until","","Read all bytes into `buf` until the delimiter `byte` is reached.",400,{"inputs":[{"name":"bufread"},{"name":"u8"},{"name":"vec"}],"output":{"name":"result"}}],[11,"read_line","","Read all bytes until a newline (the 0xA byte) is reached, and append\nthem to the provided buffer.",400,{"inputs":[{"name":"bufread"},{"name":"string"}],"output":{"name":"result"}}],[11,"split","","Returns an iterator over the contents of this reader split on the byte\n`byte`.",400,{"inputs":[{"name":"bufread"},{"name":"u8"}],"output":{"name":"split"}}],[11,"lines","","Returns an iterator over the lines of this reader.",400,{"inputs":[{"name":"bufread"}],"output":{"name":"lines"}}],[11,"fmt","","",379,{"inputs":[{"name":"seekfrom"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",379,{"inputs":[{"name":"seekfrom"}],"output":{"name":"seekfrom"}}],[11,"eq","","",379,{"inputs":[{"name":"seekfrom"},{"name":"seekfrom"}],"output":{"name":"bool"}}],[11,"ne","","",379,{"inputs":[{"name":"seekfrom"},{"name":"seekfrom"}],"output":{"name":"bool"}}],[11,"write","","",401,null],[11,"flush","","",401,{"inputs":[{"name":"broadcast"}],"output":{"name":"result"}}],[11,"read","","",402,null],[11,"limit","","Returns the number of bytes that can be read before this instance will\nreturn EOF.",403,{"inputs":[{"name":"take"}],"output":{"name":"u64"}}],[11,"read","","",403,null],[11,"fill_buf","","",403,{"inputs":[{"name":"take"}],"output":{"name":"result"}}],[11,"consume","","",403,{"inputs":[{"name":"take"},{"name":"usize"}],"output":null}],[11,"read","","",404,null],[11,"next","","",405,{"inputs":[{"name":"bytes"}],"output":{"name":"option"}}],[11,"fmt","","",380,{"inputs":[{"name":"charserror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"next","","",406,{"inputs":[{"name":"chars"}],"output":{"name":"option"}}],[11,"description","","",380,{"inputs":[{"name":"charserror"}],"output":{"name":"str"}}],[11,"cause","","",380,{"inputs":[{"name":"charserror"}],"output":{"name":"option"}}],[11,"fmt","","",380,{"inputs":[{"name":"charserror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"next","","",407,{"inputs":[{"name":"split"}],"output":{"name":"option"}}],[11,"next","","",408,{"inputs":[{"name":"lines"}],"output":{"name":"option"}}],[0,"net","std","Networking primitives for TCP/UDP communication.",null,null],[3,"Ipv4Addr","std::net","Representation of an IPv4 address.",null,null],[3,"Ipv6Addr","","Representation of an IPv6 address.",null,null],[3,"SocketAddrV4","","An IPv4 socket address which is a (ip, port) combination.",null,null],[3,"SocketAddrV6","","An IPv6 socket address.",null,null],[3,"TcpStream","","A structure which represents a TCP stream between a local socket and a\nremote socket.",null,null],[3,"TcpListener","","A structure representing a socket server.",null,null],[3,"Incoming","","An infinite iterator over the connections from a `TcpListener`.",null,null],[3,"UdpSocket","","A User Datagram Protocol socket.",null,null],[3,"AddrParseError","","An error returned when parsing an IP address or a socket address.",null,null],[3,"LookupHost","","An iterator over `SocketAddr` values returned from a host lookup operation.",null,null],[4,"IpAddr","","An IP address, either a IPv4 or IPv6 address.",null,null],[13,"V4","","Representation of an IPv4 address.",409,null],[13,"V6","","Representation of an IPv6 address.",409,null],[4,"Ipv6MulticastScope","","",null,null],[13,"InterfaceLocal","","",410,null],[13,"LinkLocal","","",410,null],[13,"RealmLocal","","",410,null],[13,"AdminLocal","","",410,null],[13,"SiteLocal","","",410,null],[13,"OrganizationLocal","","",410,null],[13,"Global","","",410,null],[4,"SocketAddr","","Representation of a socket address for networking applications.",null,null],[13,"V4","","An IPv4 socket address which is a (ip, port) combination.",411,null],[13,"V6","","An IPv6 socket address",411,null],[4,"Shutdown","","Possible values which can be passed to the `shutdown` method of `TcpStream`.",null,null],[13,"Read","","Indicates that the reading portion of this stream/socket should be shut\ndown. All currently blocked and future reads will return `Ok(0)`.",412,null],[13,"Write","","Indicates that the writing portion of this stream/socket should be shut\ndown. All currently blocked and future writes will return an error.",412,null],[13,"Both","","Shut down both the reading and writing portions of this stream.",412,null],[5,"lookup_host","","Resolve the host specified by `host` as a number of `SocketAddr` instances.",null,{"inputs":[{"name":"str"}],"output":{"name":"result"}}],[5,"lookup_addr","","Resolve the given address to a hostname.",null,{"inputs":[{"name":"ipaddr"}],"output":{"name":"result"}}],[11,"cmp","","",409,{"inputs":[{"name":"ipaddr"},{"name":"ipaddr"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",409,{"inputs":[{"name":"ipaddr"},{"name":"ipaddr"}],"output":{"name":"option"}}],[11,"lt","","",409,{"inputs":[{"name":"ipaddr"},{"name":"ipaddr"}],"output":{"name":"bool"}}],[11,"le","","",409,{"inputs":[{"name":"ipaddr"},{"name":"ipaddr"}],"output":{"name":"bool"}}],[11,"gt","","",409,{"inputs":[{"name":"ipaddr"},{"name":"ipaddr"}],"output":{"name":"bool"}}],[11,"ge","","",409,{"inputs":[{"name":"ipaddr"},{"name":"ipaddr"}],"output":{"name":"bool"}}],[11,"hash","","",409,null],[11,"fmt","","",409,{"inputs":[{"name":"ipaddr"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",409,{"inputs":[{"name":"ipaddr"},{"name":"ipaddr"}],"output":{"name":"bool"}}],[11,"ne","","",409,{"inputs":[{"name":"ipaddr"},{"name":"ipaddr"}],"output":{"name":"bool"}}],[11,"clone","","",409,{"inputs":[{"name":"ipaddr"}],"output":{"name":"ipaddr"}}],[11,"fmt","","",410,{"inputs":[{"name":"ipv6multicastscope"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",410,null],[11,"clone","","",410,{"inputs":[{"name":"ipv6multicastscope"}],"output":{"name":"ipv6multicastscope"}}],[11,"eq","","",410,{"inputs":[{"name":"ipv6multicastscope"},{"name":"ipv6multicastscope"}],"output":{"name":"bool"}}],[11,"ne","","",410,{"inputs":[{"name":"ipv6multicastscope"},{"name":"ipv6multicastscope"}],"output":{"name":"bool"}}],[11,"new","","Creates a new IPv4 address from four eight-bit octets.",413,{"inputs":[{"name":"ipv4addr"},{"name":"u8"},{"name":"u8"},{"name":"u8"},{"name":"u8"}],"output":{"name":"ipv4addr"}}],[11,"octets","","Returns the four eight-bit integers that make up this address.",413,null],[11,"is_unspecified","","Returns true for the special 'unspecified' address 0.0.0.0.",413,{"inputs":[{"name":"ipv4addr"}],"output":{"name":"bool"}}],[11,"is_loopback","","Returns true if this is a loopback address (127.0.0.0/8).",413,{"inputs":[{"name":"ipv4addr"}],"output":{"name":"bool"}}],[11,"is_private","","Returns true if this is a private address.",413,{"inputs":[{"name":"ipv4addr"}],"output":{"name":"bool"}}],[11,"is_link_local","","Returns true if the address is link-local (169.254.0.0/16).",413,{"inputs":[{"name":"ipv4addr"}],"output":{"name":"bool"}}],[11,"is_global","","Returns true if the address appears to be globally routable.",413,{"inputs":[{"name":"ipv4addr"}],"output":{"name":"bool"}}],[11,"is_multicast","","Returns true if this is a multicast address.",413,{"inputs":[{"name":"ipv4addr"}],"output":{"name":"bool"}}],[11,"is_broadcast","","Returns true if this is a broadcast address.",413,{"inputs":[{"name":"ipv4addr"}],"output":{"name":"bool"}}],[11,"is_documentation","","Returns true if this address is in a range designated for documentation.",413,{"inputs":[{"name":"ipv4addr"}],"output":{"name":"bool"}}],[11,"to_ipv6_compatible","","Converts this address to an IPv4-compatible IPv6 address.",413,{"inputs":[{"name":"ipv4addr"}],"output":{"name":"ipv6addr"}}],[11,"to_ipv6_mapped","","Converts this address to an IPv4-mapped IPv6 address.",413,{"inputs":[{"name":"ipv4addr"}],"output":{"name":"ipv6addr"}}],[11,"fmt","","",409,{"inputs":[{"name":"ipaddr"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",413,{"inputs":[{"name":"ipv4addr"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",413,{"inputs":[{"name":"ipv4addr"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",413,{"inputs":[{"name":"ipv4addr"}],"output":{"name":"ipv4addr"}}],[11,"eq","","",413,{"inputs":[{"name":"ipv4addr"},{"name":"ipv4addr"}],"output":{"name":"bool"}}],[11,"hash","","",413,{"inputs":[{"name":"ipv4addr"},{"name":"h"}],"output":null}],[11,"partial_cmp","","",413,{"inputs":[{"name":"ipv4addr"},{"name":"ipv4addr"}],"output":{"name":"option"}}],[11,"cmp","","",413,{"inputs":[{"name":"ipv4addr"},{"name":"ipv4addr"}],"output":{"name":"ordering"}}],[11,"from","","",413,{"inputs":[{"name":"ipv4addr"},{"name":"u32"}],"output":{"name":"ipv4addr"}}],[11,"new","","Creates a new IPv6 address from eight 16-bit segments.",414,{"inputs":[{"name":"ipv6addr"},{"name":"u16"},{"name":"u16"},{"name":"u16"},{"name":"u16"},{"name":"u16"},{"name":"u16"},{"name":"u16"},{"name":"u16"}],"output":{"name":"ipv6addr"}}],[11,"segments","","Returns the eight 16-bit segments that make up this address.",414,null],[11,"is_unspecified","","Returns true for the special 'unspecified' address ::.",414,{"inputs":[{"name":"ipv6addr"}],"output":{"name":"bool"}}],[11,"is_loopback","","Returns true if this is a loopback address (::1).",414,{"inputs":[{"name":"ipv6addr"}],"output":{"name":"bool"}}],[11,"is_global","","Returns true if the address appears to be globally routable.",414,{"inputs":[{"name":"ipv6addr"}],"output":{"name":"bool"}}],[11,"is_unique_local","","Returns true if this is a unique local address (IPv6).",414,{"inputs":[{"name":"ipv6addr"}],"output":{"name":"bool"}}],[11,"is_unicast_link_local","","Returns true if the address is unicast and link-local (fe80::/10).",414,{"inputs":[{"name":"ipv6addr"}],"output":{"name":"bool"}}],[11,"is_unicast_site_local","","Returns true if this is a deprecated unicast site-local address (IPv6\nfec0::/10).",414,{"inputs":[{"name":"ipv6addr"}],"output":{"name":"bool"}}],[11,"is_unicast_global","","Returns true if the address is a globally routable unicast address.",414,{"inputs":[{"name":"ipv6addr"}],"output":{"name":"bool"}}],[11,"multicast_scope","","Returns the address's multicast scope if the address is multicast.",414,{"inputs":[{"name":"ipv6addr"}],"output":{"name":"option"}}],[11,"is_multicast","","Returns true if this is a multicast address.",414,{"inputs":[{"name":"ipv6addr"}],"output":{"name":"bool"}}],[11,"to_ipv4","","Converts this address to an IPv4 address. Returns None if this address is\nneither IPv4-compatible or IPv4-mapped.",414,{"inputs":[{"name":"ipv6addr"}],"output":{"name":"option"}}],[11,"fmt","","",414,{"inputs":[{"name":"ipv6addr"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",414,{"inputs":[{"name":"ipv6addr"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",414,{"inputs":[{"name":"ipv6addr"}],"output":{"name":"ipv6addr"}}],[11,"eq","","",414,{"inputs":[{"name":"ipv6addr"},{"name":"ipv6addr"}],"output":{"name":"bool"}}],[11,"hash","","",414,{"inputs":[{"name":"ipv6addr"},{"name":"h"}],"output":null}],[11,"partial_cmp","","",414,{"inputs":[{"name":"ipv6addr"},{"name":"ipv6addr"}],"output":{"name":"option"}}],[11,"cmp","","",414,{"inputs":[{"name":"ipv6addr"},{"name":"ipv6addr"}],"output":{"name":"ordering"}}],[11,"fmt","","",411,{"inputs":[{"name":"socketaddr"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",411,null],[11,"eq","","",411,{"inputs":[{"name":"socketaddr"},{"name":"socketaddr"}],"output":{"name":"bool"}}],[11,"ne","","",411,{"inputs":[{"name":"socketaddr"},{"name":"socketaddr"}],"output":{"name":"bool"}}],[11,"clone","","",411,{"inputs":[{"name":"socketaddr"}],"output":{"name":"socketaddr"}}],[11,"new","","Creates a new socket address from the (ip, port) pair.",411,{"inputs":[{"name":"socketaddr"},{"name":"ipaddr"},{"name":"u16"}],"output":{"name":"socketaddr"}}],[11,"ip","","Returns the IP address associated with this socket address.",411,{"inputs":[{"name":"socketaddr"}],"output":{"name":"ipaddr"}}],[11,"port","","Returns the port number associated with this socket address.",411,{"inputs":[{"name":"socketaddr"}],"output":{"name":"u16"}}],[11,"new","","Creates a new socket address from the (ip, port) pair.",415,{"inputs":[{"name":"socketaddrv4"},{"name":"ipv4addr"},{"name":"u16"}],"output":{"name":"socketaddrv4"}}],[11,"ip","","Returns the IP address associated with this socket address.",415,{"inputs":[{"name":"socketaddrv4"}],"output":{"name":"ipv4addr"}}],[11,"port","","Returns the port number associated with this socket address.",415,{"inputs":[{"name":"socketaddrv4"}],"output":{"name":"u16"}}],[11,"new","","Creates a new socket address from the ip/port/flowinfo/scope_id\ncomponents.",416,{"inputs":[{"name":"socketaddrv6"},{"name":"ipv6addr"},{"name":"u16"},{"name":"u32"},{"name":"u32"}],"output":{"name":"socketaddrv6"}}],[11,"ip","","Returns the IP address associated with this socket address.",416,{"inputs":[{"name":"socketaddrv6"}],"output":{"name":"ipv6addr"}}],[11,"port","","Returns the port number associated with this socket address.",416,{"inputs":[{"name":"socketaddrv6"}],"output":{"name":"u16"}}],[11,"flowinfo","","Returns scope ID associated with this address, corresponding to the\n`sin6_flowinfo` field in C.",416,{"inputs":[{"name":"socketaddrv6"}],"output":{"name":"u32"}}],[11,"scope_id","","Returns scope ID associated with this address, corresponding to the\n`sin6_scope_id` field in C.",416,{"inputs":[{"name":"socketaddrv6"}],"output":{"name":"u32"}}],[11,"fmt","","",411,{"inputs":[{"name":"socketaddr"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",415,{"inputs":[{"name":"socketaddrv4"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",415,{"inputs":[{"name":"socketaddrv4"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",416,{"inputs":[{"name":"socketaddrv6"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",416,{"inputs":[{"name":"socketaddrv6"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",415,{"inputs":[{"name":"socketaddrv4"}],"output":{"name":"socketaddrv4"}}],[11,"clone","","",416,{"inputs":[{"name":"socketaddrv6"}],"output":{"name":"socketaddrv6"}}],[11,"eq","","",415,{"inputs":[{"name":"socketaddrv4"},{"name":"socketaddrv4"}],"output":{"name":"bool"}}],[11,"eq","","",416,{"inputs":[{"name":"socketaddrv6"},{"name":"socketaddrv6"}],"output":{"name":"bool"}}],[11,"hash","","",415,{"inputs":[{"name":"socketaddrv4"},{"name":"h"}],"output":null}],[11,"hash","","",416,{"inputs":[{"name":"socketaddrv6"},{"name":"h"}],"output":null}],[11,"to_socket_addrs","","",411,{"inputs":[{"name":"socketaddr"}],"output":{"name":"result"}}],[11,"to_socket_addrs","","",415,{"inputs":[{"name":"socketaddrv4"}],"output":{"name":"result"}}],[11,"to_socket_addrs","","",416,{"inputs":[{"name":"socketaddrv6"}],"output":{"name":"result"}}],[11,"connect","","Opens a TCP connection to a remote host.",417,{"inputs":[{"name":"tcpstream"},{"name":"a"}],"output":{"name":"result"}}],[11,"peer_addr","","Returns the socket address of the remote peer of this TCP connection.",417,{"inputs":[{"name":"tcpstream"}],"output":{"name":"result"}}],[11,"local_addr","","Returns the socket address of the local half of this TCP connection.",417,{"inputs":[{"name":"tcpstream"}],"output":{"name":"result"}}],[11,"shutdown","","Shuts down the read, write, or both halves of this connection.",417,{"inputs":[{"name":"tcpstream"},{"name":"shutdown"}],"output":{"name":"result"}}],[11,"try_clone","","Creates a new independently owned handle to the underlying socket.",417,{"inputs":[{"name":"tcpstream"}],"output":{"name":"result"}}],[11,"set_nodelay","","Sets the nodelay flag on this connection to the boolean specified.",417,{"inputs":[{"name":"tcpstream"},{"name":"bool"}],"output":{"name":"result"}}],[11,"set_keepalive","","Sets the keepalive timeout to the timeout specified.",417,{"inputs":[{"name":"tcpstream"},{"name":"option"}],"output":{"name":"result"}}],[11,"set_read_timeout","","Sets the read timeout to the timeout specified.",417,{"inputs":[{"name":"tcpstream"},{"name":"option"}],"output":{"name":"result"}}],[11,"set_write_timeout","","Sets the write timeout to the timeout specified.",417,{"inputs":[{"name":"tcpstream"},{"name":"option"}],"output":{"name":"result"}}],[11,"read_timeout","","Returns the read timeout of this socket.",417,{"inputs":[{"name":"tcpstream"}],"output":{"name":"result"}}],[11,"write_timeout","","Returns the write timeout of this socket.",417,{"inputs":[{"name":"tcpstream"}],"output":{"name":"result"}}],[11,"read","","",417,null],[11,"read_to_end","","",417,{"inputs":[{"name":"tcpstream"},{"name":"vec"}],"output":{"name":"result"}}],[11,"write","","",417,null],[11,"flush","","",417,{"inputs":[{"name":"tcpstream"}],"output":{"name":"result"}}],[11,"fmt","","",417,{"inputs":[{"name":"tcpstream"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"bind","","Creates a new `TcpListener` which will be bound to the specified\naddress.",418,{"inputs":[{"name":"tcplistener"},{"name":"a"}],"output":{"name":"result"}}],[11,"local_addr","","Returns the local socket address of this listener.",418,{"inputs":[{"name":"tcplistener"}],"output":{"name":"result"}}],[11,"try_clone","","Creates a new independently owned handle to the underlying socket.",418,{"inputs":[{"name":"tcplistener"}],"output":{"name":"result"}}],[11,"accept","","Accept a new incoming connection from this listener.",418,{"inputs":[{"name":"tcplistener"}],"output":{"name":"result"}}],[11,"incoming","","Returns an iterator over the connections being received on this\nlistener.",418,{"inputs":[{"name":"tcplistener"}],"output":{"name":"incoming"}}],[11,"next","","",419,{"inputs":[{"name":"incoming"}],"output":{"name":"option"}}],[11,"fmt","","",418,{"inputs":[{"name":"tcplistener"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"bind","","Creates a UDP socket from the given address.",420,{"inputs":[{"name":"udpsocket"},{"name":"a"}],"output":{"name":"result"}}],[11,"recv_from","","Receives data from the socket. On success, returns the number of bytes\nread and the address from whence the data came.",420,null],[11,"send_to","","Sends data on the socket to the given address. On success, returns the\nnumber of bytes written.",420,null],[11,"local_addr","","Returns the socket address that this socket was created from.",420,{"inputs":[{"name":"udpsocket"}],"output":{"name":"result"}}],[11,"try_clone","","Creates a new independently owned handle to the underlying socket.",420,{"inputs":[{"name":"udpsocket"}],"output":{"name":"result"}}],[11,"set_broadcast","","Sets the broadcast flag on or off.",420,{"inputs":[{"name":"udpsocket"},{"name":"bool"}],"output":{"name":"result"}}],[11,"set_multicast_loop","","Sets the multicast loop flag to the specified value.",420,{"inputs":[{"name":"udpsocket"},{"name":"bool"}],"output":{"name":"result"}}],[11,"join_multicast","","Joins a multicast IP address (becomes a member of it).",420,{"inputs":[{"name":"udpsocket"},{"name":"ipaddr"}],"output":{"name":"result"}}],[11,"leave_multicast","","Leaves a multicast IP address (drops membership from it).",420,{"inputs":[{"name":"udpsocket"},{"name":"ipaddr"}],"output":{"name":"result"}}],[11,"set_multicast_time_to_live","","Sets the multicast TTL.",420,{"inputs":[{"name":"udpsocket"},{"name":"i32"}],"output":{"name":"result"}}],[11,"set_time_to_live","","Sets this socket's TTL.",420,{"inputs":[{"name":"udpsocket"},{"name":"i32"}],"output":{"name":"result"}}],[11,"set_read_timeout","","Sets the read timeout to the timeout specified.",420,{"inputs":[{"name":"udpsocket"},{"name":"option"}],"output":{"name":"result"}}],[11,"set_write_timeout","","Sets the write timeout to the timeout specified.",420,{"inputs":[{"name":"udpsocket"},{"name":"option"}],"output":{"name":"result"}}],[11,"read_timeout","","Returns the read timeout of this socket.",420,{"inputs":[{"name":"udpsocket"}],"output":{"name":"result"}}],[11,"write_timeout","","Returns the write timeout of this socket.",420,{"inputs":[{"name":"udpsocket"}],"output":{"name":"result"}}],[11,"fmt","","",420,{"inputs":[{"name":"udpsocket"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from_str","","",409,{"inputs":[{"name":"ipaddr"},{"name":"str"}],"output":{"name":"result"}}],[11,"from_str","","",413,{"inputs":[{"name":"ipv4addr"},{"name":"str"}],"output":{"name":"result"}}],[11,"from_str","","",414,{"inputs":[{"name":"ipv6addr"},{"name":"str"}],"output":{"name":"result"}}],[11,"from_str","","",411,{"inputs":[{"name":"socketaddr"},{"name":"str"}],"output":{"name":"result"}}],[11,"eq","","",421,{"inputs":[{"name":"addrparseerror"},{"name":"addrparseerror"}],"output":{"name":"bool"}}],[11,"ne","","",421,{"inputs":[{"name":"addrparseerror"},{"name":"addrparseerror"}],"output":{"name":"bool"}}],[11,"clone","","",421,{"inputs":[{"name":"addrparseerror"}],"output":{"name":"addrparseerror"}}],[11,"fmt","","",421,{"inputs":[{"name":"addrparseerror"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"ToSocketAddrs","","A trait for objects which can be converted or resolved to one or more\n`SocketAddr` values.",null,null],[16,"Iter","","Returned iterator over socket addresses which this type may correspond\nto.",422,null],[10,"to_socket_addrs","","Converts this object to an iterator of resolved `SocketAddr`s.",422,{"inputs":[{"name":"tosocketaddrs"}],"output":{"name":"result"}}],[11,"fmt","","",412,{"inputs":[{"name":"shutdown"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",412,{"inputs":[{"name":"shutdown"},{"name":"shutdown"}],"output":{"name":"bool"}}],[11,"ne","","",412,{"inputs":[{"name":"shutdown"},{"name":"shutdown"}],"output":{"name":"bool"}}],[11,"clone","","",412,{"inputs":[{"name":"shutdown"}],"output":{"name":"shutdown"}}],[11,"next","","",423,{"inputs":[{"name":"lookuphost"}],"output":{"name":"option"}}],[0,"os","std","OS-specific functionality",null,null],[0,"unix","std::os","Experimental extensions to `std` for Unix platforms.",null,null],[0,"io","std::os::unix","Unix-specific extensions to general I/O primitives",null,null],[6,"RawFd","std::os::unix::io","Raw file descriptors.",null,null],[8,"AsRawFd","","A trait to extract the raw unix file descriptor from an underlying\nobject.",null,null],[10,"as_raw_fd","","Extracts the raw file descriptor.",424,{"inputs":[{"name":"asrawfd"}],"output":{"name":"rawfd"}}],[8,"FromRawFd","","A trait to express the ability to construct an object from a raw file\ndescriptor.",null,null],[10,"from_raw_fd","","Constructs a new instances of `Self` from the given raw file\ndescriptor.",425,{"inputs":[{"name":"fromrawfd"},{"name":"rawfd"}],"output":{"name":"self"}}],[8,"IntoRawFd","","A trait to express the ability to consume an object and acquire ownership of\nits raw file descriptor.",null,null],[10,"into_raw_fd","","Consumes this object, returning the raw underlying file descriptor.",426,{"inputs":[{"name":"intorawfd"}],"output":{"name":"rawfd"}}],[11,"as_raw_fd","std::fs","",372,{"inputs":[{"name":"file"}],"output":{"name":"rawfd"}}],[11,"from_raw_fd","","",372,{"inputs":[{"name":"file"},{"name":"rawfd"}],"output":{"name":"file"}}],[11,"into_raw_fd","","",372,{"inputs":[{"name":"file"}],"output":{"name":"rawfd"}}],[11,"as_raw_fd","std::net","",417,{"inputs":[{"name":"tcpstream"}],"output":{"name":"rawfd"}}],[11,"as_raw_fd","","",418,{"inputs":[{"name":"tcplistener"}],"output":{"name":"rawfd"}}],[11,"as_raw_fd","","",420,{"inputs":[{"name":"udpsocket"}],"output":{"name":"rawfd"}}],[11,"from_raw_fd","","",417,{"inputs":[{"name":"tcpstream"},{"name":"rawfd"}],"output":{"name":"tcpstream"}}],[11,"from_raw_fd","","",418,{"inputs":[{"name":"tcplistener"},{"name":"rawfd"}],"output":{"name":"tcplistener"}}],[11,"from_raw_fd","","",420,{"inputs":[{"name":"udpsocket"},{"name":"rawfd"}],"output":{"name":"udpsocket"}}],[11,"into_raw_fd","","",417,{"inputs":[{"name":"tcpstream"}],"output":{"name":"rawfd"}}],[11,"into_raw_fd","","",418,{"inputs":[{"name":"tcplistener"}],"output":{"name":"rawfd"}}],[11,"into_raw_fd","","",420,{"inputs":[{"name":"udpsocket"}],"output":{"name":"rawfd"}}],[0,"ffi","std::os::unix","Unix-specific extension to the primitives in the `std::ffi` module",null,null],[8,"OsStringExt","std::os::unix::ffi","Unix-specific extensions to `OsString`.",null,null],[10,"from_vec","","Creates an `OsString` from a byte vector.",427,{"inputs":[{"name":"osstringext"},{"name":"vec"}],"output":{"name":"self"}}],[10,"into_vec","","Yields the underlying byte vector of this `OsString`.",427,{"inputs":[{"name":"osstringext"}],"output":{"name":"vec"}}],[8,"OsStrExt","","Unix-specific extensions to `OsStr`.",null,null],[10,"from_bytes","","",428,null],[10,"as_bytes","","Gets the underlying byte view of the `OsStr` slice.",428,null],[11,"from_vec","std::ffi","",366,{"inputs":[{"name":"osstring"},{"name":"vec"}],"output":{"name":"osstring"}}],[11,"into_vec","","",366,{"inputs":[{"name":"osstring"}],"output":{"name":"vec"}}],[11,"from_bytes","","",367,null],[11,"as_bytes","","",367,null],[0,"fs","std::os::unix","Unix-specific extensions to primitives in the `std::fs` module.",null,null],[5,"symlink","std::os::unix::fs","Creates a new symbolic link on the filesystem.",null,{"inputs":[{"name":"p"},{"name":"q"}],"output":{"name":"result"}}],[17,"USER_READ","","",null,null],[17,"USER_WRITE","","",null,null],[17,"USER_EXECUTE","","",null,null],[17,"USER_RWX","","",null,null],[17,"GROUP_READ","","",null,null],[17,"GROUP_WRITE","","",null,null],[17,"GROUP_EXECUTE","","",null,null],[17,"GROUP_RWX","","",null,null],[17,"OTHER_READ","","",null,null],[17,"OTHER_WRITE","","",null,null],[17,"OTHER_EXECUTE","","",null,null],[17,"OTHER_RWX","","",null,null],[17,"ALL_READ","","",null,null],[17,"ALL_WRITE","","",null,null],[17,"ALL_EXECUTE","","",null,null],[17,"ALL_RWX","","",null,null],[17,"SETUID","","",null,null],[17,"SETGID","","",null,null],[17,"STICKY_BIT","","",null,null],[8,"PermissionsExt","","Unix-specific extensions to `Permissions`",null,null],[10,"mode","","Returns the underlying raw `mode_t` bits that are the standard Unix\npermissions for this file.",429,{"inputs":[{"name":"permissionsext"}],"output":{"name":"mode_t"}}],[10,"set_mode","","Sets the underlying raw `mode_t` bits for this set of permissions.",429,{"inputs":[{"name":"permissionsext"},{"name":"mode_t"}],"output":null}],[10,"from_mode","","Creates a new instance of `Permissions` from the given set of Unix\npermission bits.",429,{"inputs":[{"name":"permissionsext"},{"name":"mode_t"}],"output":{"name":"self"}}],[8,"OpenOptionsExt","","Unix-specific extensions to `OpenOptions`",null,null],[10,"mode","","Sets the mode bits that a new file will be created with.",430,{"inputs":[{"name":"openoptionsext"},{"name":"mode_t"}],"output":{"name":"self"}}],[8,"MetadataExt","","",null,null],[10,"dev","","",431,{"inputs":[{"name":"metadataext"}],"output":{"name":"dev_t"}}],[10,"ino","","",431,{"inputs":[{"name":"metadataext"}],"output":{"name":"ino_t"}}],[10,"mode","","",431,{"inputs":[{"name":"metadataext"}],"output":{"name":"mode_t"}}],[10,"nlink","","",431,{"inputs":[{"name":"metadataext"}],"output":{"name":"nlink_t"}}],[10,"uid","","",431,{"inputs":[{"name":"metadataext"}],"output":{"name":"uid_t"}}],[10,"gid","","",431,{"inputs":[{"name":"metadataext"}],"output":{"name":"gid_t"}}],[10,"rdev","","",431,{"inputs":[{"name":"metadataext"}],"output":{"name":"dev_t"}}],[10,"size","","",431,{"inputs":[{"name":"metadataext"}],"output":{"name":"off_t"}}],[10,"atime","","",431,{"inputs":[{"name":"metadataext"}],"output":{"name":"time_t"}}],[10,"atime_nsec","","",431,{"inputs":[{"name":"metadataext"}],"output":{"name":"c_long"}}],[10,"mtime","","",431,{"inputs":[{"name":"metadataext"}],"output":{"name":"time_t"}}],[10,"mtime_nsec","","",431,{"inputs":[{"name":"metadataext"}],"output":{"name":"c_long"}}],[10,"ctime","","",431,{"inputs":[{"name":"metadataext"}],"output":{"name":"time_t"}}],[10,"ctime_nsec","","",431,{"inputs":[{"name":"metadataext"}],"output":{"name":"c_long"}}],[10,"blksize","","",431,{"inputs":[{"name":"metadataext"}],"output":{"name":"blksize_t"}}],[10,"blocks","","",431,{"inputs":[{"name":"metadataext"}],"output":{"name":"blkcnt_t"}}],[8,"FileTypeExt","","Add special unix types (block/char device, fifo and socket)",null,null],[10,"is_block_device","","Returns whether this file type is a block device.",432,{"inputs":[{"name":"filetypeext"}],"output":{"name":"bool"}}],[10,"is_char_device","","Returns whether this file type is a char device.",432,{"inputs":[{"name":"filetypeext"}],"output":{"name":"bool"}}],[10,"is_fifo","","Returns whether this file type is a fifo.",432,{"inputs":[{"name":"filetypeext"}],"output":{"name":"bool"}}],[10,"is_socket","","Returns whether this file type is a socket.",432,{"inputs":[{"name":"filetypeext"}],"output":{"name":"bool"}}],[8,"DirEntryExt","","Unix-specific extension methods for `fs::DirEntry`",null,null],[10,"ino","","Returns the underlying `d_ino` field in the contained `dirent`\nstructure.",433,{"inputs":[{"name":"direntryext"}],"output":{"name":"ino_t"}}],[8,"DirBuilderExt","","An extension trait for `fs::DirBuilder` for unix-specific options.",null,null],[10,"mode","","Sets the mode to create new directories with. This option defaults to\n0o777.",434,{"inputs":[{"name":"dirbuilderext"},{"name":"mode_t"}],"output":{"name":"self"}}],[11,"mode","std::fs","",370,{"inputs":[{"name":"permissions"}],"output":{"name":"mode_t"}}],[11,"set_mode","","",370,{"inputs":[{"name":"permissions"},{"name":"mode_t"}],"output":null}],[11,"from_mode","","",370,{"inputs":[{"name":"permissions"},{"name":"mode_t"}],"output":{"name":"permissions"}}],[11,"mode","","",369,{"inputs":[{"name":"openoptions"},{"name":"mode_t"}],"output":{"name":"openoptions"}}],[11,"dev","","",373,{"inputs":[{"name":"metadata"}],"output":{"name":"dev_t"}}],[11,"ino","","",373,{"inputs":[{"name":"metadata"}],"output":{"name":"ino_t"}}],[11,"mode","","",373,{"inputs":[{"name":"metadata"}],"output":{"name":"mode_t"}}],[11,"nlink","","",373,{"inputs":[{"name":"metadata"}],"output":{"name":"nlink_t"}}],[11,"uid","","",373,{"inputs":[{"name":"metadata"}],"output":{"name":"uid_t"}}],[11,"gid","","",373,{"inputs":[{"name":"metadata"}],"output":{"name":"gid_t"}}],[11,"rdev","","",373,{"inputs":[{"name":"metadata"}],"output":{"name":"dev_t"}}],[11,"size","","",373,{"inputs":[{"name":"metadata"}],"output":{"name":"off_t"}}],[11,"atime","","",373,{"inputs":[{"name":"metadata"}],"output":{"name":"time_t"}}],[11,"atime_nsec","","",373,{"inputs":[{"name":"metadata"}],"output":{"name":"c_long"}}],[11,"mtime","","",373,{"inputs":[{"name":"metadata"}],"output":{"name":"time_t"}}],[11,"mtime_nsec","","",373,{"inputs":[{"name":"metadata"}],"output":{"name":"c_long"}}],[11,"ctime","","",373,{"inputs":[{"name":"metadata"}],"output":{"name":"time_t"}}],[11,"ctime_nsec","","",373,{"inputs":[{"name":"metadata"}],"output":{"name":"c_long"}}],[11,"blksize","","",373,{"inputs":[{"name":"metadata"}],"output":{"name":"blksize_t"}}],[11,"blocks","","",373,{"inputs":[{"name":"metadata"}],"output":{"name":"blkcnt_t"}}],[11,"is_block_device","","",371,{"inputs":[{"name":"filetype"}],"output":{"name":"bool"}}],[11,"is_char_device","","",371,{"inputs":[{"name":"filetype"}],"output":{"name":"bool"}}],[11,"is_fifo","","",371,{"inputs":[{"name":"filetype"}],"output":{"name":"bool"}}],[11,"is_socket","","",371,{"inputs":[{"name":"filetype"}],"output":{"name":"bool"}}],[11,"ino","","",375,{"inputs":[{"name":"direntry"}],"output":{"name":"ino_t"}}],[11,"mode","","",377,{"inputs":[{"name":"dirbuilder"},{"name":"mode_t"}],"output":{"name":"dirbuilder"}}],[0,"process","std::os::unix","Unix-specific extensions to primitives in the `std::process` module.",null,null],[8,"CommandExt","std::os::unix::process","Unix-specific extensions to the `std::process::Command` builder",null,null],[10,"uid","","Sets the child process's user id. This translates to a\n`setuid` call in the child process. Failure in the `setuid`\ncall will cause the spawn to fail.",435,{"inputs":[{"name":"commandext"},{"name":"uid_t"}],"output":{"name":"command"}}],[10,"gid","","Similar to `uid`, but sets the group id of the child process. This has\nthe same semantics as the `uid` field.",435,{"inputs":[{"name":"commandext"},{"name":"gid_t"}],"output":{"name":"command"}}],[8,"ExitStatusExt","","Unix-specific extensions to `std::process::ExitStatus`",null,null],[10,"signal","","If the process was terminated by a signal, returns that signal.",436,{"inputs":[{"name":"exitstatusext"}],"output":{"name":"option"}}],[0,"raw","std::os::unix","Unix-specific primitives available on all unix platforms",null,null],[6,"uid_t","std::os::unix::raw","",null,null],[6,"gid_t","","",null,null],[6,"pid_t","","",null,null],[6,"dev_t","","",null,null],[6,"ino_t","","",null,null],[6,"mode_t","","",null,null],[6,"nlink_t","","",null,null],[6,"off_t","","",null,null],[6,"blksize_t","","",null,null],[6,"blkcnt_t","","",null,null],[6,"time_t","","",null,null],[0,"prelude","std::os::unix","A prelude for conveniently writing platform-specific code.",null,null],[6,"RawFd","std::os::unix::prelude","Raw file descriptors.",null,null],[8,"AsRawFd","","A trait to extract the raw unix file descriptor from an underlying\nobject.",null,null],[10,"as_raw_fd","","Extracts the raw file descriptor.",424,{"inputs":[{"name":"asrawfd"}],"output":{"name":"rawfd"}}],[8,"FromRawFd","","A trait to express the ability to construct an object from a raw file\ndescriptor.",null,null],[10,"from_raw_fd","","Constructs a new instances of `Self` from the given raw file\ndescriptor.",425,{"inputs":[{"name":"fromrawfd"},{"name":"rawfd"}],"output":{"name":"self"}}],[8,"OsStrExt","","Unix-specific extensions to `OsStr`.",null,null],[10,"from_bytes","","",428,null],[10,"as_bytes","","Gets the underlying byte view of the `OsStr` slice.",428,null],[8,"OsStringExt","","Unix-specific extensions to `OsString`.",null,null],[10,"from_vec","","Creates an `OsString` from a byte vector.",427,{"inputs":[{"name":"osstringext"},{"name":"vec"}],"output":{"name":"self"}}],[10,"into_vec","","Yields the underlying byte vector of this `OsString`.",427,{"inputs":[{"name":"osstringext"}],"output":{"name":"vec"}}],[8,"PermissionsExt","","Unix-specific extensions to `Permissions`",null,null],[10,"mode","","Returns the underlying raw `mode_t` bits that are the standard Unix\npermissions for this file.",429,{"inputs":[{"name":"permissionsext"}],"output":{"name":"mode_t"}}],[10,"set_mode","","Sets the underlying raw `mode_t` bits for this set of permissions.",429,{"inputs":[{"name":"permissionsext"},{"name":"mode_t"}],"output":null}],[10,"from_mode","","Creates a new instance of `Permissions` from the given set of Unix\npermission bits.",429,{"inputs":[{"name":"permissionsext"},{"name":"mode_t"}],"output":{"name":"self"}}],[8,"OpenOptionsExt","","Unix-specific extensions to `OpenOptions`",null,null],[10,"mode","","Sets the mode bits that a new file will be created with.",430,{"inputs":[{"name":"openoptionsext"},{"name":"mode_t"}],"output":{"name":"self"}}],[8,"MetadataExt","","",null,null],[10,"dev","","",431,{"inputs":[{"name":"metadataext"}],"output":{"name":"dev_t"}}],[10,"ino","","",431,{"inputs":[{"name":"metadataext"}],"output":{"name":"ino_t"}}],[10,"mode","","",431,{"inputs":[{"name":"metadataext"}],"output":{"name":"mode_t"}}],[10,"nlink","","",431,{"inputs":[{"name":"metadataext"}],"output":{"name":"nlink_t"}}],[10,"uid","","",431,{"inputs":[{"name":"metadataext"}],"output":{"name":"uid_t"}}],[10,"gid","","",431,{"inputs":[{"name":"metadataext"}],"output":{"name":"gid_t"}}],[10,"rdev","","",431,{"inputs":[{"name":"metadataext"}],"output":{"name":"dev_t"}}],[10,"size","","",431,{"inputs":[{"name":"metadataext"}],"output":{"name":"off_t"}}],[10,"atime","","",431,{"inputs":[{"name":"metadataext"}],"output":{"name":"time_t"}}],[10,"atime_nsec","","",431,{"inputs":[{"name":"metadataext"}],"output":{"name":"c_long"}}],[10,"mtime","","",431,{"inputs":[{"name":"metadataext"}],"output":{"name":"time_t"}}],[10,"mtime_nsec","","",431,{"inputs":[{"name":"metadataext"}],"output":{"name":"c_long"}}],[10,"ctime","","",431,{"inputs":[{"name":"metadataext"}],"output":{"name":"time_t"}}],[10,"ctime_nsec","","",431,{"inputs":[{"name":"metadataext"}],"output":{"name":"c_long"}}],[10,"blksize","","",431,{"inputs":[{"name":"metadataext"}],"output":{"name":"blksize_t"}}],[10,"blocks","","",431,{"inputs":[{"name":"metadataext"}],"output":{"name":"blkcnt_t"}}],[8,"FileTypeExt","","Add special unix types (block/char device, fifo and socket)",null,null],[10,"is_block_device","","Returns whether this file type is a block device.",432,{"inputs":[{"name":"filetypeext"}],"output":{"name":"bool"}}],[10,"is_char_device","","Returns whether this file type is a char device.",432,{"inputs":[{"name":"filetypeext"}],"output":{"name":"bool"}}],[10,"is_fifo","","Returns whether this file type is a fifo.",432,{"inputs":[{"name":"filetypeext"}],"output":{"name":"bool"}}],[10,"is_socket","","Returns whether this file type is a socket.",432,{"inputs":[{"name":"filetypeext"}],"output":{"name":"bool"}}],[8,"DirEntryExt","","Unix-specific extension methods for `fs::DirEntry`",null,null],[10,"ino","","Returns the underlying `d_ino` field in the contained `dirent`\nstructure.",433,{"inputs":[{"name":"direntryext"}],"output":{"name":"ino_t"}}],[8,"CommandExt","","Unix-specific extensions to the `std::process::Command` builder",null,null],[10,"uid","","Sets the child process's user id. This translates to a\n`setuid` call in the child process. Failure in the `setuid`\ncall will cause the spawn to fail.",435,{"inputs":[{"name":"commandext"},{"name":"uid_t"}],"output":{"name":"command"}}],[10,"gid","","Similar to `uid`, but sets the group id of the child process. This has\nthe same semantics as the `uid` field.",435,{"inputs":[{"name":"commandext"},{"name":"gid_t"}],"output":{"name":"command"}}],[8,"ExitStatusExt","","Unix-specific extensions to `std::process::ExitStatus`",null,null],[10,"signal","","If the process was terminated by a signal, returns that signal.",436,{"inputs":[{"name":"exitstatusext"}],"output":{"name":"option"}}],[0,"linux","std::os","Linux-specific definitions",null,null],[0,"raw","std::os::linux","Linux-specific raw type definitions",null,null],[3,"stat","std::os::linux::raw","",null,null],[12,"st_dev","","",437,null],[12,"st_ino","","",437,null],[12,"st_nlink","","",437,null],[12,"st_mode","","",437,null],[12,"st_uid","","",437,null],[12,"st_gid","","",437,null],[12,"__pad0","","",437,null],[12,"st_rdev","","",437,null],[12,"st_size","","",437,null],[12,"st_blksize","","",437,null],[12,"st_blocks","","",437,null],[12,"st_atime","","",437,null],[12,"st_atime_nsec","","",437,null],[12,"st_mtime","","",437,null],[12,"st_mtime_nsec","","",437,null],[12,"st_ctime","","",437,null],[12,"st_ctime_nsec","","",437,null],[12,"__unused","","",437,null],[6,"dev_t","","",null,null],[6,"mode_t","","",null,null],[0,"fs","std::os::linux","",null,null],[8,"MetadataExt","std::os::linux::fs","OS-specific extension methods for `fs::Metadata`",null,null],[10,"as_raw_stat","","Gain a reference to the underlying `stat` structure which contains the\nraw information returned by the OS.",438,{"inputs":[{"name":"metadataext"}],"output":{"name":"stat"}}],[0,"raw","std::os","Raw OS-specific types for the current platform/architecture",null,null],[4,"c_void","std::os::raw","Type used to construct void pointers for use with C.",null,null],[6,"c_char","","",null,null],[6,"c_schar","","",null,null],[6,"c_uchar","","",null,null],[6,"c_short","","",null,null],[6,"c_ushort","","",null,null],[6,"c_int","","",null,null],[6,"c_uint","","",null,null],[6,"c_long","","",null,null],[6,"c_ulong","","",null,null],[6,"c_longlong","","",null,null],[6,"c_ulonglong","","",null,null],[6,"c_float","","",null,null],[6,"c_double","","",null,null],[0,"path","std","Cross-platform path manipulation.",null,null],[3,"PrefixComponent","std::path","A Windows path prefix, e.g. `C:` or `\\server\\share`.",null,null],[3,"Components","","The core iterator giving the components of a path.",null,null],[3,"Iter","","An iterator over the components of a path, as `OsStr` slices.",null,null],[3,"PathBuf","","An owned, mutable path (akin to `String`).",null,null],[3,"Path","","A slice of a path (akin to `str`).",null,null],[3,"Display","","Helper struct for safely printing paths with `format!()` and `{}`",null,null],[4,"Prefix","","Path prefixes (Windows only).",null,null],[13,"Verbatim","","Prefix `\\\\?\\`, together with the given component immediately following it.",439,null],[13,"VerbatimUNC","","Prefix `\\\\?\\UNC\\`, with the \"server\" and \"share\" components following it.",439,null],[13,"VerbatimDisk","","Prefix like `\\\\?\\C:\\`, for the given drive letter",439,null],[13,"DeviceNS","","Prefix `\\\\.\\`, together with the given component immediately following it.",439,null],[13,"UNC","","Prefix `\\\\server\\share`, with the given \"server\" and \"share\" components.",439,null],[13,"Disk","","Prefix `C:` for the given disk drive.",439,null],[4,"Component","","A single component of a path.",null,null],[13,"Prefix","","A Windows path prefix, e.g. `C:` or `\\server\\share`.",440,null],[13,"RootDir","","The root directory component, appears after any prefix and before anything else",440,null],[13,"CurDir","","A reference to the current directory, i.e. `.`",440,null],[13,"ParentDir","","A reference to the parent directory, i.e. `..`",440,null],[13,"Normal","","A normal component, i.e. `a` and `b` in `a/b`",440,null],[5,"is_separator","","Determines whether the character is one of the permitted path\nseparators for the current platform.",null,{"inputs":[{"name":"char"}],"output":{"name":"bool"}}],[17,"MAIN_SEPARATOR","","The primary separator for the current platform",null,null],[11,"eq","","",439,{"inputs":[{"name":"prefix"},{"name":"prefix"}],"output":{"name":"bool"}}],[11,"ne","","",439,{"inputs":[{"name":"prefix"},{"name":"prefix"}],"output":{"name":"bool"}}],[11,"cmp","","",439,{"inputs":[{"name":"prefix"},{"name":"prefix"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",439,{"inputs":[{"name":"prefix"},{"name":"prefix"}],"output":{"name":"option"}}],[11,"lt","","",439,{"inputs":[{"name":"prefix"},{"name":"prefix"}],"output":{"name":"bool"}}],[11,"le","","",439,{"inputs":[{"name":"prefix"},{"name":"prefix"}],"output":{"name":"bool"}}],[11,"gt","","",439,{"inputs":[{"name":"prefix"},{"name":"prefix"}],"output":{"name":"bool"}}],[11,"ge","","",439,{"inputs":[{"name":"prefix"},{"name":"prefix"}],"output":{"name":"bool"}}],[11,"hash","","",439,null],[11,"fmt","","",439,{"inputs":[{"name":"prefix"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",439,{"inputs":[{"name":"prefix"}],"output":{"name":"prefix"}}],[11,"is_verbatim","","Determines if the prefix is verbatim, i.e. begins with `\\\\?\\`.",439,{"inputs":[{"name":"prefix"}],"output":{"name":"bool"}}],[11,"fmt","","",441,{"inputs":[{"name":"prefixcomponent"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",441,null],[11,"clone","","",441,{"inputs":[{"name":"prefixcomponent"}],"output":{"name":"prefixcomponent"}}],[11,"kind","","The parsed prefix data.",441,{"inputs":[{"name":"prefixcomponent"}],"output":{"name":"prefix"}}],[11,"as_os_str","","The raw `OsStr` slice for this prefix.",441,{"inputs":[{"name":"prefixcomponent"}],"output":{"name":"osstr"}}],[11,"eq","","",441,{"inputs":[{"name":"prefixcomponent"},{"name":"prefixcomponent"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",441,{"inputs":[{"name":"prefixcomponent"},{"name":"prefixcomponent"}],"output":{"name":"option"}}],[11,"cmp","","",441,{"inputs":[{"name":"prefixcomponent"},{"name":"prefixcomponent"}],"output":{"name":"ordering"}}],[11,"fmt","","",440,{"inputs":[{"name":"component"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",440,null],[11,"cmp","","",440,{"inputs":[{"name":"component"},{"name":"component"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",440,{"inputs":[{"name":"component"},{"name":"component"}],"output":{"name":"option"}}],[11,"lt","","",440,{"inputs":[{"name":"component"},{"name":"component"}],"output":{"name":"bool"}}],[11,"le","","",440,{"inputs":[{"name":"component"},{"name":"component"}],"output":{"name":"bool"}}],[11,"gt","","",440,{"inputs":[{"name":"component"},{"name":"component"}],"output":{"name":"bool"}}],[11,"ge","","",440,{"inputs":[{"name":"component"},{"name":"component"}],"output":{"name":"bool"}}],[11,"eq","","",440,{"inputs":[{"name":"component"},{"name":"component"}],"output":{"name":"bool"}}],[11,"ne","","",440,{"inputs":[{"name":"component"},{"name":"component"}],"output":{"name":"bool"}}],[11,"clone","","",440,{"inputs":[{"name":"component"}],"output":{"name":"component"}}],[11,"as_os_str","","Extracts the underlying `OsStr` slice",440,{"inputs":[{"name":"component"}],"output":{"name":"osstr"}}],[11,"as_ref","","",440,{"inputs":[{"name":"component"}],"output":{"name":"osstr"}}],[11,"clone","","",442,{"inputs":[{"name":"components"}],"output":{"name":"components"}}],[11,"clone","","",443,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[11,"as_path","","Extracts a slice corresponding to the portion of the path remaining for iteration.",442,{"inputs":[{"name":"components"}],"output":{"name":"path"}}],[11,"peek","","Examine the next component without consuming it.",442,{"inputs":[{"name":"components"}],"output":{"name":"option"}}],[11,"as_ref","","",442,{"inputs":[{"name":"components"}],"output":{"name":"path"}}],[11,"as_ref","","",442,{"inputs":[{"name":"components"}],"output":{"name":"osstr"}}],[11,"as_path","","Extracts a slice corresponding to the portion of the path remaining for iteration.",443,{"inputs":[{"name":"iter"}],"output":{"name":"path"}}],[11,"as_ref","","",443,{"inputs":[{"name":"iter"}],"output":{"name":"path"}}],[11,"as_ref","","",443,{"inputs":[{"name":"iter"}],"output":{"name":"osstr"}}],[11,"next","","",443,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"next_back","","",443,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"next","","",442,{"inputs":[{"name":"components"}],"output":{"name":"option"}}],[11,"next_back","","",442,{"inputs":[{"name":"components"}],"output":{"name":"option"}}],[11,"eq","","",442,{"inputs":[{"name":"components"},{"name":"components"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",442,{"inputs":[{"name":"components"},{"name":"components"}],"output":{"name":"option"}}],[11,"cmp","","",442,{"inputs":[{"name":"components"},{"name":"components"}],"output":{"name":"ordering"}}],[11,"hash","","",444,null],[11,"clone","","",444,{"inputs":[{"name":"pathbuf"}],"output":{"name":"pathbuf"}}],[11,"new","","Allocates an empty `PathBuf`.",444,{"inputs":[{"name":"pathbuf"}],"output":{"name":"pathbuf"}}],[11,"as_path","","Coerces to a `Path` slice.",444,{"inputs":[{"name":"pathbuf"}],"output":{"name":"path"}}],[11,"push","","Extends `self` with `path`.",444,{"inputs":[{"name":"pathbuf"},{"name":"p"}],"output":null}],[11,"pop","","Truncate `self` to `self.parent()`.",444,{"inputs":[{"name":"pathbuf"}],"output":{"name":"bool"}}],[11,"set_file_name","","Updates `self.file_name()` to `file_name`.",444,{"inputs":[{"name":"pathbuf"},{"name":"s"}],"output":null}],[11,"set_extension","","Updates `self.extension()` to `extension`.",444,{"inputs":[{"name":"pathbuf"},{"name":"s"}],"output":{"name":"bool"}}],[11,"into_os_string","","Consumes the `PathBuf`, yielding its internal `OsString` storage.",444,{"inputs":[{"name":"pathbuf"}],"output":{"name":"osstring"}}],[11,"from","","",444,{"inputs":[{"name":"pathbuf"},{"name":"t"}],"output":{"name":"pathbuf"}}],[11,"from","","",444,{"inputs":[{"name":"pathbuf"},{"name":"osstring"}],"output":{"name":"pathbuf"}}],[11,"from","","",444,{"inputs":[{"name":"pathbuf"},{"name":"string"}],"output":{"name":"pathbuf"}}],[11,"from_iter","","",444,{"inputs":[{"name":"pathbuf"},{"name":"i"}],"output":{"name":"pathbuf"}}],[11,"extend","","",444,{"inputs":[{"name":"pathbuf"},{"name":"i"}],"output":null}],[11,"fmt","","",444,{"inputs":[{"name":"pathbuf"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"deref","","",444,{"inputs":[{"name":"pathbuf"}],"output":{"name":"path"}}],[11,"borrow","","",444,{"inputs":[{"name":"pathbuf"}],"output":{"name":"path"}}],[11,"into_cow","","",444,{"inputs":[{"name":"pathbuf"}],"output":{"name":"cow"}}],[11,"to_owned","","",445,{"inputs":[{"name":"path"}],"output":{"name":"pathbuf"}}],[11,"eq","","",444,{"inputs":[{"name":"pathbuf"},{"name":"pathbuf"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",444,{"inputs":[{"name":"pathbuf"},{"name":"pathbuf"}],"output":{"name":"option"}}],[11,"cmp","","",444,{"inputs":[{"name":"pathbuf"},{"name":"pathbuf"}],"output":{"name":"ordering"}}],[11,"as_ref","","",444,{"inputs":[{"name":"pathbuf"}],"output":{"name":"osstr"}}],[11,"into","","",444,{"inputs":[{"name":"pathbuf"}],"output":{"name":"osstring"}}],[11,"hash","","",445,null],[11,"new","","Directly wrap a string slice as a `Path` slice.",445,{"inputs":[{"name":"path"},{"name":"s"}],"output":{"name":"path"}}],[11,"as_os_str","","Yields the underlying `OsStr` slice.",445,{"inputs":[{"name":"path"}],"output":{"name":"osstr"}}],[11,"to_str","","Yields a `&str` slice if the `Path` is valid unicode.",445,{"inputs":[{"name":"path"}],"output":{"name":"option"}}],[11,"to_string_lossy","","Converts a `Path` to a `Cow<str>`.",445,{"inputs":[{"name":"path"}],"output":{"name":"cow"}}],[11,"to_path_buf","","Converts a `Path` to an owned `PathBuf`.",445,{"inputs":[{"name":"path"}],"output":{"name":"pathbuf"}}],[11,"is_absolute","","A path is *absolute* if it is independent of the current directory.",445,{"inputs":[{"name":"path"}],"output":{"name":"bool"}}],[11,"is_relative","","A path is *relative* if it is not absolute.",445,{"inputs":[{"name":"path"}],"output":{"name":"bool"}}],[11,"prefix","","Returns the *prefix* of a path, if any.",445,{"inputs":[{"name":"path"}],"output":{"name":"option"}}],[11,"has_root","","A path has a root if the body of the path begins with the directory separator.",445,{"inputs":[{"name":"path"}],"output":{"name":"bool"}}],[11,"parent","","The path without its final component, if any.",445,{"inputs":[{"name":"path"}],"output":{"name":"option"}}],[11,"file_name","","The final component of the path, if it is a normal file.",445,{"inputs":[{"name":"path"}],"output":{"name":"option"}}],[11,"relative_from","","Returns a path that, when joined onto `base`, yields `self`.",445,{"inputs":[{"name":"path"},{"name":"p"}],"output":{"name":"option"}}],[11,"starts_with","","Determines whether `base` is a prefix of `self`.",445,{"inputs":[{"name":"path"},{"name":"p"}],"output":{"name":"bool"}}],[11,"ends_with","","Determines whether `child` is a suffix of `self`.",445,{"inputs":[{"name":"path"},{"name":"p"}],"output":{"name":"bool"}}],[11,"file_stem","","Extracts the stem (non-extension) portion of `self.file_name()`.",445,{"inputs":[{"name":"path"}],"output":{"name":"option"}}],[11,"extension","","Extracts the extension of `self.file_name()`, if possible.",445,{"inputs":[{"name":"path"}],"output":{"name":"option"}}],[11,"join","","Creates an owned `PathBuf` with `path` adjoined to `self`.",445,{"inputs":[{"name":"path"},{"name":"p"}],"output":{"name":"pathbuf"}}],[11,"with_file_name","","Creates an owned `PathBuf` like `self` but with the given file name.",445,{"inputs":[{"name":"path"},{"name":"s"}],"output":{"name":"pathbuf"}}],[11,"with_extension","","Creates an owned `PathBuf` like `self` but with the given extension.",445,{"inputs":[{"name":"path"},{"name":"s"}],"output":{"name":"pathbuf"}}],[11,"components","","Produce an iterator over the components of the path.",445,{"inputs":[{"name":"path"}],"output":{"name":"components"}}],[11,"iter","","Produce an iterator over the path's components viewed as `OsStr` slices.",445,{"inputs":[{"name":"path"}],"output":{"name":"iter"}}],[11,"display","","Returns an object that implements `Display` for safely printing paths\nthat may contain non-Unicode data.",445,{"inputs":[{"name":"path"}],"output":{"name":"display"}}],[11,"as_ref","","",445,{"inputs":[{"name":"path"}],"output":{"name":"osstr"}}],[11,"fmt","","",445,{"inputs":[{"name":"path"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",446,{"inputs":[{"name":"display"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",446,{"inputs":[{"name":"display"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",445,{"inputs":[{"name":"path"},{"name":"path"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",445,{"inputs":[{"name":"path"},{"name":"path"}],"output":{"name":"option"}}],[11,"cmp","","",445,{"inputs":[{"name":"path"},{"name":"path"}],"output":{"name":"ordering"}}],[11,"as_ref","","",445,{"inputs":[{"name":"path"}],"output":{"name":"path"}}],[11,"as_ref","std::ffi","",367,{"inputs":[{"name":"osstr"}],"output":{"name":"path"}}],[11,"as_ref","","",366,{"inputs":[{"name":"osstring"}],"output":{"name":"path"}}],[11,"as_ref","std::string","",282,{"inputs":[{"name":"string"}],"output":{"name":"path"}}],[11,"as_ref","std::path","",444,{"inputs":[{"name":"pathbuf"}],"output":{"name":"path"}}],[0,"process","std","Working with processes.",null,null],[3,"Child","std::process","Representation of a running or exited child process.",null,null],[12,"stdin","","The handle for writing to the child's stdin, if it has been captured",447,null],[12,"stdout","","The handle for reading from the child's stdout, if it has been captured",447,null],[12,"stderr","","The handle for reading from the child's stderr, if it has been captured",447,null],[3,"ChildStdin","","A handle to a child procesess's stdin",null,null],[3,"ChildStdout","","A handle to a child procesess's stdout",null,null],[3,"ChildStderr","","A handle to a child procesess's stderr",null,null],[3,"Command","","The `Command` type acts as a process builder, providing fine-grained control\nover how a new process should be spawned. A default configuration can be\ngenerated using `Command::new(program)`, where `program` gives a path to the\nprogram to be executed. Additional builder methods allow the configuration\nto be changed (for example, by adding arguments) prior to spawning:",null,null],[3,"Output","","The output of a finished process.",null,null],[12,"status","","The status (exit code) of the process.",448,null],[12,"stdout","","The data that the process wrote to stdout.",448,null],[12,"stderr","","The data that the process wrote to stderr.",448,null],[3,"Stdio","","Describes what to do with a standard I/O stream for a child process.",null,null],[3,"ExitStatus","","Describes the result of a process after it has terminated.",null,null],[5,"exit","","Terminates the current process with the specified exit code.",null,{"inputs":[{"name":"i32"}],"output":null}],[11,"write","","",449,null],[11,"flush","","",449,{"inputs":[{"name":"childstdin"}],"output":{"name":"result"}}],[11,"read","","",450,null],[11,"read","","",451,null],[11,"new","","Constructs a new `Command` for launching the program at\npath `program`, with the following default configuration:",452,{"inputs":[{"name":"command"},{"name":"s"}],"output":{"name":"command"}}],[11,"arg","","Add an argument to pass to the program.",452,{"inputs":[{"name":"command"},{"name":"s"}],"output":{"name":"command"}}],[11,"args","","Add multiple arguments to pass to the program.",452,null],[11,"env","","Inserts or updates an environment variable mapping.",452,{"inputs":[{"name":"command"},{"name":"k"},{"name":"v"}],"output":{"name":"command"}}],[11,"env_remove","","Removes an environment variable mapping.",452,{"inputs":[{"name":"command"},{"name":"k"}],"output":{"name":"command"}}],[11,"env_clear","","Clears the entire environment map for the child process.",452,{"inputs":[{"name":"command"}],"output":{"name":"command"}}],[11,"current_dir","","Sets the working directory for the child process.",452,{"inputs":[{"name":"command"},{"name":"p"}],"output":{"name":"command"}}],[11,"stdin","","Configuration for the child process's stdin handle (file descriptor 0).",452,{"inputs":[{"name":"command"},{"name":"stdio"}],"output":{"name":"command"}}],[11,"stdout","","Configuration for the child process's stdout handle (file descriptor 1).",452,{"inputs":[{"name":"command"},{"name":"stdio"}],"output":{"name":"command"}}],[11,"stderr","","Configuration for the child process's stderr handle (file descriptor 2).",452,{"inputs":[{"name":"command"},{"name":"stdio"}],"output":{"name":"command"}}],[11,"spawn","","Executes the command as a child process, returning a handle to it.",452,{"inputs":[{"name":"command"}],"output":{"name":"result"}}],[11,"output","","Executes the command as a child process, waiting for it to finish and\ncollecting all of its output.",452,{"inputs":[{"name":"command"}],"output":{"name":"result"}}],[11,"status","","Executes a command as a child process, waiting for it to finish and\ncollecting its exit status.",452,{"inputs":[{"name":"command"}],"output":{"name":"result"}}],[11,"fmt","","Format the program and arguments of a Command for display. Any\nnon-utf8 data is lossily converted using the utf8 replacement\ncharacter.",452,{"inputs":[{"name":"command"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",448,{"inputs":[{"name":"output"}],"output":{"name":"output"}}],[11,"eq","","",448,{"inputs":[{"name":"output"},{"name":"output"}],"output":{"name":"bool"}}],[11,"ne","","",448,{"inputs":[{"name":"output"},{"name":"output"}],"output":{"name":"bool"}}],[11,"piped","","A new pipe should be arranged to connect the parent and child processes.",453,{"inputs":[{"name":"stdio"}],"output":{"name":"stdio"}}],[11,"inherit","","The child inherits from the corresponding parent descriptor.",453,{"inputs":[{"name":"stdio"}],"output":{"name":"stdio"}}],[11,"null","","This stream will be ignored. This is the equivalent of attaching the\nstream to `/dev/null`",453,{"inputs":[{"name":"stdio"}],"output":{"name":"stdio"}}],[11,"fmt","","",454,{"inputs":[{"name":"exitstatus"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",454,{"inputs":[{"name":"exitstatus"}],"output":{"name":"exitstatus"}}],[11,"eq","","",454,{"inputs":[{"name":"exitstatus"},{"name":"exitstatus"}],"output":{"name":"bool"}}],[11,"ne","","",454,{"inputs":[{"name":"exitstatus"},{"name":"exitstatus"}],"output":{"name":"bool"}}],[11,"success","","Was termination successful? Signal termination not considered a success,\nand success is defined as a zero exit status.",454,{"inputs":[{"name":"exitstatus"}],"output":{"name":"bool"}}],[11,"code","","Returns the exit code of the process, if any.",454,{"inputs":[{"name":"exitstatus"}],"output":{"name":"option"}}],[11,"fmt","","",454,{"inputs":[{"name":"exitstatus"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"kill","","Forces the child to exit. This is equivalent to sending a\nSIGKILL on unix platforms.",447,{"inputs":[{"name":"child"}],"output":{"name":"result"}}],[11,"id","","Returns the OS-assigned process identifier associated with this child.",447,{"inputs":[{"name":"child"}],"output":{"name":"u32"}}],[11,"wait","","Waits for the child to exit completely, returning the status that it\nexited with. This function will continue to have the same return value\nafter it has been called at least once.",447,{"inputs":[{"name":"child"}],"output":{"name":"result"}}],[11,"wait_with_output","","Simultaneously waits for the child to exit and collect all remaining\noutput on the stdout/stderr handles, returning a `Output`\ninstance.",447,{"inputs":[{"name":"child"}],"output":{"name":"result"}}],[0,"sync","std","Useful synchronization primitives",null,null],[3,"Arc","std::sync","An atomically reference counted wrapper for shared state.",null,null],[3,"Weak","","A weak pointer to an `Arc`.",null,null],[0,"atomic","","Atomic types",null,null],[3,"AtomicBool","std::sync::atomic","A boolean type which can be safely shared between threads.",null,null],[3,"AtomicIsize","","A signed integer type which can be safely shared between threads.",null,null],[3,"AtomicUsize","","An unsigned integer type which can be safely shared between threads.",null,null],[3,"AtomicPtr","","A raw pointer type which can be safely shared between threads.",null,null],[4,"Ordering","","Atomic memory orderings",null,null],[13,"Relaxed","","No ordering constraints, only atomic operations.",29,null],[13,"Release","","When coupled with a store, all previous writes become visible\nto another thread that performs a load with `Acquire` ordering\non the same value.",29,null],[13,"Acquire","","When coupled with a load, all subsequent loads will see data\nwritten before a store with `Release` ordering on the same value\nin another thread.",29,null],[13,"AcqRel","","When coupled with a load, uses `Acquire` ordering, and with a store\n`Release` ordering.",29,null],[13,"SeqCst","","Like `AcqRel` with the additional guarantee that all threads see all\nsequentially consistent operations in the same order.",29,null],[17,"ATOMIC_BOOL_INIT","","An `AtomicBool` initialized to `false`.",null,null],[17,"ATOMIC_ISIZE_INIT","","An `AtomicIsize` initialized to `0`.",null,null],[17,"ATOMIC_USIZE_INIT","","An `AtomicUsize` initialized to `0`.",null,null],[5,"fence","","An atomic fence.",null,null],[3,"Barrier","std::sync","A barrier enables multiple threads to synchronize the beginning\nof some computation.",null,null],[3,"BarrierWaitResult","","A result returned from wait.",null,null],[3,"Condvar","","A Condition Variable",null,null],[3,"StaticCondvar","","Statically allocated condition variables.",null,null],[3,"Mutex","","A mutual exclusion primitive useful for protecting shared data",null,null],[3,"MutexGuard","","An RAII implementation of a \"scoped lock\" of a mutex. When this structure is\ndropped (falls out of scope), the lock will be unlocked.",null,null],[3,"StaticMutex","","The static mutex type is provided to allow for static allocation of mutexes.",null,null],[3,"Once","","A synchronization primitive which can be used to run a one-time global\ninitialization. Useful for one-time initialization for FFI or related\nfunctionality. This type can only be constructed with the `ONCE_INIT`\nvalue.",null,null],[3,"PoisonError","","A type of error which can be returned whenever a lock is acquired.",null,null],[3,"RwLockReadGuard","","RAII structure used to release the shared read access of a lock when\ndropped.",null,null],[3,"RwLockWriteGuard","","RAII structure used to release the exclusive write access of a lock when\ndropped.",null,null],[3,"RwLock","","A reader-writer lock",null,null],[3,"StaticRwLock","","Structure representing a statically allocated RwLock.",null,null],[3,"Semaphore","","A counting, blocking, semaphore.",null,null],[3,"SemaphoreGuard","","An RAII guard which will release a resource acquired from a semaphore when\ndropped.",null,null],[3,"Future","","A type encapsulating the result of a computation which may not be complete",null,null],[4,"TryLockError","","An enumeration of possible errors which can occur while calling the\n`try_lock` method.",null,null],[13,"Poisoned","","The lock could not be acquired because another thread failed while holding\nthe lock.",455,null],[13,"WouldBlock","","The lock could not be acquired at this time because the operation would\notherwise block.",455,null],[0,"mpsc","","Multi-producer, single-consumer FIFO queue communication primitives.",null,null],[3,"Select","std::sync::mpsc","The \"receiver set\" of the select interface. This structure is used to manage\na set of receivers which are being selected over.",null,null],[3,"Handle","","A handle to a receiver which is currently a member of a `Select` set of\nreceivers.  This handle is used to keep the receiver in the set as well as\ninteract with the underlying receiver.",null,null],[3,"Receiver","","The receiving-half of Rust's channel type. This half can only be owned by\none thread",null,null],[3,"Iter","","An iterator over messages on a receiver, this iterator will block\nwhenever `next` is called, waiting for a new message, and `None` will be\nreturned when the corresponding channel has hung up.",null,null],[3,"IntoIter","","An owning iterator over messages on a receiver, this iterator will block\nwhenever `next` is called, waiting for a new message, and `None` will be\nreturned when the corresponding channel has hung up.",null,null],[3,"Sender","","The sending-half of Rust's asynchronous channel type. This half can only be\nowned by one thread, but it can be cloned to send to other threads.",null,null],[3,"SyncSender","","The sending-half of Rust's synchronous channel type. This half can only be\nowned by one thread, but it can be cloned to send to other threads.",null,null],[3,"SendError","","An error returned from the `send` function on channels.",null,null],[3,"RecvError","","An error returned from the `recv` function on a `Receiver`.",null,null],[4,"TryRecvError","","This enumeration is the list of the possible reasons that `try_recv` could\nnot return data when called.",null,null],[13,"Empty","","This channel is currently empty, but the sender(s) have not yet\ndisconnected, so data may yet become available.",456,null],[13,"Disconnected","","This channel's sending half has become disconnected, and there will\nnever be any more data received on this channel",456,null],[4,"TrySendError","","This enumeration is the list of the possible error outcomes for the\n`SyncSender::try_send` method.",null,null],[13,"Full","","The data could not be sent on the channel because it would require that\nthe callee block to send the data.",457,null],[13,"Disconnected","","This channel's receiving half has disconnected, so the data could not be\nsent. The data is returned back to the callee in this case.",457,null],[5,"channel","","Creates a new asynchronous channel, returning the sender/receiver halves.",null,null],[5,"sync_channel","","Creates a new synchronous, bounded channel.",null,null],[11,"new","","Creates a new selection structure. This set is initially empty.",458,{"inputs":[{"name":"select"}],"output":{"name":"select"}}],[11,"handle","","Creates a new handle into this receiver set for a new receiver. Note\nthat this does *not* add the receiver to the receiver set, for that you\nmust call the `add` method on the handle itself.",458,{"inputs":[{"name":"select"},{"name":"receiver"}],"output":{"name":"handle"}}],[11,"wait","","Waits for an event on this receiver set. The returned value is *not* an\nindex, but rather an id. This id can be queried against any active\n`Handle` structures (each one has an `id` method). The handle with\nthe matching `id` will have some sort of event available on it. The\nevent could either be that data is available or the corresponding\nchannel has been closed.",458,{"inputs":[{"name":"select"}],"output":{"name":"usize"}}],[11,"id","","Retrieves the id of this handle.",459,{"inputs":[{"name":"handle"}],"output":{"name":"usize"}}],[11,"recv","","Blocks to receive a value on the underlying receiver, returning `Some` on\nsuccess or `None` if the channel disconnects. This function has the same\nsemantics as `Receiver.recv`",459,{"inputs":[{"name":"handle"}],"output":{"name":"result"}}],[11,"add","","Adds this handle to the receiver set that the handle was created from. This\nmethod can be called multiple times, but it has no effect if `add` was\ncalled previously.",459,{"inputs":[{"name":"handle"}],"output":null}],[11,"remove","","Removes this handle from the `Select` set. This method is unsafe because\nit has no guarantee that the `Handle` was not moved since `add` was\ncalled.",459,{"inputs":[{"name":"handle"}],"output":null}],[11,"drop","","",458,{"inputs":[{"name":"select"}],"output":null}],[11,"drop","","",459,{"inputs":[{"name":"handle"}],"output":null}],[11,"clone","","",460,{"inputs":[{"name":"senderror"}],"output":{"name":"senderror"}}],[11,"eq","","",460,{"inputs":[{"name":"senderror"},{"name":"senderror"}],"output":{"name":"bool"}}],[11,"ne","","",460,{"inputs":[{"name":"senderror"},{"name":"senderror"}],"output":{"name":"bool"}}],[11,"fmt","","",461,{"inputs":[{"name":"recverror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",461,{"inputs":[{"name":"recverror"}],"output":{"name":"recverror"}}],[11,"eq","","",461,{"inputs":[{"name":"recverror"},{"name":"recverror"}],"output":{"name":"bool"}}],[11,"ne","","",461,{"inputs":[{"name":"recverror"},{"name":"recverror"}],"output":{"name":"bool"}}],[11,"fmt","","",456,{"inputs":[{"name":"tryrecverror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",456,{"inputs":[{"name":"tryrecverror"}],"output":{"name":"tryrecverror"}}],[11,"eq","","",456,{"inputs":[{"name":"tryrecverror"},{"name":"tryrecverror"}],"output":{"name":"bool"}}],[11,"ne","","",456,{"inputs":[{"name":"tryrecverror"},{"name":"tryrecverror"}],"output":{"name":"bool"}}],[11,"clone","","",457,{"inputs":[{"name":"trysenderror"}],"output":{"name":"trysenderror"}}],[11,"eq","","",457,{"inputs":[{"name":"trysenderror"},{"name":"trysenderror"}],"output":{"name":"bool"}}],[11,"ne","","",457,{"inputs":[{"name":"trysenderror"},{"name":"trysenderror"}],"output":{"name":"bool"}}],[11,"send","","Attempts to send a value on this channel, returning it back if it could\nnot be sent.",462,{"inputs":[{"name":"sender"},{"name":"t"}],"output":{"name":"result"}}],[11,"clone","","",462,{"inputs":[{"name":"sender"}],"output":{"name":"sender"}}],[11,"drop","","",462,{"inputs":[{"name":"sender"}],"output":null}],[11,"send","","Sends a value on this synchronous channel.",463,{"inputs":[{"name":"syncsender"},{"name":"t"}],"output":{"name":"result"}}],[11,"try_send","","Attempts to send a value on this channel without blocking.",463,{"inputs":[{"name":"syncsender"},{"name":"t"}],"output":{"name":"result"}}],[11,"clone","","",463,{"inputs":[{"name":"syncsender"}],"output":{"name":"syncsender"}}],[11,"drop","","",463,{"inputs":[{"name":"syncsender"}],"output":null}],[11,"try_recv","","Attempts to return a pending value on this receiver without blocking",464,{"inputs":[{"name":"receiver"}],"output":{"name":"result"}}],[11,"recv","","Attempts to wait for a value on this receiver, returning an error if the\ncorresponding channel has hung up.",464,{"inputs":[{"name":"receiver"}],"output":{"name":"result"}}],[11,"iter","","Returns an iterator that will block waiting for messages, but never\n`panic!`. It will return `None` when the channel has hung up.",464,{"inputs":[{"name":"receiver"}],"output":{"name":"iter"}}],[11,"next","","",465,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"next","","",466,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"into_iter","","",464,{"inputs":[{"name":"receiver"}],"output":{"name":"intoiter"}}],[11,"drop","","",464,{"inputs":[{"name":"receiver"}],"output":null}],[11,"fmt","","",460,{"inputs":[{"name":"senderror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",460,{"inputs":[{"name":"senderror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"description","","",460,{"inputs":[{"name":"senderror"}],"output":{"name":"str"}}],[11,"cause","","",460,{"inputs":[{"name":"senderror"}],"output":{"name":"option"}}],[11,"fmt","","",457,{"inputs":[{"name":"trysenderror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",457,{"inputs":[{"name":"trysenderror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"description","","",457,{"inputs":[{"name":"trysenderror"}],"output":{"name":"str"}}],[11,"cause","","",457,{"inputs":[{"name":"trysenderror"}],"output":{"name":"option"}}],[11,"fmt","","",461,{"inputs":[{"name":"recverror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"description","","",461,{"inputs":[{"name":"recverror"}],"output":{"name":"str"}}],[11,"cause","","",461,{"inputs":[{"name":"recverror"}],"output":{"name":"option"}}],[11,"fmt","","",456,{"inputs":[{"name":"tryrecverror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"description","","",456,{"inputs":[{"name":"tryrecverror"}],"output":{"name":"str"}}],[11,"cause","","",456,{"inputs":[{"name":"tryrecverror"}],"output":{"name":"option"}}],[11,"new","std::sync","Creates a new barrier that can block a given number of threads.",467,{"inputs":[{"name":"barrier"},{"name":"usize"}],"output":{"name":"barrier"}}],[11,"wait","","Blocks the current thread until all threads has rendezvoused here.",467,{"inputs":[{"name":"barrier"}],"output":{"name":"barrierwaitresult"}}],[11,"is_leader","","Returns whether this thread from `wait` is the \"leader thread\".",468,{"inputs":[{"name":"barrierwaitresult"}],"output":{"name":"bool"}}],[11,"new","","Creates a new condition variable which is ready to be waited on and\nnotified.",469,{"inputs":[{"name":"condvar"}],"output":{"name":"condvar"}}],[11,"wait","","Blocks the current thread until this condition variable receives a\nnotification.",469,{"inputs":[{"name":"condvar"},{"name":"mutexguard"}],"output":{"name":"lockresult"}}],[11,"wait_timeout_ms","","Waits on this condition variable for a notification, timing out after a\nspecified duration.",469,{"inputs":[{"name":"condvar"},{"name":"mutexguard"},{"name":"u32"}],"output":{"name":"lockresult"}}],[11,"wait_timeout","","Waits on this condition variable for a notification, timing out after a\nspecified duration.",469,{"inputs":[{"name":"condvar"},{"name":"mutexguard"},{"name":"duration"}],"output":{"name":"lockresult"}}],[11,"wait_timeout_with","","Waits on this condition variable for a notification, timing out after a\nspecified duration.",469,{"inputs":[{"name":"condvar"},{"name":"mutexguard"},{"name":"duration"},{"name":"f"}],"output":{"name":"lockresult"}}],[11,"notify_one","","Wakes up one blocked thread on this condvar.",469,{"inputs":[{"name":"condvar"}],"output":null}],[11,"notify_all","","Wakes up all blocked threads on this condvar.",469,{"inputs":[{"name":"condvar"}],"output":null}],[11,"drop","","",469,{"inputs":[{"name":"condvar"}],"output":null}],[11,"new","","Creates a new condition variable",470,{"inputs":[{"name":"staticcondvar"}],"output":{"name":"staticcondvar"}}],[11,"wait","","Blocks the current thread until this condition variable receives a\nnotification.",470,{"inputs":[{"name":"staticcondvar"},{"name":"mutexguard"}],"output":{"name":"lockresult"}}],[11,"wait_timeout_ms","","Waits on this condition variable for a notification, timing out after a\nspecified duration.",470,{"inputs":[{"name":"staticcondvar"},{"name":"mutexguard"},{"name":"u32"}],"output":{"name":"lockresult"}}],[11,"wait_timeout","","Waits on this condition variable for a notification, timing out after a\nspecified duration.",470,{"inputs":[{"name":"staticcondvar"},{"name":"mutexguard"},{"name":"duration"}],"output":{"name":"lockresult"}}],[11,"wait_timeout_with","","Waits on this condition variable for a notification, timing out after a\nspecified duration.",470,{"inputs":[{"name":"staticcondvar"},{"name":"mutexguard"},{"name":"duration"},{"name":"f"}],"output":{"name":"lockresult"}}],[11,"notify_one","","Wakes up one blocked thread on this condvar.",470,{"inputs":[{"name":"staticcondvar"}],"output":null}],[11,"notify_all","","Wakes up all blocked threads on this condvar.",470,{"inputs":[{"name":"staticcondvar"}],"output":null}],[11,"destroy","","Deallocates all resources associated with this static condvar.",470,{"inputs":[{"name":"staticcondvar"}],"output":null}],[11,"get","","Get the value of the future.",471,{"inputs":[{"name":"future"}],"output":{"name":"a"}}],[11,"into_inner","","Gets the value from this future, forcing evaluation.",471,{"inputs":[{"name":"future"}],"output":{"name":"a"}}],[11,"get_ref","","Executes the future's closure and then returns a reference\nto the result.  The reference lasts as long as\nthe future.",471,{"inputs":[{"name":"future"}],"output":{"name":"a"}}],[11,"from_value","","Create a future from a value.",471,{"inputs":[{"name":"future"},{"name":"a"}],"output":{"name":"future"}}],[11,"from_fn","","Create a future from a function.",471,{"inputs":[{"name":"future"},{"name":"f"}],"output":{"name":"future"}}],[11,"from_receiver","","Create a future from a port",471,{"inputs":[{"name":"future"},{"name":"receiver"}],"output":{"name":"future"}}],[11,"spawn","","Create a future from a unique closure.",471,{"inputs":[{"name":"future"},{"name":"f"}],"output":{"name":"future"}}],[11,"new","","Creates a new mutex in an unlocked state ready for use.",472,{"inputs":[{"name":"mutex"},{"name":"t"}],"output":{"name":"mutex"}}],[11,"lock","","Acquires a mutex, blocking the current thread until it is able to do so.",472,{"inputs":[{"name":"mutex"}],"output":{"name":"lockresult"}}],[11,"try_lock","","Attempts to acquire this lock.",472,{"inputs":[{"name":"mutex"}],"output":{"name":"trylockresult"}}],[11,"is_poisoned","","Determines whether the lock is poisoned.",472,{"inputs":[{"name":"mutex"}],"output":{"name":"bool"}}],[11,"drop","","",472,{"inputs":[{"name":"mutex"}],"output":null}],[11,"fmt","","",472,{"inputs":[{"name":"mutex"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","Creates a new mutex in an unlocked state ready for use.",473,{"inputs":[{"name":"staticmutex"}],"output":{"name":"staticmutex"}}],[11,"lock","","Acquires this lock, see `Mutex::lock`",473,{"inputs":[{"name":"staticmutex"}],"output":{"name":"lockresult"}}],[11,"try_lock","","Attempts to grab this lock, see `Mutex::try_lock`",473,{"inputs":[{"name":"staticmutex"}],"output":{"name":"trylockresult"}}],[11,"destroy","","Deallocates resources associated with this static mutex.",473,{"inputs":[{"name":"staticmutex"}],"output":null}],[11,"deref","","",474,{"inputs":[{"name":"mutexguard"}],"output":{"name":"t"}}],[11,"deref_mut","","",474,{"inputs":[{"name":"mutexguard"}],"output":{"name":"t"}}],[11,"drop","","",474,{"inputs":[{"name":"mutexguard"}],"output":null}],[11,"new","","Creates a new `Once` value.",475,{"inputs":[{"name":"once"}],"output":{"name":"once"}}],[11,"call_once","","Performs an initialization routine once and only once. The given closure\nwill be executed if this is the first time `call_once` has been called,\nand otherwise the routine will *not* be invoked.",475,{"inputs":[{"name":"once"},{"name":"f"}],"output":null}],[11,"new","","Creates a new instance of an `RwLock<T>` which is unlocked.",476,{"inputs":[{"name":"rwlock"},{"name":"t"}],"output":{"name":"rwlock"}}],[11,"read","","Locks this rwlock with shared read access, blocking the current thread\nuntil it can be acquired.",476,{"inputs":[{"name":"rwlock"}],"output":{"name":"lockresult"}}],[11,"try_read","","Attempts to acquire this rwlock with shared read access.",476,{"inputs":[{"name":"rwlock"}],"output":{"name":"trylockresult"}}],[11,"write","","Locks this rwlock with exclusive write access, blocking the current\nthread until it can be acquired.",476,{"inputs":[{"name":"rwlock"}],"output":{"name":"lockresult"}}],[11,"try_write","","Attempts to lock this rwlock with exclusive write access.",476,{"inputs":[{"name":"rwlock"}],"output":{"name":"trylockresult"}}],[11,"is_poisoned","","Determines whether the lock is poisoned.",476,{"inputs":[{"name":"rwlock"}],"output":{"name":"bool"}}],[11,"drop","","",476,{"inputs":[{"name":"rwlock"}],"output":null}],[11,"fmt","","",476,{"inputs":[{"name":"rwlock"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","Creates a new rwlock.",477,{"inputs":[{"name":"staticrwlock"}],"output":{"name":"staticrwlock"}}],[11,"read","","Locks this rwlock with shared read access, blocking the current thread\nuntil it can be acquired.",477,{"inputs":[{"name":"staticrwlock"}],"output":{"name":"lockresult"}}],[11,"try_read","","Attempts to acquire this lock with shared read access.",477,{"inputs":[{"name":"staticrwlock"}],"output":{"name":"trylockresult"}}],[11,"write","","Locks this rwlock with exclusive write access, blocking the current\nthread until it can be acquired.",477,{"inputs":[{"name":"staticrwlock"}],"output":{"name":"lockresult"}}],[11,"try_write","","Attempts to lock this rwlock with exclusive write access.",477,{"inputs":[{"name":"staticrwlock"}],"output":{"name":"trylockresult"}}],[11,"destroy","","Deallocates all resources associated with this static lock.",477,{"inputs":[{"name":"staticrwlock"}],"output":null}],[11,"deref","","",478,{"inputs":[{"name":"rwlockreadguard"}],"output":{"name":"t"}}],[11,"deref","","",479,{"inputs":[{"name":"rwlockwriteguard"}],"output":{"name":"t"}}],[11,"deref_mut","","",479,{"inputs":[{"name":"rwlockwriteguard"}],"output":{"name":"t"}}],[11,"drop","","",478,{"inputs":[{"name":"rwlockreadguard"}],"output":null}],[11,"drop","","",479,{"inputs":[{"name":"rwlockwriteguard"}],"output":null}],[11,"new","","Creates a new semaphore with the initial count specified.",480,{"inputs":[{"name":"semaphore"},{"name":"isize"}],"output":{"name":"semaphore"}}],[11,"acquire","","Acquires a resource of this semaphore, blocking the current thread until\nit can do so.",480,{"inputs":[{"name":"semaphore"}],"output":null}],[11,"release","","Release a resource from this semaphore.",480,{"inputs":[{"name":"semaphore"}],"output":null}],[11,"access","","Acquires a resource of this semaphore, returning an RAII guard to\nrelease the semaphore when dropped.",480,{"inputs":[{"name":"semaphore"}],"output":{"name":"semaphoreguard"}}],[11,"drop","","",481,{"inputs":[{"name":"semaphoreguard"}],"output":null}],[6,"TryLockResult","","A type alias for the result of a nonblocking locking method.",null,null],[6,"LockResult","","A type alias for the result of a lock method which can be poisoned.",null,null],[17,"CONDVAR_INIT","","Constant initializer for a statically allocated condition variable.",null,null],[17,"MUTEX_INIT","","Static initialization of a mutex. This constant can be used to initialize\nother mutex constants.",null,null],[17,"ONCE_INIT","","Initialization value for static `Once` values.",null,null],[17,"RW_LOCK_INIT","","Constant initialization for a statically-initialized rwlock.",null,null],[0,"time","std","Temporal quantification.",null,null],[3,"Duration","std::time","A duration type to represent a span of time, typically used for system\ntimeouts.",null,null],[11,"fmt","","",482,{"inputs":[{"name":"duration"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"cmp","","",482,{"inputs":[{"name":"duration"},{"name":"duration"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",482,{"inputs":[{"name":"duration"},{"name":"duration"}],"output":{"name":"option"}}],[11,"lt","","",482,{"inputs":[{"name":"duration"},{"name":"duration"}],"output":{"name":"bool"}}],[11,"le","","",482,{"inputs":[{"name":"duration"},{"name":"duration"}],"output":{"name":"bool"}}],[11,"gt","","",482,{"inputs":[{"name":"duration"},{"name":"duration"}],"output":{"name":"bool"}}],[11,"ge","","",482,{"inputs":[{"name":"duration"},{"name":"duration"}],"output":{"name":"bool"}}],[11,"eq","","",482,{"inputs":[{"name":"duration"},{"name":"duration"}],"output":{"name":"bool"}}],[11,"ne","","",482,{"inputs":[{"name":"duration"},{"name":"duration"}],"output":{"name":"bool"}}],[11,"clone","","",482,{"inputs":[{"name":"duration"}],"output":{"name":"duration"}}],[11,"new","","Crates a new `Duration` from the specified number of seconds and\nadditional nanosecond precision.",482,{"inputs":[{"name":"duration"},{"name":"u64"},{"name":"u32"}],"output":{"name":"duration"}}],[11,"span","","Runs a closure, returning the duration of time it took to run the\nclosure.",482,{"inputs":[{"name":"duration"},{"name":"f"}],"output":{"name":"duration"}}],[11,"from_secs","","Creates a new `Duration` from the specified number of seconds.",482,{"inputs":[{"name":"duration"},{"name":"u64"}],"output":{"name":"duration"}}],[11,"from_millis","","Creates a new `Duration` from the specified number of milliseconds.",482,{"inputs":[{"name":"duration"},{"name":"u64"}],"output":{"name":"duration"}}],[11,"as_secs","","Returns the number of whole seconds represented by this duration.",482,{"inputs":[{"name":"duration"}],"output":{"name":"u64"}}],[11,"secs","","Returns the number of whole seconds represented by this duration.",482,{"inputs":[{"name":"duration"}],"output":{"name":"u64"}}],[11,"subsec_nanos","","Returns the nanosecond precision represented by this duration.",482,{"inputs":[{"name":"duration"}],"output":{"name":"u32"}}],[11,"extra_nanos","","Returns the nanosecond precision represented by this duration.",482,{"inputs":[{"name":"duration"}],"output":{"name":"u32"}}],[11,"add","","",482,{"inputs":[{"name":"duration"},{"name":"duration"}],"output":{"name":"duration"}}],[11,"sub","","",482,{"inputs":[{"name":"duration"},{"name":"duration"}],"output":{"name":"duration"}}],[11,"mul","","",482,{"inputs":[{"name":"duration"},{"name":"u32"}],"output":{"name":"duration"}}],[11,"div","","",482,{"inputs":[{"name":"duration"},{"name":"u32"}],"output":{"name":"duration"}}],[11,"fmt","std::sync","",483,{"inputs":[{"name":"poisonerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",483,{"inputs":[{"name":"poisonerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"description","","",483,{"inputs":[{"name":"poisonerror"}],"output":{"name":"str"}}],[11,"new","","Creates a `PoisonError`.",483,{"inputs":[{"name":"poisonerror"},{"name":"t"}],"output":{"name":"poisonerror"}}],[11,"into_inner","","Consumes this error indicating that a lock is poisoned, returning the\nunderlying guard to allow access regardless.",483,{"inputs":[{"name":"poisonerror"}],"output":{"name":"t"}}],[11,"get_ref","","Reaches into this error indicating that a lock is poisoned, returning a\nreference to the underlying guard to allow access regardless.",483,{"inputs":[{"name":"poisonerror"}],"output":{"name":"t"}}],[11,"get_mut","","Reaches into this error indicating that a lock is poisoned, returning a\nmutable reference to the underlying guard to allow access regardless.",483,{"inputs":[{"name":"poisonerror"}],"output":{"name":"t"}}],[11,"from","","",455,{"inputs":[{"name":"trylockerror"},{"name":"poisonerror"}],"output":{"name":"trylockerror"}}],[11,"fmt","","",455,{"inputs":[{"name":"trylockerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",455,{"inputs":[{"name":"trylockerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"description","","",455,{"inputs":[{"name":"trylockerror"}],"output":{"name":"str"}}],[11,"cause","","",455,{"inputs":[{"name":"trylockerror"}],"output":{"name":"option"}}],[11,"as_raw_fd","std::fs","",372,{"inputs":[{"name":"file"}],"output":{"name":"rawfd"}}],[11,"from_raw_fd","","",372,{"inputs":[{"name":"file"},{"name":"rawfd"}],"output":{"name":"file"}}],[11,"into_raw_fd","","",372,{"inputs":[{"name":"file"}],"output":{"name":"rawfd"}}],[11,"as_raw_fd","std::net","",417,{"inputs":[{"name":"tcpstream"}],"output":{"name":"rawfd"}}],[11,"as_raw_fd","","",418,{"inputs":[{"name":"tcplistener"}],"output":{"name":"rawfd"}}],[11,"as_raw_fd","","",420,{"inputs":[{"name":"udpsocket"}],"output":{"name":"rawfd"}}],[11,"from_raw_fd","","",417,{"inputs":[{"name":"tcpstream"},{"name":"rawfd"}],"output":{"name":"tcpstream"}}],[11,"from_raw_fd","","",418,{"inputs":[{"name":"tcplistener"},{"name":"rawfd"}],"output":{"name":"tcplistener"}}],[11,"from_raw_fd","","",420,{"inputs":[{"name":"udpsocket"},{"name":"rawfd"}],"output":{"name":"udpsocket"}}],[11,"into_raw_fd","","",417,{"inputs":[{"name":"tcpstream"}],"output":{"name":"rawfd"}}],[11,"into_raw_fd","","",418,{"inputs":[{"name":"tcplistener"}],"output":{"name":"rawfd"}}],[11,"into_raw_fd","","",420,{"inputs":[{"name":"udpsocket"}],"output":{"name":"rawfd"}}],[11,"from_vec","std::ffi","",366,{"inputs":[{"name":"osstring"},{"name":"vec"}],"output":{"name":"osstring"}}],[11,"into_vec","","",366,{"inputs":[{"name":"osstring"}],"output":{"name":"vec"}}],[11,"from_bytes","","",367,null],[11,"as_bytes","","",367,null],[11,"mode","std::fs","",370,{"inputs":[{"name":"permissions"}],"output":{"name":"mode_t"}}],[11,"set_mode","","",370,{"inputs":[{"name":"permissions"},{"name":"mode_t"}],"output":null}],[11,"from_mode","","",370,{"inputs":[{"name":"permissions"},{"name":"mode_t"}],"output":{"name":"permissions"}}],[11,"mode","","",369,{"inputs":[{"name":"openoptions"},{"name":"mode_t"}],"output":{"name":"openoptions"}}],[11,"dev","","",373,{"inputs":[{"name":"metadata"}],"output":{"name":"dev_t"}}],[11,"ino","","",373,{"inputs":[{"name":"metadata"}],"output":{"name":"ino_t"}}],[11,"mode","","",373,{"inputs":[{"name":"metadata"}],"output":{"name":"mode_t"}}],[11,"nlink","","",373,{"inputs":[{"name":"metadata"}],"output":{"name":"nlink_t"}}],[11,"uid","","",373,{"inputs":[{"name":"metadata"}],"output":{"name":"uid_t"}}],[11,"gid","","",373,{"inputs":[{"name":"metadata"}],"output":{"name":"gid_t"}}],[11,"rdev","","",373,{"inputs":[{"name":"metadata"}],"output":{"name":"dev_t"}}],[11,"size","","",373,{"inputs":[{"name":"metadata"}],"output":{"name":"off_t"}}],[11,"atime","","",373,{"inputs":[{"name":"metadata"}],"output":{"name":"time_t"}}],[11,"atime_nsec","","",373,{"inputs":[{"name":"metadata"}],"output":{"name":"c_long"}}],[11,"mtime","","",373,{"inputs":[{"name":"metadata"}],"output":{"name":"time_t"}}],[11,"mtime_nsec","","",373,{"inputs":[{"name":"metadata"}],"output":{"name":"c_long"}}],[11,"ctime","","",373,{"inputs":[{"name":"metadata"}],"output":{"name":"time_t"}}],[11,"ctime_nsec","","",373,{"inputs":[{"name":"metadata"}],"output":{"name":"c_long"}}],[11,"blksize","","",373,{"inputs":[{"name":"metadata"}],"output":{"name":"blksize_t"}}],[11,"blocks","","",373,{"inputs":[{"name":"metadata"}],"output":{"name":"blkcnt_t"}}],[11,"is_block_device","","",371,{"inputs":[{"name":"filetype"}],"output":{"name":"bool"}}],[11,"is_char_device","","",371,{"inputs":[{"name":"filetype"}],"output":{"name":"bool"}}],[11,"is_fifo","","",371,{"inputs":[{"name":"filetype"}],"output":{"name":"bool"}}],[11,"is_socket","","",371,{"inputs":[{"name":"filetype"}],"output":{"name":"bool"}}],[11,"ino","","",375,{"inputs":[{"name":"direntry"}],"output":{"name":"ino_t"}}],[11,"mode","","",377,{"inputs":[{"name":"dirbuilder"},{"name":"mode_t"}],"output":{"name":"dirbuilder"}}],[11,"uid","std::process","",452,{"inputs":[{"name":"command"},{"name":"uid_t"}],"output":{"name":"command"}}],[11,"gid","","",452,{"inputs":[{"name":"command"},{"name":"gid_t"}],"output":{"name":"command"}}],[11,"signal","","",454,{"inputs":[{"name":"exitstatus"}],"output":{"name":"option"}}],[11,"from_raw_fd","","",453,{"inputs":[{"name":"stdio"},{"name":"rawfd"}],"output":{"name":"stdio"}}],[11,"as_raw_fd","","",449,{"inputs":[{"name":"childstdin"}],"output":{"name":"rawfd"}}],[11,"as_raw_fd","","",450,{"inputs":[{"name":"childstdout"}],"output":{"name":"rawfd"}}],[11,"as_raw_fd","","",451,{"inputs":[{"name":"childstderr"}],"output":{"name":"rawfd"}}],[11,"into_raw_fd","","",449,{"inputs":[{"name":"childstdin"}],"output":{"name":"rawfd"}}],[11,"into_raw_fd","","",450,{"inputs":[{"name":"childstdout"}],"output":{"name":"rawfd"}}],[11,"into_raw_fd","","",451,{"inputs":[{"name":"childstderr"}],"output":{"name":"rawfd"}}],[11,"as_raw_stat","std::fs","",373,{"inputs":[{"name":"metadata"}],"output":{"name":"stat"}}],[0,"rt","std","Runtime services",null,null],[0,"heap","std::rt","",null,null],[5,"allocate","std::rt::heap","Return a pointer to `size` bytes of memory aligned to `align`.",null,null],[5,"reallocate","","Resize the allocation referenced by `ptr` to `size` bytes.",null,null],[5,"reallocate_inplace","","Resize the allocation referenced by `ptr` to `size` bytes.",null,null],[5,"deallocate","","Deallocates the memory referenced by `ptr`.",null,null],[5,"usable_size","","Returns the usable size of an allocation created with the specified the\n`size` and `align`.",null,{"inputs":[{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[5,"stats_print","","Prints implementation-defined allocator statistics.",null,null],[17,"EMPTY","","An arbitrary non-null address to represent zero-size allocations.",null,null],[5,"at_exit","std::rt","Enqueues a procedure to run when the main thread exits.",null,{"inputs":[{"name":"f"}],"output":{"name":"result"}}],[5,"cleanup","","One-time runtime cleanup.",null,{"inputs":[],"output":null}],[0,"backtrace","","Simple backtrace functionality (to print on panic)",null,null],[5,"write","std::rt::backtrace","",null,{"inputs":[{"name":"write"}],"output":{"name":"result"}}],[5,"log_enabled","","",null,{"inputs":[],"output":{"name":"bool"}}],[0,"util","std::rt","",null,null],[5,"min_stack","std::rt::util","",null,{"inputs":[],"output":{"name":"usize"}}],[5,"dumb_print","","",null,{"inputs":[{"name":"arguments"}],"output":null}],[5,"abort","","",null,{"inputs":[{"name":"arguments"}],"output":null}],[5,"report_overflow","","",null,{"inputs":[],"output":null}],[17,"ENFORCE_SANITY","","",null,null],[0,"unwind","std::rt","Implementation of Rust stack unwinding",null,null],[5,"try","std::rt::unwind","Invoke a closure, capturing the cause of panic if one occurs.",null,{"inputs":[{"name":"f"}],"output":{"name":"result"}}],[5,"panicking","","Determines whether the current thread is unwinding because of panic.",null,{"inputs":[],"output":{"name":"bool"}}],[5,"rust_begin_unwind","","Entry point of panic from the libcore crate.",null,{"inputs":[{"name":"arguments"},{"name":"str"},{"name":"u32"}],"output":null}],[5,"begin_unwind_fmt","","The entry point for unwinding with a formatted message.",null,null],[5,"begin_unwind","","This is the entry point of unwinding for panic!() and assert!().",null,null],[5,"register","","Register a callback to be invoked when a thread unwinds.",null,{"inputs":[{"name":"callback"}],"output":{"name":"bool"}}],[6,"Callback","","",null,null],[0,"args","std::rt","Global storage for command line arguments",null,null],[5,"init","std::rt::args","One-time global initialization.",null,null],[5,"cleanup","","One-time global cleanup.",null,{"inputs":[],"output":null}],[5,"take","","Take the global arguments from global storage.",null,{"inputs":[],"output":{"name":"option"}}],[5,"put","","Give the global arguments to global storage.",null,{"inputs":[{"name":"vec"}],"output":null}],[5,"clone","","Make a clone of the global arguments.",null,{"inputs":[],"output":{"name":"option"}}],[17,"DEFAULT_ERROR_CODE","std::rt","The default error code of the rust runtime if the main thread panics instead\nof exiting cleanly.",null,null],[11,"next_u64","std::rand","Return the next random u64.",484,{"inputs":[{"name":"rng"}],"output":{"name":"u64"}}],[11,"next_f32","","Return the next random f32 selected from the half-open\ninterval `[0, 1)`.",484,{"inputs":[{"name":"rng"}],"output":{"name":"f32"}}],[11,"next_f64","","Return the next random f64 selected from the half-open\ninterval `[0, 1)`.",484,{"inputs":[{"name":"rng"}],"output":{"name":"f64"}}],[11,"fill_bytes","","Fill `dest` with random data.",484,null],[11,"gen","","Return a random value of a `Rand` type.",484,{"inputs":[{"name":"rng"}],"output":{"name":"t"}}],[11,"gen_iter","","Return an iterator that will yield an infinite number of randomly\ngenerated items.",484,{"inputs":[{"name":"rng"}],"output":{"name":"generator"}}],[11,"gen_range","","Generate a random value in the range [`low`, `high`).",484,{"inputs":[{"name":"rng"},{"name":"t"},{"name":"t"}],"output":{"name":"t"}}],[11,"gen_weighted_bool","","Return a bool with a 1 in n chance of true",484,{"inputs":[{"name":"rng"},{"name":"usize"}],"output":{"name":"bool"}}],[11,"gen_ascii_chars","","Return an iterator of random characters from the set A-Z,a-z,0-9.",484,{"inputs":[{"name":"rng"}],"output":{"name":"asciigenerator"}}],[11,"choose","","Return a random element from `values`.",484,null],[11,"shuffle","","Shuffle a mutable slice in place.",484,null],[11,"new_unseeded","rand","Creates a new XorShiftRng instance which is not seeded.",485,{"inputs":[{"name":"xorshiftrng"}],"output":{"name":"xorshiftrng"}}],[11,"new","rand::distributions::range","Create a new `Range` instance that samples uniformly from\n`[low, high)`. Panics if `low >= high`.",486,{"inputs":[{"name":"range"},{"name":"x"},{"name":"x"}],"output":{"name":"range"}}],[11,"sample","","",486,{"inputs":[{"name":"range"},{"name":"r"}],"output":{"name":"sup"}}],[11,"ind_sample","","",486,{"inputs":[{"name":"range"},{"name":"r"}],"output":{"name":"sup"}}],[11,"new","rand::distributions::gamma","Construct an object representing the `Gamma(shape, scale)`\ndistribution.",487,{"inputs":[{"name":"gamma"},{"name":"f64"},{"name":"f64"}],"output":{"name":"gamma"}}],[11,"sample","","",487,{"inputs":[{"name":"gamma"},{"name":"r"}],"output":{"name":"f64"}}],[11,"sample","","",488,{"inputs":[{"name":"gammasmallshape"},{"name":"r"}],"output":{"name":"f64"}}],[11,"sample","","",489,{"inputs":[{"name":"gammalargeshape"},{"name":"r"}],"output":{"name":"f64"}}],[11,"ind_sample","","",487,{"inputs":[{"name":"gamma"},{"name":"r"}],"output":{"name":"f64"}}],[11,"ind_sample","","",488,{"inputs":[{"name":"gammasmallshape"},{"name":"r"}],"output":{"name":"f64"}}],[11,"ind_sample","","",489,{"inputs":[{"name":"gammalargeshape"},{"name":"r"}],"output":{"name":"f64"}}],[11,"new","","Create a new chi-squared distribution with degrees-of-freedom\n`k`. Panics if `k < 0`.",490,{"inputs":[{"name":"chisquared"},{"name":"f64"}],"output":{"name":"chisquared"}}],[11,"sample","","",490,{"inputs":[{"name":"chisquared"},{"name":"r"}],"output":{"name":"f64"}}],[11,"ind_sample","","",490,{"inputs":[{"name":"chisquared"},{"name":"r"}],"output":{"name":"f64"}}],[11,"new","","Create a new `FisherF` distribution, with the given\nparameter. Panics if either `m` or `n` are not positive.",491,{"inputs":[{"name":"fisherf"},{"name":"f64"},{"name":"f64"}],"output":{"name":"fisherf"}}],[11,"sample","","",491,{"inputs":[{"name":"fisherf"},{"name":"r"}],"output":{"name":"f64"}}],[11,"ind_sample","","",491,{"inputs":[{"name":"fisherf"},{"name":"r"}],"output":{"name":"f64"}}],[11,"new","","Create a new Student t distribution with `n` degrees of\nfreedom. Panics if `n <= 0`.",492,{"inputs":[{"name":"studentt"},{"name":"f64"}],"output":{"name":"studentt"}}],[11,"sample","","",492,{"inputs":[{"name":"studentt"},{"name":"r"}],"output":{"name":"f64"}}],[11,"ind_sample","","",492,{"inputs":[{"name":"studentt"},{"name":"r"}],"output":{"name":"f64"}}],[11,"clone","rand::distributions::normal","",493,{"inputs":[{"name":"standardnormal"}],"output":{"name":"standardnormal"}}],[11,"clone","","",494,{"inputs":[{"name":"normal"}],"output":{"name":"normal"}}],[11,"new","","Construct a new `Normal` distribution with the given mean and\nstandard deviation.",494,{"inputs":[{"name":"normal"},{"name":"f64"},{"name":"f64"}],"output":{"name":"normal"}}],[11,"sample","","",494,{"inputs":[{"name":"normal"},{"name":"r"}],"output":{"name":"f64"}}],[11,"ind_sample","","",494,{"inputs":[{"name":"normal"},{"name":"r"}],"output":{"name":"f64"}}],[11,"clone","","",495,{"inputs":[{"name":"lognormal"}],"output":{"name":"lognormal"}}],[11,"new","","Construct a new `LogNormal` distribution with the given mean\nand standard deviation.",495,{"inputs":[{"name":"lognormal"},{"name":"f64"},{"name":"f64"}],"output":{"name":"lognormal"}}],[11,"sample","","",495,{"inputs":[{"name":"lognormal"},{"name":"r"}],"output":{"name":"f64"}}],[11,"ind_sample","","",495,{"inputs":[{"name":"lognormal"},{"name":"r"}],"output":{"name":"f64"}}],[11,"clone","rand::distributions::exponential","",496,{"inputs":[{"name":"exp1"}],"output":{"name":"exp1"}}],[11,"clone","","",497,{"inputs":[{"name":"exp"}],"output":{"name":"exp"}}],[11,"new","","Construct a new `Exp` with the given shape parameter\n`lambda`. Panics if `lambda <= 0`.",497,{"inputs":[{"name":"exp"},{"name":"f64"}],"output":{"name":"exp"}}],[11,"sample","","",497,{"inputs":[{"name":"exp"},{"name":"r"}],"output":{"name":"f64"}}],[11,"ind_sample","","",497,{"inputs":[{"name":"exp"},{"name":"r"}],"output":{"name":"f64"}}],[11,"new","rand::distributions","",498,{"inputs":[{"name":"randsample"}],"output":{"name":"randsample"}}],[11,"sample","","",498,{"inputs":[{"name":"randsample"},{"name":"r"}],"output":{"name":"sup"}}],[11,"ind_sample","","",498,{"inputs":[{"name":"randsample"},{"name":"r"}],"output":{"name":"sup"}}],[11,"new","","Create a new `WeightedChoice`.",499,null],[11,"sample","","",499,{"inputs":[{"name":"weightedchoice"},{"name":"r"}],"output":{"name":"t"}}],[11,"ind_sample","","",499,{"inputs":[{"name":"weightedchoice"},{"name":"r"}],"output":{"name":"t"}}],[11,"new_unseeded","rand::isaac","Create an ISAAC random number generator using the default\nfixed seed.",500,{"inputs":[{"name":"isaacrng"}],"output":{"name":"isaacrng"}}],[11,"clone","","",500,{"inputs":[{"name":"isaacrng"}],"output":{"name":"isaacrng"}}],[11,"next_u32","","",500,{"inputs":[{"name":"isaacrng"}],"output":{"name":"u32"}}],[11,"reseed","","",500,null],[11,"from_seed","","Create an ISAAC random number generator with a seed. This can\nbe any length, although the maximum number of elements used is\n256 and any more will be silently ignored. A generator\nconstructed with a given seed will generate the same sequence\nof values as all other generators constructed with that seed.",500,null],[11,"new_unseeded","","Create a 64-bit ISAAC random number generator using the\ndefault fixed seed.",501,{"inputs":[{"name":"isaac64rng"}],"output":{"name":"isaac64rng"}}],[11,"clone","","",501,{"inputs":[{"name":"isaac64rng"}],"output":{"name":"isaac64rng"}}],[11,"next_u32","","",501,{"inputs":[{"name":"isaac64rng"}],"output":{"name":"u32"}}],[11,"next_u64","","",501,{"inputs":[{"name":"isaac64rng"}],"output":{"name":"u64"}}],[11,"reseed","","",501,null],[11,"from_seed","","Create an ISAAC random number generator with a seed. This can\nbe any length, although the maximum number of elements used is\n256 and any more will be silently ignored. A generator\nconstructed with a given seed will generate the same sequence\nof values as all other generators constructed with that seed.",501,null],[11,"clone","rand::chacha","",502,{"inputs":[{"name":"chacharng"}],"output":{"name":"chacharng"}}],[11,"new_unseeded","","Create an ChaCha random number generator using the default\nfixed key of 8 zero words.",502,{"inputs":[{"name":"chacharng"}],"output":{"name":"chacharng"}}],[11,"set_counter","","Sets the internal 128-bit ChaCha counter to\na user-provided value. This permits jumping\narbitrarily ahead (or backwards) in the pseudorandom stream.",502,null],[11,"next_u32","","",502,{"inputs":[{"name":"chacharng"}],"output":{"name":"u32"}}],[11,"reseed","","",502,null],[11,"from_seed","","Create a ChaCha generator from a seed,\nobtained from a variable-length u32 array.\nOnly up to 8 words are used; if less than 8\nwords are used, the remaining are set to zero.",502,null],[11,"new","rand::reseeding","Create a new `ReseedingRng` with the given parameters.",503,{"inputs":[{"name":"reseedingrng"},{"name":"r"},{"name":"usize"},{"name":"rsdr"}],"output":{"name":"reseedingrng"}}],[11,"reseed_if_necessary","","Reseed the internal RNG if the number of bytes that have been\ngenerated exceed the threshold.",503,null],[11,"next_u32","","",503,{"inputs":[{"name":"reseedingrng"}],"output":{"name":"u32"}}],[11,"next_u64","","",503,{"inputs":[{"name":"reseedingrng"}],"output":{"name":"u64"}}],[11,"fill_bytes","","",503,null],[11,"reseed","","",503,null],[11,"from_seed","","Create a new `ReseedingRng` from the given reseeder and\nseed. This uses a default value for `generation_threshold`.",503,null],[11,"clone","","",504,{"inputs":[{"name":"reseedwithdefault"}],"output":{"name":"reseedwithdefault"}}],[11,"reseed","","",504,null],[11,"default","","",504,{"inputs":[{"name":"reseedwithdefault"}],"output":{"name":"reseedwithdefault"}}],[11,"next","rand","",505,{"inputs":[{"name":"generator"}],"output":{"name":"option"}}],[11,"next","","",506,{"inputs":[{"name":"asciigenerator"}],"output":{"name":"option"}}],[11,"clone","","",485,{"inputs":[{"name":"xorshiftrng"}],"output":{"name":"xorshiftrng"}}],[11,"next_u32","","",485,{"inputs":[{"name":"xorshiftrng"}],"output":{"name":"u32"}}],[11,"reseed","","Reseed an XorShiftRng. This will panic if `seed` is entirely 0.",485,null],[11,"from_seed","","Create a new XorShiftRng. This will panic if `seed` is entirely 0.",485,null],[14,"assert!","std","Ensure that a boolean expression is `true` at runtime.",null,null],[14,"assert_eq!","","Asserts that two expressions are equal to each other.",null,null],[14,"debug_assert!","","Ensure that a boolean expression is `true` at runtime.",null,null],[14,"debug_assert_eq!","","Asserts that two expressions are equal to each other, testing equality in\nboth directions.",null,null],[14,"write!","","Use the `format!` syntax to write data into a buffer of type `&mut Write`.\nSee `std::fmt` for more information.",null,null],[14,"writeln!","","Equivalent to the `write!` macro, except that a newline is appended after\nthe message is written.",null,null],[14,"unreachable!","","A utility macro for indicating unreachable code.",null,null],[14,"unimplemented!","","A standardised placeholder for marking unfinished code. It panics with the\nmessage `\"not yet implemented\"` when executed.",null,null],[14,"vec!","","Creates a `Vec` containing the arguments.",null,null],[14,"format!","","Use the syntax described in `std::fmt` to create a value of type `String`.\nSee `std::fmt` for more information.",null,null],[14,"panic!","","The entry point for panic of Rust threads.",null,null],[14,"print!","","Macro for printing to the standard output.",null,null],[14,"println!","","Macro for printing to the standard output.",null,null],[14,"try!","","Helper macro for unwrapping `Result` values while returning early with an\nerror if the value of the expression is `Err`. Can only be used in\nfunctions that return `Result` because of the early return of `Err` that\nit provides.",null,null],[14,"select!","","A macro to select an event from a number of receivers.",null,null],[14,"format_args!","","The core macro for formatted string creation & output.",null,null],[14,"env!","","Inspect an environment variable at compile time.",null,null],[14,"option_env!","","Optionally inspect an environment variable at compile time.",null,null],[14,"concat_idents!","","Concatenate identifiers into one identifier.",null,null],[14,"concat!","","Concatenates literals into a static string slice.",null,null],[14,"line!","","A macro which expands to the line number on which it was invoked.",null,null],[14,"column!","","A macro which expands to the column number on which it was invoked.",null,null],[14,"file!","","A macro which expands to the file name from which it was invoked.",null,null],[14,"stringify!","","A macro which stringifies its argument.",null,null],[14,"include_str!","","Includes a utf8-encoded file as a string.",null,null],[14,"include_bytes!","","Includes a file as a byte slice.",null,null],[14,"module_path!","","Expands to a string that represents the current module path.",null,null],[14,"cfg!","","Boolean evaluation of configuration flags.",null,null],[14,"include!","","Parse the current given file as an expression.",null,null],[14,"thread_local!","","Declare a new thread local storage key of type `std::thread::LocalKey`.",null,null],[14,"scoped_thread_local!","","Declare a new scoped thread local storage key.",null,null],[15,"bool","","The boolean type.",null,null],[15,"char","","A Unicode scalar value.",null,null],[15,"pointer","","Raw, unsafe pointers, `*const T`, and `*mut T`.",null,null],[15,"array","","A fixed-size array, denoted `[T; N]`, for the element type, `T`, and\nthe non-negative compile time constant size, `N`.",null,null],[15,"slice","","A dynamically-sized view into a contiguous sequence, `[T]`.",null,null],[15,"str","","Unicode string slices.",null,null],[15,"tuple","","A finite heterogeneous sequence, `(T, U, ..)`.",null,null],[15,"f32","","The 32-bit floating point type.",null,null],[15,"f64","","The 64-bit floating point type.",null,null],[15,"i8","","The 8-bit signed integer type.",null,null],[15,"i16","","The 16-bit signed integer type.",null,null],[15,"i32","","The 32-bit signed integer type.",null,null],[15,"i64","","The 64-bit signed integer type.",null,null],[15,"u8","","The 8-bit unsigned integer type.",null,null],[15,"u16","","The 16-bit unsigned integer type.",null,null],[15,"u32","","The 32-bit unsigned integer type.",null,null],[15,"u64","","The 64-bit unsigned integer type.",null,null],[15,"isize","","The pointer-sized signed integer type.",null,null],[15,"usize","","The pointer-sized signed integer type.",null,null],[11,"overflowing_add","","",507,null],[11,"overflowing_sub","","",507,null],[11,"overflowing_mul","","",507,null],[11,"overflowing_div","","",507,null],[11,"overflowing_rem","","",507,null],[11,"overflowing_shl","","",507,null],[11,"overflowing_shr","","",507,null],[11,"overflowing_neg","","",507,null],[11,"overflowing_add","","",508,null],[11,"overflowing_sub","","",508,null],[11,"overflowing_mul","","",508,null],[11,"overflowing_div","","",508,null],[11,"overflowing_rem","","",508,null],[11,"overflowing_shl","","",508,null],[11,"overflowing_shr","","",508,null],[11,"overflowing_neg","","",508,null],[11,"overflowing_add","","",509,null],[11,"overflowing_sub","","",509,null],[11,"overflowing_mul","","",509,null],[11,"overflowing_div","","",509,null],[11,"overflowing_rem","","",509,null],[11,"overflowing_shl","","",509,null],[11,"overflowing_shr","","",509,null],[11,"overflowing_neg","","",509,null],[11,"overflowing_add","","",510,null],[11,"overflowing_sub","","",510,null],[11,"overflowing_mul","","",510,null],[11,"overflowing_div","","",510,null],[11,"overflowing_rem","","",510,null],[11,"overflowing_shl","","",510,null],[11,"overflowing_shr","","",510,null],[11,"overflowing_neg","","",510,null],[11,"overflowing_add","","",511,null],[11,"overflowing_sub","","",511,null],[11,"overflowing_mul","","",511,null],[11,"overflowing_div","","",511,null],[11,"overflowing_rem","","",511,null],[11,"overflowing_shl","","",511,null],[11,"overflowing_shr","","",511,null],[11,"overflowing_neg","","",511,null],[11,"overflowing_add","","",512,null],[11,"overflowing_sub","","",512,null],[11,"overflowing_mul","","",512,null],[11,"overflowing_div","","",512,null],[11,"overflowing_rem","","",512,null],[11,"overflowing_shl","","",512,null],[11,"overflowing_shr","","",512,null],[11,"overflowing_neg","","",512,null],[11,"overflowing_add","","",513,null],[11,"overflowing_sub","","",513,null],[11,"overflowing_mul","","",513,null],[11,"overflowing_div","","",513,null],[11,"overflowing_rem","","",513,null],[11,"overflowing_shl","","",513,null],[11,"overflowing_shr","","",513,null],[11,"overflowing_neg","","",513,null],[11,"overflowing_add","","",514,null],[11,"overflowing_sub","","",514,null],[11,"overflowing_mul","","",514,null],[11,"overflowing_div","","",514,null],[11,"overflowing_rem","","",514,null],[11,"overflowing_shl","","",514,null],[11,"overflowing_shr","","",514,null],[11,"overflowing_neg","","",514,null],[11,"overflowing_add","","",515,null],[11,"overflowing_sub","","",515,null],[11,"overflowing_mul","","",515,null],[11,"overflowing_div","","",515,null],[11,"overflowing_rem","","",515,null],[11,"overflowing_neg","","",515,null],[11,"overflowing_shl","","",515,null],[11,"overflowing_shr","","",515,null],[11,"overflowing_add","","",516,null],[11,"overflowing_sub","","",516,null],[11,"overflowing_mul","","",516,null],[11,"overflowing_div","","",516,null],[11,"overflowing_rem","","",516,null],[11,"overflowing_neg","","",516,null],[11,"overflowing_shl","","",516,null],[11,"overflowing_shr","","",516,null],[11,"full_add","","",511,null],[11,"full_mul","","",511,null],[11,"full_mul_add","","",511,null],[11,"full_div_rem","","",511,null],[11,"full_add","","",512,null],[11,"full_mul","","",512,null],[11,"full_mul_add","","",512,null],[11,"full_div_rem","","",512,null],[11,"full_add","","",513,null],[11,"full_mul","","",513,null],[11,"full_mul_add","","",513,null],[11,"full_div_rem","","",513,null],[11,"ldexpi","","",517,{"inputs":[{"name":"f32"},{"name":"i64"},{"name":"isize"}],"output":{"name":"f32"}}],[11,"min_pos_norm_value","","",517,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[11,"ldexpi","","",518,{"inputs":[{"name":"f64"},{"name":"i64"},{"name":"isize"}],"output":{"name":"f64"}}],[11,"min_pos_norm_value","","",518,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[11,"zero","","",511,{"inputs":[{"name":"u8"}],"output":{"name":"u8"}}],[11,"one","","",511,{"inputs":[{"name":"u8"}],"output":{"name":"u8"}}],[11,"zero","","",512,{"inputs":[{"name":"u16"}],"output":{"name":"u16"}}],[11,"one","","",512,{"inputs":[{"name":"u16"}],"output":{"name":"u16"}}],[11,"zero","","",513,{"inputs":[{"name":"u32"}],"output":{"name":"u32"}}],[11,"one","","",513,{"inputs":[{"name":"u32"}],"output":{"name":"u32"}}],[11,"zero","","",514,{"inputs":[{"name":"u64"}],"output":{"name":"u64"}}],[11,"one","","",514,{"inputs":[{"name":"u64"}],"output":{"name":"u64"}}],[11,"zero","","",515,{"inputs":[{"name":"usize"}],"output":{"name":"usize"}}],[11,"one","","",515,{"inputs":[{"name":"usize"}],"output":{"name":"usize"}}],[11,"zero","","",507,{"inputs":[{"name":"i8"}],"output":{"name":"i8"}}],[11,"one","","",507,{"inputs":[{"name":"i8"}],"output":{"name":"i8"}}],[11,"zero","","",508,{"inputs":[{"name":"i16"}],"output":{"name":"i16"}}],[11,"one","","",508,{"inputs":[{"name":"i16"}],"output":{"name":"i16"}}],[11,"zero","","",509,{"inputs":[{"name":"i32"}],"output":{"name":"i32"}}],[11,"one","","",509,{"inputs":[{"name":"i32"}],"output":{"name":"i32"}}],[11,"zero","","",510,{"inputs":[{"name":"i64"}],"output":{"name":"i64"}}],[11,"one","","",510,{"inputs":[{"name":"i64"}],"output":{"name":"i64"}}],[11,"zero","","",516,{"inputs":[{"name":"isize"}],"output":{"name":"isize"}}],[11,"one","","",516,{"inputs":[{"name":"isize"}],"output":{"name":"isize"}}],[11,"zero","","",517,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[11,"one","","",517,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[11,"zero","","",518,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[11,"one","","",518,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[11,"min_value","","Returns the smallest value that can be represented by this integer type.",507,{"inputs":[{"name":"i8"}],"output":{"name":"i8"}}],[11,"max_value","","Returns the largest value that can be represented by this integer type.",507,{"inputs":[{"name":"i8"}],"output":{"name":"i8"}}],[11,"from_str_radix","","Converts a string slice in a given base to an integer.",507,{"inputs":[{"name":"i8"},{"name":"str"},{"name":"u32"}],"output":{"name":"result"}}],[11,"count_ones","","Returns the number of ones in the binary representation of `self`.",507,{"inputs":[{"name":"i8"}],"output":{"name":"u32"}}],[11,"count_zeros","","Returns the number of zeros in the binary representation of `self`.",507,{"inputs":[{"name":"i8"}],"output":{"name":"u32"}}],[11,"leading_zeros","","Returns the number of leading zeros in the binary representation\nof `self`.",507,{"inputs":[{"name":"i8"}],"output":{"name":"u32"}}],[11,"trailing_zeros","","Returns the number of trailing zeros in the binary representation\nof `self`.",507,{"inputs":[{"name":"i8"}],"output":{"name":"u32"}}],[11,"rotate_left","","Shifts the bits to the left by a specified amount, `n`,\nwrapping the truncated bits to the end of the resulting integer.",507,{"inputs":[{"name":"i8"},{"name":"u32"}],"output":{"name":"i8"}}],[11,"rotate_right","","Shifts the bits to the right by a specified amount, `n`,\nwrapping the truncated bits to the beginning of the resulting\ninteger.",507,{"inputs":[{"name":"i8"},{"name":"u32"}],"output":{"name":"i8"}}],[11,"swap_bytes","","Reverses the byte order of the integer.",507,{"inputs":[{"name":"i8"}],"output":{"name":"i8"}}],[11,"from_be","","Converts an integer from big endian to the target's endianness.",507,{"inputs":[{"name":"i8"},{"name":"i8"}],"output":{"name":"i8"}}],[11,"from_le","","Converts an integer from little endian to the target's endianness.",507,{"inputs":[{"name":"i8"},{"name":"i8"}],"output":{"name":"i8"}}],[11,"to_be","","Converts `self` to big endian from the target's endianness.",507,{"inputs":[{"name":"i8"}],"output":{"name":"i8"}}],[11,"to_le","","Converts `self` to little endian from the target's endianness.",507,{"inputs":[{"name":"i8"}],"output":{"name":"i8"}}],[11,"checked_add","","Checked integer addition. Computes `self + other`, returning `None`\nif overflow occurred.",507,{"inputs":[{"name":"i8"},{"name":"i8"}],"output":{"name":"option"}}],[11,"checked_sub","","Checked integer subtraction. Computes `self - other`, returning\n`None` if underflow occurred.",507,{"inputs":[{"name":"i8"},{"name":"i8"}],"output":{"name":"option"}}],[11,"checked_mul","","Checked integer multiplication. Computes `self * other`, returning\n`None` if underflow or overflow occurred.",507,{"inputs":[{"name":"i8"},{"name":"i8"}],"output":{"name":"option"}}],[11,"checked_div","","Checked integer division. Computes `self / other`, returning `None`\nif `other == 0` or the operation results in underflow or overflow.",507,{"inputs":[{"name":"i8"},{"name":"i8"}],"output":{"name":"option"}}],[11,"saturating_add","","Saturating integer addition. Computes `self + other`, saturating at\nthe numeric bounds instead of overflowing.",507,{"inputs":[{"name":"i8"},{"name":"i8"}],"output":{"name":"i8"}}],[11,"saturating_sub","","Saturating integer subtraction. Computes `self - other`, saturating\nat the numeric bounds instead of overflowing.",507,{"inputs":[{"name":"i8"},{"name":"i8"}],"output":{"name":"i8"}}],[11,"wrapping_add","","Wrapping (modular) addition. Computes `self + other`,\nwrapping around at the boundary of the type.",507,{"inputs":[{"name":"i8"},{"name":"i8"}],"output":{"name":"i8"}}],[11,"wrapping_sub","","Wrapping (modular) subtraction. Computes `self - other`,\nwrapping around at the boundary of the type.",507,{"inputs":[{"name":"i8"},{"name":"i8"}],"output":{"name":"i8"}}],[11,"wrapping_mul","","Wrapping (modular) multiplication. Computes `self *\nother`, wrapping around at the boundary of the type.",507,{"inputs":[{"name":"i8"},{"name":"i8"}],"output":{"name":"i8"}}],[11,"wrapping_div","","Wrapping (modular) division. Computes `self / other`,\nwrapping around at the boundary of the type.",507,{"inputs":[{"name":"i8"},{"name":"i8"}],"output":{"name":"i8"}}],[11,"wrapping_rem","","Wrapping (modular) remainder. Computes `self % other`,\nwrapping around at the boundary of the type.",507,{"inputs":[{"name":"i8"},{"name":"i8"}],"output":{"name":"i8"}}],[11,"wrapping_neg","","Wrapping (modular) negation. Computes `-self`,\nwrapping around at the boundary of the type.",507,{"inputs":[{"name":"i8"}],"output":{"name":"i8"}}],[11,"wrapping_shl","","Panic-free bitwise shift-left; yields `self << mask(rhs)`,\nwhere `mask` removes any high-order bits of `rhs` that\nwould cause the shift to exceed the bitwidth of the type.",507,{"inputs":[{"name":"i8"},{"name":"u32"}],"output":{"name":"i8"}}],[11,"wrapping_shr","","Panic-free bitwise shift-left; yields `self >> mask(rhs)`,\nwhere `mask` removes any high-order bits of `rhs` that\nwould cause the shift to exceed the bitwidth of the type.",507,{"inputs":[{"name":"i8"},{"name":"u32"}],"output":{"name":"i8"}}],[11,"pow","","Raises self to the power of `exp`, using exponentiation by squaring.",507,{"inputs":[{"name":"i8"},{"name":"u32"}],"output":{"name":"i8"}}],[11,"abs","","Computes the absolute value of `self`.",507,{"inputs":[{"name":"i8"}],"output":{"name":"i8"}}],[11,"signum","","Returns a number representing sign of `self`.",507,{"inputs":[{"name":"i8"}],"output":{"name":"i8"}}],[11,"is_positive","","Returns `true` if `self` is positive and `false` if the number\nis zero or negative.",507,{"inputs":[{"name":"i8"}],"output":{"name":"bool"}}],[11,"is_negative","","Returns `true` if `self` is negative and `false` if the number\nis zero or positive.",507,{"inputs":[{"name":"i8"}],"output":{"name":"bool"}}],[11,"min_value","","Returns the smallest value that can be represented by this integer type.",508,{"inputs":[{"name":"i16"}],"output":{"name":"i16"}}],[11,"max_value","","Returns the largest value that can be represented by this integer type.",508,{"inputs":[{"name":"i16"}],"output":{"name":"i16"}}],[11,"from_str_radix","","Converts a string slice in a given base to an integer.",508,{"inputs":[{"name":"i16"},{"name":"str"},{"name":"u32"}],"output":{"name":"result"}}],[11,"count_ones","","Returns the number of ones in the binary representation of `self`.",508,{"inputs":[{"name":"i16"}],"output":{"name":"u32"}}],[11,"count_zeros","","Returns the number of zeros in the binary representation of `self`.",508,{"inputs":[{"name":"i16"}],"output":{"name":"u32"}}],[11,"leading_zeros","","Returns the number of leading zeros in the binary representation\nof `self`.",508,{"inputs":[{"name":"i16"}],"output":{"name":"u32"}}],[11,"trailing_zeros","","Returns the number of trailing zeros in the binary representation\nof `self`.",508,{"inputs":[{"name":"i16"}],"output":{"name":"u32"}}],[11,"rotate_left","","Shifts the bits to the left by a specified amount, `n`,\nwrapping the truncated bits to the end of the resulting integer.",508,{"inputs":[{"name":"i16"},{"name":"u32"}],"output":{"name":"i16"}}],[11,"rotate_right","","Shifts the bits to the right by a specified amount, `n`,\nwrapping the truncated bits to the beginning of the resulting\ninteger.",508,{"inputs":[{"name":"i16"},{"name":"u32"}],"output":{"name":"i16"}}],[11,"swap_bytes","","Reverses the byte order of the integer.",508,{"inputs":[{"name":"i16"}],"output":{"name":"i16"}}],[11,"from_be","","Converts an integer from big endian to the target's endianness.",508,{"inputs":[{"name":"i16"},{"name":"i16"}],"output":{"name":"i16"}}],[11,"from_le","","Converts an integer from little endian to the target's endianness.",508,{"inputs":[{"name":"i16"},{"name":"i16"}],"output":{"name":"i16"}}],[11,"to_be","","Converts `self` to big endian from the target's endianness.",508,{"inputs":[{"name":"i16"}],"output":{"name":"i16"}}],[11,"to_le","","Converts `self` to little endian from the target's endianness.",508,{"inputs":[{"name":"i16"}],"output":{"name":"i16"}}],[11,"checked_add","","Checked integer addition. Computes `self + other`, returning `None`\nif overflow occurred.",508,{"inputs":[{"name":"i16"},{"name":"i16"}],"output":{"name":"option"}}],[11,"checked_sub","","Checked integer subtraction. Computes `self - other`, returning\n`None` if underflow occurred.",508,{"inputs":[{"name":"i16"},{"name":"i16"}],"output":{"name":"option"}}],[11,"checked_mul","","Checked integer multiplication. Computes `self * other`, returning\n`None` if underflow or overflow occurred.",508,{"inputs":[{"name":"i16"},{"name":"i16"}],"output":{"name":"option"}}],[11,"checked_div","","Checked integer division. Computes `self / other`, returning `None`\nif `other == 0` or the operation results in underflow or overflow.",508,{"inputs":[{"name":"i16"},{"name":"i16"}],"output":{"name":"option"}}],[11,"saturating_add","","Saturating integer addition. Computes `self + other`, saturating at\nthe numeric bounds instead of overflowing.",508,{"inputs":[{"name":"i16"},{"name":"i16"}],"output":{"name":"i16"}}],[11,"saturating_sub","","Saturating integer subtraction. Computes `self - other`, saturating\nat the numeric bounds instead of overflowing.",508,{"inputs":[{"name":"i16"},{"name":"i16"}],"output":{"name":"i16"}}],[11,"wrapping_add","","Wrapping (modular) addition. Computes `self + other`,\nwrapping around at the boundary of the type.",508,{"inputs":[{"name":"i16"},{"name":"i16"}],"output":{"name":"i16"}}],[11,"wrapping_sub","","Wrapping (modular) subtraction. Computes `self - other`,\nwrapping around at the boundary of the type.",508,{"inputs":[{"name":"i16"},{"name":"i16"}],"output":{"name":"i16"}}],[11,"wrapping_mul","","Wrapping (modular) multiplication. Computes `self *\nother`, wrapping around at the boundary of the type.",508,{"inputs":[{"name":"i16"},{"name":"i16"}],"output":{"name":"i16"}}],[11,"wrapping_div","","Wrapping (modular) division. Computes `self / other`,\nwrapping around at the boundary of the type.",508,{"inputs":[{"name":"i16"},{"name":"i16"}],"output":{"name":"i16"}}],[11,"wrapping_rem","","Wrapping (modular) remainder. Computes `self % other`,\nwrapping around at the boundary of the type.",508,{"inputs":[{"name":"i16"},{"name":"i16"}],"output":{"name":"i16"}}],[11,"wrapping_neg","","Wrapping (modular) negation. Computes `-self`,\nwrapping around at the boundary of the type.",508,{"inputs":[{"name":"i16"}],"output":{"name":"i16"}}],[11,"wrapping_shl","","Panic-free bitwise shift-left; yields `self << mask(rhs)`,\nwhere `mask` removes any high-order bits of `rhs` that\nwould cause the shift to exceed the bitwidth of the type.",508,{"inputs":[{"name":"i16"},{"name":"u32"}],"output":{"name":"i16"}}],[11,"wrapping_shr","","Panic-free bitwise shift-left; yields `self >> mask(rhs)`,\nwhere `mask` removes any high-order bits of `rhs` that\nwould cause the shift to exceed the bitwidth of the type.",508,{"inputs":[{"name":"i16"},{"name":"u32"}],"output":{"name":"i16"}}],[11,"pow","","Raises self to the power of `exp`, using exponentiation by squaring.",508,{"inputs":[{"name":"i16"},{"name":"u32"}],"output":{"name":"i16"}}],[11,"abs","","Computes the absolute value of `self`.",508,{"inputs":[{"name":"i16"}],"output":{"name":"i16"}}],[11,"signum","","Returns a number representing sign of `self`.",508,{"inputs":[{"name":"i16"}],"output":{"name":"i16"}}],[11,"is_positive","","Returns `true` if `self` is positive and `false` if the number\nis zero or negative.",508,{"inputs":[{"name":"i16"}],"output":{"name":"bool"}}],[11,"is_negative","","Returns `true` if `self` is negative and `false` if the number\nis zero or positive.",508,{"inputs":[{"name":"i16"}],"output":{"name":"bool"}}],[11,"min_value","","Returns the smallest value that can be represented by this integer type.",509,{"inputs":[{"name":"i32"}],"output":{"name":"i32"}}],[11,"max_value","","Returns the largest value that can be represented by this integer type.",509,{"inputs":[{"name":"i32"}],"output":{"name":"i32"}}],[11,"from_str_radix","","Converts a string slice in a given base to an integer.",509,{"inputs":[{"name":"i32"},{"name":"str"},{"name":"u32"}],"output":{"name":"result"}}],[11,"count_ones","","Returns the number of ones in the binary representation of `self`.",509,{"inputs":[{"name":"i32"}],"output":{"name":"u32"}}],[11,"count_zeros","","Returns the number of zeros in the binary representation of `self`.",509,{"inputs":[{"name":"i32"}],"output":{"name":"u32"}}],[11,"leading_zeros","","Returns the number of leading zeros in the binary representation\nof `self`.",509,{"inputs":[{"name":"i32"}],"output":{"name":"u32"}}],[11,"trailing_zeros","","Returns the number of trailing zeros in the binary representation\nof `self`.",509,{"inputs":[{"name":"i32"}],"output":{"name":"u32"}}],[11,"rotate_left","","Shifts the bits to the left by a specified amount, `n`,\nwrapping the truncated bits to the end of the resulting integer.",509,{"inputs":[{"name":"i32"},{"name":"u32"}],"output":{"name":"i32"}}],[11,"rotate_right","","Shifts the bits to the right by a specified amount, `n`,\nwrapping the truncated bits to the beginning of the resulting\ninteger.",509,{"inputs":[{"name":"i32"},{"name":"u32"}],"output":{"name":"i32"}}],[11,"swap_bytes","","Reverses the byte order of the integer.",509,{"inputs":[{"name":"i32"}],"output":{"name":"i32"}}],[11,"from_be","","Converts an integer from big endian to the target's endianness.",509,{"inputs":[{"name":"i32"},{"name":"i32"}],"output":{"name":"i32"}}],[11,"from_le","","Converts an integer from little endian to the target's endianness.",509,{"inputs":[{"name":"i32"},{"name":"i32"}],"output":{"name":"i32"}}],[11,"to_be","","Converts `self` to big endian from the target's endianness.",509,{"inputs":[{"name":"i32"}],"output":{"name":"i32"}}],[11,"to_le","","Converts `self` to little endian from the target's endianness.",509,{"inputs":[{"name":"i32"}],"output":{"name":"i32"}}],[11,"checked_add","","Checked integer addition. Computes `self + other`, returning `None`\nif overflow occurred.",509,{"inputs":[{"name":"i32"},{"name":"i32"}],"output":{"name":"option"}}],[11,"checked_sub","","Checked integer subtraction. Computes `self - other`, returning\n`None` if underflow occurred.",509,{"inputs":[{"name":"i32"},{"name":"i32"}],"output":{"name":"option"}}],[11,"checked_mul","","Checked integer multiplication. Computes `self * other`, returning\n`None` if underflow or overflow occurred.",509,{"inputs":[{"name":"i32"},{"name":"i32"}],"output":{"name":"option"}}],[11,"checked_div","","Checked integer division. Computes `self / other`, returning `None`\nif `other == 0` or the operation results in underflow or overflow.",509,{"inputs":[{"name":"i32"},{"name":"i32"}],"output":{"name":"option"}}],[11,"saturating_add","","Saturating integer addition. Computes `self + other`, saturating at\nthe numeric bounds instead of overflowing.",509,{"inputs":[{"name":"i32"},{"name":"i32"}],"output":{"name":"i32"}}],[11,"saturating_sub","","Saturating integer subtraction. Computes `self - other`, saturating\nat the numeric bounds instead of overflowing.",509,{"inputs":[{"name":"i32"},{"name":"i32"}],"output":{"name":"i32"}}],[11,"wrapping_add","","Wrapping (modular) addition. Computes `self + other`,\nwrapping around at the boundary of the type.",509,{"inputs":[{"name":"i32"},{"name":"i32"}],"output":{"name":"i32"}}],[11,"wrapping_sub","","Wrapping (modular) subtraction. Computes `self - other`,\nwrapping around at the boundary of the type.",509,{"inputs":[{"name":"i32"},{"name":"i32"}],"output":{"name":"i32"}}],[11,"wrapping_mul","","Wrapping (modular) multiplication. Computes `self *\nother`, wrapping around at the boundary of the type.",509,{"inputs":[{"name":"i32"},{"name":"i32"}],"output":{"name":"i32"}}],[11,"wrapping_div","","Wrapping (modular) division. Computes `self / other`,\nwrapping around at the boundary of the type.",509,{"inputs":[{"name":"i32"},{"name":"i32"}],"output":{"name":"i32"}}],[11,"wrapping_rem","","Wrapping (modular) remainder. Computes `self % other`,\nwrapping around at the boundary of the type.",509,{"inputs":[{"name":"i32"},{"name":"i32"}],"output":{"name":"i32"}}],[11,"wrapping_neg","","Wrapping (modular) negation. Computes `-self`,\nwrapping around at the boundary of the type.",509,{"inputs":[{"name":"i32"}],"output":{"name":"i32"}}],[11,"wrapping_shl","","Panic-free bitwise shift-left; yields `self << mask(rhs)`,\nwhere `mask` removes any high-order bits of `rhs` that\nwould cause the shift to exceed the bitwidth of the type.",509,{"inputs":[{"name":"i32"},{"name":"u32"}],"output":{"name":"i32"}}],[11,"wrapping_shr","","Panic-free bitwise shift-left; yields `self >> mask(rhs)`,\nwhere `mask` removes any high-order bits of `rhs` that\nwould cause the shift to exceed the bitwidth of the type.",509,{"inputs":[{"name":"i32"},{"name":"u32"}],"output":{"name":"i32"}}],[11,"pow","","Raises self to the power of `exp`, using exponentiation by squaring.",509,{"inputs":[{"name":"i32"},{"name":"u32"}],"output":{"name":"i32"}}],[11,"abs","","Computes the absolute value of `self`.",509,{"inputs":[{"name":"i32"}],"output":{"name":"i32"}}],[11,"signum","","Returns a number representing sign of `self`.",509,{"inputs":[{"name":"i32"}],"output":{"name":"i32"}}],[11,"is_positive","","Returns `true` if `self` is positive and `false` if the number\nis zero or negative.",509,{"inputs":[{"name":"i32"}],"output":{"name":"bool"}}],[11,"is_negative","","Returns `true` if `self` is negative and `false` if the number\nis zero or positive.",509,{"inputs":[{"name":"i32"}],"output":{"name":"bool"}}],[11,"min_value","","Returns the smallest value that can be represented by this integer type.",510,{"inputs":[{"name":"i64"}],"output":{"name":"i64"}}],[11,"max_value","","Returns the largest value that can be represented by this integer type.",510,{"inputs":[{"name":"i64"}],"output":{"name":"i64"}}],[11,"from_str_radix","","Converts a string slice in a given base to an integer.",510,{"inputs":[{"name":"i64"},{"name":"str"},{"name":"u32"}],"output":{"name":"result"}}],[11,"count_ones","","Returns the number of ones in the binary representation of `self`.",510,{"inputs":[{"name":"i64"}],"output":{"name":"u32"}}],[11,"count_zeros","","Returns the number of zeros in the binary representation of `self`.",510,{"inputs":[{"name":"i64"}],"output":{"name":"u32"}}],[11,"leading_zeros","","Returns the number of leading zeros in the binary representation\nof `self`.",510,{"inputs":[{"name":"i64"}],"output":{"name":"u32"}}],[11,"trailing_zeros","","Returns the number of trailing zeros in the binary representation\nof `self`.",510,{"inputs":[{"name":"i64"}],"output":{"name":"u32"}}],[11,"rotate_left","","Shifts the bits to the left by a specified amount, `n`,\nwrapping the truncated bits to the end of the resulting integer.",510,{"inputs":[{"name":"i64"},{"name":"u32"}],"output":{"name":"i64"}}],[11,"rotate_right","","Shifts the bits to the right by a specified amount, `n`,\nwrapping the truncated bits to the beginning of the resulting\ninteger.",510,{"inputs":[{"name":"i64"},{"name":"u32"}],"output":{"name":"i64"}}],[11,"swap_bytes","","Reverses the byte order of the integer.",510,{"inputs":[{"name":"i64"}],"output":{"name":"i64"}}],[11,"from_be","","Converts an integer from big endian to the target's endianness.",510,{"inputs":[{"name":"i64"},{"name":"i64"}],"output":{"name":"i64"}}],[11,"from_le","","Converts an integer from little endian to the target's endianness.",510,{"inputs":[{"name":"i64"},{"name":"i64"}],"output":{"name":"i64"}}],[11,"to_be","","Converts `self` to big endian from the target's endianness.",510,{"inputs":[{"name":"i64"}],"output":{"name":"i64"}}],[11,"to_le","","Converts `self` to little endian from the target's endianness.",510,{"inputs":[{"name":"i64"}],"output":{"name":"i64"}}],[11,"checked_add","","Checked integer addition. Computes `self + other`, returning `None`\nif overflow occurred.",510,{"inputs":[{"name":"i64"},{"name":"i64"}],"output":{"name":"option"}}],[11,"checked_sub","","Checked integer subtraction. Computes `self - other`, returning\n`None` if underflow occurred.",510,{"inputs":[{"name":"i64"},{"name":"i64"}],"output":{"name":"option"}}],[11,"checked_mul","","Checked integer multiplication. Computes `self * other`, returning\n`None` if underflow or overflow occurred.",510,{"inputs":[{"name":"i64"},{"name":"i64"}],"output":{"name":"option"}}],[11,"checked_div","","Checked integer division. Computes `self / other`, returning `None`\nif `other == 0` or the operation results in underflow or overflow.",510,{"inputs":[{"name":"i64"},{"name":"i64"}],"output":{"name":"option"}}],[11,"saturating_add","","Saturating integer addition. Computes `self + other`, saturating at\nthe numeric bounds instead of overflowing.",510,{"inputs":[{"name":"i64"},{"name":"i64"}],"output":{"name":"i64"}}],[11,"saturating_sub","","Saturating integer subtraction. Computes `self - other`, saturating\nat the numeric bounds instead of overflowing.",510,{"inputs":[{"name":"i64"},{"name":"i64"}],"output":{"name":"i64"}}],[11,"wrapping_add","","Wrapping (modular) addition. Computes `self + other`,\nwrapping around at the boundary of the type.",510,{"inputs":[{"name":"i64"},{"name":"i64"}],"output":{"name":"i64"}}],[11,"wrapping_sub","","Wrapping (modular) subtraction. Computes `self - other`,\nwrapping around at the boundary of the type.",510,{"inputs":[{"name":"i64"},{"name":"i64"}],"output":{"name":"i64"}}],[11,"wrapping_mul","","Wrapping (modular) multiplication. Computes `self *\nother`, wrapping around at the boundary of the type.",510,{"inputs":[{"name":"i64"},{"name":"i64"}],"output":{"name":"i64"}}],[11,"wrapping_div","","Wrapping (modular) division. Computes `self / other`,\nwrapping around at the boundary of the type.",510,{"inputs":[{"name":"i64"},{"name":"i64"}],"output":{"name":"i64"}}],[11,"wrapping_rem","","Wrapping (modular) remainder. Computes `self % other`,\nwrapping around at the boundary of the type.",510,{"inputs":[{"name":"i64"},{"name":"i64"}],"output":{"name":"i64"}}],[11,"wrapping_neg","","Wrapping (modular) negation. Computes `-self`,\nwrapping around at the boundary of the type.",510,{"inputs":[{"name":"i64"}],"output":{"name":"i64"}}],[11,"wrapping_shl","","Panic-free bitwise shift-left; yields `self << mask(rhs)`,\nwhere `mask` removes any high-order bits of `rhs` that\nwould cause the shift to exceed the bitwidth of the type.",510,{"inputs":[{"name":"i64"},{"name":"u32"}],"output":{"name":"i64"}}],[11,"wrapping_shr","","Panic-free bitwise shift-left; yields `self >> mask(rhs)`,\nwhere `mask` removes any high-order bits of `rhs` that\nwould cause the shift to exceed the bitwidth of the type.",510,{"inputs":[{"name":"i64"},{"name":"u32"}],"output":{"name":"i64"}}],[11,"pow","","Raises self to the power of `exp`, using exponentiation by squaring.",510,{"inputs":[{"name":"i64"},{"name":"u32"}],"output":{"name":"i64"}}],[11,"abs","","Computes the absolute value of `self`.",510,{"inputs":[{"name":"i64"}],"output":{"name":"i64"}}],[11,"signum","","Returns a number representing sign of `self`.",510,{"inputs":[{"name":"i64"}],"output":{"name":"i64"}}],[11,"is_positive","","Returns `true` if `self` is positive and `false` if the number\nis zero or negative.",510,{"inputs":[{"name":"i64"}],"output":{"name":"bool"}}],[11,"is_negative","","Returns `true` if `self` is negative and `false` if the number\nis zero or positive.",510,{"inputs":[{"name":"i64"}],"output":{"name":"bool"}}],[11,"min_value","","Returns the smallest value that can be represented by this integer type.",516,{"inputs":[{"name":"isize"}],"output":{"name":"isize"}}],[11,"max_value","","Returns the largest value that can be represented by this integer type.",516,{"inputs":[{"name":"isize"}],"output":{"name":"isize"}}],[11,"from_str_radix","","Converts a string slice in a given base to an integer.",516,{"inputs":[{"name":"isize"},{"name":"str"},{"name":"u32"}],"output":{"name":"result"}}],[11,"count_ones","","Returns the number of ones in the binary representation of `self`.",516,{"inputs":[{"name":"isize"}],"output":{"name":"u32"}}],[11,"count_zeros","","Returns the number of zeros in the binary representation of `self`.",516,{"inputs":[{"name":"isize"}],"output":{"name":"u32"}}],[11,"leading_zeros","","Returns the number of leading zeros in the binary representation\nof `self`.",516,{"inputs":[{"name":"isize"}],"output":{"name":"u32"}}],[11,"trailing_zeros","","Returns the number of trailing zeros in the binary representation\nof `self`.",516,{"inputs":[{"name":"isize"}],"output":{"name":"u32"}}],[11,"rotate_left","","Shifts the bits to the left by a specified amount, `n`,\nwrapping the truncated bits to the end of the resulting integer.",516,{"inputs":[{"name":"isize"},{"name":"u32"}],"output":{"name":"isize"}}],[11,"rotate_right","","Shifts the bits to the right by a specified amount, `n`,\nwrapping the truncated bits to the beginning of the resulting\ninteger.",516,{"inputs":[{"name":"isize"},{"name":"u32"}],"output":{"name":"isize"}}],[11,"swap_bytes","","Reverses the byte order of the integer.",516,{"inputs":[{"name":"isize"}],"output":{"name":"isize"}}],[11,"from_be","","Converts an integer from big endian to the target's endianness.",516,{"inputs":[{"name":"isize"},{"name":"isize"}],"output":{"name":"isize"}}],[11,"from_le","","Converts an integer from little endian to the target's endianness.",516,{"inputs":[{"name":"isize"},{"name":"isize"}],"output":{"name":"isize"}}],[11,"to_be","","Converts `self` to big endian from the target's endianness.",516,{"inputs":[{"name":"isize"}],"output":{"name":"isize"}}],[11,"to_le","","Converts `self` to little endian from the target's endianness.",516,{"inputs":[{"name":"isize"}],"output":{"name":"isize"}}],[11,"checked_add","","Checked integer addition. Computes `self + other`, returning `None`\nif overflow occurred.",516,{"inputs":[{"name":"isize"},{"name":"isize"}],"output":{"name":"option"}}],[11,"checked_sub","","Checked integer subtraction. Computes `self - other`, returning\n`None` if underflow occurred.",516,{"inputs":[{"name":"isize"},{"name":"isize"}],"output":{"name":"option"}}],[11,"checked_mul","","Checked integer multiplication. Computes `self * other`, returning\n`None` if underflow or overflow occurred.",516,{"inputs":[{"name":"isize"},{"name":"isize"}],"output":{"name":"option"}}],[11,"checked_div","","Checked integer division. Computes `self / other`, returning `None`\nif `other == 0` or the operation results in underflow or overflow.",516,{"inputs":[{"name":"isize"},{"name":"isize"}],"output":{"name":"option"}}],[11,"saturating_add","","Saturating integer addition. Computes `self + other`, saturating at\nthe numeric bounds instead of overflowing.",516,{"inputs":[{"name":"isize"},{"name":"isize"}],"output":{"name":"isize"}}],[11,"saturating_sub","","Saturating integer subtraction. Computes `self - other`, saturating\nat the numeric bounds instead of overflowing.",516,{"inputs":[{"name":"isize"},{"name":"isize"}],"output":{"name":"isize"}}],[11,"wrapping_add","","Wrapping (modular) addition. Computes `self + other`,\nwrapping around at the boundary of the type.",516,{"inputs":[{"name":"isize"},{"name":"isize"}],"output":{"name":"isize"}}],[11,"wrapping_sub","","Wrapping (modular) subtraction. Computes `self - other`,\nwrapping around at the boundary of the type.",516,{"inputs":[{"name":"isize"},{"name":"isize"}],"output":{"name":"isize"}}],[11,"wrapping_mul","","Wrapping (modular) multiplication. Computes `self *\nother`, wrapping around at the boundary of the type.",516,{"inputs":[{"name":"isize"},{"name":"isize"}],"output":{"name":"isize"}}],[11,"wrapping_div","","Wrapping (modular) division. Computes `self / other`,\nwrapping around at the boundary of the type.",516,{"inputs":[{"name":"isize"},{"name":"isize"}],"output":{"name":"isize"}}],[11,"wrapping_rem","","Wrapping (modular) remainder. Computes `self % other`,\nwrapping around at the boundary of the type.",516,{"inputs":[{"name":"isize"},{"name":"isize"}],"output":{"name":"isize"}}],[11,"wrapping_neg","","Wrapping (modular) negation. Computes `-self`,\nwrapping around at the boundary of the type.",516,{"inputs":[{"name":"isize"}],"output":{"name":"isize"}}],[11,"wrapping_shl","","Panic-free bitwise shift-left; yields `self << mask(rhs)`,\nwhere `mask` removes any high-order bits of `rhs` that\nwould cause the shift to exceed the bitwidth of the type.",516,{"inputs":[{"name":"isize"},{"name":"u32"}],"output":{"name":"isize"}}],[11,"wrapping_shr","","Panic-free bitwise shift-left; yields `self >> mask(rhs)`,\nwhere `mask` removes any high-order bits of `rhs` that\nwould cause the shift to exceed the bitwidth of the type.",516,{"inputs":[{"name":"isize"},{"name":"u32"}],"output":{"name":"isize"}}],[11,"pow","","Raises self to the power of `exp`, using exponentiation by squaring.",516,{"inputs":[{"name":"isize"},{"name":"u32"}],"output":{"name":"isize"}}],[11,"abs","","Computes the absolute value of `self`.",516,{"inputs":[{"name":"isize"}],"output":{"name":"isize"}}],[11,"signum","","Returns a number representing sign of `self`.",516,{"inputs":[{"name":"isize"}],"output":{"name":"isize"}}],[11,"is_positive","","Returns `true` if `self` is positive and `false` if the number\nis zero or negative.",516,{"inputs":[{"name":"isize"}],"output":{"name":"bool"}}],[11,"is_negative","","Returns `true` if `self` is negative and `false` if the number\nis zero or positive.",516,{"inputs":[{"name":"isize"}],"output":{"name":"bool"}}],[11,"min_value","","Returns the smallest value that can be represented by this integer type.",511,{"inputs":[{"name":"u8"}],"output":{"name":"u8"}}],[11,"max_value","","Returns the largest value that can be represented by this integer type.",511,{"inputs":[{"name":"u8"}],"output":{"name":"u8"}}],[11,"from_str_radix","","Converts a string slice in a given base to an integer.",511,{"inputs":[{"name":"u8"},{"name":"str"},{"name":"u32"}],"output":{"name":"result"}}],[11,"count_ones","","Returns the number of ones in the binary representation of `self`.",511,{"inputs":[{"name":"u8"}],"output":{"name":"u32"}}],[11,"count_zeros","","Returns the number of zeros in the binary representation of `self`.",511,{"inputs":[{"name":"u8"}],"output":{"name":"u32"}}],[11,"leading_zeros","","Returns the number of leading zeros in the binary representation\nof `self`.",511,{"inputs":[{"name":"u8"}],"output":{"name":"u32"}}],[11,"trailing_zeros","","Returns the number of trailing zeros in the binary representation\nof `self`.",511,{"inputs":[{"name":"u8"}],"output":{"name":"u32"}}],[11,"rotate_left","","Shifts the bits to the left by a specified amount, `n`,\nwrapping the truncated bits to the end of the resulting integer.",511,{"inputs":[{"name":"u8"},{"name":"u32"}],"output":{"name":"u8"}}],[11,"rotate_right","","Shifts the bits to the right by a specified amount, `n`,\nwrapping the truncated bits to the beginning of the resulting\ninteger.",511,{"inputs":[{"name":"u8"},{"name":"u32"}],"output":{"name":"u8"}}],[11,"swap_bytes","","Reverses the byte order of the integer.",511,{"inputs":[{"name":"u8"}],"output":{"name":"u8"}}],[11,"from_be","","Converts an integer from big endian to the target's endianness.",511,{"inputs":[{"name":"u8"},{"name":"u8"}],"output":{"name":"u8"}}],[11,"from_le","","Converts an integer from little endian to the target's endianness.",511,{"inputs":[{"name":"u8"},{"name":"u8"}],"output":{"name":"u8"}}],[11,"to_be","","Converts `self` to big endian from the target's endianness.",511,{"inputs":[{"name":"u8"}],"output":{"name":"u8"}}],[11,"to_le","","Converts `self` to little endian from the target's endianness.",511,{"inputs":[{"name":"u8"}],"output":{"name":"u8"}}],[11,"checked_add","","Checked integer addition. Computes `self + other`, returning `None`\nif overflow occurred.",511,{"inputs":[{"name":"u8"},{"name":"u8"}],"output":{"name":"option"}}],[11,"checked_sub","","Checked integer subtraction. Computes `self - other`, returning\n`None` if underflow occurred.",511,{"inputs":[{"name":"u8"},{"name":"u8"}],"output":{"name":"option"}}],[11,"checked_mul","","Checked integer multiplication. Computes `self * other`, returning\n`None` if underflow or overflow occurred.",511,{"inputs":[{"name":"u8"},{"name":"u8"}],"output":{"name":"option"}}],[11,"checked_div","","Checked integer division. Computes `self / other`, returning `None`\nif `other == 0` or the operation results in underflow or overflow.",511,{"inputs":[{"name":"u8"},{"name":"u8"}],"output":{"name":"option"}}],[11,"saturating_add","","Saturating integer addition. Computes `self + other`, saturating at\nthe numeric bounds instead of overflowing.",511,{"inputs":[{"name":"u8"},{"name":"u8"}],"output":{"name":"u8"}}],[11,"saturating_sub","","Saturating integer subtraction. Computes `self - other`, saturating\nat the numeric bounds instead of overflowing.",511,{"inputs":[{"name":"u8"},{"name":"u8"}],"output":{"name":"u8"}}],[11,"wrapping_add","","Wrapping (modular) addition. Computes `self + other`,\nwrapping around at the boundary of the type.",511,{"inputs":[{"name":"u8"},{"name":"u8"}],"output":{"name":"u8"}}],[11,"wrapping_sub","","Wrapping (modular) subtraction. Computes `self - other`,\nwrapping around at the boundary of the type.",511,{"inputs":[{"name":"u8"},{"name":"u8"}],"output":{"name":"u8"}}],[11,"wrapping_mul","","Wrapping (modular) multiplication. Computes `self *\nother`, wrapping around at the boundary of the type.",511,{"inputs":[{"name":"u8"},{"name":"u8"}],"output":{"name":"u8"}}],[11,"wrapping_div","","Wrapping (modular) division. Computes `self / other`,\nwrapping around at the boundary of the type.",511,{"inputs":[{"name":"u8"},{"name":"u8"}],"output":{"name":"u8"}}],[11,"wrapping_rem","","Wrapping (modular) remainder. Computes `self % other`,\nwrapping around at the boundary of the type.",511,{"inputs":[{"name":"u8"},{"name":"u8"}],"output":{"name":"u8"}}],[11,"wrapping_neg","","Wrapping (modular) negation. Computes `-self`,\nwrapping around at the boundary of the type.",511,{"inputs":[{"name":"u8"}],"output":{"name":"u8"}}],[11,"wrapping_shl","","Panic-free bitwise shift-left; yields `self << mask(rhs)`,\nwhere `mask` removes any high-order bits of `rhs` that\nwould cause the shift to exceed the bitwidth of the type.",511,{"inputs":[{"name":"u8"},{"name":"u32"}],"output":{"name":"u8"}}],[11,"wrapping_shr","","Panic-free bitwise shift-left; yields `self >> mask(rhs)`,\nwhere `mask` removes any high-order bits of `rhs` that\nwould cause the shift to exceed the bitwidth of the type.",511,{"inputs":[{"name":"u8"},{"name":"u32"}],"output":{"name":"u8"}}],[11,"pow","","Raises self to the power of `exp`, using exponentiation by squaring.",511,{"inputs":[{"name":"u8"},{"name":"u32"}],"output":{"name":"u8"}}],[11,"is_power_of_two","","Returns `true` if and only if `self == 2^k` for some `k`.",511,{"inputs":[{"name":"u8"}],"output":{"name":"bool"}}],[11,"next_power_of_two","","Returns the smallest power of two greater than or equal to `self`.\nUnspecified behavior on overflow.",511,{"inputs":[{"name":"u8"}],"output":{"name":"u8"}}],[11,"checked_next_power_of_two","","Returns the smallest power of two greater than or equal to `n`. If\nthe next power of two is greater than the type's maximum value,\n`None` is returned, otherwise the power of two is wrapped in `Some`.",511,{"inputs":[{"name":"u8"}],"output":{"name":"option"}}],[11,"min_value","","Returns the smallest value that can be represented by this integer type.",512,{"inputs":[{"name":"u16"}],"output":{"name":"u16"}}],[11,"max_value","","Returns the largest value that can be represented by this integer type.",512,{"inputs":[{"name":"u16"}],"output":{"name":"u16"}}],[11,"from_str_radix","","Converts a string slice in a given base to an integer.",512,{"inputs":[{"name":"u16"},{"name":"str"},{"name":"u32"}],"output":{"name":"result"}}],[11,"count_ones","","Returns the number of ones in the binary representation of `self`.",512,{"inputs":[{"name":"u16"}],"output":{"name":"u32"}}],[11,"count_zeros","","Returns the number of zeros in the binary representation of `self`.",512,{"inputs":[{"name":"u16"}],"output":{"name":"u32"}}],[11,"leading_zeros","","Returns the number of leading zeros in the binary representation\nof `self`.",512,{"inputs":[{"name":"u16"}],"output":{"name":"u32"}}],[11,"trailing_zeros","","Returns the number of trailing zeros in the binary representation\nof `self`.",512,{"inputs":[{"name":"u16"}],"output":{"name":"u32"}}],[11,"rotate_left","","Shifts the bits to the left by a specified amount, `n`,\nwrapping the truncated bits to the end of the resulting integer.",512,{"inputs":[{"name":"u16"},{"name":"u32"}],"output":{"name":"u16"}}],[11,"rotate_right","","Shifts the bits to the right by a specified amount, `n`,\nwrapping the truncated bits to the beginning of the resulting\ninteger.",512,{"inputs":[{"name":"u16"},{"name":"u32"}],"output":{"name":"u16"}}],[11,"swap_bytes","","Reverses the byte order of the integer.",512,{"inputs":[{"name":"u16"}],"output":{"name":"u16"}}],[11,"from_be","","Converts an integer from big endian to the target's endianness.",512,{"inputs":[{"name":"u16"},{"name":"u16"}],"output":{"name":"u16"}}],[11,"from_le","","Converts an integer from little endian to the target's endianness.",512,{"inputs":[{"name":"u16"},{"name":"u16"}],"output":{"name":"u16"}}],[11,"to_be","","Converts `self` to big endian from the target's endianness.",512,{"inputs":[{"name":"u16"}],"output":{"name":"u16"}}],[11,"to_le","","Converts `self` to little endian from the target's endianness.",512,{"inputs":[{"name":"u16"}],"output":{"name":"u16"}}],[11,"checked_add","","Checked integer addition. Computes `self + other`, returning `None`\nif overflow occurred.",512,{"inputs":[{"name":"u16"},{"name":"u16"}],"output":{"name":"option"}}],[11,"checked_sub","","Checked integer subtraction. Computes `self - other`, returning\n`None` if underflow occurred.",512,{"inputs":[{"name":"u16"},{"name":"u16"}],"output":{"name":"option"}}],[11,"checked_mul","","Checked integer multiplication. Computes `self * other`, returning\n`None` if underflow or overflow occurred.",512,{"inputs":[{"name":"u16"},{"name":"u16"}],"output":{"name":"option"}}],[11,"checked_div","","Checked integer division. Computes `self / other`, returning `None`\nif `other == 0` or the operation results in underflow or overflow.",512,{"inputs":[{"name":"u16"},{"name":"u16"}],"output":{"name":"option"}}],[11,"saturating_add","","Saturating integer addition. Computes `self + other`, saturating at\nthe numeric bounds instead of overflowing.",512,{"inputs":[{"name":"u16"},{"name":"u16"}],"output":{"name":"u16"}}],[11,"saturating_sub","","Saturating integer subtraction. Computes `self - other`, saturating\nat the numeric bounds instead of overflowing.",512,{"inputs":[{"name":"u16"},{"name":"u16"}],"output":{"name":"u16"}}],[11,"wrapping_add","","Wrapping (modular) addition. Computes `self + other`,\nwrapping around at the boundary of the type.",512,{"inputs":[{"name":"u16"},{"name":"u16"}],"output":{"name":"u16"}}],[11,"wrapping_sub","","Wrapping (modular) subtraction. Computes `self - other`,\nwrapping around at the boundary of the type.",512,{"inputs":[{"name":"u16"},{"name":"u16"}],"output":{"name":"u16"}}],[11,"wrapping_mul","","Wrapping (modular) multiplication. Computes `self *\nother`, wrapping around at the boundary of the type.",512,{"inputs":[{"name":"u16"},{"name":"u16"}],"output":{"name":"u16"}}],[11,"wrapping_div","","Wrapping (modular) division. Computes `self / other`,\nwrapping around at the boundary of the type.",512,{"inputs":[{"name":"u16"},{"name":"u16"}],"output":{"name":"u16"}}],[11,"wrapping_rem","","Wrapping (modular) remainder. Computes `self % other`,\nwrapping around at the boundary of the type.",512,{"inputs":[{"name":"u16"},{"name":"u16"}],"output":{"name":"u16"}}],[11,"wrapping_neg","","Wrapping (modular) negation. Computes `-self`,\nwrapping around at the boundary of the type.",512,{"inputs":[{"name":"u16"}],"output":{"name":"u16"}}],[11,"wrapping_shl","","Panic-free bitwise shift-left; yields `self << mask(rhs)`,\nwhere `mask` removes any high-order bits of `rhs` that\nwould cause the shift to exceed the bitwidth of the type.",512,{"inputs":[{"name":"u16"},{"name":"u32"}],"output":{"name":"u16"}}],[11,"wrapping_shr","","Panic-free bitwise shift-left; yields `self >> mask(rhs)`,\nwhere `mask` removes any high-order bits of `rhs` that\nwould cause the shift to exceed the bitwidth of the type.",512,{"inputs":[{"name":"u16"},{"name":"u32"}],"output":{"name":"u16"}}],[11,"pow","","Raises self to the power of `exp`, using exponentiation by squaring.",512,{"inputs":[{"name":"u16"},{"name":"u32"}],"output":{"name":"u16"}}],[11,"is_power_of_two","","Returns `true` if and only if `self == 2^k` for some `k`.",512,{"inputs":[{"name":"u16"}],"output":{"name":"bool"}}],[11,"next_power_of_two","","Returns the smallest power of two greater than or equal to `self`.\nUnspecified behavior on overflow.",512,{"inputs":[{"name":"u16"}],"output":{"name":"u16"}}],[11,"checked_next_power_of_two","","Returns the smallest power of two greater than or equal to `n`. If\nthe next power of two is greater than the type's maximum value,\n`None` is returned, otherwise the power of two is wrapped in `Some`.",512,{"inputs":[{"name":"u16"}],"output":{"name":"option"}}],[11,"min_value","","Returns the smallest value that can be represented by this integer type.",513,{"inputs":[{"name":"u32"}],"output":{"name":"u32"}}],[11,"max_value","","Returns the largest value that can be represented by this integer type.",513,{"inputs":[{"name":"u32"}],"output":{"name":"u32"}}],[11,"from_str_radix","","Converts a string slice in a given base to an integer.",513,{"inputs":[{"name":"u32"},{"name":"str"},{"name":"u32"}],"output":{"name":"result"}}],[11,"count_ones","","Returns the number of ones in the binary representation of `self`.",513,{"inputs":[{"name":"u32"}],"output":{"name":"u32"}}],[11,"count_zeros","","Returns the number of zeros in the binary representation of `self`.",513,{"inputs":[{"name":"u32"}],"output":{"name":"u32"}}],[11,"leading_zeros","","Returns the number of leading zeros in the binary representation\nof `self`.",513,{"inputs":[{"name":"u32"}],"output":{"name":"u32"}}],[11,"trailing_zeros","","Returns the number of trailing zeros in the binary representation\nof `self`.",513,{"inputs":[{"name":"u32"}],"output":{"name":"u32"}}],[11,"rotate_left","","Shifts the bits to the left by a specified amount, `n`,\nwrapping the truncated bits to the end of the resulting integer.",513,{"inputs":[{"name":"u32"},{"name":"u32"}],"output":{"name":"u32"}}],[11,"rotate_right","","Shifts the bits to the right by a specified amount, `n`,\nwrapping the truncated bits to the beginning of the resulting\ninteger.",513,{"inputs":[{"name":"u32"},{"name":"u32"}],"output":{"name":"u32"}}],[11,"swap_bytes","","Reverses the byte order of the integer.",513,{"inputs":[{"name":"u32"}],"output":{"name":"u32"}}],[11,"from_be","","Converts an integer from big endian to the target's endianness.",513,{"inputs":[{"name":"u32"},{"name":"u32"}],"output":{"name":"u32"}}],[11,"from_le","","Converts an integer from little endian to the target's endianness.",513,{"inputs":[{"name":"u32"},{"name":"u32"}],"output":{"name":"u32"}}],[11,"to_be","","Converts `self` to big endian from the target's endianness.",513,{"inputs":[{"name":"u32"}],"output":{"name":"u32"}}],[11,"to_le","","Converts `self` to little endian from the target's endianness.",513,{"inputs":[{"name":"u32"}],"output":{"name":"u32"}}],[11,"checked_add","","Checked integer addition. Computes `self + other`, returning `None`\nif overflow occurred.",513,{"inputs":[{"name":"u32"},{"name":"u32"}],"output":{"name":"option"}}],[11,"checked_sub","","Checked integer subtraction. Computes `self - other`, returning\n`None` if underflow occurred.",513,{"inputs":[{"name":"u32"},{"name":"u32"}],"output":{"name":"option"}}],[11,"checked_mul","","Checked integer multiplication. Computes `self * other`, returning\n`None` if underflow or overflow occurred.",513,{"inputs":[{"name":"u32"},{"name":"u32"}],"output":{"name":"option"}}],[11,"checked_div","","Checked integer division. Computes `self / other`, returning `None`\nif `other == 0` or the operation results in underflow or overflow.",513,{"inputs":[{"name":"u32"},{"name":"u32"}],"output":{"name":"option"}}],[11,"saturating_add","","Saturating integer addition. Computes `self + other`, saturating at\nthe numeric bounds instead of overflowing.",513,{"inputs":[{"name":"u32"},{"name":"u32"}],"output":{"name":"u32"}}],[11,"saturating_sub","","Saturating integer subtraction. Computes `self - other`, saturating\nat the numeric bounds instead of overflowing.",513,{"inputs":[{"name":"u32"},{"name":"u32"}],"output":{"name":"u32"}}],[11,"wrapping_add","","Wrapping (modular) addition. Computes `self + other`,\nwrapping around at the boundary of the type.",513,{"inputs":[{"name":"u32"},{"name":"u32"}],"output":{"name":"u32"}}],[11,"wrapping_sub","","Wrapping (modular) subtraction. Computes `self - other`,\nwrapping around at the boundary of the type.",513,{"inputs":[{"name":"u32"},{"name":"u32"}],"output":{"name":"u32"}}],[11,"wrapping_mul","","Wrapping (modular) multiplication. Computes `self *\nother`, wrapping around at the boundary of the type.",513,{"inputs":[{"name":"u32"},{"name":"u32"}],"output":{"name":"u32"}}],[11,"wrapping_div","","Wrapping (modular) division. Computes `self / other`,\nwrapping around at the boundary of the type.",513,{"inputs":[{"name":"u32"},{"name":"u32"}],"output":{"name":"u32"}}],[11,"wrapping_rem","","Wrapping (modular) remainder. Computes `self % other`,\nwrapping around at the boundary of the type.",513,{"inputs":[{"name":"u32"},{"name":"u32"}],"output":{"name":"u32"}}],[11,"wrapping_neg","","Wrapping (modular) negation. Computes `-self`,\nwrapping around at the boundary of the type.",513,{"inputs":[{"name":"u32"}],"output":{"name":"u32"}}],[11,"wrapping_shl","","Panic-free bitwise shift-left; yields `self << mask(rhs)`,\nwhere `mask` removes any high-order bits of `rhs` that\nwould cause the shift to exceed the bitwidth of the type.",513,{"inputs":[{"name":"u32"},{"name":"u32"}],"output":{"name":"u32"}}],[11,"wrapping_shr","","Panic-free bitwise shift-left; yields `self >> mask(rhs)`,\nwhere `mask` removes any high-order bits of `rhs` that\nwould cause the shift to exceed the bitwidth of the type.",513,{"inputs":[{"name":"u32"},{"name":"u32"}],"output":{"name":"u32"}}],[11,"pow","","Raises self to the power of `exp`, using exponentiation by squaring.",513,{"inputs":[{"name":"u32"},{"name":"u32"}],"output":{"name":"u32"}}],[11,"is_power_of_two","","Returns `true` if and only if `self == 2^k` for some `k`.",513,{"inputs":[{"name":"u32"}],"output":{"name":"bool"}}],[11,"next_power_of_two","","Returns the smallest power of two greater than or equal to `self`.\nUnspecified behavior on overflow.",513,{"inputs":[{"name":"u32"}],"output":{"name":"u32"}}],[11,"checked_next_power_of_two","","Returns the smallest power of two greater than or equal to `n`. If\nthe next power of two is greater than the type's maximum value,\n`None` is returned, otherwise the power of two is wrapped in `Some`.",513,{"inputs":[{"name":"u32"}],"output":{"name":"option"}}],[11,"min_value","","Returns the smallest value that can be represented by this integer type.",514,{"inputs":[{"name":"u64"}],"output":{"name":"u64"}}],[11,"max_value","","Returns the largest value that can be represented by this integer type.",514,{"inputs":[{"name":"u64"}],"output":{"name":"u64"}}],[11,"from_str_radix","","Converts a string slice in a given base to an integer.",514,{"inputs":[{"name":"u64"},{"name":"str"},{"name":"u32"}],"output":{"name":"result"}}],[11,"count_ones","","Returns the number of ones in the binary representation of `self`.",514,{"inputs":[{"name":"u64"}],"output":{"name":"u32"}}],[11,"count_zeros","","Returns the number of zeros in the binary representation of `self`.",514,{"inputs":[{"name":"u64"}],"output":{"name":"u32"}}],[11,"leading_zeros","","Returns the number of leading zeros in the binary representation\nof `self`.",514,{"inputs":[{"name":"u64"}],"output":{"name":"u32"}}],[11,"trailing_zeros","","Returns the number of trailing zeros in the binary representation\nof `self`.",514,{"inputs":[{"name":"u64"}],"output":{"name":"u32"}}],[11,"rotate_left","","Shifts the bits to the left by a specified amount, `n`,\nwrapping the truncated bits to the end of the resulting integer.",514,{"inputs":[{"name":"u64"},{"name":"u32"}],"output":{"name":"u64"}}],[11,"rotate_right","","Shifts the bits to the right by a specified amount, `n`,\nwrapping the truncated bits to the beginning of the resulting\ninteger.",514,{"inputs":[{"name":"u64"},{"name":"u32"}],"output":{"name":"u64"}}],[11,"swap_bytes","","Reverses the byte order of the integer.",514,{"inputs":[{"name":"u64"}],"output":{"name":"u64"}}],[11,"from_be","","Converts an integer from big endian to the target's endianness.",514,{"inputs":[{"name":"u64"},{"name":"u64"}],"output":{"name":"u64"}}],[11,"from_le","","Converts an integer from little endian to the target's endianness.",514,{"inputs":[{"name":"u64"},{"name":"u64"}],"output":{"name":"u64"}}],[11,"to_be","","Converts `self` to big endian from the target's endianness.",514,{"inputs":[{"name":"u64"}],"output":{"name":"u64"}}],[11,"to_le","","Converts `self` to little endian from the target's endianness.",514,{"inputs":[{"name":"u64"}],"output":{"name":"u64"}}],[11,"checked_add","","Checked integer addition. Computes `self + other`, returning `None`\nif overflow occurred.",514,{"inputs":[{"name":"u64"},{"name":"u64"}],"output":{"name":"option"}}],[11,"checked_sub","","Checked integer subtraction. Computes `self - other`, returning\n`None` if underflow occurred.",514,{"inputs":[{"name":"u64"},{"name":"u64"}],"output":{"name":"option"}}],[11,"checked_mul","","Checked integer multiplication. Computes `self * other`, returning\n`None` if underflow or overflow occurred.",514,{"inputs":[{"name":"u64"},{"name":"u64"}],"output":{"name":"option"}}],[11,"checked_div","","Checked integer division. Computes `self / other`, returning `None`\nif `other == 0` or the operation results in underflow or overflow.",514,{"inputs":[{"name":"u64"},{"name":"u64"}],"output":{"name":"option"}}],[11,"saturating_add","","Saturating integer addition. Computes `self + other`, saturating at\nthe numeric bounds instead of overflowing.",514,{"inputs":[{"name":"u64"},{"name":"u64"}],"output":{"name":"u64"}}],[11,"saturating_sub","","Saturating integer subtraction. Computes `self - other`, saturating\nat the numeric bounds instead of overflowing.",514,{"inputs":[{"name":"u64"},{"name":"u64"}],"output":{"name":"u64"}}],[11,"wrapping_add","","Wrapping (modular) addition. Computes `self + other`,\nwrapping around at the boundary of the type.",514,{"inputs":[{"name":"u64"},{"name":"u64"}],"output":{"name":"u64"}}],[11,"wrapping_sub","","Wrapping (modular) subtraction. Computes `self - other`,\nwrapping around at the boundary of the type.",514,{"inputs":[{"name":"u64"},{"name":"u64"}],"output":{"name":"u64"}}],[11,"wrapping_mul","","Wrapping (modular) multiplication. Computes `self *\nother`, wrapping around at the boundary of the type.",514,{"inputs":[{"name":"u64"},{"name":"u64"}],"output":{"name":"u64"}}],[11,"wrapping_div","","Wrapping (modular) division. Computes `self / other`,\nwrapping around at the boundary of the type.",514,{"inputs":[{"name":"u64"},{"name":"u64"}],"output":{"name":"u64"}}],[11,"wrapping_rem","","Wrapping (modular) remainder. Computes `self % other`,\nwrapping around at the boundary of the type.",514,{"inputs":[{"name":"u64"},{"name":"u64"}],"output":{"name":"u64"}}],[11,"wrapping_neg","","Wrapping (modular) negation. Computes `-self`,\nwrapping around at the boundary of the type.",514,{"inputs":[{"name":"u64"}],"output":{"name":"u64"}}],[11,"wrapping_shl","","Panic-free bitwise shift-left; yields `self << mask(rhs)`,\nwhere `mask` removes any high-order bits of `rhs` that\nwould cause the shift to exceed the bitwidth of the type.",514,{"inputs":[{"name":"u64"},{"name":"u32"}],"output":{"name":"u64"}}],[11,"wrapping_shr","","Panic-free bitwise shift-left; yields `self >> mask(rhs)`,\nwhere `mask` removes any high-order bits of `rhs` that\nwould cause the shift to exceed the bitwidth of the type.",514,{"inputs":[{"name":"u64"},{"name":"u32"}],"output":{"name":"u64"}}],[11,"pow","","Raises self to the power of `exp`, using exponentiation by squaring.",514,{"inputs":[{"name":"u64"},{"name":"u32"}],"output":{"name":"u64"}}],[11,"is_power_of_two","","Returns `true` if and only if `self == 2^k` for some `k`.",514,{"inputs":[{"name":"u64"}],"output":{"name":"bool"}}],[11,"next_power_of_two","","Returns the smallest power of two greater than or equal to `self`.\nUnspecified behavior on overflow.",514,{"inputs":[{"name":"u64"}],"output":{"name":"u64"}}],[11,"checked_next_power_of_two","","Returns the smallest power of two greater than or equal to `n`. If\nthe next power of two is greater than the type's maximum value,\n`None` is returned, otherwise the power of two is wrapped in `Some`.",514,{"inputs":[{"name":"u64"}],"output":{"name":"option"}}],[11,"min_value","","Returns the smallest value that can be represented by this integer type.",515,{"inputs":[{"name":"usize"}],"output":{"name":"usize"}}],[11,"max_value","","Returns the largest value that can be represented by this integer type.",515,{"inputs":[{"name":"usize"}],"output":{"name":"usize"}}],[11,"from_str_radix","","Converts a string slice in a given base to an integer.",515,{"inputs":[{"name":"usize"},{"name":"str"},{"name":"u32"}],"output":{"name":"result"}}],[11,"count_ones","","Returns the number of ones in the binary representation of `self`.",515,{"inputs":[{"name":"usize"}],"output":{"name":"u32"}}],[11,"count_zeros","","Returns the number of zeros in the binary representation of `self`.",515,{"inputs":[{"name":"usize"}],"output":{"name":"u32"}}],[11,"leading_zeros","","Returns the number of leading zeros in the binary representation\nof `self`.",515,{"inputs":[{"name":"usize"}],"output":{"name":"u32"}}],[11,"trailing_zeros","","Returns the number of trailing zeros in the binary representation\nof `self`.",515,{"inputs":[{"name":"usize"}],"output":{"name":"u32"}}],[11,"rotate_left","","Shifts the bits to the left by a specified amount, `n`,\nwrapping the truncated bits to the end of the resulting integer.",515,{"inputs":[{"name":"usize"},{"name":"u32"}],"output":{"name":"usize"}}],[11,"rotate_right","","Shifts the bits to the right by a specified amount, `n`,\nwrapping the truncated bits to the beginning of the resulting\ninteger.",515,{"inputs":[{"name":"usize"},{"name":"u32"}],"output":{"name":"usize"}}],[11,"swap_bytes","","Reverses the byte order of the integer.",515,{"inputs":[{"name":"usize"}],"output":{"name":"usize"}}],[11,"from_be","","Converts an integer from big endian to the target's endianness.",515,{"inputs":[{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"from_le","","Converts an integer from little endian to the target's endianness.",515,{"inputs":[{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"to_be","","Converts `self` to big endian from the target's endianness.",515,{"inputs":[{"name":"usize"}],"output":{"name":"usize"}}],[11,"to_le","","Converts `self` to little endian from the target's endianness.",515,{"inputs":[{"name":"usize"}],"output":{"name":"usize"}}],[11,"checked_add","","Checked integer addition. Computes `self + other`, returning `None`\nif overflow occurred.",515,{"inputs":[{"name":"usize"},{"name":"usize"}],"output":{"name":"option"}}],[11,"checked_sub","","Checked integer subtraction. Computes `self - other`, returning\n`None` if underflow occurred.",515,{"inputs":[{"name":"usize"},{"name":"usize"}],"output":{"name":"option"}}],[11,"checked_mul","","Checked integer multiplication. Computes `self * other`, returning\n`None` if underflow or overflow occurred.",515,{"inputs":[{"name":"usize"},{"name":"usize"}],"output":{"name":"option"}}],[11,"checked_div","","Checked integer division. Computes `self / other`, returning `None`\nif `other == 0` or the operation results in underflow or overflow.",515,{"inputs":[{"name":"usize"},{"name":"usize"}],"output":{"name":"option"}}],[11,"saturating_add","","Saturating integer addition. Computes `self + other`, saturating at\nthe numeric bounds instead of overflowing.",515,{"inputs":[{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"saturating_sub","","Saturating integer subtraction. Computes `self - other`, saturating\nat the numeric bounds instead of overflowing.",515,{"inputs":[{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"wrapping_add","","Wrapping (modular) addition. Computes `self + other`,\nwrapping around at the boundary of the type.",515,{"inputs":[{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"wrapping_sub","","Wrapping (modular) subtraction. Computes `self - other`,\nwrapping around at the boundary of the type.",515,{"inputs":[{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"wrapping_mul","","Wrapping (modular) multiplication. Computes `self *\nother`, wrapping around at the boundary of the type.",515,{"inputs":[{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"wrapping_div","","Wrapping (modular) division. Computes `self / other`,\nwrapping around at the boundary of the type.",515,{"inputs":[{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"wrapping_rem","","Wrapping (modular) remainder. Computes `self % other`,\nwrapping around at the boundary of the type.",515,{"inputs":[{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"wrapping_neg","","Wrapping (modular) negation. Computes `-self`,\nwrapping around at the boundary of the type.",515,{"inputs":[{"name":"usize"}],"output":{"name":"usize"}}],[11,"wrapping_shl","","Panic-free bitwise shift-left; yields `self << mask(rhs)`,\nwhere `mask` removes any high-order bits of `rhs` that\nwould cause the shift to exceed the bitwidth of the type.",515,{"inputs":[{"name":"usize"},{"name":"u32"}],"output":{"name":"usize"}}],[11,"wrapping_shr","","Panic-free bitwise shift-left; yields `self >> mask(rhs)`,\nwhere `mask` removes any high-order bits of `rhs` that\nwould cause the shift to exceed the bitwidth of the type.",515,{"inputs":[{"name":"usize"},{"name":"u32"}],"output":{"name":"usize"}}],[11,"pow","","Raises self to the power of `exp`, using exponentiation by squaring.",515,{"inputs":[{"name":"usize"},{"name":"u32"}],"output":{"name":"usize"}}],[11,"is_power_of_two","","Returns `true` if and only if `self == 2^k` for some `k`.",515,{"inputs":[{"name":"usize"}],"output":{"name":"bool"}}],[11,"next_power_of_two","","Returns the smallest power of two greater than or equal to `self`.\nUnspecified behavior on overflow.",515,{"inputs":[{"name":"usize"}],"output":{"name":"usize"}}],[11,"checked_next_power_of_two","","Returns the smallest power of two greater than or equal to `n`. If\nthe next power of two is greater than the type's maximum value,\n`None` is returned, otherwise the power of two is wrapped in `Some`.",515,{"inputs":[{"name":"usize"}],"output":{"name":"option"}}],[11,"from_str","","Converts a string in base 10 to a float.\nAccepts an optional decimal exponent.",517,{"inputs":[{"name":"f32"},{"name":"str"}],"output":{"name":"result"}}],[11,"from_str","","Converts a string in base 10 to a float.\nAccepts an optional decimal exponent.",518,{"inputs":[{"name":"f64"},{"name":"str"}],"output":{"name":"result"}}],[11,"from_str","","",516,{"inputs":[{"name":"isize"},{"name":"str"}],"output":{"name":"result"}}],[11,"from_str","","",507,{"inputs":[{"name":"i8"},{"name":"str"}],"output":{"name":"result"}}],[11,"from_str","","",508,{"inputs":[{"name":"i16"},{"name":"str"}],"output":{"name":"result"}}],[11,"from_str","","",509,{"inputs":[{"name":"i32"},{"name":"str"}],"output":{"name":"result"}}],[11,"from_str","","",510,{"inputs":[{"name":"i64"},{"name":"str"}],"output":{"name":"result"}}],[11,"from_str","","",515,{"inputs":[{"name":"usize"},{"name":"str"}],"output":{"name":"result"}}],[11,"from_str","","",511,{"inputs":[{"name":"u8"},{"name":"str"}],"output":{"name":"result"}}],[11,"from_str","","",512,{"inputs":[{"name":"u16"},{"name":"str"}],"output":{"name":"result"}}],[11,"from_str","","",513,{"inputs":[{"name":"u32"},{"name":"str"}],"output":{"name":"result"}}],[11,"from_str","","",514,{"inputs":[{"name":"u64"},{"name":"str"}],"output":{"name":"result"}}],[11,"is_null","","Returns true if the pointer is null.",519,{"inputs":[{"name":"pointer"}],"output":{"name":"bool"}}],[11,"as_ref","","Returns `None` if the pointer is null, or else returns a reference to\nthe value wrapped in `Some`.",519,{"inputs":[{"name":"pointer"}],"output":{"name":"option"}}],[11,"offset","","Calculates the offset from a pointer. `count` is in units of T; e.g. a\n`count` of 3 represents a pointer offset of `3 * sizeof::<T>()` bytes.",519,null],[11,"is_null","","Returns true if the pointer is null.",519,{"inputs":[{"name":"pointer"}],"output":{"name":"bool"}}],[11,"as_ref","","Returns `None` if the pointer is null, or else returns a reference to\nthe value wrapped in `Some`.",519,{"inputs":[{"name":"pointer"}],"output":{"name":"option"}}],[11,"offset","","Calculates the offset from a pointer. `count` is in units of T; e.g. a\n`count` of 3 represents a pointer offset of `3 * sizeof::<T>()` bytes.",519,null],[11,"as_mut","","Returns `None` if the pointer is null, or else returns a mutable\nreference to the value wrapped in `Some`.",519,{"inputs":[{"name":"pointer"}],"output":{"name":"option"}}],[11,"eq","","",519,null],[11,"eq","","",519,null],[11,"clone","","",519,null],[11,"clone","","",519,null],[11,"cmp","","",519,null],[11,"partial_cmp","","",519,null],[11,"lt","","",519,null],[11,"le","","",519,null],[11,"gt","","",519,null],[11,"ge","","",519,null],[11,"cmp","","",519,null],[11,"partial_cmp","","",519,null],[11,"lt","","",519,null],[11,"le","","",519,null],[11,"gt","","",519,null],[11,"ge","","",519,null],[11,"add","","",515,{"inputs":[{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"add","","",515,null],[11,"add","","",515,null],[11,"add","","",515,null],[11,"add","","",511,{"inputs":[{"name":"u8"},{"name":"u8"}],"output":{"name":"u8"}}],[11,"add","","",511,null],[11,"add","","",511,null],[11,"add","","",511,null],[11,"add","","",512,{"inputs":[{"name":"u16"},{"name":"u16"}],"output":{"name":"u16"}}],[11,"add","","",512,null],[11,"add","","",512,null],[11,"add","","",512,null],[11,"add","","",513,{"inputs":[{"name":"u32"},{"name":"u32"}],"output":{"name":"u32"}}],[11,"add","","",513,null],[11,"add","","",513,null],[11,"add","","",513,null],[11,"add","","",514,{"inputs":[{"name":"u64"},{"name":"u64"}],"output":{"name":"u64"}}],[11,"add","","",514,null],[11,"add","","",514,null],[11,"add","","",514,null],[11,"add","","",516,{"inputs":[{"name":"isize"},{"name":"isize"}],"output":{"name":"isize"}}],[11,"add","","",516,null],[11,"add","","",516,null],[11,"add","","",516,null],[11,"add","","",507,{"inputs":[{"name":"i8"},{"name":"i8"}],"output":{"name":"i8"}}],[11,"add","","",507,null],[11,"add","","",507,null],[11,"add","","",507,null],[11,"add","","",508,{"inputs":[{"name":"i16"},{"name":"i16"}],"output":{"name":"i16"}}],[11,"add","","",508,null],[11,"add","","",508,null],[11,"add","","",508,null],[11,"add","","",509,{"inputs":[{"name":"i32"},{"name":"i32"}],"output":{"name":"i32"}}],[11,"add","","",509,null],[11,"add","","",509,null],[11,"add","","",509,null],[11,"add","","",510,{"inputs":[{"name":"i64"},{"name":"i64"}],"output":{"name":"i64"}}],[11,"add","","",510,null],[11,"add","","",510,null],[11,"add","","",510,null],[11,"add","","",517,{"inputs":[{"name":"f32"},{"name":"f32"}],"output":{"name":"f32"}}],[11,"add","","",517,null],[11,"add","","",517,null],[11,"add","","",517,null],[11,"add","","",518,{"inputs":[{"name":"f64"},{"name":"f64"}],"output":{"name":"f64"}}],[11,"add","","",518,null],[11,"add","","",518,null],[11,"add","","",518,null],[11,"sub","","",515,{"inputs":[{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"sub","","",515,null],[11,"sub","","",515,null],[11,"sub","","",515,null],[11,"sub","","",511,{"inputs":[{"name":"u8"},{"name":"u8"}],"output":{"name":"u8"}}],[11,"sub","","",511,null],[11,"sub","","",511,null],[11,"sub","","",511,null],[11,"sub","","",512,{"inputs":[{"name":"u16"},{"name":"u16"}],"output":{"name":"u16"}}],[11,"sub","","",512,null],[11,"sub","","",512,null],[11,"sub","","",512,null],[11,"sub","","",513,{"inputs":[{"name":"u32"},{"name":"u32"}],"output":{"name":"u32"}}],[11,"sub","","",513,null],[11,"sub","","",513,null],[11,"sub","","",513,null],[11,"sub","","",514,{"inputs":[{"name":"u64"},{"name":"u64"}],"output":{"name":"u64"}}],[11,"sub","","",514,null],[11,"sub","","",514,null],[11,"sub","","",514,null],[11,"sub","","",516,{"inputs":[{"name":"isize"},{"name":"isize"}],"output":{"name":"isize"}}],[11,"sub","","",516,null],[11,"sub","","",516,null],[11,"sub","","",516,null],[11,"sub","","",507,{"inputs":[{"name":"i8"},{"name":"i8"}],"output":{"name":"i8"}}],[11,"sub","","",507,null],[11,"sub","","",507,null],[11,"sub","","",507,null],[11,"sub","","",508,{"inputs":[{"name":"i16"},{"name":"i16"}],"output":{"name":"i16"}}],[11,"sub","","",508,null],[11,"sub","","",508,null],[11,"sub","","",508,null],[11,"sub","","",509,{"inputs":[{"name":"i32"},{"name":"i32"}],"output":{"name":"i32"}}],[11,"sub","","",509,null],[11,"sub","","",509,null],[11,"sub","","",509,null],[11,"sub","","",510,{"inputs":[{"name":"i64"},{"name":"i64"}],"output":{"name":"i64"}}],[11,"sub","","",510,null],[11,"sub","","",510,null],[11,"sub","","",510,null],[11,"sub","","",517,{"inputs":[{"name":"f32"},{"name":"f32"}],"output":{"name":"f32"}}],[11,"sub","","",517,null],[11,"sub","","",517,null],[11,"sub","","",517,null],[11,"sub","","",518,{"inputs":[{"name":"f64"},{"name":"f64"}],"output":{"name":"f64"}}],[11,"sub","","",518,null],[11,"sub","","",518,null],[11,"sub","","",518,null],[11,"mul","","",515,{"inputs":[{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"mul","","",515,null],[11,"mul","","",515,null],[11,"mul","","",515,null],[11,"mul","","",511,{"inputs":[{"name":"u8"},{"name":"u8"}],"output":{"name":"u8"}}],[11,"mul","","",511,null],[11,"mul","","",511,null],[11,"mul","","",511,null],[11,"mul","","",512,{"inputs":[{"name":"u16"},{"name":"u16"}],"output":{"name":"u16"}}],[11,"mul","","",512,null],[11,"mul","","",512,null],[11,"mul","","",512,null],[11,"mul","","",513,{"inputs":[{"name":"u32"},{"name":"u32"}],"output":{"name":"u32"}}],[11,"mul","","",513,null],[11,"mul","","",513,null],[11,"mul","","",513,null],[11,"mul","","",514,{"inputs":[{"name":"u64"},{"name":"u64"}],"output":{"name":"u64"}}],[11,"mul","","",514,null],[11,"mul","","",514,null],[11,"mul","","",514,null],[11,"mul","","",516,{"inputs":[{"name":"isize"},{"name":"isize"}],"output":{"name":"isize"}}],[11,"mul","","",516,null],[11,"mul","","",516,null],[11,"mul","","",516,null],[11,"mul","","",507,{"inputs":[{"name":"i8"},{"name":"i8"}],"output":{"name":"i8"}}],[11,"mul","","",507,null],[11,"mul","","",507,null],[11,"mul","","",507,null],[11,"mul","","",508,{"inputs":[{"name":"i16"},{"name":"i16"}],"output":{"name":"i16"}}],[11,"mul","","",508,null],[11,"mul","","",508,null],[11,"mul","","",508,null],[11,"mul","","",509,{"inputs":[{"name":"i32"},{"name":"i32"}],"output":{"name":"i32"}}],[11,"mul","","",509,null],[11,"mul","","",509,null],[11,"mul","","",509,null],[11,"mul","","",510,{"inputs":[{"name":"i64"},{"name":"i64"}],"output":{"name":"i64"}}],[11,"mul","","",510,null],[11,"mul","","",510,null],[11,"mul","","",510,null],[11,"mul","","",517,{"inputs":[{"name":"f32"},{"name":"f32"}],"output":{"name":"f32"}}],[11,"mul","","",517,null],[11,"mul","","",517,null],[11,"mul","","",517,null],[11,"mul","","",518,{"inputs":[{"name":"f64"},{"name":"f64"}],"output":{"name":"f64"}}],[11,"mul","","",518,null],[11,"mul","","",518,null],[11,"mul","","",518,null],[11,"div","","",515,{"inputs":[{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"div","","",515,null],[11,"div","","",515,null],[11,"div","","",515,null],[11,"div","","",511,{"inputs":[{"name":"u8"},{"name":"u8"}],"output":{"name":"u8"}}],[11,"div","","",511,null],[11,"div","","",511,null],[11,"div","","",511,null],[11,"div","","",512,{"inputs":[{"name":"u16"},{"name":"u16"}],"output":{"name":"u16"}}],[11,"div","","",512,null],[11,"div","","",512,null],[11,"div","","",512,null],[11,"div","","",513,{"inputs":[{"name":"u32"},{"name":"u32"}],"output":{"name":"u32"}}],[11,"div","","",513,null],[11,"div","","",513,null],[11,"div","","",513,null],[11,"div","","",514,{"inputs":[{"name":"u64"},{"name":"u64"}],"output":{"name":"u64"}}],[11,"div","","",514,null],[11,"div","","",514,null],[11,"div","","",514,null],[11,"div","","",516,{"inputs":[{"name":"isize"},{"name":"isize"}],"output":{"name":"isize"}}],[11,"div","","",516,null],[11,"div","","",516,null],[11,"div","","",516,null],[11,"div","","",507,{"inputs":[{"name":"i8"},{"name":"i8"}],"output":{"name":"i8"}}],[11,"div","","",507,null],[11,"div","","",507,null],[11,"div","","",507,null],[11,"div","","",508,{"inputs":[{"name":"i16"},{"name":"i16"}],"output":{"name":"i16"}}],[11,"div","","",508,null],[11,"div","","",508,null],[11,"div","","",508,null],[11,"div","","",509,{"inputs":[{"name":"i32"},{"name":"i32"}],"output":{"name":"i32"}}],[11,"div","","",509,null],[11,"div","","",509,null],[11,"div","","",509,null],[11,"div","","",510,{"inputs":[{"name":"i64"},{"name":"i64"}],"output":{"name":"i64"}}],[11,"div","","",510,null],[11,"div","","",510,null],[11,"div","","",510,null],[11,"div","","",517,{"inputs":[{"name":"f32"},{"name":"f32"}],"output":{"name":"f32"}}],[11,"div","","",517,null],[11,"div","","",517,null],[11,"div","","",517,null],[11,"div","","",518,{"inputs":[{"name":"f64"},{"name":"f64"}],"output":{"name":"f64"}}],[11,"div","","",518,null],[11,"div","","",518,null],[11,"div","","",518,null],[11,"rem","","",515,{"inputs":[{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"rem","","",515,null],[11,"rem","","",515,null],[11,"rem","","",515,null],[11,"rem","","",511,{"inputs":[{"name":"u8"},{"name":"u8"}],"output":{"name":"u8"}}],[11,"rem","","",511,null],[11,"rem","","",511,null],[11,"rem","","",511,null],[11,"rem","","",512,{"inputs":[{"name":"u16"},{"name":"u16"}],"output":{"name":"u16"}}],[11,"rem","","",512,null],[11,"rem","","",512,null],[11,"rem","","",512,null],[11,"rem","","",513,{"inputs":[{"name":"u32"},{"name":"u32"}],"output":{"name":"u32"}}],[11,"rem","","",513,null],[11,"rem","","",513,null],[11,"rem","","",513,null],[11,"rem","","",514,{"inputs":[{"name":"u64"},{"name":"u64"}],"output":{"name":"u64"}}],[11,"rem","","",514,null],[11,"rem","","",514,null],[11,"rem","","",514,null],[11,"rem","","",516,{"inputs":[{"name":"isize"},{"name":"isize"}],"output":{"name":"isize"}}],[11,"rem","","",516,null],[11,"rem","","",516,null],[11,"rem","","",516,null],[11,"rem","","",507,{"inputs":[{"name":"i8"},{"name":"i8"}],"output":{"name":"i8"}}],[11,"rem","","",507,null],[11,"rem","","",507,null],[11,"rem","","",507,null],[11,"rem","","",508,{"inputs":[{"name":"i16"},{"name":"i16"}],"output":{"name":"i16"}}],[11,"rem","","",508,null],[11,"rem","","",508,null],[11,"rem","","",508,null],[11,"rem","","",509,{"inputs":[{"name":"i32"},{"name":"i32"}],"output":{"name":"i32"}}],[11,"rem","","",509,null],[11,"rem","","",509,null],[11,"rem","","",509,null],[11,"rem","","",510,{"inputs":[{"name":"i64"},{"name":"i64"}],"output":{"name":"i64"}}],[11,"rem","","",510,null],[11,"rem","","",510,null],[11,"rem","","",510,null],[11,"rem","","",517,{"inputs":[{"name":"f32"},{"name":"f32"}],"output":{"name":"f32"}}],[11,"rem","","",518,{"inputs":[{"name":"f64"},{"name":"f64"}],"output":{"name":"f64"}}],[11,"rem","","",518,null],[11,"rem","","",518,null],[11,"rem","","",518,null],[11,"rem","","",517,null],[11,"rem","","",517,null],[11,"rem","","",517,null],[11,"neg","","",516,{"inputs":[{"name":"isize"}],"output":{"name":"isize"}}],[11,"neg","","",516,null],[11,"neg","","",507,{"inputs":[{"name":"i8"}],"output":{"name":"i8"}}],[11,"neg","","",507,null],[11,"neg","","",508,{"inputs":[{"name":"i16"}],"output":{"name":"i16"}}],[11,"neg","","",508,null],[11,"neg","","",509,{"inputs":[{"name":"i32"}],"output":{"name":"i32"}}],[11,"neg","","",509,null],[11,"neg","","",510,{"inputs":[{"name":"i64"}],"output":{"name":"i64"}}],[11,"neg","","",510,null],[11,"neg","","",517,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[11,"neg","","",517,null],[11,"neg","","",518,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[11,"neg","","",518,null],[11,"not","","",520,{"inputs":[{"name":"bool"}],"output":{"name":"bool"}}],[11,"not","","",520,null],[11,"not","","",515,{"inputs":[{"name":"usize"}],"output":{"name":"usize"}}],[11,"not","","",515,null],[11,"not","","",511,{"inputs":[{"name":"u8"}],"output":{"name":"u8"}}],[11,"not","","",511,null],[11,"not","","",512,{"inputs":[{"name":"u16"}],"output":{"name":"u16"}}],[11,"not","","",512,null],[11,"not","","",513,{"inputs":[{"name":"u32"}],"output":{"name":"u32"}}],[11,"not","","",513,null],[11,"not","","",514,{"inputs":[{"name":"u64"}],"output":{"name":"u64"}}],[11,"not","","",514,null],[11,"not","","",516,{"inputs":[{"name":"isize"}],"output":{"name":"isize"}}],[11,"not","","",516,null],[11,"not","","",507,{"inputs":[{"name":"i8"}],"output":{"name":"i8"}}],[11,"not","","",507,null],[11,"not","","",508,{"inputs":[{"name":"i16"}],"output":{"name":"i16"}}],[11,"not","","",508,null],[11,"not","","",509,{"inputs":[{"name":"i32"}],"output":{"name":"i32"}}],[11,"not","","",509,null],[11,"not","","",510,{"inputs":[{"name":"i64"}],"output":{"name":"i64"}}],[11,"not","","",510,null],[11,"bitand","","",520,{"inputs":[{"name":"bool"},{"name":"bool"}],"output":{"name":"bool"}}],[11,"bitand","","",520,null],[11,"bitand","","",520,null],[11,"bitand","","",520,null],[11,"bitand","","",515,{"inputs":[{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"bitand","","",515,null],[11,"bitand","","",515,null],[11,"bitand","","",515,null],[11,"bitand","","",511,{"inputs":[{"name":"u8"},{"name":"u8"}],"output":{"name":"u8"}}],[11,"bitand","","",511,null],[11,"bitand","","",511,null],[11,"bitand","","",511,null],[11,"bitand","","",512,{"inputs":[{"name":"u16"},{"name":"u16"}],"output":{"name":"u16"}}],[11,"bitand","","",512,null],[11,"bitand","","",512,null],[11,"bitand","","",512,null],[11,"bitand","","",513,{"inputs":[{"name":"u32"},{"name":"u32"}],"output":{"name":"u32"}}],[11,"bitand","","",513,null],[11,"bitand","","",513,null],[11,"bitand","","",513,null],[11,"bitand","","",514,{"inputs":[{"name":"u64"},{"name":"u64"}],"output":{"name":"u64"}}],[11,"bitand","","",514,null],[11,"bitand","","",514,null],[11,"bitand","","",514,null],[11,"bitand","","",516,{"inputs":[{"name":"isize"},{"name":"isize"}],"output":{"name":"isize"}}],[11,"bitand","","",516,null],[11,"bitand","","",516,null],[11,"bitand","","",516,null],[11,"bitand","","",507,{"inputs":[{"name":"i8"},{"name":"i8"}],"output":{"name":"i8"}}],[11,"bitand","","",507,null],[11,"bitand","","",507,null],[11,"bitand","","",507,null],[11,"bitand","","",508,{"inputs":[{"name":"i16"},{"name":"i16"}],"output":{"name":"i16"}}],[11,"bitand","","",508,null],[11,"bitand","","",508,null],[11,"bitand","","",508,null],[11,"bitand","","",509,{"inputs":[{"name":"i32"},{"name":"i32"}],"output":{"name":"i32"}}],[11,"bitand","","",509,null],[11,"bitand","","",509,null],[11,"bitand","","",509,null],[11,"bitand","","",510,{"inputs":[{"name":"i64"},{"name":"i64"}],"output":{"name":"i64"}}],[11,"bitand","","",510,null],[11,"bitand","","",510,null],[11,"bitand","","",510,null],[11,"bitor","","",520,{"inputs":[{"name":"bool"},{"name":"bool"}],"output":{"name":"bool"}}],[11,"bitor","","",520,null],[11,"bitor","","",520,null],[11,"bitor","","",520,null],[11,"bitor","","",515,{"inputs":[{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"bitor","","",515,null],[11,"bitor","","",515,null],[11,"bitor","","",515,null],[11,"bitor","","",511,{"inputs":[{"name":"u8"},{"name":"u8"}],"output":{"name":"u8"}}],[11,"bitor","","",511,null],[11,"bitor","","",511,null],[11,"bitor","","",511,null],[11,"bitor","","",512,{"inputs":[{"name":"u16"},{"name":"u16"}],"output":{"name":"u16"}}],[11,"bitor","","",512,null],[11,"bitor","","",512,null],[11,"bitor","","",512,null],[11,"bitor","","",513,{"inputs":[{"name":"u32"},{"name":"u32"}],"output":{"name":"u32"}}],[11,"bitor","","",513,null],[11,"bitor","","",513,null],[11,"bitor","","",513,null],[11,"bitor","","",514,{"inputs":[{"name":"u64"},{"name":"u64"}],"output":{"name":"u64"}}],[11,"bitor","","",514,null],[11,"bitor","","",514,null],[11,"bitor","","",514,null],[11,"bitor","","",516,{"inputs":[{"name":"isize"},{"name":"isize"}],"output":{"name":"isize"}}],[11,"bitor","","",516,null],[11,"bitor","","",516,null],[11,"bitor","","",516,null],[11,"bitor","","",507,{"inputs":[{"name":"i8"},{"name":"i8"}],"output":{"name":"i8"}}],[11,"bitor","","",507,null],[11,"bitor","","",507,null],[11,"bitor","","",507,null],[11,"bitor","","",508,{"inputs":[{"name":"i16"},{"name":"i16"}],"output":{"name":"i16"}}],[11,"bitor","","",508,null],[11,"bitor","","",508,null],[11,"bitor","","",508,null],[11,"bitor","","",509,{"inputs":[{"name":"i32"},{"name":"i32"}],"output":{"name":"i32"}}],[11,"bitor","","",509,null],[11,"bitor","","",509,null],[11,"bitor","","",509,null],[11,"bitor","","",510,{"inputs":[{"name":"i64"},{"name":"i64"}],"output":{"name":"i64"}}],[11,"bitor","","",510,null],[11,"bitor","","",510,null],[11,"bitor","","",510,null],[11,"bitxor","","",520,{"inputs":[{"name":"bool"},{"name":"bool"}],"output":{"name":"bool"}}],[11,"bitxor","","",520,null],[11,"bitxor","","",520,null],[11,"bitxor","","",520,null],[11,"bitxor","","",515,{"inputs":[{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"bitxor","","",515,null],[11,"bitxor","","",515,null],[11,"bitxor","","",515,null],[11,"bitxor","","",511,{"inputs":[{"name":"u8"},{"name":"u8"}],"output":{"name":"u8"}}],[11,"bitxor","","",511,null],[11,"bitxor","","",511,null],[11,"bitxor","","",511,null],[11,"bitxor","","",512,{"inputs":[{"name":"u16"},{"name":"u16"}],"output":{"name":"u16"}}],[11,"bitxor","","",512,null],[11,"bitxor","","",512,null],[11,"bitxor","","",512,null],[11,"bitxor","","",513,{"inputs":[{"name":"u32"},{"name":"u32"}],"output":{"name":"u32"}}],[11,"bitxor","","",513,null],[11,"bitxor","","",513,null],[11,"bitxor","","",513,null],[11,"bitxor","","",514,{"inputs":[{"name":"u64"},{"name":"u64"}],"output":{"name":"u64"}}],[11,"bitxor","","",514,null],[11,"bitxor","","",514,null],[11,"bitxor","","",514,null],[11,"bitxor","","",516,{"inputs":[{"name":"isize"},{"name":"isize"}],"output":{"name":"isize"}}],[11,"bitxor","","",516,null],[11,"bitxor","","",516,null],[11,"bitxor","","",516,null],[11,"bitxor","","",507,{"inputs":[{"name":"i8"},{"name":"i8"}],"output":{"name":"i8"}}],[11,"bitxor","","",507,null],[11,"bitxor","","",507,null],[11,"bitxor","","",507,null],[11,"bitxor","","",508,{"inputs":[{"name":"i16"},{"name":"i16"}],"output":{"name":"i16"}}],[11,"bitxor","","",508,null],[11,"bitxor","","",508,null],[11,"bitxor","","",508,null],[11,"bitxor","","",509,{"inputs":[{"name":"i32"},{"name":"i32"}],"output":{"name":"i32"}}],[11,"bitxor","","",509,null],[11,"bitxor","","",509,null],[11,"bitxor","","",509,null],[11,"bitxor","","",510,{"inputs":[{"name":"i64"},{"name":"i64"}],"output":{"name":"i64"}}],[11,"bitxor","","",510,null],[11,"bitxor","","",510,null],[11,"bitxor","","",510,null],[11,"shl","","",511,{"inputs":[{"name":"u8"},{"name":"u8"}],"output":{"name":"u8"}}],[11,"shl","","",511,null],[11,"shl","","",511,null],[11,"shl","","",511,null],[11,"shl","","",511,{"inputs":[{"name":"u8"},{"name":"u16"}],"output":{"name":"u8"}}],[11,"shl","","",511,null],[11,"shl","","",511,null],[11,"shl","","",511,null],[11,"shl","","",511,{"inputs":[{"name":"u8"},{"name":"u32"}],"output":{"name":"u8"}}],[11,"shl","","",511,null],[11,"shl","","",511,null],[11,"shl","","",511,null],[11,"shl","","",511,{"inputs":[{"name":"u8"},{"name":"u64"}],"output":{"name":"u8"}}],[11,"shl","","",511,null],[11,"shl","","",511,null],[11,"shl","","",511,null],[11,"shl","","",511,{"inputs":[{"name":"u8"},{"name":"usize"}],"output":{"name":"u8"}}],[11,"shl","","",511,null],[11,"shl","","",511,null],[11,"shl","","",511,null],[11,"shl","","",511,{"inputs":[{"name":"u8"},{"name":"i8"}],"output":{"name":"u8"}}],[11,"shl","","",511,null],[11,"shl","","",511,null],[11,"shl","","",511,null],[11,"shl","","",511,{"inputs":[{"name":"u8"},{"name":"i16"}],"output":{"name":"u8"}}],[11,"shl","","",511,null],[11,"shl","","",511,null],[11,"shl","","",511,null],[11,"shl","","",511,{"inputs":[{"name":"u8"},{"name":"i32"}],"output":{"name":"u8"}}],[11,"shl","","",511,null],[11,"shl","","",511,null],[11,"shl","","",511,null],[11,"shl","","",511,{"inputs":[{"name":"u8"},{"name":"i64"}],"output":{"name":"u8"}}],[11,"shl","","",511,null],[11,"shl","","",511,null],[11,"shl","","",511,null],[11,"shl","","",511,{"inputs":[{"name":"u8"},{"name":"isize"}],"output":{"name":"u8"}}],[11,"shl","","",511,null],[11,"shl","","",511,null],[11,"shl","","",511,null],[11,"shl","","",512,{"inputs":[{"name":"u16"},{"name":"u8"}],"output":{"name":"u16"}}],[11,"shl","","",512,null],[11,"shl","","",512,null],[11,"shl","","",512,null],[11,"shl","","",512,{"inputs":[{"name":"u16"},{"name":"u16"}],"output":{"name":"u16"}}],[11,"shl","","",512,null],[11,"shl","","",512,null],[11,"shl","","",512,null],[11,"shl","","",512,{"inputs":[{"name":"u16"},{"name":"u32"}],"output":{"name":"u16"}}],[11,"shl","","",512,null],[11,"shl","","",512,null],[11,"shl","","",512,null],[11,"shl","","",512,{"inputs":[{"name":"u16"},{"name":"u64"}],"output":{"name":"u16"}}],[11,"shl","","",512,null],[11,"shl","","",512,null],[11,"shl","","",512,null],[11,"shl","","",512,{"inputs":[{"name":"u16"},{"name":"usize"}],"output":{"name":"u16"}}],[11,"shl","","",512,null],[11,"shl","","",512,null],[11,"shl","","",512,null],[11,"shl","","",512,{"inputs":[{"name":"u16"},{"name":"i8"}],"output":{"name":"u16"}}],[11,"shl","","",512,null],[11,"shl","","",512,null],[11,"shl","","",512,null],[11,"shl","","",512,{"inputs":[{"name":"u16"},{"name":"i16"}],"output":{"name":"u16"}}],[11,"shl","","",512,null],[11,"shl","","",512,null],[11,"shl","","",512,null],[11,"shl","","",512,{"inputs":[{"name":"u16"},{"name":"i32"}],"output":{"name":"u16"}}],[11,"shl","","",512,null],[11,"shl","","",512,null],[11,"shl","","",512,null],[11,"shl","","",512,{"inputs":[{"name":"u16"},{"name":"i64"}],"output":{"name":"u16"}}],[11,"shl","","",512,null],[11,"shl","","",512,null],[11,"shl","","",512,null],[11,"shl","","",512,{"inputs":[{"name":"u16"},{"name":"isize"}],"output":{"name":"u16"}}],[11,"shl","","",512,null],[11,"shl","","",512,null],[11,"shl","","",512,null],[11,"shl","","",513,{"inputs":[{"name":"u32"},{"name":"u8"}],"output":{"name":"u32"}}],[11,"shl","","",513,null],[11,"shl","","",513,null],[11,"shl","","",513,null],[11,"shl","","",513,{"inputs":[{"name":"u32"},{"name":"u16"}],"output":{"name":"u32"}}],[11,"shl","","",513,null],[11,"shl","","",513,null],[11,"shl","","",513,null],[11,"shl","","",513,{"inputs":[{"name":"u32"},{"name":"u32"}],"output":{"name":"u32"}}],[11,"shl","","",513,null],[11,"shl","","",513,null],[11,"shl","","",513,null],[11,"shl","","",513,{"inputs":[{"name":"u32"},{"name":"u64"}],"output":{"name":"u32"}}],[11,"shl","","",513,null],[11,"shl","","",513,null],[11,"shl","","",513,null],[11,"shl","","",513,{"inputs":[{"name":"u32"},{"name":"usize"}],"output":{"name":"u32"}}],[11,"shl","","",513,null],[11,"shl","","",513,null],[11,"shl","","",513,null],[11,"shl","","",513,{"inputs":[{"name":"u32"},{"name":"i8"}],"output":{"name":"u32"}}],[11,"shl","","",513,null],[11,"shl","","",513,null],[11,"shl","","",513,null],[11,"shl","","",513,{"inputs":[{"name":"u32"},{"name":"i16"}],"output":{"name":"u32"}}],[11,"shl","","",513,null],[11,"shl","","",513,null],[11,"shl","","",513,null],[11,"shl","","",513,{"inputs":[{"name":"u32"},{"name":"i32"}],"output":{"name":"u32"}}],[11,"shl","","",513,null],[11,"shl","","",513,null],[11,"shl","","",513,null],[11,"shl","","",513,{"inputs":[{"name":"u32"},{"name":"i64"}],"output":{"name":"u32"}}],[11,"shl","","",513,null],[11,"shl","","",513,null],[11,"shl","","",513,null],[11,"shl","","",513,{"inputs":[{"name":"u32"},{"name":"isize"}],"output":{"name":"u32"}}],[11,"shl","","",513,null],[11,"shl","","",513,null],[11,"shl","","",513,null],[11,"shl","","",514,{"inputs":[{"name":"u64"},{"name":"u8"}],"output":{"name":"u64"}}],[11,"shl","","",514,null],[11,"shl","","",514,null],[11,"shl","","",514,null],[11,"shl","","",514,{"inputs":[{"name":"u64"},{"name":"u16"}],"output":{"name":"u64"}}],[11,"shl","","",514,null],[11,"shl","","",514,null],[11,"shl","","",514,null],[11,"shl","","",514,{"inputs":[{"name":"u64"},{"name":"u32"}],"output":{"name":"u64"}}],[11,"shl","","",514,null],[11,"shl","","",514,null],[11,"shl","","",514,null],[11,"shl","","",514,{"inputs":[{"name":"u64"},{"name":"u64"}],"output":{"name":"u64"}}],[11,"shl","","",514,null],[11,"shl","","",514,null],[11,"shl","","",514,null],[11,"shl","","",514,{"inputs":[{"name":"u64"},{"name":"usize"}],"output":{"name":"u64"}}],[11,"shl","","",514,null],[11,"shl","","",514,null],[11,"shl","","",514,null],[11,"shl","","",514,{"inputs":[{"name":"u64"},{"name":"i8"}],"output":{"name":"u64"}}],[11,"shl","","",514,null],[11,"shl","","",514,null],[11,"shl","","",514,null],[11,"shl","","",514,{"inputs":[{"name":"u64"},{"name":"i16"}],"output":{"name":"u64"}}],[11,"shl","","",514,null],[11,"shl","","",514,null],[11,"shl","","",514,null],[11,"shl","","",514,{"inputs":[{"name":"u64"},{"name":"i32"}],"output":{"name":"u64"}}],[11,"shl","","",514,null],[11,"shl","","",514,null],[11,"shl","","",514,null],[11,"shl","","",514,{"inputs":[{"name":"u64"},{"name":"i64"}],"output":{"name":"u64"}}],[11,"shl","","",514,null],[11,"shl","","",514,null],[11,"shl","","",514,null],[11,"shl","","",514,{"inputs":[{"name":"u64"},{"name":"isize"}],"output":{"name":"u64"}}],[11,"shl","","",514,null],[11,"shl","","",514,null],[11,"shl","","",514,null],[11,"shl","","",515,{"inputs":[{"name":"usize"},{"name":"u8"}],"output":{"name":"usize"}}],[11,"shl","","",515,null],[11,"shl","","",515,null],[11,"shl","","",515,null],[11,"shl","","",515,{"inputs":[{"name":"usize"},{"name":"u16"}],"output":{"name":"usize"}}],[11,"shl","","",515,null],[11,"shl","","",515,null],[11,"shl","","",515,null],[11,"shl","","",515,{"inputs":[{"name":"usize"},{"name":"u32"}],"output":{"name":"usize"}}],[11,"shl","","",515,null],[11,"shl","","",515,null],[11,"shl","","",515,null],[11,"shl","","",515,{"inputs":[{"name":"usize"},{"name":"u64"}],"output":{"name":"usize"}}],[11,"shl","","",515,null],[11,"shl","","",515,null],[11,"shl","","",515,null],[11,"shl","","",515,{"inputs":[{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"shl","","",515,null],[11,"shl","","",515,null],[11,"shl","","",515,null],[11,"shl","","",515,{"inputs":[{"name":"usize"},{"name":"i8"}],"output":{"name":"usize"}}],[11,"shl","","",515,null],[11,"shl","","",515,null],[11,"shl","","",515,null],[11,"shl","","",515,{"inputs":[{"name":"usize"},{"name":"i16"}],"output":{"name":"usize"}}],[11,"shl","","",515,null],[11,"shl","","",515,null],[11,"shl","","",515,null],[11,"shl","","",515,{"inputs":[{"name":"usize"},{"name":"i32"}],"output":{"name":"usize"}}],[11,"shl","","",515,null],[11,"shl","","",515,null],[11,"shl","","",515,null],[11,"shl","","",515,{"inputs":[{"name":"usize"},{"name":"i64"}],"output":{"name":"usize"}}],[11,"shl","","",515,null],[11,"shl","","",515,null],[11,"shl","","",515,null],[11,"shl","","",515,{"inputs":[{"name":"usize"},{"name":"isize"}],"output":{"name":"usize"}}],[11,"shl","","",515,null],[11,"shl","","",515,null],[11,"shl","","",515,null],[11,"shl","","",507,{"inputs":[{"name":"i8"},{"name":"u8"}],"output":{"name":"i8"}}],[11,"shl","","",507,null],[11,"shl","","",507,null],[11,"shl","","",507,null],[11,"shl","","",507,{"inputs":[{"name":"i8"},{"name":"u16"}],"output":{"name":"i8"}}],[11,"shl","","",507,null],[11,"shl","","",507,null],[11,"shl","","",507,null],[11,"shl","","",507,{"inputs":[{"name":"i8"},{"name":"u32"}],"output":{"name":"i8"}}],[11,"shl","","",507,null],[11,"shl","","",507,null],[11,"shl","","",507,null],[11,"shl","","",507,{"inputs":[{"name":"i8"},{"name":"u64"}],"output":{"name":"i8"}}],[11,"shl","","",507,null],[11,"shl","","",507,null],[11,"shl","","",507,null],[11,"shl","","",507,{"inputs":[{"name":"i8"},{"name":"usize"}],"output":{"name":"i8"}}],[11,"shl","","",507,null],[11,"shl","","",507,null],[11,"shl","","",507,null],[11,"shl","","",507,{"inputs":[{"name":"i8"},{"name":"i8"}],"output":{"name":"i8"}}],[11,"shl","","",507,null],[11,"shl","","",507,null],[11,"shl","","",507,null],[11,"shl","","",507,{"inputs":[{"name":"i8"},{"name":"i16"}],"output":{"name":"i8"}}],[11,"shl","","",507,null],[11,"shl","","",507,null],[11,"shl","","",507,null],[11,"shl","","",507,{"inputs":[{"name":"i8"},{"name":"i32"}],"output":{"name":"i8"}}],[11,"shl","","",507,null],[11,"shl","","",507,null],[11,"shl","","",507,null],[11,"shl","","",507,{"inputs":[{"name":"i8"},{"name":"i64"}],"output":{"name":"i8"}}],[11,"shl","","",507,null],[11,"shl","","",507,null],[11,"shl","","",507,null],[11,"shl","","",507,{"inputs":[{"name":"i8"},{"name":"isize"}],"output":{"name":"i8"}}],[11,"shl","","",507,null],[11,"shl","","",507,null],[11,"shl","","",507,null],[11,"shl","","",508,{"inputs":[{"name":"i16"},{"name":"u8"}],"output":{"name":"i16"}}],[11,"shl","","",508,null],[11,"shl","","",508,null],[11,"shl","","",508,null],[11,"shl","","",508,{"inputs":[{"name":"i16"},{"name":"u16"}],"output":{"name":"i16"}}],[11,"shl","","",508,null],[11,"shl","","",508,null],[11,"shl","","",508,null],[11,"shl","","",508,{"inputs":[{"name":"i16"},{"name":"u32"}],"output":{"name":"i16"}}],[11,"shl","","",508,null],[11,"shl","","",508,null],[11,"shl","","",508,null],[11,"shl","","",508,{"inputs":[{"name":"i16"},{"name":"u64"}],"output":{"name":"i16"}}],[11,"shl","","",508,null],[11,"shl","","",508,null],[11,"shl","","",508,null],[11,"shl","","",508,{"inputs":[{"name":"i16"},{"name":"usize"}],"output":{"name":"i16"}}],[11,"shl","","",508,null],[11,"shl","","",508,null],[11,"shl","","",508,null],[11,"shl","","",508,{"inputs":[{"name":"i16"},{"name":"i8"}],"output":{"name":"i16"}}],[11,"shl","","",508,null],[11,"shl","","",508,null],[11,"shl","","",508,null],[11,"shl","","",508,{"inputs":[{"name":"i16"},{"name":"i16"}],"output":{"name":"i16"}}],[11,"shl","","",508,null],[11,"shl","","",508,null],[11,"shl","","",508,null],[11,"shl","","",508,{"inputs":[{"name":"i16"},{"name":"i32"}],"output":{"name":"i16"}}],[11,"shl","","",508,null],[11,"shl","","",508,null],[11,"shl","","",508,null],[11,"shl","","",508,{"inputs":[{"name":"i16"},{"name":"i64"}],"output":{"name":"i16"}}],[11,"shl","","",508,null],[11,"shl","","",508,null],[11,"shl","","",508,null],[11,"shl","","",508,{"inputs":[{"name":"i16"},{"name":"isize"}],"output":{"name":"i16"}}],[11,"shl","","",508,null],[11,"shl","","",508,null],[11,"shl","","",508,null],[11,"shl","","",509,{"inputs":[{"name":"i32"},{"name":"u8"}],"output":{"name":"i32"}}],[11,"shl","","",509,null],[11,"shl","","",509,null],[11,"shl","","",509,null],[11,"shl","","",509,{"inputs":[{"name":"i32"},{"name":"u16"}],"output":{"name":"i32"}}],[11,"shl","","",509,null],[11,"shl","","",509,null],[11,"shl","","",509,null],[11,"shl","","",509,{"inputs":[{"name":"i32"},{"name":"u32"}],"output":{"name":"i32"}}],[11,"shl","","",509,null],[11,"shl","","",509,null],[11,"shl","","",509,null],[11,"shl","","",509,{"inputs":[{"name":"i32"},{"name":"u64"}],"output":{"name":"i32"}}],[11,"shl","","",509,null],[11,"shl","","",509,null],[11,"shl","","",509,null],[11,"shl","","",509,{"inputs":[{"name":"i32"},{"name":"usize"}],"output":{"name":"i32"}}],[11,"shl","","",509,null],[11,"shl","","",509,null],[11,"shl","","",509,null],[11,"shl","","",509,{"inputs":[{"name":"i32"},{"name":"i8"}],"output":{"name":"i32"}}],[11,"shl","","",509,null],[11,"shl","","",509,null],[11,"shl","","",509,null],[11,"shl","","",509,{"inputs":[{"name":"i32"},{"name":"i16"}],"output":{"name":"i32"}}],[11,"shl","","",509,null],[11,"shl","","",509,null],[11,"shl","","",509,null],[11,"shl","","",509,{"inputs":[{"name":"i32"},{"name":"i32"}],"output":{"name":"i32"}}],[11,"shl","","",509,null],[11,"shl","","",509,null],[11,"shl","","",509,null],[11,"shl","","",509,{"inputs":[{"name":"i32"},{"name":"i64"}],"output":{"name":"i32"}}],[11,"shl","","",509,null],[11,"shl","","",509,null],[11,"shl","","",509,null],[11,"shl","","",509,{"inputs":[{"name":"i32"},{"name":"isize"}],"output":{"name":"i32"}}],[11,"shl","","",509,null],[11,"shl","","",509,null],[11,"shl","","",509,null],[11,"shl","","",510,{"inputs":[{"name":"i64"},{"name":"u8"}],"output":{"name":"i64"}}],[11,"shl","","",510,null],[11,"shl","","",510,null],[11,"shl","","",510,null],[11,"shl","","",510,{"inputs":[{"name":"i64"},{"name":"u16"}],"output":{"name":"i64"}}],[11,"shl","","",510,null],[11,"shl","","",510,null],[11,"shl","","",510,null],[11,"shl","","",510,{"inputs":[{"name":"i64"},{"name":"u32"}],"output":{"name":"i64"}}],[11,"shl","","",510,null],[11,"shl","","",510,null],[11,"shl","","",510,null],[11,"shl","","",510,{"inputs":[{"name":"i64"},{"name":"u64"}],"output":{"name":"i64"}}],[11,"shl","","",510,null],[11,"shl","","",510,null],[11,"shl","","",510,null],[11,"shl","","",510,{"inputs":[{"name":"i64"},{"name":"usize"}],"output":{"name":"i64"}}],[11,"shl","","",510,null],[11,"shl","","",510,null],[11,"shl","","",510,null],[11,"shl","","",510,{"inputs":[{"name":"i64"},{"name":"i8"}],"output":{"name":"i64"}}],[11,"shl","","",510,null],[11,"shl","","",510,null],[11,"shl","","",510,null],[11,"shl","","",510,{"inputs":[{"name":"i64"},{"name":"i16"}],"output":{"name":"i64"}}],[11,"shl","","",510,null],[11,"shl","","",510,null],[11,"shl","","",510,null],[11,"shl","","",510,{"inputs":[{"name":"i64"},{"name":"i32"}],"output":{"name":"i64"}}],[11,"shl","","",510,null],[11,"shl","","",510,null],[11,"shl","","",510,null],[11,"shl","","",510,{"inputs":[{"name":"i64"},{"name":"i64"}],"output":{"name":"i64"}}],[11,"shl","","",510,null],[11,"shl","","",510,null],[11,"shl","","",510,null],[11,"shl","","",510,{"inputs":[{"name":"i64"},{"name":"isize"}],"output":{"name":"i64"}}],[11,"shl","","",510,null],[11,"shl","","",510,null],[11,"shl","","",510,null],[11,"shl","","",516,{"inputs":[{"name":"isize"},{"name":"u8"}],"output":{"name":"isize"}}],[11,"shl","","",516,null],[11,"shl","","",516,null],[11,"shl","","",516,null],[11,"shl","","",516,{"inputs":[{"name":"isize"},{"name":"u16"}],"output":{"name":"isize"}}],[11,"shl","","",516,null],[11,"shl","","",516,null],[11,"shl","","",516,null],[11,"shl","","",516,{"inputs":[{"name":"isize"},{"name":"u32"}],"output":{"name":"isize"}}],[11,"shl","","",516,null],[11,"shl","","",516,null],[11,"shl","","",516,null],[11,"shl","","",516,{"inputs":[{"name":"isize"},{"name":"u64"}],"output":{"name":"isize"}}],[11,"shl","","",516,null],[11,"shl","","",516,null],[11,"shl","","",516,null],[11,"shl","","",516,{"inputs":[{"name":"isize"},{"name":"usize"}],"output":{"name":"isize"}}],[11,"shl","","",516,null],[11,"shl","","",516,null],[11,"shl","","",516,null],[11,"shl","","",516,{"inputs":[{"name":"isize"},{"name":"i8"}],"output":{"name":"isize"}}],[11,"shl","","",516,null],[11,"shl","","",516,null],[11,"shl","","",516,null],[11,"shl","","",516,{"inputs":[{"name":"isize"},{"name":"i16"}],"output":{"name":"isize"}}],[11,"shl","","",516,null],[11,"shl","","",516,null],[11,"shl","","",516,null],[11,"shl","","",516,{"inputs":[{"name":"isize"},{"name":"i32"}],"output":{"name":"isize"}}],[11,"shl","","",516,null],[11,"shl","","",516,null],[11,"shl","","",516,null],[11,"shl","","",516,{"inputs":[{"name":"isize"},{"name":"i64"}],"output":{"name":"isize"}}],[11,"shl","","",516,null],[11,"shl","","",516,null],[11,"shl","","",516,null],[11,"shl","","",516,{"inputs":[{"name":"isize"},{"name":"isize"}],"output":{"name":"isize"}}],[11,"shl","","",516,null],[11,"shl","","",516,null],[11,"shl","","",516,null],[11,"shr","","",511,{"inputs":[{"name":"u8"},{"name":"u8"}],"output":{"name":"u8"}}],[11,"shr","","",511,null],[11,"shr","","",511,null],[11,"shr","","",511,null],[11,"shr","","",511,{"inputs":[{"name":"u8"},{"name":"u16"}],"output":{"name":"u8"}}],[11,"shr","","",511,null],[11,"shr","","",511,null],[11,"shr","","",511,null],[11,"shr","","",511,{"inputs":[{"name":"u8"},{"name":"u32"}],"output":{"name":"u8"}}],[11,"shr","","",511,null],[11,"shr","","",511,null],[11,"shr","","",511,null],[11,"shr","","",511,{"inputs":[{"name":"u8"},{"name":"u64"}],"output":{"name":"u8"}}],[11,"shr","","",511,null],[11,"shr","","",511,null],[11,"shr","","",511,null],[11,"shr","","",511,{"inputs":[{"name":"u8"},{"name":"usize"}],"output":{"name":"u8"}}],[11,"shr","","",511,null],[11,"shr","","",511,null],[11,"shr","","",511,null],[11,"shr","","",511,{"inputs":[{"name":"u8"},{"name":"i8"}],"output":{"name":"u8"}}],[11,"shr","","",511,null],[11,"shr","","",511,null],[11,"shr","","",511,null],[11,"shr","","",511,{"inputs":[{"name":"u8"},{"name":"i16"}],"output":{"name":"u8"}}],[11,"shr","","",511,null],[11,"shr","","",511,null],[11,"shr","","",511,null],[11,"shr","","",511,{"inputs":[{"name":"u8"},{"name":"i32"}],"output":{"name":"u8"}}],[11,"shr","","",511,null],[11,"shr","","",511,null],[11,"shr","","",511,null],[11,"shr","","",511,{"inputs":[{"name":"u8"},{"name":"i64"}],"output":{"name":"u8"}}],[11,"shr","","",511,null],[11,"shr","","",511,null],[11,"shr","","",511,null],[11,"shr","","",511,{"inputs":[{"name":"u8"},{"name":"isize"}],"output":{"name":"u8"}}],[11,"shr","","",511,null],[11,"shr","","",511,null],[11,"shr","","",511,null],[11,"shr","","",512,{"inputs":[{"name":"u16"},{"name":"u8"}],"output":{"name":"u16"}}],[11,"shr","","",512,null],[11,"shr","","",512,null],[11,"shr","","",512,null],[11,"shr","","",512,{"inputs":[{"name":"u16"},{"name":"u16"}],"output":{"name":"u16"}}],[11,"shr","","",512,null],[11,"shr","","",512,null],[11,"shr","","",512,null],[11,"shr","","",512,{"inputs":[{"name":"u16"},{"name":"u32"}],"output":{"name":"u16"}}],[11,"shr","","",512,null],[11,"shr","","",512,null],[11,"shr","","",512,null],[11,"shr","","",512,{"inputs":[{"name":"u16"},{"name":"u64"}],"output":{"name":"u16"}}],[11,"shr","","",512,null],[11,"shr","","",512,null],[11,"shr","","",512,null],[11,"shr","","",512,{"inputs":[{"name":"u16"},{"name":"usize"}],"output":{"name":"u16"}}],[11,"shr","","",512,null],[11,"shr","","",512,null],[11,"shr","","",512,null],[11,"shr","","",512,{"inputs":[{"name":"u16"},{"name":"i8"}],"output":{"name":"u16"}}],[11,"shr","","",512,null],[11,"shr","","",512,null],[11,"shr","","",512,null],[11,"shr","","",512,{"inputs":[{"name":"u16"},{"name":"i16"}],"output":{"name":"u16"}}],[11,"shr","","",512,null],[11,"shr","","",512,null],[11,"shr","","",512,null],[11,"shr","","",512,{"inputs":[{"name":"u16"},{"name":"i32"}],"output":{"name":"u16"}}],[11,"shr","","",512,null],[11,"shr","","",512,null],[11,"shr","","",512,null],[11,"shr","","",512,{"inputs":[{"name":"u16"},{"name":"i64"}],"output":{"name":"u16"}}],[11,"shr","","",512,null],[11,"shr","","",512,null],[11,"shr","","",512,null],[11,"shr","","",512,{"inputs":[{"name":"u16"},{"name":"isize"}],"output":{"name":"u16"}}],[11,"shr","","",512,null],[11,"shr","","",512,null],[11,"shr","","",512,null],[11,"shr","","",513,{"inputs":[{"name":"u32"},{"name":"u8"}],"output":{"name":"u32"}}],[11,"shr","","",513,null],[11,"shr","","",513,null],[11,"shr","","",513,null],[11,"shr","","",513,{"inputs":[{"name":"u32"},{"name":"u16"}],"output":{"name":"u32"}}],[11,"shr","","",513,null],[11,"shr","","",513,null],[11,"shr","","",513,null],[11,"shr","","",513,{"inputs":[{"name":"u32"},{"name":"u32"}],"output":{"name":"u32"}}],[11,"shr","","",513,null],[11,"shr","","",513,null],[11,"shr","","",513,null],[11,"shr","","",513,{"inputs":[{"name":"u32"},{"name":"u64"}],"output":{"name":"u32"}}],[11,"shr","","",513,null],[11,"shr","","",513,null],[11,"shr","","",513,null],[11,"shr","","",513,{"inputs":[{"name":"u32"},{"name":"usize"}],"output":{"name":"u32"}}],[11,"shr","","",513,null],[11,"shr","","",513,null],[11,"shr","","",513,null],[11,"shr","","",513,{"inputs":[{"name":"u32"},{"name":"i8"}],"output":{"name":"u32"}}],[11,"shr","","",513,null],[11,"shr","","",513,null],[11,"shr","","",513,null],[11,"shr","","",513,{"inputs":[{"name":"u32"},{"name":"i16"}],"output":{"name":"u32"}}],[11,"shr","","",513,null],[11,"shr","","",513,null],[11,"shr","","",513,null],[11,"shr","","",513,{"inputs":[{"name":"u32"},{"name":"i32"}],"output":{"name":"u32"}}],[11,"shr","","",513,null],[11,"shr","","",513,null],[11,"shr","","",513,null],[11,"shr","","",513,{"inputs":[{"name":"u32"},{"name":"i64"}],"output":{"name":"u32"}}],[11,"shr","","",513,null],[11,"shr","","",513,null],[11,"shr","","",513,null],[11,"shr","","",513,{"inputs":[{"name":"u32"},{"name":"isize"}],"output":{"name":"u32"}}],[11,"shr","","",513,null],[11,"shr","","",513,null],[11,"shr","","",513,null],[11,"shr","","",514,{"inputs":[{"name":"u64"},{"name":"u8"}],"output":{"name":"u64"}}],[11,"shr","","",514,null],[11,"shr","","",514,null],[11,"shr","","",514,null],[11,"shr","","",514,{"inputs":[{"name":"u64"},{"name":"u16"}],"output":{"name":"u64"}}],[11,"shr","","",514,null],[11,"shr","","",514,null],[11,"shr","","",514,null],[11,"shr","","",514,{"inputs":[{"name":"u64"},{"name":"u32"}],"output":{"name":"u64"}}],[11,"shr","","",514,null],[11,"shr","","",514,null],[11,"shr","","",514,null],[11,"shr","","",514,{"inputs":[{"name":"u64"},{"name":"u64"}],"output":{"name":"u64"}}],[11,"shr","","",514,null],[11,"shr","","",514,null],[11,"shr","","",514,null],[11,"shr","","",514,{"inputs":[{"name":"u64"},{"name":"usize"}],"output":{"name":"u64"}}],[11,"shr","","",514,null],[11,"shr","","",514,null],[11,"shr","","",514,null],[11,"shr","","",514,{"inputs":[{"name":"u64"},{"name":"i8"}],"output":{"name":"u64"}}],[11,"shr","","",514,null],[11,"shr","","",514,null],[11,"shr","","",514,null],[11,"shr","","",514,{"inputs":[{"name":"u64"},{"name":"i16"}],"output":{"name":"u64"}}],[11,"shr","","",514,null],[11,"shr","","",514,null],[11,"shr","","",514,null],[11,"shr","","",514,{"inputs":[{"name":"u64"},{"name":"i32"}],"output":{"name":"u64"}}],[11,"shr","","",514,null],[11,"shr","","",514,null],[11,"shr","","",514,null],[11,"shr","","",514,{"inputs":[{"name":"u64"},{"name":"i64"}],"output":{"name":"u64"}}],[11,"shr","","",514,null],[11,"shr","","",514,null],[11,"shr","","",514,null],[11,"shr","","",514,{"inputs":[{"name":"u64"},{"name":"isize"}],"output":{"name":"u64"}}],[11,"shr","","",514,null],[11,"shr","","",514,null],[11,"shr","","",514,null],[11,"shr","","",515,{"inputs":[{"name":"usize"},{"name":"u8"}],"output":{"name":"usize"}}],[11,"shr","","",515,null],[11,"shr","","",515,null],[11,"shr","","",515,null],[11,"shr","","",515,{"inputs":[{"name":"usize"},{"name":"u16"}],"output":{"name":"usize"}}],[11,"shr","","",515,null],[11,"shr","","",515,null],[11,"shr","","",515,null],[11,"shr","","",515,{"inputs":[{"name":"usize"},{"name":"u32"}],"output":{"name":"usize"}}],[11,"shr","","",515,null],[11,"shr","","",515,null],[11,"shr","","",515,null],[11,"shr","","",515,{"inputs":[{"name":"usize"},{"name":"u64"}],"output":{"name":"usize"}}],[11,"shr","","",515,null],[11,"shr","","",515,null],[11,"shr","","",515,null],[11,"shr","","",515,{"inputs":[{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"shr","","",515,null],[11,"shr","","",515,null],[11,"shr","","",515,null],[11,"shr","","",515,{"inputs":[{"name":"usize"},{"name":"i8"}],"output":{"name":"usize"}}],[11,"shr","","",515,null],[11,"shr","","",515,null],[11,"shr","","",515,null],[11,"shr","","",515,{"inputs":[{"name":"usize"},{"name":"i16"}],"output":{"name":"usize"}}],[11,"shr","","",515,null],[11,"shr","","",515,null],[11,"shr","","",515,null],[11,"shr","","",515,{"inputs":[{"name":"usize"},{"name":"i32"}],"output":{"name":"usize"}}],[11,"shr","","",515,null],[11,"shr","","",515,null],[11,"shr","","",515,null],[11,"shr","","",515,{"inputs":[{"name":"usize"},{"name":"i64"}],"output":{"name":"usize"}}],[11,"shr","","",515,null],[11,"shr","","",515,null],[11,"shr","","",515,null],[11,"shr","","",515,{"inputs":[{"name":"usize"},{"name":"isize"}],"output":{"name":"usize"}}],[11,"shr","","",515,null],[11,"shr","","",515,null],[11,"shr","","",515,null],[11,"shr","","",507,{"inputs":[{"name":"i8"},{"name":"u8"}],"output":{"name":"i8"}}],[11,"shr","","",507,null],[11,"shr","","",507,null],[11,"shr","","",507,null],[11,"shr","","",507,{"inputs":[{"name":"i8"},{"name":"u16"}],"output":{"name":"i8"}}],[11,"shr","","",507,null],[11,"shr","","",507,null],[11,"shr","","",507,null],[11,"shr","","",507,{"inputs":[{"name":"i8"},{"name":"u32"}],"output":{"name":"i8"}}],[11,"shr","","",507,null],[11,"shr","","",507,null],[11,"shr","","",507,null],[11,"shr","","",507,{"inputs":[{"name":"i8"},{"name":"u64"}],"output":{"name":"i8"}}],[11,"shr","","",507,null],[11,"shr","","",507,null],[11,"shr","","",507,null],[11,"shr","","",507,{"inputs":[{"name":"i8"},{"name":"usize"}],"output":{"name":"i8"}}],[11,"shr","","",507,null],[11,"shr","","",507,null],[11,"shr","","",507,null],[11,"shr","","",507,{"inputs":[{"name":"i8"},{"name":"i8"}],"output":{"name":"i8"}}],[11,"shr","","",507,null],[11,"shr","","",507,null],[11,"shr","","",507,null],[11,"shr","","",507,{"inputs":[{"name":"i8"},{"name":"i16"}],"output":{"name":"i8"}}],[11,"shr","","",507,null],[11,"shr","","",507,null],[11,"shr","","",507,null],[11,"shr","","",507,{"inputs":[{"name":"i8"},{"name":"i32"}],"output":{"name":"i8"}}],[11,"shr","","",507,null],[11,"shr","","",507,null],[11,"shr","","",507,null],[11,"shr","","",507,{"inputs":[{"name":"i8"},{"name":"i64"}],"output":{"name":"i8"}}],[11,"shr","","",507,null],[11,"shr","","",507,null],[11,"shr","","",507,null],[11,"shr","","",507,{"inputs":[{"name":"i8"},{"name":"isize"}],"output":{"name":"i8"}}],[11,"shr","","",507,null],[11,"shr","","",507,null],[11,"shr","","",507,null],[11,"shr","","",508,{"inputs":[{"name":"i16"},{"name":"u8"}],"output":{"name":"i16"}}],[11,"shr","","",508,null],[11,"shr","","",508,null],[11,"shr","","",508,null],[11,"shr","","",508,{"inputs":[{"name":"i16"},{"name":"u16"}],"output":{"name":"i16"}}],[11,"shr","","",508,null],[11,"shr","","",508,null],[11,"shr","","",508,null],[11,"shr","","",508,{"inputs":[{"name":"i16"},{"name":"u32"}],"output":{"name":"i16"}}],[11,"shr","","",508,null],[11,"shr","","",508,null],[11,"shr","","",508,null],[11,"shr","","",508,{"inputs":[{"name":"i16"},{"name":"u64"}],"output":{"name":"i16"}}],[11,"shr","","",508,null],[11,"shr","","",508,null],[11,"shr","","",508,null],[11,"shr","","",508,{"inputs":[{"name":"i16"},{"name":"usize"}],"output":{"name":"i16"}}],[11,"shr","","",508,null],[11,"shr","","",508,null],[11,"shr","","",508,null],[11,"shr","","",508,{"inputs":[{"name":"i16"},{"name":"i8"}],"output":{"name":"i16"}}],[11,"shr","","",508,null],[11,"shr","","",508,null],[11,"shr","","",508,null],[11,"shr","","",508,{"inputs":[{"name":"i16"},{"name":"i16"}],"output":{"name":"i16"}}],[11,"shr","","",508,null],[11,"shr","","",508,null],[11,"shr","","",508,null],[11,"shr","","",508,{"inputs":[{"name":"i16"},{"name":"i32"}],"output":{"name":"i16"}}],[11,"shr","","",508,null],[11,"shr","","",508,null],[11,"shr","","",508,null],[11,"shr","","",508,{"inputs":[{"name":"i16"},{"name":"i64"}],"output":{"name":"i16"}}],[11,"shr","","",508,null],[11,"shr","","",508,null],[11,"shr","","",508,null],[11,"shr","","",508,{"inputs":[{"name":"i16"},{"name":"isize"}],"output":{"name":"i16"}}],[11,"shr","","",508,null],[11,"shr","","",508,null],[11,"shr","","",508,null],[11,"shr","","",509,{"inputs":[{"name":"i32"},{"name":"u8"}],"output":{"name":"i32"}}],[11,"shr","","",509,null],[11,"shr","","",509,null],[11,"shr","","",509,null],[11,"shr","","",509,{"inputs":[{"name":"i32"},{"name":"u16"}],"output":{"name":"i32"}}],[11,"shr","","",509,null],[11,"shr","","",509,null],[11,"shr","","",509,null],[11,"shr","","",509,{"inputs":[{"name":"i32"},{"name":"u32"}],"output":{"name":"i32"}}],[11,"shr","","",509,null],[11,"shr","","",509,null],[11,"shr","","",509,null],[11,"shr","","",509,{"inputs":[{"name":"i32"},{"name":"u64"}],"output":{"name":"i32"}}],[11,"shr","","",509,null],[11,"shr","","",509,null],[11,"shr","","",509,null],[11,"shr","","",509,{"inputs":[{"name":"i32"},{"name":"usize"}],"output":{"name":"i32"}}],[11,"shr","","",509,null],[11,"shr","","",509,null],[11,"shr","","",509,null],[11,"shr","","",509,{"inputs":[{"name":"i32"},{"name":"i8"}],"output":{"name":"i32"}}],[11,"shr","","",509,null],[11,"shr","","",509,null],[11,"shr","","",509,null],[11,"shr","","",509,{"inputs":[{"name":"i32"},{"name":"i16"}],"output":{"name":"i32"}}],[11,"shr","","",509,null],[11,"shr","","",509,null],[11,"shr","","",509,null],[11,"shr","","",509,{"inputs":[{"name":"i32"},{"name":"i32"}],"output":{"name":"i32"}}],[11,"shr","","",509,null],[11,"shr","","",509,null],[11,"shr","","",509,null],[11,"shr","","",509,{"inputs":[{"name":"i32"},{"name":"i64"}],"output":{"name":"i32"}}],[11,"shr","","",509,null],[11,"shr","","",509,null],[11,"shr","","",509,null],[11,"shr","","",509,{"inputs":[{"name":"i32"},{"name":"isize"}],"output":{"name":"i32"}}],[11,"shr","","",509,null],[11,"shr","","",509,null],[11,"shr","","",509,null],[11,"shr","","",510,{"inputs":[{"name":"i64"},{"name":"u8"}],"output":{"name":"i64"}}],[11,"shr","","",510,null],[11,"shr","","",510,null],[11,"shr","","",510,null],[11,"shr","","",510,{"inputs":[{"name":"i64"},{"name":"u16"}],"output":{"name":"i64"}}],[11,"shr","","",510,null],[11,"shr","","",510,null],[11,"shr","","",510,null],[11,"shr","","",510,{"inputs":[{"name":"i64"},{"name":"u32"}],"output":{"name":"i64"}}],[11,"shr","","",510,null],[11,"shr","","",510,null],[11,"shr","","",510,null],[11,"shr","","",510,{"inputs":[{"name":"i64"},{"name":"u64"}],"output":{"name":"i64"}}],[11,"shr","","",510,null],[11,"shr","","",510,null],[11,"shr","","",510,null],[11,"shr","","",510,{"inputs":[{"name":"i64"},{"name":"usize"}],"output":{"name":"i64"}}],[11,"shr","","",510,null],[11,"shr","","",510,null],[11,"shr","","",510,null],[11,"shr","","",510,{"inputs":[{"name":"i64"},{"name":"i8"}],"output":{"name":"i64"}}],[11,"shr","","",510,null],[11,"shr","","",510,null],[11,"shr","","",510,null],[11,"shr","","",510,{"inputs":[{"name":"i64"},{"name":"i16"}],"output":{"name":"i64"}}],[11,"shr","","",510,null],[11,"shr","","",510,null],[11,"shr","","",510,null],[11,"shr","","",510,{"inputs":[{"name":"i64"},{"name":"i32"}],"output":{"name":"i64"}}],[11,"shr","","",510,null],[11,"shr","","",510,null],[11,"shr","","",510,null],[11,"shr","","",510,{"inputs":[{"name":"i64"},{"name":"i64"}],"output":{"name":"i64"}}],[11,"shr","","",510,null],[11,"shr","","",510,null],[11,"shr","","",510,null],[11,"shr","","",510,{"inputs":[{"name":"i64"},{"name":"isize"}],"output":{"name":"i64"}}],[11,"shr","","",510,null],[11,"shr","","",510,null],[11,"shr","","",510,null],[11,"shr","","",516,{"inputs":[{"name":"isize"},{"name":"u8"}],"output":{"name":"isize"}}],[11,"shr","","",516,null],[11,"shr","","",516,null],[11,"shr","","",516,null],[11,"shr","","",516,{"inputs":[{"name":"isize"},{"name":"u16"}],"output":{"name":"isize"}}],[11,"shr","","",516,null],[11,"shr","","",516,null],[11,"shr","","",516,null],[11,"shr","","",516,{"inputs":[{"name":"isize"},{"name":"u32"}],"output":{"name":"isize"}}],[11,"shr","","",516,null],[11,"shr","","",516,null],[11,"shr","","",516,null],[11,"shr","","",516,{"inputs":[{"name":"isize"},{"name":"u64"}],"output":{"name":"isize"}}],[11,"shr","","",516,null],[11,"shr","","",516,null],[11,"shr","","",516,null],[11,"shr","","",516,{"inputs":[{"name":"isize"},{"name":"usize"}],"output":{"name":"isize"}}],[11,"shr","","",516,null],[11,"shr","","",516,null],[11,"shr","","",516,null],[11,"shr","","",516,{"inputs":[{"name":"isize"},{"name":"i8"}],"output":{"name":"isize"}}],[11,"shr","","",516,null],[11,"shr","","",516,null],[11,"shr","","",516,null],[11,"shr","","",516,{"inputs":[{"name":"isize"},{"name":"i16"}],"output":{"name":"isize"}}],[11,"shr","","",516,null],[11,"shr","","",516,null],[11,"shr","","",516,null],[11,"shr","","",516,{"inputs":[{"name":"isize"},{"name":"i32"}],"output":{"name":"isize"}}],[11,"shr","","",516,null],[11,"shr","","",516,null],[11,"shr","","",516,null],[11,"shr","","",516,{"inputs":[{"name":"isize"},{"name":"i64"}],"output":{"name":"isize"}}],[11,"shr","","",516,null],[11,"shr","","",516,null],[11,"shr","","",516,null],[11,"shr","","",516,{"inputs":[{"name":"isize"},{"name":"isize"}],"output":{"name":"isize"}}],[11,"shr","","",516,null],[11,"shr","","",516,null],[11,"shr","","",516,null],[11,"eq","","",521,null],[11,"ne","","",521,null],[11,"eq","","",520,{"inputs":[{"name":"bool"},{"name":"bool"}],"output":{"name":"bool"}}],[11,"ne","","",520,{"inputs":[{"name":"bool"},{"name":"bool"}],"output":{"name":"bool"}}],[11,"eq","","",522,{"inputs":[{"name":"char"},{"name":"char"}],"output":{"name":"bool"}}],[11,"ne","","",522,{"inputs":[{"name":"char"},{"name":"char"}],"output":{"name":"bool"}}],[11,"eq","","",515,{"inputs":[{"name":"usize"},{"name":"usize"}],"output":{"name":"bool"}}],[11,"ne","","",515,{"inputs":[{"name":"usize"},{"name":"usize"}],"output":{"name":"bool"}}],[11,"eq","","",511,{"inputs":[{"name":"u8"},{"name":"u8"}],"output":{"name":"bool"}}],[11,"ne","","",511,{"inputs":[{"name":"u8"},{"name":"u8"}],"output":{"name":"bool"}}],[11,"eq","","",512,{"inputs":[{"name":"u16"},{"name":"u16"}],"output":{"name":"bool"}}],[11,"ne","","",512,{"inputs":[{"name":"u16"},{"name":"u16"}],"output":{"name":"bool"}}],[11,"eq","","",513,{"inputs":[{"name":"u32"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"ne","","",513,{"inputs":[{"name":"u32"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"eq","","",514,{"inputs":[{"name":"u64"},{"name":"u64"}],"output":{"name":"bool"}}],[11,"ne","","",514,{"inputs":[{"name":"u64"},{"name":"u64"}],"output":{"name":"bool"}}],[11,"eq","","",516,{"inputs":[{"name":"isize"},{"name":"isize"}],"output":{"name":"bool"}}],[11,"ne","","",516,{"inputs":[{"name":"isize"},{"name":"isize"}],"output":{"name":"bool"}}],[11,"eq","","",507,{"inputs":[{"name":"i8"},{"name":"i8"}],"output":{"name":"bool"}}],[11,"ne","","",507,{"inputs":[{"name":"i8"},{"name":"i8"}],"output":{"name":"bool"}}],[11,"eq","","",508,{"inputs":[{"name":"i16"},{"name":"i16"}],"output":{"name":"bool"}}],[11,"ne","","",508,{"inputs":[{"name":"i16"},{"name":"i16"}],"output":{"name":"bool"}}],[11,"eq","","",509,{"inputs":[{"name":"i32"},{"name":"i32"}],"output":{"name":"bool"}}],[11,"ne","","",509,{"inputs":[{"name":"i32"},{"name":"i32"}],"output":{"name":"bool"}}],[11,"eq","","",510,{"inputs":[{"name":"i64"},{"name":"i64"}],"output":{"name":"bool"}}],[11,"ne","","",510,{"inputs":[{"name":"i64"},{"name":"i64"}],"output":{"name":"bool"}}],[11,"eq","","",517,{"inputs":[{"name":"f32"},{"name":"f32"}],"output":{"name":"bool"}}],[11,"ne","","",517,{"inputs":[{"name":"f32"},{"name":"f32"}],"output":{"name":"bool"}}],[11,"eq","","",518,{"inputs":[{"name":"f64"},{"name":"f64"}],"output":{"name":"bool"}}],[11,"ne","","",518,{"inputs":[{"name":"f64"},{"name":"f64"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",521,null],[11,"partial_cmp","","",520,{"inputs":[{"name":"bool"},{"name":"bool"}],"output":{"name":"option"}}],[11,"partial_cmp","","",522,{"inputs":[{"name":"char"},{"name":"char"}],"output":{"name":"option"}}],[11,"lt","","",522,{"inputs":[{"name":"char"},{"name":"char"}],"output":{"name":"bool"}}],[11,"le","","",522,{"inputs":[{"name":"char"},{"name":"char"}],"output":{"name":"bool"}}],[11,"ge","","",522,{"inputs":[{"name":"char"},{"name":"char"}],"output":{"name":"bool"}}],[11,"gt","","",522,{"inputs":[{"name":"char"},{"name":"char"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",515,{"inputs":[{"name":"usize"},{"name":"usize"}],"output":{"name":"option"}}],[11,"lt","","",515,{"inputs":[{"name":"usize"},{"name":"usize"}],"output":{"name":"bool"}}],[11,"le","","",515,{"inputs":[{"name":"usize"},{"name":"usize"}],"output":{"name":"bool"}}],[11,"ge","","",515,{"inputs":[{"name":"usize"},{"name":"usize"}],"output":{"name":"bool"}}],[11,"gt","","",515,{"inputs":[{"name":"usize"},{"name":"usize"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",511,{"inputs":[{"name":"u8"},{"name":"u8"}],"output":{"name":"option"}}],[11,"lt","","",511,{"inputs":[{"name":"u8"},{"name":"u8"}],"output":{"name":"bool"}}],[11,"le","","",511,{"inputs":[{"name":"u8"},{"name":"u8"}],"output":{"name":"bool"}}],[11,"ge","","",511,{"inputs":[{"name":"u8"},{"name":"u8"}],"output":{"name":"bool"}}],[11,"gt","","",511,{"inputs":[{"name":"u8"},{"name":"u8"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",512,{"inputs":[{"name":"u16"},{"name":"u16"}],"output":{"name":"option"}}],[11,"lt","","",512,{"inputs":[{"name":"u16"},{"name":"u16"}],"output":{"name":"bool"}}],[11,"le","","",512,{"inputs":[{"name":"u16"},{"name":"u16"}],"output":{"name":"bool"}}],[11,"ge","","",512,{"inputs":[{"name":"u16"},{"name":"u16"}],"output":{"name":"bool"}}],[11,"gt","","",512,{"inputs":[{"name":"u16"},{"name":"u16"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",513,{"inputs":[{"name":"u32"},{"name":"u32"}],"output":{"name":"option"}}],[11,"lt","","",513,{"inputs":[{"name":"u32"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"le","","",513,{"inputs":[{"name":"u32"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"ge","","",513,{"inputs":[{"name":"u32"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"gt","","",513,{"inputs":[{"name":"u32"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",514,{"inputs":[{"name":"u64"},{"name":"u64"}],"output":{"name":"option"}}],[11,"lt","","",514,{"inputs":[{"name":"u64"},{"name":"u64"}],"output":{"name":"bool"}}],[11,"le","","",514,{"inputs":[{"name":"u64"},{"name":"u64"}],"output":{"name":"bool"}}],[11,"ge","","",514,{"inputs":[{"name":"u64"},{"name":"u64"}],"output":{"name":"bool"}}],[11,"gt","","",514,{"inputs":[{"name":"u64"},{"name":"u64"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",516,{"inputs":[{"name":"isize"},{"name":"isize"}],"output":{"name":"option"}}],[11,"lt","","",516,{"inputs":[{"name":"isize"},{"name":"isize"}],"output":{"name":"bool"}}],[11,"le","","",516,{"inputs":[{"name":"isize"},{"name":"isize"}],"output":{"name":"bool"}}],[11,"ge","","",516,{"inputs":[{"name":"isize"},{"name":"isize"}],"output":{"name":"bool"}}],[11,"gt","","",516,{"inputs":[{"name":"isize"},{"name":"isize"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",507,{"inputs":[{"name":"i8"},{"name":"i8"}],"output":{"name":"option"}}],[11,"lt","","",507,{"inputs":[{"name":"i8"},{"name":"i8"}],"output":{"name":"bool"}}],[11,"le","","",507,{"inputs":[{"name":"i8"},{"name":"i8"}],"output":{"name":"bool"}}],[11,"ge","","",507,{"inputs":[{"name":"i8"},{"name":"i8"}],"output":{"name":"bool"}}],[11,"gt","","",507,{"inputs":[{"name":"i8"},{"name":"i8"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",508,{"inputs":[{"name":"i16"},{"name":"i16"}],"output":{"name":"option"}}],[11,"lt","","",508,{"inputs":[{"name":"i16"},{"name":"i16"}],"output":{"name":"bool"}}],[11,"le","","",508,{"inputs":[{"name":"i16"},{"name":"i16"}],"output":{"name":"bool"}}],[11,"ge","","",508,{"inputs":[{"name":"i16"},{"name":"i16"}],"output":{"name":"bool"}}],[11,"gt","","",508,{"inputs":[{"name":"i16"},{"name":"i16"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",509,{"inputs":[{"name":"i32"},{"name":"i32"}],"output":{"name":"option"}}],[11,"lt","","",509,{"inputs":[{"name":"i32"},{"name":"i32"}],"output":{"name":"bool"}}],[11,"le","","",509,{"inputs":[{"name":"i32"},{"name":"i32"}],"output":{"name":"bool"}}],[11,"ge","","",509,{"inputs":[{"name":"i32"},{"name":"i32"}],"output":{"name":"bool"}}],[11,"gt","","",509,{"inputs":[{"name":"i32"},{"name":"i32"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",510,{"inputs":[{"name":"i64"},{"name":"i64"}],"output":{"name":"option"}}],[11,"lt","","",510,{"inputs":[{"name":"i64"},{"name":"i64"}],"output":{"name":"bool"}}],[11,"le","","",510,{"inputs":[{"name":"i64"},{"name":"i64"}],"output":{"name":"bool"}}],[11,"ge","","",510,{"inputs":[{"name":"i64"},{"name":"i64"}],"output":{"name":"bool"}}],[11,"gt","","",510,{"inputs":[{"name":"i64"},{"name":"i64"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",517,{"inputs":[{"name":"f32"},{"name":"f32"}],"output":{"name":"option"}}],[11,"lt","","",517,{"inputs":[{"name":"f32"},{"name":"f32"}],"output":{"name":"bool"}}],[11,"le","","",517,{"inputs":[{"name":"f32"},{"name":"f32"}],"output":{"name":"bool"}}],[11,"ge","","",517,{"inputs":[{"name":"f32"},{"name":"f32"}],"output":{"name":"bool"}}],[11,"gt","","",517,{"inputs":[{"name":"f32"},{"name":"f32"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",518,{"inputs":[{"name":"f64"},{"name":"f64"}],"output":{"name":"option"}}],[11,"lt","","",518,{"inputs":[{"name":"f64"},{"name":"f64"}],"output":{"name":"bool"}}],[11,"le","","",518,{"inputs":[{"name":"f64"},{"name":"f64"}],"output":{"name":"bool"}}],[11,"ge","","",518,{"inputs":[{"name":"f64"},{"name":"f64"}],"output":{"name":"bool"}}],[11,"gt","","",518,{"inputs":[{"name":"f64"},{"name":"f64"}],"output":{"name":"bool"}}],[11,"cmp","","",521,null],[11,"cmp","","",520,{"inputs":[{"name":"bool"},{"name":"bool"}],"output":{"name":"ordering"}}],[11,"cmp","","",522,{"inputs":[{"name":"char"},{"name":"char"}],"output":{"name":"ordering"}}],[11,"cmp","","",515,{"inputs":[{"name":"usize"},{"name":"usize"}],"output":{"name":"ordering"}}],[11,"cmp","","",511,{"inputs":[{"name":"u8"},{"name":"u8"}],"output":{"name":"ordering"}}],[11,"cmp","","",512,{"inputs":[{"name":"u16"},{"name":"u16"}],"output":{"name":"ordering"}}],[11,"cmp","","",513,{"inputs":[{"name":"u32"},{"name":"u32"}],"output":{"name":"ordering"}}],[11,"cmp","","",514,{"inputs":[{"name":"u64"},{"name":"u64"}],"output":{"name":"ordering"}}],[11,"cmp","","",516,{"inputs":[{"name":"isize"},{"name":"isize"}],"output":{"name":"ordering"}}],[11,"cmp","","",507,{"inputs":[{"name":"i8"},{"name":"i8"}],"output":{"name":"ordering"}}],[11,"cmp","","",508,{"inputs":[{"name":"i16"},{"name":"i16"}],"output":{"name":"ordering"}}],[11,"cmp","","",509,{"inputs":[{"name":"i32"},{"name":"i32"}],"output":{"name":"ordering"}}],[11,"cmp","","",510,{"inputs":[{"name":"i64"},{"name":"i64"}],"output":{"name":"ordering"}}],[11,"clone","","Returns a deep copy of the value.",516,{"inputs":[{"name":"isize"}],"output":{"name":"isize"}}],[11,"clone","","Returns a deep copy of the value.",507,{"inputs":[{"name":"i8"}],"output":{"name":"i8"}}],[11,"clone","","Returns a deep copy of the value.",508,{"inputs":[{"name":"i16"}],"output":{"name":"i16"}}],[11,"clone","","Returns a deep copy of the value.",509,{"inputs":[{"name":"i32"}],"output":{"name":"i32"}}],[11,"clone","","Returns a deep copy of the value.",510,{"inputs":[{"name":"i64"}],"output":{"name":"i64"}}],[11,"clone","","Returns a deep copy of the value.",515,{"inputs":[{"name":"usize"}],"output":{"name":"usize"}}],[11,"clone","","Returns a deep copy of the value.",511,{"inputs":[{"name":"u8"}],"output":{"name":"u8"}}],[11,"clone","","Returns a deep copy of the value.",512,{"inputs":[{"name":"u16"}],"output":{"name":"u16"}}],[11,"clone","","Returns a deep copy of the value.",513,{"inputs":[{"name":"u32"}],"output":{"name":"u32"}}],[11,"clone","","Returns a deep copy of the value.",514,{"inputs":[{"name":"u64"}],"output":{"name":"u64"}}],[11,"clone","","Returns a deep copy of the value.",517,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[11,"clone","","Returns a deep copy of the value.",518,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[11,"clone","","Returns a deep copy of the value.",521,null],[11,"clone","","Returns a deep copy of the value.",520,{"inputs":[{"name":"bool"}],"output":{"name":"bool"}}],[11,"clone","","Returns a deep copy of the value.",522,{"inputs":[{"name":"char"}],"output":{"name":"char"}}],[11,"default","","",521,null],[11,"default","","",520,{"inputs":[{"name":"bool"}],"output":{"name":"bool"}}],[11,"default","","",522,{"inputs":[{"name":"char"}],"output":{"name":"char"}}],[11,"default","","",515,{"inputs":[{"name":"usize"}],"output":{"name":"usize"}}],[11,"default","","",511,{"inputs":[{"name":"u8"}],"output":{"name":"u8"}}],[11,"default","","",512,{"inputs":[{"name":"u16"}],"output":{"name":"u16"}}],[11,"default","","",513,{"inputs":[{"name":"u32"}],"output":{"name":"u32"}}],[11,"default","","",514,{"inputs":[{"name":"u64"}],"output":{"name":"u64"}}],[11,"default","","",516,{"inputs":[{"name":"isize"}],"output":{"name":"isize"}}],[11,"default","","",507,{"inputs":[{"name":"i8"}],"output":{"name":"i8"}}],[11,"default","","",508,{"inputs":[{"name":"i16"}],"output":{"name":"i16"}}],[11,"default","","",509,{"inputs":[{"name":"i32"}],"output":{"name":"i32"}}],[11,"default","","",510,{"inputs":[{"name":"i64"}],"output":{"name":"i64"}}],[11,"default","","",517,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[11,"default","","",518,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[11,"as_ref","","",523,null],[11,"as_mut","","",523,null],[11,"as_ref","","",524,{"inputs":[{"name":"str"}],"output":{"name":"str"}}],[11,"as_slice","","",525,null],[11,"as_mut_slice","","",525,null],[11,"as_ref","","",525,null],[11,"as_mut","","",525,null],[11,"clone","","",525,null],[11,"hash","","",525,null],[11,"fmt","","",525,{"inputs":[{"name":"array"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"iter"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"itermut"}}],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"partial_cmp","","",525,null],[11,"lt","","",525,null],[11,"le","","",525,null],[11,"ge","","",525,null],[11,"gt","","",525,null],[11,"cmp","","",525,null],[11,"as_slice","","",525,null],[11,"as_mut_slice","","",525,null],[11,"as_ref","","",525,null],[11,"as_mut","","",525,null],[11,"clone","","",525,null],[11,"hash","","",525,null],[11,"fmt","","",525,{"inputs":[{"name":"array"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"iter"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"itermut"}}],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"partial_cmp","","",525,null],[11,"lt","","",525,null],[11,"le","","",525,null],[11,"ge","","",525,null],[11,"gt","","",525,null],[11,"cmp","","",525,null],[11,"as_slice","","",525,null],[11,"as_mut_slice","","",525,null],[11,"as_ref","","",525,null],[11,"as_mut","","",525,null],[11,"clone","","",525,null],[11,"hash","","",525,null],[11,"fmt","","",525,{"inputs":[{"name":"array"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"iter"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"itermut"}}],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"partial_cmp","","",525,null],[11,"lt","","",525,null],[11,"le","","",525,null],[11,"ge","","",525,null],[11,"gt","","",525,null],[11,"cmp","","",525,null],[11,"as_slice","","",525,null],[11,"as_mut_slice","","",525,null],[11,"as_ref","","",525,null],[11,"as_mut","","",525,null],[11,"clone","","",525,null],[11,"hash","","",525,null],[11,"fmt","","",525,{"inputs":[{"name":"array"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"iter"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"itermut"}}],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"partial_cmp","","",525,null],[11,"lt","","",525,null],[11,"le","","",525,null],[11,"ge","","",525,null],[11,"gt","","",525,null],[11,"cmp","","",525,null],[11,"as_slice","","",525,null],[11,"as_mut_slice","","",525,null],[11,"as_ref","","",525,null],[11,"as_mut","","",525,null],[11,"clone","","",525,null],[11,"hash","","",525,null],[11,"fmt","","",525,{"inputs":[{"name":"array"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"iter"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"itermut"}}],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"partial_cmp","","",525,null],[11,"lt","","",525,null],[11,"le","","",525,null],[11,"ge","","",525,null],[11,"gt","","",525,null],[11,"cmp","","",525,null],[11,"as_slice","","",525,null],[11,"as_mut_slice","","",525,null],[11,"as_ref","","",525,null],[11,"as_mut","","",525,null],[11,"clone","","",525,null],[11,"hash","","",525,null],[11,"fmt","","",525,{"inputs":[{"name":"array"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"iter"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"itermut"}}],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"partial_cmp","","",525,null],[11,"lt","","",525,null],[11,"le","","",525,null],[11,"ge","","",525,null],[11,"gt","","",525,null],[11,"cmp","","",525,null],[11,"as_slice","","",525,null],[11,"as_mut_slice","","",525,null],[11,"as_ref","","",525,null],[11,"as_mut","","",525,null],[11,"clone","","",525,null],[11,"hash","","",525,null],[11,"fmt","","",525,{"inputs":[{"name":"array"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"iter"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"itermut"}}],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"partial_cmp","","",525,null],[11,"lt","","",525,null],[11,"le","","",525,null],[11,"ge","","",525,null],[11,"gt","","",525,null],[11,"cmp","","",525,null],[11,"as_slice","","",525,null],[11,"as_mut_slice","","",525,null],[11,"as_ref","","",525,null],[11,"as_mut","","",525,null],[11,"clone","","",525,null],[11,"hash","","",525,null],[11,"fmt","","",525,{"inputs":[{"name":"array"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"iter"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"itermut"}}],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"partial_cmp","","",525,null],[11,"lt","","",525,null],[11,"le","","",525,null],[11,"ge","","",525,null],[11,"gt","","",525,null],[11,"cmp","","",525,null],[11,"as_slice","","",525,null],[11,"as_mut_slice","","",525,null],[11,"as_ref","","",525,null],[11,"as_mut","","",525,null],[11,"clone","","",525,null],[11,"hash","","",525,null],[11,"fmt","","",525,{"inputs":[{"name":"array"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"iter"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"itermut"}}],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"partial_cmp","","",525,null],[11,"lt","","",525,null],[11,"le","","",525,null],[11,"ge","","",525,null],[11,"gt","","",525,null],[11,"cmp","","",525,null],[11,"as_slice","","",525,null],[11,"as_mut_slice","","",525,null],[11,"as_ref","","",525,null],[11,"as_mut","","",525,null],[11,"clone","","",525,null],[11,"hash","","",525,null],[11,"fmt","","",525,{"inputs":[{"name":"array"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"iter"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"itermut"}}],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"partial_cmp","","",525,null],[11,"lt","","",525,null],[11,"le","","",525,null],[11,"ge","","",525,null],[11,"gt","","",525,null],[11,"cmp","","",525,null],[11,"as_slice","","",525,null],[11,"as_mut_slice","","",525,null],[11,"as_ref","","",525,null],[11,"as_mut","","",525,null],[11,"clone","","",525,null],[11,"hash","","",525,null],[11,"fmt","","",525,{"inputs":[{"name":"array"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"iter"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"itermut"}}],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"partial_cmp","","",525,null],[11,"lt","","",525,null],[11,"le","","",525,null],[11,"ge","","",525,null],[11,"gt","","",525,null],[11,"cmp","","",525,null],[11,"as_slice","","",525,null],[11,"as_mut_slice","","",525,null],[11,"as_ref","","",525,null],[11,"as_mut","","",525,null],[11,"clone","","",525,null],[11,"hash","","",525,null],[11,"fmt","","",525,{"inputs":[{"name":"array"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"iter"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"itermut"}}],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"partial_cmp","","",525,null],[11,"lt","","",525,null],[11,"le","","",525,null],[11,"ge","","",525,null],[11,"gt","","",525,null],[11,"cmp","","",525,null],[11,"as_slice","","",525,null],[11,"as_mut_slice","","",525,null],[11,"as_ref","","",525,null],[11,"as_mut","","",525,null],[11,"clone","","",525,null],[11,"hash","","",525,null],[11,"fmt","","",525,{"inputs":[{"name":"array"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"iter"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"itermut"}}],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"partial_cmp","","",525,null],[11,"lt","","",525,null],[11,"le","","",525,null],[11,"ge","","",525,null],[11,"gt","","",525,null],[11,"cmp","","",525,null],[11,"as_slice","","",525,null],[11,"as_mut_slice","","",525,null],[11,"as_ref","","",525,null],[11,"as_mut","","",525,null],[11,"clone","","",525,null],[11,"hash","","",525,null],[11,"fmt","","",525,{"inputs":[{"name":"array"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"iter"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"itermut"}}],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"partial_cmp","","",525,null],[11,"lt","","",525,null],[11,"le","","",525,null],[11,"ge","","",525,null],[11,"gt","","",525,null],[11,"cmp","","",525,null],[11,"as_slice","","",525,null],[11,"as_mut_slice","","",525,null],[11,"as_ref","","",525,null],[11,"as_mut","","",525,null],[11,"clone","","",525,null],[11,"hash","","",525,null],[11,"fmt","","",525,{"inputs":[{"name":"array"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"iter"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"itermut"}}],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"partial_cmp","","",525,null],[11,"lt","","",525,null],[11,"le","","",525,null],[11,"ge","","",525,null],[11,"gt","","",525,null],[11,"cmp","","",525,null],[11,"as_slice","","",525,null],[11,"as_mut_slice","","",525,null],[11,"as_ref","","",525,null],[11,"as_mut","","",525,null],[11,"clone","","",525,null],[11,"hash","","",525,null],[11,"fmt","","",525,{"inputs":[{"name":"array"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"iter"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"itermut"}}],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"partial_cmp","","",525,null],[11,"lt","","",525,null],[11,"le","","",525,null],[11,"ge","","",525,null],[11,"gt","","",525,null],[11,"cmp","","",525,null],[11,"as_slice","","",525,null],[11,"as_mut_slice","","",525,null],[11,"as_ref","","",525,null],[11,"as_mut","","",525,null],[11,"clone","","",525,null],[11,"hash","","",525,null],[11,"fmt","","",525,{"inputs":[{"name":"array"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"iter"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"itermut"}}],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"partial_cmp","","",525,null],[11,"lt","","",525,null],[11,"le","","",525,null],[11,"ge","","",525,null],[11,"gt","","",525,null],[11,"cmp","","",525,null],[11,"as_slice","","",525,null],[11,"as_mut_slice","","",525,null],[11,"as_ref","","",525,null],[11,"as_mut","","",525,null],[11,"clone","","",525,null],[11,"hash","","",525,null],[11,"fmt","","",525,{"inputs":[{"name":"array"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"iter"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"itermut"}}],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"partial_cmp","","",525,null],[11,"lt","","",525,null],[11,"le","","",525,null],[11,"ge","","",525,null],[11,"gt","","",525,null],[11,"cmp","","",525,null],[11,"as_slice","","",525,null],[11,"as_mut_slice","","",525,null],[11,"as_ref","","",525,null],[11,"as_mut","","",525,null],[11,"clone","","",525,null],[11,"hash","","",525,null],[11,"fmt","","",525,{"inputs":[{"name":"array"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"iter"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"itermut"}}],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"partial_cmp","","",525,null],[11,"lt","","",525,null],[11,"le","","",525,null],[11,"ge","","",525,null],[11,"gt","","",525,null],[11,"cmp","","",525,null],[11,"as_slice","","",525,null],[11,"as_mut_slice","","",525,null],[11,"as_ref","","",525,null],[11,"as_mut","","",525,null],[11,"clone","","",525,null],[11,"hash","","",525,null],[11,"fmt","","",525,{"inputs":[{"name":"array"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"iter"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"itermut"}}],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"partial_cmp","","",525,null],[11,"lt","","",525,null],[11,"le","","",525,null],[11,"ge","","",525,null],[11,"gt","","",525,null],[11,"cmp","","",525,null],[11,"as_slice","","",525,null],[11,"as_mut_slice","","",525,null],[11,"as_ref","","",525,null],[11,"as_mut","","",525,null],[11,"clone","","",525,null],[11,"hash","","",525,null],[11,"fmt","","",525,{"inputs":[{"name":"array"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"iter"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"itermut"}}],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"partial_cmp","","",525,null],[11,"lt","","",525,null],[11,"le","","",525,null],[11,"ge","","",525,null],[11,"gt","","",525,null],[11,"cmp","","",525,null],[11,"as_slice","","",525,null],[11,"as_mut_slice","","",525,null],[11,"as_ref","","",525,null],[11,"as_mut","","",525,null],[11,"clone","","",525,null],[11,"hash","","",525,null],[11,"fmt","","",525,{"inputs":[{"name":"array"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"iter"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"itermut"}}],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"partial_cmp","","",525,null],[11,"lt","","",525,null],[11,"le","","",525,null],[11,"ge","","",525,null],[11,"gt","","",525,null],[11,"cmp","","",525,null],[11,"as_slice","","",525,null],[11,"as_mut_slice","","",525,null],[11,"as_ref","","",525,null],[11,"as_mut","","",525,null],[11,"clone","","",525,null],[11,"hash","","",525,null],[11,"fmt","","",525,{"inputs":[{"name":"array"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"iter"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"itermut"}}],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"partial_cmp","","",525,null],[11,"lt","","",525,null],[11,"le","","",525,null],[11,"ge","","",525,null],[11,"gt","","",525,null],[11,"cmp","","",525,null],[11,"as_slice","","",525,null],[11,"as_mut_slice","","",525,null],[11,"as_ref","","",525,null],[11,"as_mut","","",525,null],[11,"clone","","",525,null],[11,"hash","","",525,null],[11,"fmt","","",525,{"inputs":[{"name":"array"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"iter"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"itermut"}}],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"partial_cmp","","",525,null],[11,"lt","","",525,null],[11,"le","","",525,null],[11,"ge","","",525,null],[11,"gt","","",525,null],[11,"cmp","","",525,null],[11,"as_slice","","",525,null],[11,"as_mut_slice","","",525,null],[11,"as_ref","","",525,null],[11,"as_mut","","",525,null],[11,"clone","","",525,null],[11,"hash","","",525,null],[11,"fmt","","",525,{"inputs":[{"name":"array"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"iter"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"itermut"}}],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"partial_cmp","","",525,null],[11,"lt","","",525,null],[11,"le","","",525,null],[11,"ge","","",525,null],[11,"gt","","",525,null],[11,"cmp","","",525,null],[11,"as_slice","","",525,null],[11,"as_mut_slice","","",525,null],[11,"as_ref","","",525,null],[11,"as_mut","","",525,null],[11,"clone","","",525,null],[11,"hash","","",525,null],[11,"fmt","","",525,{"inputs":[{"name":"array"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"iter"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"itermut"}}],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"partial_cmp","","",525,null],[11,"lt","","",525,null],[11,"le","","",525,null],[11,"ge","","",525,null],[11,"gt","","",525,null],[11,"cmp","","",525,null],[11,"as_slice","","",525,null],[11,"as_mut_slice","","",525,null],[11,"as_ref","","",525,null],[11,"as_mut","","",525,null],[11,"clone","","",525,null],[11,"hash","","",525,null],[11,"fmt","","",525,{"inputs":[{"name":"array"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"iter"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"itermut"}}],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"partial_cmp","","",525,null],[11,"lt","","",525,null],[11,"le","","",525,null],[11,"ge","","",525,null],[11,"gt","","",525,null],[11,"cmp","","",525,null],[11,"as_slice","","",525,null],[11,"as_mut_slice","","",525,null],[11,"as_ref","","",525,null],[11,"as_mut","","",525,null],[11,"clone","","",525,null],[11,"hash","","",525,null],[11,"fmt","","",525,{"inputs":[{"name":"array"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"iter"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"itermut"}}],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"partial_cmp","","",525,null],[11,"lt","","",525,null],[11,"le","","",525,null],[11,"ge","","",525,null],[11,"gt","","",525,null],[11,"cmp","","",525,null],[11,"as_slice","","",525,null],[11,"as_mut_slice","","",525,null],[11,"as_ref","","",525,null],[11,"as_mut","","",525,null],[11,"clone","","",525,null],[11,"hash","","",525,null],[11,"fmt","","",525,{"inputs":[{"name":"array"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"iter"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"itermut"}}],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"partial_cmp","","",525,null],[11,"lt","","",525,null],[11,"le","","",525,null],[11,"ge","","",525,null],[11,"gt","","",525,null],[11,"cmp","","",525,null],[11,"as_slice","","",525,null],[11,"as_mut_slice","","",525,null],[11,"as_ref","","",525,null],[11,"as_mut","","",525,null],[11,"clone","","",525,null],[11,"hash","","",525,null],[11,"fmt","","",525,{"inputs":[{"name":"array"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"iter"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"itermut"}}],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"partial_cmp","","",525,null],[11,"lt","","",525,null],[11,"le","","",525,null],[11,"ge","","",525,null],[11,"gt","","",525,null],[11,"cmp","","",525,null],[11,"as_slice","","",525,null],[11,"as_mut_slice","","",525,null],[11,"as_ref","","",525,null],[11,"as_mut","","",525,null],[11,"clone","","",525,null],[11,"hash","","",525,null],[11,"fmt","","",525,{"inputs":[{"name":"array"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"iter"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"itermut"}}],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"partial_cmp","","",525,null],[11,"lt","","",525,null],[11,"le","","",525,null],[11,"ge","","",525,null],[11,"gt","","",525,null],[11,"cmp","","",525,null],[11,"as_slice","","",525,null],[11,"as_mut_slice","","",525,null],[11,"as_ref","","",525,null],[11,"as_mut","","",525,null],[11,"clone","","",525,null],[11,"hash","","",525,null],[11,"fmt","","",525,{"inputs":[{"name":"array"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"iter"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"itermut"}}],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"partial_cmp","","",525,null],[11,"lt","","",525,null],[11,"le","","",525,null],[11,"ge","","",525,null],[11,"gt","","",525,null],[11,"cmp","","",525,null],[11,"as_slice","","",525,null],[11,"as_mut_slice","","",525,null],[11,"as_ref","","",525,null],[11,"as_mut","","",525,null],[11,"clone","","",525,null],[11,"hash","","",525,null],[11,"fmt","","",525,{"inputs":[{"name":"array"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"iter"}}],[11,"into_iter","","",525,{"inputs":[{"name":"array"}],"output":{"name":"itermut"}}],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"eq","","",525,null],[11,"ne","","",525,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"partial_cmp","","",525,null],[11,"lt","","",525,null],[11,"le","","",525,null],[11,"ge","","",525,null],[11,"gt","","",525,null],[11,"cmp","","",525,null],[11,"step","","",515,{"inputs":[{"name":"usize"},{"name":"usize"}],"output":{"name":"option"}}],[11,"steps_between","","",515,{"inputs":[{"name":"usize"},{"name":"usize"},{"name":"usize"},{"name":"usize"}],"output":{"name":"option"}}],[11,"step","","",511,{"inputs":[{"name":"u8"},{"name":"u8"}],"output":{"name":"option"}}],[11,"steps_between","","",511,{"inputs":[{"name":"u8"},{"name":"u8"},{"name":"u8"},{"name":"u8"}],"output":{"name":"option"}}],[11,"step","","",512,{"inputs":[{"name":"u16"},{"name":"u16"}],"output":{"name":"option"}}],[11,"steps_between","","",512,{"inputs":[{"name":"u16"},{"name":"u16"},{"name":"u16"},{"name":"u16"}],"output":{"name":"option"}}],[11,"step","","",513,{"inputs":[{"name":"u32"},{"name":"u32"}],"output":{"name":"option"}}],[11,"steps_between","","",513,{"inputs":[{"name":"u32"},{"name":"u32"},{"name":"u32"},{"name":"u32"}],"output":{"name":"option"}}],[11,"step","","",516,{"inputs":[{"name":"isize"},{"name":"isize"}],"output":{"name":"option"}}],[11,"steps_between","","",516,{"inputs":[{"name":"isize"},{"name":"isize"},{"name":"isize"},{"name":"isize"}],"output":{"name":"option"}}],[11,"step","","",507,{"inputs":[{"name":"i8"},{"name":"i8"}],"output":{"name":"option"}}],[11,"steps_between","","",507,{"inputs":[{"name":"i8"},{"name":"i8"},{"name":"i8"},{"name":"i8"}],"output":{"name":"option"}}],[11,"step","","",508,{"inputs":[{"name":"i16"},{"name":"i16"}],"output":{"name":"option"}}],[11,"steps_between","","",508,{"inputs":[{"name":"i16"},{"name":"i16"},{"name":"i16"},{"name":"i16"}],"output":{"name":"option"}}],[11,"step","","",509,{"inputs":[{"name":"i32"},{"name":"i32"}],"output":{"name":"option"}}],[11,"steps_between","","",509,{"inputs":[{"name":"i32"},{"name":"i32"},{"name":"i32"},{"name":"i32"}],"output":{"name":"option"}}],[11,"step","","",514,{"inputs":[{"name":"u64"},{"name":"u64"}],"output":{"name":"option"}}],[11,"steps_between","","",514,{"inputs":[{"name":"u64"},{"name":"u64"},{"name":"u64"},{"name":"u64"}],"output":{"name":"option"}}],[11,"step","","",510,{"inputs":[{"name":"i64"},{"name":"i64"}],"output":{"name":"option"}}],[11,"steps_between","","",510,{"inputs":[{"name":"i64"},{"name":"i64"},{"name":"i64"},{"name":"i64"}],"output":{"name":"option"}}],[11,"index","","",523,{"inputs":[{"name":"slice"},{"name":"usize"}],"output":{"name":"t"}}],[11,"index_mut","","",523,{"inputs":[{"name":"slice"},{"name":"usize"}],"output":{"name":"t"}}],[11,"index","","",523,null],[11,"index","","",523,null],[11,"index","","",523,null],[11,"index","","",523,null],[11,"index_mut","","",523,null],[11,"index_mut","","",523,null],[11,"index_mut","","",523,null],[11,"index_mut","","",523,null],[11,"default","","",523,null],[11,"into_iter","","",523,{"inputs":[{"name":"slice"}],"output":{"name":"iter"}}],[11,"into_iter","","",523,{"inputs":[{"name":"slice"}],"output":{"name":"itermut"}}],[11,"set_memory","","",523,null],[11,"eq","","",523,null],[11,"ne","","",523,null],[11,"cmp","","",523,null],[11,"partial_cmp","","",523,null],[11,"lt","","",523,null],[11,"le","","",523,null],[11,"ge","","",523,null],[11,"gt","","",523,null],[11,"as_unsigned","","",523,null],[11,"as_signed","","",523,null],[11,"as_unsigned_mut","","",523,null],[11,"as_signed_mut","","",523,null],[11,"as_unsigned","","",523,null],[11,"as_signed","","",523,null],[11,"as_unsigned_mut","","",523,null],[11,"as_signed_mut","","",523,null],[11,"as_unsigned","","",523,null],[11,"as_signed","","",523,null],[11,"as_unsigned_mut","","",523,null],[11,"as_signed_mut","","",523,null],[11,"as_unsigned","","",523,null],[11,"as_signed","","",523,null],[11,"as_unsigned_mut","","",523,null],[11,"as_signed_mut","","",523,null],[11,"as_unsigned","","",523,null],[11,"as_signed","","",523,null],[11,"as_unsigned_mut","","",523,null],[11,"as_signed_mut","","",523,null],[11,"as_unsigned","","",523,null],[11,"as_signed","","",523,null],[11,"as_unsigned_mut","","",523,null],[11,"as_signed_mut","","",523,null],[11,"as_unsigned","","",523,null],[11,"as_signed","","",523,null],[11,"as_unsigned_mut","","",523,null],[11,"as_signed_mut","","",523,null],[11,"as_unsigned","","",523,null],[11,"as_signed","","",523,null],[11,"as_unsigned_mut","","",523,null],[11,"as_signed_mut","","",523,null],[11,"as_unsigned","","",523,null],[11,"as_signed","","",523,null],[11,"as_unsigned_mut","","",523,null],[11,"as_signed_mut","","",523,null],[11,"as_unsigned","","",523,null],[11,"as_signed","","",523,null],[11,"as_unsigned_mut","","",523,null],[11,"as_signed_mut","","",523,null],[11,"into_searcher","","",522,{"inputs":[{"name":"char"},{"name":"str"}],"output":{"name":"charsearcher"}}],[11,"is_contained_in","","",522,{"inputs":[{"name":"char"},{"name":"str"}],"output":{"name":"bool"}}],[11,"is_prefix_of","","",522,{"inputs":[{"name":"char"},{"name":"str"}],"output":{"name":"bool"}}],[11,"is_suffix_of","","",522,{"inputs":[{"name":"char"},{"name":"str"}],"output":{"name":"bool"}}],[11,"into_searcher","","",523,{"inputs":[{"name":"slice"},{"name":"str"}],"output":{"name":"charslicesearcher"}}],[11,"is_contained_in","","",523,{"inputs":[{"name":"slice"},{"name":"str"}],"output":{"name":"bool"}}],[11,"is_prefix_of","","",523,{"inputs":[{"name":"slice"},{"name":"str"}],"output":{"name":"bool"}}],[11,"is_suffix_of","","",523,{"inputs":[{"name":"slice"},{"name":"str"}],"output":{"name":"bool"}}],[11,"into_searcher","","",524,{"inputs":[{"name":"str"},{"name":"str"}],"output":{"name":"strsearcher"}}],[11,"is_prefix_of","","Checks whether the pattern matches at the front of the haystack",524,{"inputs":[{"name":"str"},{"name":"str"}],"output":{"name":"bool"}}],[11,"is_suffix_of","","Checks whether the pattern matches at the back of the haystack",524,{"inputs":[{"name":"str"},{"name":"str"}],"output":{"name":"bool"}}],[11,"from_str","","Parse a `bool` from a string.",520,{"inputs":[{"name":"bool"},{"name":"str"}],"output":{"name":"result"}}],[11,"cmp","","",524,{"inputs":[{"name":"str"},{"name":"str"}],"output":{"name":"ordering"}}],[11,"eq","","",524,{"inputs":[{"name":"str"},{"name":"str"}],"output":{"name":"bool"}}],[11,"ne","","",524,{"inputs":[{"name":"str"},{"name":"str"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",524,{"inputs":[{"name":"str"},{"name":"str"}],"output":{"name":"option"}}],[11,"index","","",524,{"inputs":[{"name":"str"},{"name":"range"}],"output":{"name":"str"}}],[11,"index_mut","","",524,{"inputs":[{"name":"str"},{"name":"range"}],"output":{"name":"str"}}],[11,"index","","",524,{"inputs":[{"name":"str"},{"name":"rangeto"}],"output":{"name":"str"}}],[11,"index_mut","","",524,{"inputs":[{"name":"str"},{"name":"rangeto"}],"output":{"name":"str"}}],[11,"index","","",524,{"inputs":[{"name":"str"},{"name":"rangefrom"}],"output":{"name":"str"}}],[11,"index_mut","","",524,{"inputs":[{"name":"str"},{"name":"rangefrom"}],"output":{"name":"str"}}],[11,"index","","",524,{"inputs":[{"name":"str"},{"name":"rangefull"}],"output":{"name":"str"}}],[11,"index_mut","","",524,{"inputs":[{"name":"str"},{"name":"rangefull"}],"output":{"name":"str"}}],[11,"as_ref","","",524,null],[11,"default","","",524,{"inputs":[{"name":"str"}],"output":{"name":"str"}}],[11,"hash","","",511,null],[11,"hash_slice","","",511,null],[11,"hash","","",512,null],[11,"hash_slice","","",512,null],[11,"hash","","",513,null],[11,"hash_slice","","",513,null],[11,"hash","","",514,null],[11,"hash_slice","","",514,null],[11,"hash","","",515,null],[11,"hash_slice","","",515,null],[11,"hash","","",507,null],[11,"hash_slice","","",507,null],[11,"hash","","",508,null],[11,"hash_slice","","",508,null],[11,"hash","","",509,null],[11,"hash_slice","","",509,null],[11,"hash","","",510,null],[11,"hash_slice","","",510,null],[11,"hash","","",516,null],[11,"hash_slice","","",516,null],[11,"hash","","",520,null],[11,"hash","","",522,null],[11,"hash","","",524,null],[11,"hash","","",521,null],[11,"hash","","",521,null],[11,"hash","","",521,null],[11,"hash","","",521,null],[11,"hash","","",521,null],[11,"hash","","",521,null],[11,"hash","","",521,null],[11,"hash","","",521,null],[11,"hash","","",521,null],[11,"hash","","",521,null],[11,"hash","","",521,null],[11,"hash","","",521,null],[11,"hash","","",521,null],[11,"hash","","",523,null],[11,"hash","","",519,null],[11,"hash","","",519,null],[11,"fmt","","",516,{"inputs":[{"name":"isize"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",516,{"inputs":[{"name":"isize"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",516,{"inputs":[{"name":"isize"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",516,{"inputs":[{"name":"isize"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",516,{"inputs":[{"name":"isize"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",515,{"inputs":[{"name":"usize"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",515,{"inputs":[{"name":"usize"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",515,{"inputs":[{"name":"usize"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",515,{"inputs":[{"name":"usize"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",515,{"inputs":[{"name":"usize"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",507,{"inputs":[{"name":"i8"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",507,{"inputs":[{"name":"i8"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",507,{"inputs":[{"name":"i8"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",507,{"inputs":[{"name":"i8"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",507,{"inputs":[{"name":"i8"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",511,{"inputs":[{"name":"u8"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",511,{"inputs":[{"name":"u8"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",511,{"inputs":[{"name":"u8"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",511,{"inputs":[{"name":"u8"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",511,{"inputs":[{"name":"u8"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",508,{"inputs":[{"name":"i16"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",508,{"inputs":[{"name":"i16"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",508,{"inputs":[{"name":"i16"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",508,{"inputs":[{"name":"i16"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",508,{"inputs":[{"name":"i16"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",512,{"inputs":[{"name":"u16"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",512,{"inputs":[{"name":"u16"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",512,{"inputs":[{"name":"u16"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",512,{"inputs":[{"name":"u16"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",512,{"inputs":[{"name":"u16"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",509,{"inputs":[{"name":"i32"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",509,{"inputs":[{"name":"i32"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",509,{"inputs":[{"name":"i32"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",509,{"inputs":[{"name":"i32"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",509,{"inputs":[{"name":"i32"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",513,{"inputs":[{"name":"u32"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",513,{"inputs":[{"name":"u32"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",513,{"inputs":[{"name":"u32"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",513,{"inputs":[{"name":"u32"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",513,{"inputs":[{"name":"u32"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",510,{"inputs":[{"name":"i64"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",510,{"inputs":[{"name":"i64"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",510,{"inputs":[{"name":"i64"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",510,{"inputs":[{"name":"i64"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",510,{"inputs":[{"name":"i64"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",514,{"inputs":[{"name":"u64"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",514,{"inputs":[{"name":"u64"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",514,{"inputs":[{"name":"u64"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",514,{"inputs":[{"name":"u64"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",514,{"inputs":[{"name":"u64"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",507,{"inputs":[{"name":"i8"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",511,{"inputs":[{"name":"u8"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",508,{"inputs":[{"name":"i16"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",512,{"inputs":[{"name":"u16"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",509,{"inputs":[{"name":"i32"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",513,{"inputs":[{"name":"u32"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",510,{"inputs":[{"name":"i64"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",514,{"inputs":[{"name":"u64"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",516,{"inputs":[{"name":"isize"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",515,{"inputs":[{"name":"usize"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",520,{"inputs":[{"name":"bool"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",520,{"inputs":[{"name":"bool"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",524,{"inputs":[{"name":"str"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",524,{"inputs":[{"name":"str"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",522,{"inputs":[{"name":"char"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",522,{"inputs":[{"name":"char"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",519,{"inputs":[{"name":"pointer"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",519,{"inputs":[{"name":"pointer"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",517,{"inputs":[{"name":"f32"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",517,{"inputs":[{"name":"f32"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",517,{"inputs":[{"name":"f32"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",517,{"inputs":[{"name":"f32"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",518,{"inputs":[{"name":"f64"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",518,{"inputs":[{"name":"f64"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",518,{"inputs":[{"name":"f64"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",518,{"inputs":[{"name":"f64"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",519,{"inputs":[{"name":"pointer"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",519,{"inputs":[{"name":"pointer"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",521,{"inputs":[{"name":"tuple"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",521,{"inputs":[{"name":"tuple"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",521,{"inputs":[{"name":"tuple"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",521,{"inputs":[{"name":"tuple"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",521,{"inputs":[{"name":"tuple"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",521,{"inputs":[{"name":"tuple"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",521,{"inputs":[{"name":"tuple"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",521,{"inputs":[{"name":"tuple"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",521,{"inputs":[{"name":"tuple"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",521,{"inputs":[{"name":"tuple"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",521,{"inputs":[{"name":"tuple"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",521,{"inputs":[{"name":"tuple"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",523,{"inputs":[{"name":"slice"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",521,{"inputs":[{"name":"tuple"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",521,null],[11,"eq","","",521,null],[11,"ne","","",521,null],[11,"partial_cmp","","",521,null],[11,"lt","","",521,null],[11,"le","","",521,null],[11,"ge","","",521,null],[11,"gt","","",521,null],[11,"cmp","","",521,null],[11,"default","","",521,null],[11,"clone","","",521,null],[11,"eq","","",521,null],[11,"ne","","",521,null],[11,"partial_cmp","","",521,null],[11,"lt","","",521,null],[11,"le","","",521,null],[11,"ge","","",521,null],[11,"gt","","",521,null],[11,"cmp","","",521,null],[11,"default","","",521,null],[11,"clone","","",521,null],[11,"eq","","",521,null],[11,"ne","","",521,null],[11,"partial_cmp","","",521,null],[11,"lt","","",521,null],[11,"le","","",521,null],[11,"ge","","",521,null],[11,"gt","","",521,null],[11,"cmp","","",521,null],[11,"default","","",521,null],[11,"clone","","",521,null],[11,"eq","","",521,null],[11,"ne","","",521,null],[11,"partial_cmp","","",521,null],[11,"lt","","",521,null],[11,"le","","",521,null],[11,"ge","","",521,null],[11,"gt","","",521,null],[11,"cmp","","",521,null],[11,"default","","",521,null],[11,"clone","","",521,null],[11,"eq","","",521,null],[11,"ne","","",521,null],[11,"partial_cmp","","",521,null],[11,"lt","","",521,null],[11,"le","","",521,null],[11,"ge","","",521,null],[11,"gt","","",521,null],[11,"cmp","","",521,null],[11,"default","","",521,null],[11,"clone","","",521,null],[11,"eq","","",521,null],[11,"ne","","",521,null],[11,"partial_cmp","","",521,null],[11,"lt","","",521,null],[11,"le","","",521,null],[11,"ge","","",521,null],[11,"gt","","",521,null],[11,"cmp","","",521,null],[11,"default","","",521,null],[11,"clone","","",521,null],[11,"eq","","",521,null],[11,"ne","","",521,null],[11,"partial_cmp","","",521,null],[11,"lt","","",521,null],[11,"le","","",521,null],[11,"ge","","",521,null],[11,"gt","","",521,null],[11,"cmp","","",521,null],[11,"default","","",521,null],[11,"clone","","",521,null],[11,"eq","","",521,null],[11,"ne","","",521,null],[11,"partial_cmp","","",521,null],[11,"lt","","",521,null],[11,"le","","",521,null],[11,"ge","","",521,null],[11,"gt","","",521,null],[11,"cmp","","",521,null],[11,"default","","",521,null],[11,"clone","","",521,null],[11,"eq","","",521,null],[11,"ne","","",521,null],[11,"partial_cmp","","",521,null],[11,"lt","","",521,null],[11,"le","","",521,null],[11,"ge","","",521,null],[11,"gt","","",521,null],[11,"cmp","","",521,null],[11,"default","","",521,null],[11,"clone","","",521,null],[11,"eq","","",521,null],[11,"ne","","",521,null],[11,"partial_cmp","","",521,null],[11,"lt","","",521,null],[11,"le","","",521,null],[11,"ge","","",521,null],[11,"gt","","",521,null],[11,"cmp","","",521,null],[11,"default","","",521,null],[11,"clone","","",521,null],[11,"eq","","",521,null],[11,"ne","","",521,null],[11,"partial_cmp","","",521,null],[11,"lt","","",521,null],[11,"le","","",521,null],[11,"ge","","",521,null],[11,"gt","","",521,null],[11,"cmp","","",521,null],[11,"default","","",521,null],[11,"clone","","",521,null],[11,"eq","","",521,null],[11,"ne","","",521,null],[11,"partial_cmp","","",521,null],[11,"lt","","",521,null],[11,"le","","",521,null],[11,"ge","","",521,null],[11,"gt","","",521,null],[11,"cmp","","",521,null],[11,"default","","",521,null],[11,"len","","Returns the number of elements in the slice.",523,{"inputs":[{"name":"slice"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns true if the slice has a length of 0",523,{"inputs":[{"name":"slice"}],"output":{"name":"bool"}}],[11,"first","","Returns the first element of a slice, or `None` if it is empty.",523,{"inputs":[{"name":"slice"}],"output":{"name":"option"}}],[11,"first_mut","","Returns a mutable pointer to the first element of a slice, or `None` if it is empty",523,{"inputs":[{"name":"slice"}],"output":{"name":"option"}}],[11,"tail","","Returns all but the first element of a slice.",523,null],[11,"split_first","","Returns the first and all the rest of the elements of a slice.",523,{"inputs":[{"name":"slice"}],"output":{"name":"option"}}],[11,"tail_mut","","Returns all but the first element of a mutable slice",523,null],[11,"split_first_mut","","Returns the first and all the rest of the elements of a slice.",523,{"inputs":[{"name":"slice"}],"output":{"name":"option"}}],[11,"init","","Returns all but the last element of a slice.",523,null],[11,"split_last","","Returns the last and all the rest of the elements of a slice.",523,{"inputs":[{"name":"slice"}],"output":{"name":"option"}}],[11,"init_mut","","Returns all but the last element of a mutable slice",523,null],[11,"split_last_mut","","Returns the last and all the rest of the elements of a slice.",523,{"inputs":[{"name":"slice"}],"output":{"name":"option"}}],[11,"last","","Returns the last element of a slice, or `None` if it is empty.",523,{"inputs":[{"name":"slice"}],"output":{"name":"option"}}],[11,"last_mut","","Returns a mutable pointer to the last item in the slice.",523,{"inputs":[{"name":"slice"}],"output":{"name":"option"}}],[11,"get","","Returns the element of a slice at the given index, or `None` if the\nindex is out of bounds.",523,{"inputs":[{"name":"slice"},{"name":"usize"}],"output":{"name":"option"}}],[11,"get_mut","","Returns a mutable reference to the element at the given index,\nor `None` if the index is out of bounds",523,{"inputs":[{"name":"slice"},{"name":"usize"}],"output":{"name":"option"}}],[11,"get_unchecked","","Returns a pointer to the element at the given index, without doing\nbounds checking.",523,{"inputs":[{"name":"slice"},{"name":"usize"}],"output":{"name":"t"}}],[11,"get_unchecked_mut","","Returns an unsafe mutable pointer to the element in index",523,{"inputs":[{"name":"slice"},{"name":"usize"}],"output":{"name":"t"}}],[11,"as_ptr","","Returns an raw pointer to the slice's buffer",523,null],[11,"as_mut_ptr","","Returns an unsafe mutable pointer to the slice's buffer.",523,null],[11,"swap","","Swaps two elements in a slice.",523,null],[11,"reverse","","Reverse the order of elements in a slice, in place.",523,null],[11,"iter","","Returns an iterator over the slice.",523,{"inputs":[{"name":"slice"}],"output":{"name":"iter"}}],[11,"iter_mut","","Returns an iterator that allows modifying each value",523,{"inputs":[{"name":"slice"}],"output":{"name":"itermut"}}],[11,"windows","","Returns an iterator over all contiguous windows of length\n`size`. The windows overlap. If the slice is shorter than\n`size`, the iterator returns no values.",523,{"inputs":[{"name":"slice"},{"name":"usize"}],"output":{"name":"windows"}}],[11,"chunks","","Returns an iterator over `size` elements of the slice at a\ntime. The chunks do not overlap. If `size` does not divide the\nlength of the slice, then the last chunk will not have length\n`size`.",523,{"inputs":[{"name":"slice"},{"name":"usize"}],"output":{"name":"chunks"}}],[11,"chunks_mut","","Returns an iterator over `chunk_size` elements of the slice at a time.\nThe chunks are mutable and do not overlap. If `chunk_size` does\nnot divide the length of the slice, then the last chunk will not\nhave length `chunk_size`.",523,{"inputs":[{"name":"slice"},{"name":"usize"}],"output":{"name":"chunksmut"}}],[11,"split_at","","Divides one slice into two at an index.",523,null],[11,"split_at_mut","","Divides one `&mut` into two at an index.",523,null],[11,"split","","Returns an iterator over subslices separated by elements that match\n`pred`.  The matched element is not contained in the subslices.",523,{"inputs":[{"name":"slice"},{"name":"f"}],"output":{"name":"split"}}],[11,"split_mut","","Returns an iterator over mutable subslices separated by elements that\nmatch `pred`.  The matched element is not contained in the subslices.",523,{"inputs":[{"name":"slice"},{"name":"f"}],"output":{"name":"splitmut"}}],[11,"splitn","","Returns an iterator over subslices separated by elements that match\n`pred`, limited to returning at most `n` items.  The matched element is\nnot contained in the subslices.",523,{"inputs":[{"name":"slice"},{"name":"usize"},{"name":"f"}],"output":{"name":"splitn"}}],[11,"splitn_mut","","Returns an iterator over subslices separated by elements that match\n`pred`, limited to returning at most `n` items.  The matched element is\nnot contained in the subslices.",523,{"inputs":[{"name":"slice"},{"name":"usize"},{"name":"f"}],"output":{"name":"splitnmut"}}],[11,"rsplitn","","Returns an iterator over subslices separated by elements that match\n`pred` limited to returning at most `n` items. This starts at the end of\nthe slice and works backwards.  The matched element is not contained in\nthe subslices.",523,{"inputs":[{"name":"slice"},{"name":"usize"},{"name":"f"}],"output":{"name":"rsplitn"}}],[11,"rsplitn_mut","","Returns an iterator over subslices separated by elements that match\n`pred` limited to returning at most `n` items. This starts at the end of\nthe slice and works backwards.  The matched element is not contained in\nthe subslices.",523,{"inputs":[{"name":"slice"},{"name":"usize"},{"name":"f"}],"output":{"name":"rsplitnmut"}}],[11,"contains","","Returns true if the slice contains an element with the given value.",523,{"inputs":[{"name":"slice"},{"name":"t"}],"output":{"name":"bool"}}],[11,"starts_with","","Returns true if `needle` is a prefix of the slice.",523,null],[11,"ends_with","","Returns true if `needle` is a suffix of the slice.",523,null],[11,"position_elem","","Find the first index containing a matching value.",523,{"inputs":[{"name":"slice"},{"name":"t"}],"output":{"name":"option"}}],[11,"rposition_elem","","Find the last index containing a matching value.",523,{"inputs":[{"name":"slice"},{"name":"t"}],"output":{"name":"option"}}],[11,"binary_search","","Binary search a sorted slice for a given element.",523,{"inputs":[{"name":"slice"},{"name":"t"}],"output":{"name":"result"}}],[11,"binary_search_by","","Binary search a sorted slice with a comparator function.",523,{"inputs":[{"name":"slice"},{"name":"f"}],"output":{"name":"result"}}],[11,"sort","","Sorts the slice, in place.",523,null],[11,"sort_by","","Sorts the slice, in place, using `compare` to compare\nelements.",523,null],[11,"permutations","","Creates an iterator that yields every possible permutation of the\nvector in succession.",523,{"inputs":[{"name":"slice"}],"output":{"name":"permutations"}}],[11,"next_permutation","","Mutates the slice to the next lexicographic permutation.",523,{"inputs":[{"name":"slice"}],"output":{"name":"bool"}}],[11,"prev_permutation","","Mutates the slice to the previous lexicographic permutation.",523,{"inputs":[{"name":"slice"}],"output":{"name":"bool"}}],[11,"clone_from_slice","","Copies as many elements from `src` as it can into `self` (the\nshorter of `self.len()` and `src.len()`). Returns the number\nof elements copied.",523,null],[11,"move_from","","Consumes `src` and moves as many elements as it can into `self`\nfrom the range [start,end).",523,{"inputs":[{"name":"slice"},{"name":"vec"},{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"to_vec","","Copies `self` into a new `Vec`.",523,{"inputs":[{"name":"slice"}],"output":{"name":"vec"}}],[11,"into_vec","","Converts `self` into a vector without clones or allocation.",523,{"inputs":[{"name":"slice"}],"output":{"name":"vec"}}],[11,"concat","","",523,{"inputs":[{"name":"slice"}],"output":{"name":"vec"}}],[11,"join","","",523,{"inputs":[{"name":"slice"},{"name":"t"}],"output":{"name":"vec"}}],[11,"connect","","",523,{"inputs":[{"name":"slice"},{"name":"t"}],"output":{"name":"vec"}}],[11,"to_owned","","",523,{"inputs":[{"name":"slice"}],"output":{"name":"vec"}}],[11,"concat","","",523,{"inputs":[{"name":"slice"}],"output":{"name":"string"}}],[11,"join","","",523,{"inputs":[{"name":"slice"},{"name":"str"}],"output":{"name":"string"}}],[11,"connect","","",523,{"inputs":[{"name":"slice"},{"name":"str"}],"output":{"name":"string"}}],[11,"to_owned","","",524,{"inputs":[{"name":"str"}],"output":{"name":"string"}}],[11,"len","","Returns the length of `self` in bytes.",524,{"inputs":[{"name":"str"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns true if this slice has a length of zero bytes.",524,{"inputs":[{"name":"str"}],"output":{"name":"bool"}}],[11,"width","","Returns a string's displayed width in columns.",524,{"inputs":[{"name":"str"},{"name":"bool"}],"output":{"name":"usize"}}],[11,"is_char_boundary","","Checks that `index`-th byte lies at the start and/or end of a\nUTF-8 code point sequence.",524,{"inputs":[{"name":"str"},{"name":"usize"}],"output":{"name":"bool"}}],[11,"as_bytes","","Converts `self` to a byte slice.",524,null],[11,"as_ptr","","Returns a raw pointer to the `&str`'s buffer.",524,null],[11,"slice_unchecked","","Takes a bytewise slice from a string.",524,{"inputs":[{"name":"str"},{"name":"usize"},{"name":"usize"}],"output":{"name":"str"}}],[11,"slice_mut_unchecked","","Takes a bytewise mutable slice from a string.",524,{"inputs":[{"name":"str"},{"name":"usize"},{"name":"usize"}],"output":{"name":"str"}}],[11,"slice_chars","","Returns a slice of the string from the range [`begin`..`end`) where indices\nare counted in code points.",524,{"inputs":[{"name":"str"},{"name":"usize"},{"name":"usize"}],"output":{"name":"str"}}],[11,"char_range_at","","Given a byte position, return the next code point and its index.",524,{"inputs":[{"name":"str"},{"name":"usize"}],"output":{"name":"charrange"}}],[11,"char_range_at_reverse","","Given a byte position, return the previous `char` and its position.",524,{"inputs":[{"name":"str"},{"name":"usize"}],"output":{"name":"charrange"}}],[11,"char_at","","Given a byte position, return the `char` at that position.",524,{"inputs":[{"name":"str"},{"name":"usize"}],"output":{"name":"char"}}],[11,"char_at_reverse","","Given a byte position, return the `char` at that position, counting\nfrom the end.",524,{"inputs":[{"name":"str"},{"name":"usize"}],"output":{"name":"char"}}],[11,"slice_shift_char","","Retrieves the first code point from a `&str` and returns it.",524,{"inputs":[{"name":"str"}],"output":{"name":"option"}}],[11,"split_at","","Divide one string slice into two at an index.",524,null],[11,"split_at_mut","","Divide one mutable string slice into two at an index.",524,null],[11,"chars","","An iterator over the code points of `self`.",524,{"inputs":[{"name":"str"}],"output":{"name":"chars"}}],[11,"char_indices","","An iterator over the `char`s of `self` and their byte offsets.",524,{"inputs":[{"name":"str"}],"output":{"name":"charindices"}}],[11,"bytes","","An iterator over the bytes of `self`.",524,{"inputs":[{"name":"str"}],"output":{"name":"bytes"}}],[11,"split_whitespace","","An iterator over the non-empty substrings of `self` which contain no whitespace,\nand which are separated by any amount of whitespace.",524,{"inputs":[{"name":"str"}],"output":{"name":"splitwhitespace"}}],[11,"words","","An iterator over the non-empty substrings of `self` which contain no whitespace,\nand which are separated by any amount of whitespace.",524,{"inputs":[{"name":"str"}],"output":{"name":"splitwhitespace"}}],[11,"lines","","An iterator over the lines of a string, separated by `\\n`.",524,{"inputs":[{"name":"str"}],"output":{"name":"lines"}}],[11,"lines_any","","An iterator over the lines of a string, separated by either\n`\\n` or `\\r\\n`.",524,{"inputs":[{"name":"str"}],"output":{"name":"linesany"}}],[11,"nfd_chars","","Returns an iterator over the string in Unicode Normalization Form D\n(canonical decomposition).",524,{"inputs":[{"name":"str"}],"output":{"name":"decompositions"}}],[11,"nfkd_chars","","Returns an iterator over the string in Unicode Normalization Form KD\n(compatibility decomposition).",524,{"inputs":[{"name":"str"}],"output":{"name":"decompositions"}}],[11,"nfc_chars","","An Iterator over the string in Unicode Normalization Form C\n(canonical decomposition followed by canonical composition).",524,{"inputs":[{"name":"str"}],"output":{"name":"recompositions"}}],[11,"nfkc_chars","","An Iterator over the string in Unicode Normalization Form KC\n(compatibility decomposition followed by canonical composition).",524,{"inputs":[{"name":"str"}],"output":{"name":"recompositions"}}],[11,"graphemes","","Returns an iterator over the [grapheme clusters][graphemes] of `self`.",524,{"inputs":[{"name":"str"},{"name":"bool"}],"output":{"name":"graphemes"}}],[11,"grapheme_indices","","Returns an iterator over the grapheme clusters of `self` and their\nbyte offsets. See\n`graphemes()` for more information.",524,{"inputs":[{"name":"str"},{"name":"bool"}],"output":{"name":"graphemeindices"}}],[11,"utf16_units","","Returns an iterator of `u16` over the string encoded as UTF-16.",524,{"inputs":[{"name":"str"}],"output":{"name":"utf16units"}}],[11,"contains","","Returns `true` if `self` contains another `&str`.",524,{"inputs":[{"name":"str"},{"name":"p"}],"output":{"name":"bool"}}],[11,"starts_with","","Returns `true` if the given `&str` is a prefix of the string.",524,{"inputs":[{"name":"str"},{"name":"p"}],"output":{"name":"bool"}}],[11,"ends_with","","Returns true if the given `&str` is a suffix of the string.",524,{"inputs":[{"name":"str"},{"name":"p"}],"output":{"name":"bool"}}],[11,"find","","Returns the byte index of the first character of `self` that matches\nthe pattern, if it\nexists.",524,{"inputs":[{"name":"str"},{"name":"p"}],"output":{"name":"option"}}],[11,"rfind","","Returns the byte index of the last character of `self` that\nmatches the pattern, if it\nexists.",524,{"inputs":[{"name":"str"},{"name":"p"}],"output":{"name":"option"}}],[11,"split","","An iterator over substrings of `self`, separated by characters\nmatched by a pattern.",524,{"inputs":[{"name":"str"},{"name":"p"}],"output":{"name":"split"}}],[11,"rsplit","","An iterator over substrings of `self`, separated by characters\nmatched by a pattern and yielded in reverse order.",524,{"inputs":[{"name":"str"},{"name":"p"}],"output":{"name":"rsplit"}}],[11,"split_terminator","","An iterator over substrings of `self`, separated by characters\nmatched by a pattern.",524,{"inputs":[{"name":"str"},{"name":"p"}],"output":{"name":"splitterminator"}}],[11,"rsplit_terminator","","An iterator over substrings of `self`, separated by characters\nmatched by a pattern and yielded in reverse order.",524,{"inputs":[{"name":"str"},{"name":"p"}],"output":{"name":"rsplitterminator"}}],[11,"splitn","","An iterator over substrings of `self`, separated by a pattern,\nrestricted to returning\nat most `count` items.",524,{"inputs":[{"name":"str"},{"name":"usize"},{"name":"p"}],"output":{"name":"splitn"}}],[11,"rsplitn","","An iterator over substrings of `self`, separated by a pattern,\nstarting from the end of the string, restricted to returning\nat most `count` items.",524,{"inputs":[{"name":"str"},{"name":"usize"},{"name":"p"}],"output":{"name":"rsplitn"}}],[11,"matches","","An iterator over the matches of a pattern within `self`.",524,{"inputs":[{"name":"str"},{"name":"p"}],"output":{"name":"matches"}}],[11,"rmatches","","An iterator over the matches of a pattern within `self`, yielded in\nreverse order.",524,{"inputs":[{"name":"str"},{"name":"p"}],"output":{"name":"rmatches"}}],[11,"match_indices","","An iterator over the start and end indices of the disjoint matches\nof a pattern within `self`.",524,{"inputs":[{"name":"str"},{"name":"p"}],"output":{"name":"matchindices"}}],[11,"rmatch_indices","","An iterator over the start and end indices of the disjoint matches of\na pattern within\n`self`, yielded in reverse order.",524,{"inputs":[{"name":"str"},{"name":"p"}],"output":{"name":"rmatchindices"}}],[11,"subslice_offset","","Returns the byte offset of an inner slice relative to an enclosing\nouter slice.",524,{"inputs":[{"name":"str"},{"name":"str"}],"output":{"name":"usize"}}],[11,"trim","","Returns a `&str` with leading and trailing whitespace removed.",524,{"inputs":[{"name":"str"}],"output":{"name":"str"}}],[11,"trim_left","","Returns a `&str` with leading whitespace removed.",524,{"inputs":[{"name":"str"}],"output":{"name":"str"}}],[11,"trim_right","","Returns a `&str` with trailing whitespace removed.",524,{"inputs":[{"name":"str"}],"output":{"name":"str"}}],[11,"trim_matches","","Returns a string with all pre- and suffixes that match a pattern\nrepeatedly removed.",524,{"inputs":[{"name":"str"},{"name":"p"}],"output":{"name":"str"}}],[11,"trim_left_matches","","Returns a string with all prefixes that match a pattern\nrepeatedly removed.",524,{"inputs":[{"name":"str"},{"name":"p"}],"output":{"name":"str"}}],[11,"trim_right_matches","","Returns a string with all suffixes that match a pattern\nrepeatedly removed.",524,{"inputs":[{"name":"str"},{"name":"p"}],"output":{"name":"str"}}],[11,"parse","","Parses `self` into the specified type.",524,{"inputs":[{"name":"str"}],"output":{"name":"result"}}],[11,"replace","","Replaces all occurrences of one string with another.",524,{"inputs":[{"name":"str"},{"name":"str"},{"name":"str"}],"output":{"name":"string"}}],[11,"to_lowercase","","Returns the lowercase equivalent of this string.",524,{"inputs":[{"name":"str"}],"output":{"name":"string"}}],[11,"to_uppercase","","Returns the uppercase equivalent of this string.",524,{"inputs":[{"name":"str"}],"output":{"name":"string"}}],[11,"escape_default","","Escapes each char in `s` with `char::escape_default`.",524,{"inputs":[{"name":"str"}],"output":{"name":"string"}}],[11,"escape_unicode","","Escapes each char in `s` with `char::escape_unicode`.",524,{"inputs":[{"name":"str"}],"output":{"name":"string"}}],[11,"into_string","","Converts the `Box<str>` into a `String` without copying or allocating.",524,{"inputs":[{"name":"str"}],"output":{"name":"string"}}],[11,"eq","","",524,{"inputs":[{"name":"str"},{"name":"string"}],"output":{"name":"bool"}}],[11,"ne","","",524,{"inputs":[{"name":"str"},{"name":"string"}],"output":{"name":"bool"}}],[11,"eq","","",524,{"inputs":[{"name":"str"},{"name":"string"}],"output":{"name":"bool"}}],[11,"ne","","",524,{"inputs":[{"name":"str"},{"name":"string"}],"output":{"name":"bool"}}],[11,"eq","","",524,{"inputs":[{"name":"str"},{"name":"cow"}],"output":{"name":"bool"}}],[11,"ne","","",524,{"inputs":[{"name":"str"},{"name":"cow"}],"output":{"name":"bool"}}],[11,"eq","","",524,{"inputs":[{"name":"str"},{"name":"cow"}],"output":{"name":"bool"}}],[11,"ne","","",524,{"inputs":[{"name":"str"},{"name":"cow"}],"output":{"name":"bool"}}],[11,"into_cow","","",524,{"inputs":[{"name":"str"}],"output":{"name":"cow"}}],[11,"into_cow","","",523,{"inputs":[{"name":"slice"}],"output":{"name":"cow"}}],[11,"graphemes","","",524,{"inputs":[{"name":"str"},{"name":"bool"}],"output":{"name":"graphemes"}}],[11,"grapheme_indices","","",524,{"inputs":[{"name":"str"},{"name":"bool"}],"output":{"name":"graphemeindices"}}],[11,"words","","",524,{"inputs":[{"name":"str"}],"output":{"name":"splitwhitespace"}}],[11,"split_whitespace","","",524,{"inputs":[{"name":"str"}],"output":{"name":"splitwhitespace"}}],[11,"is_whitespace","","",524,{"inputs":[{"name":"str"}],"output":{"name":"bool"}}],[11,"is_alphanumeric","","",524,{"inputs":[{"name":"str"}],"output":{"name":"bool"}}],[11,"width","","",524,{"inputs":[{"name":"str"},{"name":"bool"}],"output":{"name":"usize"}}],[11,"trim","","",524,{"inputs":[{"name":"str"}],"output":{"name":"str"}}],[11,"trim_left","","",524,{"inputs":[{"name":"str"}],"output":{"name":"str"}}],[11,"trim_right","","",524,{"inputs":[{"name":"str"}],"output":{"name":"str"}}],[11,"is_digit","","Checks if a `char` parses as a numeric digit in the given radix.",522,{"inputs":[{"name":"char"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"to_digit","","Converts a character to the corresponding digit.",522,{"inputs":[{"name":"char"},{"name":"u32"}],"output":{"name":"option"}}],[11,"escape_unicode","","Returns an iterator that yields the hexadecimal Unicode escape of a\ncharacter, as `char`s.",522,{"inputs":[{"name":"char"}],"output":{"name":"escapeunicode"}}],[11,"escape_default","","Returns an iterator that yields the 'default' ASCII and\nC++11-like literal escape of a character, as `char`s.",522,{"inputs":[{"name":"char"}],"output":{"name":"escapedefault"}}],[11,"len_utf8","","Returns the number of bytes this character would need if encoded in\nUTF-8.",522,{"inputs":[{"name":"char"}],"output":{"name":"usize"}}],[11,"len_utf16","","Returns the number of 16-bit code units this character would need if\nencoded in UTF-16.",522,{"inputs":[{"name":"char"}],"output":{"name":"usize"}}],[11,"encode_utf8","","Encodes this character as UTF-8 into the provided byte buffer, and then\nreturns the number of bytes written.",522,null],[11,"encode_utf16","","Encodes this character as UTF-16 into the provided `u16` buffer, and\nthen returns the number of `u16`s written.",522,null],[11,"is_alphabetic","","Returns whether the specified character is considered a Unicode\nalphabetic code point.",522,{"inputs":[{"name":"char"}],"output":{"name":"bool"}}],[11,"is_xid_start","","Returns whether the specified character satisfies the 'XID_Start'\nUnicode property.",522,{"inputs":[{"name":"char"}],"output":{"name":"bool"}}],[11,"is_xid_continue","","Returns whether the specified `char` satisfies the 'XID_Continue'\nUnicode property.",522,{"inputs":[{"name":"char"}],"output":{"name":"bool"}}],[11,"is_lowercase","","Indicates whether a character is in lowercase.",522,{"inputs":[{"name":"char"}],"output":{"name":"bool"}}],[11,"is_uppercase","","Indicates whether a character is in uppercase.",522,{"inputs":[{"name":"char"}],"output":{"name":"bool"}}],[11,"is_whitespace","","Indicates whether a character is whitespace.",522,{"inputs":[{"name":"char"}],"output":{"name":"bool"}}],[11,"is_alphanumeric","","Indicates whether a character is alphanumeric.",522,{"inputs":[{"name":"char"}],"output":{"name":"bool"}}],[11,"is_control","","Indicates whether a character is a control code point.",522,{"inputs":[{"name":"char"}],"output":{"name":"bool"}}],[11,"is_numeric","","Indicates whether the character is numeric (Nd, Nl, or No).",522,{"inputs":[{"name":"char"}],"output":{"name":"bool"}}],[11,"to_lowercase","","Converts a character to its lowercase equivalent.",522,{"inputs":[{"name":"char"}],"output":{"name":"tolowercase"}}],[11,"to_uppercase","","Converts a character to its uppercase equivalent.",522,{"inputs":[{"name":"char"}],"output":{"name":"touppercase"}}],[11,"width","","Returns this character's displayed width in columns, or `None` if it is a\ncontrol character other than `'\\x00'`.",522,{"inputs":[{"name":"char"},{"name":"bool"}],"output":{"name":"option"}}],[11,"from_str_radix","","Parses a float as with a given radix",517,{"inputs":[{"name":"f32"},{"name":"str"},{"name":"u32"}],"output":{"name":"result"}}],[11,"is_nan","","Returns `true` if this value is `NaN` and false otherwise.",517,{"inputs":[{"name":"f32"}],"output":{"name":"bool"}}],[11,"is_infinite","","Returns `true` if this value is positive infinity or negative infinity and\nfalse otherwise.",517,{"inputs":[{"name":"f32"}],"output":{"name":"bool"}}],[11,"is_finite","","Returns `true` if this number is neither infinite nor `NaN`.",517,{"inputs":[{"name":"f32"}],"output":{"name":"bool"}}],[11,"is_normal","","Returns `true` if the number is neither zero, infinite,\n[subnormal][subnormal], or `NaN`.",517,{"inputs":[{"name":"f32"}],"output":{"name":"bool"}}],[11,"classify","","Returns the floating point category of the number. If only one property\nis going to be tested, it is generally faster to use the specific\npredicate instead.",517,{"inputs":[{"name":"f32"}],"output":{"name":"fpcategory"}}],[11,"integer_decode","","Returns the mantissa, base 2 exponent, and sign as integers, respectively.\nThe original number can be recovered by `sign * mantissa * 2 ^ exponent`.\nThe floating point encoding is documented in the [Reference][floating-point].",517,null],[11,"floor","","Returns the largest integer less than or equal to a number.",517,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[11,"ceil","","Returns the smallest integer greater than or equal to a number.",517,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[11,"round","","Returns the nearest integer to a number. Round half-way cases away from\n`0.0`.",517,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[11,"trunc","","Returns the integer part of a number.",517,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[11,"fract","","Returns the fractional part of a number.",517,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[11,"abs","","Computes the absolute value of `self`. Returns `NAN` if the\nnumber is `NAN`.",517,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[11,"signum","","Returns a number that represents the sign of `self`.",517,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[11,"is_sign_positive","","Returns `true` if `self`'s sign bit is positive, including\n`+0.0` and `INFINITY`.",517,{"inputs":[{"name":"f32"}],"output":{"name":"bool"}}],[11,"is_sign_negative","","Returns `true` if `self`'s sign is negative, including `-0.0`\nand `NEG_INFINITY`.",517,{"inputs":[{"name":"f32"}],"output":{"name":"bool"}}],[11,"mul_add","","Fused multiply-add. Computes `(self * a) + b` with only one rounding\nerror. This produces a more accurate result with better performance than\na separate multiplication operation followed by an add.",517,{"inputs":[{"name":"f32"},{"name":"f32"},{"name":"f32"}],"output":{"name":"f32"}}],[11,"recip","","Takes the reciprocal (inverse) of a number, `1/x`.",517,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[11,"powi","","Raises a number to an integer power.",517,{"inputs":[{"name":"f32"},{"name":"i32"}],"output":{"name":"f32"}}],[11,"powf","","Raises a number to a floating point power.",517,{"inputs":[{"name":"f32"},{"name":"f32"}],"output":{"name":"f32"}}],[11,"sqrt","","Takes the square root of a number.",517,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[11,"exp","","Returns `e^(self)`, (the exponential function).",517,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[11,"exp2","","Returns `2^(self)`.",517,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[11,"ln","","Returns the natural logarithm of the number.",517,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[11,"log","","Returns the logarithm of the number with respect to an arbitrary base.",517,{"inputs":[{"name":"f32"},{"name":"f32"}],"output":{"name":"f32"}}],[11,"log2","","Returns the base 2 logarithm of the number.",517,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[11,"log10","","Returns the base 10 logarithm of the number.",517,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[11,"to_degrees","","Converts radians to degrees.",517,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[11,"to_radians","","Converts degrees to radians.",517,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[11,"ldexp","","Constructs a floating point number of `x*2^exp`.",517,{"inputs":[{"name":"f32"},{"name":"f32"},{"name":"isize"}],"output":{"name":"f32"}}],[11,"frexp","","Breaks the number into a normalized fraction and a base-2 exponent,\nsatisfying:",517,null],[11,"next_after","","Returns the next representable floating-point value in the direction of\n`other`.",517,{"inputs":[{"name":"f32"},{"name":"f32"}],"output":{"name":"f32"}}],[11,"max","","Returns the maximum of the two numbers.",517,{"inputs":[{"name":"f32"},{"name":"f32"}],"output":{"name":"f32"}}],[11,"min","","Returns the minimum of the two numbers.",517,{"inputs":[{"name":"f32"},{"name":"f32"}],"output":{"name":"f32"}}],[11,"abs_sub","","The positive difference of two numbers.",517,{"inputs":[{"name":"f32"},{"name":"f32"}],"output":{"name":"f32"}}],[11,"cbrt","","Takes the cubic root of a number.",517,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[11,"hypot","","Calculates the length of the hypotenuse of a right-angle triangle given\nlegs of length `x` and `y`.",517,{"inputs":[{"name":"f32"},{"name":"f32"}],"output":{"name":"f32"}}],[11,"sin","","Computes the sine of a number (in radians).",517,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[11,"cos","","Computes the cosine of a number (in radians).",517,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[11,"tan","","Computes the tangent of a number (in radians).",517,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[11,"asin","","Computes the arcsine of a number. Return value is in radians in\nthe range [-pi/2, pi/2] or NaN if the number is outside the range\n[-1, 1].",517,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[11,"acos","","Computes the arccosine of a number. Return value is in radians in\nthe range [0, pi] or NaN if the number is outside the range\n[-1, 1].",517,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[11,"atan","","Computes the arctangent of a number. Return value is in radians in the\nrange [-pi/2, pi/2];",517,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[11,"atan2","","Computes the four quadrant arctangent of `self` (`y`) and `other` (`x`).",517,{"inputs":[{"name":"f32"},{"name":"f32"}],"output":{"name":"f32"}}],[11,"sin_cos","","Simultaneously computes the sine and cosine of the number, `x`. Returns\n`(sin(x), cos(x))`.",517,null],[11,"exp_m1","","Returns `e^(self) - 1` in a way that is accurate even if the\nnumber is close to zero.",517,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[11,"ln_1p","","Returns `ln(1+n)` (natural logarithm) more accurately than if\nthe operations were performed separately.",517,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[11,"sinh","","Hyperbolic sine function.",517,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[11,"cosh","","Hyperbolic cosine function.",517,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[11,"tanh","","Hyperbolic tangent function.",517,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[11,"asinh","","Inverse hyperbolic sine function.",517,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[11,"acosh","","Inverse hyperbolic cosine function.",517,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[11,"atanh","","Inverse hyperbolic tangent function.",517,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[11,"from_str_radix","","Parses a float as with a given radix",518,{"inputs":[{"name":"f64"},{"name":"str"},{"name":"u32"}],"output":{"name":"result"}}],[11,"is_nan","","Returns `true` if this value is `NaN` and false otherwise.",518,{"inputs":[{"name":"f64"}],"output":{"name":"bool"}}],[11,"is_infinite","","Returns `true` if this value is positive infinity or negative infinity and\nfalse otherwise.",518,{"inputs":[{"name":"f64"}],"output":{"name":"bool"}}],[11,"is_finite","","Returns `true` if this number is neither infinite nor `NaN`.",518,{"inputs":[{"name":"f64"}],"output":{"name":"bool"}}],[11,"is_normal","","Returns `true` if the number is neither zero, infinite,\n[subnormal][subnormal], or `NaN`.",518,{"inputs":[{"name":"f64"}],"output":{"name":"bool"}}],[11,"classify","","Returns the floating point category of the number. If only one property\nis going to be tested, it is generally faster to use the specific\npredicate instead.",518,{"inputs":[{"name":"f64"}],"output":{"name":"fpcategory"}}],[11,"integer_decode","","Returns the mantissa, base 2 exponent, and sign as integers, respectively.\nThe original number can be recovered by `sign * mantissa * 2 ^ exponent`.\nThe floating point encoding is documented in the [Reference][floating-point].",518,null],[11,"floor","","Returns the largest integer less than or equal to a number.",518,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[11,"ceil","","Returns the smallest integer greater than or equal to a number.",518,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[11,"round","","Returns the nearest integer to a number. Round half-way cases away from\n`0.0`.",518,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[11,"trunc","","Returns the integer part of a number.",518,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[11,"fract","","Returns the fractional part of a number.",518,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[11,"abs","","Computes the absolute value of `self`. Returns `NAN` if the\nnumber is `NAN`.",518,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[11,"signum","","Returns a number that represents the sign of `self`.",518,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[11,"is_sign_positive","","Returns `true` if `self`'s sign bit is positive, including\n`+0.0` and `INFINITY`.",518,{"inputs":[{"name":"f64"}],"output":{"name":"bool"}}],[11,"is_positive","","",518,{"inputs":[{"name":"f64"}],"output":{"name":"bool"}}],[11,"is_sign_negative","","Returns `true` if `self`'s sign is negative, including `-0.0`\nand `NEG_INFINITY`.",518,{"inputs":[{"name":"f64"}],"output":{"name":"bool"}}],[11,"is_negative","","",518,{"inputs":[{"name":"f64"}],"output":{"name":"bool"}}],[11,"mul_add","","Fused multiply-add. Computes `(self * a) + b` with only one rounding\nerror. This produces a more accurate result with better performance than\na separate multiplication operation followed by an add.",518,{"inputs":[{"name":"f64"},{"name":"f64"},{"name":"f64"}],"output":{"name":"f64"}}],[11,"recip","","Takes the reciprocal (inverse) of a number, `1/x`.",518,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[11,"powi","","Raises a number to an integer power.",518,{"inputs":[{"name":"f64"},{"name":"i32"}],"output":{"name":"f64"}}],[11,"powf","","Raises a number to a floating point power.",518,{"inputs":[{"name":"f64"},{"name":"f64"}],"output":{"name":"f64"}}],[11,"sqrt","","Takes the square root of a number.",518,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[11,"exp","","Returns `e^(self)`, (the exponential function).",518,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[11,"exp2","","Returns `2^(self)`.",518,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[11,"ln","","Returns the natural logarithm of the number.",518,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[11,"log","","Returns the logarithm of the number with respect to an arbitrary base.",518,{"inputs":[{"name":"f64"},{"name":"f64"}],"output":{"name":"f64"}}],[11,"log2","","Returns the base 2 logarithm of the number.",518,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[11,"log10","","Returns the base 10 logarithm of the number.",518,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[11,"to_degrees","","Converts radians to degrees.",518,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[11,"to_radians","","Converts degrees to radians.",518,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[11,"ldexp","","Constructs a floating point number of `x*2^exp`.",518,{"inputs":[{"name":"f64"},{"name":"f64"},{"name":"isize"}],"output":{"name":"f64"}}],[11,"frexp","","Breaks the number into a normalized fraction and a base-2 exponent,\nsatisfying:",518,null],[11,"next_after","","Returns the next representable floating-point value in the direction of\n`other`.",518,{"inputs":[{"name":"f64"},{"name":"f64"}],"output":{"name":"f64"}}],[11,"max","","Returns the maximum of the two numbers.",518,{"inputs":[{"name":"f64"},{"name":"f64"}],"output":{"name":"f64"}}],[11,"min","","Returns the minimum of the two numbers.",518,{"inputs":[{"name":"f64"},{"name":"f64"}],"output":{"name":"f64"}}],[11,"abs_sub","","The positive difference of two numbers.",518,{"inputs":[{"name":"f64"},{"name":"f64"}],"output":{"name":"f64"}}],[11,"cbrt","","Takes the cubic root of a number.",518,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[11,"hypot","","Calculates the length of the hypotenuse of a right-angle triangle given\nlegs of length `x` and `y`.",518,{"inputs":[{"name":"f64"},{"name":"f64"}],"output":{"name":"f64"}}],[11,"sin","","Computes the sine of a number (in radians).",518,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[11,"cos","","Computes the cosine of a number (in radians).",518,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[11,"tan","","Computes the tangent of a number (in radians).",518,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[11,"asin","","Computes the arcsine of a number. Return value is in radians in\nthe range [-pi/2, pi/2] or NaN if the number is outside the range\n[-1, 1].",518,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[11,"acos","","Computes the arccosine of a number. Return value is in radians in\nthe range [0, pi] or NaN if the number is outside the range\n[-1, 1].",518,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[11,"atan","","Computes the arctangent of a number. Return value is in radians in the\nrange [-pi/2, pi/2];",518,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[11,"atan2","","Computes the four quadrant arctangent of `self` (`y`) and `other` (`x`).",518,{"inputs":[{"name":"f64"},{"name":"f64"}],"output":{"name":"f64"}}],[11,"sin_cos","","Simultaneously computes the sine and cosine of the number, `x`. Returns\n`(sin(x), cos(x))`.",518,null],[11,"exp_m1","","Returns `e^(self) - 1` in a way that is accurate even if the\nnumber is close to zero.",518,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[11,"ln_1p","","Returns `ln(1+n)` (natural logarithm) more accurately than if\nthe operations were performed separately.",518,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[11,"sinh","","Hyperbolic sine function.",518,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[11,"cosh","","Hyperbolic cosine function.",518,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[11,"tanh","","Hyperbolic tangent function.",518,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[11,"asinh","","Inverse hyperbolic sine function.",518,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[11,"acosh","","Inverse hyperbolic cosine function.",518,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[11,"atanh","","Inverse hyperbolic tangent function.",518,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[11,"is_ascii","","",524,{"inputs":[{"name":"str"}],"output":{"name":"bool"}}],[11,"to_ascii_uppercase","","",524,{"inputs":[{"name":"str"}],"output":{"name":"string"}}],[11,"to_ascii_lowercase","","",524,{"inputs":[{"name":"str"}],"output":{"name":"string"}}],[11,"eq_ignore_ascii_case","","",524,{"inputs":[{"name":"str"},{"name":"str"}],"output":{"name":"bool"}}],[11,"make_ascii_uppercase","","",524,{"inputs":[{"name":"str"}],"output":null}],[11,"make_ascii_lowercase","","",524,{"inputs":[{"name":"str"}],"output":null}],[11,"is_ascii","","",523,{"inputs":[{"name":"slice"}],"output":{"name":"bool"}}],[11,"to_ascii_uppercase","","",523,{"inputs":[{"name":"slice"}],"output":{"name":"vec"}}],[11,"to_ascii_lowercase","","",523,{"inputs":[{"name":"slice"}],"output":{"name":"vec"}}],[11,"eq_ignore_ascii_case","","",523,null],[11,"make_ascii_uppercase","","",523,{"inputs":[{"name":"slice"}],"output":null}],[11,"make_ascii_lowercase","","",523,{"inputs":[{"name":"slice"}],"output":null}],[11,"is_ascii","","",511,{"inputs":[{"name":"u8"}],"output":{"name":"bool"}}],[11,"to_ascii_uppercase","","",511,{"inputs":[{"name":"u8"}],"output":{"name":"u8"}}],[11,"to_ascii_lowercase","","",511,{"inputs":[{"name":"u8"}],"output":{"name":"u8"}}],[11,"eq_ignore_ascii_case","","",511,{"inputs":[{"name":"u8"},{"name":"u8"}],"output":{"name":"bool"}}],[11,"make_ascii_uppercase","","",511,{"inputs":[{"name":"u8"}],"output":null}],[11,"make_ascii_lowercase","","",511,{"inputs":[{"name":"u8"}],"output":null}],[11,"is_ascii","","",522,{"inputs":[{"name":"char"}],"output":{"name":"bool"}}],[11,"to_ascii_uppercase","","",522,{"inputs":[{"name":"char"}],"output":{"name":"char"}}],[11,"to_ascii_lowercase","","",522,{"inputs":[{"name":"char"}],"output":{"name":"char"}}],[11,"eq_ignore_ascii_case","","",522,{"inputs":[{"name":"char"},{"name":"char"}],"output":{"name":"bool"}}],[11,"make_ascii_uppercase","","",522,{"inputs":[{"name":"char"}],"output":null}],[11,"make_ascii_lowercase","","",522,{"inputs":[{"name":"char"}],"output":null}],[11,"clone","std::collections::hash_map","",526,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[11,"clone","","",527,{"inputs":[{"name":"keys"}],"output":{"name":"keys"}}],[11,"clone","","",528,{"inputs":[{"name":"values"}],"output":{"name":"values"}}],[11,"next","","",526,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",526,null],[11,"len","","",526,{"inputs":[{"name":"iter"}],"output":{"name":"usize"}}],[11,"next","","",529,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"size_hint","","",529,null],[11,"len","","",529,{"inputs":[{"name":"itermut"}],"output":{"name":"usize"}}],[11,"next","","",530,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",530,null],[11,"len","","",530,{"inputs":[{"name":"intoiter"}],"output":{"name":"usize"}}],[11,"next","","",527,{"inputs":[{"name":"keys"}],"output":{"name":"option"}}],[11,"size_hint","","",527,null],[11,"len","","",527,{"inputs":[{"name":"keys"}],"output":{"name":"usize"}}],[11,"next","","",528,{"inputs":[{"name":"values"}],"output":{"name":"option"}}],[11,"size_hint","","",528,null],[11,"len","","",528,{"inputs":[{"name":"values"}],"output":{"name":"usize"}}],[11,"next","","",531,{"inputs":[{"name":"drain"}],"output":{"name":"option"}}],[11,"size_hint","","",531,null],[11,"len","","",531,{"inputs":[{"name":"drain"}],"output":{"name":"usize"}}],[11,"get","","Returns a mutable reference to the entry if occupied, or the VacantEntry if vacant",353,{"inputs":[{"name":"entry"}],"output":{"name":"result"}}],[11,"or_insert","","Ensures a value is in the entry by inserting the default if empty, and returns\na mutable reference to the value in the entry.",353,{"inputs":[{"name":"entry"},{"name":"v"}],"output":{"name":"v"}}],[11,"or_insert_with","","Ensures a value is in the entry by inserting the result of the default function if empty,\nand returns a mutable reference to the value in the entry.",353,{"inputs":[{"name":"entry"},{"name":"f"}],"output":{"name":"v"}}],[11,"get","","Gets a reference to the value in the entry.",532,{"inputs":[{"name":"occupiedentry"}],"output":{"name":"v"}}],[11,"get_mut","","Gets a mutable reference to the value in the entry.",532,{"inputs":[{"name":"occupiedentry"}],"output":{"name":"v"}}],[11,"into_mut","","Converts the OccupiedEntry into a mutable reference to the value in the entry\nwith a lifetime bound to the map itself",532,{"inputs":[{"name":"occupiedentry"}],"output":{"name":"v"}}],[11,"insert","","Sets the value of the entry, and returns the entry's old value",532,{"inputs":[{"name":"occupiedentry"},{"name":"v"}],"output":{"name":"v"}}],[11,"remove","","Takes the value out of the entry, and returns it",532,{"inputs":[{"name":"occupiedentry"}],"output":{"name":"v"}}],[11,"insert","","Sets the value of the entry with the VacantEntry's key,\nand returns a mutable reference to it",533,{"inputs":[{"name":"vacantentry"},{"name":"v"}],"output":{"name":"v"}}],[11,"clone","","",534,{"inputs":[{"name":"randomstate"}],"output":{"name":"randomstate"}}],[11,"new","","Constructs a new `RandomState` that is initialized with random keys.",534,{"inputs":[{"name":"randomstate"}],"output":{"name":"randomstate"}}],[11,"hasher","","",534,{"inputs":[{"name":"randomstate"}],"output":{"name":"siphasher"}}],[11,"default","","",534,{"inputs":[{"name":"randomstate"}],"output":{"name":"randomstate"}}],[11,"clone","std::collections::hash_set","",535,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[11,"next","","",535,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",535,null],[11,"len","","",535,{"inputs":[{"name":"iter"}],"output":{"name":"usize"}}],[11,"next","","",536,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",536,null],[11,"len","","",536,{"inputs":[{"name":"intoiter"}],"output":{"name":"usize"}}],[11,"next","","",537,{"inputs":[{"name":"drain"}],"output":{"name":"option"}}],[11,"size_hint","","",537,null],[11,"len","","",537,{"inputs":[{"name":"drain"}],"output":{"name":"usize"}}],[11,"clone","","",538,{"inputs":[{"name":"intersection"}],"output":{"name":"intersection"}}],[11,"next","","",538,{"inputs":[{"name":"intersection"}],"output":{"name":"option"}}],[11,"size_hint","","",538,null],[11,"clone","","",539,{"inputs":[{"name":"difference"}],"output":{"name":"difference"}}],[11,"next","","",539,{"inputs":[{"name":"difference"}],"output":{"name":"option"}}],[11,"size_hint","","",539,null],[11,"clone","","",540,{"inputs":[{"name":"symmetricdifference"}],"output":{"name":"symmetricdifference"}}],[11,"next","","",540,{"inputs":[{"name":"symmetricdifference"}],"output":{"name":"option"}}],[11,"size_hint","","",540,null],[11,"clone","","",541,{"inputs":[{"name":"union"}],"output":{"name":"union"}}],[11,"next","","",541,{"inputs":[{"name":"union"}],"output":{"name":"option"}}],[11,"size_hint","","",541,null],[11,"hasher","std::collections::hash_state","",542,{"inputs":[{"name":"defaultstate"}],"output":{"name":"h"}}],[11,"clone","","",542,{"inputs":[{"name":"defaultstate"}],"output":{"name":"defaultstate"}}],[11,"default","","",542,{"inputs":[{"name":"defaultstate"}],"output":{"name":"defaultstate"}}],[11,"from","std::io","",384,{"inputs":[{"name":"error"},{"name":"nulerror"}],"output":{"name":"error"}}],[11,"eq","std","",524,{"inputs":[{"name":"str"},{"name":"osstring"}],"output":{"name":"bool"}}],[11,"eq","","",524,{"inputs":[{"name":"str"},{"name":"osstr"}],"output":{"name":"bool"}}],[11,"as_ref","","",524,{"inputs":[{"name":"str"}],"output":{"name":"osstr"}}],[11,"metadata","std::path","",445,{"inputs":[{"name":"path"}],"output":{"name":"result"}}],[11,"symlink_metadata","","",445,{"inputs":[{"name":"path"}],"output":{"name":"result"}}],[11,"canonicalize","","",445,{"inputs":[{"name":"path"}],"output":{"name":"result"}}],[11,"read_link","","",445,{"inputs":[{"name":"path"}],"output":{"name":"result"}}],[11,"read_dir","","",445,{"inputs":[{"name":"path"}],"output":{"name":"result"}}],[11,"exists","","",445,{"inputs":[{"name":"path"}],"output":{"name":"bool"}}],[11,"is_file","","",445,{"inputs":[{"name":"path"}],"output":{"name":"bool"}}],[11,"is_dir","","",445,{"inputs":[{"name":"path"}],"output":{"name":"bool"}}],[11,"read","std","",523,null],[11,"fill_buf","","",523,{"inputs":[{"name":"slice"}],"output":{"name":"result"}}],[11,"consume","","",523,{"inputs":[{"name":"slice"},{"name":"usize"}],"output":null}],[11,"write","","",523,null],[11,"write_all","","",523,null],[11,"flush","","",523,{"inputs":[{"name":"slice"}],"output":{"name":"result"}}],[11,"from","","",513,{"inputs":[{"name":"u32"},{"name":"ipv4addr"}],"output":{"name":"u32"}}],[11,"to_socket_addrs","","",521,{"inputs":[{"name":"tuple"}],"output":{"name":"result"}}],[11,"to_socket_addrs","","",521,{"inputs":[{"name":"tuple"}],"output":{"name":"result"}}],[11,"to_socket_addrs","","",521,{"inputs":[{"name":"tuple"}],"output":{"name":"result"}}],[11,"to_socket_addrs","","",521,{"inputs":[{"name":"tuple"}],"output":{"name":"result"}}],[11,"to_socket_addrs","","",524,{"inputs":[{"name":"str"}],"output":{"name":"result"}}],[11,"uid","std::process","",452,{"inputs":[{"name":"command"},{"name":"uid_t"}],"output":{"name":"command"}}],[11,"gid","","",452,{"inputs":[{"name":"command"},{"name":"gid_t"}],"output":{"name":"command"}}],[11,"signal","","",454,{"inputs":[{"name":"exitstatus"}],"output":{"name":"option"}}],[11,"from_raw_fd","","",453,{"inputs":[{"name":"stdio"},{"name":"rawfd"}],"output":{"name":"stdio"}}],[11,"as_raw_fd","","",449,{"inputs":[{"name":"childstdin"}],"output":{"name":"rawfd"}}],[11,"as_raw_fd","","",450,{"inputs":[{"name":"childstdout"}],"output":{"name":"rawfd"}}],[11,"as_raw_fd","","",451,{"inputs":[{"name":"childstderr"}],"output":{"name":"rawfd"}}],[11,"into_raw_fd","","",449,{"inputs":[{"name":"childstdin"}],"output":{"name":"rawfd"}}],[11,"into_raw_fd","","",450,{"inputs":[{"name":"childstdout"}],"output":{"name":"rawfd"}}],[11,"into_raw_fd","","",451,{"inputs":[{"name":"childstderr"}],"output":{"name":"rawfd"}}],[11,"as_ref","std","",524,{"inputs":[{"name":"str"}],"output":{"name":"path"}}]],"paths":[[8,"Any"],[3,"TypeId"],[3,"Wrapping"],[3,"Big32x36"],[3,"Big8x3"],[3,"Decoded"],[4,"FullDecoded"],[3,"Fp"],[4,"Part"],[3,"Formatted"],[4,"Sign"],[4,"FpCategory"],[3,"ParseIntError"],[4,"IntErrorKind"],[3,"ParseFloatError"],[4,"FloatErrorKind"],[3,"NonZero"],[3,"Unique"],[3,"NoCopy"],[3,"PhantomData"],[3,"RangeFull"],[3,"Range"],[3,"RangeFrom"],[3,"RangeTo"],[4,"Ordering"],[3,"AtomicBool"],[3,"AtomicIsize"],[3,"AtomicUsize"],[3,"AtomicPtr"],[4,"Ordering"],[3,"Cell"],[4,"BorrowState"],[3,"RefCell"],[3,"BorrowRef"],[3,"Ref"],[3,"RefMut"],[3,"BorrowRefMut"],[3,"UnsafeCell"],[3,"EscapeUnicode"],[4,"EscapeUnicodeState"],[3,"EscapeDefault"],[4,"EscapeDefaultState"],[3,"Rev"],[4,"MinMaxResult"],[3,"Cloned"],[3,"Cycle"],[3,"Chain"],[3,"Zip"],[3,"Map"],[3,"Filter"],[3,"FilterMap"],[3,"Enumerate"],[3,"Peekable"],[3,"SkipWhile"],[3,"TakeWhile"],[3,"Skip"],[3,"Take"],[3,"Scan"],[3,"FlatMap"],[3,"Fuse"],[3,"Inspect"],[3,"Unfold"],[3,"StepBy"],[3,"RangeInclusive"],[3,"Repeat"],[3,"Empty"],[3,"Once"],[4,"Option"],[3,"Item"],[3,"Iter"],[3,"IterMut"],[3,"IntoIter"],[3,"Slice"],[3,"TraitObject"],[4,"Result"],[3,"Iter"],[3,"IterMut"],[3,"IntoIter"],[3,"i8x16"],[3,"i16x8"],[3,"i32x4"],[3,"i64x2"],[3,"u8x16"],[3,"u16x8"],[3,"u32x4"],[3,"u64x2"],[3,"f32x4"],[3,"f64x2"],[3,"Iter"],[3,"IterMut"],[3,"Split"],[3,"SplitMut"],[3,"GenericSplitN"],[3,"SplitN"],[3,"RSplitN"],[3,"SplitNMut"],[3,"RSplitNMut"],[3,"Windows"],[3,"Chunks"],[3,"ChunksMut"],[4,"SearchStep"],[3,"CharEqSearcher"],[3,"CharEqPattern"],[3,"CharSearcher"],[3,"CharSliceSearcher"],[3,"CharPredicateSearcher"],[3,"StrSearcher"],[4,"StrSearcherImpl"],[3,"EmptyNeedle"],[3,"TwoWaySearcher"],[4,"MatchOnly"],[4,"RejectAndMatch"],[3,"ParseBoolError"],[3,"Utf8Error"],[3,"Chars"],[3,"CharIndices"],[3,"Bytes"],[3,"BytesDeref"],[3,"SplitInternal"],[3,"Split"],[3,"RSplit"],[3,"SplitTerminator"],[3,"RSplitTerminator"],[3,"SplitNInternal"],[3,"SplitN"],[3,"RSplitN"],[3,"MatchIndicesInternal"],[3,"MatchIndices"],[3,"RMatchIndices"],[3,"MatchesInternal"],[3,"Matches"],[3,"RMatches"],[3,"Lines"],[3,"LinesAny"],[3,"LinesAnyMap"],[3,"CharRange"],[3,"SipHasher"],[3,"Binary"],[3,"Octal"],[3,"Decimal"],[3,"LowerHex"],[3,"UpperHex"],[3,"Radix"],[3,"RadixFmt"],[3,"PadAdapter"],[3,"DebugStruct"],[3,"DebugTuple"],[3,"DebugInner"],[3,"DebugSet"],[3,"DebugList"],[3,"DebugMap"],[3,"Argument"],[3,"FormatSpec"],[4,"Alignment"],[4,"Count"],[4,"Position"],[3,"Error"],[4,"FlagV1"],[3,"Arguments"],[3,"Formatter"],[8,"Clone"],[8,"PartialEq"],[8,"Ord"],[8,"PartialOrd"],[8,"AsRef"],[8,"AsMut"],[8,"Into"],[8,"From"],[8,"Default"],[8,"Hash"],[8,"Hasher"],[8,"Iterator"],[8,"FromIterator"],[8,"IntoIterator"],[8,"Extend"],[8,"DoubleEndedIterator"],[8,"RandomAccessIterator"],[8,"ExactSizeIterator"],[8,"Step"],[8,"Drop"],[8,"Add"],[8,"Sub"],[8,"Mul"],[8,"Div"],[8,"Rem"],[8,"Neg"],[8,"Not"],[8,"BitAnd"],[8,"BitOr"],[8,"BitXor"],[8,"Shl"],[8,"Shr"],[8,"Index"],[8,"IndexMut"],[8,"Deref"],[8,"DerefMut"],[8,"Fn"],[8,"FnMut"],[8,"FnOnce"],[8,"Place"],[8,"Placer"],[8,"InPlace"],[8,"Boxed"],[8,"BoxPlace"],[8,"Repr"],[3,"ExchangeHeapSingleton"],[3,"IntermediateBox"],[3,"Box"],[3,"Weak"],[3,"Arc"],[3,"Rc"],[3,"Weak"],[3,"RawVec"],[8,"FnBox"],[8,"Borrow"],[8,"BorrowMut"],[8,"ToOwned"],[4,"Cow"],[3,"BinaryHeap"],[3,"Hole"],[3,"Iter"],[3,"IntoIter"],[3,"Drain"],[3,"BitVec"],[3,"Iter"],[3,"BitSet"],[3,"BlockIter"],[3,"TwoBitPositions"],[3,"SetIter"],[3,"Union"],[3,"Intersection"],[3,"Difference"],[3,"SymmetricDifference"],[3,"RawItems"],[3,"Node"],[3,"Handle"],[3,"ElemsAndEdges"],[3,"MoveTraversalImpl"],[3,"AbsTraversal"],[3,"NodeSlice"],[3,"MutNodeSlice"],[3,"BTreeMap"],[3,"AbsIter"],[3,"IdRef"],[3,"PartialSearchStack"],[3,"Pusher"],[3,"SearchStack"],[3,"Iter"],[3,"IterMut"],[3,"IntoIter"],[3,"Keys"],[3,"Values"],[3,"Range"],[3,"RangeMut"],[4,"Entry"],[3,"VacantEntry"],[3,"OccupiedEntry"],[3,"BTreeSet"],[3,"Iter"],[3,"IntoIter"],[3,"Range"],[3,"Difference"],[3,"SymmetricDifference"],[3,"Intersection"],[3,"Union"],[3,"EnumSet"],[3,"Iter"],[3,"Iter"],[3,"IntoIter"],[3,"Rawlink"],[3,"LinkedList"],[3,"IterMut"],[3,"ElementSwaps"],[3,"Vec"],[4,"Direction"],[3,"SizeDirection"],[3,"Permutations"],[4,"DecompositionType"],[3,"Decompositions"],[4,"RecompositionState"],[3,"Recompositions"],[3,"Utf16Units"],[3,"String"],[3,"FromUtf8Error"],[3,"FromUtf16Error"],[3,"ParseError"],[3,"Drain"],[3,"IntoIter"],[3,"Drain"],[3,"PartialVecNonZeroSized"],[3,"PartialVecZeroSized"],[3,"VecDeque"],[3,"Iter"],[3,"IterMut"],[3,"IntoIter"],[3,"Drain"],[3,"VecMap"],[4,"Entry"],[3,"VacantEntry"],[3,"OccupiedEntry"],[3,"Iter"],[3,"IterMut"],[3,"Keys"],[3,"Values"],[3,"Drain"],[3,"IntoIter"],[4,"Bound"],[8,"IntoCow"],[8,"Binary"],[8,"Pointer"],[8,"Write"],[8,"Octal"],[8,"LowerHex"],[8,"UpperHex"],[8,"UpperExp"],[8,"Display"],[8,"Debug"],[8,"LowerExp"],[8,"SliceConcatExt"],[8,"MutableByteVector"],[8,"IntSliceExt"],[4,"GraphemeCat"],[3,"GraphemeIndices"],[3,"Graphemes"],[4,"GraphemeState"],[3,"Utf16Items"],[4,"Utf16Item"],[3,"Utf16Encoder"],[3,"SplitWhitespace"],[3,"ToLowercase"],[3,"ToUppercase"],[4,"CaseMappingIter"],[8,"FromStr"],[8,"Pattern"],[8,"Searcher"],[8,"ReverseSearcher"],[8,"ToString"],[8,"Error"],[8,"OwnedAsciiExt"],[8,"AsciiExt"],[3,"EscapeDefault"],[8,"Zero"],[8,"One"],[8,"OverflowingOps"],[4,"LocalKeyState"],[3,"LocalKey"],[3,"ScopedKey"],[3,"Builder"],[3,"Thread"],[3,"JoinHandle"],[3,"JoinGuard"],[3,"HashMap"],[3,"HashSet"],[4,"Entry"],[8,"HashState"],[3,"DynamicLibrary"],[4,"VarError"],[3,"Vars"],[3,"VarsOs"],[3,"SplitPaths"],[3,"JoinPathsError"],[3,"Args"],[3,"ArgsOs"],[3,"CString"],[3,"CStr"],[3,"NulError"],[3,"OsString"],[3,"OsStr"],[8,"PathExt"],[3,"OpenOptions"],[3,"Permissions"],[3,"FileType"],[3,"File"],[3,"Metadata"],[3,"ReadDir"],[3,"DirEntry"],[3,"WalkDir"],[3,"DirBuilder"],[4,"ErrorKind"],[4,"SeekFrom"],[4,"CharsError"],[3,"BufReader"],[3,"IntoInnerError"],[3,"BufWriter"],[3,"Error"],[3,"LineWriter"],[3,"BufStream"],[3,"Cursor"],[3,"Empty"],[3,"Repeat"],[3,"Sink"],[3,"Stdin"],[3,"StdinLock"],[3,"Stdout"],[3,"StdoutLock"],[3,"Stderr"],[3,"StderrLock"],[8,"Read"],[8,"Write"],[8,"Seek"],[8,"BufRead"],[3,"Broadcast"],[3,"Chain"],[3,"Take"],[3,"Tee"],[3,"Bytes"],[3,"Chars"],[3,"Split"],[3,"Lines"],[4,"IpAddr"],[4,"Ipv6MulticastScope"],[4,"SocketAddr"],[4,"Shutdown"],[3,"Ipv4Addr"],[3,"Ipv6Addr"],[3,"SocketAddrV4"],[3,"SocketAddrV6"],[3,"TcpStream"],[3,"TcpListener"],[3,"Incoming"],[3,"UdpSocket"],[3,"AddrParseError"],[8,"ToSocketAddrs"],[3,"LookupHost"],[8,"AsRawFd"],[8,"FromRawFd"],[8,"IntoRawFd"],[8,"OsStringExt"],[8,"OsStrExt"],[8,"PermissionsExt"],[8,"OpenOptionsExt"],[8,"MetadataExt"],[8,"FileTypeExt"],[8,"DirEntryExt"],[8,"DirBuilderExt"],[8,"CommandExt"],[8,"ExitStatusExt"],[3,"stat"],[8,"MetadataExt"],[4,"Prefix"],[4,"Component"],[3,"PrefixComponent"],[3,"Components"],[3,"Iter"],[3,"PathBuf"],[3,"Path"],[3,"Display"],[3,"Child"],[3,"Output"],[3,"ChildStdin"],[3,"ChildStdout"],[3,"ChildStderr"],[3,"Command"],[3,"Stdio"],[3,"ExitStatus"],[4,"TryLockError"],[4,"TryRecvError"],[4,"TrySendError"],[3,"Select"],[3,"Handle"],[3,"SendError"],[3,"RecvError"],[3,"Sender"],[3,"SyncSender"],[3,"Receiver"],[3,"Iter"],[3,"IntoIter"],[3,"Barrier"],[3,"BarrierWaitResult"],[3,"Condvar"],[3,"StaticCondvar"],[3,"Future"],[3,"Mutex"],[3,"StaticMutex"],[3,"MutexGuard"],[3,"Once"],[3,"RwLock"],[3,"StaticRwLock"],[3,"RwLockReadGuard"],[3,"RwLockWriteGuard"],[3,"Semaphore"],[3,"SemaphoreGuard"],[3,"Duration"],[3,"PoisonError"],[8,"Rng"],[3,"XorShiftRng"],[3,"Range"],[3,"Gamma"],[3,"GammaSmallShape"],[3,"GammaLargeShape"],[3,"ChiSquared"],[3,"FisherF"],[3,"StudentT"],[3,"StandardNormal"],[3,"Normal"],[3,"LogNormal"],[3,"Exp1"],[3,"Exp"],[3,"RandSample"],[3,"WeightedChoice"],[3,"IsaacRng"],[3,"Isaac64Rng"],[3,"ChaChaRng"],[3,"ReseedingRng"],[3,"ReseedWithDefault"],[3,"Generator"],[3,"AsciiGenerator"],[15,"i8"],[15,"i16"],[15,"i32"],[15,"i64"],[15,"u8"],[15,"u16"],[15,"u32"],[15,"u64"],[15,"usize"],[15,"isize"],[15,"f32"],[15,"f64"],[15,"pointer"],[15,"bool"],[15,"tuple"],[15,"char"],[15,"slice"],[15,"str"],[15,"array"],[3,"Iter"],[3,"Keys"],[3,"Values"],[3,"IterMut"],[3,"IntoIter"],[3,"Drain"],[3,"OccupiedEntry"],[3,"VacantEntry"],[3,"RandomState"],[3,"Iter"],[3,"IntoIter"],[3,"Drain"],[3,"Intersection"],[3,"Difference"],[3,"SymmetricDifference"],[3,"Union"],[3,"DefaultState"]]};
searchIndex['rustc_unicode'] = {"items":[[0,"","rustc_unicode","# The Unicode Library",null,null],[0,"char","","A Unicode scalar value",null,null],[17,"MAX","rustc_unicode::char","The highest valid code point",null,null],[5,"from_u32","","Converts a `u32` to an `Option<char>`.",null,{"inputs":[{"name":"u32"}],"output":{"name":"option"}}],[5,"from_u32_unchecked","","Converts a `u32` to an `char`, not checking whether it is a valid unicode\ncodepoint.",null,{"inputs":[{"name":"u32"}],"output":{"name":"char"}}],[5,"from_digit","","Converts a number to the character representing it.",null,{"inputs":[{"name":"u32"},{"name":"u32"}],"output":{"name":"option"}}],[11,"fmt","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",0,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"cmp","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"option"}}],[11,"lt","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"le","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"gt","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"ge","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"eq","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"ne","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"shl","","",0,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shr","","",0,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shl","","",0,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shr","","",0,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shl","","",0,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shr","","",0,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shl","","",0,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shr","","",0,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shl","","",0,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shr","","",0,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shl","","",0,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shr","","",0,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shl","","",0,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shr","","",0,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shl","","",0,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shr","","",0,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shl","","",0,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shr","","",0,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shl","","",0,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shr","","",0,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"add","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"sub","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"mul","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"div","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"not","","",0,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitxor","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitor","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitand","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"add","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"sub","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"mul","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"div","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"not","","",0,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitxor","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitor","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitand","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"add","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"sub","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"mul","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"div","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"not","","",0,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitxor","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitor","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitand","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"add","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"sub","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"mul","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"div","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"not","","",0,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitxor","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitor","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitand","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"add","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"sub","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"mul","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"div","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"not","","",0,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitxor","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitor","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitand","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"add","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"sub","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"mul","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"div","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"not","","",0,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitxor","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitor","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitand","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"add","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"sub","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"mul","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"div","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"not","","",0,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitxor","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitor","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitand","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"add","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"sub","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"mul","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"div","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"not","","",0,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitxor","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitor","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitand","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"add","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"sub","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"mul","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"div","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"not","","",0,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitxor","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitor","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitand","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"add","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"sub","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"mul","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"div","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"not","","",0,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitxor","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitor","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitand","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"from_small","core::num::flt2dec::bignum","Makes a bignum from one digit.",1,{"inputs":[{"name":"big32x36"},{"name":"u32"}],"output":{"name":"big32x36"}}],[11,"from_u64","","Makes a bignum from `u64` value.",1,{"inputs":[{"name":"big32x36"},{"name":"u64"}],"output":{"name":"big32x36"}}],[11,"is_zero","","Returns true if the bignum is zero.",1,{"inputs":[{"name":"big32x36"}],"output":{"name":"bool"}}],[11,"add","","Adds `other` to itself and returns its own mutable reference.",1,{"inputs":[{"name":"big32x36"},{"name":"big32x36"}],"output":{"name":"big32x36"}}],[11,"sub","","Subtracts `other` from itself and returns its own mutable reference.",1,{"inputs":[{"name":"big32x36"},{"name":"big32x36"}],"output":{"name":"big32x36"}}],[11,"mul_small","","Multiplies itself by a digit-sized `other` and returns its own\nmutable reference.",1,{"inputs":[{"name":"big32x36"},{"name":"u32"}],"output":{"name":"big32x36"}}],[11,"mul_pow2","","Multiplies itself by `2^bits` and returns its own mutable reference.",1,{"inputs":[{"name":"big32x36"},{"name":"usize"}],"output":{"name":"big32x36"}}],[11,"mul_digits","","Multiplies itself by a number described by `other[0] + other[1] * 2^W +\nother[2] * 2^(2W) + ...` (where `W` is the number of bits in the digit type)\nand returns its own mutable reference.",1,null],[11,"div_rem_small","","Divides itself by a digit-sized `other` and returns its own\nmutable reference *and* the remainder.",1,null],[11,"eq","","",1,{"inputs":[{"name":"big32x36"},{"name":"big32x36"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",1,{"inputs":[{"name":"big32x36"},{"name":"big32x36"}],"output":{"name":"option"}}],[11,"cmp","","",1,{"inputs":[{"name":"big32x36"},{"name":"big32x36"}],"output":{"name":"ordering"}}],[11,"clone","","",1,{"inputs":[{"name":"big32x36"}],"output":{"name":"big32x36"}}],[11,"fmt","","",1,{"inputs":[{"name":"big32x36"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from_small","core::num::flt2dec::bignum::tests","Makes a bignum from one digit.",2,{"inputs":[{"name":"big8x3"},{"name":"u8"}],"output":{"name":"big8x3"}}],[11,"from_u64","","Makes a bignum from `u64` value.",2,{"inputs":[{"name":"big8x3"},{"name":"u64"}],"output":{"name":"big8x3"}}],[11,"is_zero","","Returns true if the bignum is zero.",2,{"inputs":[{"name":"big8x3"}],"output":{"name":"bool"}}],[11,"add","","Adds `other` to itself and returns its own mutable reference.",2,{"inputs":[{"name":"big8x3"},{"name":"big8x3"}],"output":{"name":"big8x3"}}],[11,"sub","","Subtracts `other` from itself and returns its own mutable reference.",2,{"inputs":[{"name":"big8x3"},{"name":"big8x3"}],"output":{"name":"big8x3"}}],[11,"mul_small","","Multiplies itself by a digit-sized `other` and returns its own\nmutable reference.",2,{"inputs":[{"name":"big8x3"},{"name":"u8"}],"output":{"name":"big8x3"}}],[11,"mul_pow2","","Multiplies itself by `2^bits` and returns its own mutable reference.",2,{"inputs":[{"name":"big8x3"},{"name":"usize"}],"output":{"name":"big8x3"}}],[11,"mul_digits","","Multiplies itself by a number described by `other[0] + other[1] * 2^W +\nother[2] * 2^(2W) + ...` (where `W` is the number of bits in the digit type)\nand returns its own mutable reference.",2,null],[11,"div_rem_small","","Divides itself by a digit-sized `other` and returns its own\nmutable reference *and* the remainder.",2,null],[11,"eq","","",2,{"inputs":[{"name":"big8x3"},{"name":"big8x3"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",2,{"inputs":[{"name":"big8x3"},{"name":"big8x3"}],"output":{"name":"option"}}],[11,"cmp","","",2,{"inputs":[{"name":"big8x3"},{"name":"big8x3"}],"output":{"name":"ordering"}}],[11,"clone","","",2,{"inputs":[{"name":"big8x3"}],"output":{"name":"big8x3"}}],[11,"fmt","","",2,{"inputs":[{"name":"big8x3"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","core::num::flt2dec::decoder","",3,{"inputs":[{"name":"decoded"},{"name":"decoded"}],"output":{"name":"bool"}}],[11,"ne","","",3,{"inputs":[{"name":"decoded"},{"name":"decoded"}],"output":{"name":"bool"}}],[11,"fmt","","",3,{"inputs":[{"name":"decoded"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",3,{"inputs":[{"name":"decoded"}],"output":{"name":"decoded"}}],[11,"eq","","",4,{"inputs":[{"name":"fulldecoded"},{"name":"fulldecoded"}],"output":{"name":"bool"}}],[11,"ne","","",4,{"inputs":[{"name":"fulldecoded"},{"name":"fulldecoded"}],"output":{"name":"bool"}}],[11,"fmt","","",4,{"inputs":[{"name":"fulldecoded"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",4,{"inputs":[{"name":"fulldecoded"}],"output":{"name":"fulldecoded"}}],[11,"fmt","core::num::flt2dec::strategy::grisu","",5,{"inputs":[{"name":"fp"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",5,{"inputs":[{"name":"fp"}],"output":{"name":"fp"}}],[11,"fmt","core::num::flt2dec","",6,{"inputs":[{"name":"part"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",6,{"inputs":[{"name":"part"},{"name":"part"}],"output":{"name":"bool"}}],[11,"ne","","",6,{"inputs":[{"name":"part"},{"name":"part"}],"output":{"name":"bool"}}],[11,"clone","","",6,{"inputs":[{"name":"part"}],"output":{"name":"part"}}],[11,"len","","Returns the exact byte length of given part.",6,{"inputs":[{"name":"part"}],"output":{"name":"usize"}}],[11,"write","","Writes a part into the supplied buffer.\nReturns the number of written bytes, or `None` if the buffer is not enough.\n(It may still leave partially written bytes in the buffer; do not rely on that.)",6,null],[11,"clone","","",7,{"inputs":[{"name":"formatted"}],"output":{"name":"formatted"}}],[11,"len","","Returns the exact byte length of combined formatted result.",7,{"inputs":[{"name":"formatted"}],"output":{"name":"usize"}}],[11,"write","","Writes all formatted parts into the supplied buffer.\nReturns the number of written bytes, or `None` if the buffer is not enough.\n(It may still leave partially written bytes in the buffer; do not rely on that.)",7,null],[11,"fmt","","",8,{"inputs":[{"name":"sign"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",8,{"inputs":[{"name":"sign"},{"name":"sign"}],"output":{"name":"bool"}}],[11,"ne","","",8,{"inputs":[{"name":"sign"},{"name":"sign"}],"output":{"name":"bool"}}],[11,"clone","","",8,{"inputs":[{"name":"sign"}],"output":{"name":"sign"}}],[11,"fmt","core::num","",9,{"inputs":[{"name":"fpcategory"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",9,{"inputs":[{"name":"fpcategory"},{"name":"fpcategory"}],"output":{"name":"bool"}}],[11,"ne","","",9,{"inputs":[{"name":"fpcategory"},{"name":"fpcategory"}],"output":{"name":"bool"}}],[11,"clone","","",9,{"inputs":[{"name":"fpcategory"}],"output":{"name":"fpcategory"}}],[11,"eq","","",10,{"inputs":[{"name":"parseinterror"},{"name":"parseinterror"}],"output":{"name":"bool"}}],[11,"ne","","",10,{"inputs":[{"name":"parseinterror"},{"name":"parseinterror"}],"output":{"name":"bool"}}],[11,"clone","","",10,{"inputs":[{"name":"parseinterror"}],"output":{"name":"parseinterror"}}],[11,"fmt","","",10,{"inputs":[{"name":"parseinterror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",11,{"inputs":[{"name":"interrorkind"},{"name":"interrorkind"}],"output":{"name":"bool"}}],[11,"ne","","",11,{"inputs":[{"name":"interrorkind"},{"name":"interrorkind"}],"output":{"name":"bool"}}],[11,"clone","","",11,{"inputs":[{"name":"interrorkind"}],"output":{"name":"interrorkind"}}],[11,"fmt","","",11,{"inputs":[{"name":"interrorkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",10,{"inputs":[{"name":"parseinterror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",12,{"inputs":[{"name":"parsefloaterror"},{"name":"parsefloaterror"}],"output":{"name":"bool"}}],[11,"ne","","",12,{"inputs":[{"name":"parsefloaterror"},{"name":"parsefloaterror"}],"output":{"name":"bool"}}],[11,"clone","","",12,{"inputs":[{"name":"parsefloaterror"}],"output":{"name":"parsefloaterror"}}],[11,"fmt","","",12,{"inputs":[{"name":"parsefloaterror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",13,{"inputs":[{"name":"floaterrorkind"},{"name":"floaterrorkind"}],"output":{"name":"bool"}}],[11,"ne","","",13,{"inputs":[{"name":"floaterrorkind"},{"name":"floaterrorkind"}],"output":{"name":"bool"}}],[11,"clone","","",13,{"inputs":[{"name":"floaterrorkind"}],"output":{"name":"floaterrorkind"}}],[11,"fmt","","",13,{"inputs":[{"name":"floaterrorkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",12,{"inputs":[{"name":"parsefloaterror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","core::nonzero","",14,null],[11,"fmt","","",14,{"inputs":[{"name":"nonzero"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"partial_cmp","","",14,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"option"}}],[11,"lt","","",14,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"le","","",14,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"gt","","",14,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"ge","","",14,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"cmp","","",14,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"ordering"}}],[11,"eq","","",14,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"ne","","",14,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"clone","","",14,{"inputs":[{"name":"nonzero"}],"output":{"name":"nonzero"}}],[11,"new","","Creates an instance of NonZero with the provided value.\nYou must indeed ensure that the value is actually \"non-zero\".",14,{"inputs":[{"name":"nonzero"},{"name":"t"}],"output":{"name":"nonzero"}}],[11,"deref","","",14,{"inputs":[{"name":"nonzero"}],"output":{"name":"t"}}],[11,"new","core::ptr","Creates a new `Unique`.",15,null],[11,"get","","Dereferences the content.",15,{"inputs":[{"name":"unique"}],"output":{"name":"t"}}],[11,"get_mut","","Mutably dereferences the content.",15,{"inputs":[{"name":"unique"}],"output":{"name":"t"}}],[11,"deref","","",15,null],[11,"fmt","","",15,{"inputs":[{"name":"unique"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"cmp","core::marker","",16,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",16,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"option"}}],[11,"lt","","",16,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"le","","",16,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"gt","","",16,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"ge","","",16,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"eq","","",16,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"ne","","",16,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"clone","","",16,{"inputs":[{"name":"nocopy"}],"output":{"name":"nocopy"}}],[11,"hash","","",17,null],[11,"eq","","",17,{"inputs":[{"name":"phantomdata"},{"name":"phantomdata"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",17,{"inputs":[{"name":"phantomdata"},{"name":"phantomdata"}],"output":{"name":"option"}}],[11,"cmp","","",17,{"inputs":[{"name":"phantomdata"},{"name":"phantomdata"}],"output":{"name":"ordering"}}],[11,"clone","","",17,{"inputs":[{"name":"phantomdata"}],"output":{"name":"phantomdata"}}],[11,"eq","core::ops","",18,{"inputs":[{"name":"rangefull"},{"name":"rangefull"}],"output":{"name":"bool"}}],[11,"ne","","",18,{"inputs":[{"name":"rangefull"},{"name":"rangefull"}],"output":{"name":"bool"}}],[11,"clone","","",18,{"inputs":[{"name":"rangefull"}],"output":{"name":"rangefull"}}],[11,"fmt","","",18,{"inputs":[{"name":"rangefull"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",19,{"inputs":[{"name":"range"},{"name":"range"}],"output":{"name":"bool"}}],[11,"ne","","",19,{"inputs":[{"name":"range"},{"name":"range"}],"output":{"name":"bool"}}],[11,"clone","","",19,{"inputs":[{"name":"range"}],"output":{"name":"range"}}],[11,"fmt","","",19,{"inputs":[{"name":"range"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",20,{"inputs":[{"name":"rangefrom"},{"name":"rangefrom"}],"output":{"name":"bool"}}],[11,"ne","","",20,{"inputs":[{"name":"rangefrom"},{"name":"rangefrom"}],"output":{"name":"bool"}}],[11,"clone","","",20,{"inputs":[{"name":"rangefrom"}],"output":{"name":"rangefrom"}}],[11,"fmt","","",20,{"inputs":[{"name":"rangefrom"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",21,{"inputs":[{"name":"rangeto"},{"name":"rangeto"}],"output":{"name":"bool"}}],[11,"ne","","",21,{"inputs":[{"name":"rangeto"},{"name":"rangeto"}],"output":{"name":"bool"}}],[11,"clone","","",21,{"inputs":[{"name":"rangeto"}],"output":{"name":"rangeto"}}],[11,"fmt","","",21,{"inputs":[{"name":"rangeto"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","core::cmp","",22,{"inputs":[{"name":"ordering"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",22,{"inputs":[{"name":"ordering"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"ne","","",22,{"inputs":[{"name":"ordering"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"clone","","",22,{"inputs":[{"name":"ordering"}],"output":{"name":"ordering"}}],[11,"reverse","","Reverse the `Ordering`.",22,{"inputs":[{"name":"ordering"}],"output":{"name":"ordering"}}],[11,"cmp","","",22,{"inputs":[{"name":"ordering"},{"name":"ordering"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",22,{"inputs":[{"name":"ordering"},{"name":"ordering"}],"output":{"name":"option"}}],[11,"fmt","rustc_unicode","",23,{"inputs":[{"name":"any"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",23,{"inputs":[{"name":"any"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"is","","Returns true if the boxed type is the same as `T`",23,{"inputs":[{"name":"any"}],"output":{"name":"bool"}}],[11,"downcast_ref","","Returns some reference to the boxed value if it is of type `T`, or\n`None` if it isn't.",23,{"inputs":[{"name":"any"}],"output":{"name":"option"}}],[11,"downcast_mut","","Returns some mutable reference to the boxed value if it is of type `T`, or\n`None` if it isn't.",23,{"inputs":[{"name":"any"}],"output":{"name":"option"}}],[11,"is","","Forwards to the method defined on the type `Any`.",23,{"inputs":[{"name":"any"}],"output":{"name":"bool"}}],[11,"downcast_ref","","Forwards to the method defined on the type `Any`.",23,{"inputs":[{"name":"any"}],"output":{"name":"option"}}],[11,"downcast_mut","","Forwards to the method defined on the type `Any`.",23,{"inputs":[{"name":"any"}],"output":{"name":"option"}}],[11,"hash","core::any","",24,null],[11,"fmt","","",24,{"inputs":[{"name":"typeid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",24,{"inputs":[{"name":"typeid"},{"name":"typeid"}],"output":{"name":"bool"}}],[11,"ne","","",24,{"inputs":[{"name":"typeid"},{"name":"typeid"}],"output":{"name":"bool"}}],[11,"clone","","",24,{"inputs":[{"name":"typeid"}],"output":{"name":"typeid"}}],[11,"of","","Returns the `TypeId` of the type this generic function has been\ninstantiated with",24,{"inputs":[{"name":"typeid"}],"output":{"name":"typeid"}}],[11,"default","core::atomic","",25,{"inputs":[{"name":"atomicbool"}],"output":{"name":"atomicbool"}}],[11,"default","","",26,{"inputs":[{"name":"atomicisize"}],"output":{"name":"atomicisize"}}],[11,"default","","",27,{"inputs":[{"name":"atomicusize"}],"output":{"name":"atomicusize"}}],[11,"default","","",28,{"inputs":[{"name":"atomicptr"}],"output":{"name":"atomicptr"}}],[11,"clone","","",29,{"inputs":[{"name":"ordering"}],"output":{"name":"ordering"}}],[11,"new","","Creates a new `AtomicBool`.",25,{"inputs":[{"name":"atomicbool"},{"name":"bool"}],"output":{"name":"atomicbool"}}],[11,"load","","Loads a value from the bool.",25,{"inputs":[{"name":"atomicbool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"store","","Stores a value into the bool.",25,null],[11,"swap","","Stores a value into the bool, returning the old value.",25,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"compare_and_swap","","Stores a value into the `bool` if the current value is the same as the `current` value.",25,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"fetch_and","","Logical \"and\" with a boolean value.",25,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"fetch_nand","","Logical \"nand\" with a boolean value.",25,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"fetch_or","","Logical \"or\" with a boolean value.",25,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"fetch_xor","","Logical \"xor\" with a boolean value.",25,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"new","","Creates a new `AtomicIsize`.",26,{"inputs":[{"name":"atomicisize"},{"name":"isize"}],"output":{"name":"atomicisize"}}],[11,"load","","Loads a value from the isize.",26,{"inputs":[{"name":"atomicisize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"store","","Stores a value into the isize.",26,null],[11,"swap","","Stores a value into the isize, returning the old value.",26,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"compare_and_swap","","Stores a value into the `isize` if the current value is the same as the `current` value.",26,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"fetch_add","","Add an isize to the current value, returning the previous value.",26,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"fetch_sub","","Subtract an isize from the current value, returning the previous value.",26,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"fetch_and","","Bitwise and with the current isize, returning the previous value.",26,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"fetch_or","","Bitwise or with the current isize, returning the previous value.",26,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"fetch_xor","","Bitwise xor with the current isize, returning the previous value.",26,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"new","","Creates a new `AtomicUsize`.",27,{"inputs":[{"name":"atomicusize"},{"name":"usize"}],"output":{"name":"atomicusize"}}],[11,"load","","Loads a value from the usize.",27,{"inputs":[{"name":"atomicusize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"store","","Stores a value into the usize.",27,null],[11,"swap","","Stores a value into the usize, returning the old value.",27,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"compare_and_swap","","Stores a value into the `usize` if the current value is the same as the `current` value.",27,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"fetch_add","","Add to the current usize, returning the previous value.",27,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"fetch_sub","","Subtract from the current usize, returning the previous value.",27,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"fetch_and","","Bitwise and with the current usize, returning the previous value.",27,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"fetch_or","","Bitwise or with the current usize, returning the previous value.",27,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"fetch_xor","","Bitwise xor with the current usize, returning the previous value.",27,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"new","","Creates a new `AtomicPtr`.",28,null],[11,"load","","Loads a value from the pointer.",28,null],[11,"store","","Stores a value into the pointer.",28,null],[11,"swap","","Stores a value into the pointer, returning the old value.",28,null],[11,"compare_and_swap","","Stores a value into the pointer if the current value is the same as the `current` value.",28,null],[11,"fmt","","",27,{"inputs":[{"name":"atomicusize"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",26,{"inputs":[{"name":"atomicisize"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",25,{"inputs":[{"name":"atomicbool"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",28,{"inputs":[{"name":"atomicptr"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","core::cell","Creates a new `Cell` containing the given value.",30,{"inputs":[{"name":"cell"},{"name":"t"}],"output":{"name":"cell"}}],[11,"get","","Returns a copy of the contained value.",30,{"inputs":[{"name":"cell"}],"output":{"name":"t"}}],[11,"set","","Sets the contained value.",30,null],[11,"as_unsafe_cell","","Returns a reference to the underlying `UnsafeCell`.",30,{"inputs":[{"name":"cell"}],"output":{"name":"unsafecell"}}],[11,"clone","","",30,{"inputs":[{"name":"cell"}],"output":{"name":"cell"}}],[11,"default","","",30,{"inputs":[{"name":"cell"}],"output":{"name":"cell"}}],[11,"eq","","",30,{"inputs":[{"name":"cell"},{"name":"cell"}],"output":{"name":"bool"}}],[11,"fmt","","",31,{"inputs":[{"name":"borrowstate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",31,{"inputs":[{"name":"borrowstate"},{"name":"borrowstate"}],"output":{"name":"bool"}}],[11,"ne","","",31,{"inputs":[{"name":"borrowstate"},{"name":"borrowstate"}],"output":{"name":"bool"}}],[11,"clone","","",31,{"inputs":[{"name":"borrowstate"}],"output":{"name":"borrowstate"}}],[11,"new","","Creates a new `RefCell` containing `value`.",32,{"inputs":[{"name":"refcell"},{"name":"t"}],"output":{"name":"refcell"}}],[11,"into_inner","","Consumes the `RefCell`, returning the wrapped value.",32,{"inputs":[{"name":"refcell"}],"output":{"name":"t"}}],[11,"borrow_state","","Query the current state of this `RefCell`",32,{"inputs":[{"name":"refcell"}],"output":{"name":"borrowstate"}}],[11,"borrow","","Immutably borrows the wrapped value.",32,{"inputs":[{"name":"refcell"}],"output":{"name":"ref"}}],[11,"borrow_mut","","Mutably borrows the wrapped value.",32,{"inputs":[{"name":"refcell"}],"output":{"name":"refmut"}}],[11,"as_unsafe_cell","","Returns a reference to the underlying `UnsafeCell`.",32,{"inputs":[{"name":"refcell"}],"output":{"name":"unsafecell"}}],[11,"clone","","",32,{"inputs":[{"name":"refcell"}],"output":{"name":"refcell"}}],[11,"default","","",32,{"inputs":[{"name":"refcell"}],"output":{"name":"refcell"}}],[11,"eq","","",32,{"inputs":[{"name":"refcell"},{"name":"refcell"}],"output":{"name":"bool"}}],[11,"drop","","",33,null],[11,"clone","","",33,{"inputs":[{"name":"borrowref"}],"output":{"name":"borrowref"}}],[11,"deref","","",34,{"inputs":[{"name":"ref"}],"output":{"name":"t"}}],[11,"clone","","Copies a `Ref`.",34,{"inputs":[{"name":"ref"},{"name":"ref"}],"output":{"name":"ref"}}],[11,"map","","Make a new `Ref` for a component of the borrowed data.",34,{"inputs":[{"name":"ref"},{"name":"ref"},{"name":"f"}],"output":{"name":"ref"}}],[11,"filter_map","","Make a new `Ref` for a optional component of the borrowed data, e.g. an\nenum variant.",34,{"inputs":[{"name":"ref"},{"name":"ref"},{"name":"f"}],"output":{"name":"option"}}],[11,"map","","Make a new `RefMut` for a component of the borrowed data, e.g. an enum\nvariant.",35,{"inputs":[{"name":"refmut"},{"name":"refmut"},{"name":"f"}],"output":{"name":"refmut"}}],[11,"filter_map","","Make a new `RefMut` for a optional component of the borrowed data, e.g.\nan enum variant.",35,{"inputs":[{"name":"refmut"},{"name":"refmut"},{"name":"f"}],"output":{"name":"option"}}],[11,"drop","","",36,null],[11,"deref","","",35,{"inputs":[{"name":"refmut"}],"output":{"name":"t"}}],[11,"deref_mut","","",35,{"inputs":[{"name":"refmut"}],"output":{"name":"t"}}],[11,"new","","Constructs a new instance of `UnsafeCell` which will wrap the specified\nvalue.",37,{"inputs":[{"name":"unsafecell"},{"name":"t"}],"output":{"name":"unsafecell"}}],[11,"into_inner","","Unwraps the value.",37,{"inputs":[{"name":"unsafecell"}],"output":{"name":"t"}}],[11,"get","","Gets a mutable pointer to the wrapped value.",37,null],[11,"clone","core::char","",38,{"inputs":[{"name":"escapeunicode"}],"output":{"name":"escapeunicode"}}],[11,"clone","","",39,{"inputs":[{"name":"escapeunicodestate"}],"output":{"name":"escapeunicodestate"}}],[11,"next","","",38,{"inputs":[{"name":"escapeunicode"}],"output":{"name":"option"}}],[11,"clone","","",40,{"inputs":[{"name":"escapedefault"}],"output":{"name":"escapedefault"}}],[11,"clone","","",41,{"inputs":[{"name":"escapedefaultstate"}],"output":{"name":"escapedefaultstate"}}],[11,"next","","",40,{"inputs":[{"name":"escapedefault"}],"output":{"name":"option"}}],[11,"clone","core::iter","",42,{"inputs":[{"name":"rev"}],"output":{"name":"rev"}}],[11,"next","","",42,{"inputs":[{"name":"rev"}],"output":{"name":"option"}}],[11,"size_hint","","",42,null],[11,"next_back","","",42,{"inputs":[{"name":"rev"}],"output":{"name":"option"}}],[11,"indexable","","",42,{"inputs":[{"name":"rev"}],"output":{"name":"usize"}}],[11,"idx","","",42,{"inputs":[{"name":"rev"},{"name":"usize"}],"output":{"name":"option"}}],[11,"fmt","","",43,{"inputs":[{"name":"minmaxresult"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",43,{"inputs":[{"name":"minmaxresult"},{"name":"minmaxresult"}],"output":{"name":"bool"}}],[11,"ne","","",43,{"inputs":[{"name":"minmaxresult"},{"name":"minmaxresult"}],"output":{"name":"bool"}}],[11,"clone","","",43,{"inputs":[{"name":"minmaxresult"}],"output":{"name":"minmaxresult"}}],[11,"into_option","","`into_option` creates an `Option` of type `(T,T)`. The returned `Option`\nhas variant `None` if and only if the `MinMaxResult` has variant\n`NoElements`. Otherwise variant `Some(x,y)` is returned where `x <= y`.\nIf `MinMaxResult` has variant `OneElement(x)`, performing this operation\nwill make one clone of `x`.",43,{"inputs":[{"name":"minmaxresult"}],"output":{"name":"option"}}],[11,"clone","","",44,{"inputs":[{"name":"cloned"}],"output":{"name":"cloned"}}],[11,"next","","",44,{"inputs":[{"name":"cloned"}],"output":{"name":"option"}}],[11,"size_hint","","",44,null],[11,"next_back","","",44,{"inputs":[{"name":"cloned"}],"output":{"name":"option"}}],[11,"indexable","","",44,{"inputs":[{"name":"cloned"}],"output":{"name":"usize"}}],[11,"idx","","",44,{"inputs":[{"name":"cloned"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",45,{"inputs":[{"name":"cycle"}],"output":{"name":"cycle"}}],[11,"next","","",45,{"inputs":[{"name":"cycle"}],"output":{"name":"option"}}],[11,"size_hint","","",45,null],[11,"indexable","","",45,{"inputs":[{"name":"cycle"}],"output":{"name":"usize"}}],[11,"idx","","",45,{"inputs":[{"name":"cycle"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",46,{"inputs":[{"name":"chain"}],"output":{"name":"chain"}}],[11,"next","","",46,{"inputs":[{"name":"chain"}],"output":{"name":"option"}}],[11,"count","","",46,{"inputs":[{"name":"chain"}],"output":{"name":"usize"}}],[11,"nth","","",46,{"inputs":[{"name":"chain"},{"name":"usize"}],"output":{"name":"option"}}],[11,"last","","",46,{"inputs":[{"name":"chain"}],"output":{"name":"option"}}],[11,"size_hint","","",46,null],[11,"next_back","","",46,{"inputs":[{"name":"chain"}],"output":{"name":"option"}}],[11,"indexable","","",46,{"inputs":[{"name":"chain"}],"output":{"name":"usize"}}],[11,"idx","","",46,{"inputs":[{"name":"chain"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",47,{"inputs":[{"name":"zip"}],"output":{"name":"zip"}}],[11,"next","","",47,{"inputs":[{"name":"zip"}],"output":{"name":"option"}}],[11,"size_hint","","",47,null],[11,"next_back","","",47,{"inputs":[{"name":"zip"}],"output":{"name":"option"}}],[11,"indexable","","",47,{"inputs":[{"name":"zip"}],"output":{"name":"usize"}}],[11,"idx","","",47,{"inputs":[{"name":"zip"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",48,{"inputs":[{"name":"map"}],"output":{"name":"map"}}],[11,"next","","",48,{"inputs":[{"name":"map"}],"output":{"name":"option"}}],[11,"size_hint","","",48,null],[11,"next_back","","",48,{"inputs":[{"name":"map"}],"output":{"name":"option"}}],[11,"indexable","","",48,{"inputs":[{"name":"map"}],"output":{"name":"usize"}}],[11,"idx","","",48,{"inputs":[{"name":"map"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",49,{"inputs":[{"name":"filter"}],"output":{"name":"filter"}}],[11,"next","","",49,{"inputs":[{"name":"filter"}],"output":{"name":"option"}}],[11,"size_hint","","",49,null],[11,"next_back","","",49,{"inputs":[{"name":"filter"}],"output":{"name":"option"}}],[11,"clone","","",50,{"inputs":[{"name":"filtermap"}],"output":{"name":"filtermap"}}],[11,"next","","",50,{"inputs":[{"name":"filtermap"}],"output":{"name":"option"}}],[11,"size_hint","","",50,null],[11,"next_back","","",50,{"inputs":[{"name":"filtermap"}],"output":{"name":"option"}}],[11,"clone","","",51,{"inputs":[{"name":"enumerate"}],"output":{"name":"enumerate"}}],[11,"next","","# Overflow Behavior",51,{"inputs":[{"name":"enumerate"}],"output":{"name":"option"}}],[11,"size_hint","","",51,null],[11,"nth","","",51,{"inputs":[{"name":"enumerate"},{"name":"usize"}],"output":{"name":"option"}}],[11,"count","","",51,{"inputs":[{"name":"enumerate"}],"output":{"name":"usize"}}],[11,"next_back","","",51,{"inputs":[{"name":"enumerate"}],"output":{"name":"option"}}],[11,"indexable","","",51,{"inputs":[{"name":"enumerate"}],"output":{"name":"usize"}}],[11,"idx","","",51,{"inputs":[{"name":"enumerate"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",52,{"inputs":[{"name":"peekable"}],"output":{"name":"peekable"}}],[11,"next","","",52,{"inputs":[{"name":"peekable"}],"output":{"name":"option"}}],[11,"count","","",52,{"inputs":[{"name":"peekable"}],"output":{"name":"usize"}}],[11,"nth","","",52,{"inputs":[{"name":"peekable"},{"name":"usize"}],"output":{"name":"option"}}],[11,"last","","",52,{"inputs":[{"name":"peekable"}],"output":{"name":"option"}}],[11,"size_hint","","",52,null],[11,"peek","","Returns a reference to the next element of the iterator with out\nadvancing it, or None if the iterator is exhausted.",52,{"inputs":[{"name":"peekable"}],"output":{"name":"option"}}],[11,"is_empty","","Checks whether peekable iterator is empty or not.",52,{"inputs":[{"name":"peekable"}],"output":{"name":"bool"}}],[11,"clone","","",53,{"inputs":[{"name":"skipwhile"}],"output":{"name":"skipwhile"}}],[11,"next","","",53,{"inputs":[{"name":"skipwhile"}],"output":{"name":"option"}}],[11,"size_hint","","",53,null],[11,"clone","","",54,{"inputs":[{"name":"takewhile"}],"output":{"name":"takewhile"}}],[11,"next","","",54,{"inputs":[{"name":"takewhile"}],"output":{"name":"option"}}],[11,"size_hint","","",54,null],[11,"clone","","",55,{"inputs":[{"name":"skip"}],"output":{"name":"skip"}}],[11,"next","","",55,{"inputs":[{"name":"skip"}],"output":{"name":"option"}}],[11,"nth","","",55,{"inputs":[{"name":"skip"},{"name":"usize"}],"output":{"name":"option"}}],[11,"count","","",55,{"inputs":[{"name":"skip"}],"output":{"name":"usize"}}],[11,"last","","",55,{"inputs":[{"name":"skip"}],"output":{"name":"option"}}],[11,"size_hint","","",55,null],[11,"indexable","","",55,{"inputs":[{"name":"skip"}],"output":{"name":"usize"}}],[11,"idx","","",55,{"inputs":[{"name":"skip"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",56,{"inputs":[{"name":"take"}],"output":{"name":"take"}}],[11,"next","","",56,{"inputs":[{"name":"take"}],"output":{"name":"option"}}],[11,"nth","","",56,{"inputs":[{"name":"take"},{"name":"usize"}],"output":{"name":"option"}}],[11,"size_hint","","",56,null],[11,"indexable","","",56,{"inputs":[{"name":"take"}],"output":{"name":"usize"}}],[11,"idx","","",56,{"inputs":[{"name":"take"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",57,{"inputs":[{"name":"scan"}],"output":{"name":"scan"}}],[11,"next","","",57,{"inputs":[{"name":"scan"}],"output":{"name":"option"}}],[11,"size_hint","","",57,null],[11,"clone","","",58,{"inputs":[{"name":"flatmap"}],"output":{"name":"flatmap"}}],[11,"next","","",58,{"inputs":[{"name":"flatmap"}],"output":{"name":"option"}}],[11,"size_hint","","",58,null],[11,"next_back","","",58,{"inputs":[{"name":"flatmap"}],"output":{"name":"option"}}],[11,"clone","","",59,{"inputs":[{"name":"fuse"}],"output":{"name":"fuse"}}],[11,"next","","",59,{"inputs":[{"name":"fuse"}],"output":{"name":"option"}}],[11,"nth","","",59,{"inputs":[{"name":"fuse"},{"name":"usize"}],"output":{"name":"option"}}],[11,"last","","",59,{"inputs":[{"name":"fuse"}],"output":{"name":"option"}}],[11,"count","","",59,{"inputs":[{"name":"fuse"}],"output":{"name":"usize"}}],[11,"size_hint","","",59,null],[11,"next_back","","",59,{"inputs":[{"name":"fuse"}],"output":{"name":"option"}}],[11,"indexable","","",59,{"inputs":[{"name":"fuse"}],"output":{"name":"usize"}}],[11,"idx","","",59,{"inputs":[{"name":"fuse"},{"name":"usize"}],"output":{"name":"option"}}],[11,"reset_fuse","","Resets the `Fuse` such that the next call to `.next()` or\n`.next_back()` will call the underlying iterator again even if it\npreviously returned `None`.",59,null],[11,"clone","","",60,{"inputs":[{"name":"inspect"}],"output":{"name":"inspect"}}],[11,"next","","",60,{"inputs":[{"name":"inspect"}],"output":{"name":"option"}}],[11,"size_hint","","",60,null],[11,"next_back","","",60,{"inputs":[{"name":"inspect"}],"output":{"name":"option"}}],[11,"indexable","","",60,{"inputs":[{"name":"inspect"}],"output":{"name":"usize"}}],[11,"idx","","",60,{"inputs":[{"name":"inspect"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",61,{"inputs":[{"name":"unfold"}],"output":{"name":"unfold"}}],[11,"new","","Creates a new iterator with the specified closure as the \"iterator\nfunction\" and an initial state to eventually pass to the closure",61,{"inputs":[{"name":"unfold"},{"name":"st"},{"name":"f"}],"output":{"name":"unfold"}}],[11,"next","","",61,{"inputs":[{"name":"unfold"}],"output":{"name":"option"}}],[11,"size_hint","","",61,null],[11,"clone","","",62,{"inputs":[{"name":"stepby"}],"output":{"name":"stepby"}}],[11,"step_by","core::ops","Creates an iterator starting at the same point, but stepping by\nthe given amount at each iteration.",20,{"inputs":[{"name":"rangefrom"},{"name":"a"}],"output":{"name":"stepby"}}],[11,"step_by","","Creates an iterator with the same range, but stepping by the\ngiven amount at each iteration.",19,{"inputs":[{"name":"range"},{"name":"a"}],"output":{"name":"stepby"}}],[11,"next","core::iter","",62,{"inputs":[{"name":"stepby"}],"output":{"name":"option"}}],[11,"size_hint","","",62,null],[11,"clone","","",63,{"inputs":[{"name":"rangeinclusive"}],"output":{"name":"rangeinclusive"}}],[11,"next","","",63,{"inputs":[{"name":"rangeinclusive"}],"output":{"name":"option"}}],[11,"size_hint","","",63,null],[11,"next_back","","",63,{"inputs":[{"name":"rangeinclusive"}],"output":{"name":"option"}}],[11,"next","","",62,{"inputs":[{"name":"stepby"}],"output":{"name":"option"}}],[11,"size_hint","","",62,null],[11,"next","core::ops","",19,{"inputs":[{"name":"range"}],"output":{"name":"option"}}],[11,"size_hint","","",19,null],[11,"next_back","","",19,{"inputs":[{"name":"range"}],"output":{"name":"option"}}],[11,"next","","",20,{"inputs":[{"name":"rangefrom"}],"output":{"name":"option"}}],[11,"clone","core::iter","",64,{"inputs":[{"name":"repeat"}],"output":{"name":"repeat"}}],[11,"next","","",64,{"inputs":[{"name":"repeat"}],"output":{"name":"option"}}],[11,"size_hint","","",64,null],[11,"next_back","","",64,{"inputs":[{"name":"repeat"}],"output":{"name":"option"}}],[11,"indexable","","",64,{"inputs":[{"name":"repeat"}],"output":{"name":"usize"}}],[11,"idx","","",64,{"inputs":[{"name":"repeat"},{"name":"usize"}],"output":{"name":"option"}}],[11,"next","","",65,{"inputs":[{"name":"empty"}],"output":{"name":"option"}}],[11,"size_hint","","",65,null],[11,"next_back","","",65,{"inputs":[{"name":"empty"}],"output":{"name":"option"}}],[11,"len","","",65,{"inputs":[{"name":"empty"}],"output":{"name":"usize"}}],[11,"clone","","",65,{"inputs":[{"name":"empty"}],"output":{"name":"empty"}}],[11,"default","","",65,{"inputs":[{"name":"empty"}],"output":{"name":"empty"}}],[11,"clone","","",66,{"inputs":[{"name":"once"}],"output":{"name":"once"}}],[11,"next","","",66,{"inputs":[{"name":"once"}],"output":{"name":"option"}}],[11,"size_hint","","",66,null],[11,"next_back","","",66,{"inputs":[{"name":"once"}],"output":{"name":"option"}}],[11,"len","","",66,{"inputs":[{"name":"once"}],"output":{"name":"usize"}}],[11,"hash","core::option","",67,null],[11,"fmt","","",67,{"inputs":[{"name":"option"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"cmp","","",67,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",67,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"option"}}],[11,"lt","","",67,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"le","","",67,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"gt","","",67,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"ge","","",67,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"eq","","",67,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"ne","","",67,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"clone","","",67,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[11,"is_some","","Returns `true` if the option is a `Some` value",67,{"inputs":[{"name":"option"}],"output":{"name":"bool"}}],[11,"is_none","","Returns `true` if the option is a `None` value",67,{"inputs":[{"name":"option"}],"output":{"name":"bool"}}],[11,"as_ref","","Converts from `Option<T>` to `Option<&T>`",67,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[11,"as_mut","","Converts from `Option<T>` to `Option<&mut T>`",67,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[11,"as_mut_slice","","Converts from `Option<T>` to `&mut [T]` (without copying)",67,null],[11,"expect","","Unwraps an option, yielding the content of a `Some`",67,{"inputs":[{"name":"option"},{"name":"str"}],"output":{"name":"t"}}],[11,"unwrap","","Moves the value `v` out of the `Option<T>` if it is `Some(v)`.",67,{"inputs":[{"name":"option"}],"output":{"name":"t"}}],[11,"unwrap_or","","Returns the contained value or a default.",67,{"inputs":[{"name":"option"},{"name":"t"}],"output":{"name":"t"}}],[11,"unwrap_or_else","","Returns the contained value or computes it from a closure.",67,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"t"}}],[11,"map","","Maps an `Option<T>` to `Option<U>` by applying a function to a contained value",67,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"option"}}],[11,"map_or","","Applies a function to the contained value (if any),\nor returns a `default` (if not).",67,{"inputs":[{"name":"option"},{"name":"u"},{"name":"f"}],"output":{"name":"u"}}],[11,"map_or_else","","Applies a function to the contained value (if any),\nor computes a `default` (if not).",67,{"inputs":[{"name":"option"},{"name":"d"},{"name":"f"}],"output":{"name":"u"}}],[11,"ok_or","","Transforms the `Option<T>` into a `Result<T, E>`, mapping `Some(v)` to\n`Ok(v)` and `None` to `Err(err)`.",67,{"inputs":[{"name":"option"},{"name":"e"}],"output":{"name":"result"}}],[11,"ok_or_else","","Transforms the `Option<T>` into a `Result<T, E>`, mapping `Some(v)` to\n`Ok(v)` and `None` to `Err(err())`.",67,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"result"}}],[11,"iter","","Returns an iterator over the possibly contained value.",67,{"inputs":[{"name":"option"}],"output":{"name":"iter"}}],[11,"iter_mut","","Returns a mutable iterator over the possibly contained value.",67,{"inputs":[{"name":"option"}],"output":{"name":"itermut"}}],[11,"and","","Returns `None` if the option is `None`, otherwise returns `optb`.",67,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"option"}}],[11,"and_then","","Returns `None` if the option is `None`, otherwise calls `f` with the\nwrapped value and returns the result.",67,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"option"}}],[11,"or","","Returns the option if it contains a value, otherwise returns `optb`.",67,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"option"}}],[11,"or_else","","Returns the option if it contains a value, otherwise calls `f` and\nreturns the result.",67,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"option"}}],[11,"take","","Takes the value out of the option, leaving a `None` in its place.",67,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[11,"as_slice","","Converts from `Option<T>` to `&[T]` (without copying)",67,null],[11,"cloned","","Maps an Option<&T> to an Option<T> by cloning the contents of the Option.",67,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[11,"unwrap_or_default","","Returns the contained value or a default",67,{"inputs":[{"name":"option"}],"output":{"name":"t"}}],[11,"default","","",67,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[11,"into_iter","","Returns a consuming iterator over the possibly contained value.",67,{"inputs":[{"name":"option"}],"output":{"name":"intoiter"}}],[11,"clone","","",68,{"inputs":[{"name":"item"}],"output":{"name":"item"}}],[11,"next","","",68,{"inputs":[{"name":"item"}],"output":{"name":"option"}}],[11,"size_hint","","",68,null],[11,"next_back","","",68,{"inputs":[{"name":"item"}],"output":{"name":"option"}}],[11,"next","","",69,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",69,null],[11,"next_back","","",69,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"clone","","",69,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[11,"next","","",70,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"size_hint","","",70,null],[11,"next_back","","",70,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"clone","","",71,{"inputs":[{"name":"intoiter"}],"output":{"name":"intoiter"}}],[11,"next","","",71,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",71,null],[11,"next_back","","",71,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"from_iter","","Takes each element in the `Iterator`: if it is `None`, no further\nelements are taken, and the `None` is returned. Should no `None` occur, a\ncontainer with the values of each `Option` is returned.",67,{"inputs":[{"name":"option"},{"name":"i"}],"output":{"name":"option"}}],[11,"clone","core::raw","",72,{"inputs":[{"name":"slice"}],"output":{"name":"slice"}}],[11,"clone","","",73,{"inputs":[{"name":"traitobject"}],"output":{"name":"traitobject"}}],[11,"hash","core::result","",74,null],[11,"fmt","","",74,{"inputs":[{"name":"result"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"cmp","","",74,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",74,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"option"}}],[11,"lt","","",74,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"le","","",74,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"gt","","",74,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"ge","","",74,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"eq","","",74,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"ne","","",74,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"clone","","",74,{"inputs":[{"name":"result"}],"output":{"name":"result"}}],[11,"is_ok","","Returns true if the result is `Ok`",74,{"inputs":[{"name":"result"}],"output":{"name":"bool"}}],[11,"is_err","","Returns true if the result is `Err`",74,{"inputs":[{"name":"result"}],"output":{"name":"bool"}}],[11,"ok","","Converts from `Result<T, E>` to `Option<T>`",74,{"inputs":[{"name":"result"}],"output":{"name":"option"}}],[11,"err","","Converts from `Result<T, E>` to `Option<E>`",74,{"inputs":[{"name":"result"}],"output":{"name":"option"}}],[11,"as_ref","","Converts from `Result<T, E>` to `Result<&T, &E>`",74,{"inputs":[{"name":"result"}],"output":{"name":"result"}}],[11,"as_mut","","Converts from `Result<T, E>` to `Result<&mut T, &mut E>`",74,{"inputs":[{"name":"result"}],"output":{"name":"result"}}],[11,"as_slice","","Converts from `Result<T, E>` to `&[T]` (without copying)",74,null],[11,"as_mut_slice","","Converts from `Result<T, E>` to `&mut [T]` (without copying)",74,null],[11,"map","","Maps a `Result<T, E>` to `Result<U, E>` by applying a function to an\ncontained `Ok` value, leaving an `Err` value untouched.",74,{"inputs":[{"name":"result"},{"name":"f"}],"output":{"name":"result"}}],[11,"map_err","","Maps a `Result<T, E>` to `Result<T, F>` by applying a function to an\ncontained `Err` value, leaving an `Ok` value untouched.",74,{"inputs":[{"name":"result"},{"name":"o"}],"output":{"name":"result"}}],[11,"iter","","Returns an iterator over the possibly contained value.",74,{"inputs":[{"name":"result"}],"output":{"name":"iter"}}],[11,"iter_mut","","Returns a mutable iterator over the possibly contained value.",74,{"inputs":[{"name":"result"}],"output":{"name":"itermut"}}],[11,"and","","Returns `res` if the result is `Ok`, otherwise returns the `Err` value of `self`.",74,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"result"}}],[11,"and_then","","Calls `op` if the result is `Ok`, otherwise returns the `Err` value of `self`.",74,{"inputs":[{"name":"result"},{"name":"f"}],"output":{"name":"result"}}],[11,"or","","Returns `res` if the result is `Err`, otherwise returns the `Ok` value of `self`.",74,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"result"}}],[11,"or_else","","Calls `op` if the result is `Err`, otherwise returns the `Ok` value of `self`.",74,{"inputs":[{"name":"result"},{"name":"o"}],"output":{"name":"result"}}],[11,"unwrap_or","","Unwraps a result, yielding the content of an `Ok`.\nElse it returns `optb`.",74,{"inputs":[{"name":"result"},{"name":"t"}],"output":{"name":"t"}}],[11,"unwrap_or_else","","Unwraps a result, yielding the content of an `Ok`.\nIf the value is an `Err` then it calls `op` with its value.",74,{"inputs":[{"name":"result"},{"name":"f"}],"output":{"name":"t"}}],[11,"unwrap","","Unwraps a result, yielding the content of an `Ok`.",74,{"inputs":[{"name":"result"}],"output":{"name":"t"}}],[11,"expect","","Unwraps a result, yielding the content of an `Ok`.",74,{"inputs":[{"name":"result"},{"name":"str"}],"output":{"name":"t"}}],[11,"unwrap_err","","Unwraps a result, yielding the content of an `Err`.",74,{"inputs":[{"name":"result"}],"output":{"name":"e"}}],[11,"into_iter","","Returns a consuming iterator over the possibly contained value.",74,{"inputs":[{"name":"result"}],"output":{"name":"intoiter"}}],[11,"next","","",75,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",75,null],[11,"next_back","","",75,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"clone","","",75,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[11,"next","","",76,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"size_hint","","",76,null],[11,"next_back","","",76,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"next","","",77,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",77,null],[11,"next_back","","",77,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"from_iter","","Takes each element in the `Iterator`: if it is an `Err`, no further\nelements are taken, and the `Err` is returned. Should no `Err` occur, a\ncontainer with the values of each `Result` is returned.",74,{"inputs":[{"name":"result"},{"name":"i"}],"output":{"name":"result"}}],[11,"fmt","core::simd","",78,{"inputs":[{"name":"i8x16"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",78,{"inputs":[{"name":"i8x16"}],"output":{"name":"i8x16"}}],[11,"fmt","","",79,{"inputs":[{"name":"i16x8"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",79,{"inputs":[{"name":"i16x8"}],"output":{"name":"i16x8"}}],[11,"fmt","","",80,{"inputs":[{"name":"i32x4"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",80,{"inputs":[{"name":"i32x4"}],"output":{"name":"i32x4"}}],[11,"fmt","","",81,{"inputs":[{"name":"i64x2"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",81,{"inputs":[{"name":"i64x2"}],"output":{"name":"i64x2"}}],[11,"fmt","","",82,{"inputs":[{"name":"u8x16"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",82,{"inputs":[{"name":"u8x16"}],"output":{"name":"u8x16"}}],[11,"fmt","","",83,{"inputs":[{"name":"u16x8"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",83,{"inputs":[{"name":"u16x8"}],"output":{"name":"u16x8"}}],[11,"fmt","","",84,{"inputs":[{"name":"u32x4"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",84,{"inputs":[{"name":"u32x4"}],"output":{"name":"u32x4"}}],[11,"fmt","","",85,{"inputs":[{"name":"u64x2"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",85,{"inputs":[{"name":"u64x2"}],"output":{"name":"u64x2"}}],[11,"fmt","","",86,{"inputs":[{"name":"f32x4"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",86,{"inputs":[{"name":"f32x4"}],"output":{"name":"f32x4"}}],[11,"fmt","","",87,{"inputs":[{"name":"f64x2"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",87,{"inputs":[{"name":"f64x2"}],"output":{"name":"f64x2"}}],[11,"as_slice","core::slice","View the underlying data as a subslice of the original data.",88,null],[11,"next","","",88,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",88,null],[11,"count","","",88,{"inputs":[{"name":"iter"}],"output":{"name":"usize"}}],[11,"nth","","",88,{"inputs":[{"name":"iter"},{"name":"usize"}],"output":{"name":"option"}}],[11,"last","","",88,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"next_back","","",88,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"clone","","",88,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[11,"indexable","","",88,{"inputs":[{"name":"iter"}],"output":{"name":"usize"}}],[11,"idx","","",88,{"inputs":[{"name":"iter"},{"name":"usize"}],"output":{"name":"option"}}],[11,"into_slice","","View the underlying data as a subslice of the original data.",89,null],[11,"next","","",89,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"size_hint","","",89,null],[11,"count","","",89,{"inputs":[{"name":"itermut"}],"output":{"name":"usize"}}],[11,"nth","","",89,{"inputs":[{"name":"itermut"},{"name":"usize"}],"output":{"name":"option"}}],[11,"last","","",89,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"next_back","","",89,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"clone","","",90,{"inputs":[{"name":"split"}],"output":{"name":"split"}}],[11,"next","","",90,{"inputs":[{"name":"split"}],"output":{"name":"option"}}],[11,"size_hint","","",90,null],[11,"next_back","","",90,{"inputs":[{"name":"split"}],"output":{"name":"option"}}],[11,"finish","","",90,{"inputs":[{"name":"split"}],"output":{"name":"option"}}],[11,"finish","","",91,{"inputs":[{"name":"splitmut"}],"output":{"name":"option"}}],[11,"next","","",91,{"inputs":[{"name":"splitmut"}],"output":{"name":"option"}}],[11,"size_hint","","",91,null],[11,"next_back","","",91,{"inputs":[{"name":"splitmut"}],"output":{"name":"option"}}],[11,"next","","",92,{"inputs":[{"name":"genericsplitn"}],"output":{"name":"option"}}],[11,"size_hint","","",92,null],[11,"next","","",93,{"inputs":[{"name":"splitn"}],"output":{"name":"option"}}],[11,"size_hint","","",93,null],[11,"next","","",94,{"inputs":[{"name":"rsplitn"}],"output":{"name":"option"}}],[11,"size_hint","","",94,null],[11,"next","","",95,{"inputs":[{"name":"splitnmut"}],"output":{"name":"option"}}],[11,"size_hint","","",95,null],[11,"next","","",96,{"inputs":[{"name":"rsplitnmut"}],"output":{"name":"option"}}],[11,"size_hint","","",96,null],[11,"clone","","",97,{"inputs":[{"name":"windows"}],"output":{"name":"windows"}}],[11,"next","","",97,{"inputs":[{"name":"windows"}],"output":{"name":"option"}}],[11,"size_hint","","",97,null],[11,"next_back","","",97,{"inputs":[{"name":"windows"}],"output":{"name":"option"}}],[11,"indexable","","",97,{"inputs":[{"name":"windows"}],"output":{"name":"usize"}}],[11,"idx","","",97,{"inputs":[{"name":"windows"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",98,{"inputs":[{"name":"chunks"}],"output":{"name":"chunks"}}],[11,"next","","",98,{"inputs":[{"name":"chunks"}],"output":{"name":"option"}}],[11,"size_hint","","",98,null],[11,"next_back","","",98,{"inputs":[{"name":"chunks"}],"output":{"name":"option"}}],[11,"indexable","","",98,{"inputs":[{"name":"chunks"}],"output":{"name":"usize"}}],[11,"idx","","",98,{"inputs":[{"name":"chunks"},{"name":"usize"}],"output":{"name":"option"}}],[11,"next","","",99,{"inputs":[{"name":"chunksmut"}],"output":{"name":"option"}}],[11,"size_hint","","",99,null],[11,"next_back","","",99,{"inputs":[{"name":"chunksmut"}],"output":{"name":"option"}}],[11,"fmt","core::str::pattern","",100,{"inputs":[{"name":"searchstep"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",100,{"inputs":[{"name":"searchstep"},{"name":"searchstep"}],"output":{"name":"bool"}}],[11,"ne","","",100,{"inputs":[{"name":"searchstep"},{"name":"searchstep"}],"output":{"name":"bool"}}],[11,"clone","","",100,{"inputs":[{"name":"searchstep"}],"output":{"name":"searchstep"}}],[11,"clone","","",101,{"inputs":[{"name":"chareqsearcher"}],"output":{"name":"chareqsearcher"}}],[11,"into_searcher","","",102,{"inputs":[{"name":"chareqpattern"},{"name":"str"}],"output":{"name":"chareqsearcher"}}],[11,"haystack","","",101,{"inputs":[{"name":"chareqsearcher"}],"output":{"name":"str"}}],[11,"next","","",101,{"inputs":[{"name":"chareqsearcher"}],"output":{"name":"searchstep"}}],[11,"next_back","","",101,{"inputs":[{"name":"chareqsearcher"}],"output":{"name":"searchstep"}}],[11,"clone","","",103,{"inputs":[{"name":"charsearcher"}],"output":{"name":"charsearcher"}}],[11,"haystack","","",103,{"inputs":[{"name":"charsearcher"}],"output":{"name":"str"}}],[11,"next","","",103,{"inputs":[{"name":"charsearcher"}],"output":{"name":"searchstep"}}],[11,"next_match","","",103,{"inputs":[{"name":"charsearcher"}],"output":{"name":"option"}}],[11,"next_reject","","",103,{"inputs":[{"name":"charsearcher"}],"output":{"name":"option"}}],[11,"next_back","","",103,{"inputs":[{"name":"charsearcher"}],"output":{"name":"searchstep"}}],[11,"next_match_back","","",103,{"inputs":[{"name":"charsearcher"}],"output":{"name":"option"}}],[11,"next_reject_back","","",103,{"inputs":[{"name":"charsearcher"}],"output":{"name":"option"}}],[11,"clone","","",104,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"charslicesearcher"}}],[11,"haystack","","",104,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"str"}}],[11,"next","","",104,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"searchstep"}}],[11,"next_match","","",104,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"option"}}],[11,"next_reject","","",104,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"option"}}],[11,"next_back","","",104,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"searchstep"}}],[11,"next_match_back","","",104,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"option"}}],[11,"next_reject_back","","",104,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"option"}}],[11,"clone","","",105,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"charpredicatesearcher"}}],[11,"haystack","","",105,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"str"}}],[11,"next","","",105,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"searchstep"}}],[11,"next_match","","",105,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"option"}}],[11,"next_reject","","",105,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"option"}}],[11,"next_back","","",105,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"searchstep"}}],[11,"next_match_back","","",105,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"option"}}],[11,"next_reject_back","","",105,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"option"}}],[11,"fmt","","",106,{"inputs":[{"name":"strsearcher"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",106,{"inputs":[{"name":"strsearcher"}],"output":{"name":"strsearcher"}}],[11,"fmt","","",107,{"inputs":[{"name":"strsearcherimpl"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",107,{"inputs":[{"name":"strsearcherimpl"}],"output":{"name":"strsearcherimpl"}}],[11,"fmt","","",108,{"inputs":[{"name":"emptyneedle"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",108,{"inputs":[{"name":"emptyneedle"}],"output":{"name":"emptyneedle"}}],[11,"haystack","","",106,{"inputs":[{"name":"strsearcher"}],"output":{"name":"str"}}],[11,"next","","",106,{"inputs":[{"name":"strsearcher"}],"output":{"name":"searchstep"}}],[11,"next_match","","",106,{"inputs":[{"name":"strsearcher"}],"output":{"name":"option"}}],[11,"next_back","","",106,{"inputs":[{"name":"strsearcher"}],"output":{"name":"searchstep"}}],[11,"next_match_back","","",106,{"inputs":[{"name":"strsearcher"}],"output":{"name":"option"}}],[11,"fmt","","",109,{"inputs":[{"name":"twowaysearcher"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",109,{"inputs":[{"name":"twowaysearcher"}],"output":{"name":"twowaysearcher"}}],[11,"use_early_reject","","",110,{"inputs":[{"name":"matchonly"}],"output":{"name":"bool"}}],[11,"rejecting","","",110,null],[11,"matching","","",110,null],[11,"use_early_reject","","",111,{"inputs":[{"name":"rejectandmatch"}],"output":{"name":"bool"}}],[11,"rejecting","","",111,null],[11,"matching","","",111,null],[11,"eq","core::str","",112,{"inputs":[{"name":"parseboolerror"},{"name":"parseboolerror"}],"output":{"name":"bool"}}],[11,"ne","","",112,{"inputs":[{"name":"parseboolerror"},{"name":"parseboolerror"}],"output":{"name":"bool"}}],[11,"clone","","",112,{"inputs":[{"name":"parseboolerror"}],"output":{"name":"parseboolerror"}}],[11,"fmt","","",112,{"inputs":[{"name":"parseboolerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",112,{"inputs":[{"name":"parseboolerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",113,{"inputs":[{"name":"utf8error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",113,{"inputs":[{"name":"utf8error"}],"output":{"name":"utf8error"}}],[11,"eq","","",113,{"inputs":[{"name":"utf8error"},{"name":"utf8error"}],"output":{"name":"bool"}}],[11,"ne","","",113,{"inputs":[{"name":"utf8error"},{"name":"utf8error"}],"output":{"name":"bool"}}],[11,"valid_up_to","","Returns the index in the given string up to which valid UTF-8 was\nverified.",113,{"inputs":[{"name":"utf8error"}],"output":{"name":"usize"}}],[11,"fmt","","",113,{"inputs":[{"name":"utf8error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",114,{"inputs":[{"name":"chars"}],"output":{"name":"chars"}}],[11,"next","","",114,{"inputs":[{"name":"chars"}],"output":{"name":"option"}}],[11,"size_hint","","",114,null],[11,"next_back","","",114,{"inputs":[{"name":"chars"}],"output":{"name":"option"}}],[11,"clone","","",115,{"inputs":[{"name":"charindices"}],"output":{"name":"charindices"}}],[11,"next","","",115,{"inputs":[{"name":"charindices"}],"output":{"name":"option"}}],[11,"size_hint","","",115,null],[11,"next_back","","",115,{"inputs":[{"name":"charindices"}],"output":{"name":"option"}}],[11,"clone","","",116,{"inputs":[{"name":"bytes"}],"output":{"name":"bytes"}}],[11,"clone","","",117,{"inputs":[{"name":"bytesderef"}],"output":{"name":"bytesderef"}}],[11,"call","","",117,null],[11,"call_mut","","",117,null],[11,"call_once","","",117,null],[11,"next","","",116,{"inputs":[{"name":"bytes"}],"output":{"name":"option"}}],[11,"size_hint","","",116,null],[11,"next_back","","",116,{"inputs":[{"name":"bytes"}],"output":{"name":"option"}}],[11,"len","","",116,{"inputs":[{"name":"bytes"}],"output":{"name":"usize"}}],[11,"clone","","",118,{"inputs":[{"name":"splitinternal"}],"output":{"name":"splitinternal"}}],[11,"next","","",119,{"inputs":[{"name":"split"}],"output":{"name":"option"}}],[11,"clone","","",119,{"inputs":[{"name":"split"}],"output":{"name":"split"}}],[11,"next","","",120,{"inputs":[{"name":"rsplit"}],"output":{"name":"option"}}],[11,"clone","","",120,{"inputs":[{"name":"rsplit"}],"output":{"name":"rsplit"}}],[11,"next_back","","",119,{"inputs":[{"name":"split"}],"output":{"name":"option"}}],[11,"next_back","","",120,{"inputs":[{"name":"rsplit"}],"output":{"name":"option"}}],[11,"next","","",121,{"inputs":[{"name":"splitterminator"}],"output":{"name":"option"}}],[11,"clone","","",121,{"inputs":[{"name":"splitterminator"}],"output":{"name":"splitterminator"}}],[11,"next","","",122,{"inputs":[{"name":"rsplitterminator"}],"output":{"name":"option"}}],[11,"clone","","",122,{"inputs":[{"name":"rsplitterminator"}],"output":{"name":"rsplitterminator"}}],[11,"next_back","","",121,{"inputs":[{"name":"splitterminator"}],"output":{"name":"option"}}],[11,"next_back","","",122,{"inputs":[{"name":"rsplitterminator"}],"output":{"name":"option"}}],[11,"clone","","",123,{"inputs":[{"name":"splitninternal"}],"output":{"name":"splitninternal"}}],[11,"next","","",124,{"inputs":[{"name":"splitn"}],"output":{"name":"option"}}],[11,"clone","","",124,{"inputs":[{"name":"splitn"}],"output":{"name":"splitn"}}],[11,"next","","",125,{"inputs":[{"name":"rsplitn"}],"output":{"name":"option"}}],[11,"clone","","",125,{"inputs":[{"name":"rsplitn"}],"output":{"name":"rsplitn"}}],[11,"clone","","",126,{"inputs":[{"name":"matchindicesinternal"}],"output":{"name":"matchindicesinternal"}}],[11,"next","","",127,{"inputs":[{"name":"matchindices"}],"output":{"name":"option"}}],[11,"clone","","",127,{"inputs":[{"name":"matchindices"}],"output":{"name":"matchindices"}}],[11,"next","","",128,{"inputs":[{"name":"rmatchindices"}],"output":{"name":"option"}}],[11,"clone","","",128,{"inputs":[{"name":"rmatchindices"}],"output":{"name":"rmatchindices"}}],[11,"next_back","","",127,{"inputs":[{"name":"matchindices"}],"output":{"name":"option"}}],[11,"next_back","","",128,{"inputs":[{"name":"rmatchindices"}],"output":{"name":"option"}}],[11,"clone","","",129,{"inputs":[{"name":"matchesinternal"}],"output":{"name":"matchesinternal"}}],[11,"next","","",130,{"inputs":[{"name":"matches"}],"output":{"name":"option"}}],[11,"clone","","",130,{"inputs":[{"name":"matches"}],"output":{"name":"matches"}}],[11,"next","","",131,{"inputs":[{"name":"rmatches"}],"output":{"name":"option"}}],[11,"clone","","",131,{"inputs":[{"name":"rmatches"}],"output":{"name":"rmatches"}}],[11,"next_back","","",130,{"inputs":[{"name":"matches"}],"output":{"name":"option"}}],[11,"next_back","","",131,{"inputs":[{"name":"rmatches"}],"output":{"name":"option"}}],[11,"clone","","",132,{"inputs":[{"name":"lines"}],"output":{"name":"lines"}}],[11,"next","","",132,{"inputs":[{"name":"lines"}],"output":{"name":"option"}}],[11,"size_hint","","",132,null],[11,"next_back","","",132,{"inputs":[{"name":"lines"}],"output":{"name":"option"}}],[11,"clone","","",133,{"inputs":[{"name":"linesany"}],"output":{"name":"linesany"}}],[11,"clone","","",134,{"inputs":[{"name":"linesanymap"}],"output":{"name":"linesanymap"}}],[11,"call","","",134,null],[11,"call_mut","","",134,null],[11,"call_once","","",134,null],[11,"next","","",133,{"inputs":[{"name":"linesany"}],"output":{"name":"option"}}],[11,"size_hint","","",133,null],[11,"next_back","","",133,{"inputs":[{"name":"linesany"}],"output":{"name":"option"}}],[11,"clone","","",135,{"inputs":[{"name":"charrange"}],"output":{"name":"charrange"}}],[11,"new","core::hash::sip","Creates a new `SipHasher` with the two initial keys set to 0.",136,{"inputs":[{"name":"siphasher"}],"output":{"name":"siphasher"}}],[11,"new_with_keys","","Creates a `SipHasher` that is keyed off the provided keys.",136,{"inputs":[{"name":"siphasher"},{"name":"u64"},{"name":"u64"}],"output":{"name":"siphasher"}}],[11,"write","","",136,null],[11,"finish","","",136,{"inputs":[{"name":"siphasher"}],"output":{"name":"u64"}}],[11,"clone","","",136,{"inputs":[{"name":"siphasher"}],"output":{"name":"siphasher"}}],[11,"default","","",136,{"inputs":[{"name":"siphasher"}],"output":{"name":"siphasher"}}],[11,"eq","core::fmt::num","",137,{"inputs":[{"name":"binary"},{"name":"binary"}],"output":{"name":"bool"}}],[11,"ne","","",137,{"inputs":[{"name":"binary"},{"name":"binary"}],"output":{"name":"bool"}}],[11,"clone","","",137,{"inputs":[{"name":"binary"}],"output":{"name":"binary"}}],[11,"eq","","",138,{"inputs":[{"name":"octal"},{"name":"octal"}],"output":{"name":"bool"}}],[11,"ne","","",138,{"inputs":[{"name":"octal"},{"name":"octal"}],"output":{"name":"bool"}}],[11,"clone","","",138,{"inputs":[{"name":"octal"}],"output":{"name":"octal"}}],[11,"eq","","",139,{"inputs":[{"name":"decimal"},{"name":"decimal"}],"output":{"name":"bool"}}],[11,"ne","","",139,{"inputs":[{"name":"decimal"},{"name":"decimal"}],"output":{"name":"bool"}}],[11,"clone","","",139,{"inputs":[{"name":"decimal"}],"output":{"name":"decimal"}}],[11,"eq","","",140,{"inputs":[{"name":"lowerhex"},{"name":"lowerhex"}],"output":{"name":"bool"}}],[11,"ne","","",140,{"inputs":[{"name":"lowerhex"},{"name":"lowerhex"}],"output":{"name":"bool"}}],[11,"clone","","",140,{"inputs":[{"name":"lowerhex"}],"output":{"name":"lowerhex"}}],[11,"eq","","",141,{"inputs":[{"name":"upperhex"},{"name":"upperhex"}],"output":{"name":"bool"}}],[11,"ne","","",141,{"inputs":[{"name":"upperhex"},{"name":"upperhex"}],"output":{"name":"bool"}}],[11,"clone","","",141,{"inputs":[{"name":"upperhex"}],"output":{"name":"upperhex"}}],[11,"eq","","",142,{"inputs":[{"name":"radix"},{"name":"radix"}],"output":{"name":"bool"}}],[11,"ne","","",142,{"inputs":[{"name":"radix"},{"name":"radix"}],"output":{"name":"bool"}}],[11,"clone","","",142,{"inputs":[{"name":"radix"}],"output":{"name":"radix"}}],[11,"clone","","",143,{"inputs":[{"name":"radixfmt"}],"output":{"name":"radixfmt"}}],[11,"fmt","","",143,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",143,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",143,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",143,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",143,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",143,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",143,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",143,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",143,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",143,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",143,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",143,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",143,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",143,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",143,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",143,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",143,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",143,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",143,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",143,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"write_str","core::fmt::builders","",144,{"inputs":[{"name":"padadapter"},{"name":"str"}],"output":{"name":"result"}}],[11,"field","","Adds a new field to the generated struct output.",145,{"inputs":[{"name":"debugstruct"},{"name":"str"},{"name":"debug"}],"output":{"name":"debugstruct"}}],[11,"finish","","Finishes output and returns any error encountered.",145,{"inputs":[{"name":"debugstruct"}],"output":{"name":"result"}}],[11,"field","","Adds a new field to the generated tuple struct output.",146,{"inputs":[{"name":"debugtuple"},{"name":"debug"}],"output":{"name":"debugtuple"}}],[11,"finish","","Finishes output and returns any error encountered.",146,{"inputs":[{"name":"debugtuple"}],"output":{"name":"result"}}],[11,"formatter","","Returns the wrapped `Formatter`.",146,{"inputs":[{"name":"debugtuple"}],"output":{"name":"formatter"}}],[11,"finish","","",147,null],[11,"entry","","Adds a new entry to the set output.",148,{"inputs":[{"name":"debugset"},{"name":"debug"}],"output":{"name":"debugset"}}],[11,"entries","","Adds the contents of an iterator of entries to the set output.",148,{"inputs":[{"name":"debugset"},{"name":"i"}],"output":{"name":"debugset"}}],[11,"finish","","Finishes output and returns any error encountered.",148,{"inputs":[{"name":"debugset"}],"output":{"name":"result"}}],[11,"entry","","Adds a new entry to the list output.",149,{"inputs":[{"name":"debuglist"},{"name":"debug"}],"output":{"name":"debuglist"}}],[11,"entries","","Adds the contents of an iterator of entries to the list output.",149,{"inputs":[{"name":"debuglist"},{"name":"i"}],"output":{"name":"debuglist"}}],[11,"finish","","Finishes output and returns any error encountered.",149,{"inputs":[{"name":"debuglist"}],"output":{"name":"result"}}],[11,"entry","","Adds a new entry to the map output.",150,{"inputs":[{"name":"debugmap"},{"name":"debug"},{"name":"debug"}],"output":{"name":"debugmap"}}],[11,"entries","","Adds the contents of an iterator of entries to the map output.",150,{"inputs":[{"name":"debugmap"},{"name":"i"}],"output":{"name":"debugmap"}}],[11,"finish","","Finishes output and returns any error encountered.",150,{"inputs":[{"name":"debugmap"}],"output":{"name":"result"}}],[11,"clone","core::fmt::rt::v1","",151,{"inputs":[{"name":"argument"}],"output":{"name":"argument"}}],[11,"clone","","",152,{"inputs":[{"name":"formatspec"}],"output":{"name":"formatspec"}}],[11,"eq","","",153,{"inputs":[{"name":"alignment"},{"name":"alignment"}],"output":{"name":"bool"}}],[11,"ne","","",153,{"inputs":[{"name":"alignment"},{"name":"alignment"}],"output":{"name":"bool"}}],[11,"clone","","",153,{"inputs":[{"name":"alignment"}],"output":{"name":"alignment"}}],[11,"clone","","",154,{"inputs":[{"name":"count"}],"output":{"name":"count"}}],[11,"clone","","",155,{"inputs":[{"name":"position"}],"output":{"name":"position"}}],[11,"fmt","core::fmt","",156,{"inputs":[{"name":"error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",156,{"inputs":[{"name":"error"}],"output":{"name":"error"}}],[11,"clone","","",157,{"inputs":[{"name":"argumentv1"}],"output":{"name":"argumentv1"}}],[11,"clone","","",158,{"inputs":[{"name":"flagv1"}],"output":{"name":"flagv1"}}],[11,"clone","","",159,{"inputs":[{"name":"arguments"}],"output":{"name":"arguments"}}],[11,"fmt","","",159,{"inputs":[{"name":"arguments"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",159,{"inputs":[{"name":"arguments"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"pad_integral","","Performs the correct padding for an integer which has already been\nemitted into a str. The str should *not* contain the sign for the\ninteger, that will be added by this method.",160,{"inputs":[{"name":"formatter"},{"name":"bool"},{"name":"str"},{"name":"str"}],"output":{"name":"result"}}],[11,"pad","","This function takes a string slice and emits it to the internal buffer\nafter applying the relevant formatting flags specified. The flags\nrecognized for generic strings are:",160,{"inputs":[{"name":"formatter"},{"name":"str"}],"output":{"name":"result"}}],[11,"write_str","","Writes some data to the underlying buffer contained within this\nformatter.",160,{"inputs":[{"name":"formatter"},{"name":"str"}],"output":{"name":"result"}}],[11,"write_fmt","","Writes some formatted information into this instance",160,{"inputs":[{"name":"formatter"},{"name":"arguments"}],"output":{"name":"result"}}],[11,"flags","","Flags for formatting (packed version of rt::Flag)",160,{"inputs":[{"name":"formatter"}],"output":{"name":"u32"}}],[11,"fill","","Character used as 'fill' whenever there is alignment",160,{"inputs":[{"name":"formatter"}],"output":{"name":"char"}}],[11,"align","","Flag indicating what form of alignment was requested",160,{"inputs":[{"name":"formatter"}],"output":{"name":"alignment"}}],[11,"width","","Optionally specified integer width that the output should be",160,{"inputs":[{"name":"formatter"}],"output":{"name":"option"}}],[11,"precision","","Optionally specified precision for numeric types",160,{"inputs":[{"name":"formatter"}],"output":{"name":"option"}}],[11,"debug_struct","","Creates a `DebugStruct` builder designed to assist with creation of\n`fmt::Debug` implementations for structs.",160,{"inputs":[{"name":"formatter"},{"name":"str"}],"output":{"name":"debugstruct"}}],[11,"debug_tuple","","Creates a `DebugTuple` builder designed to assist with creation of\n`fmt::Debug` implementations for tuple structs.",160,{"inputs":[{"name":"formatter"},{"name":"str"}],"output":{"name":"debugtuple"}}],[11,"debug_list","","Creates a `DebugList` builder designed to assist with creation of\n`fmt::Debug` implementations for list-like structures.",160,{"inputs":[{"name":"formatter"}],"output":{"name":"debuglist"}}],[11,"debug_set","","Creates a `DebugSet` builder designed to assist with creation of\n`fmt::Debug` implementations for set-like structures.",160,{"inputs":[{"name":"formatter"}],"output":{"name":"debugset"}}],[11,"debug_map","","Creates a `DebugMap` builder designed to assist with creation of\n`fmt::Debug` implementations for map-like structures.",160,{"inputs":[{"name":"formatter"}],"output":{"name":"debugmap"}}],[11,"write_str","","",160,{"inputs":[{"name":"formatter"},{"name":"str"}],"output":{"name":"result"}}],[11,"write_char","","",160,{"inputs":[{"name":"formatter"},{"name":"char"}],"output":{"name":"result"}}],[11,"write_fmt","","",160,{"inputs":[{"name":"formatter"},{"name":"arguments"}],"output":{"name":"result"}}],[11,"fmt","","",156,{"inputs":[{"name":"error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","core::marker","",17,{"inputs":[{"name":"phantomdata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","core::cell","",30,{"inputs":[{"name":"cell"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",32,{"inputs":[{"name":"refcell"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",34,{"inputs":[{"name":"ref"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",35,{"inputs":[{"name":"refmut"},{"name":"formatter"}],"output":{"name":"result"}}],[3,"EscapeUnicode","rustc_unicode::char","An iterator over the characters that represent a `char`, as escaped by\nRust's unicode escaping rules.",null,null],[3,"EscapeDefault","","An iterator over the characters that represent a `char`, escaped\nfor maximum portability.",null,null],[3,"ToLowercase","","An iterator over the lowercase mapping of a given character, returned from\nthe [`to_lowercase` method](../primitive.char.html#method.to_lowercase) on\ncharacters.",null,null],[3,"ToUppercase","","An iterator over the uppercase mapping of a given character, returned from\nthe [`to_uppercase` method](../primitive.char.html#method.to_uppercase) on\ncharacters.",null,null],[5,"decompose_canonical","","Compute canonical Unicode decomposition for character",null,{"inputs":[{"name":"char"},{"name":"f"}],"output":null}],[5,"decompose_compatible","","Compute canonical or compatible Unicode decomposition for character",null,{"inputs":[{"name":"char"},{"name":"f"}],"output":null}],[5,"compose","","",null,{"inputs":[{"name":"char"},{"name":"char"}],"output":{"name":"option"}}],[5,"canonical_combining_class","","",null,{"inputs":[{"name":"char"}],"output":{"name":"u8"}}],[17,"UNICODE_VERSION","","The version of [Unicode](http://www.unicode.org/)\nthat the unicode parts of `CharExt` and `UnicodeStrPrelude` traits are based on.",null,null],[11,"next","","",161,{"inputs":[{"name":"tolowercase"}],"output":{"name":"option"}}],[11,"next","","",162,{"inputs":[{"name":"touppercase"}],"output":{"name":"option"}}],[0,"str","rustc_unicode","",null,null],[3,"SplitWhitespace","rustc_unicode::str","An iterator over the non-whitespace substrings of a string,\nseparated by any amount of whitespace.",null,null],[3,"Graphemes","","External iterator for a string's\n[grapheme clusters](http://www.unicode.org/reports/tr29/#Grapheme_Cluster_Boundaries).",null,null],[3,"GraphemeIndices","","External iterator for grapheme clusters and byte offsets.",null,null],[3,"Utf16Items","","An iterator that decodes UTF-16 encoded codepoints from a vector\nof `u16`s.",null,null],[3,"Utf16Encoder","","Iterator adaptor for encoding `char`s to UTF-16.",null,null],[4,"Utf16Item","","The possibilities for values decoded from a `u16` stream.",null,null],[13,"ScalarValue","","A valid codepoint.",163,null],[13,"LoneSurrogate","","An invalid surrogate without its pair.",163,null],[5,"utf8_char_width","","Given a first byte, determine how many bytes are in this UTF-8 character",null,{"inputs":[{"name":"u8"}],"output":{"name":"usize"}}],[5,"is_utf16","","Determines if a vector of `u16` contains valid UTF-16",null,null],[5,"utf16_items","","Create an iterator over the UTF-16 encoded codepoints in `v`,\nreturning invalid surrogates as `LoneSurrogate`s.",null,null],[6,"Words","","",null,null],[8,"UnicodeStr","","Methods for Unicode string slices",null,null],[10,"graphemes","","",164,{"inputs":[{"name":"unicodestr"},{"name":"bool"}],"output":{"name":"graphemes"}}],[10,"grapheme_indices","","",164,{"inputs":[{"name":"unicodestr"},{"name":"bool"}],"output":{"name":"graphemeindices"}}],[10,"words","","",164,{"inputs":[{"name":"unicodestr"}],"output":{"name":"words"}}],[10,"split_whitespace","","",164,{"inputs":[{"name":"unicodestr"}],"output":{"name":"splitwhitespace"}}],[10,"is_whitespace","","",164,{"inputs":[{"name":"unicodestr"}],"output":{"name":"bool"}}],[10,"is_alphanumeric","","",164,{"inputs":[{"name":"unicodestr"}],"output":{"name":"bool"}}],[10,"width","","",164,{"inputs":[{"name":"unicodestr"},{"name":"bool"}],"output":{"name":"usize"}}],[10,"trim","","",164,{"inputs":[{"name":"unicodestr"}],"output":{"name":"str"}}],[10,"trim_left","","",164,{"inputs":[{"name":"unicodestr"}],"output":{"name":"str"}}],[10,"trim_right","","",164,{"inputs":[{"name":"unicodestr"}],"output":{"name":"str"}}],[0,"derived_property","rustc_unicode","",null,null],[5,"Cased","rustc_unicode::derived_property","",null,{"inputs":[{"name":"char"}],"output":{"name":"bool"}}],[5,"Case_Ignorable","","",null,{"inputs":[{"name":"char"}],"output":{"name":"bool"}}],[11,"clone","rustc_unicode::str","",165,{"inputs":[{"name":"graphemeindices"}],"output":{"name":"graphemeindices"}}],[11,"next","","",165,{"inputs":[{"name":"graphemeindices"}],"output":{"name":"option"}}],[11,"size_hint","","",165,null],[11,"next_back","","",165,{"inputs":[{"name":"graphemeindices"}],"output":{"name":"option"}}],[11,"clone","","",166,{"inputs":[{"name":"graphemes"}],"output":{"name":"graphemes"}}],[11,"size_hint","","",166,null],[11,"next","","",166,{"inputs":[{"name":"graphemes"}],"output":{"name":"option"}}],[11,"next_back","","",166,{"inputs":[{"name":"graphemes"}],"output":{"name":"option"}}],[11,"clone","","",167,{"inputs":[{"name":"utf16items"}],"output":{"name":"utf16items"}}],[11,"fmt","","",163,{"inputs":[{"name":"utf16item"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",163,{"inputs":[{"name":"utf16item"}],"output":{"name":"utf16item"}}],[11,"eq","","",163,{"inputs":[{"name":"utf16item"},{"name":"utf16item"}],"output":{"name":"bool"}}],[11,"ne","","",163,{"inputs":[{"name":"utf16item"},{"name":"utf16item"}],"output":{"name":"bool"}}],[11,"to_char_lossy","","Convert `self` to a `char`, taking `LoneSurrogate`s to the\nreplacement character (U+FFFD).",163,{"inputs":[{"name":"utf16item"}],"output":{"name":"char"}}],[11,"next","","",167,{"inputs":[{"name":"utf16items"}],"output":{"name":"option"}}],[11,"size_hint","","",167,null],[11,"clone","","",168,{"inputs":[{"name":"utf16encoder"}],"output":{"name":"utf16encoder"}}],[11,"new","","Create a UTF-16 encoder from any `char` iterator.",168,{"inputs":[{"name":"utf16encoder"},{"name":"i"}],"output":{"name":"utf16encoder"}}],[11,"next","","",168,{"inputs":[{"name":"utf16encoder"}],"output":{"name":"option"}}],[11,"size_hint","","",168,null],[11,"next","","",169,{"inputs":[{"name":"splitwhitespace"}],"output":{"name":"option"}}],[11,"next_back","","",169,{"inputs":[{"name":"splitwhitespace"}],"output":{"name":"option"}}]],"paths":[[3,"Wrapping"],[3,"Big32x36"],[3,"Big8x3"],[3,"Decoded"],[4,"FullDecoded"],[3,"Fp"],[4,"Part"],[3,"Formatted"],[4,"Sign"],[4,"FpCategory"],[3,"ParseIntError"],[4,"IntErrorKind"],[3,"ParseFloatError"],[4,"FloatErrorKind"],[3,"NonZero"],[3,"Unique"],[3,"NoCopy"],[3,"PhantomData"],[3,"RangeFull"],[3,"Range"],[3,"RangeFrom"],[3,"RangeTo"],[4,"Ordering"],[8,"Any"],[3,"TypeId"],[3,"AtomicBool"],[3,"AtomicIsize"],[3,"AtomicUsize"],[3,"AtomicPtr"],[4,"Ordering"],[3,"Cell"],[4,"BorrowState"],[3,"RefCell"],[3,"BorrowRef"],[3,"Ref"],[3,"RefMut"],[3,"BorrowRefMut"],[3,"UnsafeCell"],[3,"EscapeUnicode"],[4,"EscapeUnicodeState"],[3,"EscapeDefault"],[4,"EscapeDefaultState"],[3,"Rev"],[4,"MinMaxResult"],[3,"Cloned"],[3,"Cycle"],[3,"Chain"],[3,"Zip"],[3,"Map"],[3,"Filter"],[3,"FilterMap"],[3,"Enumerate"],[3,"Peekable"],[3,"SkipWhile"],[3,"TakeWhile"],[3,"Skip"],[3,"Take"],[3,"Scan"],[3,"FlatMap"],[3,"Fuse"],[3,"Inspect"],[3,"Unfold"],[3,"StepBy"],[3,"RangeInclusive"],[3,"Repeat"],[3,"Empty"],[3,"Once"],[4,"Option"],[3,"Item"],[3,"Iter"],[3,"IterMut"],[3,"IntoIter"],[3,"Slice"],[3,"TraitObject"],[4,"Result"],[3,"Iter"],[3,"IterMut"],[3,"IntoIter"],[3,"i8x16"],[3,"i16x8"],[3,"i32x4"],[3,"i64x2"],[3,"u8x16"],[3,"u16x8"],[3,"u32x4"],[3,"u64x2"],[3,"f32x4"],[3,"f64x2"],[3,"Iter"],[3,"IterMut"],[3,"Split"],[3,"SplitMut"],[3,"GenericSplitN"],[3,"SplitN"],[3,"RSplitN"],[3,"SplitNMut"],[3,"RSplitNMut"],[3,"Windows"],[3,"Chunks"],[3,"ChunksMut"],[4,"SearchStep"],[3,"CharEqSearcher"],[3,"CharEqPattern"],[3,"CharSearcher"],[3,"CharSliceSearcher"],[3,"CharPredicateSearcher"],[3,"StrSearcher"],[4,"StrSearcherImpl"],[3,"EmptyNeedle"],[3,"TwoWaySearcher"],[4,"MatchOnly"],[4,"RejectAndMatch"],[3,"ParseBoolError"],[3,"Utf8Error"],[3,"Chars"],[3,"CharIndices"],[3,"Bytes"],[3,"BytesDeref"],[3,"SplitInternal"],[3,"Split"],[3,"RSplit"],[3,"SplitTerminator"],[3,"RSplitTerminator"],[3,"SplitNInternal"],[3,"SplitN"],[3,"RSplitN"],[3,"MatchIndicesInternal"],[3,"MatchIndices"],[3,"RMatchIndices"],[3,"MatchesInternal"],[3,"Matches"],[3,"RMatches"],[3,"Lines"],[3,"LinesAny"],[3,"LinesAnyMap"],[3,"CharRange"],[3,"SipHasher"],[3,"Binary"],[3,"Octal"],[3,"Decimal"],[3,"LowerHex"],[3,"UpperHex"],[3,"Radix"],[3,"RadixFmt"],[3,"PadAdapter"],[3,"DebugStruct"],[3,"DebugTuple"],[3,"DebugInner"],[3,"DebugSet"],[3,"DebugList"],[3,"DebugMap"],[3,"Argument"],[3,"FormatSpec"],[4,"Alignment"],[4,"Count"],[4,"Position"],[3,"Error"],[3,"ArgumentV1"],[4,"FlagV1"],[3,"Arguments"],[3,"Formatter"],[3,"ToLowercase"],[3,"ToUppercase"],[4,"Utf16Item"],[8,"UnicodeStr"],[3,"GraphemeIndices"],[3,"Graphemes"],[3,"Utf16Items"],[3,"Utf16Encoder"],[3,"SplitWhitespace"]]};
searchIndex['libc'] = {"items":[[0,"","libc","Bindings for the C standard library and other platform libraries",null,null],[0,"types","","",null,null],[0,"common","libc::types","",null,null],[0,"c95","libc::types::common","",null,null],[4,"c_void","libc::types::common::c95","Type used to construct void pointers for use with C.",null,null],[13,"__variant1","","",0,null],[13,"__variant2","","",0,null],[4,"FILE","","",null,null],[4,"fpos_t","","",null,null],[0,"c99","libc::types::common","",null,null],[6,"int8_t","libc::types::common::c99","",null,null],[6,"int16_t","","",null,null],[6,"int32_t","","",null,null],[6,"int64_t","","",null,null],[6,"uint8_t","","",null,null],[6,"uint16_t","","",null,null],[6,"uint32_t","","",null,null],[6,"uint64_t","","",null,null],[0,"posix88","libc::types::common","",null,null],[4,"DIR","libc::types::common::posix88","",null,null],[4,"dirent_t","","",null,null],[0,"os","libc::types","",null,null],[0,"common","libc::types::os","",null,null],[0,"posix01","libc::types::os::common","",null,null],[3,"glob_t","libc::types::os::common::posix01","",null,null],[12,"gl_pathc","","",1,null],[12,"gl_pathv","","",1,null],[12,"gl_offs","","",1,null],[12,"__unused1","","",1,null],[12,"__unused2","","",1,null],[12,"__unused3","","",1,null],[12,"__unused4","","",1,null],[12,"__unused5","","",1,null],[3,"timeval","","",null,null],[12,"tv_sec","","",2,null],[12,"tv_usec","","",2,null],[3,"timespec","","",null,null],[12,"tv_sec","","",3,null],[12,"tv_nsec","","",3,null],[3,"rlimit","","",null,null],[12,"rlim_cur","","",4,null],[12,"rlim_max","","",4,null],[4,"timezone","","",null,null],[6,"pthread_t","","",null,null],[6,"rlim_t","","",null,null],[6,"sighandler_t","","",null,null],[11,"clone","","",1,{"inputs":[{"name":"glob_t"}],"output":{"name":"glob_t"}}],[11,"clone","","",2,{"inputs":[{"name":"timeval"}],"output":{"name":"timeval"}}],[11,"clone","","",3,{"inputs":[{"name":"timespec"}],"output":{"name":"timespec"}}],[11,"clone","","",4,{"inputs":[{"name":"rlimit"}],"output":{"name":"rlimit"}}],[0,"bsd43","libc::types::os::common","",null,null],[3,"rusage","libc::types::os::common::bsd43","",null,null],[12,"ru_utime","","",5,null],[12,"ru_stime","","",5,null],[12,"ru_maxrss","","",5,null],[12,"ru_ixrss","","",5,null],[12,"ru_idrss","","",5,null],[12,"ru_isrss","","",5,null],[12,"ru_minflt","","",5,null],[12,"ru_majflt","","",5,null],[12,"ru_nswap","","",5,null],[12,"ru_inblock","","",5,null],[12,"ru_oublock","","",5,null],[12,"ru_msgsnd","","",5,null],[12,"ru_msgrcv","","",5,null],[12,"ru_nsignals","","",5,null],[12,"ru_nvcsw","","",5,null],[12,"ru_nivcsw","","",5,null],[11,"clone","","",5,{"inputs":[{"name":"rusage"}],"output":{"name":"rusage"}}],[0,"bsd44","libc::types::os::common","",null,null],[3,"sockaddr","libc::types::os::common::bsd44","",null,null],[12,"sa_family","","",6,null],[12,"sa_data","","",6,null],[3,"sockaddr_storage","","",null,null],[12,"ss_family","","",7,null],[12,"__ss_align","","",7,null],[12,"__ss_pad2","","",7,null],[3,"sockaddr_in","","",null,null],[12,"sin_family","","",8,null],[12,"sin_port","","",8,null],[12,"sin_addr","","",8,null],[12,"sin_zero","","",8,null],[3,"in_addr","","",null,null],[12,"s_addr","","",9,null],[3,"sockaddr_in6","","",null,null],[12,"sin6_family","","",10,null],[12,"sin6_port","","",10,null],[12,"sin6_flowinfo","","",10,null],[12,"sin6_addr","","",10,null],[12,"sin6_scope_id","","",10,null],[3,"in6_addr","","",null,null],[12,"s6_addr","","",11,null],[3,"ip_mreq","","",null,null],[12,"imr_multiaddr","","",12,null],[12,"imr_interface","","",12,null],[3,"ip6_mreq","","",null,null],[12,"ipv6mr_multiaddr","","",13,null],[12,"ipv6mr_interface","","",13,null],[3,"addrinfo","","",null,null],[12,"ai_flags","","",14,null],[12,"ai_family","","",14,null],[12,"ai_socktype","","",14,null],[12,"ai_protocol","","",14,null],[12,"ai_addrlen","","",14,null],[12,"ai_addr","","",14,null],[12,"ai_canonname","","",14,null],[12,"ai_next","","",14,null],[3,"sockaddr_un","","",null,null],[12,"sun_family","","",15,null],[12,"sun_path","","",15,null],[3,"ifaddrs","","",null,null],[12,"ifa_next","","",16,null],[12,"ifa_name","","",16,null],[12,"ifa_flags","","",16,null],[12,"ifa_addr","","",16,null],[12,"ifa_netmask","","",16,null],[12,"ifa_ifu","","",16,null],[12,"ifa_data","","",16,null],[6,"socklen_t","","",null,null],[6,"sa_family_t","","",null,null],[6,"in_port_t","","",null,null],[6,"in_addr_t","","",null,null],[11,"clone","","",6,{"inputs":[{"name":"sockaddr"}],"output":{"name":"sockaddr"}}],[11,"clone","","",7,{"inputs":[{"name":"sockaddr_storage"}],"output":{"name":"sockaddr_storage"}}],[11,"clone","","",8,{"inputs":[{"name":"sockaddr_in"}],"output":{"name":"sockaddr_in"}}],[11,"clone","","",9,{"inputs":[{"name":"in_addr"}],"output":{"name":"in_addr"}}],[11,"clone","","",10,{"inputs":[{"name":"sockaddr_in6"}],"output":{"name":"sockaddr_in6"}}],[11,"clone","","",11,{"inputs":[{"name":"in6_addr"}],"output":{"name":"in6_addr"}}],[11,"clone","","",12,{"inputs":[{"name":"ip_mreq"}],"output":{"name":"ip_mreq"}}],[11,"clone","","",13,{"inputs":[{"name":"ip6_mreq"}],"output":{"name":"ip6_mreq"}}],[11,"clone","","",14,{"inputs":[{"name":"addrinfo"}],"output":{"name":"addrinfo"}}],[11,"clone","","",15,{"inputs":[{"name":"sockaddr_un"}],"output":{"name":"sockaddr_un"}}],[11,"clone","","",16,{"inputs":[{"name":"ifaddrs"}],"output":{"name":"ifaddrs"}}],[0,"arch","libc::types::os","",null,null],[0,"c95","libc::types::os::arch","",null,null],[6,"c_char","libc::types::os::arch::c95","",null,null],[6,"c_schar","","",null,null],[6,"c_uchar","","",null,null],[6,"c_short","","",null,null],[6,"c_ushort","","",null,null],[6,"c_int","","",null,null],[6,"c_uint","","",null,null],[6,"c_long","","",null,null],[6,"c_ulong","","",null,null],[6,"c_float","","",null,null],[6,"c_double","","",null,null],[6,"size_t","","",null,null],[6,"ptrdiff_t","","",null,null],[6,"clock_t","","",null,null],[6,"time_t","","",null,null],[6,"suseconds_t","","",null,null],[6,"wchar_t","","",null,null],[0,"c99","libc::types::os::arch","",null,null],[6,"c_longlong","libc::types::os::arch::c99","",null,null],[6,"c_ulonglong","","",null,null],[6,"intptr_t","","",null,null],[6,"uintptr_t","","",null,null],[6,"intmax_t","","",null,null],[6,"uintmax_t","","",null,null],[0,"posix88","libc::types::os::arch","",null,null],[6,"off_t","libc::types::os::arch::posix88","",null,null],[6,"dev_t","","",null,null],[6,"ino_t","","",null,null],[6,"pid_t","","",null,null],[6,"uid_t","","",null,null],[6,"gid_t","","",null,null],[6,"useconds_t","","",null,null],[6,"mode_t","","",null,null],[6,"ssize_t","","",null,null],[0,"posix01","libc::types::os::arch","",null,null],[3,"stat","libc::types::os::arch::posix01","",null,null],[12,"st_dev","","",17,null],[12,"st_ino","","",17,null],[12,"st_nlink","","",17,null],[12,"st_mode","","",17,null],[12,"st_uid","","",17,null],[12,"st_gid","","",17,null],[12,"__pad0","","",17,null],[12,"st_rdev","","",17,null],[12,"st_size","","",17,null],[12,"st_blksize","","",17,null],[12,"st_blocks","","",17,null],[12,"st_atime","","",17,null],[12,"st_atime_nsec","","",17,null],[12,"st_mtime","","",17,null],[12,"st_mtime_nsec","","",17,null],[12,"st_ctime","","",17,null],[12,"st_ctime_nsec","","",17,null],[12,"__unused","","",17,null],[3,"utimbuf","","",null,null],[12,"actime","","",18,null],[12,"modtime","","",18,null],[3,"pthread_attr_t","","",null,null],[12,"__size","","",19,null],[6,"nlink_t","","",null,null],[6,"blksize_t","","",null,null],[6,"blkcnt_t","","",null,null],[11,"clone","","",17,{"inputs":[{"name":"stat"}],"output":{"name":"stat"}}],[11,"clone","","",18,{"inputs":[{"name":"utimbuf"}],"output":{"name":"utimbuf"}}],[11,"clone","","",19,{"inputs":[{"name":"pthread_attr_t"}],"output":{"name":"pthread_attr_t"}}],[0,"extra","libc::types::os::arch","",null,null],[3,"sockaddr_ll","libc::types::os::arch::extra","",null,null],[12,"sll_family","","",20,null],[12,"sll_protocol","","",20,null],[12,"sll_ifindex","","",20,null],[12,"sll_hatype","","",20,null],[12,"sll_pkttype","","",20,null],[12,"sll_halen","","",20,null],[12,"sll_addr","","",20,null],[11,"clone","","",20,{"inputs":[{"name":"sockaddr_ll"}],"output":{"name":"sockaddr_ll"}}],[0,"consts","libc","",null,null],[0,"os","libc::consts","",null,null],[0,"c95","libc::consts::os","",null,null],[17,"EXIT_FAILURE","libc::consts::os::c95","",null,null],[17,"EXIT_SUCCESS","","",null,null],[17,"RAND_MAX","","",null,null],[17,"EOF","","",null,null],[17,"SEEK_SET","","",null,null],[17,"SEEK_CUR","","",null,null],[17,"SEEK_END","","",null,null],[17,"_IOFBF","","",null,null],[17,"_IONBF","","",null,null],[17,"_IOLBF","","",null,null],[17,"BUFSIZ","","",null,null],[17,"FOPEN_MAX","","",null,null],[17,"FILENAME_MAX","","",null,null],[17,"L_tmpnam","","",null,null],[17,"TMP_MAX","","",null,null],[0,"posix88","libc::consts::os","",null,null],[17,"O_RDONLY","libc::consts::os::posix88","",null,null],[17,"O_WRONLY","","",null,null],[17,"O_RDWR","","",null,null],[17,"O_APPEND","","",null,null],[17,"O_CREAT","","",null,null],[17,"O_EXCL","","",null,null],[17,"O_NOCTTY","","",null,null],[17,"O_TRUNC","","",null,null],[17,"S_IFIFO","","",null,null],[17,"S_IFCHR","","",null,null],[17,"S_IFBLK","","",null,null],[17,"S_IFDIR","","",null,null],[17,"S_IFREG","","",null,null],[17,"S_IFLNK","","",null,null],[17,"S_IFSOCK","","",null,null],[17,"S_IFMT","","",null,null],[17,"S_IEXEC","","",null,null],[17,"S_IWRITE","","",null,null],[17,"S_IREAD","","",null,null],[17,"S_IRWXU","","",null,null],[17,"S_IXUSR","","",null,null],[17,"S_IWUSR","","",null,null],[17,"S_IRUSR","","",null,null],[17,"S_IRWXG","","",null,null],[17,"S_IXGRP","","",null,null],[17,"S_IWGRP","","",null,null],[17,"S_IRGRP","","",null,null],[17,"S_IRWXO","","",null,null],[17,"S_IXOTH","","",null,null],[17,"S_IWOTH","","",null,null],[17,"S_IROTH","","",null,null],[17,"F_OK","","",null,null],[17,"R_OK","","",null,null],[17,"W_OK","","",null,null],[17,"X_OK","","",null,null],[17,"STDIN_FILENO","","",null,null],[17,"STDOUT_FILENO","","",null,null],[17,"STDERR_FILENO","","",null,null],[17,"F_LOCK","","",null,null],[17,"F_TEST","","",null,null],[17,"F_TLOCK","","",null,null],[17,"F_ULOCK","","",null,null],[17,"SIGHUP","","",null,null],[17,"SIGINT","","",null,null],[17,"SIGQUIT","","",null,null],[17,"SIGILL","","",null,null],[17,"SIGABRT","","",null,null],[17,"SIGFPE","","",null,null],[17,"SIGKILL","","",null,null],[17,"SIGSEGV","","",null,null],[17,"SIGPIPE","","",null,null],[17,"SIGALRM","","",null,null],[17,"SIGTERM","","",null,null],[17,"PROT_NONE","","",null,null],[17,"PROT_READ","","",null,null],[17,"PROT_WRITE","","",null,null],[17,"PROT_EXEC","","",null,null],[17,"MAP_FILE","","",null,null],[17,"MAP_SHARED","","",null,null],[17,"MAP_PRIVATE","","",null,null],[17,"MAP_FIXED","","",null,null],[17,"MAP_ANON","","",null,null],[17,"MAP_FAILED","","",null,null],[17,"MCL_CURRENT","","",null,null],[17,"MCL_FUTURE","","",null,null],[17,"MS_ASYNC","","",null,null],[17,"MS_INVALIDATE","","",null,null],[17,"MS_SYNC","","",null,null],[17,"EPERM","","",null,null],[17,"ENOENT","","",null,null],[17,"ESRCH","","",null,null],[17,"EINTR","","",null,null],[17,"EIO","","",null,null],[17,"ENXIO","","",null,null],[17,"E2BIG","","",null,null],[17,"ENOEXEC","","",null,null],[17,"EBADF","","",null,null],[17,"ECHILD","","",null,null],[17,"EAGAIN","","",null,null],[17,"ENOMEM","","",null,null],[17,"EACCES","","",null,null],[17,"EFAULT","","",null,null],[17,"ENOTBLK","","",null,null],[17,"EBUSY","","",null,null],[17,"EEXIST","","",null,null],[17,"EXDEV","","",null,null],[17,"ENODEV","","",null,null],[17,"ENOTDIR","","",null,null],[17,"EISDIR","","",null,null],[17,"EINVAL","","",null,null],[17,"ENFILE","","",null,null],[17,"EMFILE","","",null,null],[17,"ENOTTY","","",null,null],[17,"ETXTBSY","","",null,null],[17,"EFBIG","","",null,null],[17,"ENOSPC","","",null,null],[17,"ESPIPE","","",null,null],[17,"EROFS","","",null,null],[17,"EMLINK","","",null,null],[17,"EPIPE","","",null,null],[17,"EDOM","","",null,null],[17,"ERANGE","","",null,null],[17,"EDEADLK","","",null,null],[17,"ENAMETOOLONG","","",null,null],[17,"ENOLCK","","",null,null],[17,"ENOSYS","","",null,null],[17,"ENOTEMPTY","","",null,null],[17,"ELOOP","","",null,null],[17,"EWOULDBLOCK","","",null,null],[17,"ENOMSG","","",null,null],[17,"EIDRM","","",null,null],[17,"ECHRNG","","",null,null],[17,"EL2NSYNC","","",null,null],[17,"EL3HLT","","",null,null],[17,"EL3RST","","",null,null],[17,"ELNRNG","","",null,null],[17,"EUNATCH","","",null,null],[17,"ENOCSI","","",null,null],[17,"EL2HLT","","",null,null],[17,"EBADE","","",null,null],[17,"EBADR","","",null,null],[17,"EXFULL","","",null,null],[17,"ENOANO","","",null,null],[17,"EBADRQC","","",null,null],[17,"EBADSLT","","",null,null],[17,"EDEADLOCK","","",null,null],[17,"EBFONT","","",null,null],[17,"ENOSTR","","",null,null],[17,"ENODATA","","",null,null],[17,"ETIME","","",null,null],[17,"ENOSR","","",null,null],[17,"ENONET","","",null,null],[17,"ENOPKG","","",null,null],[17,"EREMOTE","","",null,null],[17,"ENOLINK","","",null,null],[17,"EADV","","",null,null],[17,"ESRMNT","","",null,null],[17,"ECOMM","","",null,null],[17,"EPROTO","","",null,null],[17,"EMULTIHOP","","",null,null],[17,"EDOTDOT","","",null,null],[17,"EBADMSG","","",null,null],[17,"EOVERFLOW","","",null,null],[17,"ENOTUNIQ","","",null,null],[17,"EBADFD","","",null,null],[17,"EREMCHG","","",null,null],[17,"ELIBACC","","",null,null],[17,"ELIBBAD","","",null,null],[17,"ELIBSCN","","",null,null],[17,"ELIBMAX","","",null,null],[17,"ELIBEXEC","","",null,null],[17,"EILSEQ","","",null,null],[17,"ERESTART","","",null,null],[17,"ESTRPIPE","","",null,null],[17,"EUSERS","","",null,null],[17,"ENOTSOCK","","",null,null],[17,"EDESTADDRREQ","","",null,null],[17,"EMSGSIZE","","",null,null],[17,"EPROTOTYPE","","",null,null],[17,"ENOPROTOOPT","","",null,null],[17,"EPROTONOSUPPORT","","",null,null],[17,"ESOCKTNOSUPPORT","","",null,null],[17,"EOPNOTSUPP","","",null,null],[17,"EPFNOSUPPORT","","",null,null],[17,"EAFNOSUPPORT","","",null,null],[17,"EADDRINUSE","","",null,null],[17,"EADDRNOTAVAIL","","",null,null],[17,"ENETDOWN","","",null,null],[17,"ENETUNREACH","","",null,null],[17,"ENETRESET","","",null,null],[17,"ECONNABORTED","","",null,null],[17,"ECONNRESET","","",null,null],[17,"ENOBUFS","","",null,null],[17,"EISCONN","","",null,null],[17,"ENOTCONN","","",null,null],[17,"ESHUTDOWN","","",null,null],[17,"ETOOMANYREFS","","",null,null],[17,"ETIMEDOUT","","",null,null],[17,"ECONNREFUSED","","",null,null],[17,"EHOSTDOWN","","",null,null],[17,"EHOSTUNREACH","","",null,null],[17,"EALREADY","","",null,null],[17,"EINPROGRESS","","",null,null],[17,"ESTALE","","",null,null],[17,"EUCLEAN","","",null,null],[17,"ENOTNAM","","",null,null],[17,"ENAVAIL","","",null,null],[17,"EISNAM","","",null,null],[17,"EREMOTEIO","","",null,null],[17,"EDQUOT","","",null,null],[17,"ENOMEDIUM","","",null,null],[17,"EMEDIUMTYPE","","",null,null],[17,"ECANCELED","","",null,null],[17,"ENOKEY","","",null,null],[17,"EKEYEXPIRED","","",null,null],[17,"EKEYREVOKED","","",null,null],[17,"EKEYREJECTED","","",null,null],[17,"EOWNERDEAD","","",null,null],[17,"ENOTRECOVERABLE","","",null,null],[17,"ERFKILL","","",null,null],[17,"EHWPOISON","","",null,null],[0,"posix01","libc::consts::os","",null,null],[17,"F_DUPFD","libc::consts::os::posix01","",null,null],[17,"F_GETFD","","",null,null],[17,"F_SETFD","","",null,null],[17,"F_GETFL","","",null,null],[17,"F_SETFL","","",null,null],[17,"O_ACCMODE","","",null,null],[17,"SIGTRAP","","",null,null],[17,"SIG_IGN","","",null,null],[17,"GLOB_ERR","","",null,null],[17,"GLOB_MARK","","",null,null],[17,"GLOB_NOSORT","","",null,null],[17,"GLOB_DOOFFS","","",null,null],[17,"GLOB_NOCHECK","","",null,null],[17,"GLOB_APPEND","","",null,null],[17,"GLOB_NOESCAPE","","",null,null],[17,"GLOB_NOSPACE","","",null,null],[17,"GLOB_ABORTED","","",null,null],[17,"GLOB_NOMATCH","","",null,null],[17,"POSIX_MADV_NORMAL","","",null,null],[17,"POSIX_MADV_RANDOM","","",null,null],[17,"POSIX_MADV_SEQUENTIAL","","",null,null],[17,"POSIX_MADV_WILLNEED","","",null,null],[17,"POSIX_MADV_DONTNEED","","",null,null],[17,"_SC_MQ_PRIO_MAX","","",null,null],[17,"_SC_IOV_MAX","","",null,null],[17,"_SC_GETGR_R_SIZE_MAX","","",null,null],[17,"_SC_GETPW_R_SIZE_MAX","","",null,null],[17,"_SC_LOGIN_NAME_MAX","","",null,null],[17,"_SC_TTY_NAME_MAX","","",null,null],[17,"_SC_THREADS","","",null,null],[17,"_SC_THREAD_SAFE_FUNCTIONS","","",null,null],[17,"_SC_THREAD_DESTRUCTOR_ITERATIONS","","",null,null],[17,"_SC_THREAD_KEYS_MAX","","",null,null],[17,"_SC_THREAD_STACK_MIN","","",null,null],[17,"_SC_THREAD_THREADS_MAX","","",null,null],[17,"_SC_THREAD_ATTR_STACKADDR","","",null,null],[17,"_SC_THREAD_ATTR_STACKSIZE","","",null,null],[17,"_SC_THREAD_PRIORITY_SCHEDULING","","",null,null],[17,"_SC_THREAD_PRIO_INHERIT","","",null,null],[17,"_SC_THREAD_PRIO_PROTECT","","",null,null],[17,"_SC_THREAD_PROCESS_SHARED","","",null,null],[17,"_SC_ATEXIT_MAX","","",null,null],[17,"_SC_XOPEN_VERSION","","",null,null],[17,"_SC_XOPEN_XCU_VERSION","","",null,null],[17,"_SC_XOPEN_UNIX","","",null,null],[17,"_SC_XOPEN_CRYPT","","",null,null],[17,"_SC_XOPEN_ENH_I18N","","",null,null],[17,"_SC_XOPEN_SHM","","",null,null],[17,"_SC_XOPEN_LEGACY","","",null,null],[17,"_SC_XOPEN_REALTIME","","",null,null],[17,"_SC_XOPEN_REALTIME_THREADS","","",null,null],[17,"PTHREAD_CREATE_JOINABLE","","",null,null],[17,"PTHREAD_CREATE_DETACHED","","",null,null],[17,"PTHREAD_STACK_MIN","","",null,null],[17,"CLOCK_REALTIME","","",null,null],[17,"CLOCK_MONOTONIC","","",null,null],[17,"RLIMIT_CPU","","",null,null],[17,"RLIMIT_FSIZE","","",null,null],[17,"RLIMIT_DATA","","",null,null],[17,"RLIMIT_STACK","","",null,null],[17,"RLIMIT_CORE","","",null,null],[17,"RLIMIT_RSS","","",null,null],[17,"RLIMIT_NOFILE","","",null,null],[17,"RLIMIT_AS","","",null,null],[17,"RLIMIT_NPROC","","",null,null],[17,"RLIMIT_MEMLOCK","","",null,null],[17,"RLIMIT_LOCKS","","",null,null],[17,"RLIMIT_SIGPENDING","","",null,null],[17,"RLIMIT_MSGQUEUE","","",null,null],[17,"RLIMIT_NICE","","",null,null],[17,"RLIMIT_RTPRIO","","",null,null],[17,"RLIMIT_RTTIME","","",null,null],[17,"RLIMIT_NLIMITS","","",null,null],[17,"RLIM_INFINITY","","",null,null],[17,"RLIM_SAVED_MAX","","",null,null],[17,"RLIM_SAVED_CUR","","",null,null],[17,"RUSAGE_SELF","","",null,null],[17,"RUSAGE_CHILDREN","","",null,null],[17,"RUSAGE_THREAD","","",null,null],[0,"bsd44","libc::consts::os","",null,null],[17,"MADV_NORMAL","libc::consts::os::bsd44","",null,null],[17,"MADV_RANDOM","","",null,null],[17,"MADV_SEQUENTIAL","","",null,null],[17,"MADV_WILLNEED","","",null,null],[17,"MADV_DONTNEED","","",null,null],[17,"MADV_REMOVE","","",null,null],[17,"MADV_DONTFORK","","",null,null],[17,"MADV_DOFORK","","",null,null],[17,"MADV_MERGEABLE","","",null,null],[17,"MADV_UNMERGEABLE","","",null,null],[17,"MADV_HWPOISON","","",null,null],[17,"IFF_LOOPBACK","","",null,null],[17,"AF_UNIX","","",null,null],[17,"AF_INET","","",null,null],[17,"AF_INET6","","",null,null],[17,"SOCK_STREAM","","",null,null],[17,"SOCK_DGRAM","","",null,null],[17,"SOCK_RAW","","",null,null],[17,"IPPROTO_TCP","","",null,null],[17,"IPPROTO_IP","","",null,null],[17,"IPPROTO_IPV6","","",null,null],[17,"IP_MULTICAST_TTL","","",null,null],[17,"IP_MULTICAST_LOOP","","",null,null],[17,"IP_TTL","","",null,null],[17,"IP_HDRINCL","","",null,null],[17,"IP_ADD_MEMBERSHIP","","",null,null],[17,"IP_DROP_MEMBERSHIP","","",null,null],[17,"IPV6_ADD_MEMBERSHIP","","",null,null],[17,"IPV6_DROP_MEMBERSHIP","","",null,null],[17,"TCP_NODELAY","","",null,null],[17,"TCP_MAXSEG","","",null,null],[17,"TCP_CORK","","",null,null],[17,"TCP_KEEPIDLE","","",null,null],[17,"TCP_KEEPINTVL","","",null,null],[17,"TCP_KEEPCNT","","",null,null],[17,"TCP_SYNCNT","","",null,null],[17,"TCP_LINGER2","","",null,null],[17,"TCP_DEFER_ACCEPT","","",null,null],[17,"TCP_WINDOW_CLAMP","","",null,null],[17,"TCP_INFO","","",null,null],[17,"TCP_QUICKACK","","",null,null],[17,"TCP_CONGESTION","","",null,null],[17,"TCP_MD5SIG","","",null,null],[17,"TCP_COOKIE_TRANSACTIONS","","",null,null],[17,"TCP_THIN_LINEAR_TIMEOUTS","","",null,null],[17,"TCP_THIN_DUPACK","","",null,null],[17,"TCP_USER_TIMEOUT","","",null,null],[17,"TCP_REPAIR","","",null,null],[17,"TCP_REPAIR_QUEUE","","",null,null],[17,"TCP_QUEUE_SEQ","","",null,null],[17,"TCP_REPAIR_OPTIONS","","",null,null],[17,"TCP_FASTOPEN","","",null,null],[17,"TCP_TIMESTAMP","","",null,null],[17,"SOL_SOCKET","","",null,null],[17,"SO_DEBUG","","",null,null],[17,"SO_REUSEADDR","","",null,null],[17,"SO_TYPE","","",null,null],[17,"SO_ERROR","","",null,null],[17,"SO_DONTROUTE","","",null,null],[17,"SO_BROADCAST","","",null,null],[17,"SO_SNDBUF","","",null,null],[17,"SO_RCVBUF","","",null,null],[17,"SO_KEEPALIVE","","",null,null],[17,"SO_OOBINLINE","","",null,null],[17,"SO_LINGER","","",null,null],[17,"SO_REUSEPORT","","",null,null],[17,"SO_RCVLOWAT","","",null,null],[17,"SO_SNDLOWAT","","",null,null],[17,"SO_RCVTIMEO","","",null,null],[17,"SO_SNDTIMEO","","",null,null],[17,"SO_ACCEPTCONN","","",null,null],[17,"SHUT_RD","","",null,null],[17,"SHUT_WR","","",null,null],[17,"SHUT_RDWR","","",null,null],[17,"LOCK_SH","","",null,null],[17,"LOCK_EX","","",null,null],[17,"LOCK_NB","","",null,null],[17,"LOCK_UN","","",null,null],[0,"extra","libc::consts::os","",null,null],[17,"AF_PACKET","libc::consts::os::extra","",null,null],[17,"IPPROTO_RAW","","",null,null],[17,"O_RSYNC","","",null,null],[17,"O_DSYNC","","",null,null],[17,"O_NONBLOCK","","",null,null],[17,"O_SYNC","","",null,null],[17,"PROT_GROWSDOWN","","",null,null],[17,"PROT_GROWSUP","","",null,null],[17,"MAP_TYPE","","",null,null],[17,"MAP_ANONYMOUS","","",null,null],[17,"MAP_32BIT","","",null,null],[17,"MAP_GROWSDOWN","","",null,null],[17,"MAP_DENYWRITE","","",null,null],[17,"MAP_EXECUTABLE","","",null,null],[17,"MAP_LOCKED","","",null,null],[17,"MAP_NORESERVE","","",null,null],[17,"MAP_POPULATE","","",null,null],[17,"MAP_NONBLOCK","","",null,null],[17,"MAP_STACK","","",null,null],[0,"sysconf","libc::consts::os","",null,null],[17,"_SC_ARG_MAX","libc::consts::os::sysconf","",null,null],[17,"_SC_CHILD_MAX","","",null,null],[17,"_SC_CLK_TCK","","",null,null],[17,"_SC_NGROUPS_MAX","","",null,null],[17,"_SC_OPEN_MAX","","",null,null],[17,"_SC_STREAM_MAX","","",null,null],[17,"_SC_TZNAME_MAX","","",null,null],[17,"_SC_JOB_CONTROL","","",null,null],[17,"_SC_SAVED_IDS","","",null,null],[17,"_SC_REALTIME_SIGNALS","","",null,null],[17,"_SC_PRIORITY_SCHEDULING","","",null,null],[17,"_SC_TIMERS","","",null,null],[17,"_SC_ASYNCHRONOUS_IO","","",null,null],[17,"_SC_PRIORITIZED_IO","","",null,null],[17,"_SC_SYNCHRONIZED_IO","","",null,null],[17,"_SC_FSYNC","","",null,null],[17,"_SC_MAPPED_FILES","","",null,null],[17,"_SC_MEMLOCK","","",null,null],[17,"_SC_MEMLOCK_RANGE","","",null,null],[17,"_SC_MEMORY_PROTECTION","","",null,null],[17,"_SC_MESSAGE_PASSING","","",null,null],[17,"_SC_SEMAPHORES","","",null,null],[17,"_SC_SHARED_MEMORY_OBJECTS","","",null,null],[17,"_SC_AIO_LISTIO_MAX","","",null,null],[17,"_SC_AIO_MAX","","",null,null],[17,"_SC_AIO_PRIO_DELTA_MAX","","",null,null],[17,"_SC_DELAYTIMER_MAX","","",null,null],[17,"_SC_MQ_OPEN_MAX","","",null,null],[17,"_SC_VERSION","","",null,null],[17,"_SC_PAGESIZE","","",null,null],[17,"_SC_RTSIG_MAX","","",null,null],[17,"_SC_SEM_NSEMS_MAX","","",null,null],[17,"_SC_SEM_VALUE_MAX","","",null,null],[17,"_SC_SIGQUEUE_MAX","","",null,null],[17,"_SC_TIMER_MAX","","",null,null],[17,"_SC_BC_BASE_MAX","","",null,null],[17,"_SC_BC_DIM_MAX","","",null,null],[17,"_SC_BC_SCALE_MAX","","",null,null],[17,"_SC_BC_STRING_MAX","","",null,null],[17,"_SC_COLL_WEIGHTS_MAX","","",null,null],[17,"_SC_EXPR_NEST_MAX","","",null,null],[17,"_SC_LINE_MAX","","",null,null],[17,"_SC_RE_DUP_MAX","","",null,null],[17,"_SC_2_VERSION","","",null,null],[17,"_SC_2_C_BIND","","",null,null],[17,"_SC_2_C_DEV","","",null,null],[17,"_SC_2_FORT_DEV","","",null,null],[17,"_SC_2_FORT_RUN","","",null,null],[17,"_SC_2_SW_DEV","","",null,null],[17,"_SC_2_LOCALEDEF","","",null,null],[17,"_SC_NPROCESSORS_ONLN","","",null,null],[17,"_SC_2_CHAR_TERM","","",null,null],[17,"_SC_2_C_VERSION","","",null,null],[17,"_SC_2_UPE","","",null,null],[17,"_SC_XBS5_ILP32_OFF32","","",null,null],[17,"_SC_XBS5_ILP32_OFFBIG","","",null,null],[17,"_SC_XBS5_LPBIG_OFFBIG","","",null,null],[0,"funcs","libc","",null,null],[0,"c95","libc::funcs","",null,null],[0,"ctype","libc::funcs::c95","",null,null],[5,"isalnum","libc::funcs::c95::ctype","",null,null],[5,"isalpha","","",null,null],[5,"iscntrl","","",null,null],[5,"isdigit","","",null,null],[5,"isgraph","","",null,null],[5,"islower","","",null,null],[5,"isprint","","",null,null],[5,"ispunct","","",null,null],[5,"isspace","","",null,null],[5,"isupper","","",null,null],[5,"isxdigit","","",null,null],[5,"tolower","","",null,null],[5,"toupper","","",null,null],[0,"stdio","libc::funcs::c95","",null,null],[5,"fopen","libc::funcs::c95::stdio","",null,null],[5,"freopen","","",null,null],[5,"fflush","","",null,null],[5,"fclose","","",null,null],[5,"remove","","",null,null],[5,"rename","","",null,null],[5,"tmpfile","","",null,null],[5,"setvbuf","","",null,null],[5,"setbuf","","",null,null],[5,"fgetc","","",null,null],[5,"fgets","","",null,null],[5,"fputc","","",null,null],[5,"fputs","","",null,null],[5,"puts","","",null,null],[5,"ungetc","","",null,null],[5,"fread","","",null,null],[5,"fwrite","","",null,null],[5,"fseek","","",null,null],[5,"ftell","","",null,null],[5,"rewind","","",null,null],[5,"fgetpos","","",null,null],[5,"fsetpos","","",null,null],[5,"feof","","",null,null],[5,"ferror","","",null,null],[5,"perror","","",null,null],[0,"stdlib","libc::funcs::c95","",null,null],[5,"abs","libc::funcs::c95::stdlib","",null,null],[5,"labs","","",null,null],[5,"atof","","",null,null],[5,"atoi","","",null,null],[5,"strtod","","",null,null],[5,"strtol","","",null,null],[5,"strtoul","","",null,null],[5,"calloc","","",null,null],[5,"malloc","","",null,null],[5,"realloc","","",null,null],[5,"free","","",null,null],[5,"exit","","Exits the running program in a possibly dangerous manner.",null,null],[5,"_exit","","",null,null],[5,"atexit","","",null,null],[5,"system","","",null,null],[5,"getenv","","",null,null],[5,"rand","","",null,null],[5,"srand","","",null,null],[0,"string","libc::funcs::c95","",null,null],[5,"strcpy","libc::funcs::c95::string","",null,null],[5,"strncpy","","",null,null],[5,"strcat","","",null,null],[5,"strncat","","",null,null],[5,"strcmp","","",null,null],[5,"strncmp","","",null,null],[5,"strcoll","","",null,null],[5,"strchr","","",null,null],[5,"strrchr","","",null,null],[5,"strspn","","",null,null],[5,"strcspn","","",null,null],[5,"strpbrk","","",null,null],[5,"strstr","","",null,null],[5,"strlen","","",null,null],[5,"strerror","","",null,null],[5,"strtok","","",null,null],[5,"strxfrm","","",null,null],[5,"wcslen","","",null,null],[5,"memcmp","","",null,null],[5,"memchr","","",null,null],[0,"posix88","libc::funcs","",null,null],[0,"stat_","libc::funcs::posix88","",null,null],[5,"chmod","libc::funcs::posix88::stat_","",null,null],[5,"fchmod","","",null,null],[5,"fstat","","",null,null],[5,"mkdir","","",null,null],[5,"mkfifo","","",null,null],[5,"stat","","",null,null],[0,"stdio","libc::funcs::posix88","",null,null],[5,"popen","libc::funcs::posix88::stdio","",null,null],[5,"pclose","","",null,null],[5,"fdopen","","",null,null],[5,"fileno","","",null,null],[0,"fcntl","libc::funcs::posix88","",null,null],[5,"open","libc::funcs::posix88::fcntl","",null,null],[5,"creat","","",null,null],[5,"fcntl","","",null,null],[0,"dirent","libc::funcs::posix88","",null,null],[5,"opendir","libc::funcs::posix88::dirent","",null,null],[5,"readdir_r","","",null,null],[5,"closedir","","",null,null],[5,"rewinddir","","",null,null],[5,"seekdir","","",null,null],[5,"telldir","","",null,null],[0,"unistd","libc::funcs::posix88","",null,null],[5,"access","libc::funcs::posix88::unistd","",null,null],[5,"alarm","","",null,null],[5,"chdir","","",null,null],[5,"chown","","",null,null],[5,"close","","",null,null],[5,"dup","","",null,null],[5,"dup2","","",null,null],[5,"execv","","",null,null],[5,"execve","","",null,null],[5,"execvp","","",null,null],[5,"fork","","",null,null],[5,"fpathconf","","",null,null],[5,"getcwd","","",null,null],[5,"getegid","","",null,null],[5,"geteuid","","",null,null],[5,"getgid","","",null,null],[5,"getgroups","","",null,null],[5,"getlogin","","",null,null],[5,"getopt","","",null,null],[5,"getpgrp","","",null,null],[5,"getpid","","",null,null],[5,"getppid","","",null,null],[5,"getuid","","",null,null],[5,"getsid","","",null,null],[5,"isatty","","",null,null],[5,"link","","",null,null],[5,"lseek","","",null,null],[5,"pathconf","","",null,null],[5,"pause","","",null,null],[5,"pipe","","",null,null],[5,"read","","",null,null],[5,"rmdir","","",null,null],[5,"setgid","","",null,null],[5,"setpgid","","",null,null],[5,"setsid","","",null,null],[5,"setuid","","",null,null],[5,"sleep","","",null,null],[5,"usleep","","",null,null],[5,"nanosleep","","",null,null],[5,"sysconf","","",null,null],[5,"tcgetpgrp","","",null,null],[5,"ttyname","","",null,null],[5,"unlink","","",null,null],[5,"wait","","",null,null],[5,"waitpid","","",null,null],[5,"write","","",null,null],[5,"pread","","",null,null],[5,"pwrite","","",null,null],[5,"utime","","",null,null],[17,"_PC_NAME_MAX","","",null,null],[0,"signal","libc::funcs::posix88","",null,null],[5,"kill","libc::funcs::posix88::signal","",null,null],[0,"mman","libc::funcs::posix88","",null,null],[5,"mlock","libc::funcs::posix88::mman","",null,null],[5,"munlock","","",null,null],[5,"mlockall","","",null,null],[5,"munlockall","","",null,null],[5,"mprotect","","",null,null],[5,"msync","","",null,null],[5,"shm_open","","",null,null],[5,"shm_unlink","","",null,null],[5,"mmap","","",null,null],[5,"munmap","","",null,null],[0,"net","libc::funcs::posix88","",null,null],[5,"if_nametoindex","libc::funcs::posix88::net","",null,null],[0,"posix01","libc::funcs","",null,null],[0,"stat_","libc::funcs::posix01","",null,null],[5,"lstat","libc::funcs::posix01::stat_","",null,null],[0,"unistd","libc::funcs::posix01","",null,null],[5,"readlink","libc::funcs::posix01::unistd","",null,null],[5,"fsync","","",null,null],[5,"fdatasync","","",null,null],[5,"setenv","","",null,null],[5,"unsetenv","","",null,null],[5,"putenv","","",null,null],[5,"symlink","","",null,null],[5,"ftruncate","","",null,null],[0,"signal","libc::funcs::posix01","",null,null],[5,"signal","libc::funcs::posix01::signal","",null,null],[0,"glob","libc::funcs::posix01","",null,null],[5,"glob","libc::funcs::posix01::glob","",null,null],[5,"globfree","","",null,null],[0,"mman","libc::funcs::posix01","",null,null],[5,"posix_madvise","libc::funcs::posix01::mman","",null,null],[0,"resource","libc::funcs::posix01","",null,null],[5,"getrlimit","libc::funcs::posix01::resource","",null,null],[5,"setrlimit","","",null,null],[5,"getrusage","","",null,null],[0,"bsd43","libc::funcs","",null,null],[5,"socket","libc::funcs::bsd43","",null,null],[5,"connect","","",null,null],[5,"bind","","",null,null],[5,"listen","","",null,null],[5,"accept","","",null,null],[5,"getpeername","","",null,null],[5,"getsockname","","",null,null],[5,"setsockopt","","",null,null],[5,"recv","","",null,null],[5,"send","","",null,null],[5,"recvfrom","","",null,null],[5,"sendto","","",null,null],[5,"getifaddrs","","",null,null],[5,"freeifaddrs","","",null,null],[5,"shutdown","","",null,null],[0,"bsd44","libc::funcs","",null,null],[5,"getdtablesize","libc::funcs::bsd44","",null,null],[5,"ioctl","","",null,null],[5,"madvise","","",null,null],[5,"mincore","","",null,null],[5,"flock","","",null,null]],"paths":[[4,"c_void"],[3,"glob_t"],[3,"timeval"],[3,"timespec"],[3,"rlimit"],[3,"rusage"],[3,"sockaddr"],[3,"sockaddr_storage"],[3,"sockaddr_in"],[3,"in_addr"],[3,"sockaddr_in6"],[3,"in6_addr"],[3,"ip_mreq"],[3,"ip6_mreq"],[3,"addrinfo"],[3,"sockaddr_un"],[3,"ifaddrs"],[3,"stat"],[3,"utimbuf"],[3,"pthread_attr_t"],[3,"sockaddr_ll"]]};
searchIndex['core'] = {"items":[[0,"","core","# The Rust Core Library",null,null],[0,"isize","","Operations and constants for pointer-sized signed integers (`isize` type)",null,null],[17,"BITS","core::isize","",null,null],[17,"BYTES","","",null,null],[17,"MIN","","",null,null],[17,"MAX","","",null,null],[0,"i8","core","Operations and constants for signed 8-bits integers (`i8` type)",null,null],[17,"BITS","core::i8","",null,null],[17,"BYTES","","",null,null],[17,"MIN","","",null,null],[17,"MAX","","",null,null],[0,"i16","core","Operations and constants for signed 16-bits integers (`i16` type)",null,null],[17,"BITS","core::i16","",null,null],[17,"BYTES","","",null,null],[17,"MIN","","",null,null],[17,"MAX","","",null,null],[0,"i32","core","Operations and constants for signed 32-bits integers (`i32` type)",null,null],[17,"BITS","core::i32","",null,null],[17,"BYTES","","",null,null],[17,"MIN","","",null,null],[17,"MAX","","",null,null],[0,"i64","core","Operations and constants for signed 64-bits integers (`i64` type)",null,null],[17,"BITS","core::i64","",null,null],[17,"BYTES","","",null,null],[17,"MIN","","",null,null],[17,"MAX","","",null,null],[0,"usize","core","Operations and constants for pointer-sized unsigned integers (`usize` type)",null,null],[17,"BITS","core::usize","",null,null],[17,"BYTES","","",null,null],[17,"MIN","","",null,null],[17,"MAX","","",null,null],[0,"u8","core","Operations and constants for unsigned 8-bits integers (`u8` type)",null,null],[17,"BITS","core::u8","",null,null],[17,"BYTES","","",null,null],[17,"MIN","","",null,null],[17,"MAX","","",null,null],[0,"u16","core","Operations and constants for unsigned 16-bits integers (`u16` type)",null,null],[17,"BITS","core::u16","",null,null],[17,"BYTES","","",null,null],[17,"MIN","","",null,null],[17,"MAX","","",null,null],[0,"u32","core","Operations and constants for unsigned 32-bits integers (`u32` type)",null,null],[17,"BITS","core::u32","",null,null],[17,"BYTES","","",null,null],[17,"MIN","","",null,null],[17,"MAX","","",null,null],[0,"u64","core","Operations and constants for unsigned 64-bits integer (`u64` type)",null,null],[17,"BITS","core::u64","",null,null],[17,"BYTES","","",null,null],[17,"MIN","","",null,null],[17,"MAX","","",null,null],[0,"f32","core","Operations and constants for 32-bits floats (`f32` type)",null,null],[0,"consts","core::f32","Basic mathematial constants.",null,null],[17,"PI","core::f32::consts","Archimedes' constant",null,null],[17,"PI_2","","pi * 2.0",null,null],[17,"FRAC_PI_2","","pi/2.0",null,null],[17,"FRAC_PI_3","","pi/3.0",null,null],[17,"FRAC_PI_4","","pi/4.0",null,null],[17,"FRAC_PI_6","","pi/6.0",null,null],[17,"FRAC_PI_8","","pi/8.0",null,null],[17,"FRAC_1_PI","","1.0/pi",null,null],[17,"FRAC_2_PI","","2.0/pi",null,null],[17,"FRAC_2_SQRT_PI","","2.0/sqrt(pi)",null,null],[17,"SQRT_2","","sqrt(2.0)",null,null],[17,"FRAC_1_SQRT_2","","1.0/sqrt(2.0)",null,null],[17,"E","","Euler's number",null,null],[17,"LOG2_E","","log2(e)",null,null],[17,"LOG10_E","","log10(e)",null,null],[17,"LN_2","","ln(2.0)",null,null],[17,"LN_10","","ln(10.0)",null,null],[17,"RADIX","core::f32","",null,null],[17,"MANTISSA_DIGITS","","",null,null],[17,"DIGITS","","",null,null],[17,"EPSILON","","",null,null],[17,"MIN","","Smallest finite f32 value",null,null],[17,"MIN_POSITIVE","","Smallest positive, normalized f32 value",null,null],[17,"MAX","","Largest finite f32 value",null,null],[17,"MIN_EXP","","",null,null],[17,"MAX_EXP","","",null,null],[17,"MIN_10_EXP","","",null,null],[17,"MAX_10_EXP","","",null,null],[17,"NAN","","",null,null],[17,"INFINITY","","",null,null],[17,"NEG_INFINITY","","",null,null],[0,"f64","core","Operations and constants for 64-bits floats (`f64` type)",null,null],[0,"consts","core::f64","Basic mathematial constants.",null,null],[17,"PI","core::f64::consts","Archimedes' constant",null,null],[17,"PI_2","","pi * 2.0",null,null],[17,"FRAC_PI_2","","pi/2.0",null,null],[17,"FRAC_PI_3","","pi/3.0",null,null],[17,"FRAC_PI_4","","pi/4.0",null,null],[17,"FRAC_PI_6","","pi/6.0",null,null],[17,"FRAC_PI_8","","pi/8.0",null,null],[17,"FRAC_1_PI","","1.0/pi",null,null],[17,"FRAC_2_PI","","2.0/pi",null,null],[17,"FRAC_2_SQRT_PI","","2.0/sqrt(pi)",null,null],[17,"SQRT_2","","sqrt(2.0)",null,null],[17,"FRAC_1_SQRT_2","","1.0/sqrt(2.0)",null,null],[17,"E","","Euler's number",null,null],[17,"LOG2_E","","log2(e)",null,null],[17,"LOG10_E","","log10(e)",null,null],[17,"LN_2","","ln(2.0)",null,null],[17,"LN_10","","ln(10.0)",null,null],[17,"RADIX","core::f64","",null,null],[17,"MANTISSA_DIGITS","","",null,null],[17,"DIGITS","","",null,null],[17,"EPSILON","","",null,null],[17,"MIN","","Smallest finite f64 value",null,null],[17,"MIN_POSITIVE","","Smallest positive, normalized f64 value",null,null],[17,"MAX","","Largest finite f64 value",null,null],[17,"MIN_EXP","","",null,null],[17,"MAX_EXP","","",null,null],[17,"MIN_10_EXP","","",null,null],[17,"MAX_10_EXP","","",null,null],[17,"NAN","","",null,null],[17,"INFINITY","","",null,null],[17,"NEG_INFINITY","","",null,null],[0,"num","core","Numeric traits and functions for the built-in numeric types.",null,null],[3,"Wrapping","core::num","Provides intentionally-wrapped arithmetic on `T`.",null,null],[3,"ParseIntError","","An error which can be returned when parsing an integer.",null,null],[3,"ParseFloatError","","An error which can be returned when parsing a float.",null,null],[4,"FpCategory","","Used for representing the classification of floating point numbers",null,null],[13,"Nan","","\"Not a Number\", often obtained by dividing by zero",0,null],[13,"Infinite","","Positive or negative infinity",0,null],[13,"Zero","","Positive or negative zero",0,null],[13,"Subnormal","","De-normalized floating point representation (less precise than `Normal`)",0,null],[13,"Normal","","A regular floating point number",0,null],[0,"wrapping","","",null,null],[8,"OverflowingOps","core::num::wrapping","",null,null],[10,"overflowing_add","","",1,null],[10,"overflowing_sub","","",1,null],[10,"overflowing_mul","","",1,null],[10,"overflowing_div","","",1,null],[10,"overflowing_rem","","",1,null],[10,"overflowing_neg","","",1,null],[10,"overflowing_shl","","",1,null],[10,"overflowing_shr","","",1,null],[11,"shl","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shr","","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shl","","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shr","","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shl","","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shr","","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shl","","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shr","","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shl","","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shr","","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shl","","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shr","","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shl","","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shr","","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shl","","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shr","","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shl","","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shr","","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shl","","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"shr","","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[11,"add","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"sub","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"mul","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"div","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"not","","",2,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitxor","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitor","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitand","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"add","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"sub","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"mul","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"div","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"not","","",2,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitxor","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitor","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitand","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"add","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"sub","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"mul","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"div","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"not","","",2,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitxor","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitor","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitand","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"add","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"sub","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"mul","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"div","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"not","","",2,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitxor","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitor","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitand","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"add","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"sub","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"mul","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"div","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"not","","",2,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitxor","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitor","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitand","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"add","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"sub","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"mul","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"div","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"not","","",2,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitxor","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitor","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitand","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"add","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"sub","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"mul","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"div","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"not","","",2,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitxor","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitor","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitand","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"add","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"sub","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"mul","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"div","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"not","","",2,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitxor","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitor","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitand","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"add","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"sub","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"mul","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"div","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"not","","",2,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitxor","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitor","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitand","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"add","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"sub","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"mul","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"div","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"not","","",2,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitxor","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitor","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"bitand","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[8,"Zero","","Types that have a \"zero\" value.",null,null],[10,"zero","","The \"zero\" (usually, additive identity) for this type.",3,{"inputs":[{"name":"zero"}],"output":{"name":"self"}}],[8,"One","","Types that have a \"one\" value.",null,null],[10,"one","","The \"one\" (usually, multiplicative identity) for this type.",4,{"inputs":[{"name":"one"}],"output":{"name":"self"}}],[11,"fmt","","",2,{"inputs":[{"name":"wrapping"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",2,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"cmp","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"option"}}],[11,"lt","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"le","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"gt","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"ge","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"eq","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"ne","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"fmt","","",0,{"inputs":[{"name":"fpcategory"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",0,{"inputs":[{"name":"fpcategory"},{"name":"fpcategory"}],"output":{"name":"bool"}}],[11,"ne","","",0,{"inputs":[{"name":"fpcategory"},{"name":"fpcategory"}],"output":{"name":"bool"}}],[11,"clone","","",0,{"inputs":[{"name":"fpcategory"}],"output":{"name":"fpcategory"}}],[11,"eq","","",5,{"inputs":[{"name":"parseinterror"},{"name":"parseinterror"}],"output":{"name":"bool"}}],[11,"ne","","",5,{"inputs":[{"name":"parseinterror"},{"name":"parseinterror"}],"output":{"name":"bool"}}],[11,"clone","","",5,{"inputs":[{"name":"parseinterror"}],"output":{"name":"parseinterror"}}],[11,"fmt","","",5,{"inputs":[{"name":"parseinterror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",5,{"inputs":[{"name":"parseinterror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",6,{"inputs":[{"name":"parsefloaterror"},{"name":"parsefloaterror"}],"output":{"name":"bool"}}],[11,"ne","","",6,{"inputs":[{"name":"parsefloaterror"},{"name":"parsefloaterror"}],"output":{"name":"bool"}}],[11,"clone","","",6,{"inputs":[{"name":"parsefloaterror"}],"output":{"name":"parsefloaterror"}}],[11,"fmt","","",6,{"inputs":[{"name":"parsefloaterror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",6,{"inputs":[{"name":"parsefloaterror"},{"name":"formatter"}],"output":{"name":"result"}}],[0,"prelude","core","The core prelude",null,null],[0,"intrinsics","","rustc compiler intrinsics.",null,null],[5,"atomic_cxchg","core::intrinsics","",null,null],[5,"atomic_cxchg_acq","","",null,null],[5,"atomic_cxchg_rel","","",null,null],[5,"atomic_cxchg_acqrel","","",null,null],[5,"atomic_cxchg_relaxed","","",null,null],[5,"atomic_load","","",null,null],[5,"atomic_load_acq","","",null,null],[5,"atomic_load_relaxed","","",null,null],[5,"atomic_load_unordered","","",null,null],[5,"atomic_store","","",null,null],[5,"atomic_store_rel","","",null,null],[5,"atomic_store_relaxed","","",null,null],[5,"atomic_store_unordered","","",null,null],[5,"atomic_xchg","","",null,null],[5,"atomic_xchg_acq","","",null,null],[5,"atomic_xchg_rel","","",null,null],[5,"atomic_xchg_acqrel","","",null,null],[5,"atomic_xchg_relaxed","","",null,null],[5,"atomic_xadd","","",null,null],[5,"atomic_xadd_acq","","",null,null],[5,"atomic_xadd_rel","","",null,null],[5,"atomic_xadd_acqrel","","",null,null],[5,"atomic_xadd_relaxed","","",null,null],[5,"atomic_xsub","","",null,null],[5,"atomic_xsub_acq","","",null,null],[5,"atomic_xsub_rel","","",null,null],[5,"atomic_xsub_acqrel","","",null,null],[5,"atomic_xsub_relaxed","","",null,null],[5,"atomic_and","","",null,null],[5,"atomic_and_acq","","",null,null],[5,"atomic_and_rel","","",null,null],[5,"atomic_and_acqrel","","",null,null],[5,"atomic_and_relaxed","","",null,null],[5,"atomic_nand","","",null,null],[5,"atomic_nand_acq","","",null,null],[5,"atomic_nand_rel","","",null,null],[5,"atomic_nand_acqrel","","",null,null],[5,"atomic_nand_relaxed","","",null,null],[5,"atomic_or","","",null,null],[5,"atomic_or_acq","","",null,null],[5,"atomic_or_rel","","",null,null],[5,"atomic_or_acqrel","","",null,null],[5,"atomic_or_relaxed","","",null,null],[5,"atomic_xor","","",null,null],[5,"atomic_xor_acq","","",null,null],[5,"atomic_xor_rel","","",null,null],[5,"atomic_xor_acqrel","","",null,null],[5,"atomic_xor_relaxed","","",null,null],[5,"atomic_max","","",null,null],[5,"atomic_max_acq","","",null,null],[5,"atomic_max_rel","","",null,null],[5,"atomic_max_acqrel","","",null,null],[5,"atomic_max_relaxed","","",null,null],[5,"atomic_min","","",null,null],[5,"atomic_min_acq","","",null,null],[5,"atomic_min_rel","","",null,null],[5,"atomic_min_acqrel","","",null,null],[5,"atomic_min_relaxed","","",null,null],[5,"atomic_umin","","",null,null],[5,"atomic_umin_acq","","",null,null],[5,"atomic_umin_rel","","",null,null],[5,"atomic_umin_acqrel","","",null,null],[5,"atomic_umin_relaxed","","",null,null],[5,"atomic_umax","","",null,null],[5,"atomic_umax_acq","","",null,null],[5,"atomic_umax_rel","","",null,null],[5,"atomic_umax_acqrel","","",null,null],[5,"atomic_umax_relaxed","","",null,null],[5,"atomic_fence","","",null,null],[5,"atomic_fence_acq","","",null,null],[5,"atomic_fence_rel","","",null,null],[5,"atomic_fence_acqrel","","",null,null],[5,"atomic_singlethreadfence","","A compiler-only memory barrier.",null,null],[5,"atomic_singlethreadfence_acq","","",null,null],[5,"atomic_singlethreadfence_rel","","",null,null],[5,"atomic_singlethreadfence_acqrel","","",null,null],[5,"abort","","Aborts the execution of the process.",null,null],[5,"unreachable","","Tells LLVM that this point in the code is not reachable,\nenabling further optimizations.",null,null],[5,"assume","","Informs the optimizer that a condition is always true.\nIf the condition is false, the behavior is undefined.",null,null],[5,"breakpoint","","Executes a breakpoint trap, for inspection by a debugger.",null,null],[5,"size_of","","The size of a type in bytes.",null,null],[5,"move_val_init","","Moves a value to an uninitialized memory location.",null,null],[5,"min_align_of","","",null,null],[5,"pref_align_of","","",null,null],[5,"size_of_val","","",null,null],[5,"min_align_of_val","","",null,null],[5,"drop_in_place","","",null,null],[5,"type_name","","Gets a static string slice containing the name of a type.",null,null],[5,"type_id","","Gets an identifier which is globally unique to the specified type. This\nfunction will return the same value for a type regardless of whichever\ncrate it is invoked in.",null,null],[5,"init_dropped","","Creates a value initialized to so that its drop flag,\nif any, says that it has been dropped.",null,null],[5,"init","","Creates a value initialized to zero.",null,null],[5,"uninit","","Creates an uninitialized value.",null,null],[5,"forget","","Moves a value out of scope without running drop glue.",null,null],[5,"transmute","","Unsafely transforms a value of one type into a value of another type.",null,null],[5,"return_address","","Gives the address for the return value of the enclosing function.",null,null],[5,"needs_drop","","Returns `true` if the actual type given as `T` requires drop\nglue; returns `false` if the actual type provided for `T`\nimplements `Copy`.",null,null],[5,"offset","","Calculates the offset from a pointer.",null,null],[5,"arith_offset","","Calculates the offset from a pointer, potentially wrapping.",null,null],[5,"copy_nonoverlapping","","Copies `count * size_of<T>` bytes from `src` to `dst`. The source\nand destination may *not* overlap.",null,null],[5,"copy","","Copies `count * size_of<T>` bytes from `src` to `dst`. The source\nand destination may overlap.",null,null],[5,"write_bytes","","Invokes memset on the specified pointer, setting `count * size_of::<T>()`\nbytes of memory starting at `dst` to `c`.",null,null],[5,"volatile_copy_nonoverlapping_memory","","Equivalent to the appropriate `llvm.memcpy.p0i8.0i8.*` intrinsic, with\na size of `count` * `size_of::<T>()` and an alignment of\n`min_align_of::<T>()`",null,null],[5,"volatile_copy_memory","","Equivalent to the appropriate `llvm.memmove.p0i8.0i8.*` intrinsic, with\na size of `count` * `size_of::<T>()` and an alignment of\n`min_align_of::<T>()`",null,null],[5,"volatile_set_memory","","Equivalent to the appropriate `llvm.memset.p0i8.*` intrinsic, with a\nsize of `count` * `size_of::<T>()` and an alignment of\n`min_align_of::<T>()`.",null,null],[5,"volatile_load","","Perform a volatile load from the `src` pointer.",null,null],[5,"volatile_store","","Perform a volatile store to the `dst` pointer.",null,null],[5,"sqrtf32","","Returns the square root of an `f32`",null,null],[5,"sqrtf64","","Returns the square root of an `f64`",null,null],[5,"powif32","","Raises an `f32` to an integer power.",null,null],[5,"powif64","","Raises an `f64` to an integer power.",null,null],[5,"sinf32","","Returns the sine of an `f32`.",null,null],[5,"sinf64","","Returns the sine of an `f64`.",null,null],[5,"cosf32","","Returns the cosine of an `f32`.",null,null],[5,"cosf64","","Returns the cosine of an `f64`.",null,null],[5,"powf32","","Raises an `f32` to an `f32` power.",null,null],[5,"powf64","","Raises an `f64` to an `f64` power.",null,null],[5,"expf32","","Returns the exponential of an `f32`.",null,null],[5,"expf64","","Returns the exponential of an `f64`.",null,null],[5,"exp2f32","","Returns 2 raised to the power of an `f32`.",null,null],[5,"exp2f64","","Returns 2 raised to the power of an `f64`.",null,null],[5,"logf32","","Returns the natural logarithm of an `f32`.",null,null],[5,"logf64","","Returns the natural logarithm of an `f64`.",null,null],[5,"log10f32","","Returns the base 10 logarithm of an `f32`.",null,null],[5,"log10f64","","Returns the base 10 logarithm of an `f64`.",null,null],[5,"log2f32","","Returns the base 2 logarithm of an `f32`.",null,null],[5,"log2f64","","Returns the base 2 logarithm of an `f64`.",null,null],[5,"fmaf32","","Returns `a * b + c` for `f32` values.",null,null],[5,"fmaf64","","Returns `a * b + c` for `f64` values.",null,null],[5,"fabsf32","","Returns the absolute value of an `f32`.",null,null],[5,"fabsf64","","Returns the absolute value of an `f64`.",null,null],[5,"copysignf32","","Copies the sign from `y` to `x` for `f32` values.",null,null],[5,"copysignf64","","Copies the sign from `y` to `x` for `f64` values.",null,null],[5,"floorf32","","Returns the largest integer less than or equal to an `f32`.",null,null],[5,"floorf64","","Returns the largest integer less than or equal to an `f64`.",null,null],[5,"ceilf32","","Returns the smallest integer greater than or equal to an `f32`.",null,null],[5,"ceilf64","","Returns the smallest integer greater than or equal to an `f64`.",null,null],[5,"truncf32","","Returns the integer part of an `f32`.",null,null],[5,"truncf64","","Returns the integer part of an `f64`.",null,null],[5,"rintf32","","Returns the nearest integer to an `f32`. May raise an inexact floating-point exception\nif the argument is not an integer.",null,null],[5,"rintf64","","Returns the nearest integer to an `f64`. May raise an inexact floating-point exception\nif the argument is not an integer.",null,null],[5,"nearbyintf32","","Returns the nearest integer to an `f32`.",null,null],[5,"nearbyintf64","","Returns the nearest integer to an `f64`.",null,null],[5,"roundf32","","Returns the nearest integer to an `f32`. Rounds half-way cases away from zero.",null,null],[5,"roundf64","","Returns the nearest integer to an `f64`. Rounds half-way cases away from zero.",null,null],[5,"ctpop8","","Returns the number of bits set in a `u8`.",null,null],[5,"ctpop16","","Returns the number of bits set in a `u16`.",null,null],[5,"ctpop32","","Returns the number of bits set in a `u32`.",null,null],[5,"ctpop64","","Returns the number of bits set in a `u64`.",null,null],[5,"ctlz8","","Returns the number of leading bits unset in a `u8`.",null,null],[5,"ctlz16","","Returns the number of leading bits unset in a `u16`.",null,null],[5,"ctlz32","","Returns the number of leading bits unset in a `u32`.",null,null],[5,"ctlz64","","Returns the number of leading bits unset in a `u64`.",null,null],[5,"cttz8","","Returns the number of trailing bits unset in a `u8`.",null,null],[5,"cttz16","","Returns the number of trailing bits unset in a `u16`.",null,null],[5,"cttz32","","Returns the number of trailing bits unset in a `u32`.",null,null],[5,"cttz64","","Returns the number of trailing bits unset in a `u64`.",null,null],[5,"bswap16","","Reverses the bytes in a `u16`.",null,null],[5,"bswap32","","Reverses the bytes in a `u32`.",null,null],[5,"bswap64","","Reverses the bytes in a `u64`.",null,null],[5,"i8_add_with_overflow","","Performs checked `i8` addition.",null,null],[5,"i16_add_with_overflow","","Performs checked `i16` addition.",null,null],[5,"i32_add_with_overflow","","Performs checked `i32` addition.",null,null],[5,"i64_add_with_overflow","","Performs checked `i64` addition.",null,null],[5,"u8_add_with_overflow","","Performs checked `u8` addition.",null,null],[5,"u16_add_with_overflow","","Performs checked `u16` addition.",null,null],[5,"u32_add_with_overflow","","Performs checked `u32` addition.",null,null],[5,"u64_add_with_overflow","","Performs checked `u64` addition.",null,null],[5,"i8_sub_with_overflow","","Performs checked `i8` subtraction.",null,null],[5,"i16_sub_with_overflow","","Performs checked `i16` subtraction.",null,null],[5,"i32_sub_with_overflow","","Performs checked `i32` subtraction.",null,null],[5,"i64_sub_with_overflow","","Performs checked `i64` subtraction.",null,null],[5,"u8_sub_with_overflow","","Performs checked `u8` subtraction.",null,null],[5,"u16_sub_with_overflow","","Performs checked `u16` subtraction.",null,null],[5,"u32_sub_with_overflow","","Performs checked `u32` subtraction.",null,null],[5,"u64_sub_with_overflow","","Performs checked `u64` subtraction.",null,null],[5,"i8_mul_with_overflow","","Performs checked `i8` multiplication.",null,null],[5,"i16_mul_with_overflow","","Performs checked `i16` multiplication.",null,null],[5,"i32_mul_with_overflow","","Performs checked `i32` multiplication.",null,null],[5,"i64_mul_with_overflow","","Performs checked `i64` multiplication.",null,null],[5,"u8_mul_with_overflow","","Performs checked `u8` multiplication.",null,null],[5,"u16_mul_with_overflow","","Performs checked `u16` multiplication.",null,null],[5,"u32_mul_with_overflow","","Performs checked `u32` multiplication.",null,null],[5,"u64_mul_with_overflow","","Performs checked `u64` multiplication.",null,null],[5,"overflowing_add","","Returns (a + b) mod 2^N, where N is the width of N in bits.",null,null],[5,"overflowing_sub","","Returns (a - b) mod 2^N, where N is the width of N in bits.",null,null],[5,"overflowing_mul","","Returns (a * b) mod 2^N, where N is the width of N in bits.",null,null],[5,"unchecked_sdiv","","Performs an unchecked signed division, which results in undefined behavior,\nin cases where y == 0, or x == isize::MIN and y == -1",null,null],[5,"unchecked_udiv","","Performs an unchecked unsigned division, which results in undefined behavior,\nin cases where y == 0",null,null],[5,"unchecked_srem","","Returns the remainder of an unchecked signed division, which results in\nundefined behavior, in cases where y == 0, or x == isize::MIN and y == -1",null,null],[5,"unchecked_urem","","Returns the remainder of an unchecked unsigned division, which results in\nundefined behavior, in cases where y == 0",null,null],[5,"discriminant_value","","Returns the value of the discriminant for the variant in 'v',\ncast to a `u64`; if `T` has no discriminant, returns 0.",null,null],[5,"try","","Rust's \"try catch\" construct which invokes the function pointer `f` with\nthe data pointer `data`, returning the exception payload if an exception\nis thrown (aka the thread panics).",null,null],[0,"mem","core","Basic functions for dealing with memory",null,null],[5,"forget","core::mem","Leaks a value into the void, consuming ownership and never running its\ndestructor.",null,{"inputs":[{"name":"t"}],"output":null}],[5,"size_of","","Returns the size of a type in bytes.",null,{"inputs":[],"output":{"name":"usize"}}],[5,"size_of_val","","Returns the size of the type that `val` points to in bytes.",null,{"inputs":[{"name":"t"}],"output":{"name":"usize"}}],[5,"min_align_of","","Returns the ABI-required minimum alignment of a type",null,{"inputs":[],"output":{"name":"usize"}}],[5,"min_align_of_val","","Returns the ABI-required minimum alignment of the type of the value that `val` points to",null,{"inputs":[{"name":"t"}],"output":{"name":"usize"}}],[5,"align_of","","Returns the alignment in memory for a type.",null,{"inputs":[],"output":{"name":"usize"}}],[5,"align_of_val","","Returns the ABI-required minimum alignment of the type of the value that `val` points to",null,{"inputs":[{"name":"t"}],"output":{"name":"usize"}}],[5,"zeroed","","Creates a value initialized to zero.",null,{"inputs":[],"output":{"name":"t"}}],[5,"dropped","","Creates a value initialized to an unspecified series of bytes.",null,{"inputs":[],"output":{"name":"t"}}],[5,"uninitialized","","Bypasses Rust's normal memory-initialization checks by pretending to\nproduce a value of type T, while doing nothing at all.",null,{"inputs":[],"output":{"name":"t"}}],[5,"swap","","Swap the values at two mutable locations of the same type, without deinitialising or copying\neither one.",null,{"inputs":[{"name":"t"},{"name":"t"}],"output":null}],[5,"replace","","Replaces the value at a mutable location with a new one, returning the old value, without\ndeinitialising or copying either one.",null,{"inputs":[{"name":"t"},{"name":"t"}],"output":{"name":"t"}}],[5,"drop","","Disposes of a value.",null,{"inputs":[{"name":"t"}],"output":null}],[5,"transmute_copy","","Interprets `src` as `&U`, and then reads `src` without moving the contained\nvalue.",null,{"inputs":[{"name":"t"}],"output":{"name":"u"}}],[5,"copy_lifetime","","Transforms lifetime of the second pointer to match the first.",null,{"inputs":[{"name":"s"},{"name":"t"}],"output":{"name":"t"}}],[5,"copy_mut_lifetime","","Transforms lifetime of the second mutable pointer to match the first.",null,{"inputs":[{"name":"s"},{"name":"t"}],"output":{"name":"t"}}],[17,"POST_DROP_U8","","",null,null],[17,"POST_DROP_U32","","",null,null],[17,"POST_DROP_U64","","",null,null],[17,"POST_DROP_USIZE","","",null,null],[0,"nonzero","core","Exposes the NonZero lang item which provides optimization hints.",null,null],[3,"NonZero","core::nonzero","A wrapper type for raw pointers and integers that will never be\nNULL or 0 that might allow certain optimizations.",null,null],[8,"Zeroable","","Unsafe trait to indicate what types are usable with the NonZero struct",null,null],[11,"hash","","",7,null],[11,"fmt","","",7,{"inputs":[{"name":"nonzero"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"partial_cmp","","",7,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"option"}}],[11,"lt","","",7,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"le","","",7,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"gt","","",7,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"ge","","",7,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"cmp","","",7,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"ordering"}}],[11,"eq","","",7,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"ne","","",7,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"clone","","",7,{"inputs":[{"name":"nonzero"}],"output":{"name":"nonzero"}}],[11,"new","","Creates an instance of NonZero with the provided value.\nYou must indeed ensure that the value is actually \"non-zero\".",7,{"inputs":[{"name":"nonzero"},{"name":"t"}],"output":{"name":"nonzero"}}],[11,"deref","","",7,{"inputs":[{"name":"nonzero"}],"output":{"name":"t"}}],[0,"ptr","core","Raw, unsafe pointers, `*const T`, and `*mut T`",null,null],[3,"Unique","core::ptr","A wrapper around a raw `*mut T` that indicates that the possessor\nof this wrapper owns the referent. This in turn implies that the\n`Unique<T>` is `Send`/`Sync` if `T` is `Send`/`Sync`, unlike a raw\n`*mut T` (which conveys no particular ownership semantics).  It\nalso implies that the referent of the pointer should not be\nmodified without a unique path to the `Unique` reference. Useful\nfor building abstractions like `Vec<T>` or `Box<T>`, which\ninternally use raw pointers to manage the memory that they own.",null,null],[5,"null","","Creates a null raw pointer.",null,null],[5,"null_mut","","Creates a null mutable raw pointer.",null,null],[5,"swap","","Swaps the values at two mutable locations of the same type, without\ndeinitialising either. They may overlap, unlike `mem::swap` which is\notherwise equivalent.",null,null],[5,"replace","","Replaces the value at `dest` with `src`, returning the old\nvalue, without dropping either.",null,null],[5,"read","","Reads the value from `src` without moving it. This leaves the\nmemory in `src` unchanged.",null,null],[5,"read_and_zero","","Reads the value from `src` and nulls it out without dropping it.",null,null],[5,"read_and_drop","","Variant of read_and_zero that writes the specific drop-flag byte\n(which may be more appropriate than zero).",null,null],[5,"write","","Overwrites a memory location with the given value without reading or\ndropping the old value.",null,null],[11,"new","","Creates a new `Unique`.",8,null],[11,"get","","Dereferences the content.",8,{"inputs":[{"name":"unique"}],"output":{"name":"t"}}],[11,"get_mut","","Mutably dereferences the content.",8,{"inputs":[{"name":"unique"}],"output":{"name":"t"}}],[11,"deref","","",8,null],[11,"fmt","","",8,{"inputs":[{"name":"unique"},{"name":"formatter"}],"output":{"name":"result"}}],[0,"marker","core","Primitive traits and marker types representing basic 'kinds' of types.",null,null],[3,"NoCopy","core::marker","A type which is considered \"not POD\", meaning that it is not\nimplicitly copyable. This is typically embedded in other types to\nensure that they are never copied, even if they lack a destructor.",null,null],[3,"PhantomData","","`PhantomData<T>` allows you to describe that a type acts as if it stores a value of type `T`,\neven though it does not. This allows you to inform the compiler about certain safety properties\nof your code.",null,null],[8,"Send","","Types able to be transferred across thread boundaries.",null,null],[8,"Sized","","Types with a constant size known at compile-time.",null,null],[8,"Unsize","","Types that can be \"unsized\" to a dynamically sized type.",null,null],[8,"Copy","","Types that can be copied by simply copying bits (i.e. `memcpy`).",null,null],[8,"Sync","","Types that can be safely shared between threads when aliased.",null,null],[8,"Reflect","","A marker trait indicates a type that can be reflected over. This\ntrait is implemented for all types. Its purpose is to ensure that\nwhen you write a generic function that will employ reflection,\nthat must be reflected (no pun intended) in the generic bounds of\nthat function. Here is an example:",null,null],[11,"cmp","","",9,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",9,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"option"}}],[11,"lt","","",9,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"le","","",9,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"gt","","",9,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"ge","","",9,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"eq","","",9,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"ne","","",9,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"clone","","",9,{"inputs":[{"name":"nocopy"}],"output":{"name":"nocopy"}}],[11,"hash","","",10,{"inputs":[{"name":"phantomdata"},{"name":"h"}],"output":null}],[11,"eq","","",10,{"inputs":[{"name":"phantomdata"},{"name":"phantomdata"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",10,{"inputs":[{"name":"phantomdata"},{"name":"phantomdata"}],"output":{"name":"option"}}],[11,"cmp","","",10,{"inputs":[{"name":"phantomdata"},{"name":"phantomdata"}],"output":{"name":"ordering"}}],[11,"clone","","",10,{"inputs":[{"name":"phantomdata"}],"output":{"name":"phantomdata"}}],[0,"ops","core","Overloadable operators",null,null],[3,"RangeFull","core::ops","An unbounded range.",null,null],[3,"Range","","A (half-open) range which is bounded at both ends.",null,null],[12,"start","","The lower bound of the range (inclusive).",11,null],[12,"end","","The upper bound of the range (exclusive).",11,null],[3,"RangeFrom","","A range which is only bounded below.",null,null],[12,"start","","The lower bound of the range (inclusive).",12,null],[3,"RangeTo","","A range which is only bounded above.",null,null],[12,"end","","The upper bound of the range (exclusive).",13,null],[8,"Drop","","The `Drop` trait is used to run some code when a value goes out of scope.\nThis is sometimes called a 'destructor'.",null,null],[10,"drop","","The `drop` method, called when the value goes out of scope.",14,{"inputs":[{"name":"drop"}],"output":null}],[8,"Add","","The `Add` trait is used to specify the functionality of `+`.",null,null],[16,"Output","","The resulting type after applying the `+` operator",15,null],[10,"add","","The method for the `+` operator",15,{"inputs":[{"name":"add"},{"name":"rhs"}],"output":{"name":"output"}}],[8,"Sub","","The `Sub` trait is used to specify the functionality of `-`.",null,null],[16,"Output","","The resulting type after applying the `-` operator",16,null],[10,"sub","","The method for the `-` operator",16,{"inputs":[{"name":"sub"},{"name":"rhs"}],"output":{"name":"output"}}],[8,"Mul","","The `Mul` trait is used to specify the functionality of `*`.",null,null],[16,"Output","","The resulting type after applying the `*` operator",17,null],[10,"mul","","The method for the `*` operator",17,{"inputs":[{"name":"mul"},{"name":"rhs"}],"output":{"name":"output"}}],[8,"Div","","The `Div` trait is used to specify the functionality of `/`.",null,null],[16,"Output","","The resulting type after applying the `/` operator",18,null],[10,"div","","The method for the `/` operator",18,{"inputs":[{"name":"div"},{"name":"rhs"}],"output":{"name":"output"}}],[8,"Rem","","The `Rem` trait is used to specify the functionality of `%`.",null,null],[16,"Output","","The resulting type after applying the `%` operator",19,null],[10,"rem","","The method for the `%` operator",19,{"inputs":[{"name":"rem"},{"name":"rhs"}],"output":{"name":"output"}}],[8,"Neg","","The `Neg` trait is used to specify the functionality of unary `-`.",null,null],[16,"Output","","The resulting type after applying the `-` operator",20,null],[10,"neg","","The method for the unary `-` operator",20,{"inputs":[{"name":"neg"}],"output":{"name":"output"}}],[8,"Not","","The `Not` trait is used to specify the functionality of unary `!`.",null,null],[16,"Output","","The resulting type after applying the `!` operator",21,null],[10,"not","","The method for the unary `!` operator",21,{"inputs":[{"name":"not"}],"output":{"name":"output"}}],[8,"BitAnd","","The `BitAnd` trait is used to specify the functionality of `&`.",null,null],[16,"Output","","The resulting type after applying the `&` operator",22,null],[10,"bitand","","The method for the `&` operator",22,{"inputs":[{"name":"bitand"},{"name":"rhs"}],"output":{"name":"output"}}],[8,"BitOr","","The `BitOr` trait is used to specify the functionality of `|`.",null,null],[16,"Output","","The resulting type after applying the `|` operator",23,null],[10,"bitor","","The method for the `|` operator",23,{"inputs":[{"name":"bitor"},{"name":"rhs"}],"output":{"name":"output"}}],[8,"BitXor","","The `BitXor` trait is used to specify the functionality of `^`.",null,null],[16,"Output","","The resulting type after applying the `^` operator",24,null],[10,"bitxor","","The method for the `^` operator",24,{"inputs":[{"name":"bitxor"},{"name":"rhs"}],"output":{"name":"output"}}],[8,"Shl","","The `Shl` trait is used to specify the functionality of `<<`.",null,null],[16,"Output","","The resulting type after applying the `<<` operator",25,null],[10,"shl","","The method for the `<<` operator",25,{"inputs":[{"name":"shl"},{"name":"rhs"}],"output":{"name":"output"}}],[8,"Shr","","The `Shr` trait is used to specify the functionality of `>>`.",null,null],[16,"Output","","The resulting type after applying the `>>` operator",26,null],[10,"shr","","The method for the `>>` operator",26,{"inputs":[{"name":"shr"},{"name":"rhs"}],"output":{"name":"output"}}],[8,"Index","","The `Index` trait is used to specify the functionality of indexing operations\nlike `arr[idx]` when used in an immutable context.",null,null],[16,"Output","","The returned type after indexing",27,null],[10,"index","","The method for the indexing (`Foo[Bar]`) operation",27,{"inputs":[{"name":"index"},{"name":"idx"}],"output":{"name":"output"}}],[8,"IndexMut","","The `IndexMut` trait is used to specify the functionality of indexing\noperations like `arr[idx]`, when used in a mutable context.",null,null],[10,"index_mut","","The method for the indexing (`Foo[Bar]`) operation",28,{"inputs":[{"name":"indexmut"},{"name":"idx"}],"output":{"name":"output"}}],[8,"Deref","","The `Deref` trait is used to specify the functionality of dereferencing\noperations like `*v`.",null,null],[16,"Target","","The resulting type after dereferencing",29,null],[10,"deref","","The method called to dereference a value",29,{"inputs":[{"name":"deref"}],"output":{"name":"target"}}],[8,"DerefMut","","The `DerefMut` trait is used to specify the functionality of dereferencing\nmutably like `*v = 1;`",null,null],[10,"deref_mut","","The method called to mutably dereference a value",30,{"inputs":[{"name":"derefmut"}],"output":{"name":"target"}}],[8,"Fn","","A version of the call operator that takes an immutable receiver.",null,null],[10,"call","","This is called when the call operator is used.",31,{"inputs":[{"name":"fn"},{"name":"args"}],"output":{"name":"output"}}],[8,"FnMut","","A version of the call operator that takes a mutable receiver.",null,null],[10,"call_mut","","This is called when the call operator is used.",32,{"inputs":[{"name":"fnmut"},{"name":"args"}],"output":{"name":"output"}}],[8,"FnOnce","","A version of the call operator that takes a by-value receiver.",null,null],[16,"Output","","The returned type after the call operator is used.",33,null],[10,"call_once","","This is called when the call operator is used.",33,{"inputs":[{"name":"fnonce"},{"name":"args"}],"output":{"name":"output"}}],[8,"CoerceUnsized","","Trait that indicates that this is a pointer or a wrapper for one,\nwhere unsizing can be performed on the pointee.",null,null],[8,"Place","","Both `in (PLACE) EXPR` and `box EXPR` desugar into expressions\nthat allocate an intermediate \"place\" that holds uninitialized\nstate.  The desugaring evaluates EXPR, and writes the result at\nthe address returned by the `pointer` method of this trait.",null,null],[10,"pointer","","Returns the address where the input value will be written.\nNote that the data at this address is generally uninitialized,\nand thus one should use `ptr::write` for initializing it.",34,null],[8,"Placer","","Interface to implementations of  `in (PLACE) EXPR`.",null,null],[16,"Place","","`Place` is the intermedate agent guarding the\nuninitialized state for `Data`.",35,null],[10,"make_place","","Creates a fresh place from `self`.",35,{"inputs":[{"name":"placer"}],"output":{"name":"place"}}],[8,"InPlace","","Specialization of `Place` trait supporting `in (PLACE) EXPR`.",null,null],[16,"Owner","","`Owner` is the type of the end value of `in (PLACE) EXPR`",36,null],[10,"finalize","","Converts self into the final value, shifting\ndeallocation/cleanup responsibilities (if any remain), over to\nthe returned instance of `Owner` and forgetting self.",36,{"inputs":[{"name":"inplace"}],"output":{"name":"owner"}}],[8,"Boxed","","Core trait for the `box EXPR` form.",null,null],[16,"Data","","The kind of data that is stored in this kind of box.",37,null],[16,"Place","","The place that will negotiate the storage of the data.",37,null],[10,"finalize","","Converts filled place into final owning value, shifting\ndeallocation/cleanup responsibilities (if any remain), over to\nreturned instance of `Self` and forgetting `filled`.",37,{"inputs":[{"name":"boxed"},{"name":"place"}],"output":{"name":"self"}}],[8,"BoxPlace","","Specialization of `Place` trait supporting `box EXPR`.",null,null],[10,"make_place","","Creates a globally fresh place.",38,{"inputs":[{"name":"boxplace"}],"output":{"name":"self"}}],[11,"eq","","",39,{"inputs":[{"name":"rangefull"},{"name":"rangefull"}],"output":{"name":"bool"}}],[11,"ne","","",39,{"inputs":[{"name":"rangefull"},{"name":"rangefull"}],"output":{"name":"bool"}}],[11,"clone","","",39,{"inputs":[{"name":"rangefull"}],"output":{"name":"rangefull"}}],[11,"fmt","","",39,{"inputs":[{"name":"rangefull"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",11,{"inputs":[{"name":"range"},{"name":"range"}],"output":{"name":"bool"}}],[11,"ne","","",11,{"inputs":[{"name":"range"},{"name":"range"}],"output":{"name":"bool"}}],[11,"clone","","",11,{"inputs":[{"name":"range"}],"output":{"name":"range"}}],[11,"fmt","","",11,{"inputs":[{"name":"range"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",12,{"inputs":[{"name":"rangefrom"},{"name":"rangefrom"}],"output":{"name":"bool"}}],[11,"ne","","",12,{"inputs":[{"name":"rangefrom"},{"name":"rangefrom"}],"output":{"name":"bool"}}],[11,"clone","","",12,{"inputs":[{"name":"rangefrom"}],"output":{"name":"rangefrom"}}],[11,"fmt","","",12,{"inputs":[{"name":"rangefrom"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",13,{"inputs":[{"name":"rangeto"},{"name":"rangeto"}],"output":{"name":"bool"}}],[11,"ne","","",13,{"inputs":[{"name":"rangeto"},{"name":"rangeto"}],"output":{"name":"bool"}}],[11,"clone","","",13,{"inputs":[{"name":"rangeto"}],"output":{"name":"rangeto"}}],[11,"fmt","","",13,{"inputs":[{"name":"rangeto"},{"name":"formatter"}],"output":{"name":"result"}}],[0,"cmp","core","Functionality for ordering and comparison.",null,null],[4,"Ordering","core::cmp","An `Ordering` is the result of a comparison between two values.",null,null],[13,"Less","","An ordering where a compared value is less [than another].",40,null],[13,"Equal","","An ordering where a compared value is equal [to another].",40,null],[13,"Greater","","An ordering where a compared value is greater [than another].",40,null],[5,"min","","Compare and return the minimum of two values.",null,{"inputs":[{"name":"t"},{"name":"t"}],"output":{"name":"t"}}],[5,"max","","Compare and return the maximum of two values.",null,{"inputs":[{"name":"t"},{"name":"t"}],"output":{"name":"t"}}],[5,"partial_min","","Compare and return the minimum of two values if there is one.",null,{"inputs":[{"name":"t"},{"name":"t"}],"output":{"name":"option"}}],[5,"partial_max","","Compare and return the maximum of two values if there is one.",null,{"inputs":[{"name":"t"},{"name":"t"}],"output":{"name":"option"}}],[8,"PartialEq","","Trait for equality comparisons which are [partial equivalence\nrelations](http://en.wikipedia.org/wiki/Partial_equivalence_relation).",null,null],[10,"eq","","This method tests for `self` and `other` values to be equal, and is used\nby `==`.",41,{"inputs":[{"name":"partialeq"},{"name":"rhs"}],"output":{"name":"bool"}}],[11,"ne","","This method tests for `!=`.",41,{"inputs":[{"name":"partialeq"},{"name":"rhs"}],"output":{"name":"bool"}}],[8,"Eq","","Trait for equality comparisons which are [equivalence relations](\nhttps://en.wikipedia.org/wiki/Equivalence_relation).",null,null],[8,"Ord","","Trait for types that form a [total order](https://en.wikipedia.org/wiki/Total_order).",null,null],[10,"cmp","","This method returns an `Ordering` between `self` and `other`.",42,{"inputs":[{"name":"ord"},{"name":"self"}],"output":{"name":"ordering"}}],[8,"PartialOrd","","Trait for values that can be compared for a sort-order.",null,null],[10,"partial_cmp","","This method returns an ordering between `self` and `other` values if one exists.",43,{"inputs":[{"name":"partialord"},{"name":"rhs"}],"output":{"name":"option"}}],[11,"lt","","This method tests less than (for `self` and `other`) and is used by the `<` operator.",43,{"inputs":[{"name":"partialord"},{"name":"rhs"}],"output":{"name":"bool"}}],[11,"le","","This method tests less than or equal to (for `self` and `other`) and is used by the `<=`\noperator.",43,{"inputs":[{"name":"partialord"},{"name":"rhs"}],"output":{"name":"bool"}}],[11,"gt","","This method tests greater than (for `self` and `other`) and is used by the `>` operator.",43,{"inputs":[{"name":"partialord"},{"name":"rhs"}],"output":{"name":"bool"}}],[11,"ge","","This method tests greater than or equal to (for `self` and `other`) and is used by the `>=`\noperator.",43,{"inputs":[{"name":"partialord"},{"name":"rhs"}],"output":{"name":"bool"}}],[11,"fmt","","",40,{"inputs":[{"name":"ordering"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",40,{"inputs":[{"name":"ordering"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"ne","","",40,{"inputs":[{"name":"ordering"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"clone","","",40,{"inputs":[{"name":"ordering"}],"output":{"name":"ordering"}}],[11,"reverse","","Reverse the `Ordering`.",40,{"inputs":[{"name":"ordering"}],"output":{"name":"ordering"}}],[11,"cmp","","",40,{"inputs":[{"name":"ordering"},{"name":"ordering"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",40,{"inputs":[{"name":"ordering"},{"name":"ordering"}],"output":{"name":"option"}}],[0,"clone","core","The `Clone` trait for types that cannot be 'implicitly copied'",null,null],[8,"Clone","core::clone","A common trait for cloning an object.",null,null],[10,"clone","","Returns a copy of the value.",44,{"inputs":[{"name":"clone"}],"output":{"name":"self"}}],[11,"clone_from","","Performs copy-assignment from `source`.",44,{"inputs":[{"name":"clone"},{"name":"self"}],"output":null}],[0,"default","core","The `Default` trait for types which may have meaningful default values.",null,null],[8,"Default","core::default","A trait that types which have a useful default value should implement.",null,null],[10,"default","","Returns the \"default value\" for a type.",45,{"inputs":[{"name":"default"}],"output":{"name":"self"}}],[0,"convert","core","Traits for conversions between types.",null,null],[8,"AsRef","core::convert","A cheap, reference-to-reference conversion.",null,null],[10,"as_ref","","Performs the conversion.",46,{"inputs":[{"name":"asref"}],"output":{"name":"t"}}],[8,"AsMut","","A cheap, mutable reference-to-mutable reference conversion.",null,null],[10,"as_mut","","Performs the conversion.",47,{"inputs":[{"name":"asmut"}],"output":{"name":"t"}}],[8,"Into","","A conversion that consumes `self`, which may or may not be expensive.",null,null],[10,"into","","Performs the conversion.",48,{"inputs":[{"name":"into"}],"output":{"name":"t"}}],[8,"From","","Construct `Self` via a conversion.",null,null],[10,"from","","Performs the conversion.",49,{"inputs":[{"name":"from"},{"name":"t"}],"output":{"name":"self"}}],[0,"any","core","This module implements the `Any` trait, which enables dynamic typing\nof any `'static` type through runtime reflection.",null,null],[3,"TypeId","core::any","A `TypeId` represents a globally unique identifier for a type.",null,null],[8,"Any","","A type to emulate dynamic typing.",null,null],[10,"get_type_id","","Gets the `TypeId` of `self`.",50,{"inputs":[{"name":"any"}],"output":{"name":"typeid"}}],[11,"fmt","core","",50,{"inputs":[{"name":"any"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",50,{"inputs":[{"name":"any"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"is","","Returns true if the boxed type is the same as `T`",50,{"inputs":[{"name":"any"}],"output":{"name":"bool"}}],[11,"downcast_ref","","Returns some reference to the boxed value if it is of type `T`, or\n`None` if it isn't.",50,{"inputs":[{"name":"any"}],"output":{"name":"option"}}],[11,"downcast_mut","","Returns some mutable reference to the boxed value if it is of type `T`, or\n`None` if it isn't.",50,{"inputs":[{"name":"any"}],"output":{"name":"option"}}],[11,"is","","Forwards to the method defined on the type `Any`.",50,{"inputs":[{"name":"any"}],"output":{"name":"bool"}}],[11,"downcast_ref","","Forwards to the method defined on the type `Any`.",50,{"inputs":[{"name":"any"}],"output":{"name":"option"}}],[11,"downcast_mut","","Forwards to the method defined on the type `Any`.",50,{"inputs":[{"name":"any"}],"output":{"name":"option"}}],[11,"hash","core::any","",51,null],[11,"fmt","","",51,{"inputs":[{"name":"typeid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",51,{"inputs":[{"name":"typeid"},{"name":"typeid"}],"output":{"name":"bool"}}],[11,"ne","","",51,{"inputs":[{"name":"typeid"},{"name":"typeid"}],"output":{"name":"bool"}}],[11,"clone","","",51,{"inputs":[{"name":"typeid"}],"output":{"name":"typeid"}}],[11,"of","","Returns the `TypeId` of the type this generic function has been\ninstantiated with",51,{"inputs":[{"name":"typeid"}],"output":{"name":"typeid"}}],[0,"array","core","Implementations of things like `Eq` for fixed-length arrays\nup to a certain length. Eventually we should able to generalize\nto all lengths.",null,null],[8,"FixedSizeArray","core::array","Utility trait implemented only on arrays of fixed size",null,null],[10,"as_slice","","Converts the array to immutable slice",52,null],[10,"as_mut_slice","","Converts the array to mutable slice",52,null],[0,"atomic","core","Atomic types",null,null],[3,"AtomicBool","core::atomic","A boolean type which can be safely shared between threads.",null,null],[3,"AtomicIsize","","A signed integer type which can be safely shared between threads.",null,null],[3,"AtomicUsize","","An unsigned integer type which can be safely shared between threads.",null,null],[3,"AtomicPtr","","A raw pointer type which can be safely shared between threads.",null,null],[4,"Ordering","","Atomic memory orderings",null,null],[13,"Relaxed","","No ordering constraints, only atomic operations.",53,null],[13,"Release","","When coupled with a store, all previous writes become visible\nto another thread that performs a load with `Acquire` ordering\non the same value.",53,null],[13,"Acquire","","When coupled with a load, all subsequent loads will see data\nwritten before a store with `Release` ordering on the same value\nin another thread.",53,null],[13,"AcqRel","","When coupled with a load, uses `Acquire` ordering, and with a store\n`Release` ordering.",53,null],[13,"SeqCst","","Like `AcqRel` with the additional guarantee that all threads see all\nsequentially consistent operations in the same order.",53,null],[5,"fence","","An atomic fence.",null,{"inputs":[{"name":"ordering"}],"output":null}],[17,"ATOMIC_BOOL_INIT","","An `AtomicBool` initialized to `false`.",null,null],[17,"ATOMIC_ISIZE_INIT","","An `AtomicIsize` initialized to `0`.",null,null],[17,"ATOMIC_USIZE_INIT","","An `AtomicUsize` initialized to `0`.",null,null],[11,"default","","",54,{"inputs":[{"name":"atomicbool"}],"output":{"name":"self"}}],[11,"default","","",55,{"inputs":[{"name":"atomicisize"}],"output":{"name":"self"}}],[11,"default","","",56,{"inputs":[{"name":"atomicusize"}],"output":{"name":"self"}}],[11,"default","","",57,{"inputs":[{"name":"atomicptr"}],"output":{"name":"atomicptr"}}],[11,"clone","","",53,{"inputs":[{"name":"ordering"}],"output":{"name":"ordering"}}],[11,"new","","Creates a new `AtomicBool`.",54,{"inputs":[{"name":"atomicbool"},{"name":"bool"}],"output":{"name":"atomicbool"}}],[11,"load","","Loads a value from the bool.",54,{"inputs":[{"name":"atomicbool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"store","","Stores a value into the bool.",54,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"ordering"}],"output":null}],[11,"swap","","Stores a value into the bool, returning the old value.",54,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"compare_and_swap","","Stores a value into the `bool` if the current value is the same as the `current` value.",54,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"fetch_and","","Logical \"and\" with a boolean value.",54,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"fetch_nand","","Logical \"nand\" with a boolean value.",54,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"fetch_or","","Logical \"or\" with a boolean value.",54,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"fetch_xor","","Logical \"xor\" with a boolean value.",54,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"new","","Creates a new `AtomicIsize`.",55,{"inputs":[{"name":"atomicisize"},{"name":"isize"}],"output":{"name":"atomicisize"}}],[11,"load","","Loads a value from the isize.",55,{"inputs":[{"name":"atomicisize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"store","","Stores a value into the isize.",55,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":null}],[11,"swap","","Stores a value into the isize, returning the old value.",55,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"compare_and_swap","","Stores a value into the `isize` if the current value is the same as the `current` value.",55,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"fetch_add","","Add an isize to the current value, returning the previous value.",55,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"fetch_sub","","Subtract an isize from the current value, returning the previous value.",55,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"fetch_and","","Bitwise and with the current isize, returning the previous value.",55,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"fetch_or","","Bitwise or with the current isize, returning the previous value.",55,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"fetch_xor","","Bitwise xor with the current isize, returning the previous value.",55,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"new","","Creates a new `AtomicUsize`.",56,{"inputs":[{"name":"atomicusize"},{"name":"usize"}],"output":{"name":"atomicusize"}}],[11,"load","","Loads a value from the usize.",56,{"inputs":[{"name":"atomicusize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"store","","Stores a value into the usize.",56,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":null}],[11,"swap","","Stores a value into the usize, returning the old value.",56,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"compare_and_swap","","Stores a value into the `usize` if the current value is the same as the `current` value.",56,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"fetch_add","","Add to the current usize, returning the previous value.",56,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"fetch_sub","","Subtract from the current usize, returning the previous value.",56,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"fetch_and","","Bitwise and with the current usize, returning the previous value.",56,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"fetch_or","","Bitwise or with the current usize, returning the previous value.",56,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"fetch_xor","","Bitwise xor with the current usize, returning the previous value.",56,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"new","","Creates a new `AtomicPtr`.",57,null],[11,"load","","Loads a value from the pointer.",57,null],[11,"store","","Stores a value into the pointer.",57,null],[11,"swap","","Stores a value into the pointer, returning the old value.",57,null],[11,"compare_and_swap","","Stores a value into the pointer if the current value is the same as the `current` value.",57,null],[11,"fmt","","",56,{"inputs":[{"name":"atomicusize"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",55,{"inputs":[{"name":"atomicisize"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",54,{"inputs":[{"name":"atomicbool"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",57,{"inputs":[{"name":"atomicptr"},{"name":"formatter"}],"output":{"name":"result"}}],[0,"cell","core","Shareable mutable containers.",null,null],[3,"Cell","core::cell","A mutable memory location that admits only `Copy` data.",null,null],[3,"RefCell","","A mutable memory location with dynamically checked borrow rules",null,null],[3,"Ref","","Wraps a borrowed reference to a value in a `RefCell` box.\nA wrapper type for an immutably borrowed value from a `RefCell<T>`.",null,null],[3,"RefMut","","A wrapper type for a mutably borrowed value from a `RefCell<T>`.",null,null],[3,"UnsafeCell","","The core primitive for interior mutability in Rust.",null,null],[12,"value","","Wrapped value",58,null],[4,"BorrowState","","An enumeration of values returned from the `state` method on a `RefCell<T>`.",null,null],[13,"Reading","","The cell is currently being read, there is at least one active `borrow`.",59,null],[13,"Writing","","The cell is currently being written to, there is an active `borrow_mut`.",59,null],[13,"Unused","","There are no outstanding borrows on this cell.",59,null],[5,"clone_ref","","Copies a `Ref`.",null,{"inputs":[{"name":"ref"}],"output":{"name":"ref"}}],[11,"new","","Creates a new `Cell` containing the given value.",60,{"inputs":[{"name":"cell"},{"name":"t"}],"output":{"name":"cell"}}],[11,"get","","Returns a copy of the contained value.",60,{"inputs":[{"name":"cell"}],"output":{"name":"t"}}],[11,"set","","Sets the contained value.",60,{"inputs":[{"name":"cell"},{"name":"t"}],"output":null}],[11,"as_unsafe_cell","","Returns a reference to the underlying `UnsafeCell`.",60,{"inputs":[{"name":"cell"}],"output":{"name":"unsafecell"}}],[11,"clone","","",60,{"inputs":[{"name":"cell"}],"output":{"name":"cell"}}],[11,"default","","",60,{"inputs":[{"name":"cell"}],"output":{"name":"cell"}}],[11,"eq","","",60,{"inputs":[{"name":"cell"},{"name":"cell"}],"output":{"name":"bool"}}],[11,"fmt","","",59,{"inputs":[{"name":"borrowstate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",59,{"inputs":[{"name":"borrowstate"},{"name":"borrowstate"}],"output":{"name":"bool"}}],[11,"ne","","",59,{"inputs":[{"name":"borrowstate"},{"name":"borrowstate"}],"output":{"name":"bool"}}],[11,"clone","","",59,{"inputs":[{"name":"borrowstate"}],"output":{"name":"borrowstate"}}],[11,"new","","Creates a new `RefCell` containing `value`.",61,{"inputs":[{"name":"refcell"},{"name":"t"}],"output":{"name":"refcell"}}],[11,"into_inner","","Consumes the `RefCell`, returning the wrapped value.",61,{"inputs":[{"name":"refcell"}],"output":{"name":"t"}}],[11,"borrow_state","","Query the current state of this `RefCell`",61,{"inputs":[{"name":"refcell"}],"output":{"name":"borrowstate"}}],[11,"borrow","","Immutably borrows the wrapped value.",61,{"inputs":[{"name":"refcell"}],"output":{"name":"ref"}}],[11,"borrow_mut","","Mutably borrows the wrapped value.",61,{"inputs":[{"name":"refcell"}],"output":{"name":"refmut"}}],[11,"as_unsafe_cell","","Returns a reference to the underlying `UnsafeCell`.",61,{"inputs":[{"name":"refcell"}],"output":{"name":"unsafecell"}}],[11,"clone","","",61,{"inputs":[{"name":"refcell"}],"output":{"name":"refcell"}}],[11,"default","","",61,{"inputs":[{"name":"refcell"}],"output":{"name":"refcell"}}],[11,"eq","","",61,{"inputs":[{"name":"refcell"},{"name":"refcell"}],"output":{"name":"bool"}}],[11,"deref","","",62,{"inputs":[{"name":"ref"}],"output":{"name":"t"}}],[11,"clone","","Copies a `Ref`.",62,{"inputs":[{"name":"ref"},{"name":"ref"}],"output":{"name":"ref"}}],[11,"map","","Make a new `Ref` for a component of the borrowed data.",62,{"inputs":[{"name":"ref"},{"name":"ref"},{"name":"f"}],"output":{"name":"ref"}}],[11,"filter_map","","Make a new `Ref` for a optional component of the borrowed data, e.g. an\nenum variant.",62,{"inputs":[{"name":"ref"},{"name":"ref"},{"name":"f"}],"output":{"name":"option"}}],[11,"map","","Make a new `RefMut` for a component of the borrowed data, e.g. an enum\nvariant.",63,{"inputs":[{"name":"refmut"},{"name":"refmut"},{"name":"f"}],"output":{"name":"refmut"}}],[11,"filter_map","","Make a new `RefMut` for a optional component of the borrowed data, e.g.\nan enum variant.",63,{"inputs":[{"name":"refmut"},{"name":"refmut"},{"name":"f"}],"output":{"name":"option"}}],[11,"deref","","",63,{"inputs":[{"name":"refmut"}],"output":{"name":"t"}}],[11,"deref_mut","","",63,{"inputs":[{"name":"refmut"}],"output":{"name":"t"}}],[11,"new","","Constructs a new instance of `UnsafeCell` which will wrap the specified\nvalue.",58,{"inputs":[{"name":"unsafecell"},{"name":"t"}],"output":{"name":"unsafecell"}}],[11,"into_inner","","Unwraps the value.",58,{"inputs":[{"name":"unsafecell"}],"output":{"name":"t"}}],[11,"get","","Gets a mutable pointer to the wrapped value.",58,null],[0,"char","core","Character manipulation.",null,null],[3,"EscapeUnicode","core::char","An iterator over the characters that represent a `char`, as escaped by\nRust's unicode escaping rules.",null,null],[3,"EscapeDefault","","An iterator over the characters that represent a `char`, escaped\nfor maximum portability.",null,null],[5,"from_u32","","Converts a `u32` to an `Option<char>`.",null,{"inputs":[{"name":"u32"}],"output":{"name":"option"}}],[5,"from_u32_unchecked","","Converts a `u32` to an `char`, not checking whether it is a valid unicode\ncodepoint.",null,{"inputs":[{"name":"u32"}],"output":{"name":"char"}}],[5,"from_digit","","Converts a number to the character representing it.",null,{"inputs":[{"name":"u32"},{"name":"u32"}],"output":{"name":"option"}}],[17,"MAX","","The highest valid code point",null,null],[11,"clone","","",64,{"inputs":[{"name":"escapeunicode"}],"output":{"name":"escapeunicode"}}],[11,"next","","",64,{"inputs":[{"name":"escapeunicode"}],"output":{"name":"option"}}],[11,"clone","","",65,{"inputs":[{"name":"escapedefault"}],"output":{"name":"escapedefault"}}],[11,"next","","",65,{"inputs":[{"name":"escapedefault"}],"output":{"name":"option"}}],[0,"panicking","core","Panic support for libcore",null,null],[5,"panic","core::panicking","",null,null],[5,"panic_fmt","","",null,null],[0,"iter","core","Composable external iterators",null,null],[3,"Rev","core::iter","An double-ended iterator with the direction inverted",null,null],[3,"Cloned","","An iterator that clones the elements of an underlying iterator",null,null],[3,"Cycle","","An iterator that repeats endlessly",null,null],[3,"Chain","","An iterator that strings two iterators together",null,null],[3,"Zip","","An iterator that iterates two other iterators simultaneously",null,null],[3,"Map","","An iterator that maps the values of `iter` with `f`",null,null],[3,"Filter","","An iterator that filters the elements of `iter` with `predicate`",null,null],[3,"FilterMap","","An iterator that uses `f` to both filter and map elements from `iter`",null,null],[3,"Enumerate","","An iterator that yields the current count and the element during iteration",null,null],[3,"Peekable","","An iterator with a `peek()` that returns an optional reference to the next element.",null,null],[3,"SkipWhile","","An iterator that rejects elements while `predicate` is true",null,null],[3,"TakeWhile","","An iterator that only accepts elements while `predicate` is true",null,null],[3,"Skip","","An iterator that skips over `n` elements of `iter`.",null,null],[3,"Take","","An iterator that only iterates over the first `n` iterations of `iter`.",null,null],[3,"Scan","","An iterator to maintain state while iterating another iterator",null,null],[12,"state","","The current internal state to be passed to the closure next.",66,null],[3,"FlatMap","","An iterator that maps each element to an iterator,\nand yields the elements of the produced iterators",null,null],[3,"Fuse","","An iterator that yields `None` forever after the underlying iterator\nyields `None` once.",null,null],[3,"Inspect","","An iterator that calls a function with a reference to each\nelement before yielding it.",null,null],[3,"Unfold","","An iterator that passes mutable state to a closure and yields the result.",null,null],[12,"state","","Internal state that will be passed to the closure on the next iteration",67,null],[3,"StepBy","","An adapter for stepping range iterators by a custom amount.",null,null],[3,"RangeInclusive","","An iterator over the range [start, stop]",null,null],[3,"Repeat","","An iterator that repeats an element endlessly",null,null],[3,"Empty","","An iterator that yields nothing.",null,null],[3,"Once","","An iterator that yields an element exactly once.",null,null],[4,"MinMaxResult","","`MinMaxResult` is an enum returned by `min_max`. See `Iterator::min_max` for\nmore detail.",null,null],[13,"NoElements","","Empty iterator",68,null],[13,"OneElement","","Iterator with one element, so the minimum and maximum are the same",68,null],[13,"MinMax","","More than one element in the iterator, the first element is not larger\nthan the second",68,null],[5,"range_inclusive","","Returns an iterator over the range [start, stop].",null,{"inputs":[{"name":"a"},{"name":"a"}],"output":{"name":"rangeinclusive"}}],[5,"iterate","","Creates a new iterator that produces an infinite sequence of\nrepeated applications of the given function `f`.",null,{"inputs":[{"name":"t"},{"name":"f"}],"output":{"name":"iterate"}}],[5,"repeat","","Creates a new iterator that endlessly repeats the element `elt`.",null,{"inputs":[{"name":"t"}],"output":{"name":"repeat"}}],[5,"empty","","Creates an iterator that yields nothing.",null,{"inputs":[],"output":{"name":"empty"}}],[5,"once","","Creates an iterator that yields an element exactly once.",null,{"inputs":[{"name":"t"}],"output":{"name":"once"}}],[0,"order","","Functions for lexicographical ordering of sequences.",null,null],[5,"equals","core::iter::order","Compare `a` and `b` for equality using `Eq`",null,{"inputs":[{"name":"l"},{"name":"r"}],"output":{"name":"bool"}}],[5,"cmp","","Order `a` and `b` lexicographically using `Ord`",null,{"inputs":[{"name":"l"},{"name":"r"}],"output":{"name":"ordering"}}],[5,"partial_cmp","","Order `a` and `b` lexicographically using `PartialOrd`",null,{"inputs":[{"name":"l"},{"name":"r"}],"output":{"name":"option"}}],[5,"eq","","Compare `a` and `b` for equality (Using partial equality, `PartialEq`)",null,{"inputs":[{"name":"l"},{"name":"r"}],"output":{"name":"bool"}}],[5,"ne","","Compares `a` and `b` for nonequality (Using partial equality, `PartialEq`)",null,{"inputs":[{"name":"l"},{"name":"r"}],"output":{"name":"bool"}}],[5,"lt","","Returns `a` < `b` lexicographically (Using partial order, `PartialOrd`)",null,{"inputs":[{"name":"l"},{"name":"r"}],"output":{"name":"bool"}}],[5,"le","","Returns `a` <= `b` lexicographically (Using partial order, `PartialOrd`)",null,{"inputs":[{"name":"l"},{"name":"r"}],"output":{"name":"bool"}}],[5,"gt","","Returns `a` > `b` lexicographically (Using partial order, `PartialOrd`)",null,{"inputs":[{"name":"l"},{"name":"r"}],"output":{"name":"bool"}}],[5,"ge","","Returns `a` >= `b` lexicographically (Using partial order, `PartialOrd`)",null,{"inputs":[{"name":"l"},{"name":"r"}],"output":{"name":"bool"}}],[6,"Iterate","core::iter","An iterator that repeatedly applies a given function, starting\nfrom a given seed value.",null,null],[8,"Iterator","","An interface for dealing with \"external iterators\". These types of iterators\ncan be resumed at any time as all state is stored internally as opposed to\nbeing located on the call stack.",null,null],[16,"Item","","The type of the elements being iterated",69,null],[10,"next","","Advances the iterator and returns the next value. Returns `None` when the\nend is reached.",69,{"inputs":[{"name":"iterator"}],"output":{"name":"option"}}],[11,"size_hint","","Returns a lower and upper bound on the remaining length of the iterator.",69,null],[11,"count","","Counts the number of elements in this iterator.",69,{"inputs":[{"name":"iterator"}],"output":{"name":"usize"}}],[11,"last","","Loops through the entire iterator, returning the last element.",69,{"inputs":[{"name":"iterator"}],"output":{"name":"option"}}],[11,"nth","","Loops through `n` iterations, returning the `n`th element of the\niterator.",69,{"inputs":[{"name":"iterator"},{"name":"usize"}],"output":{"name":"option"}}],[11,"chain","","Chain this iterator with another, returning a new iterator that will\nfinish iterating over the current iterator, and then iterate\nover the other specified iterator.",69,{"inputs":[{"name":"iterator"},{"name":"u"}],"output":{"name":"chain"}}],[11,"zip","","Creates an iterator that iterates over both this and the specified\niterators simultaneously, yielding the two elements as pairs. When\neither iterator returns `None`, all further invocations of `next()`\nwill return `None`.",69,{"inputs":[{"name":"iterator"},{"name":"u"}],"output":{"name":"zip"}}],[11,"map","","Creates a new iterator that will apply the specified function to each\nelement returned by the first, yielding the mapped element instead.",69,{"inputs":[{"name":"iterator"},{"name":"f"}],"output":{"name":"map"}}],[11,"filter","","Creates an iterator that applies the predicate to each element returned\nby this iterator. The only elements that will be yielded are those that\nmake the predicate evaluate to `true`.",69,{"inputs":[{"name":"iterator"},{"name":"p"}],"output":{"name":"filter"}}],[11,"filter_map","","Creates an iterator that both filters and maps elements.\nIf the specified function returns `None`, the element is skipped.\nOtherwise the option is unwrapped and the new value is yielded.",69,{"inputs":[{"name":"iterator"},{"name":"f"}],"output":{"name":"filtermap"}}],[11,"enumerate","","Creates an iterator that yields pairs `(i, val)` where `i` is the\ncurrent index of iteration and `val` is the value returned by the\niterator.",69,{"inputs":[{"name":"iterator"}],"output":{"name":"enumerate"}}],[11,"peekable","","Creates an iterator that has a `.peek()` method\nthat returns an optional reference to the next element.",69,{"inputs":[{"name":"iterator"}],"output":{"name":"peekable"}}],[11,"skip_while","","Creates an iterator that invokes the predicate on elements\nuntil it returns false. Once the predicate returns false, that\nelement and all further elements are yielded.",69,{"inputs":[{"name":"iterator"},{"name":"p"}],"output":{"name":"skipwhile"}}],[11,"take_while","","Creates an iterator that yields elements so long as the predicate\nreturns true. After the predicate returns false for the first time, no\nfurther elements will be yielded.",69,{"inputs":[{"name":"iterator"},{"name":"p"}],"output":{"name":"takewhile"}}],[11,"skip","","Creates an iterator that skips the first `n` elements of this iterator,\nand then yields all further items.",69,{"inputs":[{"name":"iterator"},{"name":"usize"}],"output":{"name":"skip"}}],[11,"take","","Creates an iterator that yields the first `n` elements of this\niterator.",69,{"inputs":[{"name":"iterator"},{"name":"usize"}],"output":{"name":"take"}}],[11,"scan","","Creates a new iterator that behaves in a similar fashion to fold.\nThere is a state which is passed between each iteration and can be\nmutated as necessary. The yielded values from the closure are yielded\nfrom the Scan instance when not `None`.",69,{"inputs":[{"name":"iterator"},{"name":"st"},{"name":"f"}],"output":{"name":"scan"}}],[11,"flat_map","","Takes a function that maps each element to a new iterator and yields\nall the elements of the produced iterators.",69,{"inputs":[{"name":"iterator"},{"name":"f"}],"output":{"name":"flatmap"}}],[11,"fuse","","Creates an iterator that yields `None` forever after the underlying\niterator yields `None`. Random-access iterator behavior is not\naffected, only single and double-ended iterator behavior.",69,{"inputs":[{"name":"iterator"}],"output":{"name":"fuse"}}],[11,"inspect","","Creates an iterator that calls a function with a reference to each\nelement before yielding it. This is often useful for debugging an\niterator pipeline.",69,{"inputs":[{"name":"iterator"},{"name":"f"}],"output":{"name":"inspect"}}],[11,"by_ref","","Creates a wrapper around a mutable reference to the iterator.",69,{"inputs":[{"name":"iterator"}],"output":{"name":"self"}}],[11,"collect","","Loops through the entire iterator, collecting all of the elements into\na container implementing `FromIterator`.",69,{"inputs":[{"name":"iterator"}],"output":{"name":"b"}}],[11,"partition","","Loops through the entire iterator, collecting all of the elements into\none of two containers, depending on a predicate. The elements of the\nfirst container satisfy the predicate, while the elements of the second\ndo not.",69,null],[11,"fold","","Performs a fold operation over the entire iterator, returning the\neventual state at the end of the iteration.",69,{"inputs":[{"name":"iterator"},{"name":"b"},{"name":"f"}],"output":{"name":"b"}}],[11,"all","","Tests whether the predicate holds true for all elements in the iterator.",69,{"inputs":[{"name":"iterator"},{"name":"f"}],"output":{"name":"bool"}}],[11,"any","","Tests whether any element of an iterator satisfies the specified\npredicate.",69,{"inputs":[{"name":"iterator"},{"name":"f"}],"output":{"name":"bool"}}],[11,"find","","Returns the first element satisfying the specified predicate.",69,{"inputs":[{"name":"iterator"},{"name":"p"}],"output":{"name":"option"}}],[11,"position","","Returns the index of the first element satisfying the specified predicate",69,{"inputs":[{"name":"iterator"},{"name":"p"}],"output":{"name":"option"}}],[11,"rposition","","Returns the index of the last element satisfying the specified predicate",69,{"inputs":[{"name":"iterator"},{"name":"p"}],"output":{"name":"option"}}],[11,"max","","Consumes the entire iterator to return the maximum element.",69,{"inputs":[{"name":"iterator"}],"output":{"name":"option"}}],[11,"min","","Consumes the entire iterator to return the minimum element.",69,{"inputs":[{"name":"iterator"}],"output":{"name":"option"}}],[11,"min_max","","`min_max` finds the minimum and maximum elements in the iterator.",69,{"inputs":[{"name":"iterator"}],"output":{"name":"minmaxresult"}}],[11,"max_by","","Returns the element that gives the maximum value from the\nspecified function.",69,{"inputs":[{"name":"iterator"},{"name":"f"}],"output":{"name":"option"}}],[11,"min_by","","Returns the element that gives the minimum value from the\nspecified function.",69,{"inputs":[{"name":"iterator"},{"name":"f"}],"output":{"name":"option"}}],[11,"rev","","Change the direction of the iterator",69,{"inputs":[{"name":"iterator"}],"output":{"name":"rev"}}],[11,"unzip","","Converts an iterator of pairs into a pair of containers.",69,null],[11,"cloned","","Creates an iterator that clones the elements it yields.",69,{"inputs":[{"name":"iterator"}],"output":{"name":"cloned"}}],[11,"cycle","","Repeats an iterator endlessly",69,{"inputs":[{"name":"iterator"}],"output":{"name":"cycle"}}],[11,"reverse_in_place","","Use an iterator to reverse a container in place.",69,{"inputs":[{"name":"iterator"}],"output":null}],[11,"sum","","Iterates over the entire iterator, summing up all the elements",69,{"inputs":[{"name":"iterator"}],"output":{"name":"s"}}],[11,"product","","Iterates over the entire iterator, multiplying all the elements",69,{"inputs":[{"name":"iterator"}],"output":{"name":"p"}}],[8,"FromIterator","","Conversion from an `Iterator`",null,null],[10,"from_iter","","Builds a container with elements from something iterable.",70,{"inputs":[{"name":"fromiterator"},{"name":"t"}],"output":{"name":"self"}}],[8,"IntoIterator","","Conversion into an `Iterator`",null,null],[16,"Item","","The type of the elements being iterated",71,null],[16,"IntoIter","","A container for iterating over elements of type `Item`",71,null],[10,"into_iter","","Consumes `Self` and returns an iterator over it",71,{"inputs":[{"name":"intoiterator"}],"output":{"name":"intoiter"}}],[8,"Extend","","A type growable from an `Iterator` implementation",null,null],[10,"extend","","Extends a container with the elements yielded by an arbitrary iterator",72,{"inputs":[{"name":"extend"},{"name":"t"}],"output":null}],[8,"DoubleEndedIterator","","A range iterator able to yield elements from both ends",null,null],[10,"next_back","","Yields an element from the end of the range, returning `None` if the\nrange is empty.",73,{"inputs":[{"name":"doubleendediterator"}],"output":{"name":"option"}}],[8,"RandomAccessIterator","","An object implementing random access indexing by `usize`",null,null],[10,"indexable","","Returns the number of indexable elements. At most `std::usize::MAX`\nelements are indexable, even if the iterator represents a longer range.",74,{"inputs":[{"name":"randomaccessiterator"}],"output":{"name":"usize"}}],[10,"idx","","Returns an element at an index, or `None` if the index is out of bounds",74,{"inputs":[{"name":"randomaccessiterator"},{"name":"usize"}],"output":{"name":"option"}}],[8,"ExactSizeIterator","","An iterator that knows its exact length",null,null],[11,"len","","Returns the exact length of the iterator.",75,{"inputs":[{"name":"exactsizeiterator"}],"output":{"name":"usize"}}],[8,"Step","","Objects that can be stepped over in both directions.",null,null],[10,"step","","Steps `self` if possible.",76,{"inputs":[{"name":"step"},{"name":"self"}],"output":{"name":"option"}}],[10,"steps_between","","Returns the number of steps between two step objects. The count is\ninclusive of `start` and exclusive of `end`.",76,{"inputs":[{"name":"step"},{"name":"self"},{"name":"self"},{"name":"self"}],"output":{"name":"option"}}],[11,"clone","","",77,{"inputs":[{"name":"rev"}],"output":{"name":"rev"}}],[11,"next","","",77,{"inputs":[{"name":"rev"}],"output":{"name":"option"}}],[11,"size_hint","","",77,null],[11,"next_back","","",77,{"inputs":[{"name":"rev"}],"output":{"name":"option"}}],[11,"indexable","","",77,{"inputs":[{"name":"rev"}],"output":{"name":"usize"}}],[11,"idx","","",77,{"inputs":[{"name":"rev"},{"name":"usize"}],"output":{"name":"option"}}],[11,"fmt","","",68,{"inputs":[{"name":"minmaxresult"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",68,{"inputs":[{"name":"minmaxresult"},{"name":"minmaxresult"}],"output":{"name":"bool"}}],[11,"ne","","",68,{"inputs":[{"name":"minmaxresult"},{"name":"minmaxresult"}],"output":{"name":"bool"}}],[11,"clone","","",68,{"inputs":[{"name":"minmaxresult"}],"output":{"name":"minmaxresult"}}],[11,"into_option","","`into_option` creates an `Option` of type `(T,T)`. The returned `Option`\nhas variant `None` if and only if the `MinMaxResult` has variant\n`NoElements`. Otherwise variant `Some(x,y)` is returned where `x <= y`.\nIf `MinMaxResult` has variant `OneElement(x)`, performing this operation\nwill make one clone of `x`.",68,{"inputs":[{"name":"minmaxresult"}],"output":{"name":"option"}}],[11,"clone","","",78,{"inputs":[{"name":"cloned"}],"output":{"name":"cloned"}}],[11,"next","","",78,{"inputs":[{"name":"cloned"}],"output":{"name":"option"}}],[11,"size_hint","","",78,null],[11,"next_back","","",78,{"inputs":[{"name":"cloned"}],"output":{"name":"option"}}],[11,"indexable","","",78,{"inputs":[{"name":"cloned"}],"output":{"name":"usize"}}],[11,"idx","","",78,{"inputs":[{"name":"cloned"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",79,{"inputs":[{"name":"cycle"}],"output":{"name":"cycle"}}],[11,"next","","",79,{"inputs":[{"name":"cycle"}],"output":{"name":"option"}}],[11,"size_hint","","",79,null],[11,"indexable","","",79,{"inputs":[{"name":"cycle"}],"output":{"name":"usize"}}],[11,"idx","","",79,{"inputs":[{"name":"cycle"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",80,{"inputs":[{"name":"chain"}],"output":{"name":"chain"}}],[11,"next","","",80,{"inputs":[{"name":"chain"}],"output":{"name":"option"}}],[11,"count","","",80,{"inputs":[{"name":"chain"}],"output":{"name":"usize"}}],[11,"nth","","",80,{"inputs":[{"name":"chain"},{"name":"usize"}],"output":{"name":"option"}}],[11,"last","","",80,{"inputs":[{"name":"chain"}],"output":{"name":"option"}}],[11,"size_hint","","",80,null],[11,"next_back","","",80,{"inputs":[{"name":"chain"}],"output":{"name":"option"}}],[11,"indexable","","",80,{"inputs":[{"name":"chain"}],"output":{"name":"usize"}}],[11,"idx","","",80,{"inputs":[{"name":"chain"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",81,{"inputs":[{"name":"zip"}],"output":{"name":"zip"}}],[11,"next","","",81,{"inputs":[{"name":"zip"}],"output":{"name":"option"}}],[11,"size_hint","","",81,null],[11,"next_back","","",81,{"inputs":[{"name":"zip"}],"output":{"name":"option"}}],[11,"indexable","","",81,{"inputs":[{"name":"zip"}],"output":{"name":"usize"}}],[11,"idx","","",81,{"inputs":[{"name":"zip"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",82,{"inputs":[{"name":"map"}],"output":{"name":"map"}}],[11,"next","","",82,{"inputs":[{"name":"map"}],"output":{"name":"option"}}],[11,"size_hint","","",82,null],[11,"next_back","","",82,{"inputs":[{"name":"map"}],"output":{"name":"option"}}],[11,"indexable","","",82,{"inputs":[{"name":"map"}],"output":{"name":"usize"}}],[11,"idx","","",82,{"inputs":[{"name":"map"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",83,{"inputs":[{"name":"filter"}],"output":{"name":"filter"}}],[11,"next","","",83,{"inputs":[{"name":"filter"}],"output":{"name":"option"}}],[11,"size_hint","","",83,null],[11,"next_back","","",83,{"inputs":[{"name":"filter"}],"output":{"name":"option"}}],[11,"clone","","",84,{"inputs":[{"name":"filtermap"}],"output":{"name":"filtermap"}}],[11,"next","","",84,{"inputs":[{"name":"filtermap"}],"output":{"name":"option"}}],[11,"size_hint","","",84,null],[11,"next_back","","",84,{"inputs":[{"name":"filtermap"}],"output":{"name":"option"}}],[11,"clone","","",85,{"inputs":[{"name":"enumerate"}],"output":{"name":"enumerate"}}],[11,"next","","# Overflow Behavior",85,{"inputs":[{"name":"enumerate"}],"output":{"name":"option"}}],[11,"size_hint","","",85,null],[11,"nth","","",85,{"inputs":[{"name":"enumerate"},{"name":"usize"}],"output":{"name":"option"}}],[11,"count","","",85,{"inputs":[{"name":"enumerate"}],"output":{"name":"usize"}}],[11,"next_back","","",85,{"inputs":[{"name":"enumerate"}],"output":{"name":"option"}}],[11,"indexable","","",85,{"inputs":[{"name":"enumerate"}],"output":{"name":"usize"}}],[11,"idx","","",85,{"inputs":[{"name":"enumerate"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",86,{"inputs":[{"name":"peekable"}],"output":{"name":"peekable"}}],[11,"next","","",86,{"inputs":[{"name":"peekable"}],"output":{"name":"option"}}],[11,"count","","",86,{"inputs":[{"name":"peekable"}],"output":{"name":"usize"}}],[11,"nth","","",86,{"inputs":[{"name":"peekable"},{"name":"usize"}],"output":{"name":"option"}}],[11,"last","","",86,{"inputs":[{"name":"peekable"}],"output":{"name":"option"}}],[11,"size_hint","","",86,null],[11,"peek","","Returns a reference to the next element of the iterator with out\nadvancing it, or None if the iterator is exhausted.",86,{"inputs":[{"name":"peekable"}],"output":{"name":"option"}}],[11,"is_empty","","Checks whether peekable iterator is empty or not.",86,{"inputs":[{"name":"peekable"}],"output":{"name":"bool"}}],[11,"clone","","",87,{"inputs":[{"name":"skipwhile"}],"output":{"name":"skipwhile"}}],[11,"next","","",87,{"inputs":[{"name":"skipwhile"}],"output":{"name":"option"}}],[11,"size_hint","","",87,null],[11,"clone","","",88,{"inputs":[{"name":"takewhile"}],"output":{"name":"takewhile"}}],[11,"next","","",88,{"inputs":[{"name":"takewhile"}],"output":{"name":"option"}}],[11,"size_hint","","",88,null],[11,"clone","","",89,{"inputs":[{"name":"skip"}],"output":{"name":"skip"}}],[11,"next","","",89,{"inputs":[{"name":"skip"}],"output":{"name":"option"}}],[11,"nth","","",89,{"inputs":[{"name":"skip"},{"name":"usize"}],"output":{"name":"option"}}],[11,"count","","",89,{"inputs":[{"name":"skip"}],"output":{"name":"usize"}}],[11,"last","","",89,{"inputs":[{"name":"skip"}],"output":{"name":"option"}}],[11,"size_hint","","",89,null],[11,"indexable","","",89,{"inputs":[{"name":"skip"}],"output":{"name":"usize"}}],[11,"idx","","",89,{"inputs":[{"name":"skip"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",90,{"inputs":[{"name":"take"}],"output":{"name":"take"}}],[11,"next","","",90,{"inputs":[{"name":"take"}],"output":{"name":"option"}}],[11,"nth","","",90,{"inputs":[{"name":"take"},{"name":"usize"}],"output":{"name":"option"}}],[11,"size_hint","","",90,null],[11,"indexable","","",90,{"inputs":[{"name":"take"}],"output":{"name":"usize"}}],[11,"idx","","",90,{"inputs":[{"name":"take"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",66,{"inputs":[{"name":"scan"}],"output":{"name":"scan"}}],[11,"next","","",66,{"inputs":[{"name":"scan"}],"output":{"name":"option"}}],[11,"size_hint","","",66,null],[11,"clone","","",91,{"inputs":[{"name":"flatmap"}],"output":{"name":"flatmap"}}],[11,"next","","",91,{"inputs":[{"name":"flatmap"}],"output":{"name":"option"}}],[11,"size_hint","","",91,null],[11,"next_back","","",91,{"inputs":[{"name":"flatmap"}],"output":{"name":"option"}}],[11,"clone","","",92,{"inputs":[{"name":"fuse"}],"output":{"name":"fuse"}}],[11,"next","","",92,{"inputs":[{"name":"fuse"}],"output":{"name":"option"}}],[11,"nth","","",92,{"inputs":[{"name":"fuse"},{"name":"usize"}],"output":{"name":"option"}}],[11,"last","","",92,{"inputs":[{"name":"fuse"}],"output":{"name":"option"}}],[11,"count","","",92,{"inputs":[{"name":"fuse"}],"output":{"name":"usize"}}],[11,"size_hint","","",92,null],[11,"next_back","","",92,{"inputs":[{"name":"fuse"}],"output":{"name":"option"}}],[11,"indexable","","",92,{"inputs":[{"name":"fuse"}],"output":{"name":"usize"}}],[11,"idx","","",92,{"inputs":[{"name":"fuse"},{"name":"usize"}],"output":{"name":"option"}}],[11,"reset_fuse","","Resets the `Fuse` such that the next call to `.next()` or\n`.next_back()` will call the underlying iterator again even if it\npreviously returned `None`.",92,{"inputs":[{"name":"fuse"}],"output":null}],[11,"clone","","",93,{"inputs":[{"name":"inspect"}],"output":{"name":"inspect"}}],[11,"next","","",93,{"inputs":[{"name":"inspect"}],"output":{"name":"option"}}],[11,"size_hint","","",93,null],[11,"next_back","","",93,{"inputs":[{"name":"inspect"}],"output":{"name":"option"}}],[11,"indexable","","",93,{"inputs":[{"name":"inspect"}],"output":{"name":"usize"}}],[11,"idx","","",93,{"inputs":[{"name":"inspect"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",67,{"inputs":[{"name":"unfold"}],"output":{"name":"unfold"}}],[11,"new","","Creates a new iterator with the specified closure as the \"iterator\nfunction\" and an initial state to eventually pass to the closure",67,{"inputs":[{"name":"unfold"},{"name":"st"},{"name":"f"}],"output":{"name":"unfold"}}],[11,"next","","",67,{"inputs":[{"name":"unfold"}],"output":{"name":"option"}}],[11,"size_hint","","",67,null],[11,"clone","","",94,{"inputs":[{"name":"stepby"}],"output":{"name":"stepby"}}],[11,"step_by","core::ops","Creates an iterator starting at the same point, but stepping by\nthe given amount at each iteration.",12,{"inputs":[{"name":"rangefrom"},{"name":"a"}],"output":{"name":"stepby"}}],[11,"step_by","","Creates an iterator with the same range, but stepping by the\ngiven amount at each iteration.",11,{"inputs":[{"name":"range"},{"name":"a"}],"output":{"name":"stepby"}}],[11,"next","core::iter","",94,{"inputs":[{"name":"stepby"}],"output":{"name":"option"}}],[11,"size_hint","","",94,null],[11,"clone","","",95,{"inputs":[{"name":"rangeinclusive"}],"output":{"name":"rangeinclusive"}}],[11,"next","","",95,{"inputs":[{"name":"rangeinclusive"}],"output":{"name":"option"}}],[11,"size_hint","","",95,null],[11,"next_back","","",95,{"inputs":[{"name":"rangeinclusive"}],"output":{"name":"option"}}],[11,"next","","",94,{"inputs":[{"name":"stepby"}],"output":{"name":"option"}}],[11,"size_hint","","",94,null],[11,"next","core::ops","",11,{"inputs":[{"name":"range"}],"output":{"name":"option"}}],[11,"size_hint","","",11,null],[11,"next_back","","",11,{"inputs":[{"name":"range"}],"output":{"name":"option"}}],[11,"next","","",12,{"inputs":[{"name":"rangefrom"}],"output":{"name":"option"}}],[11,"clone","core::iter","",96,{"inputs":[{"name":"repeat"}],"output":{"name":"repeat"}}],[11,"next","","",96,{"inputs":[{"name":"repeat"}],"output":{"name":"option"}}],[11,"size_hint","","",96,null],[11,"next_back","","",96,{"inputs":[{"name":"repeat"}],"output":{"name":"option"}}],[11,"indexable","","",96,{"inputs":[{"name":"repeat"}],"output":{"name":"usize"}}],[11,"idx","","",96,{"inputs":[{"name":"repeat"},{"name":"usize"}],"output":{"name":"option"}}],[11,"next","","",97,{"inputs":[{"name":"empty"}],"output":{"name":"option"}}],[11,"size_hint","","",97,null],[11,"next_back","","",97,{"inputs":[{"name":"empty"}],"output":{"name":"option"}}],[11,"len","","",97,{"inputs":[{"name":"empty"}],"output":{"name":"usize"}}],[11,"clone","","",97,{"inputs":[{"name":"empty"}],"output":{"name":"empty"}}],[11,"default","","",97,{"inputs":[{"name":"empty"}],"output":{"name":"empty"}}],[11,"clone","","",98,{"inputs":[{"name":"once"}],"output":{"name":"once"}}],[11,"next","","",98,{"inputs":[{"name":"once"}],"output":{"name":"option"}}],[11,"size_hint","","",98,null],[11,"next_back","","",98,{"inputs":[{"name":"once"}],"output":{"name":"option"}}],[11,"len","","",98,{"inputs":[{"name":"once"}],"output":{"name":"usize"}}],[0,"option","core","Optional values",null,null],[3,"Iter","core::option","An iterator over a reference of the contained item in an Option.",null,null],[3,"IterMut","","An iterator over a mutable reference of the contained item in an Option.",null,null],[3,"IntoIter","","An iterator over the item contained inside an Option.",null,null],[4,"Option","","The `Option` type. See [the module level documentation](index.html) for more.",null,null],[13,"None","","No value",99,null],[13,"Some","","Some value `T`",99,null],[11,"hash","","",99,null],[11,"fmt","","",99,{"inputs":[{"name":"option"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"cmp","","",99,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",99,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"option"}}],[11,"lt","","",99,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"le","","",99,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"gt","","",99,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"ge","","",99,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"eq","","",99,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"ne","","",99,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"clone","","",99,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[11,"is_some","","Returns `true` if the option is a `Some` value",99,{"inputs":[{"name":"option"}],"output":{"name":"bool"}}],[11,"is_none","","Returns `true` if the option is a `None` value",99,{"inputs":[{"name":"option"}],"output":{"name":"bool"}}],[11,"as_ref","","Converts from `Option<T>` to `Option<&T>`",99,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[11,"as_mut","","Converts from `Option<T>` to `Option<&mut T>`",99,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[11,"as_mut_slice","","Converts from `Option<T>` to `&mut [T]` (without copying)",99,null],[11,"expect","","Unwraps an option, yielding the content of a `Some`",99,{"inputs":[{"name":"option"},{"name":"str"}],"output":{"name":"t"}}],[11,"unwrap","","Moves the value `v` out of the `Option<T>` if it is `Some(v)`.",99,{"inputs":[{"name":"option"}],"output":{"name":"t"}}],[11,"unwrap_or","","Returns the contained value or a default.",99,{"inputs":[{"name":"option"},{"name":"t"}],"output":{"name":"t"}}],[11,"unwrap_or_else","","Returns the contained value or computes it from a closure.",99,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"t"}}],[11,"map","","Maps an `Option<T>` to `Option<U>` by applying a function to a contained value",99,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"option"}}],[11,"map_or","","Applies a function to the contained value (if any),\nor returns a `default` (if not).",99,{"inputs":[{"name":"option"},{"name":"u"},{"name":"f"}],"output":{"name":"u"}}],[11,"map_or_else","","Applies a function to the contained value (if any),\nor computes a `default` (if not).",99,{"inputs":[{"name":"option"},{"name":"d"},{"name":"f"}],"output":{"name":"u"}}],[11,"ok_or","","Transforms the `Option<T>` into a `Result<T, E>`, mapping `Some(v)` to\n`Ok(v)` and `None` to `Err(err)`.",99,{"inputs":[{"name":"option"},{"name":"e"}],"output":{"name":"result"}}],[11,"ok_or_else","","Transforms the `Option<T>` into a `Result<T, E>`, mapping `Some(v)` to\n`Ok(v)` and `None` to `Err(err())`.",99,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"result"}}],[11,"iter","","Returns an iterator over the possibly contained value.",99,{"inputs":[{"name":"option"}],"output":{"name":"iter"}}],[11,"iter_mut","","Returns a mutable iterator over the possibly contained value.",99,{"inputs":[{"name":"option"}],"output":{"name":"itermut"}}],[11,"and","","Returns `None` if the option is `None`, otherwise returns `optb`.",99,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"option"}}],[11,"and_then","","Returns `None` if the option is `None`, otherwise calls `f` with the\nwrapped value and returns the result.",99,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"option"}}],[11,"or","","Returns the option if it contains a value, otherwise returns `optb`.",99,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"option"}}],[11,"or_else","","Returns the option if it contains a value, otherwise calls `f` and\nreturns the result.",99,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"option"}}],[11,"take","","Takes the value out of the option, leaving a `None` in its place.",99,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[11,"as_slice","","Converts from `Option<T>` to `&[T]` (without copying)",99,null],[11,"cloned","","Maps an Option<&T> to an Option<T> by cloning the contents of the Option.",99,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[11,"unwrap_or_default","","Returns the contained value or a default",99,{"inputs":[{"name":"option"}],"output":{"name":"t"}}],[11,"default","","",99,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[11,"into_iter","","Returns a consuming iterator over the possibly contained value.",99,{"inputs":[{"name":"option"}],"output":{"name":"intoiter"}}],[11,"next","","",100,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",100,null],[11,"next_back","","",100,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"clone","","",100,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[11,"next","","",101,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"size_hint","","",101,null],[11,"next_back","","",101,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"clone","","",102,{"inputs":[{"name":"intoiter"}],"output":{"name":"intoiter"}}],[11,"next","","",102,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",102,null],[11,"next_back","","",102,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"from_iter","","Takes each element in the `Iterator`: if it is `None`, no further\nelements are taken, and the `None` is returned. Should no `None` occur, a\ncontainer with the values of each `Option` is returned.",99,{"inputs":[{"name":"option"},{"name":"i"}],"output":{"name":"option"}}],[0,"raw","core","Contains struct definitions for the layout of compiler built-in types.",null,null],[3,"Slice","core::raw","The representation of a slice like `&[T]`.",null,null],[12,"data","","",103,null],[12,"len","","",103,null],[3,"TraitObject","","The representation of a trait object like `&SomeTrait`.",null,null],[12,"data","","",104,null],[12,"vtable","","",104,null],[8,"Repr","","This trait is meant to map equivalences between raw structs and their\ncorresponding rust values.",null,null],[11,"repr","","This function \"unwraps\" a rust value (without consuming it) into its raw\nstruct representation. This can be used to read/write different values\nfor the struct. This is a safe method because by default it does not\nenable write-access to the fields of the return value in safe code.",105,{"inputs":[{"name":"repr"}],"output":{"name":"t"}}],[11,"clone","","",103,{"inputs":[{"name":"slice"}],"output":{"name":"slice"}}],[11,"clone","","",104,{"inputs":[{"name":"traitobject"}],"output":{"name":"traitobject"}}],[0,"result","core","Error handling with the `Result` type",null,null],[3,"Iter","core::result","An iterator over a reference to the `Ok` variant of a `Result`.",null,null],[3,"IterMut","","An iterator over a mutable reference to the `Ok` variant of a `Result`.",null,null],[3,"IntoIter","","An iterator over the value in a `Ok` variant of a `Result`.",null,null],[4,"Result","","`Result` is a type that represents either success (`Ok`) or failure (`Err`).",null,null],[13,"Ok","","Contains the success value",106,null],[13,"Err","","Contains the error value",106,null],[5,"fold","","Performs a fold operation over the result values from an iterator.",null,{"inputs":[{"name":"iter"},{"name":"v"},{"name":"f"}],"output":{"name":"result"}}],[11,"hash","","",106,null],[11,"fmt","","",106,{"inputs":[{"name":"result"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"cmp","","",106,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",106,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"option"}}],[11,"lt","","",106,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"le","","",106,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"gt","","",106,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"ge","","",106,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"eq","","",106,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"ne","","",106,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"clone","","",106,{"inputs":[{"name":"result"}],"output":{"name":"result"}}],[11,"is_ok","","Returns true if the result is `Ok`",106,{"inputs":[{"name":"result"}],"output":{"name":"bool"}}],[11,"is_err","","Returns true if the result is `Err`",106,{"inputs":[{"name":"result"}],"output":{"name":"bool"}}],[11,"ok","","Converts from `Result<T, E>` to `Option<T>`",106,{"inputs":[{"name":"result"}],"output":{"name":"option"}}],[11,"err","","Converts from `Result<T, E>` to `Option<E>`",106,{"inputs":[{"name":"result"}],"output":{"name":"option"}}],[11,"as_ref","","Converts from `Result<T, E>` to `Result<&T, &E>`",106,{"inputs":[{"name":"result"}],"output":{"name":"result"}}],[11,"as_mut","","Converts from `Result<T, E>` to `Result<&mut T, &mut E>`",106,{"inputs":[{"name":"result"}],"output":{"name":"result"}}],[11,"as_slice","","Converts from `Result<T, E>` to `&[T]` (without copying)",106,null],[11,"as_mut_slice","","Converts from `Result<T, E>` to `&mut [T]` (without copying)",106,null],[11,"map","","Maps a `Result<T, E>` to `Result<U, E>` by applying a function to an\ncontained `Ok` value, leaving an `Err` value untouched.",106,{"inputs":[{"name":"result"},{"name":"f"}],"output":{"name":"result"}}],[11,"map_err","","Maps a `Result<T, E>` to `Result<T, F>` by applying a function to an\ncontained `Err` value, leaving an `Ok` value untouched.",106,{"inputs":[{"name":"result"},{"name":"o"}],"output":{"name":"result"}}],[11,"iter","","Returns an iterator over the possibly contained value.",106,{"inputs":[{"name":"result"}],"output":{"name":"iter"}}],[11,"iter_mut","","Returns a mutable iterator over the possibly contained value.",106,{"inputs":[{"name":"result"}],"output":{"name":"itermut"}}],[11,"and","","Returns `res` if the result is `Ok`, otherwise returns the `Err` value of `self`.",106,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"result"}}],[11,"and_then","","Calls `op` if the result is `Ok`, otherwise returns the `Err` value of `self`.",106,{"inputs":[{"name":"result"},{"name":"f"}],"output":{"name":"result"}}],[11,"or","","Returns `res` if the result is `Err`, otherwise returns the `Ok` value of `self`.",106,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"result"}}],[11,"or_else","","Calls `op` if the result is `Err`, otherwise returns the `Ok` value of `self`.",106,{"inputs":[{"name":"result"},{"name":"o"}],"output":{"name":"result"}}],[11,"unwrap_or","","Unwraps a result, yielding the content of an `Ok`.\nElse it returns `optb`.",106,{"inputs":[{"name":"result"},{"name":"t"}],"output":{"name":"t"}}],[11,"unwrap_or_else","","Unwraps a result, yielding the content of an `Ok`.\nIf the value is an `Err` then it calls `op` with its value.",106,{"inputs":[{"name":"result"},{"name":"f"}],"output":{"name":"t"}}],[11,"unwrap","","Unwraps a result, yielding the content of an `Ok`.",106,{"inputs":[{"name":"result"}],"output":{"name":"t"}}],[11,"expect","","Unwraps a result, yielding the content of an `Ok`.",106,{"inputs":[{"name":"result"},{"name":"str"}],"output":{"name":"t"}}],[11,"unwrap_err","","Unwraps a result, yielding the content of an `Err`.",106,{"inputs":[{"name":"result"}],"output":{"name":"e"}}],[11,"into_iter","","Returns a consuming iterator over the possibly contained value.",106,{"inputs":[{"name":"result"}],"output":{"name":"intoiter"}}],[11,"next","","",107,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",107,null],[11,"next_back","","",107,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"clone","","",107,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[11,"next","","",108,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"size_hint","","",108,null],[11,"next_back","","",108,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"next","","",109,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",109,null],[11,"next_back","","",109,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"from_iter","","Takes each element in the `Iterator`: if it is an `Err`, no further\nelements are taken, and the `Err` is returned. Should no `Err` occur, a\ncontainer with the values of each `Result` is returned.",106,{"inputs":[{"name":"result"},{"name":"i"}],"output":{"name":"result"}}],[0,"simd","core","SIMD vectors.",null,null],[3,"i8x16","core::simd","",null,null],[3,"i16x8","","",null,null],[3,"i32x4","","",null,null],[3,"i64x2","","",null,null],[3,"u8x16","","",null,null],[3,"u16x8","","",null,null],[3,"u32x4","","",null,null],[3,"u64x2","","",null,null],[3,"f32x4","","",null,null],[3,"f64x2","","",null,null],[11,"fmt","","",110,{"inputs":[{"name":"i8x16"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",110,{"inputs":[{"name":"i8x16"}],"output":{"name":"i8x16"}}],[11,"fmt","","",111,{"inputs":[{"name":"i16x8"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",111,{"inputs":[{"name":"i16x8"}],"output":{"name":"i16x8"}}],[11,"fmt","","",112,{"inputs":[{"name":"i32x4"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",112,{"inputs":[{"name":"i32x4"}],"output":{"name":"i32x4"}}],[11,"fmt","","",113,{"inputs":[{"name":"i64x2"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",113,{"inputs":[{"name":"i64x2"}],"output":{"name":"i64x2"}}],[11,"fmt","","",114,{"inputs":[{"name":"u8x16"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",114,{"inputs":[{"name":"u8x16"}],"output":{"name":"u8x16"}}],[11,"fmt","","",115,{"inputs":[{"name":"u16x8"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",115,{"inputs":[{"name":"u16x8"}],"output":{"name":"u16x8"}}],[11,"fmt","","",116,{"inputs":[{"name":"u32x4"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",116,{"inputs":[{"name":"u32x4"}],"output":{"name":"u32x4"}}],[11,"fmt","","",117,{"inputs":[{"name":"u64x2"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",117,{"inputs":[{"name":"u64x2"}],"output":{"name":"u64x2"}}],[11,"fmt","","",118,{"inputs":[{"name":"f32x4"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",118,{"inputs":[{"name":"f32x4"}],"output":{"name":"f32x4"}}],[11,"fmt","","",119,{"inputs":[{"name":"f64x2"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",119,{"inputs":[{"name":"f64x2"}],"output":{"name":"f64x2"}}],[0,"slice","core","Slice management and manipulation",null,null],[3,"Iter","core::slice","Immutable slice iterator",null,null],[3,"IterMut","","Mutable slice iterator.",null,null],[3,"Split","","An iterator over subslices separated by elements that match a predicate\nfunction.",null,null],[3,"SplitMut","","An iterator over the subslices of the vector which are separated\nby elements that match `pred`.",null,null],[3,"SplitN","","An iterator over subslices separated by elements that match a predicate\nfunction, limited to a given number of splits.",null,null],[3,"RSplitN","","An iterator over subslices separated by elements that match a\npredicate function, limited to a given number of splits, starting\nfrom the end of the slice.",null,null],[3,"SplitNMut","","An iterator over subslices separated by elements that match a predicate\nfunction, limited to a given number of splits.",null,null],[3,"RSplitNMut","","An iterator over subslices separated by elements that match a\npredicate function, limited to a given number of splits, starting\nfrom the end of the slice.",null,null],[3,"Windows","","An iterator over overlapping subslices of length `size`.",null,null],[3,"Chunks","","An iterator over a slice in (non-overlapping) chunks (`size` elements at a\ntime).",null,null],[3,"ChunksMut","","An iterator over a slice in (non-overlapping) mutable chunks (`size`\nelements at a time). When the slice len is not evenly divided by the chunk\nsize, the last slice of the iteration will be the remainder.",null,null],[5,"ref_slice","","Converts a pointer to A into a slice of length 1 (without copying).",null,null],[5,"mut_ref_slice","","Converts a pointer to A into a slice of length 1 (without copying).",null,null],[5,"from_raw_parts","","Forms a slice from a pointer and a length.",null,null],[5,"from_raw_parts_mut","","Performs the same functionality as `from_raw_parts`, except that a mutable\nslice is returned.",null,null],[0,"bytes","","Operations on `[u8]`.",null,null],[5,"copy_memory","core::slice::bytes","Copies data from `src` to `dst`",null,null],[8,"MutableByteVector","","A trait for operations on mutable `[u8]`s.",null,null],[10,"set_memory","","Sets all bytes of the receiver to the given value.",120,{"inputs":[{"name":"mutablebytevector"},{"name":"u8"}],"output":null}],[8,"IntSliceExt","core::slice","Extension methods for slices containing integers.",null,null],[10,"as_unsigned","","Converts the slice to an immutable slice of unsigned integers with the same width.",121,null],[10,"as_signed","","Converts the slice to an immutable slice of signed integers with the same width.",121,null],[10,"as_unsigned_mut","","Converts the slice to a mutable slice of unsigned integers with the same width.",121,null],[10,"as_signed_mut","","Converts the slice to a mutable slice of signed integers with the same width.",121,null],[11,"as_slice","","View the underlying data as a subslice of the original data.",122,null],[11,"next","","",122,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",122,null],[11,"count","","",122,{"inputs":[{"name":"iter"}],"output":{"name":"usize"}}],[11,"nth","","",122,{"inputs":[{"name":"iter"},{"name":"usize"}],"output":{"name":"option"}}],[11,"last","","",122,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"next_back","","",122,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"clone","","",122,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[11,"indexable","","",122,{"inputs":[{"name":"iter"}],"output":{"name":"usize"}}],[11,"idx","","",122,{"inputs":[{"name":"iter"},{"name":"usize"}],"output":{"name":"option"}}],[11,"into_slice","","View the underlying data as a subslice of the original data.",123,null],[11,"next","","",123,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"size_hint","","",123,null],[11,"count","","",123,{"inputs":[{"name":"itermut"}],"output":{"name":"usize"}}],[11,"nth","","",123,{"inputs":[{"name":"itermut"},{"name":"usize"}],"output":{"name":"option"}}],[11,"last","","",123,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"next_back","","",123,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"clone","","",124,{"inputs":[{"name":"split"}],"output":{"name":"split"}}],[11,"next","","",124,{"inputs":[{"name":"split"}],"output":{"name":"option"}}],[11,"size_hint","","",124,null],[11,"next_back","","",124,{"inputs":[{"name":"split"}],"output":{"name":"option"}}],[11,"next","","",125,{"inputs":[{"name":"splitmut"}],"output":{"name":"option"}}],[11,"size_hint","","",125,null],[11,"next_back","","",125,{"inputs":[{"name":"splitmut"}],"output":{"name":"option"}}],[11,"next","","",126,{"inputs":[{"name":"splitn"}],"output":{"name":"option"}}],[11,"size_hint","","",126,null],[11,"next","","",127,{"inputs":[{"name":"rsplitn"}],"output":{"name":"option"}}],[11,"size_hint","","",127,null],[11,"next","","",128,{"inputs":[{"name":"splitnmut"}],"output":{"name":"option"}}],[11,"size_hint","","",128,null],[11,"next","","",129,{"inputs":[{"name":"rsplitnmut"}],"output":{"name":"option"}}],[11,"size_hint","","",129,null],[11,"clone","","",130,{"inputs":[{"name":"windows"}],"output":{"name":"windows"}}],[11,"next","","",130,{"inputs":[{"name":"windows"}],"output":{"name":"option"}}],[11,"size_hint","","",130,null],[11,"next_back","","",130,{"inputs":[{"name":"windows"}],"output":{"name":"option"}}],[11,"indexable","","",130,{"inputs":[{"name":"windows"}],"output":{"name":"usize"}}],[11,"idx","","",130,{"inputs":[{"name":"windows"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",131,{"inputs":[{"name":"chunks"}],"output":{"name":"chunks"}}],[11,"next","","",131,{"inputs":[{"name":"chunks"}],"output":{"name":"option"}}],[11,"size_hint","","",131,null],[11,"next_back","","",131,{"inputs":[{"name":"chunks"}],"output":{"name":"option"}}],[11,"indexable","","",131,{"inputs":[{"name":"chunks"}],"output":{"name":"usize"}}],[11,"idx","","",131,{"inputs":[{"name":"chunks"},{"name":"usize"}],"output":{"name":"option"}}],[11,"next","","",132,{"inputs":[{"name":"chunksmut"}],"output":{"name":"option"}}],[11,"size_hint","","",132,null],[11,"next_back","","",132,{"inputs":[{"name":"chunksmut"}],"output":{"name":"option"}}],[0,"str","core","String manipulation",null,null],[3,"ParseBoolError","core::str","An error returned when parsing a `bool` from a string fails.",null,null],[3,"Utf8Error","","Errors which can occur when attempting to interpret a byte slice as a `str`.",null,null],[3,"Chars","","Iterator for the char (representing *Unicode Scalar Values*) of a string",null,null],[3,"CharIndices","","Iterator for a string's characters and their byte offsets.",null,null],[3,"Bytes","","External iterator for a string's bytes.\nUse with the `std::iter` module.",null,null],[3,"Split","","Created with the method `.split()`.",null,null],[3,"RSplit","","Created with the method `.rsplit()`.",null,null],[3,"SplitTerminator","","Created with the method `.split_terminator()`.",null,null],[3,"RSplitTerminator","","Created with the method `.rsplit_terminator()`.",null,null],[3,"SplitN","","Created with the method `.splitn()`.",null,null],[3,"RSplitN","","Created with the method `.rsplitn()`.",null,null],[3,"MatchIndices","","Created with the method `.match_indices()`.",null,null],[3,"RMatchIndices","","Created with the method `.rmatch_indices()`.",null,null],[3,"Matches","","Created with the method `.matches()`.",null,null],[3,"RMatches","","Created with the method `.rmatches()`.",null,null],[3,"Lines","","Created with the method `.lines()`.",null,null],[3,"LinesAny","","Created with the method `.lines_any()`.",null,null],[3,"CharRange","","Struct that contains a `char` and the index of the first byte of\nthe next `char` in a string.  This can be used as a data structure\nfor iterating over the UTF-8 bytes of a string.",null,null],[12,"ch","","Current `char`",133,null],[12,"next","","Index of the first byte of the next `char`",133,null],[5,"from_utf8","","Converts a slice of bytes to a string slice without performing any\nallocations.",null,null],[5,"from_utf8_unchecked","","Converts a slice of bytes to a string slice without checking\nthat the string contains valid UTF-8.",null,null],[5,"next_code_point","","Reads the next code point out of a byte iterator (assuming a\nUTF-8-like encoding).",null,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[0,"pattern","","The string Pattern API.",null,null],[3,"CharSearcher","core::str::pattern","Associated type for `<char as Pattern<'a>>::Searcher`.",null,null],[3,"CharSliceSearcher","","Associated type for `<&[char] as Pattern<'a>>::Searcher`.",null,null],[3,"CharPredicateSearcher","","Associated type for `<F as Pattern<'a>>::Searcher`.",null,null],[3,"StrSearcher","","Associated type for `<&str as Pattern<'a>>::Searcher`.",null,null],[4,"SearchStep","","Result of calling `Searcher::next()` or `ReverseSearcher::next_back()`.",null,null],[13,"Match","","Expresses that a match of the pattern has been found at\n`haystack[a..b]`.",134,null],[13,"Reject","","Expresses that `haystack[a..b]` has been rejected as a possible match\nof the pattern.",134,null],[13,"Done","","Expresses that every byte of the haystack has been visted, ending\nthe iteration.",134,null],[8,"Pattern","","A string pattern.",null,null],[16,"Searcher","","Associated searcher for this pattern",135,null],[10,"into_searcher","","Constructs the associated searcher from\n`self` and the `haystack` to search in.",135,{"inputs":[{"name":"pattern"},{"name":"str"}],"output":{"name":"searcher"}}],[11,"is_contained_in","","Checks whether the pattern matches anywhere in the haystack",135,{"inputs":[{"name":"pattern"},{"name":"str"}],"output":{"name":"bool"}}],[11,"is_prefix_of","","Checks whether the pattern matches at the front of the haystack",135,{"inputs":[{"name":"pattern"},{"name":"str"}],"output":{"name":"bool"}}],[11,"is_suffix_of","","Checks whether the pattern matches at the back of the haystack",135,{"inputs":[{"name":"pattern"},{"name":"str"}],"output":{"name":"bool"}}],[8,"Searcher","","A searcher for a string pattern.",null,null],[10,"haystack","","Getter for the underlaying string to be searched in",136,{"inputs":[{"name":"searcher"}],"output":{"name":"str"}}],[10,"next","","Performs the next search step starting from the front.",136,{"inputs":[{"name":"searcher"}],"output":{"name":"searchstep"}}],[11,"next_match","","Find the next `Match` result. See `next()`",136,{"inputs":[{"name":"searcher"}],"output":{"name":"option"}}],[11,"next_reject","","Find the next `Reject` result. See `next()`",136,{"inputs":[{"name":"searcher"}],"output":{"name":"option"}}],[8,"ReverseSearcher","","A reverse searcher for a string pattern.",null,null],[10,"next_back","","Performs the next search step starting from the back.",137,{"inputs":[{"name":"reversesearcher"}],"output":{"name":"searchstep"}}],[11,"next_match_back","","Find the next `Match` result. See `next_back()`",137,{"inputs":[{"name":"reversesearcher"}],"output":{"name":"option"}}],[11,"next_reject_back","","Find the next `Reject` result. See `next_back()`",137,{"inputs":[{"name":"reversesearcher"}],"output":{"name":"option"}}],[8,"DoubleEndedSearcher","","A marker trait to express that a `ReverseSearcher`\ncan be used for a `DoubleEndedIterator` implementation.",null,null],[11,"fmt","","",134,{"inputs":[{"name":"searchstep"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",134,{"inputs":[{"name":"searchstep"},{"name":"searchstep"}],"output":{"name":"bool"}}],[11,"ne","","",134,{"inputs":[{"name":"searchstep"},{"name":"searchstep"}],"output":{"name":"bool"}}],[11,"clone","","",134,{"inputs":[{"name":"searchstep"}],"output":{"name":"searchstep"}}],[11,"clone","","",138,{"inputs":[{"name":"charsearcher"}],"output":{"name":"charsearcher"}}],[11,"haystack","","",138,{"inputs":[{"name":"charsearcher"}],"output":{"name":"str"}}],[11,"next","","",138,{"inputs":[{"name":"charsearcher"}],"output":{"name":"searchstep"}}],[11,"next_match","","",138,{"inputs":[{"name":"charsearcher"}],"output":{"name":"option"}}],[11,"next_reject","","",138,{"inputs":[{"name":"charsearcher"}],"output":{"name":"option"}}],[11,"next_back","","",138,{"inputs":[{"name":"charsearcher"}],"output":{"name":"searchstep"}}],[11,"next_match_back","","",138,{"inputs":[{"name":"charsearcher"}],"output":{"name":"option"}}],[11,"next_reject_back","","",138,{"inputs":[{"name":"charsearcher"}],"output":{"name":"option"}}],[11,"clone","","",139,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"charslicesearcher"}}],[11,"haystack","","",139,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"str"}}],[11,"next","","",139,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"searchstep"}}],[11,"next_match","","",139,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"option"}}],[11,"next_reject","","",139,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"option"}}],[11,"next_back","","",139,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"searchstep"}}],[11,"next_match_back","","",139,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"option"}}],[11,"next_reject_back","","",139,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"option"}}],[11,"clone","","",140,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"charpredicatesearcher"}}],[11,"haystack","","",140,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"str"}}],[11,"next","","",140,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"searchstep"}}],[11,"next_match","","",140,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"option"}}],[11,"next_reject","","",140,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"option"}}],[11,"next_back","","",140,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"searchstep"}}],[11,"next_match_back","","",140,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"option"}}],[11,"next_reject_back","","",140,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"option"}}],[11,"fmt","","",141,{"inputs":[{"name":"strsearcher"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",141,{"inputs":[{"name":"strsearcher"}],"output":{"name":"strsearcher"}}],[11,"haystack","","",141,{"inputs":[{"name":"strsearcher"}],"output":{"name":"str"}}],[11,"next","","",141,{"inputs":[{"name":"strsearcher"}],"output":{"name":"searchstep"}}],[11,"next_match","","",141,{"inputs":[{"name":"strsearcher"}],"output":{"name":"option"}}],[11,"next_back","","",141,{"inputs":[{"name":"strsearcher"}],"output":{"name":"searchstep"}}],[11,"next_match_back","","",141,{"inputs":[{"name":"strsearcher"}],"output":{"name":"option"}}],[8,"FromStr","core::str","A trait to abstract the idea of creating a new instance of a type from a\nstring.",null,null],[16,"Err","","The associated error which can be returned from parsing.",142,null],[10,"from_str","","Parses a string `s` to return a value of this type.",142,{"inputs":[{"name":"fromstr"},{"name":"str"}],"output":{"name":"result"}}],[11,"eq","","",143,{"inputs":[{"name":"parseboolerror"},{"name":"parseboolerror"}],"output":{"name":"bool"}}],[11,"ne","","",143,{"inputs":[{"name":"parseboolerror"},{"name":"parseboolerror"}],"output":{"name":"bool"}}],[11,"clone","","",143,{"inputs":[{"name":"parseboolerror"}],"output":{"name":"parseboolerror"}}],[11,"fmt","","",143,{"inputs":[{"name":"parseboolerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",143,{"inputs":[{"name":"parseboolerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",144,{"inputs":[{"name":"utf8error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",144,{"inputs":[{"name":"utf8error"}],"output":{"name":"utf8error"}}],[11,"eq","","",144,{"inputs":[{"name":"utf8error"},{"name":"utf8error"}],"output":{"name":"bool"}}],[11,"ne","","",144,{"inputs":[{"name":"utf8error"},{"name":"utf8error"}],"output":{"name":"bool"}}],[11,"valid_up_to","","Returns the index in the given string up to which valid UTF-8 was\nverified.",144,{"inputs":[{"name":"utf8error"}],"output":{"name":"usize"}}],[11,"fmt","","",144,{"inputs":[{"name":"utf8error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",145,{"inputs":[{"name":"chars"}],"output":{"name":"chars"}}],[11,"next","","",145,{"inputs":[{"name":"chars"}],"output":{"name":"option"}}],[11,"size_hint","","",145,null],[11,"next_back","","",145,{"inputs":[{"name":"chars"}],"output":{"name":"option"}}],[11,"clone","","",146,{"inputs":[{"name":"charindices"}],"output":{"name":"charindices"}}],[11,"next","","",146,{"inputs":[{"name":"charindices"}],"output":{"name":"option"}}],[11,"size_hint","","",146,null],[11,"next_back","","",146,{"inputs":[{"name":"charindices"}],"output":{"name":"option"}}],[11,"clone","","",147,{"inputs":[{"name":"bytes"}],"output":{"name":"bytes"}}],[11,"next","","",147,{"inputs":[{"name":"bytes"}],"output":{"name":"option"}}],[11,"size_hint","","",147,null],[11,"next_back","","",147,{"inputs":[{"name":"bytes"}],"output":{"name":"option"}}],[11,"len","","",147,{"inputs":[{"name":"bytes"}],"output":{"name":"usize"}}],[11,"next","","",148,{"inputs":[{"name":"split"}],"output":{"name":"option"}}],[11,"clone","","",148,{"inputs":[{"name":"split"}],"output":{"name":"self"}}],[11,"next","","",149,{"inputs":[{"name":"rsplit"}],"output":{"name":"option"}}],[11,"clone","","",149,{"inputs":[{"name":"rsplit"}],"output":{"name":"self"}}],[11,"next_back","","",148,{"inputs":[{"name":"split"}],"output":{"name":"option"}}],[11,"next_back","","",149,{"inputs":[{"name":"rsplit"}],"output":{"name":"option"}}],[11,"next","","",150,{"inputs":[{"name":"splitterminator"}],"output":{"name":"option"}}],[11,"clone","","",150,{"inputs":[{"name":"splitterminator"}],"output":{"name":"self"}}],[11,"next","","",151,{"inputs":[{"name":"rsplitterminator"}],"output":{"name":"option"}}],[11,"clone","","",151,{"inputs":[{"name":"rsplitterminator"}],"output":{"name":"self"}}],[11,"next_back","","",150,{"inputs":[{"name":"splitterminator"}],"output":{"name":"option"}}],[11,"next_back","","",151,{"inputs":[{"name":"rsplitterminator"}],"output":{"name":"option"}}],[11,"next","","",152,{"inputs":[{"name":"splitn"}],"output":{"name":"option"}}],[11,"clone","","",152,{"inputs":[{"name":"splitn"}],"output":{"name":"self"}}],[11,"next","","",153,{"inputs":[{"name":"rsplitn"}],"output":{"name":"option"}}],[11,"clone","","",153,{"inputs":[{"name":"rsplitn"}],"output":{"name":"self"}}],[11,"next","","",154,{"inputs":[{"name":"matchindices"}],"output":{"name":"option"}}],[11,"clone","","",154,{"inputs":[{"name":"matchindices"}],"output":{"name":"self"}}],[11,"next","","",155,{"inputs":[{"name":"rmatchindices"}],"output":{"name":"option"}}],[11,"clone","","",155,{"inputs":[{"name":"rmatchindices"}],"output":{"name":"self"}}],[11,"next_back","","",154,{"inputs":[{"name":"matchindices"}],"output":{"name":"option"}}],[11,"next_back","","",155,{"inputs":[{"name":"rmatchindices"}],"output":{"name":"option"}}],[11,"next","","",156,{"inputs":[{"name":"matches"}],"output":{"name":"option"}}],[11,"clone","","",156,{"inputs":[{"name":"matches"}],"output":{"name":"self"}}],[11,"next","","",157,{"inputs":[{"name":"rmatches"}],"output":{"name":"option"}}],[11,"clone","","",157,{"inputs":[{"name":"rmatches"}],"output":{"name":"self"}}],[11,"next_back","","",156,{"inputs":[{"name":"matches"}],"output":{"name":"option"}}],[11,"next_back","","",157,{"inputs":[{"name":"rmatches"}],"output":{"name":"option"}}],[11,"clone","","",158,{"inputs":[{"name":"lines"}],"output":{"name":"lines"}}],[11,"next","","",158,{"inputs":[{"name":"lines"}],"output":{"name":"option"}}],[11,"size_hint","","",158,null],[11,"next_back","","",158,{"inputs":[{"name":"lines"}],"output":{"name":"option"}}],[11,"clone","","",159,{"inputs":[{"name":"linesany"}],"output":{"name":"linesany"}}],[11,"next","","",159,{"inputs":[{"name":"linesany"}],"output":{"name":"option"}}],[11,"size_hint","","",159,null],[11,"next_back","","",159,{"inputs":[{"name":"linesany"}],"output":{"name":"option"}}],[11,"clone","","",133,{"inputs":[{"name":"charrange"}],"output":{"name":"charrange"}}],[0,"hash","core","Generic hashing support.",null,null],[3,"SipHasher","core::hash","An implementation of SipHash 2-4.",null,null],[5,"hash","","Hash a value with the default SipHasher algorithm (two initial keys of 0).",null,{"inputs":[{"name":"t"}],"output":{"name":"u64"}}],[11,"new","","Creates a new `SipHasher` with the two initial keys set to 0.",160,{"inputs":[{"name":"siphasher"}],"output":{"name":"siphasher"}}],[11,"new_with_keys","","Creates a `SipHasher` that is keyed off the provided keys.",160,{"inputs":[{"name":"siphasher"},{"name":"u64"},{"name":"u64"}],"output":{"name":"siphasher"}}],[11,"write","","",160,null],[11,"finish","","",160,{"inputs":[{"name":"siphasher"}],"output":{"name":"u64"}}],[11,"clone","","",160,{"inputs":[{"name":"siphasher"}],"output":{"name":"siphasher"}}],[11,"default","","",160,{"inputs":[{"name":"siphasher"}],"output":{"name":"siphasher"}}],[8,"Hash","","A hashable type.",null,null],[10,"hash","","Feeds this value into the state given, updating the hasher as necessary.",161,{"inputs":[{"name":"hash"},{"name":"h"}],"output":null}],[11,"hash_slice","","Feeds a slice of this type into the state provided.",161,null],[8,"Hasher","","A trait which represents the ability to hash an arbitrary stream of bytes.",null,null],[10,"finish","","Completes a round of hashing, producing the output hash generated.",162,{"inputs":[{"name":"hasher"}],"output":{"name":"u64"}}],[10,"write","","Writes some data into this `Hasher`",162,null],[11,"write_u8","","Write a single `u8` into this hasher",162,{"inputs":[{"name":"hasher"},{"name":"u8"}],"output":null}],[11,"write_u16","","Write a single `u16` into this hasher.",162,{"inputs":[{"name":"hasher"},{"name":"u16"}],"output":null}],[11,"write_u32","","Write a single `u32` into this hasher.",162,{"inputs":[{"name":"hasher"},{"name":"u32"}],"output":null}],[11,"write_u64","","Write a single `u64` into this hasher.",162,{"inputs":[{"name":"hasher"},{"name":"u64"}],"output":null}],[11,"write_usize","","Write a single `usize` into this hasher.",162,{"inputs":[{"name":"hasher"},{"name":"usize"}],"output":null}],[11,"write_i8","","Write a single `i8` into this hasher.",162,{"inputs":[{"name":"hasher"},{"name":"i8"}],"output":null}],[11,"write_i16","","Write a single `i16` into this hasher.",162,{"inputs":[{"name":"hasher"},{"name":"i16"}],"output":null}],[11,"write_i32","","Write a single `i32` into this hasher.",162,{"inputs":[{"name":"hasher"},{"name":"i32"}],"output":null}],[11,"write_i64","","Write a single `i64` into this hasher.",162,{"inputs":[{"name":"hasher"},{"name":"i64"}],"output":null}],[11,"write_isize","","Write a single `isize` into this hasher.",162,{"inputs":[{"name":"hasher"},{"name":"isize"}],"output":null}],[0,"fmt","core","Utilities for formatting and printing strings",null,null],[3,"Radix","core::fmt","A radix with in the range of `2..36`.",null,null],[3,"RadixFmt","","A helper type for formatting radixes.",null,null],[3,"DebugStruct","","A struct to help with `fmt::Debug` implementations.",null,null],[3,"DebugTuple","","A struct to help with `fmt::Debug` implementations.",null,null],[3,"DebugSet","","A struct to help with `fmt::Debug` implementations.",null,null],[3,"DebugList","","A struct to help with `fmt::Debug` implementations.",null,null],[3,"DebugMap","","A struct to help with `fmt::Debug` implementations.",null,null],[3,"Error","","The error type which is returned from formatting a message into a stream.",null,null],[3,"Formatter","","A struct to represent both where to emit formatting strings to and how they\nshould be formatted. A mutable version of this is passed to all formatting\ntraits.",null,null],[3,"Arguments","","This structure represents a safely precompiled version of a format string\nand its arguments. This cannot be generated at runtime because it cannot\nsafely be done so, so no constructors are given and the fields are private\nto prevent modification.",null,null],[5,"radix","","Constructs a radix formatter in the range of `2..36`.",null,{"inputs":[{"name":"t"},{"name":"u8"}],"output":{"name":"radixfmt"}}],[5,"write","","The `write` function takes an output stream, a precompiled format string,\nand a list of arguments. The arguments will be formatted according to the\nspecified format string into the output stream provided.",null,{"inputs":[{"name":"write"},{"name":"arguments"}],"output":{"name":"result"}}],[11,"eq","","",163,{"inputs":[{"name":"radix"},{"name":"radix"}],"output":{"name":"bool"}}],[11,"ne","","",163,{"inputs":[{"name":"radix"},{"name":"radix"}],"output":{"name":"bool"}}],[11,"clone","","",163,{"inputs":[{"name":"radix"}],"output":{"name":"radix"}}],[11,"clone","","",164,{"inputs":[{"name":"radixfmt"}],"output":{"name":"radixfmt"}}],[11,"fmt","","",164,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",164,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",164,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",164,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",164,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",164,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",164,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",164,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",164,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",164,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",164,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",164,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",164,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",164,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",164,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",164,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",164,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",164,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",164,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",164,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"field","","Adds a new field to the generated struct output.",165,{"inputs":[{"name":"debugstruct"},{"name":"str"},{"name":"debug"}],"output":{"name":"debugstruct"}}],[11,"finish","","Finishes output and returns any error encountered.",165,{"inputs":[{"name":"debugstruct"}],"output":{"name":"result"}}],[11,"field","","Adds a new field to the generated tuple struct output.",166,{"inputs":[{"name":"debugtuple"},{"name":"debug"}],"output":{"name":"debugtuple"}}],[11,"finish","","Finishes output and returns any error encountered.",166,{"inputs":[{"name":"debugtuple"}],"output":{"name":"result"}}],[11,"formatter","","Returns the wrapped `Formatter`.",166,{"inputs":[{"name":"debugtuple"}],"output":{"name":"formatter"}}],[11,"entry","","Adds a new entry to the set output.",167,{"inputs":[{"name":"debugset"},{"name":"debug"}],"output":{"name":"debugset"}}],[11,"entries","","Adds the contents of an iterator of entries to the set output.",167,{"inputs":[{"name":"debugset"},{"name":"i"}],"output":{"name":"debugset"}}],[11,"finish","","Finishes output and returns any error encountered.",167,{"inputs":[{"name":"debugset"}],"output":{"name":"result"}}],[11,"entry","","Adds a new entry to the list output.",168,{"inputs":[{"name":"debuglist"},{"name":"debug"}],"output":{"name":"debuglist"}}],[11,"entries","","Adds the contents of an iterator of entries to the list output.",168,{"inputs":[{"name":"debuglist"},{"name":"i"}],"output":{"name":"debuglist"}}],[11,"finish","","Finishes output and returns any error encountered.",168,{"inputs":[{"name":"debuglist"}],"output":{"name":"result"}}],[11,"entry","","Adds a new entry to the map output.",169,{"inputs":[{"name":"debugmap"},{"name":"debug"},{"name":"debug"}],"output":{"name":"debugmap"}}],[11,"entries","","Adds the contents of an iterator of entries to the map output.",169,{"inputs":[{"name":"debugmap"},{"name":"i"}],"output":{"name":"debugmap"}}],[11,"finish","","Finishes output and returns any error encountered.",169,{"inputs":[{"name":"debugmap"}],"output":{"name":"result"}}],[6,"Result","","The type returned by formatter methods.",null,null],[8,"Write","","A collection of methods that are required to format a message into a stream.",null,null],[10,"write_str","","Writes a slice of bytes into this writer, returning whether the write\nsucceeded.",170,{"inputs":[{"name":"write"},{"name":"str"}],"output":{"name":"result"}}],[11,"write_char","","Writes a `char` into this writer, returning whether the write succeeded.",170,{"inputs":[{"name":"write"},{"name":"char"}],"output":{"name":"result"}}],[11,"write_fmt","","Glue for usage of the `write!` macro with implementers of this trait.",170,{"inputs":[{"name":"write"},{"name":"arguments"}],"output":{"name":"result"}}],[8,"Debug","","Format trait for the `?` character.",null,null],[10,"fmt","","Formats the value using the given formatter.",171,{"inputs":[{"name":"debug"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"Display","","Format trait for an empty format, `{}`.",null,null],[10,"fmt","","Formats the value using the given formatter.",172,{"inputs":[{"name":"display"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"Octal","","Format trait for the `o` character.",null,null],[10,"fmt","","Formats the value using the given formatter.",173,{"inputs":[{"name":"octal"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"Binary","","Format trait for the `b` character.",null,null],[10,"fmt","","Formats the value using the given formatter.",174,{"inputs":[{"name":"binary"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"LowerHex","","Format trait for the `x` character.",null,null],[10,"fmt","","Formats the value using the given formatter.",175,{"inputs":[{"name":"lowerhex"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"UpperHex","","Format trait for the `X` character.",null,null],[10,"fmt","","Formats the value using the given formatter.",176,{"inputs":[{"name":"upperhex"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"Pointer","","Format trait for the `p` character.",null,null],[10,"fmt","","Formats the value using the given formatter.",177,{"inputs":[{"name":"pointer"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"LowerExp","","Format trait for the `e` character.",null,null],[10,"fmt","","Formats the value using the given formatter.",178,{"inputs":[{"name":"lowerexp"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"UpperExp","","Format trait for the `E` character.",null,null],[10,"fmt","","Formats the value using the given formatter.",179,{"inputs":[{"name":"upperexp"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",180,{"inputs":[{"name":"error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",180,{"inputs":[{"name":"error"}],"output":{"name":"error"}}],[11,"clone","","",181,{"inputs":[{"name":"arguments"}],"output":{"name":"arguments"}}],[11,"fmt","","",181,{"inputs":[{"name":"arguments"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",181,{"inputs":[{"name":"arguments"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"pad_integral","","Performs the correct padding for an integer which has already been\nemitted into a str. The str should *not* contain the sign for the\ninteger, that will be added by this method.",182,{"inputs":[{"name":"formatter"},{"name":"bool"},{"name":"str"},{"name":"str"}],"output":{"name":"result"}}],[11,"pad","","This function takes a string slice and emits it to the internal buffer\nafter applying the relevant formatting flags specified. The flags\nrecognized for generic strings are:",182,{"inputs":[{"name":"formatter"},{"name":"str"}],"output":{"name":"result"}}],[11,"write_str","","Writes some data to the underlying buffer contained within this\nformatter.",182,{"inputs":[{"name":"formatter"},{"name":"str"}],"output":{"name":"result"}}],[11,"write_fmt","","Writes some formatted information into this instance",182,{"inputs":[{"name":"formatter"},{"name":"arguments"}],"output":{"name":"result"}}],[11,"flags","","Flags for formatting (packed version of rt::Flag)",182,{"inputs":[{"name":"formatter"}],"output":{"name":"u32"}}],[11,"fill","","Character used as 'fill' whenever there is alignment",182,{"inputs":[{"name":"formatter"}],"output":{"name":"char"}}],[11,"align","","Flag indicating what form of alignment was requested",182,{"inputs":[{"name":"formatter"}],"output":{"name":"alignment"}}],[11,"width","","Optionally specified integer width that the output should be",182,{"inputs":[{"name":"formatter"}],"output":{"name":"option"}}],[11,"precision","","Optionally specified precision for numeric types",182,{"inputs":[{"name":"formatter"}],"output":{"name":"option"}}],[11,"debug_struct","","Creates a `DebugStruct` builder designed to assist with creation of\n`fmt::Debug` implementations for structs.",182,{"inputs":[{"name":"formatter"},{"name":"str"}],"output":{"name":"debugstruct"}}],[11,"debug_tuple","","Creates a `DebugTuple` builder designed to assist with creation of\n`fmt::Debug` implementations for tuple structs.",182,{"inputs":[{"name":"formatter"},{"name":"str"}],"output":{"name":"debugtuple"}}],[11,"debug_list","","Creates a `DebugList` builder designed to assist with creation of\n`fmt::Debug` implementations for list-like structures.",182,{"inputs":[{"name":"formatter"}],"output":{"name":"debuglist"}}],[11,"debug_set","","Creates a `DebugSet` builder designed to assist with creation of\n`fmt::Debug` implementations for set-like structures.",182,{"inputs":[{"name":"formatter"}],"output":{"name":"debugset"}}],[11,"debug_map","","Creates a `DebugMap` builder designed to assist with creation of\n`fmt::Debug` implementations for map-like structures.",182,{"inputs":[{"name":"formatter"}],"output":{"name":"debugmap"}}],[11,"write_str","","",182,{"inputs":[{"name":"formatter"},{"name":"str"}],"output":{"name":"result"}}],[11,"write_char","","",182,{"inputs":[{"name":"formatter"},{"name":"char"}],"output":{"name":"result"}}],[11,"write_fmt","","",182,{"inputs":[{"name":"formatter"},{"name":"arguments"}],"output":{"name":"result"}}],[11,"fmt","","",180,{"inputs":[{"name":"error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","core::marker","",10,{"inputs":[{"name":"phantomdata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","core::cell","",60,{"inputs":[{"name":"cell"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",61,{"inputs":[{"name":"refcell"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",62,{"inputs":[{"name":"ref"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",63,{"inputs":[{"name":"refmut"},{"name":"formatter"}],"output":{"name":"result"}}],[14,"panic!","core","Entry point of thread panic, for details, see std::macros",null,null],[14,"assert!","","Ensure that a boolean expression is `true` at runtime.",null,null],[14,"assert_eq!","","Asserts that two expressions are equal to each other.",null,null],[14,"debug_assert!","","Ensure that a boolean expression is `true` at runtime.",null,null],[14,"debug_assert_eq!","","Asserts that two expressions are equal to each other, testing equality in\nboth directions.",null,null],[14,"try!","","Short circuiting evaluation on Err",null,null],[14,"write!","","Use the `format!` syntax to write data into a buffer of type `&mut Write`.\nSee `std::fmt` for more information.",null,null],[14,"writeln!","","Equivalent to the `write!` macro, except that a newline is appended after\nthe message is written.",null,null],[14,"unreachable!","","A utility macro for indicating unreachable code.",null,null],[14,"unimplemented!","","A standardised placeholder for marking unfinished code. It panics with the\nmessage `\"not yet implemented\"` when executed.",null,null],[14,"__impl_slice_eq1!","","",null,null],[14,"__impl_slice_eq2!","","",null,null]],"paths":[[4,"FpCategory"],[8,"OverflowingOps"],[3,"Wrapping"],[8,"Zero"],[8,"One"],[3,"ParseIntError"],[3,"ParseFloatError"],[3,"NonZero"],[3,"Unique"],[3,"NoCopy"],[3,"PhantomData"],[3,"Range"],[3,"RangeFrom"],[3,"RangeTo"],[8,"Drop"],[8,"Add"],[8,"Sub"],[8,"Mul"],[8,"Div"],[8,"Rem"],[8,"Neg"],[8,"Not"],[8,"BitAnd"],[8,"BitOr"],[8,"BitXor"],[8,"Shl"],[8,"Shr"],[8,"Index"],[8,"IndexMut"],[8,"Deref"],[8,"DerefMut"],[8,"Fn"],[8,"FnMut"],[8,"FnOnce"],[8,"Place"],[8,"Placer"],[8,"InPlace"],[8,"Boxed"],[8,"BoxPlace"],[3,"RangeFull"],[4,"Ordering"],[8,"PartialEq"],[8,"Ord"],[8,"PartialOrd"],[8,"Clone"],[8,"Default"],[8,"AsRef"],[8,"AsMut"],[8,"Into"],[8,"From"],[8,"Any"],[3,"TypeId"],[8,"FixedSizeArray"],[4,"Ordering"],[3,"AtomicBool"],[3,"AtomicIsize"],[3,"AtomicUsize"],[3,"AtomicPtr"],[3,"UnsafeCell"],[4,"BorrowState"],[3,"Cell"],[3,"RefCell"],[3,"Ref"],[3,"RefMut"],[3,"EscapeUnicode"],[3,"EscapeDefault"],[3,"Scan"],[3,"Unfold"],[4,"MinMaxResult"],[8,"Iterator"],[8,"FromIterator"],[8,"IntoIterator"],[8,"Extend"],[8,"DoubleEndedIterator"],[8,"RandomAccessIterator"],[8,"ExactSizeIterator"],[8,"Step"],[3,"Rev"],[3,"Cloned"],[3,"Cycle"],[3,"Chain"],[3,"Zip"],[3,"Map"],[3,"Filter"],[3,"FilterMap"],[3,"Enumerate"],[3,"Peekable"],[3,"SkipWhile"],[3,"TakeWhile"],[3,"Skip"],[3,"Take"],[3,"FlatMap"],[3,"Fuse"],[3,"Inspect"],[3,"StepBy"],[3,"RangeInclusive"],[3,"Repeat"],[3,"Empty"],[3,"Once"],[4,"Option"],[3,"Iter"],[3,"IterMut"],[3,"IntoIter"],[3,"Slice"],[3,"TraitObject"],[8,"Repr"],[4,"Result"],[3,"Iter"],[3,"IterMut"],[3,"IntoIter"],[3,"i8x16"],[3,"i16x8"],[3,"i32x4"],[3,"i64x2"],[3,"u8x16"],[3,"u16x8"],[3,"u32x4"],[3,"u64x2"],[3,"f32x4"],[3,"f64x2"],[8,"MutableByteVector"],[8,"IntSliceExt"],[3,"Iter"],[3,"IterMut"],[3,"Split"],[3,"SplitMut"],[3,"SplitN"],[3,"RSplitN"],[3,"SplitNMut"],[3,"RSplitNMut"],[3,"Windows"],[3,"Chunks"],[3,"ChunksMut"],[3,"CharRange"],[4,"SearchStep"],[8,"Pattern"],[8,"Searcher"],[8,"ReverseSearcher"],[3,"CharSearcher"],[3,"CharSliceSearcher"],[3,"CharPredicateSearcher"],[3,"StrSearcher"],[8,"FromStr"],[3,"ParseBoolError"],[3,"Utf8Error"],[3,"Chars"],[3,"CharIndices"],[3,"Bytes"],[3,"Split"],[3,"RSplit"],[3,"SplitTerminator"],[3,"RSplitTerminator"],[3,"SplitN"],[3,"RSplitN"],[3,"MatchIndices"],[3,"RMatchIndices"],[3,"Matches"],[3,"RMatches"],[3,"Lines"],[3,"LinesAny"],[3,"SipHasher"],[8,"Hash"],[8,"Hasher"],[3,"Radix"],[3,"RadixFmt"],[3,"DebugStruct"],[3,"DebugTuple"],[3,"DebugSet"],[3,"DebugList"],[3,"DebugMap"],[8,"Write"],[8,"Debug"],[8,"Display"],[8,"Octal"],[8,"Binary"],[8,"LowerHex"],[8,"UpperHex"],[8,"Pointer"],[8,"LowerExp"],[8,"UpperExp"],[3,"Error"],[3,"Arguments"],[3,"Formatter"]]};
initSearch(searchIndex);
